;	[]==========================================================[]
;
;	    This source code is classified as confidential and 
;	    contains trade secrets owned by Award Software, Inc.
;
;	    		Copyright 1984, 1997
;			Award Software, Inc.
;			All rights reserved.
;
; 	[]==========================================================[]
;----------------------------------------------------------------------------
;Rev	Date	Name	Description
;----------------------------------------------------------------------------
;R03   12/01/97 DNL	Added ACPI OEM ID & OEM Table ID support 
;R02   10/20/97	DNL	Added S4/OS support
;R01   05/02/97 DNL	Fixed the ACPI table formate conflict with ACPI spec 1.0
;R00	123096	ATT	First rev for ACPI (spec 0.9)
;			This file will create RSDT, FACP, and FACS tables
;			The DSDT table is created by ASL code and combine together later.
;----------------------------------------------------------------------------
.model small
.code
	include	BIOS.CFG
ifdef	ACPI_SUPPORT
;Include fix EQUs	
	include ACPI.INC	
;Include chip set dependent EQUs
;
;ifdef	PIIX_PMU   		
;	include	PIIX4.ACP	
;endif;	PIIX_PMU
;Need to modify getpci.bat to rename chip set dependent filename to generic
;file name like "ACPI_CT.INC" 
	include	ACPI_CT.INC
;----------------------------------------------------------------------------
;RSDT table
;
RSDTtable:
	db	"RSDT"		;Signature
	dd	RSDTLength    	;Lenght
	db	1	     	;Revision
	db	0		;checksum
;R03	db	6 dup (?)	;OEM ID
	db	ACPI_OEMID	;R03 OEMID
;R03	db	8 dup (?)	;OEM Table ID
	db	"AWRDACPI"	;R03 OEM Table ID
	db	4 dup (?)	;OEMRevision
;R01 ;	db	4 dup (?)	;Creator ID
;R01 ;	db	4 dup (?)	;Creatore Revision
	db	4 dup (?)	;Creator ID		;R01
	db	4 dup (?)	;Creatore Revision	;R01
	db	4 dup (?)	;Pointer of FACP table
	RSDTLength EQU ($-RSDTtable)

;----------------------------------------------------------------------------
;FACP Table
;
FACPtable:
	db	"FACP" 		;Signature
	dd	FACPLength	;Length
	db	1		;Revision
	db	0		;checksum
;R03	db	6 dup (?)	;OEM ID
	db	ACPI_OEMID	;R03 OEMID
;R03	db	8 dup (?)	;OEM Table ID
	db	"AWRDACPI"	;R03 OEM Table ID
	db	4 dup (?)	;OEM Revision
	db	4 dup (?)	;Creator ID		;R01
	db	4 dup (?)	;Creatore Revision	;R01
	db	4 dup (?)	;Pointer of FACS table
	db	4 dup (?)	;Pointer of DSDT table
	db	INT_MODEL	;
	db	0		;Reserved
	dw	SCI_INT		;
	dd	SMI_CMD		;
	db	ACPI_ENABLE
	db	ACPI_DISABLE
;R01	dw	0		;Reserved 
	db	0		;R01 S4BIOS_REQ value	
	db	0		;R01 Reserved 		
	dd	PM1a_EVT_BLK
	dd	PM1b_EVT_BLK
	dd	PM1a_CNT_BLK
	dd	PM1b_CNT_BLK
	dd	PM2_CNT_BLK
	dd	PM_TMR_BLK
	dd	GPE0_BLK
	dd	GPE1_BLK
	db	PM1_EVT_LEN
	db	PM1_CNT_LEN
	db	PM2_CNT_LEN
	db	PM_TM_LEN
	db	GPE0_BLK_LEN
	db	GPE1_BLK_LEN
	db	GPE1_BASE
	db	0		;Reserved
	dw	P_LVL2_LAT
	dw	P_LVL3_LAT
	dw	FLUSH_SIZE
	dw	FLUSH_STRIDE
	db	DUTY_OFFSET
	db	DUTY_WIDTH
	db	DAY_ALRM
	db	MON_ALRM
	db	CENTURY_ALRM
;R01	db	1 dup (0)	;Reserved
	db	3 dup (0)	;R01 Reserved
	dd	FACPFlag	;Flags 
	FACPLength EQU ($-FACPtable)		

;----------------------------------------------------------------------------
;FACS Table
;
FACStable:
	db	"FACS" 		;Signature
	dd	FACSLength	;Length
	dd	0		;Hardware Signature
	dd	0		;Firmware Waking Vector
	dd	0		;Global Lock
;R02	dd	0		;Flags
	dd	FACSFlag	;R02
	db	40 dup (0)	;Reserved	
	FACSLength EQU ($-FACStable)		
;DSDT table will merge here.
endif	;ACPI_SUPPORT
end  
	
