;	[]==========================================================[]
;
;	    This source code is classified as confidential and 
;	    contains trade secrets owned by Award Software, Inc.
;
;	    		Copyright 1984, 1997
;			Award Software, Inc.
;			All rights reserved.
;
; 	[]==========================================================[]

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R00	11/13/97 PAL	Initial	version
;----------------------------------------------------------------------------
PMIOBase	EQU	ACPI_Base_IO_Addr;PM IO base value programmed in	SIS 5598
INT_MODEL	EQU	0		;Interrupt mode of ACPI description.
SCI_INT		EQU	09		;System pin the SCI interrupt is wired to.

CLK_EN		EQU	20h		;CPU clock control enable

SMI_CMD		EQU	PMIOBase+20h 	;SMI command port
PM1a_EVT_BLK	EQU	PMIOBase+0	;IO of PM status register
PM1b_EVT_BLK	EQU	0		;IO of PM status register
PM1a_CNT_BLK	EQU	PMIOBase+4	;IO of PM control register
PM1b_CNT_BLK	EQU	0		;IO of PM control register
PM2_CNT_BLK	EQU	0		;IO of PM control register
PM_TMR_BLK	EQU	PMIOBase+8	;IO of PM timer register

PRC_CNT_BLK	EQU	PMIOBase+0ch	;IO of CPU control register

GPE0_BLK	EQU	0	 	;IO of general purpose register
GPE1_BLK	EQU	0		;IO of general purpose register
PM1_EVT_LEN	EQU	4		;No. of byte of PM1?_EVT_BLK.
PM1_CNT_LEN	EQU	2		;No. of byte of PM1?_CNT_BLK.
PM2_CNT_LEN	EQU	0		;No. of byte of PM2_CNT_BLK.
PM_TM_LEN	EQU	4		;No. of byte of PM_TMR_BLK.
GPE0_BLK_LEN	EQU	0		;No. of byte of GPE0_BLK
GPE1_BLK_LEN	EQU	0		;No. of byte of GPE1_BLK
GPE1_BASE	EQU	0		;
P_LVL2_LAT	EQU	90		;Worst case HW latency in microsec. to enter/exit C2
P_LVL3_LAT	EQU	900		;Worst case HW latency in microsec. to enter/exit C3
FLUSH_SIZE	EQU	0		;
FLUSH_STRIDE	EQU	0		;
DUTY_OFFSET	EQU	1 		;Offset in P_CLK register of CPU duty cycle setting
DUTY_WIDTH	EQU	0 		;Width of CPU duty cycle bits in P_CLK register.

DAY_ALRM	EQU	7dh		;Index of RTC CMOS day alarm
MON_ALRM	EQU	7eh 		;Index of RTC CMOS month alarm
CENTURY_ALRM	EQU	7fh		;Index of RTC CMOS year alarm
S4BIOS_F	EQU	01h		;

FACPFlag	EQU	(PROC_C1+WBINVDFlag+SLP_BUTTON)		
FACSFlag	EQU	S4BIOS_F				

;****Don't set 00h to S2 in 5598 chipset, it will cause restart abnormal

S2		EQU	02h		;chip set register value for S2 state 
;S3		EQU	00h		;value for S3 state 	
;S4		EQU	00h		;value for S4 state
					;These values are read from SMI_CMD
					;by SMI handler to enable/disable ACPI.
ACPI_ENABLE	EQU	0A1h		;Value assigned by BIOS to check at software
					;SMI handler to disable SMI and enable SCI.		
ACPI_DISABLE	EQU	0A0h		;Value to enable SMI ownership
;S4BIOS_REQ	EQU	0a4h		;Value to enter S4 state (handle by BIOS)
S4BIOS_REQ	EQU	00h		;Value to enter S4 state (handle by BIOS)
					;0= Not support S4 state.
					;0a4h= Support S4 sate. 
