;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;
;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;--------------------------2A5II---------------------------------------------
;R02	04/30/97 JKY	Special support : flash write protect used GPIO0 
;			'h' active. def : FLASH_WP_USE_GPIO0 & GPIO0_H_ACTIVE
;R01	02/17/97 LRY	Support SiS 2MB ROM BIOS
;R00	01/07/97 LRY	Initial version
.386p
		PAGE	56,132
		TITLE	CHIPSET  -- 386/486 EISA ROM/BIOS

		INCLUDE BIOS.CFG
		INCLUDE COMMON.MAC
		INCLUDE POST.EQU
		INCLUDE POST.MAC
		INCLUDE	BTROMSEG.EQU

		extrn	Get_Ct:Near
		extrn	Set_Ct:Near
		extrn	Get_Set_Ct:Near

G_RAM		SEGMENT USE16 AT 0

		ORG	04H*4
		INCLUDE SEG_0.INC

		ORG	400H
		INCLUDE G_RAM.INC

G_RAM		ENDS

DGROUP		GROUP	FCODE
FCODE		SEGMENT USE16 PARA PUBLIC 'CODE'
		ASSUME	CS:DGROUP,DS:DGROUP

		ALIGN	8
FLASH_ROUTINE_HEAD	db	'AWDFLASH'
		DW	Offset	DGROUP:KBC_12V_Control
		DW	Offset	DGROUP:Ct_ROM_Write_Enable
		DW	Offset	DGROUP:Ct_ROM_Write_Disable
		DW	Offset	DGROUP:Ct_Enable_ROM_Decode
		DW	Offset	DGROUP:Ct_Init
		DW	Offset	DGROUP:CT_Disable_ROM_Shadow
		DW	Offset	DGROUP:CT_Enable_ROM_Shadow
		DW	Offset	DGROUP:Ct_Special_REG_Save
		DW	Offset	DGROUP:Ct_After_Program

;;=======================================================================*
;KBC_12V_Control:
;	ROM Write Vpp (12V) Control By Keyboard Pin 29/30
;Input : None
;Output: BL : Bit 0 Set 1 => Enable Control By Keyboard
;	      Bit 1 Set 1 => Pin 29 Active
;	      Bit 2 Set 1 => Pin 30 Active
;;=======================================================================*
		Public	KBC_12V_Control
KBC_12V_Control proc	near
ifdef	Flash_By_KB_Pin
		mov	bl,1 +(1 shl (Flash_By_KB_Pin-29+1))
else	;Flash_By_KB_Pin
		xor	bl,bl
endif	;Flash_By_KB_Pin
		retf
KBC_12V_Control endp

;;=======================================================================*
;; Ct_ROM_Write_Enable:
;; Input : None
;; Output: None
;; Note  : This routine is OEM dependent
;;=======================================================================*
		Public	Ct_ROM_Write_Enable
Ct_ROM_Write_Enable	proc	near
		pushad
		mov	cx,845h
		mov	bx,00DFh
		call	Get_Set_Ct
;R02- start
ifdef	FLASH_WP_USE_GPIO0
ifdef	GPIO0_H_ACTIVE		
		mov	cx,ACPI_R+18h	;GPIO0='h' , flash write enable
		mov	bx,01feh
		call	Get_Set_Ct
endif	;GPIO0_H_ACTIVE
endif	;FLASH_WP_USE_GPIO0
;R02 - end
		popad
		retf
Ct_ROM_Write_Enable	endp

;;=======================================================================*
;; Ct_ROM_Write_Disable:
;; Input : None
;; Output: None
;; Note  : This routine is OEM dependent
;;=======================================================================*
		Public	Ct_ROM_Write_Disable
Ct_ROM_Write_Disable	proc	near
		pushad
		mov	cx,845h
		mov	bx,20DFh
		call	Get_Set_Ct
;R02- start
ifdef	FLASH_WP_USE_GPIO0
ifdef	GPIO0_H_ACTIVE		
		mov	cx,ACPI_R+18h	;GPIO0='l' , flash write disable
		mov	bx,00feh
		call	Get_Set_Ct
endif	;GPIO0_H_ACTIVE
endif	;FLASH_WP_USE_GPIO0
;R02 - end
		popad
		retf
Ct_ROM_Write_Disable	endp
;;=======================================================================*
;Enable Flash ROM decode/Write for special motherboard
;Input : None
;Output: None
;Note  : This routine is OEM dependent
;;=======================================================================*
		Public	Ct_Enable_ROM_Decode
Ct_Enable_ROM_Decode	proc	near
		pushad
		mov	cx,840h
;R01		mov	al,0Ah
		mov	al,0Bh		;enable extended BIOS	;R01
		call	Set_Ct
		popad
		retf
Ct_Enable_ROM_Decode	endp

;;=======================================================================*
;Initialize motherboard to desired status
;Input : None
;Output: None
;Note  : This routine is OEM dependent
;;=======================================================================*
		Public	Ct_Init
Ct_Init 	proc	near
		pushad
		mov	cx,9Ah
		xor	al,al
		call	Set_Ct
		popad
		retf
Ct_Init 	endp

;;=======================================================================*
;Disable ROM Shadow
;Input	: None
;Output : None
;;=======================================================================*
		Public	CT_Disable_ROM_Shadow
CT_Disable_ROM_Shadow	proc	near
		pushad
		cli

		mov	cx,76h		;Disable F0000-FFFFF Shadow & Cacheable
		mov	bx,001Fh
		call	Get_Set_Ct

		dec	cx		;then cx = 75h
		xor	al,al		;Disable E8000-EFFFF Shadow & Cacheable
		call	Set_Ct
		dec	cx		;then cx = 74h
		call	Set_Ct 	;Disable E0000-E7FFF Shadow & Cacheable

		popad
		retf
CT_Disable_ROM_Shadow	endp

;;=======================================================================*
;Enable ROM Shadow
;Input	: None
;Output : None
;;=======================================================================*
		Public	CT_Enable_ROM_Shadow
CT_Enable_ROM_Shadow	proc	near
		pushad

		mov	cx,76h
		mov	bx,801Fh	;Enable F0000-FFFFF Shadow
		call	Get_Set_Ct

		dec	cx		;then cx = 75h
		mov	al,88h		;Enable E8000-EFFFF Shadow
		call	Set_Ct
		dec	cx		;then cx = 74h
		call	Set_Ct 	;Enable E0000-E7FFF Shadow

		popad
		retf
CT_Enable_ROM_Shadow	endp

;;=======================================================================*
;; Ct_Special_REG_Save:
;;	For register call by two hook or more, save register value here.
;;
;;		Ex:	MOV	CX,XXXX
;;			CALL	GET_CT
;;			MOV	[SI],AX 	; save word value
;;			MOV	CX,XXXX
;;			CALL	GET_CT
;;			MOV	[SI+2],AL	; save byte value
;;			MOV	CX,XXXX
;;			CALL	GET_CT
;;			MOV	[SI+3],AL
;;		MAX Length => 30 Bytes
;; Input : DS:SI
;; Output: None
;; Save  : DS,ES
;;=======================================================================*
		Public	Ct_Special_REG_Save
Ct_Special_REG_Save	proc	near
		pushad

		mov	cx,76h
		call	Get_Ct
		mov	[si],al

		dec	cx		;then cx = 75h
		call	Get_Ct
		mov	[si+1],al

		dec	cx		;then cx = 74h
		call	Get_Ct
		mov	[si+2],al

		popad
		retf
Ct_Special_REG_Save	endp

;;=======================================================================*
;Ct_After_Program:
;	Set system into certain state after flash memory fininsh program
;	Normally, enable flash write protect
;Input	: None
;Output : None
;;=======================================================================*
		Public	Ct_After_Program
Ct_After_Program	proc	near
		pushad

		mov	cx,76h
		mov	al,[si]
		call	Set_Ct

		dec	cx		;then cx = 75h
		mov	al,[si+1]
		call	Set_Ct

		dec	cx		;then cx = 74h
		mov	al,[si+2]
		call	Set_Ct

		popad
		retf
Ct_After_Program	endp

FCODE		ENDS
		END
