#	[]===========================================================[]
#
#	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
#	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE
#	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED
#	        WRITTEN AUTHORIZATION FROM THE OWNER.
#
# 	[]===========================================================[]
#

#----------------------------------------------------------------------------
#Rev    Date      Name  Description
#----------------------------------------------------------------------------
#R59    12/08/97  DRS	Add Btpci1a.inc 
#R58	12/02/97  RAY	No more PMU32.ASM
#R57	10/16/97  Stv   Add netpctbl.obj
#R56	10/01/97  TNY	Add clock generator module.
#R55	09/23/97  RAX	Add Cardbus support.
#R54	09/08/97  LAW	use MASM6.11 Compiler AUTO_IO.asm
#R53	08/01/97  RAY	Add PCI21TBL.ASM
#R52	07/14/97  RAY	Fix compile error for GETPM.BAT
#R51	06/25/97  RIC	Fixed that acpi.inc acpi_ct.inc don't synchronize
#			pnpbios.asm to compile.
#R50	06/05/97  TNY	Add sensor module.
#R49	06/03/97  KVN	Don't combine EPA pattern to BIOS if support full screen
#			logo to reduse CBROM driver rom space
#R48	05/29/97 KVN	Added a new segment for store more BIOS code
#R47	05/15/97  DNL	Added file for more SMB host controller INT15 support
#R46	05/13/97 LAW	Move EpaLogo data and Award_Mark_Font use cbrom include.
#			Befor the special EpaLogo must define "NOT_USE_CBROM_EPALOGO"
#R45	04/24/97  RAX	Added file for more SMB host controller INT15 support
#R44	04/19/97  MIL	Add GX86.AIO support.
#R43	03/26/97  KEN	Add OHCI USB legacy support.
#R42	03/22/97 KVN	Store DMI data to F000 shadow to fix Intel LDCM bug
#R41	03/21/97  AVN	Added MXIC 28F002TTC EEPROM support.
#R40	03/15/97  RAY	1. Compile PCICHIP.ASM twice by adding
#			   switch: COMPILE_FOR_RUN_TIME=0/1 in BIOS.MAK
#			   to generate PCICHIP.OBJ & PCIRUN.OBJ such that:
#
#			   PCICHIP.OBJ: linked before the fix ORG at E8000
#			   PCIRUN.OBJ: linked after the fix ORG at F8000
#
#			   This is done to support the dynamic set IRQ for
#			   PCI devices as required by the PCI 2.1 specification
#
#			2. Do not compile PCI21.ASM because it is no longer
#			   used !
#
#R39	03/07/97  DNL	Added pmupost.inc & pfeature.mnu support
#R38	03/03/97  KVN	Added ACPI function support
#R37	02/20/97  LAW	Added RTC_ON.SIO for SUPPORT_RTC_ON
#R36	01/15/97  KVN	Remove P6 micro code to ROM driver pool from 0E000h
#			POST location
#R35	12/13/96  DNL	Added notebook Keyboard controller support
#R34	12/10/96  AVN	Suppost Auto Detect EEPROM ID at POST 6 For 1M EEPROM
#R33A	12/02/96  RAY	Since the p6 data has been moved from E0POST.ASM to
#			CPUPOST.ASM, the dependency should also be changed
#R33    11/30/96  RAY   Compile CPUPOST.ASM twice to generate CPUPOST.OBJ &
#                       CPUPE8.OBJ by adding the switch: /DCompile_For_E0=0
#			such that CPUPOST.OBJ will be linked to the address
#			within E0-E8 & CPUPE8.OBJ within E8-EF
#R32	11/29/96  RIC	Add YMF715.AIO
#R31	11/15/96  RAY	Add PNPE0.ASM
#R30    11/01/96  DNL   Added Supervga.asm to super notebook VGA chip
#R29    10/21/96  RAY   Use MASM6.X to compile PCIPOST.ASM
#R28    10/17/96  AVN   Added SMI.ASM to save F-segment space
#R27    10/16/96  AVN   Added 2M BIOS Support MXIC 28F2000PPC EEPROM.
#                       Define 'MXIC_28F2000PPC'
#R26    10/14/96  RAY   Compile PCIPOST.ASM twice to generate PCIPOST.OBJ &
#                       PCIPE0.OBJ such that PCIPE0.OBJ will be linked
#                       to the address within E0-E8
#R25    10/14/96  RAX   Added Smart Battery BIOS support
#R24    10/08/96  RCH   The WIN/95 driver for YMF701 still have problem and
#R24                    no body use this chip, kill it.
#R23    10/07/96  RCH   Remove P6 update micro code to file P6UPD.INC
#R22    10/01/96  RAY   Use MASM6.X to compile IOFEAT.ASM & CFEATURE.ASM
#R21    09/30/96  KVN   Fixed INTEL 28F001BXT EEPROM update bios error if modify
#                       chiprun.asm then Get_Ct,Set_ct offset be changed
#R20    09/23/96  AVN   Added 2M BIOS Support INTEL 28F002BXT EEPROM.
#R19    09/20/96  RIC   Add YMF711.AIO CS4236.AIO in AUDIO.ASM
#R18    09/18/96  LAW   Added NS307.SIO (NS307 I/O, RTC, KBC, PS2 mouse)
#R16B   09/06/96  AVN   Delete Not Necessary Compiler.
#R17    09/03/96  KEN   USB structure modification
#R16A   08/21/96  RAY   R16 cause non-PnP BIOS compilation error
#R16    08/20/96  AVN   Detect EEPROM Type at post 6, to support 2M EEPROM
#                       for save more code in F segment.
#                       POST 6s Will copy correct flash hook to f800h:4
#R15    08/19/96  RAY   Complile superio.asm using MASM 6.X to prevent system
#                       from hanging up during complilation using MASM 5.X
#R14    08/14/96  LAW   Add SMC37C669 & UMC8669 Dual SIO
#R13    08/13/96  RAY   Add swithc MASM611 for compiling DMIPOST.ASM using
#                       MASM6.X
#R12    08/12/96  KVN   Add new DMI spec 2.0 support
#R11    08/09/96  RAY   Add new ASM module: AUTO_IO.ASM
#R10    07/09/96  AVN   Added AMD AM29F002T/ SST 29EE020 2M Type EEPROM Support.
#R09    05/29/96  RIC   Fix IOFEAT.OBJ no according to SUPERIO.OBJ etc.
#R08    05/28/96  AVN   Added AMD29F010 Support PnP Function.
#R07    05/28/96  KEN   Add USB legacy supporting function
#R06    05/24/96  RCH   Added new file MISC.ASM
#R05    04/16/96  KVN   Pack DMI function become a module and put it in
#                       0F000h-0F800h
#R04    04/09/96  KVN   Added P6 BIOS update feature
#R03    03/07/96  TNY   Add SMBA functions.
#R02    01/30/96  RAY   Add *.NVM as dependents for ESCDHIP.ASM
#R01    01/24/96  RAY   Support PNPFEAT.ASM
#R00    01/22/96  RAY   Initial revision for using NMAKE.EXE

NAME = EISA
ASM = MASM
LINK = LINK
MODBIN = MODBIN
SYM = SYMDEB
LARGS = /MAP
MARGS =

#R42COMMON = BIOS.CFG COMMON.MAC COMMON.EQU CMOS.EQU BSETUP.INC G_RAM.INC
COMMON = BIOS.CFG COMMON.MAC COMMON.EQU CMOS.EQU BSETUP.INC G_RAM.INC FSHADOW.EQU	#R42
#R02 - starts
#R08 NVM_SOURCE = dallas.nvm EisaPnP.nvm sst010.nvm f001bxt.nvm mxic.nvm other.nvm
#R10 NVM_SOURCE = dallas.nvm EisaPnP.nvm sst010.nvm f001bxt.nvm mxic.nvm other.nvm amd29f.nvm #R08
NVM_SOURCE = dallas.nvm EisaPnP.nvm sst010.nvm f001bxt.nvm mxic.nvm other.nvm amd29f.nvm am29f002.nvm   #R10
#R02 - ends
#SIO_SOURCE1 = 8669.SIO W787_877.SIO SMC92X.SIO CMDIDE.SIO ALI5119.SIO W787.SIO HMC83755.SIO DUAL5113.SIO W9775119.SIO 669_8661.SIO NS307.SIO
#SIO_SOURCE2 = SMC653.SIO GS803B.SIO NS332.SIO ALI5113.SIO SMC665.SIO SMC669.SIO S6658663.SIO I8680663.SIO  W977TF.SIO NS309.SIO SMC67x.SIO
#SIO_SOURCE3 = 8663.SIO SMCALI.SIO S93X5123.SIO DUALIO.SIO PRIME3C.SIO ITE8680.SIO W967.SIO ITE8661.SIO S93x8669.SIO SMC68X.SIO 513x5113.SIO
#SIO_SOURCE4 = SMC93X.SIO W877.SIO I82091.SIO Ali5123.SIO NS338.SIO DUAL669.SIO SUPERIO.STR SUPERIO.DO SUPERIO.SHW SUPERIO.MNU
SIO_SOURCE1 = SUPERIO.SIO SUPERIO.STR SUPERIO.DO SUPERIO.SHW SUPERIO.MNU SECONDIO.SIO
#R24 AIO_SOURCE = ES1788.AIO CT2504.AIO ES1888.AIO YMF701.AIO
#R44 AIO_SOURCE = ES1788.AIO CT2504.AIO ES1888.AIO ES1878.AIO                   #R24
#AIO_SOURCE = ES1788.AIO CT2504.AIO ES1888.AIO ES1878.AIO GX86.AIO
AIO_SOURCE = AUDIO.AIO BIOSPNP.AIO
#!IF EXIST(CLKCNTL.ASM)							#R56
#CLK_SOURCE1 = ICW6704.GEN ICS9148.GEN ICS9150.GEN ICW8803.GEN ICW8704.GEN IMI671.GEN IMI543.GEN IMI643.GEN IMI584.GEN PL526502.GEN #R56
CLK_SOURCE1 = CLOCK.GEN
#!ENDIF									#R56
!IF EXIST(SENSOR.ASM)							#R52
SSR_SOURCE1 = LM78.SSR LM75.SSR GL518SM.SSR W83781D.SSR	SIS5595.SSR	#R50
!ENDIF									#R52
!IF EXIST(UHCI.ASM)							#R52
USB_SOURCE = UHCI.ASM OHCI.ASM						#R52
!ENDIF									#R52
#R57 OBJ_FIX = ATORGS.OBJ E8FIXORG.OBJ EFIXORG.OBJ AFIXORG.OBJ MFIXORG.OBJ
OBJ_FIX = ATORGS.OBJ E8FIXORG.OBJ EFIXORG.OBJ AFIXORG.OBJ MFIXORG.OBJ NETPCTBL.OBJ	#R57
OBJ_EISA = EISAINIT.OBJ EISAMAIN.OBJ EISA_32.OBJ NVM.OBJ
OBJ_CHIP = CHIPRUN.OBJ CHIPPOST.OBJ AFLASH.OBJ VUMA.OBJ VUMA32.OBJ BIOS16.OBJ SMBA.OBJ
OBJ_PERI1 = MATHCOP.OBJ AVIDEO.OBJ HDINSTAL.OBJ AHDSK.OBJ INT13X.OBJ ADISK.OBJ FPINSTAL.OBJ					       
#R50 OBJ_PERI2 = CPINSTAL.OBJ MOUSE.OBJ AMOUSE.OBJ AKBRD.OBJ POSTINT9.OBJ LOFORMAT.OBJ SUPERIO.OBJ AUDIO.OBJ AUTO_IO.OBJ
#R56OBJ_PERI2 = CPINSTAL.OBJ MOUSE.OBJ AMOUSE.OBJ AKBRD.OBJ POSTINT9.OBJ LOFORMAT.OBJ SUPERIO.OBJ AUDIO.OBJ AUTO_IO.OBJ SENSOR.OBJ#R50
#R56 - start
OBJ_PERI2 = CPINSTAL.OBJ MOUSE.OBJ AMOUSE.OBJ AKBRD.OBJ POSTINT9.OBJ LOFORMAT.OBJ SUPERIO.OBJ AUDIO.OBJ AUTO_IO.OBJ SENSOR.OBJ CLKCNTL.OBJ 
#R56 - end
#R40 - starts
#R53 OBJ_PCI = PCI1A.OBJ PCI32.OBJ PCI1A_M2.OBJ PCI32_M2.OBJ PCIPOST.OBJ PCIPE0.OBJ PCICHIP.OBJ PCIRUN.OBJ
#R40 - ends
#R40 OBJ_PCI = PCI1A.OBJ PCI32.OBJ PCI1A_M2.OBJ PCI32_M2.OBJ pci21.obj PCIPOST.OBJ PCICHIP.OBJ PCIPE0.OBJ
#R06 OBJ_SETUP1 = SETUP.OBJ KERNAL.OBJ STDCMOS.OBJ BFEATURE.OBJ
#R48 OBJ_SETUP1 = SETUP.OBJ KERNAL.OBJ STDCMOS.OBJ BFEATURE.OBJ MISC.OBJ
#R54 OBJ_PCI = PCI1A.OBJ PCI32.OBJ PCI1A_M2.OBJ PCI32_M2.OBJ pci21tbl.obj PCIPOST.OBJ PCIPE0.OBJ PCICHIP.OBJ PCIRUN.OBJ #R53
OBJ_PCI = PCI1A.OBJ PCI32.OBJ PCI1A_M2.OBJ PCI32_M2.OBJ pci21tbl.obj PCIPOST.OBJ PCIPE0.OBJ PCICHIP.OBJ PCIRUN.OBJ CARDBUS.OBJ #R55
OBJ_SETUP1 = SETUP.OBJ KERNAL.OBJ STDCMOS.OBJ BFEATURE.OBJ MISC.OBJ XFILE.OBJ	#R48
OBJ_SETUP2 = CFEATURE.OBJ PFEATURE.OBJ PCIFEAT.OBJ IOFEAT.OBJ PNPFEAT.OBJ
#R25 OBJ_PM = PMKERNAL.OBJ APM.OBJ APM32.OBJ PM_RAM.OBJ PMU.OBJ PMUPOST.OBJ PMU32.OBJ SUS2DISK.OBJ
#R28 OBJ_PM = PMKERNAL.OBJ APM.OBJ APM32.OBJ PM_RAM.OBJ PMU.OBJ PMUPOST.OBJ PMU32.OBJ SUS2DISK.OBJ SMB.OBJ SMB32.OBJ
#R58 OBJ_PM = PMKERNAL.OBJ APM.OBJ APM32.OBJ PM_RAM.OBJ PMU.OBJ PMUPOST.OBJ PMU32.OBJ
#R58 - starts
OBJ_PM = PMKERNAL.OBJ APM.OBJ APM32.OBJ PM_RAM.OBJ PMU.OBJ PMUPOST.OBJ
#R58 - ends
#45 OBJ_PM1 = SUS2DISK.OBJ SMB.OBJ SMB32.OBJ SMI.OBJ SUPERVGA.OBJ SUPERKBC.OBJ
OBJ_PM1 = SUS2DISK.OBJ SMB.OBJ SMB32.OBJ SMBHOST.OBJ SMI.OBJ SUPERVGA.OBJ SUPERKBC.OBJ		#45 
#R05 OBJ_PNP = PNPPOST.OBJ PNPBIOS.OBJ PNPCHIP.OBJ PNPIO.OBJ PNPAUDIO.OBJ PNPKERNL.OBJ ESCDCHIP.OBJ
OBJ_PNP = PNPPOST.OBJ PNPBIOS.OBJ PNPCHIP.OBJ PNPIO.OBJ PNPAUDIO.OBJ PNPKERNL.OBJ ESCDCHIP.OBJ PNPE0.OBJ
#R33 OBJ_MISC1 = ATBASE.OBJ E0POST.OBJ E8POST.OBJ CACHE.OBJ CPU.OBJ CPUPOST.OBJ AUTO_CFG.OBJ
#R33 - starts
#R38 OBJ_MISC1 = ATBASE.OBJ E0POST.OBJ E8POST.OBJ CACHE.OBJ CPU.OBJ CPUPOST.OBJ CPUPE8.OBJ AUTO_CFG.OBJ
#R33 - ends
#R38 - start
#R44OBJ_MISC1 = ATBASE.OBJ E0POST.OBJ E8POST.OBJ CACHE.OBJ CPU.OBJ CPUPOST.OBJ CPUPE8.OBJ AUTO_CFG.OBJ ACPI.OBJ ACPITBL.OBJ DSDT.AML
OBJ_MISC1 = ATBASE.OBJ E0POST.OBJ E8POST.OBJ CACHE.OBJ CPU.OBJ CPUPOST.OBJ CPUPE8.OBJ AUTO_CFG.OBJ ACPI.OBJ ACPITBL.OBJ DSDT.AML MPINIT.OBJ	#R44
#R38 - end
#R04 OBJ_MISC2 = ATIME.OBJ MULTISER.OBJ USERINT.OBJ CT_TABLE.OBJ POSTMSG.OBJ SETSPEED.OBJ
#R36 OBJ_MISC2 = ATIME.OBJ MULTISER.OBJ USERINT.OBJ CT_TABLE.OBJ POSTMSG.OBJ SETSPEED.OBJ P6UPDATE.OBJ
#R49#R36 start
#R49OBJ_MISC2 = ATIME.OBJ MULTISER.OBJ USERINT.OBJ CT_TABLE.OBJ POSTMSG.OBJ SETSPEED.OBJ P6UPDATE.OBJ CPUCODE.OBJ
#R49#R36 end
#R49 start
OBJ_MISC2 = ATIME.OBJ MULTISER.OBJ USERINT.OBJ CT_TABLE.OBJ POSTMSG.OBJ SETSPEED.OBJ P6UPDATE.OBJ CPUCODE.OBJ AWARDEPA.OBJ
#R49 end
#R17OBJ_USB = USBPOST.OBJ
OBJ_DMI = DMIPOST.OBJ DMIFUNC.OBJ
#R20 2M_EEPROM = SST020.NVM ATMEL020.NVM AM29F002.NVM SST020.OBJ ATMEL020.OBJ AM29F002.OBJ
#R27 2M_EEPROM = SST020.NVM ATMEL020.NVM AM29F002.NVM F002BXT.NVM
#R41 2M_EEPROM = SST020.NVM ATMEL020.NVM AM29F002.NVM F002BXT.NVM MX2MPPC.NVM
2M_EEPROM = SST020.NVM ATMEL020.NVM AM29F002.NVM F002BXT.NVM MX2MPPC.NVM MX2MTTC.NVM	#R41
1M_EEPROM = SST010.NVM AMD29F.NVM F001BXT.NVM MXIC.NVM	#R34
#R30 - Start
#VGA_SOURCE1 = CHIP.VGA TRIDENT.VGA CIRRUS.VGA ATI.VGA SIS.VGA S3.VGA NEOMAGIC.VGA
VGA_SOURCE1 = SUPERVGA.VGA
#R30 - End
#R35 - start
#KBC_SOURCE1 = M388XX.KBC
KBC_SOURCE1 = SUPERKBC.KBC
#R35 - end
#R47 - start
#SMB_SOURCE = M388XX.SMB PIIX4.SMB
SMB_SOURCE = I2C.SMB
#R47 - end

#----------------------------- Rules -----------------------------

.ASM.OBJ:
        $(ASM) $(MARGS) $*,$*.OBJ;

#------------------- Build BIOS ROM -------------------

$(NAME).BIN:    $(OBJ_FIX) $(OBJ_EISA) $(OBJ_CHIP) $(OBJ_PERI1) $(OBJ_PERI2) $(OBJ_PCI)\
                $(OBJ_SETUP1) $(OBJ_SETUP2) $(OBJ_PM) $(OBJ_PNP) $(OBJ_MISC1) $(OBJ_MISC2)\
                $(OBJ_DMI) $(OBJ_PM1)\
                BOOTEXT.EXE BOOTROM.EXE CPUCODE.EXE ACPITBL.EXE awardepa.exe
	fixf8up
        $(LINK) $(LARGS) @BIOS.LNK
        $(MODBIN) TEMP.EXE $(NAME).BIN -m "($(NAME)) EVALUATION ROM - NOT FOR SALE"
        @COPY TEMP.MAP $(NAME).MAP
        @IF EXIST TEMP.MAP DEL TEMP.MAP
        @IF EXIST ORIGINAL.BIN DEL ORIGINAL.BIN
        @REN $(NAME).BIN ORIGINAL.BIN
        @REN BIOS.ROM $(NAME).BIN
#R36 start
#R49	@cbrom /cpucode /acpitbl /epa awardepa.epa	#R46
#R49 start
	@cbrom /cpucode /acpitbl /epa
#R49 end
	@cbrom /other 4100:0 awardext.rom		#R48

cpucode.exe:    cpucode.obj
        $(LINK) cpucode;
#R49 start
awardepa.exe:    awardepa.obj
        $(LINK) awardepa;
#R49 end
#R36 end
#R38 starts
acpitbl.exe:    acpitbl.obj
        $(LINK) acpitbl;
#R38 ends

#-------------------- auto-sizing Binary -------------------

#R21 bootext.exe:       bootext.obj chiprun1.obj
#R21    $(LINK) $(LARGS) bootext+chiprun1;
#R21 start
bootext.exe:    bootext.obj
        $(LINK) $(LARGS) bootext;
#R21 end

#-------------------- Boot-Block Binary ---------------------

bootrom.exe:    bootrom.obj chiprun1.obj
        $(LINK) $(LARGS) bootrom+chiprun1;

#------ Dependencies for EXT ROM & BootBlock ROM ------------

!IF EXIST(bootext.asm)
!IF EXIST(chipboot.asm)
bootext.obj:    bootext.asm chipboot.asm btromseg.equ jumpless.inc $(COMMON)
        MASM /DCompileForExtROM=1 bootext,bootext;
!ENDIF
!ENDIF

!IF EXIST(chiprun.asm)
chiprun1.obj:   chiprun.asm $(COMMON)
        MASM /DCompileForBootROM=1 chiprun,chiprun1;
!ENDIF

!IF EXIST(bootrom.asm)
!IF EXIST(earlyio.asm)
!IF EXIST(chipboot.asm)
#R23 bootrom.obj:       earlyio.asm bootrom.asm exp.equ chipboot.asm btromseg.equ $(COMMON)
#R23 - start
#R27 bootrom.obj:       earlyio.asm bootrom.asm exp.equ chipboot.asm btromseg.equ\
#R27            p6upd.inc $(COMMON)

#R59 bootrom.obj:    earlyio.asm bootrom.asm exp.equ chipboot.asm btromseg.equ\
#R59	            p6upd.inc bootrom.inc jumpless.inc $(COMMON)
#R59       MASM /DCompileForBootROM=1 bootrom;
#R59 -start
bootrom.obj:    earlyio.asm bootrom.asm exp.equ chipboot.asm btromseg.equ\
            	p6upd.inc bootrom.inc jumpless.inc btpci1a.inc $(COMMON)
        MASM /DCompileForBootROM=1 bootrom;
#R59 -end
#R23 - end

!ENDIF
!ENDIF
!ENDIF

#--------- Individual dependencies for the uncompressed binary ----------

post.equ:       setup.equ userint.equ
        touch post.equ

!IF EXIST(postmsg.asm)
postmsg.obj:    postmsg.asm $(COMMON)
!ENDIF

!IF EXIST(loformat.asm)
loformat.obj:   loformat.asm $(COMMON)
!ENDIF

!IF EXIST(atbase.asm)
atbase.obj:     atbase.asm  8042.equ 8259.equ mathcop.equ post.mac $(COMMON)
!ENDIF

!IF EXIST(atorgs.asm)
atorgs.obj:     atorgs.asm  port61.equ 8042.equ 8259.equ 8254.equ 8237.equ\
                mathcop.equ hdisk.equ userint.equ atorgs.mac post.mac\
                cpurun.asm eisa.equ vers.inc $(COMMON)
!ENDIF

#R16A !IF EXIST(E0post.asm)
#R16A #R16 E0post.obj:  E0post.asm atorgs.equ port61.equ 8042.equ 8259.equ post.mac p6data.inc $(COMMON)
#R16A E0post.obj:       E0post.asm atorgs.equ port61.equ 8042.equ 8259.equ post.mac p6data.inc \
#R16A           2meeprom.inc escdchip.asm $(2M_EEPROM) $(COMMON)        #R16
#R16A !ENDIF

#R16A - starts
!IF EXIST(escdchip.asm)
!IF EXIST(E0post.asm)
#R33A E0post.obj:     E0post.asm atorgs.equ port61.equ 8042.equ 8259.equ post.mac p6data.inc \
#R33A                 2meeprom.inc escdchip.asm $(2M_EEPROM) $(COMMON)        #R16
#R33A - starts
#R34 E0post.obj:     E0post.asm atorgs.equ port61.equ 8042.equ 8259.equ post.mac \
#R34                 2meeprom.inc escdchip.asm $(2M_EEPROM) $(COMMON)
E0post.obj:     E0post.asm atorgs.equ port61.equ 8042.equ 8259.equ post.mac \
                2meeprom.inc escdchip.asm $(2M_EEPROM) $(1M_EEPROM) $(COMMON)	#R34
#R33A - starts
!ENDIF
!ELSE
!IF EXIST(E0post.asm)
#R33A E0post.obj:     E0post.asm atorgs.equ port61.equ 8042.equ 8259.equ post.mac p6data.inc $(COMMON)
#R33A - starts
E0post.obj:     E0post.asm atorgs.equ port61.equ 8042.equ 8259.equ post.mac $(COMMON)
#R33A - ends
!ENDIF
!ENDIF
#R16A - ends

!IF EXIST(E8post.asm)
E8post.obj:     E8post.asm atorgs.equ port61.equ 8042.equ 8259.equ post.mac $(COMMON)
!ENDIF

#R26 !IF EXIST(pcipost.asm)
#R26 pcipost.obj:       pcipost.asm $(COMMON)
#R26 !ENDIF

#R26 - starts
!IF EXIST(pcipost.asm)
pcipost.obj:    pcipost.asm $(COMMON)
 ml /c /Zm /DMASM611=1 /DCOMPILE_FOR_E0=0 pcipost.asm
#R29 masm /DCOMPILE_FOR_E0=0 pcipost,pcipost;

pcipe0.obj:     pcipost.asm $(COMMON)
 ml /c /Zm /DMASM611=1 /DCOMPILE_FOR_E0=1 /Fopcipe0.obj pcipost.asm
#R29 masm /DCOMPILE_FOR_E0=1 pcipost,pcipe0;
!ENDIF
#R26 - ends

#R40 !IF EXIST(pcichip.asm)
#R40 pcichip.obj:    pcichip.asm $(COMMON)
#R40 !ENDIF

#R40 - starts
!IF EXIST(pcichip.asm)
pcichip.obj:    pcichip.asm $(COMMON)
 ml /c /Zm /DMASM611=1 /DCOMPILE_FOR_RUN_TIME=0 pcichip.asm

pcirun.obj:     pcichip.asm $(COMMON)
 ml /c /Zm /DMASM611=1 /DCOMPILE_FOR_RUN_TIME=1 /Fopcirun.obj pcichip.asm
!ENDIF
#R40 - ends

!IF EXIST(ct_table.asm)
ct_table.obj:   ct_table.asm ct_table.equ $(COMMON)
!ENDIF

!IF EXIST(adisk.asm)
adisk.obj:      adisk.asm   82077.equ adisk.equ adisk.inc fdd3mode.sio $(COMMON)
!ENDIF

!IF EXIST(ahdsk.asm)
ahdsk.obj:      ahdsk.asm 8259.equ hdisk.equ ahdsk.equ $(COMMON)
!ENDIF

!IF EXIST(int13x.asm)
int13x.obj:     int13x.asm port61.equ  cd_rom.equ int13x.equ $(COMMON)
!ENDIF

!IF EXIST(akbrd.asm)
akbrd.obj:      akbrd.asm 8042.equ 8259.equ akbrd.equ $(COMMON)
!ENDIF

!IF EXIST(postint9.asm)
postint9.obj:   postint9.asm 8042.equ 8259.equ akbrd.equ $(COMMON)
!ENDIF

!IF EXIST(equip.asm)
equip.obj:      equip.asm  common.equ $(COMMON)
!ENDIF

!IF EXIST(setspeed.asm)
setspeed.obj:   setspeed.asm  atorgs.equ 8042.equ $(COMMON)
!ENDIF

!IF EXIST(cache.asm)
cache.obj:      cache.asm 8259.equ $(COMMON)
!ENDIF

!IF EXIST(fpinstal.asm)
fpinstal.obj:   fpinstal.asm 8259.equ 82077.equ  $(COMMON)
!ENDIF

!IF EXIST(hdinstal.asm)
hdinstal.obj:   hdinstal.asm hdisk.equ 8259.equ $(COMMON)
!ENDIF

!IF EXIST(auto_cfg.asm)
auto_cfg.obj:   auto_cfg.asm $(COMMON)
!ENDIF

!IF EXIST(mouse.asm)
mouse.obj:      mouse.asm mouse.equ seg_0.inc extdata.equ 8042.equ 8259.equ $(COMMON)
!ENDIF

!IF EXIST(amouse.asm)
amouse.obj:     amouse.asm mouse.equ seg_0.inc extdata.equ 8042.equ 8259.equ $(COMMON)
!ENDIF

!IF EXIST(cpinstal.asm)
cpinstal.obj:   cpinstal.asm  lpt_port.equ ser_port.equ gameport.equ $(COMMON)
!ENDIF

!IF EXIST(mathcop.asm)
mathcop.obj:    mathcop.asm mathcop.equ $(COMMON)
!ENDIF

!IF EXIST(atime.asm)
atime.obj:      atime.asm 8259.equ $(COMMON)
!ENDIF

!IF EXIST(multiser.asm)
multiser.obj:   multiser.asm  8259.equ 8254.equ port61.equ atorgs.equ $(COMMON)
!ENDIF

!IF EXIST(userint.asm)
userint.obj:    userint.asm userint.equ $(COMMON)
!ENDIF

!IF EXIST(pmkernal.asm)
pmkernal.obj:   pmkernal.asm pm_ram.inc $(COMMON)
!ENDIF

!IF EXIST(pmu.asm)
#R37pmu.obj:        pmu.asm pm_ram.inc ct_pmram.inc v_alarm.inc $(COMMON)
pmu.obj:        pmu.asm pm_ram.inc ct_pmram.inc v_alarm.inc rtc_on.sio $(COMMON) #R37
!ENDIF

!IF EXIST(pmupost.asm)
#R37pmupost.obj:    pmupost.asm pm_ram.inc ct_pmram.inc v_alarm.inc $(COMMON)\
#R37                usbbios.asm usb.equ hci.equ hcdata.inc
!IF EXIST(pmupost.inc)
pmupost.obj:    pmupost.asm pm_ram.inc ct_pmram.inc v_alarm.inc rtc_on.sio $(COMMON)\
                usbbios.asm usb.equ hci.equ hcdata.inc pmupost.inc\
		$(USB_SOURCE)
#R52		uhci.asm ohci.asm
!ELSE
pmupost.obj:    pmupost.asm pm_ram.inc ct_pmram.inc v_alarm.inc rtc_on.sio $(COMMON)\
                usbbios.asm usb.equ hci.equ hcdata.inc\
		$(USB_SOURCE)
#R52		uhci.asm ohci.asm
!ENDIF
!ENDIF

#R58 !IF EXIST(pmu32.asm)
#R58 #R37pmu32.obj:      pmu32.asm pm_ram.inc ct_pmram.inc $(COMMON)
#R58 pmu32.obj:      pmu32.asm pm_ram.inc ct_pmram.inc rtc_on.sio $(COMMON)#R37
#R58 !ENDIF

!IF EXIST(apm.asm)
apm.obj:        apm.asm pm_ram.inc $(COMMON)
!ENDIF

!IF EXIST(apm32.asm)
apm32.obj:      apm32.asm pm_ram.inc $(COMMON)
!ENDIF

!IF EXIST(setup.asm)
setup.obj:      setup.asm $(COMMON)
!ENDIF

!IF EXIST(kernal.asm)
kernal.obj:     kernal.asm $(COMMON)
!ENDIF

!IF EXIST(stdcmos.asm)
stdcmos.obj:    stdcmos.asm $(COMMON)
!ENDIF

!IF EXIST(bfeature.asm)
bfeature.obj:   bfeature.asm $(COMMON)
!ENDIF

!IF EXIST(cfeature.asm)
cfeature.obj:   cfeature.asm jumpless.inc $(SIO_SOURCE1) $(SIO_SOURCE2) $(SIO_SOURCE3) $(SIO_SOURCE4) $(SSR_SOURCE1) $(CLK_SOURCE1) $(COMMON) 
#R22 - starts
 ml /c /Zm /Dmasm611=1 cfeature.asm
#R22 - ends
!ENDIF

!IF EXIST(pfeature.asm)
!IF EXIST(pfeature.mnu)
pfeature.obj:   pfeature.asm PFEATURE.MNU $(COMMON)
!ELSE
pfeature.obj:   pfeature.asm $(COMMON)
!ENDIF
!ENDIF

!IF EXIST(pcifeat.asm)
pcifeat.obj:    pcifeat.asm $(SIO_SOURCE1) $(SIO_SOURCE2) $(SIO_SOURCE3) $(SIO_SOURCE4) $(COMMON)
!ENDIF

!IF EXIST(IOFEAT.ASM)
#R09 IOFEAT.OBJ:        IOFEAT.ASM $(AIO_SOURCE) $(COMMON)
IOFEAT.OBJ:     IOFEAT.ASM $(AIO_SOURCE) $(COMMON) $(SIO_SOURCE1) $(SIO_SOURCE2) $(SIO_SOURCE3) $(SIO_SOURCE4)  #R09
#R22 - starts
 ml /c /Zm /Dmasm611=1 iofeat.asm
#R22 - ends
!ENDIF

!IF EXIST(PNPFEAT.ASM)
PNPFEAT.OBJ:    PNPFEAT.ASM $(AIO_SOURCE) $(COMMON)
!ENDIF

!IF EXIST(avideo.asm)
avideo.obj:     avideo.asm 6845.equ avideo.equ $(COMMON)
!ENDIF

!IF EXIST(pm_ram.asm)
pm_ram.obj:     pm_ram.asm $(COMMON)
!ENDIF

#R44 - start
!IF EXIST(mpinit.asm)
mpinit.obj:	mpinit.asm $(COMMON)
!ENDIF
#R44 - end

#R16B #R16 - START
#R16B !IF EXIST(sst020.asm)
#R16B sst020.obj:       sst020.asm sst020.nvm $(COMMON)
#R16B !ENDIF

#R16B !IF EXIST(atmel020.asm)
#R16B atmel020.obj:     atmel020.asm atmel020.nvm $(COMMON)
#R16B !ENDIF

#R16B !IF EXIST(am29f002.asm)
#R16B am29f002.obj:     am29f002.asm am29f002.nvm $(COMMON)
#R16B !ENDIF
#R16B #R16 - END

!IF EXIST(afixorg.asm)
afixorg.obj:    afixorg.asm $(COMMON)
!ENDIF

!IF EXIST(e8fixorg.asm)
e8fixorg.obj:   e8fixorg.asm $(COMMON)
!ENDIF

!IF EXIST(efixorg.asm)
efixorg.obj:    efixorg.asm $(COMMON)
!ENDIF

#R57 start
!IF EXIST(netpctbl.asm)
netpctbl.obj:    netpctbl.asm $(COMMON)
!ENDIF
#R57 end

!IF EXIST(mfixorg.asm)
mfixorg.obj:    mfixorg.asm $(COMMON)
!ENDIF

!IF EXIST(chippost.asm)
chippost.obj:   chippost.asm jumpless.inc $(COMMON)
!ENDIF

!IF EXIST(chiprun.asm)
chiprun.obj:    chiprun.asm $(COMMON)
!ENDIF

!IF EXIST(pci1a.asm)
pci1a.obj:      pci1a.asm $(COMMON)
!ENDIF

!IF EXIST(pci32.asm)
pci32.obj:      pci32.asm $(COMMON)
!ENDIF

!IF EXIST(pci1a_m2.asm)
pci1a_m2.obj:   pci1a_m2.asm $(COMMON)
!ENDIF

!IF EXIST(pci32_m2.asm)
pci32_m2.obj:   pci32_m2.asm $(COMMON)
!ENDIF

!IF EXIST(nvm.asm)
nvm.obj:        nvm.asm nvm.equ $(COMMON)
!ENDIF

!IF EXIST(eisainit.asm)
eisainit.obj:   eisainit.asm $(COMMON)
!ENDIF

!IF EXIST(eisamain.asm)
eisamain.obj:   eisamain.asm eisamain.inc eisa.equ eisa.mac $(COMMON)
!ENDIF

!IF EXIST(eisa_32.asm)
eisa_32.obj:    eisa_32.asm eisa_32.inc eisa.equ eisa.mac $(COMMON)
!ENDIF

!IF EXIST(cpu.asm)
cpu.obj:        cpu.asm $(COMMON)
!ENDIF

#R33 !IF EXIST(cpupost.asm)
#R33 cpupost.obj:    cpupost.asm $(COMMON)
#R33 !ENDIF

#R33 - starts
!IF EXIST(cpupost.asm)
#R33A cpupost.obj:    cpupost.asm $(COMMON)
#R33A - starts
cpupost.obj:    cpupost.asm $(COMMON)
#R33A - ends
 ml /c /Zm /Dmasm611=1 /DCompile_For_E0=1 cpupost.asm

cpupe8.obj:    cpupost.asm $(COMMON)
 ml /c /Zm /Dmasm611=1 /DCompile_For_E0=0 /Focpupe8.obj cpupost.asm
!ENDIF
#R33 - ends

!IF EXIST(pnppost.asm)
pnppost.obj:    pnppost.asm pnpdata.inc pnp.equ btromseg.equ dmi.equ $(COMMON)
!ENDIF

#R31 - starts
!IF EXIST(pnpe0.asm)
pnpe0.obj:	pnpe0.asm pnpdata.inc pnp.equ btromseg.equ dmi.equ $(COMMON)
 ml /c /Zm /Dmasm611=1 pnpe0.asm
!ENDIF
#R31 - ends

#R05 !IF EXIST(pnpbios.asm)
#R05 pnpbios.obj:       pnpbios.asm pnpdata.inc pnp.equ btromseg.equ dmi_func.inc dmi.equ $(COMMON)
#R05 !ENDIF
#R05 start
!IF EXIST(pnpbios.asm)
#R51 pnpbios.obj:    pnpbios.asm pnpdata.inc pnp.equ btromseg.equ acpi.inc $(COMMON)
pnpbios.obj:    pnpbios.asm pnpdata.inc pnp.equ btromseg.equ acpi.inc acpi_ct.inc $(COMMON) #R51
!ENDIF

!IF EXIST(dmifunc.asm)
dmifunc.obj:    dmifunc.asm pnp.equ btromseg.equ dmi.equ $(COMMON)
!ENDIF
#R05 end

#R12 start
!IF EXIST(dmipost.asm)
# use MASM v6.11
dmipost.obj:    dmipost.asm dmi.equ dmi_mb.inc dmi_mb.cfg dmipost.equ dmi_ct.inc  $(COMMON)
#R13   ml /c dmipost.asm
  ml /c /DMASM611=1 dmipost.asm
!ENDIF
#R12 end

!IF EXIST(pnpchip.asm)
pnpchip.obj:    pnpchip.asm pnpdata.inc pnp.equ btromseg.equ $(COMMON)
!ENDIF

!IF EXIST(pnpio.asm)
pnpio.obj:      pnpio.asm pnpdata.inc pnp.equ $(SIO_SOURCE1) $(SIO_SOURCE2) $(SIO_SOURCE3) $(SIO_SOURCE4) btromseg.equ $(COMMON)
!ENDIF

!IF EXIST(pnpkernl.asm)
pnpkernl.obj:   pnpkernl.asm pnpdata.inc pnp.equ btromseg.equ $(COMMON)
!ENDIF

!IF EXIST(escdchip.asm)
#R34 escdchip.obj:   escdchip.asm pnpdata.inc pnp.equ btromseg.equ $(NVM_SOURCE) $(COMMON)
escdchip.obj:   escdchip.asm pnpdata.inc pnp.equ btromseg.equ ROMLEN.INC $(NVM_SOURCE) $(COMMON)	#R34
!ENDIF

!IF EXIST(aflash.asm)
aflash.obj:     aflash.asm $(COMMON)
!ENDIF

!IF EXIST(superio.asm)
superio.obj:    superio.asm $(SIO_SOURCE1) $(SIO_SOURCE2) $(SIO_SOURCE3) $(SIO_SOURCE4) $(COMMON)
#R15 - starts
  ml /c /DMASM611=1 /Zm superio.asm
#R15 - ends
!ENDIF

#R50 - starts
!IF EXIST(sensor.asm)
sensor.obj:    sensor.asm $(SSR_SOURCE1) $(COMMON)
  ml /c /DMASM611=1 /DCOMPILE_FOR_SENSOR_ASM=2 /Zm sensor.asm
!ENDIF
#R50 - ends

#R56 - starts
!IF EXIST(clkcntl.asm)
clkcntl.obj:    clkcntl.asm $(CLK_SOURCE1) $(COMMON)
  ml /c /DMASM611=1 /DCOMPILE_FOR_CLKCNTL_ASM=2 /Zm clkcntl.asm
!ENDIF
#R56 - ends

#R11 - starts
!IF EXIST(auto_io.asm)
auto_io.obj:    auto_io.asm $(SIO_SOURCE1) $(SIO_SOURCE2) $(SIO_SOURCE3) $(SIO_SOURCE4) $(COMMON)
 ml /c /DMASM611=1 /Zm auto_io.asm
!ENDIF
#R11 - ends

!IF EXIST(audio.asm)
#R19 audio.obj: audio.asm $(AIO_SOURCE) $(COMMON)
#R32 audio.obj:      audio.asm ymf711.aio ymf715.aio cs4236.aio $(AIO_SOURCE) $(COMMON) #R19
#audio.obj:      audio.asm ymf711.aio ymf715.aio cs4236.aio $(AIO_SOURCE) $(COMMON) #R32
audio.obj:      audio.asm $(AIO_SOURCE) $(COMMON)
!ENDIF

!IF EXIST(pnpaudio.asm)
pnpaudio.obj:   pnpaudio.asm $(AIO_SOURCE) $(COMMON)
!ENDIF

#R40 !IF EXIST(pci21.asm)
#R40 pci21.obj:      pci21.asm $(COMMON)
#R40 !ENDIF

#R53  - starts
!IF EXIST(pci21tbl.asm)
pci21tbl.obj:      pci21tbl.asm $(COMMON)
!ENDIF
#R53  - ends

!IF EXIST(vuma.asm)
vuma.obj:       vuma.asm $(COMMON)
!ENDIF

!IF EXIST(vuma32.asm)
vuma32.obj:     vuma32.asm $(COMMON)
!ENDIF

#R03 - start
!IF EXIST(bios16.asm)
bios16.obj:     bios16.asm $(COMMON)
!ENDIF

!IF EXIST(smba.asm)
smba.obj:       smba.asm $(COMMON)
!ENDIF
#R03 - end

!IF EXIST(sus2disk.asm)
sus2disk.obj:   sus2disk.asm $(COMMON)
!ENDIF

#R04 - start
!IF EXIST(p6update.asm)
p6update.obj:   p6update.asm p6update.equ pnp.equ $(COMMON)
!ENDIF
#R04 - end

#R06 - start
!IF EXIST(misc.asm)
misc.obj:       misc.asm $(COMMON)
!ENDIF
#R06 - end

#R07 - start
#R17!IF EXIST(usbpost.asm)
#R17usbpost.obj:        usbpost.asm usb.equ hci.equ hcdata.inc $(COMMON)
#R17!ENDIF
#R07 - end

#R25 - start
!IF EXIST(smb.asm)
smb.obj:        smb.asm $(COMMON)
!ENDIF

!IF EXIST(smb32.asm)
smb32.obj:      smb32.asm $(COMMON)
!ENDIF
#R25 - end

#R28 - start
!IF EXIST(smi.asm)
smi.obj:        smi.asm ct_smi.inc $(COMMON)
!ENDIF
#R28 - end

#R30 - start
!IF EXIST(supervga.asm)
supervga.obj:   supervga.asm pm_ram.inc sm_ram.inc $(VGA_SOURCE1) $(COMMON)
        ml /c /Zm supervga.asm
!ENDIF
#R30 - end

#R35 - start
!IF EXIST(superkbc.asm)
superkbc.obj:   superkbc.asm pm_ram.inc sm_ram.inc $(KBC_SOURCE1) $(COMMON)
        ml /c /Zm superkbc.asm
!ENDIF
#R35 - end

#R36 start
!IF EXIST(cpucode.asm)
cpucode.obj:   cpucode.asm $(COMMON)
	masm cpucode;
!ENDIF
#R36 end

#R49 start
!IF EXIST(awardepa.asm)
awardepa.obj:   awardepa.asm $(COMMON)
	masm awardepa;
!ENDIF
#R49 end

#R38 start
!IF EXIST(acpi.asm)
acpi.obj:   acpi.asm acpi.inc $(COMMON)
	masm acpi;
!ENDIF

!IF EXIST(acpitbl.asm)
acpitbl.obj:   acpitbl.asm acpi_ct.inc $(COMMON)
	masm acpitbl;
!ENDIF

!IF EXIST(dsdt.asl)
dsdt.aml:   dsdt.asl *.asl
	asl dsdt.asl
!ENDIF
#R38 end

#45 - start
!IF EXIST(smbhost.asm)
#47smbhost.obj:        SMBHOST.ASM M388XX.SMB SMB.INC $(COMMON)
#47 - start
smbhost.obj:        SMBHOST.ASM SMB.INC $(SMB_SOURCE) $(COMMON)
#47 - end
!ENDIF
#45 - end

#R48 start
!IF EXIST(xfile.asm)
xfile.obj:      xfile.asm $(COMMON)
!ENDIF
#R48 end

#R55 start
!IF EXIST(Cardbus.asm)
Cardbus.obj:      Cardbus.asm $(COMMON)
!ENDIF
#R55 end
