;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;
;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;--------------------------2A5II---------------------------------------------
;R13	12/26/97 DRS	Move Ct_Enable_C_Shadow hook from chiprun.asm
;R04E	10/06/97 AVN	Fixed SDRAM fail if only BANK0 BANK2 plug, when test
;			BANK1 always fail and change latency time.
;R04D	09/18/97 AVN	Sizing SDRAM setting CAS latency time by setup, when
;			sizing fail toggle latency time	and test again, but
;			setup value no change. define 'AUTO_SDRAM_CAS_LAT'
;R12	09/12/97 AVN	Fixed use NEC sdram (2T) warm boot will hang, because
;			SHADOW_OK_CMOS(46h) in cmos checksum locate and always
;			clear when write cmos from stack.
;R04C	08/07/97 AVN	Fixed cannot detect second SDRAM.
;R04B	07/29/97 AVN	Change SDRAM CAS Latency setting by setup
;			define 'SCL_USE_CMOS_SETUP'
;R11A	06/23/97 AVN	Remove for Gemlight.
;R11	06/18/97 AVN	Default CPU Core Voltage Value for Gemlight.
;R10	06/13/97 RAY	Fix some NEC SDRAM which must be programmed to 2T in
;			order to work fine. I change the Boot Monitoring
;			algorithm a little. Instead of using 3T as the default
;			fail-safe SDRAM timing, I try to toggle the CMOS setting
;			from 2T to 3T(3T to 2T).
;R04A	05/29/97 AVN	Support NEC SDRAM must define 'NO_SDRAM_CAS_LAT_ITEM'
;			and CAS latency always set 2T.
;R09A	04/29/97 LRY	Support acpi-button power off from B2 version
;R09	04/10/97 LRY	Support acpi-button power off for B version
;R05A	04/03/97 LRY	Fixed B version can't use PS/2 mouse
;R08	04/03/97 LRY	Special for Abit.
;R07	04/02/97 LRY	Porting ACPI base,  auto detect A or B version
;R06	04/01/97 LRY	Support "LINEAR_MODE_GPIO5"  (OPTIONAL)
;R05	04/01/97 LRY	Added B version internal KBC support
;R04	03/14/97 LRY	Added SDRAM CAS latency item
;R03	03/06/97 LRY	By SiS inform, L2 cache don't support write through
;R02	02/17/97 LRY	Support SiS 2MB ROM BIOS
;R01	01/09/97 LRY	Fixed sometime warm boot hang at post code C1h
;R00	01/08/97 LRY	Initial version


;[]==============================================================[]
;
; CT_Memory_Presence:
;
;	Size the amount of on-board memory and update chipset
;	registers
;
; Saves: BP,SP
; Entry: None
;  Exit: None
; Note : 1. No stack available
;[]==============================================================[]
ifdef	COMPRESS_CODE
ifdef	CompileForExtROM
GET_CT:
CONFIG_ADDR	EQU	0CF8h
		shl	edx,16		;save dx
		shl	eax,16
		mov	ax,8000h
		rol	eax,16
		xchg	cx,ax		;then ch=ah, ah=ch, al=cl
		mov	cl,al		;then cl=cl
		and	al,NOT 03h	;32 bit access for PCI
		mov	dx,CONFIG_ADDR	;index is 0cf8h
		out	dx,eax
		add	dl,4		;start from 0cfch
		xchg	cx,ax		;then ch=ch, ah=ah, al=cl
		mov	cl,al		;then cl=cl
		and	al,03h
		add	dl,al		;byte index to read
		in	al,dx
		shr	edx,16		;restore dx
		ret

SET_CT:

		cmp	cx,0FF00h
		jb	short @F
		ret
	@@:

		shl	edx,16		;save dx
		xchg	ax,cx
		shl	ecx,16		;save value
		xchg	ax,cx		;restore cx

		mov	eax,80000000h	;device 16 is for 881
		mov	ax,cx
		and	al,NOT 03h	;32 bit access for PCI
		mov	dx,CONFIG_ADDR	;index is 0cf8h
		out	dx,eax
		add	dl,4		;start from 0cfch
		mov	al,cl
		and	al,03h
		add	dl,al		;byte index to read
		mov	eax,ecx
		shr	eax,16
		out	dx,al
		shr	edx,16		;restore dx
		ret
endif	;CompileForExtROM

		align	4
GDTR1:						; global descriptor table register
		dw	8*3			; LIMIT
		dw	offset DGROUP:GDT1
		dw	0fh			; in 0F000h segment

GDT1:						; null descriptor
		dw	0			; limit
		dw	0			; base
		db	0			; hibase
		db	0			; access
		db	0			; hilimit
		db	0			; msbase

CODE1_DT:					; cs - prom code segment
CODE1_INDEX	=	((offset CODE1_DT - offset GDT1)/8) SHL 3

		dw	0ffffh			; limit
		dw	0			; base	a15-a0
		db	0fh			; hibase   a23-a16, assume we have 64k prom
		db	9fh			; access
		db	0			; hilimit
		db	0			; msbase   a31-a24

DATA1_DT:					; ds - first 64k segment
DATA1_INDEX	=	((OFFSET DATA1_DT - OFFSET GDT1)/8) SHL 3
		dw	0ffffh			; limit
		dw	0			; base data segment points to
		db	0			; hibase	; 00000000
		db	93h			; access
		db	08fh			; hilimit (4GB)
		db	0			; msbase
endif	;COMPRESS_CODE


ifdef	CompileForExtROM
		ALIGN 4
		public	Get_CMOS2
Get_CMOS2	proc	near
		OUT	70h,AL			; address to interface
		jcxz	short $+2
		ALIGN	4
		IN	AL,71h
		jcxz	short $+2
		ret	
Get_CMOS2	endp

		ALIGN 4
		public	Set_CMOS2
Set_CMOS2	proc	near
		OUT	70h,AL			; address to interface
		jcxz	short $+2
		xchg	al,ah			;ah=index,al=value	   
		ALIGN 4
		OUT	71h,AL			; and output it
		jcxz	short $+2
		ret
Set_CMOS2	endp
endif;	CompileForExtROM


SEG_BIOS	equ	0fh
GDTTBL		struc
F_LIMIT 	dw	-1
F_LOWADDR	dw	0
F_HIGHADDR	db	?
F_AR		db	93h
F_INTEL 	dw	0
GDTTBL		ends

EDOPATTERN0	equ	055AA55AAh
MPATTERN0	equ	012345678h
MPATTERN1	equ	0FEDCBA98h

SimmCas11	EQU	14
SimmCas10	EQU	13
SimmCas09	EQU	12
SimmCas08	EQU	11
SimmRas11	EQU	26
SimmRas10	EQU	25
SimmRas09	EQU	24
DimmCas12	EQU	14
DimmCas09	EQU	12
DimmCas08	EQU	11
DimmRas14	EQU	27
DimmRas13	EQU	26

		ALIGN 4
		PUBLIC	CT_MEMORY_PRESENCE
CT_MEMORY_PRESENCE PROC NEAR

		shl	esp,16
		shl	ebp,16
		mov	ax,G_RAM
		mov	ds,ax
		assume	ds:G_RAM
		mov	bp,ds:USER_REBOOT

ifdef	CompileForExtROM
ifdef   Jumpless_Support
	JUMPLESS_FOR_CHIPBOOT_ASM	equ	1	;R60
		mov	di,offset DGROUP:@F
		jmp	Set_Clock
     @@:
endif;	Jumpless_Support
endif	;CompileForExtROM

;R07 - start
		mov	cx,08h		;get version number
		ROM_CALL Get_Ct
		mov	ah,al		;R09
		or	al,al
		mov	cx,810h
		jz	short set_acpi_base
		mov	cx,840h
		ROM_CALL Get_Ct
		or	al,80h
		ROM_CALL Set_Ct
		mov	cx,890h
set_acpi_base:
		mov	al,ACPI_BASE_IO_ADDR mod 100h
		ROM_CALL Set_Ct
		inc	cx
		mov	al,ACPI_BASE_IO_ADDR / 100h
		ROM_CALL Set_Ct
;R09 - start
;R09A		or	ah,ah
;R09A		jz	short skip_Pwr_Bt_Or
		cmp	ah,02h				;R09A
		jb	short skip_Pwr_Bt_Or		;R09A
;R09A		mov	dx,ACPI_BASE_IO_ADDR + 2
;R09A		in	ax,dx
;R09A		or	ah,01h
;R09A		out	dx,ax
;R09A		inc	dx
;R09A		inc	dx	;then dx = ACPI_BASE_IO_ADDR + 4
		mov	dx,ACPI_BASE_IO_ADDR + 4	;R09A
		in	ax,dx
		or	ah,02h
		out	dx,ax
skip_Pwr_Bt_Or:
;R09 - end
;R07 - end
;R05 - start
		in	al,64h
		cmp	al,0FFh
		jne	short external_kbc
		mov	cx,870h
		ROM_CALL Get_Ct
;R05A		or	al,08h
		or	al,0Ch		;R05A
		ROM_CALL Set_Ct
external_kbc:
;R05 - end
;R11A ;R11 - start
;R11A ifdef	GEMLIGHT_JUMPERLESS
;R11A 		mov	dx,ACPI_BASE_IO_ADDR + 1ah
;R11A 		in	ax,dx
;R11A 		or	ax,0180h
;R11A 		out	dx,ax
;R11A 
;R11A 		mov	dx,ACPI_BASE_IO_ADDR + 18h
;R11A 		in	ax,dx
;R11A 		and	al,not 80h
;R11A 		or	ah,01h
;R11A 		out	dx,ax
;R11A endif;	GEMLIGHT_JUMPERLESS
;R11A ;R11 - end
;-------------------------------------------------------------------------
;MEMORY_SIZING
	 	mov	cx,60h
@@:
		mov	al,23h		;init reg. 60,61,62 with 23h
		ROM_CALL Set_Ct		;FP, Double, 64bits, 16M type
		inc	cx
		cmp	cl,63h
		jb	short @B
					;then cl=63h
		xor	al,al		;set all DRAM absent
		ROM_CALL Set_Ct

		mov	cl,53h 		;disable always page miss
		ROM_CALL Set_Ct
	
ifndef	AUTO_SDRAM_CAS_LAT					;R04D
ifdef	NO_SDRAM_CAS_LAT_ITEM					;R04
		mov	cl,57h 		;select SRAS, SCAS
;R04A		mov	al,12h
		mov	al,02h		;R04A
		ROM_CALL Set_Ct
;R04 - start
else	;NO_SDRAM_CAS_LAT_ITEM
ifdef	SCL_USE_CMOS_SETUP				;R04B
		mov	ah,34h NMI_OFF			;R04B
		ROM_CALL Rd_CMOS			;R04B
		and	al,1				;R04B
		shl	al,4				;R04B
		mov	bl,al				;R04B
		mov	cl,57h				;R04B set SDRAM CAS latency
		ROM_CALL Get_Ct				;R04B
		and	al,not 10h			;R04B
		or	al,02h				;R04C
		or	al,bl				;R04B
		ROM_CALL Set_Ct				;R04B
else;	SCL_USE_CMOS_SETUP				;R04B

;R12 SHADOW_OK_CMOS	equ	46h
SHADOW_OK_CMOS	equ	40h				;R12
SHADOW_OK_FLAG	equ	9Dh
		mov	ah,SHADOW_OK_CMOS NMI_OFF
		ROM_CALL Rd_CMOS
		mov	bl,al		;save flag
		xor	al,al		;clear flag
		ROM_CALL Wr_CMOS

;R07B		mov	ah,5Fh NMI_OFF
		mov	ah,34h NMI_OFF	;R07B
		ROM_CALL Rd_CMOS
		cmp	bl,SHADOW_OK_FLAG
		je	short last_shadow_ok

;R07B		or	al,80h
;R10		or	al,01h		;R07B
		xor	al, 01h			;R10
		ROM_CALL Wr_CMOS
;R10		mov	bh,10h
;R10		jmp	short last_shadow_fail
last_shadow_ok:
;R07B		and	al,80h
;R07B		shr	al,3
		and	al,01h		;R07B
		shl	al,4		;R07B
		mov	bh,al
;R10 last_shadow_fail:
		mov	cl,57h	;set SDRAM CAS latency
		mov	al,02h
		or	al,bh
		ROM_CALL Set_Ct
endif;	SCL_USE_CMOS_SETUP				;R04B
endif	;NO_SDRAM_CAS_LAT_ITEM
;R04D - start
else;	AUTO_SDRAM_CAS_LAT
SHADOW_OK_CMOS	equ	40h
SHADOW_OK_FLAG	equ	9Dh
		mov	ah,34h NMI_OFF
		ROM_CALL Rd_CMOS
		and	al,01h
		shl	al,4
		mov	bh,al
		mov	cl,57h			;set SDRAM CAS latency
		mov	al,02h
		or	al,bh
		ROM_CALL Set_Ct
endif;	AUTO_SDRAM_CAS_LAT
;R04D - end
;R04 - end

;R06 - start
ifdef	LINEAR_MODE_GPIO5
		mov	cx,845h
		ROM_CALL Get_Ct
		or	al,08h
		ROM_CALL Set_Ct
		mov	cl,04h NMI_OFF
		ROM_CALL Rd_CMOS
		and	al,not 04h
		ROM_CALL Wr_CMOS
		mov	cx,845h
		ROM_CALL Get_Ct
		and	al,not 08h
		ROM_CALL Set_Ct
		mov	dx,ACPI_BASE_IO_ADDR + 18h
		in	al,dx
		or	al,20h
		out	dx,al
		xor	cx,cx
endif	;LINEAR_MODE_GPIO5
;R06 - end
;R08 - start
ifdef	LINEAR_MODE_GPCS
 ifdef	ABIT_GPCS
		mov	cx,0864h
		mov	al,01h
		ROM_CALL Set_Ct
		mov	cx,0868h
		mov	dx,5A7Ch	;io port 5A7Ch
		mov	al,dh
		ROM_CALL Set_Ct
		dec	cx		;then cx=867h
		mov	al,dl
		ROM_CALL Set_Ct
		mov	al,11100000b	;default toggle mode, fan & suspend off
		out	dx,al
 endif	;ABIT_GPCS
endif	;LINEAR_MODE_GPCS
;R08 - end

	;check if CYRIX CPU plugged
		xor	ax,ax
		sahf
		mov	ax,5
		mov	bx,2
		div	bl
		lahf
		cmp	ah,2
		mov	bl,0			;assume not Cyrix's CPU
		jne	short Skip_Linear_Mode	;not Cyrix's CPU

		Enable_Linear_Code = 1
ifdef	LINEAR_SRAM
 if	LINEAR_SRAM eq 0
		Enable_Linear_Code = 0
 endif
else	;LINEAR_SRAM
		mov	al,50h+80h		;get setup item from cmos
		out	70h,al
		NEWIODELAY
		in	al,71h
		NEWIODELAY
		shl	al,1			;bit 7
		jnc	short Skip_Linear_Mode
endif	;LINEAR_SRAM

if	Enable_Linear_Code ne 0
		mov	cl,51h			;enable linear mode
		ROM_CALL Get_Ct
		or	al,04h
		ROM_CALL Set_Ct

;R06 - start
 ifdef	LINEAR_MODE_GPIO5
		mov	dx,ACPI_BASE_IO_ADDR + 18h
		in	al,dx
		and	al,not 20h
		out	dx,al
 endif	;LINEAR_MODE_GPIO5
;R06 - end
;R08 - start
ifdef	LINEAR_MODE_GPCS
 ifdef	ABIT_GPCS
		mov	dx,5A7Ch	;io port 5A7Ch
		mov	al,01100000b	;linear mode, fan & suspend off
		out	dx,al
		mov	cx,0867h
		mov	al,02h		;release io port
		ROM_CALL Set_Ct
 endif	;ABIT_GPCS
endif	;LINEAR_MODE_GPCS
;R08 - end
endif	;Enable_Linear_Code ne 0
		
Skip_Linear_Mode:

;Enter protected mode
		mov	ax,cs
		mov	ds,ax
		assume	ds:dgroup

		lgdt	fword ptr DGROUP:GDTR1

		mov	eax,cr0
		or	al,1
		mov	cr0,eax

		FAR_JMP DGROUP:$+4,08H		; CLEAR PREFETCH, BIOS CS

		mov	ax,DATA1_INDEX
		mov	ds,ax			; ds = 00000000h
		mov	es,ax
		assume	ds:NOTHING,es:NOTHING


		mov	al,FALSE
		ROM_CALL Cpu_Cache

		xor	edi,edi
		mov	cx,62h		;bank 2
		mov	bl,04h		;bank 2

DBRx_loop_start:
;R04D - start
ifdef	AUTO_SDRAM_CAS_LAT
		mov	ah,SHADOW_OK_CMOS NMI_OFF
		xor	al,al				;clear flag
		ROM_CALL Wr_CMOS
endif;	AUTO_SDRAM_CAS_LAT
;R04D - end
		mov	si,cx		;save cx

		mov	cl,63h
		ROM_CALL Get_Ct
		or	al,bl
		ROM_CALL Set_Ct

		ROM_CALL dram_ok_or_not
		jne	short test_SDRAM

		mov	dword ptr ds:[edi],EDOPATTERN0

		mov	eax,80000054h	;set EDO test mode
		mov	dx,0CF8h
		out	dx,eax
		mov	dx,0CFDh
		in	al,dx
		or	al,40h
		align	16
		out	dx,al
		cmp	dword ptr ds:[edi],EDOPATTERN0	;R01
		lahf					;R01
		and	al,not 40h			;R01
		out	dx,al				;R01
		xor	dh,dh				;R01
		sahf					;R01
		jne	short is_FP			;R01
		mov	dh,40h				;R01
is_FP:							;R01
;R01		xor	dh,dh
;R01		cmp	dword ptr ds:[edi],EDOPATTERN0
;R01		jne	short is_FP
;R01		mov	dh,40h
;R01is_FP:
;R01		mov	cl,55h		;reset EDO test mode
;R01		ROM_CALL Get_Ct
;R01		and	al,not 40h
;R01		ROM_CALL Set_Ct

ifndef	AUTO_SDRAM_CAS_LAT				;R04D
		jmp	short dram_type_ok_dh
else;	AUTO_SDRAM_CAS_LAT				;R04D
		jmp	dram_type_ok_dh			;R04D
endif;	AUTO_SDRAM_CAS_LAT				;R04D

test_SDRAM:
		mov	dh,0C0h		;assume SDRAM
		ROM_CALL set_dram_type_dh

		mov	cl,56h
		ROM_CALL Get_Ct
		or	al,08h
		ROM_CALL Set_Ct

		inc	cx		;then cl=57h
		ROM_CALL Get_Ct
		or	al,80h
		ROM_CALL Set_Ct

		or	al,40h
		ROM_CALL Set_Ct

		dec	cx		;then cl=56h
		ROM_CALL Get_Ct
		and	al,not 08h
		ROM_CALL Set_Ct

		inc	cx		;then cl=57h
		ROM_CALL Get_Ct
		or	al,20h
		ROM_CALL Set_Ct

		ROM_CALL Set_Ct

		ROM_CALL dram_ok_or_not
		je	short dram_type_ok_dh

;R04D - start
ifdef	AUTO_SDRAM_CAS_LAT
		mov	ah,SHADOW_OK_CMOS NMI_OFF
		ROM_CALL Rd_CMOS
;R04E		xor	dh,dh
		cmp	al,SHADOW_OK_FLAG
;R04E		je	short dram_type_ok_dh
		je	short Restore_SDRAM_CAS_Value		;R04E

		mov	ax,((SHADOW_OK_CMOS NMI_OFF) shl 8) + SHADOW_OK_FLAG
		ROM_CALL Wr_CMOS

		mov	cx,57h	;set SDRAM CAS latency
		ROM_CALL Get_Ct
		xor	al,10h
		ROM_CALL Set_Ct
		mov	cx,si			;load cx
		jmp	test_SDRAM

;R04E - start
Restore_SDRAM_CAS_Value:
		mov	cx,57h	;set SDRAM CAS latency
		ROM_CALL Get_Ct
		xor	al,10h
		ROM_CALL Set_Ct
;R04E - end
endif;	AUTO_SDRAM_CAS_LAT
;R04D - end
		xor	dh,dh

dram_type_ok_dh:
		ROM_CALL set_dram_type_dh

DRAM_exist_or_not:
		align	16
		mov	dword ptr ds:[edi],   MPATTERN0
		mov	dword ptr ds:[edi+4], MPATTERN1
		WBINVD

		cmp	dword ptr ds:[edi],   MPATTERN0
		jne	NotDramExist
		cmp	dword ptr ds:[edi+4], MPATTERN1
		je	short Double_Or_Single
for32bit:
		or	dh,10h

Double_Or_Single:
		mov	cx,si		;restore cx
		mov	edi,[1 shl 27]	;128M top
		cmp	dh,0C0h		;SDRAM ?
		jb	short @F	;no, jump
		mov	edi,[1 shl 23]	;8M top
		mov	al,0E0h		;SDRAM double 1M type
		ROM_CALL Set_Ct
@@:
		ROM_CALL dram_ok_or_not
		jne	short Single_Side
		or	dh,20h
Single_Side:
		xor	edi,edi
		cmp	dh,0C0h		;SDRAM ?
		jb	short @F	;no, jump
		mov	al,0CBh		;SDRAM single 32M type
		ROM_CALL Set_Ct
@@:
		mov	byte ptr ds:[edi][1 shl 3], 61h		;test MA0
		cmp	byte ptr ds:[edi], 61h
		jne	short @F
		mov	cl,57h	  	;set MA0B, MA1B
		ROM_CALL Get_Ct
		and	al,not 02h
		ROM_CALL Set_Ct
@@:
two_simm_loop_start:
		cmp	dh,0C0h
		jae	SDRAM_MA
FP_EDO_MA:
		mov	byte ptr ds:[edi][1 shl SimmCas11], 10
		mov	byte ptr ds:[edi][1 shl SimmCas10], 09
		mov	byte ptr ds:[edi][1 shl SimmCas09], 08
		mov	byte ptr ds:[edi][1 shl SimmCas08], 07

		cmp	byte ptr ds:[edi], 07
		jne	short CAS08_decode
		mov	byte ptr ds:[edi]	   	  ,0100b  ;1M-A4
		jmp	short one_simm_ok1
CAS08_decode:
		cmp	byte ptr ds:[edi], 08
		jne	short CAS09_decode
		mov	byte ptr ds:[edi]	   	  ,0101b  ;2M-A3
		mov	byte ptr ds:[edi][1 shl SimmRas11],1001b  ;1M-A2
		mov	byte ptr ds:[edi][1 shl SimmRas10],1000b  ;512k
		mov	byte ptr ds:[edi][1 shl SimmRas09],0000b  ;256k
		jmp	short one_simm_ok1
CAS09_decode:
		cmp	byte ptr ds:[edi], 09
		jne	short CAS10_decode
		mov	byte ptr ds:[edi]	   	  ,0110b  ;4M-A2
		mov	byte ptr ds:[edi][1 shl SimmRas11],1010b  ;2M-A1
		mov	byte ptr ds:[edi][1 shl SimmRas10],0001b  ;1M-S 
		jmp	short one_simm_ok1
CAS10_decode:
		cmp	byte ptr ds:[edi], 10
		jne	short CAS11_decode
		mov	byte ptr ds:[edi]	   	  ,0111b  ;8M-A1
		mov	byte ptr ds:[edi][1 shl SimmRas11],0010b  ;4M-S 
		jmp	short one_simm_ok1
CAS11_decode:
		mov	byte ptr ds:[edi]	   	  ,0011b  ;16M
one_simm_ok1:
		jmp	one_simm_ok
SDRAM_MA:
		mov	byte ptr ds:[edi][1 shl DimmCas12], 2

		cmp	byte ptr ds:[edi], 2
		jne	short Dimm4bank
Dimm2bank:
		mov	byte ptr ds:[edi][1 shl DimmRas13], 11

		cmp	byte ptr ds:[edi], 11
		jne	short DimmRAS13_decode1
		mov	byte ptr ds:[edi]	   	  ,1000b  ;4M-12x10
		mov	byte ptr ds:[edi][1 shl DimmCas09],0100b  ;2M-12x9
		mov	byte ptr ds:[edi][1 shl DimmCas08],0000b  ;1M-12x8
		jmp	short one_simm_ok
DimmRAS13_decode1:
		mov	byte ptr ds:[edi]	   	  ,1001b  ;16M-14x10
		mov	byte ptr ds:[edi][1 shl DimmCas09],0101b  ;8M -14x9
		mov	byte ptr ds:[edi][1 shl DimmCas08],0001b  ;4M -14x8
		jmp	short one_simm_ok
Dimm4bank:
		mov	byte ptr ds:[edi][1 shl DimmRas14], 12
		mov	byte ptr ds:[edi][1 shl DimmRas13], 11

		cmp	byte ptr ds:[edi], 11
		jne	short DimmRAS13_decode2
		mov	byte ptr ds:[edi]	   	  ,1100b  ;2M-13x8
		jmp	short one_simm_ok
DimmRAS13_decode2:
		cmp	byte ptr ds:[edi], 12
		jne	short DimmRAS14_decode2
		mov	byte ptr ds:[edi]	   	  ,1010b  ;16M-14x10
		mov	byte ptr ds:[edi][1 shl DimmCas09],0110b  ;8M -14x9
		mov	byte ptr ds:[edi][1 shl DimmCas08],0010b  ;4M -14x8
		jmp	short one_simm_ok
DimmRAS14_decode2:
		mov	byte ptr ds:[edi]	   	  ,1011b  ;32M-15x10
		mov	byte ptr ds:[edi][1 shl DimmCas09],0111b  ;16M-15x9
		mov	byte ptr ds:[edi][1 shl DimmCas08],0011b  ;8M -15x8
one_simm_ok:
		test	dh,10h
		jz	short Is64
		mov	ax,ds:[edi]
		jmp	short boundary_sure
Is64:
		test	di,4		;already repeat loop?
		jnz	short two_simm_ok
		mov	ax,ds:[edi]
		add	di,4		;test another simm
		jmp	two_simm_loop_start

NotDramExist:
		mov	cl,63h
		ROM_CALL Get_Ct
		not	bl
		and	al,bl
		not	bl
		ROM_CALL Set_Ct

		xor	al,al		;reset type
		xor	dh,dh
		jmp	short boundary_sure

two_simm_ok:
		cmp	al,ds:[edi]
		jbe	short @F
		mov	ax,ds:[edi]
@@:
		sub	di,4		;restore edi
boundary_sure:
		mov	cx,si		;restore cx
		or	al,dh
		ROM_CALL Set_Ct

		dec	cx
		shr	bl,1
		jnc	DBRx_loop_start


sizing_done:


;--------------------------------------------------------------------------
CACHE_SIZING:
		POST_CODE 0C6H

;Enable CPU cache
		mov	al,TRUE
		ROM_CALL Cpu_Cache

		mov	cx,51h		;L2 exist, enable, 512k, WT,
		ROM_CALL Get_Ct		
		and	al,04h		;don't change linear mode
		or	al,0E1h
		ROM_CALL Set_Ct

		xor	edi,edi

		ROM_CALL cache_ok_or_not
		je	short DetectSize
Noncache:
		xor	bl,bl
		jmp	short size_got

DetectSize:
		mov	eax,5AA51234h
		mov	ds:[edi][100h],eax
		WBINVD
		IODELAY
		mov	bl,00010000b
		cmp	ds:[edi][40100h],eax
		je	short size_got
		mov	bl,00100000b
size_got:

		mov	cl,51h		
		ROM_CALL Get_Ct
		and	al,0Eh
		or	al,08h	;R03	;enable WB
		or	al,bl		;set cache size
		ROM_CALL Set_Ct

cache_sizing_done:

back_real:
; switch back to real mode

		mov	eax,cr0
		and	al, NOT 1
		mov	cr0,eax

		FAR_JMP DGROUP:$+4,0f000h		; flush instruction decode queue

		mov	al,FALSE
		ROM_CALL Cpu_Cache

		mov	ax,G_RAM
		mov	ds,ax
		assume	ds:G_RAM
		mov	ds:USER_REBOOT,bp
		shr	ebp,16
		align	16
		shr	esp,16
		clc
		ret
;--------------------------------------------------------------------------

set_dram_type_dh:
		mov	cx,si
		shl	esi,16
		mov	si,sp

		ROM_CALL Get_Ct
		and	al,not 0C0h
		or	al,dh
		ROM_CALL Set_Ct

		mov	sp,si
		shr	esi,16
		ret


dram_ok_or_not:
		mov	dword ptr ds:[edi],   MPATTERN0
		mov	dword ptr ds:[edi+4], MPATTERN1
		jmp	short $+2
		cmp	dword ptr ds:[edi],   MPATTERN0
		ret


cache_ok_or_not:
		mov	dword ptr ds:[edi],  MPATTERN0
		mov	dword ptr ds:[edi+4h],MPATTERN1
		cmp	dword ptr ds:[edi],  MPATTERN0
		jne	short @F
		cmp	dword ptr ds:[edi+4h],MPATTERN1
		jne	short @F
		mov	dword ptr ds:[edi],  not MPATTERN0
		mov	dword ptr ds:[edi+4h],not MPATTERN1
		cmp	dword ptr ds:[edi],  not MPATTERN0
		jne	short @F
		cmp	dword ptr ds:[edi+4h],not MPATTERN1
@@:
		ret


;R04 - start
Rd_CMOS:
;INPUT	ah = index
;OUTPUT	al = data
		mov	al,ah
		out	70h,al
		newiodelay
		in	al,71h
		ret
Wr_CMOS:
;INPUT	ah = index
;	al = data
		xchg	al,ah
		out	70h,al
		newiodelay
		xchg	al,ah
		out	71h,al
		ret
;R04 - end
CT_MEMORY_PRESENCE ENDP

ifdef	CompileForExtROM
ifdef   Jumpless_Support
		include	JUMPLESS.INC
endif;	Jumpless_Support
endif	;CompileForExtROM

ifndef	CompileForExtROM
;[]==============================================================[]
; Ct_Early_Shadow_System_Bios:
;	Shadowing system before memory testing to speedup POST.
;
;Saves: SP,BP
;Input : None
;Output: None
;[Notes]
;	1. This routine will shadow system BIOS in early stage
;	   of POST.
;	2. Stack not available
;[]==============================================================[]
		align	4
		PUBLIC	Ct_Early_Shadow_System_Bios
Ct_Early_Shadow_System_Bios	PROC	NEAR

ifdef	COMPRESS_CODE
	;program chipset with read from ROM , write to shadow RAM

		mov	cx,76h
		mov	bx,205Fh		;F000 shadow RAM writeable
		call	Get_Set_Ct

		dec	cx			;then cl=75h
		mov	bx,2255h		;E000 shadow RAM writeable
		call	Get_Set_Ct
		dec	cx			;then cl=74h
		call	Get_Set_Ct

		mov	si,ds
		mov	di,0E000h
		mov	cx,08000h		;64K
		pusha
		call	Move_Codes

		popa				;64K
		add	si,1000h
		mov	di,0F000h
		call	Move_Codes

	;program chipset with  write protect
		mov	cx,76H
		mov	bx,805Fh		;F000 shadow RAM read only
		call	Get_Set_Ct

		dec	cx			;then cl=75h
		mov	bx,8855h		;F000 shadow RAM read only
		call	Get_Set_Ct
		dec	cx			;then cl=74h
		call	Get_Set_Ct

else	;COMPRESS_CODE
		shl	esp,16

	;program chipset with read from ROM , write to shadow RAM
		mov	cx,76h
		ROM_CALL Get_Ct
		and	al,5Fh			;F000 shadow RAM writeable
		or	al,20h
		ROM_CALL Set_Ct

		dec	cx			;then cl=75h
		ROM_CALL Get_Ct
		and	al,55h			;E000 shadow RAM writeable
		or	al,22h
		ROM_CALL Set_Ct
		dec	cx			;then cl=74h
		ROM_CALL Get_Ct
		and	al,55h
		or	al,22h
		ROM_CALL Set_Ct

		mov	si,0F000H
		mov	di,si
		mov	cx,08000H		;64K
		ROM_CALL Move_Codes

		mov	si,0E000h
		mov	di,si
		mov	cx,08000H		;64K
		ROM_CALL Move_Codes

	;program chipset with  write protect
		mov	cx,76h
		ROM_CALL Get_Ct
		and	al,5Fh			;F000 shadow RAM read only
		or	al,20h
		ROM_CALL Set_Ct

		dec	cx			;then cl=75h
		ROM_CALL Get_Ct
		and	al,55h			;E000 shadow RAM read only
		or	al,22h
		ROM_CALL Set_Ct
		dec	cx			;then cl=74h
		ROM_CALL Get_Ct
		and	al,55h
		or	al,22h
		ROM_CALL Set_Ct
		mov	cx,76H

		shr	esp,16
endif	;COMPRESS_CODE

		clc
		ret
Ct_Early_Shadow_System_Bios	ENDP
endif	;CompileForExtROM

;R02 - start
ifdef	Flash_2M_support
;[]==============================================================[]
;
; Enable_Extra_1MBIOS_Hook:
;
;       Enable extra 1M bits BIOS ROMCS decode for decompress driver ROM
;
; Entry: None
;  Exit: CX = Extra BIOS segment (0C000h or 0E000h)
;	 ZF = 1	(JZ) Must be enter protect mode for access extra BIOS data
;	      0	(JNZ) Access extra BIOS could in real mode
; Note : 1. Stack available
;	 2. Save all register except CX
;	 3. Must be return far
;[]==============================================================[]
Enable_Extra_1MBIOS_Hook:

ifdef	A17_From_KB_Pin
		pusha
		mov	al,0B2h+(A17_From_KB_Pin-29)
		call	Out_KB_Pin
		popa
		mov	cx,0E000h
		or	ch,ch
		retf

Out_KB_Pin	label	near
		call	_PLKIO
		call	_PLKIO
		retn
	_PLKIO:
		push	ax
		out	64h, al
		newiodelay
	_11:
		in 	al, 60h
		newiodelay
		loop	_11
		pop	ax
		retn
endif	;A17_From_KB_Pin

ifndef	A17_From_KB_Pin
		pusha
		mov	cx,840h
		call	Get_Ct
		or	al,01h
		call	Set_Ct
		popa
		mov	cx,0C000h
		cmp	ch,ch
		retf
endif	;A17_From_KB_Pin

;[]==============================================================[]
;
; Disable_Extra_1MBIOS_Hook:
;
;       Disable extra 1M bits BIOS ROMCS decode for recover original BIOS
;	decode
;
; Entry: None
;  Exit: None
; Note : 1. Stack available
;	 2. Save all register
;	 3. Must be return far
;[]==============================================================[]
Disable_Extra_1MBIOS_Hook:

ifdef	A17_From_KB_Pin
		pusha
		mov	al,0BAh+(A17_From_KB_Pin-29)
		call	Out_KB_Pin
		popa
		retf
endif	;A17_From_KB_Pin

ifndef	A17_From_KB_Pin
		pusha
		mov	cx,840h
		call	Get_Ct
		and	al,not 01h
		call	Set_Ct
		popa
		retf
endif	;A17_From_KB_Pin

endif	;Flash_2M_support
;R02 - end


;R13 -start
ifndef	No_Support_PCI_VGA_in_Bootblock		
ifdef	CompileForBootROM
ifdef	Bootblock_16K_Support

Ct_Enable_C_Shadow	proc	near
		; 70h Bit7 - C0000h ~ C3FFFh Read Enable
		; 70h Bit6 - C0000h ~ C3FFFh L1/L2 cacheable
		; 70h Bit5 - C0000h ~ C3FFFh Write Enable
		; 70h Bit4 - C0000h ~ C3FFFh Reserved

		; 70h Bit3 - C4000h ~ C7FFFh Read Enable
		; 70h Bit2 - C4000h ~ C7FFFh L1/L2 cacheable
		; 70h Bit1 - C4000h ~ C7FFFh Write Enable
		; 70h Bit0 - C4000h ~ C7FFFh Reserved

		; 71h Bit7 - C8000h ~ CBFFFh Read Enable
		; 71h Bit6 - C8000h ~ CBFFFh L1/L2 cacheable
		; 71h Bit5 - C8000h ~ CBFFFh Write Enable
		; 71h Bit4 - C8000h ~ CBFFFh Reserved

		; 71h Bit3 - CC000h ~ CFFFFh Read Enable
		; 71h Bit2 - CC000h ~ CFFFFh L1/L2 cacheable
		; 71h Bit1 - CC000h ~ CFFFFh Write Enable
		; 71h Bit0 - CC000h ~ CFFFFh Reserved

		pusha
		mov	cx, 70h			
		mov	bx,0AA55h		;enable shadow R/W
		call	Get_Set_Ct

		mov	cx, 71h			
		mov	bx,0AA55h		;enable shadow R/W 
		call	Get_Set_Ct
		popa

		ret
Ct_Enable_C_Shadow	endp

endif	;Bootblock_16K_Support
endif	;CompileForBootROM
endif	;No_Support_PCI_VGA_in_Bootblock	
;R13 -end
