;	[]==========================================================[]
;
;	    This source code is classified as confidential and
;	    contains trade secrets owned by Award Software, Inc.
;
;			Copyright 1984, 1990
;			Award Software, Inc.
;			All rights reserved.
;
;	[]==========================================================[]

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;--------------------------2A5II---------------------------------------------
;R15C	12/26/97 DRS	Move Ct_Enable_C_Shadow hook to chipboot.asm
;R15B	12/16/97 DRS	Chipset don't want support run PCI/AGP VGA in bootblock
;R15A	12/10/97 AVN	Fixed coding error.
;R15	12/09/97 DRS	Add Ct_Enable_C_Shadow hook for support 16K_8K_8K_Unit 
;			of 2M Flash run PCI/AGP Vga in bootblock  	
;R14	10/16/97 AVN	Added ONBOARD PCI VGA using AD19 (support in B4 version)
;R13	06/25/97 AVN	when use external RTC cannot access APC register.
;R12A	06/13/97 AVN	Fixed coding error.
;R12	06/10/97 AVN	Fixed Onboard SiS6205 VGA screen garbage when warm boot
;R10A	06/10/97 AVN	Move Code to chippost.asm (Ct_Early_Shadow) for save
;			code.
;R11	05/13/97 AVN	Fixed APCR mistake in GET_CT
;R10	05/09/97 AVN	Added Write device 1, function 1 Reg 2Ch, 2Dh, 2Eh, 2Fh
;			once, those Reg is write one time only, and using by
;			customer for product serial number.
;			if those Reg had never wrote and WIN95 SCT test fail.
;R09	04/29/97 LRY	Support ACPI-buttom suspend
;R08	04/25/97 LRY	Reflash depth default 62.4us
;R04A	04/02/97 LRY	Removed porting ACPI base to chipboot.asm
;R07	04/02/97 LRY	Added hooks for acpi
;R06	04/01/97 LRY	Support "SIRQ_SELECT"  (OPTIONAL)
;R05	03/28/97 KEN	Public "Get/Set/Get_Set_Pci" for USB_SUPPORT.
;R04	03/14/97 LRY	Enhanced Get_Ct & Set_Ct to access ACPI_R & APC_R
;			Assign ACPI/SCI base address at IO 6100h
;R03	03/05/97 LRY	Clear PCI level trigger to privent warm boot hang
;R02	01/31/97 LRY	Support 6205 VGA shared memory
;R01	01/21/97 LRY	MDLE delay default slowest
;R00	01/08/97 LRY	Initial version
.386p
		PAGE	56,132
		TITLE	CHIPSET  -- 386/486 EISA ROM/BIOS

		INCLUDE BIOS.CFG
		INCLUDE COMMON.MAC
		INCLUDE POST.EQU
		INCLUDE POST.MAC
		INCLUDE BTROMSEG.EQU			;R15

G_RAM		SEGMENT USE16 AT 0

		ORG	04H*4
		INCLUDE SEG_0.INC

		ORG	400H
		INCLUDE G_RAM.INC

G_RAM		ENDS

ifdef	COMPRESS_CODE
		include 8259.equ
		include 8254.equ
		include 8237.equ
		include mathcop.equ
		INCLUDE PORT61.EQU

DGROUP		GROUP	@DATAC
@DATAC		SEGMENT USE16 DWORD COMMON 'DATAC'
		ASSUME	CS:DGROUP,DS:DGROUP
		org	1600h
else	;COMPRESS_CODE
DGROUP		GROUP	FCODE
FCODE		SEGMENT USE16 PARA PUBLIC 'CODE'
		ASSUME	CS:DGROUP,DS:DGROUP
endif	;COMPRESS_CODE

;[]===========================================================[]
;
; Procedure Name: Ct_Very_Early_Init
;	This routine is used to program the system to a known state.
;
;
; Saves: SP,BP , no stack available
;
; Input: None
;Output: None
;
; [Note]:  User must do following jobs
;	1. Save warm boot flag
;	2. Disable cache & shadows
;	3. Initial some special registers if needed
;[]===========================================================[]

		align	4
		public	Ct_Very_Early_Init
Ct_very_Early_Init	proc	near

		shl	esp,16		;save SP


	;save warm boot flag

		mov	ax,g_ram
		mov	ds,ax
		assume	ds:G_RAM
		mov	di,ds:USER_REBOOT


;R03 - start
	;clear PCI level trigger
		xor	al,al
		mov	dx,4D0h
		out	dx,al
		inc	dx
		out	dx,al
;R03 - end

;R09 - start
	;disable ACPI-buttom
		
		mov	cx,ACPI_R+03h
		mov	al,0
		Rom_Call Set_Ct
;R09 - end


	;init registers


		mov	si,offset DGROUP:PciMem_Init_Tbl
		xor	ch,ch
	@@:
		cmp	si,offset DGROUP:PciIsa_Init_Tbl
		jb	short Prg_Init_Tbl
		mov	ch,08h
Prg_Init_Tbl:
		mov	cl,cs:[si]
		Rom_Call Get_Ct
		and	al,cs:[si+1]
		or	al,cs:[si+2]
		Rom_Call Set_Ct
		add	si,3
		cmp	si,offset DGROUP:Early_Init_Tbl_End
		jne	short @B

;R10A ;R10 - start
;R10A 		mov	bl,4
;R10A 		mov	cx,92Ch
;R10A 		xor	al,al
;R10A @@:
;R10A 		Rom_Call Set_Ct
;R10A 		inc	cl
;R10A 		dec	bl
;R10A 		or	bl,bl
;R10A 		jnz	@b
;R10A ;R10 - end

;R12 - start
ifdef	Share_SIS6205
		mov	cx,(ONBOARD_PCI_VGA SHL 11)+04H
		ROM_CALL Get_Pci
		cmp	al,-1			;6205 exist?
		je	short Skip_dis_6205
		test	al,11b			;onboard enable?
		jz	short Skip_dis_6205
;Disable CRT
;R12A		mov	dx,3d4H
		mov	dx,3c4H			;R12A
		xor	al,al
		out	dx,al
		inc	dx
		out	dx,al
;Disable I/O & memory for SiS 6205
		ROM_CALL Set_Pci
Skip_dis_6205:
endif	;Share_SIS6205
;R12 - end
	;restore warm boot flag

		mov	ds:USER_REBOOT,di
		shr	esp,16

		clc
		ret

		ALIGN	4
		;---------------------
		;      index  AND  OR
		;---------------------
PciMem_Init_Tbl:
ifdef	ONBOARD_PCI_VGA				;R14
if	ONBOARD_PCI_VGA	EQ	19-11		;R14
		db	06Eh,0FFh,020h		;R14
endif;	ONBOARD_PCI_VGA				;R14
endif;	ONBOARD_PCI_VGA				;R14
		db	051h,0BBh,000h
		db	076h,000h,000h
		db	09Ah,000h,000h		;disable timeout SMI
		db	09Bh,000h,030h		;disable B-SW, SW-SMI
		db	093h,000h,084h
		db	004h,0F8h,007h		;bit1 must be 1, otherwise floppy can't read
		db	050h,000h,000h
		db	052h,00Fh,080h
		db	053h,0F9h,002h	;R08	;fix floppy unstable
		db	054h,000h,055h
		db	056h,0F8h,007h	;R01
		db	059h,000h,038h
		db	070h,011h,011h		;Disable all shadows
		db	071h,000h,000h		;Disable all shadows
		db	072h,000h,001h		;Disable all shadows
		db	073h,000h,000h		;Disable all shadows
		db	074h,000h,000h		;Disable all shadows
		db	075h,000h,000h		;Disable all shadows
		db	083h,000h,0C0h
;R12 ifdef	SHARE_SiS6205			;R02
;R12 		db	06Ch,000h,080h	;R02
;R12 else	;SHARE_SiS6205			;R02
		db	06Ch,000h,000h	;R02
;R12 endif	;SHARE_SiS6205			;R02
PciIsa_Init_Tbl:
;A0chip		db	046h,0FFh,001h		;test mode to show 80 port
		db	004h,0F8h,007h
;R04A		db	010h,000h,ACPI_BASE_IO_ADDR mod 100h	;R04
;R04A		db	011h,000h,ACPI_BASE_IO_ADDR / 100h	;R04
		db	045h,03Fh,024h
		db	040h,000h,00Ah
		db	048h,000h,0FFh
ifdef	SIRQ_SELECT				;R06
		db	06Dh,0FFh,040h		;R06
		db	088h,000h,080h		;R06
		db	089h,000h,0FFh		;R06
		db	08Ah,000h,0FFh		;R06
endif	;SIRQ_SELECT				;R06
Early_Init_Tbl_End:

Ct_very_Early_Init	endp

;[]========================================================================[]
;Procedure:	Ct_Sleep_Detect
;
;Function :	Tell BIOS kernal whether it is a resume process or not
;
;Input	  :	None
;
;Output   :	NZ - resume from sleep/suspend
;		ZR - normal reset
;
;Note	  :	1. called every time the CPU is reset/shutdown
;		2. Stack "NOT" available
;[]========================================================================[]
		Public	Ct_Sleep_Detect
Ct_Sleep_Detect Proc	Near
		xor	al,al
		ret
Ct_Sleep_Detect Endp

;[]===========================================================[]
;
; Procedure Name: Pci_Early_Init
;	This routine is used to program the system to a known state.
;
; Saves: SP,BP , no stack available
;
; Input: None
;Output: None
;[]===========================================================[]

		align	4
		public	Pci_Early_Init
Pci_Early_Init	proc	near
		ret
Pci_Early_Init	endp


;[]===================================================================[]
;
; GET_CT:
;
;	Reads a value directly from the chipset registers.
;
; Entry: CL/CX	Register to read (AL if RIS = 0, AX if RIS = 1)
; Exit:  AL/AX	Value read (BL if RVS = 0, BX if RVS = 1)
;
; Destory (PCI): EAX high word, AL, EDX high word
;
;[]===================================================================[]

		align	4
		PUBLIC	GET_CT
GET_CT		PROC	NEAR
CONFIG_ADDR	EQU	0CF8h
		public	Get_Pci		;R05
Get_Pci:				;R05
		shl	edx,16		;save dx
		shl	eax,16

		cmp	ch,ACPI_R/100h				;R04
		je	short ACPI_Reg_Rd			;R04

		mov	ax,8000h
		rol	eax,16

		cmp	ch,APC_R/100h				;R04
		je	short APC_Reg_Rd			;R04

		xchg	cx,ax		;then ch=ah, ah=ch, al=cl
		mov	cl,al		;then cl=cl
		and	al,NOT 03h	;32 bit access for PCI
		mov	dx,CONFIG_ADDR	;index is 0cf8h
		out	dx,eax
		add	dl,4		;start from 0cfch
		xchg	cx,ax		;then ch=ch, ah=ah, al=cl
		mov	cl,al		;then cl=cl
		and	al,03h
		add	dl,al		;byte index to read
		in	al,dx
rst_dx_ret:							;R04
		shr	edx,16		;restore dx
		ret
;R04 - start
ACPI_Reg_Rd:
		mov	dx,ACPI_BASE_IO_ADDR
		add	dl,cl
		adc	dh,0
		and	dl,NOT 01h
		in	ax,dx
		mov	dx,ax
		shr	eax,16		;restore ah
		mov	al,dl
		test	cl,01h
		jz	short rst_dx_ret
		mov	al,dh
		jmp	short rst_dx_ret
APC_Reg_Rd:
ifndef	Use_External_RTC				;R13
		mov	ax,0844h
		mov	dx,CONFIG_ADDR	;index is 0cf8h
		out	dx,eax
		add	dl,4
		in	al,dx
		or	al,10h
		iodelay
		out	dx,al
		mov	al,cl
		out	70h,al
		newiodelay
		in	al,71h
		shl	eax,16
		in	al,dx
		and	al,not 10h
		iodelay
		out	dx,al
		shr	eax,16				;R11
endif;	Use_External_RTC				;R13
		jmp	short rst_dx_ret
;R04 - end
GET_CT		ENDP

;[]===================================================================[]
;
; SET_CT:
;
;	Changes a value in the chipset registers.
;
; Entry: CL/CX	Register to read (AL if RIS = 0, AX if RIS = 1)
;	 AL/AX	Value to write (BL if RVS = 0, BX if RVS = 1)
;
; Exit:  NONE
;
; Destory (PCI): EAX high word, ECX high word, EDX high word
;
;[]===================================================================[]

		align	4
		PUBLIC	SET_CT
SET_CT		PROC	NEAR
		public	Set_Pci		;R05
Set_Pci:				;R05

		cmp	ch,0FFh
		jb	short @F
		ret
	@@:

		shl	edx,16		;save dx
		xchg	ax,cx
		shl	ecx,16		;save value
		xchg	ax,cx		;restore cx

		cmp	ch,ACPI_R/100h				;R04
		je	short ACPI_Reg_Wr			;R04
		cmp	ch,APC_R/100h				;R04
		je	short APC_Reg_Wr			;R04

		mov	eax,80000000h	;device 16 is for 881
		mov	ax,cx
		and	al,NOT 03h	;32 bit access for PCI
		mov	dx,CONFIG_ADDR	;index is 0cf8h
		out	dx,eax
		add	dl,4		;start from 0cfch
		mov	al,cl
		and	al,03h
		add	dl,al		;byte index to read
		mov	eax,ecx
		shr	eax,16
		out	dx,al
rst_dx_ret1:							;R04
		shr	edx,16		;restore dx
		ret
;R04 - start
ACPI_Reg_Wr:
		mov	dx,ACPI_BASE_IO_ADDR
		add	dl,cl
		adc	dh,0
		and	dl,NOT 01h
		in	ax,dx
		test	cl,01h
 		ror	ecx,16		;ror instruction will not change Z flag
		jz	short even_ACPI_reg
		mov	ah,cl
		jmp	short out_ACPI_reg
even_ACPI_reg:
		mov	al,cl
out_ACPI_reg:
		out	dx,ax
		mov	ax,cx
		shr	ecx,16
		jmp	short rst_dx_ret1
APC_Reg_Wr:
ifndef	Use_External_RTC				;R13
		mov	eax,80000844h
		mov	dx,CONFIG_ADDR	;index is 0cf8h
		out	dx,eax
		add	dl,4
		in	al,dx
		or	al,10h
		iodelay
		out	dx,al
		mov	al,cl
		out	70h,al
		mov	eax,ecx
		shr	eax,16
		out	71h,al
		shl	eax,16
		in	al,dx
		and	al,not 10h
		iodelay
		out	dx,al
endif;	Use_External_RTC				;R13
		jmp	short rst_dx_ret1
;R04 - end
SET_CT		ENDP

;[]==============================================================[]
;Read one chipset register value and set it back
;Input : CL - register index
;	 BL - value to AND
;	 BH - value to OR
;Output: none
;[]==============================================================[]
		align	4
		public	Get_Set_Ct
Get_Set_Ct	proc	near
		public	Get_Set_Pci	;R05
Get_Set_Pci:				;R05
		call	Get_Ct
		and	al,bl
		or	al,bh
		call	Set_Ct
		ret
Get_Set_Ct	endp

ifndef	CompileForBootROM

		public	A20_Byte
A20_Byte	label	byte
		db	00010000b	;bit0 = 0 - normal gate A20
					;bit0 = 1 - fast 92 port support
					;bit 7 =0 - normal turning cache
					;	1 - early turning cache
					;bit 6 =0 - normal CPU clock detect
					;	1 - special CPU clock detect
					;bit 5 =0 - normal refresh wait
					;	1 - using CPU loop wait if
					;	    BIOS shadow is disabled
					;bit 4 =1 - Don't set CPU cache on/off
					;	    If system is in protected
					;	    mode

CMOS		EQU	70H

;[]==============================================================[]
;CT_SPEED:
;	Programming speed switchwing for particular hardware design.
;Saves: ALL but flags
;Input:
;    b0 of al = 0 : to low speed
;	      = 1 : to high speed
;Output:none
;
;[Notes] 1. Program chipset registers for speed change
;	 2. This function can be disabled by MODBIN
;[]==============================================================[]
		align 4
		public	Ct_Speed
Ct_Speed	proc	near
		clc
		ret
Ct_Speed	endp

;[]==============================================================[]
;CT_A20:
;	Chipset Fast Gate A20 support
;Saves: all but flags
;Input: AL - 0ddh : turn A20 off
;	   - 0dfh : turn A20 on
;Output:carry clear - fast gate A20 ok
;	carry set   - fast gate A20 not support
;[Notes] 1. This function is used to turn on/off chipset's fast
;	    gate A20 support.
;	 2. If chipset did not support fast A20 , this routine
;	    should return carry flag, otherwise clear carry.
;[]==============================================================[]
		align	4
		public	Ct_A20
Ct_A20		proc	near
		stc
		ret
Ct_A20		endp

;[]==============================================================[]
;Int8_Hook:
;	Special process for every time tick.
;Save  : all but flags
;Input : none
;Output: none
;Note  : 1. This routine will be called after execute INT 1CH
;	 2. You can use this routine to do some power management
;	    or other special function
;[]==============================================================[]
		Public	Int8_Hook
Int8_Hook	Proc	Near
ifdef	INT8_SOUND_VOLUME
		extrn	Prg_Sound_Chip:near
		Call	Prg_Sound_Chip
endif	;INT8_SOUND_VOLUME
		ret
Int8_Hook	Endp

;[]==============================================================[]
;Int15_4f_Hook:
;	Special process for every key stroke.
;Save  : all but flags
;Input : none
;Output: none
;Note  : 1. This routine will be called after execute INT 15H
;	    function 4fH
;	 2. You can use this routine to check hotkey or other
;	    power management.
;	 3. You must reutrn carry if this routine do nothing or
;	    this key-stroke is unuseful.
;[]==============================================================[]
		Public	Int15_4f_Hook
Int15_4f_Hook	Proc	Near
		stc
		ret
Int15_4f_Hook	Endp

;R07 - start
		public	GetWakingVector
GetWakingVector:
		public	RestoreContext
RestoreContext:
		ret
;R07 - end
endif	;CompileForBootROM

ifdef	SPECIAL_FOR_POWERON
		public	Ct_For_PowerOn
Ct_For_PowerOn	proc	near
		ret
Ct_For_PowerOn	endp
endif;	SPECIAL_FOR_POWERON


;R15C ;R15 -start
;R15C ifndef	NO_Support_PCI_VGA_in_Bootblock	;R15B
;R15C ifdef	Bootblock_16K_Support
;R15C 		public	Ct_Enable_C_Shadow
;R15C Ct_Enable_C_Shadow	proc	near
;R15C 
;R15C 		; 70h Bit7 - C0000h ~ C3FFFh Read Enable
;R15C 		; 70h Bit6 - C0000h ~ C3FFFh L1/L2 cacheable
;R15C 		; 70h Bit5 - C0000h ~ C3FFFh Write Enable
;R15C 		; 70h Bit4 - C0000h ~ C3FFFh Reserved
;R15C 
;R15C 		; 70h Bit3 - C4000h ~ C7FFFh Read Enable
;R15C 		; 70h Bit2 - C4000h ~ C7FFFh L1/L2 cacheable
;R15C 		; 70h Bit1 - C4000h ~ C7FFFh Write Enable
;R15C 		; 70h Bit0 - C4000h ~ C7FFFh Reserved
;R15C 
;R15C 		; 71h Bit7 - C8000h ~ CBFFFh Read Enable
;R15C 		; 71h Bit6 - C8000h ~ CBFFFh L1/L2 cacheable
;R15C 		; 71h Bit5 - C8000h ~ CBFFFh Write Enable
;R15C 		; 71h Bit4 - C8000h ~ CBFFFh Reserved
;R15C 
;R15C 		; 71h Bit3 - CC000h ~ CFFFFh Read Enable
;R15C 		; 71h Bit2 - CC000h ~ CFFFFh L1/L2 cacheable
;R15C 		; 71h Bit1 - CC000h ~ CFFFFh Write Enable
;R15C 		; 71h Bit0 - CC000h ~ CFFFFh Reserved
;R15C 
;R15C 		pusha
;R15C ;R15A		mov	cx, (SIS5591_ID) + 70h
;R15C 		mov	cx, 70h			;R15A
;R15C 		mov	bx,0AA55h		;enable shadow R/W
;R15C 		call	Get_Set_Ct
;R15C 
;R15C ;R15A		mov	cx, (SIS5591_ID) + 71h
;R15C 		mov	cx, 71h			;R15A
;R15C 		mov	bx,0AA55h		;enable shadow R/W 
;R15C 		call	Get_Set_Ct
;R15C 		popa
;R15C 
;R15C 		ret
;R15C Ct_Enable_C_Shadow	endp
;R15C endif	;Bootblock_16K_Support
;R15C endif	;NO_Support_PCI_VGA_in_Bootblock	;R15B
;R15C ;R15 -end


ifdef	COMPRESS_CODE
;[]===================================================================[]
;Move codes from source to destionation area
;Input : SI - source , DI - destination , CX - No. of words to move
;Output: none
;[]===================================================================[]
		public	Move_Codes
Move_Codes	proc	near
		mov	ds,si
		mov	es,di
		xor	si,si
		xor	di,di
		cld
		rep	movsw
		ret
Move_Codes	endp

IF2
	IF (($ - Ct_Very_Early_Init) GT (0f80bh-0f600h))
		%OUT ERROR, CHIPRUN.ASM code size too large
		.ERR
	ENDIF
ENDIF

@DATAC		ENDS
else	;COMPRESS_CODE
FCODE		ENDS
endif	;COMPRESS_CODE
		END
