;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R05A	12/03/97 RCH	Fixed compilation error if programmer modify BIOS.CFG
;			in local drive.
;R05	11/14/97 DNL	Rename all clock generator file as clock.gen
;R01A	10/16/97 RIC	Fixed that R01 code work in vain.
;R04	10/14/97 RCH	Added alias name for ICWORK series clock generator
;			for new kernel.
;R03	10/09/97 JSN	Fix compilation error
;R02	10/03/97 RAY	Fix compilation error:
;
;			DO NOT write your code like this:
;
;			    "mov si, offset EGROUP:Boost_Val"
;			    "F000_call DGROUP:E000_64K_shadow_RW"
;
;			USE "mov si, offset Boost_Val"
;			    "F000_call E000_64K_shadow_RW" instead
;
;R01	10/03/97 RIC	Support Clock Generator of VIA Software I2C.
;R00	10/01/97 TNY	Init. Ver.

ifdef	MASM611
.MODEL  SMALL,BASIC
OPTION	PROC: PRIVATE
endif	;MASM611

.386p
		PAGE	56,132
		TITLE	CLKCNTL.ASM
.XLIST
		INCLUDE	BIOS.CFG
		INCLUDE	COMMON.MAC
		INCLUDE POST.EQU

		extrn	F000_call_proc:near
		extrn	F000_GetItem_Value:near
		extrn	GetItem_Value:near

		extrn	E000_64K_shadow_RW:near		;R02
		extrn	E000_64K_shadow_R:near		;R02

	CLKCNTL_KERNEL	=	0

;For ICWORK clock generators
ifdef	ICWORK8704_Support
	CLKCNTL_KERNEL	=	1
endif	;ICWORK8704_Support

ifdef	ICWORK8803_Support
	CLKCNTL_KERNEL	=	1
endif	;ICWORK8803_Support

ifdef	ICWORK6704_Support
	CLKCNTL_KERNEL	=	1
endif	;ICWORK6704_Support

;R04 - start
ifdef	ICW8704_Support
	CLKCNTL_KERNEL	=	1
endif	;ICW8704_Support

ifdef	ICW8803_Support
	CLKCNTL_KERNEL	=	1
endif	;ICW8803_Support

ifdef	ICW6704_Support
	CLKCNTL_KERNEL	=	1
endif	;ICW6704_Support
;R04 - end

ifdef	PL526425_Support
	CLKCNTL_KERNEL	=	1
endif;	PL526425_Support

ifdef	ICW6801_Support
	CLKCNTL_KERNEL	=	1
endif	;ICW6801_Support

ifdef	ICW10104_Support
	CLKCNTL_KERNEL	=	1
endif	;ICW10104_Support

ifdef	ICW11114_Support
	CLKCNTL_KERNEL	=	1
endif	;ICW11114_Support

;For IMI clock generators
ifdef	IMI643_Support
	CLKCNTL_KERNEL	=	1
endif	;IMI643_Support

ifdef	IMI543_Support
	CLKCNTL_KERNEL	=	1
endif	;IMI543_Support

ifdef	IMI671_Support
	CLKCNTL_KERNEL	=	1
endif	;IMI671_Support

ifdef	IMI584_Support
	CLKCNTL_KERNEL	=	1
endif	;IMI584_Support

;For ICS clock generators
ifdef	ICS9148_Support
	CLKCNTL_KERNEL	=	1
endif	;ICS9148_Support

ifdef	ICS9150_Support
	CLKCNTL_KERNEL	=	1
endif	;ICS9150_Support

ifdef	ICS9179_Support
	CLKCNTL_KERNEL	=	1
endif	;ICS9179_Support

ifdef	PL526502_Support
	CLKCNTL_KERNEL	=	1
endif;	PL526502_Support

ifdef	PL526601_Support
	CLKCNTL_KERNEL	=	1
endif;	PL526601_Support

G_RAM		SEGMENT	USE16 AT 0

		ORG	04H*4
		INCLUDE	SEG_0.INC

		ORG	400H
		INCLUDE	G_RAM.INC

G_RAM		ENDS

.LIST

DGROUP		GROUP	FCODE
FCODE           SEGMENT PARA PUBLIC 'CODE'
                ASSUME  CS:DGROUP
FCODE           ENDS

EGROUP		GROUP	ECODE
ECODE		SEGMENT	USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP,DS:G_RAM,ES:EGROUP

;[]======================================================================[]
;[]======================================================================[]
		Public	Init_Onboard_Generator
Init_Onboard_Generator	Proc	Near

IF	CLKCNTL_KERNEL

		pushad
		push	ds
		push	es
		pushf

;R02		push	0e000h
		push	cs					;R02
		pop	ds
;R02		extrn	E000_64K_shadow_RW:near
;R02		extrn	E000_64K_shadow_R:near
;R02		f000_call	DGROUP:E000_64K_shadow_RW
		f000_call	E000_64K_shadow_RW		;R02
		call	Prepare_ClkGen_Val
;R02		f000_call	DGROUP:E000_64K_shadow_R
		f000_call	E000_64K_shadow_R		;R02

		call	Prg_ClkGen_Chip

		popf
		pop	es
		pop	ds
		popad

ENDIF	;CLKCNTL_KERNEL
		ret
Init_Onboard_Generator	Endp


;R05	ifdef	ICWORK8704_Support
;R05		include	ICW8704.GEN
;R05	endif	;ICWORK8704_Support
;R05
;R05	ifdef	ICWORK8803_Support
;R05		include	ICW8803.GEN
;R05	endif	;ICWORK8803_Support
;R05
;R05	ifdef	ICWORK6704_Support
;R05		include	ICW6704.GEN
;R05	endif;	ICWORK6704_Support
;R05
;R05;R04 - start
;R05ifdef	ICW8704_Support
;R05		include	ICW8704.GEN
;R05endif	;ICW8704_Support
;R05
;R05ifdef	ICW8803_Support
;R05		include	ICW8803.GEN
;R05endif	;ICW8803_Support
;R05
;R05ifdef	ICW6704_Support
;R05		include	ICW6704.GEN
;R05endif	;ICW6704_Support
;R05;R04 - end
;R05
;R05
;R05	ifdef	IMI643_Support
;R05		include	IMI643.GEN
;R05	endif	;IMI643_Support
;R05
;R05	ifdef	IMI543_Support
;R05		include	IMI543.GEN
;R05	endif	;IMI543_Support
;R05
;R05	ifdef	IMI671_Support
;R05		include	IMI671.GEN
;R05	endif	;IMI671_Support
;R05
;R05	ifdef	IMI584_Support
;R05		include	IMI584.GEN
;R05	endif	;IMI584_Support
;R05
;R05	ifdef	ICS9148_Support
;R05		include	ICS9148.GEN
;R05	endif;	ICS9148_Support
;R05
;R05	ifdef	ICS9150_Support
;R05		include	ICS9150.GEN
;R05	endif;	ICS9150_Support
;R05
;R05	ifdef	PL526502_Support
;R05		include	PL526502.GEN
;R05	endif;	PL526502_Support
;R05 - start
IF	CLKCNTL_KERNEL				;R05A
		include	CLOCK.GEN
endif;	CLKCNTL_KERNEL				;R05A
;R05 - end

IF	CLKCNTL_KERNEL
SIS_SMBus	=	0
ifdef	SIS_5598_PCI_RESET				
SIS_SMBus	=	1
endif;	SIS_5598_PCI_RESET				
ifdef	SIS5595_ID
SIS_SMBus	=	1
endif;	SIS5595_ID

Prg_ClkGen_Chip	Proc	Near

ifdef	PIIX_ID
		call	Disable_ClkGen_For_PIIX4
endif;	PIIX_ID

ifdef	M1543
		call	Disable_ClkGen_For_M1543
endif;	M1543

ifdef	VT586_ACPI					;R01
		call	Disable_ClkGen_For_VT586B	;R01 VIA Chipset
endif;	VT586_ACPI					;R01

if	SIS_SMBus
		call	Disable_ClkGen_For_SISSMBus
endif;	SIS_SMBus

		ret
Prg_ClkGen_Chip	Endp

ifdef	PIIX_ID
Disable_ClkGen_For_PIIX4	Proc	near
		mov	dx,SMBus_Port + 04h
		mov	al,0d2h		;ID (write)
		out	dx,al
		NEWIODELAY
		NEWIODELAY

		mov	dx,SMBus_Port + 00h
Chk_Status0:
		in	al,dx		;get status
		NEWIODELAY
		out	dx,al
		NEWIODELAY
		or	al,al
		jnz	short Chk_Status0

		mov	dx,SMBus_Port + 02h
		in	al,dx		;reset pointer
		NEWIODELAY
		NEWIODELAY

;Programe block num.
;R02		mov	si,offset EGROUP:Prg_ClkGen_Num
		mov	si,offset Prg_ClkGen_Num	;R02
		mov	dh,SMBus_Port_HiByte
		mov	dl,05h
		mov	al,cs:[si]
		out	dx,al
		newiodelay
		newiodelay

;Programe block data
;R02		mov	si,offset EGROUP:Prg_ClkGen_Tbl
		mov	si,offset Prg_ClkGen_Tbl		;R02
		mov	dh,SMBus_Port_HiByte	
	@@:
		mov	dl,07h
		mov	al,cs:[si]
		out	dx,al
		NEWIODELAY
		NEWIODELAY
		add	si,1
;R02		cmp	si,offset EGROUP:Prg_ClkGen_Tbl_End
		cmp	si,offset Prg_ClkGen_Tbl_End		;R02
		jne	short @B

;Start send.
		mov	dh,SMBus_Port_HiByte
		mov	dl,02h
		mov	al,54h
		out	dx,al
		newiodelay
		newiodelay


		xor	cx,cx		;loop count
		mov	dx,SMBus_Port + 00h
Chk_Status_Final0:
		in	al,dx		;get status
		NEWIODELAY
		test	al,02h		;Send Ok ?
		jnz	short SendSmbusOk0
	;check other status 
		loop	short Chk_Status_Final0
SendSmbusOk0:
		ret
Disable_ClkGen_For_PIIX4	Endp
endif;	PIIX_ID

ifdef	M1543
Disable_ClkGen_For_M1543	Proc	near

 ;(3-b.) write '1' clear to let read index 00h to be "04h" ( Idle ).
		mov	dx,SMBUS_IO_SPACE + 00h
 Chk_Status:
		mov	al,0ffh
		out	dx,al
    		NEWIODELAY
		NEWIODELAY
		in	al,dx		;get status
		NEWIODELAY
		NEWIODELAY
		cmp	al,04h
		jne	short Chk_Status


		mov	dx,SMBUS_IO_SPACE + 03h
		mov	al,0d2h		;ID (write)
		out	dx,al
		NEWIODELAY
		NEWIODELAY

		mov	dx,SMBUS_IO_SPACE + 01h
		mov	al,0c0h		;reset pointer & set R/W block mode
		out	dx,al
		NEWIODELAY
		NEWIODELAY

;Programe block num.
;R02		mov	si,offset EGROUP:Prg_ClkGen_Num
		mov	si,offset Prg_ClkGen_Num		;R02
		mov	dx,SMBUS_IO_SPACE + 00h
		mov	dl,04h
		mov	al,cs:[si]
		out	dx,al
		newiodelay
		newiodelay

;Programe block data
;R02		mov	si,offset EGROUP:Prg_ClkGen_Tbl
		mov	si,offset Prg_ClkGen_Tbl		;R02
;R03		mov	dh,SMBus_Port_HiByte	
	@@:
;R03		mov	dl,06h
		mov	dx,SMBUS_IO_SPACE + 06h
		mov	al,cs:[si]
		out	dx,al
		NEWIODELAY
		NEWIODELAY
		add	si,1
;R02		cmp	si,offset EGROUP:Prg_ClkGen_Tbl_End
		cmp	si,offset Prg_ClkGen_Tbl_End		;R02
		jne	short @B

		mov	dx,SMBUS_IO_SPACE + 07h
		mov	al,077h		;set command
		out	dx,al
		NEWIODELAY
		NEWIODELAY

		mov	dx,SMBUS_IO_SPACE + 02h
		mov	al,0		;start send
		out	dx,al
		NEWIODELAY
		NEWIODELAY

 		ret
Disable_ClkGen_For_M1543	Endp
endif;	M1543

;R01 - starts
ifdef	VT586_ACPI					
Disable_ClkGen_For_VT586B	Proc	near
		extrn	Dir_Out:Near
		extrn	Set_Start:Near
		extrn	Wr_Byte:Near
		extrn	Wait_ACK:Near
		extrn	Set_Stop:Near

                push    cx			;R01A
                push    bx			;R01A
                call    Dir_Out
                call    Set_Start
;R01A		push    cx
;R01A		push    bx
;R01A - starts
		mov	bl,0D2h			; Slave Address
		call	Wr_Byte			;
		call	Wait_ACK		;

;The following bytes must be sent alough they are "Don't Care" in data sheet.
		mov	bl,0			; Command Code
		call	Wr_Byte			;
		call	Wait_ACK		;

		mov	bl,0			; Byte Count
		call	Wr_Byte			;
		call	Wait_ACK		;
;R01A - ends		
;R02		mov	si,offset EGROUP:Prg_ClkGen_Num
		mov	si,offset Prg_ClkGen_Num		;R02
                mov     cl,byte ptr cs:[si]
@@:
                push    cx
                inc     si
                mov     bl,byte ptr cs:[si]
                call    Wr_Byte
                call    Wait_ACK
                pop     cx
                jc      SetValuesFail
                loop    short @B
                call    Set_Stop
                pop     bx
                pop     cx
                clc
                ret
SetValuesFail:
                pop     bx
                pop     cx
                stc
                ret
Disable_ClkGen_For_VT586B	Endp
endif;	VT586_ACPI
;R01 - ends

if	SIS_SMBus
Disable_ClkGen_For_SISSMBus	Proc	near
		extrn	Set_Start:Near
		extrn	Wr_Byte:Near
		extrn	Wait_ACK:Near
		extrn	Set_Stop:Near

                push    cx			
                push    bx			
                call    Set_Start

		mov	bl,0D2h			; Slave Address
		call	Wr_Byte			;
		call	Wait_ACK		;

;The following bytes must be sent alough they are "Don't Care" in data sheet.
		mov	bl,0			; Command Code
		call	Wr_Byte			;
		call	Wait_ACK		;

		mov	bl,0			; Byte Count
		call	Wr_Byte			;
		call	Wait_ACK		;
		mov	si,offset Prg_ClkGen_Num		
                mov     cl,byte ptr cs:[si]
	@@:
                push    cx
                inc     si
                mov     bl,byte ptr cs:[si]
                call    Wr_Byte
                call    Wait_ACK
                pop     cx
                jc      SetValuesFail
                loop    short @B
                call    Set_Stop
                pop     bx
                pop     cx
                clc
                ret
SetValuesFail:
                pop     bx
                pop     cx
                stc
                ret
Disable_ClkGen_For_SISSMBus	Endp
endif;	SIS_SMBus

ENDIF;	CLKCNTL_KERNEL

ECODE		ENDS
		END
