;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;---------------------------------------------------------------------------
;R04A	12/26/97 RCH	Updated Deschutes CPU (0650H) patch ID from 05H to 15H
;R04	10/15/97 RCH	Added Deschutes CPU (0650H) A0-stepping patch code
;R03	09/04/97 RCH	Added Pentium II (0634H) patch code
;R02	02/12/97 RCH	Added C0 stepping(0633H) CPU micro code for Klamath 
;R01	01/20/97 KVN	Fixed system hang at POST 31h if CPUID is 611h and
;			remove P6 micro code to P6_KLAM.inc to cancle duplicate
;			source code
;R00	01/15/97 KVN	Initial Revision
;------	CPU patch codes included : ------------------------------------
; 1. For Pentium II BIOS(switch - KLAMATH_CPU_ONLY) :
;    a. In non-compressed flashable block : 0630H
;    b. In compressed non-flashable area  : 0632H, 0633H, 0634H, 0650H
;
; 2. For Pentium Pro BIOS(switch - P6_BIOS_ONLY) :
;    a. In non-compressed flashable block : 0617H
;    b. In compressed non-flashable area  : 0611H, 0612H, 0616H, 0619H
;
; 3. For both Penitum II & Pro BIOS(switch - BOTH_P6_KLAMATH_CPU) :
;    a. In non-compressed flashable block : 0630H
;    b. In compressed non-flashable area  : 0632H, 0633H, 0634H, 0650H
;					    0611H, 0612H, 0616H, 0617H
;					    0619H
;-----------------------------------------------------------------------

		.model	small
		.data
		include	BIOS.CFG
ifndef	NO_MORE_P6_MIRCO_CODES
MORE_P6_MIRCO_CODES	EQU	1
endif	;NO_MORE_P6_MIRCO_CODES

ifdef	P6_BIOS_ONLY
ifdef	MORE_P6_MIRCO_CODES
 ifdef	KLAMATH_CPU_ONLY 
;------------------------------------------------
;BIOS update data for klamath CPU micro update
;------------------------------------------------

	dd 000000001h ; Header Version
	dd 000000020h ; BIOS Update ID
	dd 009031996h ; DATE
	dd 000000632h ; CPUID for B0 stepping
	dd 0ebc16165h ; Checksum
	dd 000000001h ; Loader Version
	dd 000000000h ; reserved
	dd 000000000h ; reserved
	dd 000000000h ; reserved
	dd 000000000h ; reserved
	dd 000000000h ; reserved
	dd 000000000h ; reserved
	dd 012c8ed0ah
	dd 0b3af63b5h
	dd 036697458h
	dd 0969f2feah
	dd 0dcff49fbh
	dd 061886424h
	dd 016a275a6h
	dd 06aae8000h
	dd 03db398d9h
	dd 011ad7c9ch
	dd 027b14806h
	dd 037d91c0bh
	dd 0390285d5h
	dd 0353f6eb5h
	dd 0e2d8e959h
	dd 0d2738986h
	dd 0a8c9db6dh
	dd 042e6d364h
	dd 07c8972c7h
	dd 089676f3dh
	dd 0f4052ecfh
	dd 001712123h
	dd 0c70f4a00h
	dd 0f1c41d69h
	dd 01028ad1fh
	dd 0686aa5edh
	dd 0a94832b1h
	dd 06d81dd56h
	dd 0a09c6ca0h
	dd 06c1e0737h
	dd 0aabc819eh
	dd 089a6aaceh
	dd 09bea3d32h
	dd 0d22538f4h
	dd 03a87ed02h
	dd 08cb0f343h
	dd 0304f25d8h
	dd 011685b01h
	dd 01ea8e84dh
	dd 014055a84h
	dd 0e47ace77h
	dd 0e6a2751bh
	dd 03db7afc8h
	dd 044fe0cb5h
	dd 0e725c2f4h
	dd 0fc0c05eeh
	dd 07f5a0b48h
	dd 0478eed35h
	dd 07d722eebh
	dd 0a38f3b74h
	dd 0426dbe88h
	dd 02ddc23e7h
	dd 08a583b9fh
	dd 0742927f4h
	dd 0a9e9dcf3h
	dd 0aa2fa343h
	dd 0c10e487fh
	dd 029ef64fah
	dd 0d71e7cf3h
	dd 04a808e4fh
	dd 0aed107d6h
	dd 0f3908612h
	dd 0a36ca501h
	dd 08dbdad75h
	dd 01ab3e766h
	dd 0cf9201bbh
	dd 0c2fad8a7h
	dd 068d6f470h
	dd 022e68e60h
	dd 0f3aca150h
	dd 094bcfeach
	dd 069e93a97h
	dd 04e3d4469h
	dd 012da99f9h
	dd 0275c02a7h
	dd 037cd9d7ah
	dd 07ea389e2h
	dd 07c01bb74h
	dd 070a929c7h
	dd 0deb789d3h
	dd 0de24cd07h
	dd 0fec5828ch
	dd 0a5b91f9dh
	dd 06d00db0bh
	dd 0e34ac001h
	dd 0c516d658h
	dd 07dfc8a8ch
	dd 0947c76e2h
	dd 063671e03h
	dd 005f251e9h
	dd 06994e9cah
	dd 0f2612db9h
	dd 010139deah
	dd 061081a25h
	dd 039023006h
	dd 02e3f3560h
	dd 05c874818h
	dd 05a408660h
	dd 0bc8323ddh
	dd 09de68c3eh
	dd 0548a705fh
	dd 028977580h
	dd 02fde888ah
	dd 01555146ch
	dd 0d8b13c7ch
	dd 032f8d581h
	dd 0d6e69476h
	dd 09370421eh
	dd 0e765a6e2h
	dd 0a0bf3cc2h
	dd 09b7e2375h
	dd 082d2ce67h
	dd 06688d0dch
	dd 018c1730ah
	dd 0f5281528h
	dd 06000eaa2h
	dd 0c09c6043h
	dd 0f5f56e65h
	dd 04d63bf34h
	dd 0fa10fdd9h
	dd 0c26e45fch
	dd 0b7dfd87dh
	dd 0fa2e8822h
	dd 00a98e16ch
	dd 0cff4a127h
	dd 02112786ah
	dd 033d144b9h
	dd 037c05629h
	dd 06c95256dh
	dd 05abe3febh
	dd 0b5911c0fh
	dd 0e5084eeeh
	dd 0ca640a30h
	dd 0ddaa66f7h
	dd 0d56211d8h
	dd 0e07f703ah
	dd 00ba3f5b4h
	dd 001f785f9h
	dd 0489bf0d0h
	dd 0b5837ffah
	dd 09c87cf8bh
	dd 006078fb1h
	dd 0f92fefc7h
	dd 0504f8360h
	dd 099f994d5h
	dd 0a9628c69h
	dd 082889ffeh
	dd 085588722h
	dd 0ada7e483h
	dd 0a7fa7400h
	dd 02dc653b2h
	dd 06c516511h
	dd 0f710a2d2h
	dd 07328f789h
	dd 0308bf0d2h
	dd 05242d0d6h
	dd 07c4bbf14h
	dd 0adae898fh
	dd 09a2498d7h
	dd 03205ee3bh
	dd 0409ea14fh
	dd 08b7e6a7bh
	dd 09d39fddah
	dd 03cdf1927h
	dd 0f62fa6d7h
	dd 080c5812dh
	dd 069c8650bh
	dd 010eba8e6h
	dd 0be4dfe55h
	dd 09f32e2c6h
	dd 0fef961c1h
	dd 0d5af9883h
	dd 0b242952bh
	dd 0f6efd68eh
	dd 06d6a357ch
	dd 000e92af3h
	dd 04f333cd1h
	dd 0305f2b3bh
	dd 01a9c777ch
	dd 0d3598f1ch
	dd 0458dc65ah
	dd 025ffa16dh
	dd 052e154f1h
	dd 0dc680020h
	dd 084a36efch
	dd 0a0f9f700h
	dd 00789c580h
	dd 0ed661b64h
	dd 00e49f85bh
	dd 02af38404h
	dd 062cc1d88h
	dd 0c46174fdh
	dd 057cd7f58h
	dd 03207884eh
	dd 079564b7dh
	dd 056ce4257h
	dd 076f68549h
	dd 0049797f0h
	dd 0ade3d26ah
	dd 038accf34h
	dd 0d475b2c5h
	dd 035a81b5fh
	dd 0f07a09ceh
	dd 0da95bfddh
	dd 09afa8b86h
	dd 00c84cbbdh
	dd 05cde00ddh
	dd 0883a2d27h
	dd 0d78ca377h
	dd 0430c949dh
	dd 0624bbfafh
	dd 0fd7b36a6h
	dd 081b78f89h
	dd 0e87fe62dh
	dd 0777bf1b1h
	dd 049e80d52h
	dd 007f0dde9h
	dd 00a050852h
	dd 0c2ed2824h
	dd 0b421aedbh
	dd 04ec8ca4ah
	dd 049d2f958h
	dd 04711f53ah
	dd 0e9895d91h
	dd 06581d152h
	dd 068e4a767h
	dd 06886862fh
	dd 0e9022b5ch
	dd 0f1d12860h
	dd 07131e478h
	dd 0b118f29ch
	dd 08092b7e9h
	dd 0e6272f4dh
	dd 02f3692c9h
	dd 0f24c54f5h
	dd 0ca8e9aech
	dd 0838ba96fh
	dd 04f0239d3h
	dd 0f295395eh
	dd 0b3c38631h
	dd 07ea7a143h
	dd 0157a4e43h
	dd 046f8173fh
	dd 0fbc18d4ah
	dd 0c401e17ah
	dd 0c4620358h
	dd 0d2ab5437h
	dd 0a01db06fh
	dd 058ce91fch
	dd 0850de1a3h
	dd 09b542dbah
	dd 0ee77f038h
	dd 0ddd3ced6h
	dd 0c225d2ceh
	dd 063a3f765h
	dd 03342a06ch
	dd 06a780c2fh
	dd 0faa925b2h
	dd 0366ebeech
	dd 0bcc9abeah
	dd 0c7b3fa4eh
	dd 0f4f1123dh
	dd 05198702ch
	dd 03e3458b7h
	dd 00b1ce9a1h
	dd 051b1bd7fh
	dd 0711e791eh
	dd 0927d8bedh
	dd 091dbaea9h
	dd 07eefbda9h
	dd 07a19edd9h
	dd 0df7b8dceh
	dd 05bb40613h
	dd 00b0c1e0fh
	dd 085b82c98h
	dd 018da4dc1h
	dd 0c5fd78ach
	dd 057c1e31dh
	dd 04c4001b5h
	dd 0e31d2643h
	dd 0a6afbf58h
	dd 0ad200e68h
	dd 0f0114ba4h
	dd 0d6a620f2h
	dd 0c753a720h
	dd 0ac9022a0h
	dd 028a41f01h
	dd 022a4ba95h
	dd 0c00b7531h
	dd 023d42795h
	dd 0cd836a86h
	dd 090262708h
	dd 03292cad0h
	dd 040022e39h
	dd 0c1581b0ah
	dd 0e5101550h
	dd 06538096bh
	dd 0208c549dh
	dd 03ce2bf88h
	dd 0a71df38eh
	dd 03dec3685h
	dd 0ca3949f1h
	dd 079f3ad1bh
	dd 03ee8b300h
	dd 09d305fc6h
	dd 07a2e5288h
	dd 0be81a2f2h
	dd 07ada0c06h
	dd 0191c7f01h
	dd 058dfcbd1h
	dd 0c78dee72h
	dd 072364226h
	dd 01866de12h
	dd 08d22305ch
	dd 0943a0f0eh
	dd 0c81967ffh
	dd 04d55fb0fh
	dd 0af199be1h
	dd 090bbda61h
	dd 04e7c234fh
	dd 090cfec16h
	dd 09b4bcf26h
	dd 021622023h
	dd 00926f0fah
	dd 01d504377h
	dd 0a58db427h
	dd 08d93ce2bh
	dd 090bfe900h
	dd 029e67397h
	dd 02c1261edh
	dd 04ace9474h
	dd 0d5c60282h
	dd 0e53fb300h
	dd 08a61a0abh
	dd 0a7aa0918h
	dd 04389d7c5h
	dd 0d09d605ch
	dd 06c5bedb5h
	dd 0d6d54c51h
	dd 0433dea21h
	dd 07ad9e677h
	dd 0813bff76h
	dd 05a162c75h
	dd 01ee0661fh
	dd 09b6c2030h
	dd 08e8dc989h
	dd 0cd4bc9fch
	dd 04454675bh
	dd 08d583c9ch
	dd 0e3400094h
	dd 0116ebb83h
	dd 0e847bc9ah
	dd 02a4622ddh
	dd 02a901e6fh
	dd 0d789b1c0h
	dd 0094e2bbbh
	dd 0056e563fh
	dd 09f17e606h
	dd 08bc79b8dh
	dd 0d2c535c1h
	dd 006a45a27h
	dd 09dc56771h
	dd 0a06649e2h
	dd 05ff25ac8h
	dd 06554961eh
	dd 098e583d9h
	dd 038ba93dah
	dd 0dee1de18h
	dd 0037cb9d5h
	dd 06b17f195h
	dd 03431faafh
	dd 013860a0dh
	dd 028bca10dh
	dd 00a54c011h
	dd 09957cdb6h
	dd 03aa1f429h
	dd 09d41b7b3h
	dd 09aea5be2h
	dd 060c7ce6bh
	dd 04cd1c10bh
	dd 024ddddcdh
	dd 0e28412bah
	dd 0a03a5466h
	dd 0a1896879h
	dd 059edcb87h
	dd 01b241765h
	dd 0157bf161h
	dd 0f219f950h
	dd 0e86ff526h
	dd 0262005d9h
	dd 011769531h
	dd 0bca15d95h
	dd 028f5ef17h
	dd 01f27e725h
	dd 0c32631d2h
	dd 007249e61h
	dd 01ba851e3h
	dd 04f49b577h
	dd 0e2a1df5eh
	dd 0826fa7ffh
	dd 0c34e1e2eh
	dd 07fe26024h
	dd 0bc19800fh
	dd 00d368dc9h
	dd 0e03da0c6h
	dd 0adaa4f9ch
	dd 09ad1e43ch
	dd 096f84e44h
	dd 00b6cd695h
	dd 01bb46971h
	dd 0942d6e5bh
	dd 06316170dh
	dd 03164509fh
	dd 0c6659450h
	dd 0b2a0370ah
	dd 0abc208e8h
	dd 06d479811h
	dd 03684bc0eh
	dd 080b7b101h
	dd 0a50b7bb5h
	dd 043d21233h
	dd 0b423559dh
	dd 0f41dcd16h
	dd 0dfd3c276h
	dd 03e586469h
	dd 0d9b7630ah
	dd 0b88f9e44h
	dd 00cda6f4dh
	dd 0e5bf5844h
	dd 08709f788h
	dd 0dae37da6h
	dd 01fb41777h
	dd 01d903f69h
	dd 034383b69h
	dd 0d409ae70h
	dd 0d1c99758h
	dd 0dedfd7a4h
	dd 0a4bdf018h
	dd 0f4058202h
	dd 08565d66fh
	dd 05365aed9h
	dd 0fa69742eh
	dd 02cfbfbcfh
	dd 088a00b60h
	dd 0506c0713h
	dd 02866475bh
	dd 03e1df573h
	dd 0b86f7febh
	dd 031d23a7fh
	dd 0c6320e6ah
	dd 03ebbc2a5h
	dd 083a1d4efh
	dd 015169f5fh
	dd 042a61753h
	dd 0893e553eh
	dd 04ddbc66dh
	dd 07449ec1fh
	dd 076f65d22h
	dd 00622e13bh
	dd 032986f89h
	dd 021181b4bh
	dd 099a80c0ah
	dd 0d6fe00b0h
	dd 0282c0e81h
	dd 09fc1cf88h
	dd 0919b855dh
	dd 0618257d8h
	dd 082c448b8h
	dd 0e22537a1h
	dd 0a90de388h
	dd 0ba73b90ch
	dd 0d765eeb0h
	dd 062b2727eh
	dd 0a08dfe20h
	dd 070b3c8c5h
	dd 03ef04007h
	dd 09f73732bh
	dd 02201edd7h
	dd 0b836219ch
	dd 0f913af7ch
	dd 0f50f64cah
	dd 093ac107ah
	dd 0f509f84ah
	dd 06f6026f6h
	dd 0d9bb8each
	dd 04b268cfah
	dd 0a65a3fa6h
	dd 09837cb75h
	dd 0784fb835h
	dd 02060576dh
	dd 0b1604caeh
	dd 0b9da4116h
	dd 0ab320cf2h
	dd 060a1b501h
	dd 00c73fa79h
	dd 08d5a6f1eh
	dd 057688086h
	dd 0218e4005h
	dd 0ca054e3dh
	dd 0c1a3c3ech

;R02 - start
dd 000000001h ; Header Version
dd 000000032h ; BIOS Update ID
dd 012121996h ; DATE
dd 000000633h ; CPUID for C0 stepping
dd 00d73d3bch ; Checksum
dd 000000001h ; Loader Version
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 0f8d09342h
dd 08e65e8d7h
dd 06d20de4ah
dd 0826d73f0h
dd 0844f9905h
dd 029145a92h
dd 0cf9a7c2eh
dd 0b19e00f8h
dd 08dc31da8h
dd 044034bd1h
dd 00a159adah
dd 02dd635dch
dd 095eb1dd8h
dd 023f6b00ch
dd 094ef84ffh
dd 0e20a5c4ch
dd 0612b2ab3h
dd 0df0d47aeh
dd 0da10d6f9h
dd 07f6b435dh
dd 0a1b6ba0ch
dd 087957bc0h
dd 04ff35a0fh
dd 0b3e02940h
dd 0b87301a4h
dd 06ea1b8fbh
dd 04e28664dh
dd 02019a756h
dd 0b03e17ach
dd 0c6054b71h
dd 0a5c5452bh
dd 0f0517402h
dd 03d97fc30h
dd 0c35c8e69h
dd 091cb1ee0h
dd 0c36f385dh
dd 05e4e9d2ch
dd 050d3da68h
dd 0a797526bh
dd 0ef7a5828h
dd 0d9544c22h
dd 0c750e71dh
dd 00eb3662dh
dd 045479f44h
dd 031bb8e57h
dd 0cf8a195ah
dd 01ccc3653h
dd 033c33879h
dd 0f3c3096ch
dd 03691449bh
dd 0d61cb553h
dd 0af7f0c04h
dd 04f0d575ah
dd 03a634aeeh
dd 0e50c35b3h
dd 0c600ec9ah
dd 0aa0dc7c7h
dd 0d96e2063h
dd 0810619a4h
dd 0f3ea5328h
dd 073663a92h
dd 0e5ed4684h
dd 03b38c199h
dd 076be02a6h
dd 03accc8b6h
dd 04c554c96h
dd 0b5e3fa3bh
dd 065dd3423h
dd 0ca8d1687h
dd 0f2d9362ch
dd 08970002dh
dd 039d32a52h
dd 0c63123c8h
dd 0f88a630bh
dd 0a1970e9bh
dd 0839767eeh
dd 020360302h
dd 0a1a2971ah
dd 0ee3fde23h
dd 0e40e056dh
dd 076347089h
dd 0050cc72fh
dd 026a06723h
dd 0e042331ch
dd 060cfe86eh
dd 0edf3e506h
dd 0dcc867a7h
dd 01efa08e7h
dd 0eae52b92h
dd 06c7bb161h
dd 0b97334f7h
dd 00f8f1836h
dd 0938430cfh
dd 0ccf0c1fbh
dd 043f7fbd8h
dd 0e5f6c576h
dd 0e99de61ah
dd 0374118adh
dd 0a5034754h
dd 0ea27bc8bh
dd 0740679eeh
dd 0c9f2577fh
dd 07c2303bbh
dd 09c91be56h
dd 063ad48b8h
dd 05a9e3347h
dd 094b3557bh
dd 014733d4fh
dd 07d15e2aeh
dd 037d92d81h
dd 083def2f4h
dd 01d94a364h
dd 0df767488h
dd 06aa23a8ah
dd 0cfffacc7h
dd 0a6161b8ch
dd 077f2ba52h
dd 036d054f4h
dd 07b59113ah
dd 0f4c9930fh
dd 0d6d71926h
dd 01808c0e8h
dd 05a44af30h
dd 0849d2952h
dd 02726d569h
dd 0ad0efef1h
dd 0fe65fb08h
dd 0c2a5d18fh
dd 07fe5fceeh
dd 0610bdeaah
dd 01428c296h
dd 0d310101ah
dd 019e73c8dh
dd 0d4f90c45h
dd 0932565bch
dd 0329bb8b0h
dd 051aebf09h
dd 0e10da7d9h
dd 068309efch
dd 0c3dd9dd2h
dd 0775ddcc3h
dd 0b17faa9dh
dd 0f933c510h
dd 08bdb8a49h
dd 07415180eh
dd 0f1c271e7h
dd 0a7c0b756h
dd 03900b9f2h
dd 047d63cd1h
dd 084b4ec8bh
dd 0d3f74658h
dd 011ba8323h
dd 02a12bcabh
dd 05cbfbf64h
dd 0ec2a7f4fh
dd 051bb5d19h
dd 0f2b57f7ah
dd 0469f02ffh
dd 00cee5cf4h
dd 0c8787116h
dd 058719ab3h
dd 05608e695h
dd 0388933c8h
dd 07675ca44h
dd 0b43aba59h
dd 095d712dah
dd 0157718fbh
dd 01a624c3fh
dd 03762f6fbh
dd 0a98dcec3h
dd 0df354f0eh
dd 0e8c74acbh
dd 08592d0dch
dd 0ce2179ffh
dd 0dff0826eh
dd 0446438c7h
dd 08240f319h
dd 0a241ccech
dd 0add580b8h
dd 03a1e63dah
dd 074e60dcfh
dd 0300acf1bh
dd 0a2324b81h
dd 03c3df33eh
dd 0f5abd674h
dd 00c01ea77h
dd 095c349d0h
dd 091da9c12h
dd 07d6bc46ah
dd 0ec140540h
dd 0fc26fa0eh
dd 0adadc3deh
dd 015543178h
dd 0a1bec30ah
dd 0f5282036h
dd 075304b78h
dd 00f5e6697h
dd 0505c1e7bh
dd 08d2fb9d6h
dd 0a40b8f82h
dd 0ffb890a0h
dd 0248f54afh
dd 0c0165301h
dd 08e3f1a66h
dd 0aca6cd49h
dd 05957798eh
dd 00a4ae1afh
dd 0604d8234h
dd 0ca01548bh
dd 086c6a94ch
dd 07211fff1h
dd 0277b89f9h
dd 09ca3eb1bh
dd 0fe5d70b6h
dd 0edce3defh
dd 0eaa309d1h
dd 08d877cdch
dd 065bd2013h
dd 0c4183a46h
dd 01c150149h
dd 0341016e4h
dd 084a49c4eh
dd 0e717a6dch
dd 0f4d0e710h
dd 098d3e277h
dd 062de50dch
dd 0c41aed6bh
dd 0c3c2eaafh
dd 06216fc1ah
dd 0d6379895h
dd 0ef1d62a8h
dd 09906a863h
dd 0c7d5daadh
dd 0dca3d633h
dd 0a7a17e7fh
dd 0915c6b3bh
dd 0838ba96fh
dd 04f0239d3h
dd 0f295395eh
dd 0b3c38631h
dd 07ea7a143h
dd 0157a4e43h
dd 046f8173fh
dd 0fbc18d4ah
dd 0c401e17ah
dd 0c4620358h
dd 0d2ab5437h
dd 0a01db06fh
dd 058ce91fch
dd 0850de1a3h
dd 09b542dbah
dd 0ee77f038h
dd 0ddd3ced6h
dd 0c225d2ceh
dd 063a3f765h
dd 03342a06ch
dd 06a780c2fh
dd 0faa925b2h
dd 0366ebeech
dd 0bcc9abeah
dd 0c7b3fa4eh
dd 0f4f1123dh
dd 05198702ch
dd 03e3458b7h
dd 00b1ce9a1h
dd 051b1bd7fh
dd 0711e791eh
dd 0927d8bedh
dd 091dbaea9h
dd 07eefbda9h
dd 07a19edd9h
dd 0df7b8dceh
dd 05bb40613h
dd 00b0c1e0fh
dd 085b82c98h
dd 018da4dc1h
dd 0c5fd78ach
dd 057c1e31dh
dd 04c4001b5h
dd 0e31d2643h
dd 0a6afbf58h
dd 0ad200e68h
dd 0f0114ba4h
dd 0d6a620f2h
dd 0c753a720h
dd 0ac9022a0h
dd 028a41f01h
dd 022a4ba95h
dd 0c00b7531h
dd 023d42795h
dd 0cd836a86h
dd 090262708h
dd 03292cad0h
dd 040022e39h
dd 0c1581b0ah
dd 0e5101550h
dd 06538096bh
dd 0208c549dh
dd 03ce2bf88h
dd 0a71df38eh
dd 03dec3685h
dd 0ca3949f1h
dd 079f3ad1bh
dd 03ee8b300h
dd 09d305fc6h
dd 07a2e5288h
dd 0be81a2f2h
dd 07ada0c06h
dd 0191c7f01h
dd 058dfcbd1h
dd 0c78dee72h
dd 072364226h
dd 01866de12h
dd 08d22305ch
dd 0943a0f0eh
dd 0c81967ffh
dd 04d55fb0fh
dd 0af199be1h
dd 090bbda61h
dd 04e7c234fh
dd 090cfec16h
dd 09b4bcf26h
dd 021622023h
dd 00926f0fah
dd 01d504377h
dd 0a58db427h
dd 08d93ce2bh
dd 090bfe900h
dd 029e67397h
dd 02c1261edh
dd 04ace9474h
dd 0d5c60282h
dd 0e53fb300h
dd 08a61a0abh
dd 0a7aa0918h
dd 04389d7c5h
dd 0d09d605ch
dd 06c5bedb5h
dd 0d6d54c51h
dd 0433dea21h
dd 07ad9e677h
dd 0813bff76h
dd 05a162c75h
dd 01ee0661fh
dd 09b6c2030h
dd 08e8dc989h
dd 0cd4bc9fch
dd 04454675bh
dd 08d583c9ch
dd 0e3400094h
dd 0116ebb83h
dd 0e847bc9ah
dd 02a4622ddh
dd 02a901e6fh
dd 0d789b1c0h
dd 0094e2bbbh
dd 0056e563fh
dd 09f17e606h
dd 08bc79b8dh
dd 0d2c535c1h
dd 006a45a27h
dd 09dc56771h
dd 0a06649e2h
dd 05ff25ac8h
dd 06554961eh
dd 098e583d9h
dd 038ba93dah
dd 0dee1de18h
dd 0037cb9d5h
dd 06b17f195h
dd 03431faafh
dd 013860a0dh
dd 028bca10dh
dd 00a54c011h
dd 09957cdb6h
dd 03aa1f429h
dd 09d41b7b3h
dd 09aea5be2h
dd 060c7ce6bh
dd 04cd1c10bh
dd 024ddddcdh
dd 0e28412bah
dd 0a03a5466h
dd 0a1896879h
dd 059edcb87h
dd 01b241765h
dd 0157bf161h
dd 0f219f950h
dd 0e86ff526h
dd 0262005d9h
dd 011769531h
dd 0bca15d95h
dd 028f5ef17h
dd 01f27e725h
dd 0c32631d2h
dd 007249e61h
dd 01ba851e3h
dd 04f49b577h
dd 0e2a1df5eh
dd 0826fa7ffh
dd 0c34e1e2eh
dd 07fe26024h
dd 0bc19800fh
dd 00d368dc9h
dd 0e03da0c6h
dd 0adaa4f9ch
dd 09ad1e43ch
dd 096f84e44h
dd 00b6cd695h
dd 01bb46971h
dd 0942d6e5bh
dd 06316170dh
dd 03164509fh
dd 0c6659450h
dd 0b2a0370ah
dd 0abc208e8h
dd 06d479811h
dd 03684bc0eh
dd 080b7b101h
dd 0a50b7bb5h
dd 043d21233h
dd 0b423559dh
dd 0f41dcd16h
dd 0dfd3c276h
dd 03e586469h
dd 0d9b7630ah
dd 0b88f9e44h
dd 00cda6f4dh
dd 0e5bf5844h
dd 08709f788h
dd 0dae37da6h
dd 01fb41777h
dd 01d903f69h
dd 034383b69h
dd 0d409ae70h
dd 0d1c99758h
dd 0dedfd7a4h
dd 0a4bdf018h
dd 0f4058202h
dd 08565d66fh
dd 05365aed9h
dd 0fa69742eh
dd 02cfbfbcfh
dd 088a00b60h
dd 0506c0713h
dd 02866475bh
dd 03e1df573h
dd 0b86f7febh
dd 031d23a7fh
dd 0c6320e6ah
dd 03ebbc2a5h
dd 083a1d4efh
dd 015169f5fh
dd 042a61753h
dd 0893e553eh
dd 04ddbc66dh
dd 07449ec1fh
dd 076f65d22h
dd 00622e13bh
dd 032986f89h
dd 021181b4bh
dd 099a80c0ah
dd 0d6fe00b0h
dd 0282c0e81h
dd 09fc1cf88h
dd 0919b855dh
dd 0618257d8h
dd 082c448b8h
dd 0e22537a1h
dd 0a90de388h
dd 0ba73b90ch
dd 0d765eeb0h
dd 062b2727eh
dd 0a08dfe20h
dd 070b3c8c5h
dd 03ef04007h
dd 09f73732bh
dd 02201edd7h
dd 0b836219ch
dd 0f913af7ch
dd 0f50f64cah
dd 093ac107ah
dd 0f509f84ah
dd 06f6026f6h
dd 0d9bb8each
dd 04b268cfah
dd 0a65a3fa6h
dd 09837cb75h
dd 0784fb835h
dd 02060576dh
dd 0b1604caeh
dd 0b9da4116h
dd 0ab320cf2h
dd 060a1b501h
dd 00c73fa79h
dd 08d5a6f1eh
dd 057688086h
dd 0218e4005h
dd 0ca054e3dh
dd 0c1a3c3ech
;R02 - end

;R03 - start
dd 000000001h ; Header Version
dd 000000033h ; Patch ID
dd 006161997h ; DATE
dd 000000634h ; CPUID
dd 0f3ac5144h ; Checksum
dd 000000001h ; Loader Version
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 060f820dah
dd 0190b2dfdh
dd 0a8235277h
dd 0386196b2h
dd 0e6273c66h
dd 085faff8ah
dd 042314dd7h
dd 0fd1bfdf7h
dd 0ae685cb8h
dd 07267405dh
dd 0f4791381h
dd 0a83033e0h
dd 02602b1f2h
dd 0fd7266abh
dd 0e88c50d7h
dd 01adcc53ch
dd 0fff5fd93h
dd 0d74ab45fh
dd 00d5e3710h
dd 0d26d8d44h
dd 0b492bcc3h
dd 00d63cbd1h
dd 0a8b3013ch
dd 0a85e989eh
dd 01a10fe01h
dd 0857bd152h
dd 085fec6b9h
dd 03ca3923eh
dd 0d5c2b581h
dd 0a79f600ah
dd 06d19a9deh
dd 0e881ab00h
dd 0abc15ffeh
dd 04a68d443h
dd 0e6251b71h
dd 0905320a6h
dd 03139cb9ah
dd 0cab194a8h
dd 0ec6b474ch
dd 00d6c53f1h
dd 0d341a73fh
dd 0c02d0ecbh
dd 008c7b6b1h
dd 0d0b85931h
dd 0a8a799d3h
dd 00af2a4a4h
dd 080a9a08ah
dd 0a02ce895h
dd 00c6caf51h
dd 0bd94e88bh
dd 0a0e529a3h
dd 039a8f215h
dd 0e6eca66ch
dd 0a5bf2fd8h
dd 040714cf1h
dd 0f0993e6bh
dd 0b818cfcfh
dd 0439daaf6h
dd 0e6880b34h
dd 0a6585b69h
dd 00b53db39h
dd 0e4f1ff21h
dd 0e571050bh
dd 03b150a7fh
dd 0d50d5ae3h
dd 0e69b8914h
dd 032474a69h
dd 0efad62a9h
dd 09d76116fh
dd 00c485350h
dd 08e1494b1h
dd 0b4725536h
dd 0298a888bh
dd 08dc168c0h
dd 0965d7ab5h
dd 02a027efch
dd 0fa6ad3cah
dd 0b568ad22h
dd 058bde3afh
dd 0e36a8557h
dd 093ecdd0fh
dd 07c8d2d69h
dd 0dc50fbb8h
dd 0a386e0e6h
dd 0269abac6h
dd 0f80389ach
dd 0c95f1857h
dd 0240e3444h
dd 0edd9e1dfh
dd 0fb7ab24eh
dd 00f4f2a3bh
dd 0c8605403h
dd 08b021625h
dd 00a183575h
dd 0987bbc6fh
dd 0ac222affh
dd 0064de4ceh
dd 080e4c6e8h
dd 08c74f06dh
dd 019e4bb56h
dd 0c2ffb889h
dd 09aef4a78h
dd 04c2c3de2h
dd 0c96bbf47h
dd 0aa5f0b92h
dd 07f8c4bf6h
dd 0e54c29d1h
dd 08daf8866h
dd 007cb54eeh
dd 0e407f3e8h
dd 0db2509a1h
dd 0357286cfh
dd 0ce7425feh
dd 0ff052d62h
dd 0261abfb3h
dd 0c586c76bh
dd 09062bd25h
dd 010d284feh
dd 09c9f3fd6h
dd 0895ddefah
dd 014536ddfh
dd 0949b5e1fh
dd 0a1e67055h
dd 0241b635ch
dd 0d164f707h
dd 08b728ee9h
dd 043723f0dh
dd 0d32744ebh
dd 0a4bed95dh
dd 04f602670h
dd 0e14d7714h
dd 0a66c61eeh
dd 00c857bfeh
dd 0f504e8c7h
dd 0cafce3a6h
dd 03b9b9950h
dd 0c27a6f88h
dd 0f24d076fh
dd 039d2ee32h
dd 0fb85bda5h
dd 0982e7feah
dd 03d4ce8adh
dd 0b3e44e4fh
dd 0b48c3a3fh
dd 01dabea3dh
dd 0a6923fd8h
dd 08a8d5ea5h
dd 030aa9a76h
dd 0f2cc0c6bh
dd 0b5a935f7h
dd 058955fb4h
dd 0deeaf564h
dd 086b0274eh
dd 0772c70cfh
dd 0cdf46d05h
dd 09638f1f5h
dd 01950df86h
dd 0e35b99eah
dd 0dc372b3ch
dd 034b64356h
dd 0ed979bd5h
dd 0c750f41ah
dd 02dea8b83h
dd 0e95545bch
dd 0967c750ah
dd 000c1c727h
dd 0bd248095h
dd 0b2f84959h
dd 0084f47c6h
dd 08a935aa7h
dd 04bffc497h
dd 0aefdf807h
dd 00c2b496ah
dd 06b5cd545h
dd 0a5e71de0h
dd 003ed52ddh
dd 0ba2102f5h
dd 0955d9dcch
dd 03bf18ce7h
dd 06867b439h
dd 09bc4306dh
dd 0d2fd43bfh
dd 04c27b44bh
dd 0a18defceh
dd 0ef97bbadh
dd 052dcb419h
dd 09b8c3f43h
dd 0aa6a17cdh
dd 05d85b475h
dd 0ecba19afh
dd 09fedf585h
dd 05fe57f09h
dd 0ceebafdbh
dd 0b21c5efdh
dd 07bd25fb9h
dd 061d07828h
dd 09642d152h
dd 0d49025e7h
dd 064764eaeh
dd 026937397h
dd 0fdd546a7h
dd 01897e5a6h
dd 0a9e45d24h
dd 038709ae2h
dd 08df5c83ah
dd 0a12dcab8h
dd 01bd0e39ch
dd 0da89dfc4h
dd 0a9c226cdh
dd 05fa82067h
dd 049c335beh
dd 0c2cd05a2h
dd 0d6c88e30h
dd 02162973ah
dd 09d40854dh
dd 08631c03ah
dd 052143b13h
dd 0c3485a08h
dd 0355f4471h
dd 0c5978a83h
dd 0775c2cc2h
dd 08d58a16ch
dd 04afce349h
dd 0d3eb0aceh
dd 011900290h
dd 0c847e13ah
dd 0db17c949h
dd 0260b0f97h
dd 0fb0ffcf4h
dd 0f835109ah
dd 01847380eh
dd 0643d1d6dh
dd 0cafba29fh
dd 0ab40e75ah
dd 073910edbh
dd 032305b79h
dd 0838ba96fh
dd 04f0239d3h
dd 0f295395eh
dd 0b3c38631h
dd 07ea7a143h
dd 0157a4e43h
dd 046f8173fh
dd 0fbc18d4ah
dd 0c401e17ah
dd 0c4620358h
dd 0d2ab5437h
dd 0a01db06fh
dd 058ce91fch
dd 0850de1a3h
dd 09b542dbah
dd 0ee77f038h
dd 0ddd3ced6h
dd 0c225d2ceh
dd 063a3f765h
dd 03342a06ch
dd 06a780c2fh
dd 0faa925b2h
dd 0366ebeech
dd 0bcc9abeah
dd 0c7b3fa4eh
dd 0f4f1123dh
dd 05198702ch
dd 03e3458b7h
dd 00b1ce9a1h
dd 051b1bd7fh
dd 0711e791eh
dd 0927d8bedh
dd 091dbaea9h
dd 07eefbda9h
dd 07a19edd9h
dd 0df7b8dceh
dd 05bb40613h
dd 00b0c1e0fh
dd 085b82c98h
dd 018da4dc1h
dd 0c5fd78ach
dd 057c1e31dh
dd 04c4001b5h
dd 0e31d2643h
dd 0a6afbf58h
dd 0ad200e68h
dd 0f0114ba4h
dd 0d6a620f2h
dd 0c753a720h
dd 0ac9022a0h
dd 028a41f01h
dd 022a4ba95h
dd 0c00b7531h
dd 023d42795h
dd 0cd836a86h
dd 090262708h
dd 03292cad0h
dd 040022e39h
dd 0c1581b0ah
dd 0e5101550h
dd 06538096bh
dd 0208c549dh
dd 03ce2bf88h
dd 0a71df38eh
dd 03dec3685h
dd 0ca3949f1h
dd 079f3ad1bh
dd 03ee8b300h
dd 09d305fc6h
dd 07a2e5288h
dd 0be81a2f2h
dd 07ada0c06h
dd 0191c7f01h
dd 058dfcbd1h
dd 0c78dee72h
dd 072364226h
dd 01866de12h
dd 08d22305ch
dd 0943a0f0eh
dd 0c81967ffh
dd 04d55fb0fh
dd 0af199be1h
dd 090bbda61h
dd 04e7c234fh
dd 090cfec16h
dd 09b4bcf26h
dd 021622023h
dd 00926f0fah
dd 01d504377h
dd 0a58db427h
dd 08d93ce2bh
dd 090bfe900h
dd 029e67397h
dd 02c1261edh
dd 04ace9474h
dd 0d5c60282h
dd 0e53fb300h
dd 08a61a0abh
dd 0a7aa0918h
dd 04389d7c5h
dd 0d09d605ch
dd 06c5bedb5h
dd 0d6d54c51h
dd 0433dea21h
dd 07ad9e677h
dd 0813bff76h
dd 05a162c75h
dd 01ee0661fh
dd 09b6c2030h
dd 08e8dc989h
dd 0cd4bc9fch
dd 04454675bh
dd 08d583c9ch
dd 0e3400094h
dd 0116ebb83h
dd 0e847bc9ah
dd 02a4622ddh
dd 02a901e6fh
dd 0d789b1c0h
dd 0094e2bbbh
dd 0056e563fh
dd 09f17e606h
dd 08bc79b8dh
dd 0d2c535c1h
dd 006a45a27h
dd 09dc56771h
dd 0a06649e2h
dd 05ff25ac8h
dd 06554961eh
dd 098e583d9h
dd 038ba93dah
dd 0dee1de18h
dd 0037cb9d5h
dd 06b17f195h
dd 03431faafh
dd 013860a0dh
dd 028bca10dh
dd 00a54c011h
dd 09957cdb6h
dd 03aa1f429h
dd 09d41b7b3h
dd 09aea5be2h
dd 060c7ce6bh
dd 04cd1c10bh
dd 024ddddcdh
dd 0e28412bah
dd 0a03a5466h
dd 0a1896879h
dd 059edcb87h
dd 01b241765h
dd 0157bf161h
dd 0f219f950h
dd 0e86ff526h
dd 0262005d9h
dd 011769531h
dd 0bca15d95h
dd 028f5ef17h
dd 01f27e725h
dd 0c32631d2h
dd 007249e61h
dd 01ba851e3h
dd 04f49b577h
dd 0e2a1df5eh
dd 0826fa7ffh
dd 0c34e1e2eh
dd 07fe26024h
dd 0bc19800fh
dd 00d368dc9h
dd 0e03da0c6h
dd 0adaa4f9ch
dd 09ad1e43ch
dd 096f84e44h
dd 00b6cd695h
dd 01bb46971h
dd 0942d6e5bh
dd 06316170dh
dd 03164509fh
dd 0c6659450h
dd 0b2a0370ah
dd 0abc208e8h
dd 06d479811h
dd 03684bc0eh
dd 080b7b101h
dd 0a50b7bb5h
dd 043d21233h
dd 0b423559dh
dd 0f41dcd16h
dd 0dfd3c276h
dd 03e586469h
dd 0d9b7630ah
dd 0b88f9e44h
dd 00cda6f4dh
dd 0e5bf5844h
dd 08709f788h
dd 0dae37da6h
dd 01fb41777h
dd 01d903f69h
dd 034383b69h
dd 0d409ae70h
dd 0d1c99758h
dd 0dedfd7a4h
dd 0a4bdf018h
dd 0f4058202h
dd 08565d66fh
dd 05365aed9h
dd 0fa69742eh
dd 02cfbfbcfh
dd 088a00b60h
dd 0506c0713h
dd 02866475bh
dd 03e1df573h
dd 0b86f7febh
dd 031d23a7fh
dd 0c6320e6ah
dd 03ebbc2a5h
dd 083a1d4efh
dd 015169f5fh
dd 042a61753h
dd 0893e553eh
dd 04ddbc66dh
dd 07449ec1fh
dd 076f65d22h
dd 00622e13bh
dd 032986f89h
dd 021181b4bh
dd 099a80c0ah
dd 0d6fe00b0h
dd 0282c0e81h
dd 09fc1cf88h
dd 0919b855dh
dd 0618257d8h
dd 082c448b8h
dd 0e22537a1h
dd 0a90de388h
dd 0ba73b90ch
dd 0d765eeb0h
dd 062b2727eh
dd 0a08dfe20h
dd 070b3c8c5h
dd 03ef04007h
dd 09f73732bh
dd 02201edd7h
dd 0b836219ch
dd 0f913af7ch
dd 0f50f64cah
dd 093ac107ah
dd 0f509f84ah
dd 06f6026f6h
dd 0d9bb8each
dd 04b268cfah
dd 0a65a3fa6h
dd 09837cb75h
dd 0784fb835h
dd 02060576dh
dd 0b1604caeh
dd 0b9da4116h
dd 0ab320cf2h
dd 060a1b501h
dd 00c73fa79h
dd 08d5a6f1eh
dd 057688086h
dd 0218e4005h
dd 0ca054e3dh
dd 0c1a3c3ech
;R03 - end

;R04 - start
;R04A dd 000000001h ; Header Version
;R04A dd 000000005h ; Patch ID
;R04A dd 008151997h ; DATE
;R04A dd 000000650h ; CPUID, Deschutes CPU
;R04A dd 010c8495dh ; Checksum
;R04A dd 000000001h ; Loader Version
;R04A dd 000000000h ; reserved
;R04A dd 000000000h ; reserved
;R04A dd 000000000h ; reserved
;R04A dd 000000000h ; reserved
;R04A dd 000000000h ; reserved
;R04A dd 000000000h ; reserved
;R04A dd 0247067b2h
;R04A dd 020fb2991h
;R04A dd 0947f236ch
;R04A dd 05b2ad5e0h
;R04A dd 0f9c54480h
;R04A dd 0b31f7980h
;R04A dd 05f4c19c4h
;R04A dd 0af60cc7dh
;R04A dd 0fa0d39afh
;R04A dd 0407cd2fdh
;R04A dd 085824692h
;R04A dd 0b30186dah
;R04A dd 047c21662h
;R04A dd 0f9292ac0h
;R04A dd 0f94c990ch
;R04A dd 04f8c057fh
;R04A dd 0dadd6efbh
;R04A dd 0b89611eah
;R04A dd 06576ed3dh
;R04A dd 0bd73ab4fh
;R04A dd 0a41cc0ddh
;R04A dd 000ee94e6h
;R04A dd 08ff6946dh
;R04A dd 093509f96h
;R04A dd 026f266eeh
;R04A dd 0bdc1bc00h
;R04A dd 0e9e41576h
;R04A dd 037355b63h
;R04A dd 095f1b6a7h
;R04A dd 0d6b75ee3h
;R04A dd 03ea84646h
;R04A dd 0d878b18fh
;R04A dd 0e3e351ffh
;R04A dd 0017d8038h
;R04A dd 0e94347e2h
;R04A dd 0f4ab5272h
;R04A dd 058cd32fdh
;R04A dd 0e412a8c2h
;R04A dd 0da49bdaeh
;R04A dd 02c34a97bh
;R04A dd 0db74eb18h
;R04A dd 0ad581623h
;R04A dd 05bb65fdch
;R04A dd 0d77b45d3h
;R04A dd 0e3bf765fh
;R04A dd 0723e62f2h
;R04A dd 0a4383a30h
;R04A dd 0cdbdeb05h
;R04A dd 03487564bh
;R04A dd 089267b10h
;R04A dd 0e52f5d98h
;R04A dd 005087f0dh
;R04A dd 0b6028e60h
;R04A dd 0ea59a887h
;R04A dd 013fb83ebh
;R04A dd 0fe1a527ch
;R04A dd 0eee93863h
;R04A dd 021465dfah
;R04A dd 0f6a1a099h
;R04A dd 0d8c2ccech
;R04A dd 02a197432h
;R04A dd 09140d0ddh
;R04A dd 0eb453901h
;R04A dd 01a3679cbh
;R04A dd 0e6cf73f4h
;R04A dd 0d28d0992h
;R04A dd 07696f51ah
;R04A dd 08865e775h
;R04A dd 08420dd23h
;R04A dd 01dfe4a35h
;R04A dd 0f1b5eb2fh
;R04A dd 0fa732a69h
;R04A dd 03b1a92efh
;R04A dd 099a46c91h
;R04A dd 09a3170b5h
;R04A dd 05602610fh
;R04A dd 09da3e3a8h
;R04A dd 0e2f69b53h
;R04A dd 010f7fc8dh
;R04A dd 0fdb8a972h
;R04A dd 0e4a99d7eh
;R04A dd 02813f20dh
;R04A dd 094da8ccdh
;R04A dd 0f55df720h
;R04A dd 06b3e4847h
;R04A dd 0fb2ad598h
;R04A dd 0a75e4039h
;R04A dd 03ed9406dh
;R04A dd 0c2291bach
;R04A dd 0e633decbh
;R04A dd 04a827fd9h
;R04A dd 0f6ff8bb8h
;R04A dd 0c0996448h
;R04A dd 04e7e6985h
;R04A dd 084afdb66h
;R04A dd 0ca19b8f5h
;R04A dd 07345b62eh
;R04A dd 0cb631f73h
;R04A dd 0f4b47738h
;R04A dd 05cd29968h
;R04A dd 0e41117b8h
;R04A dd 08c5bf3b8h
;R04A dd 02521f97dh
;R04A dd 0b4089ee8h
;R04A dd 0d0f26719h
;R04A dd 03f74ac27h
;R04A dd 0c63667f9h
;R04A dd 0ee4d1089h
;R04A dd 03ab2c63bh
;R04A dd 09d63bb99h
;R04A dd 0d4f551e6h
;R04A dd 01f45e125h
;R04A dd 080ca18fch
;R04A dd 0b860372bh
;R04A dd 02f5f3d42h
;R04A dd 0b30c33f3h
;R04A dd 0e1cc3245h
;R04A dd 007cefeabh
;R04A dd 0cd8ccb0ah
;R04A dd 0ffa4de4fh
;R04A dd 07f4295f4h
;R04A dd 0dfca6abfh
;R04A dd 0df75fe3ah
;R04A dd 045c004bbh
;R04A dd 0b9a82440h
;R04A dd 0bcdb3b80h
;R04A dd 0628ddca5h
;R04A dd 0eb55d2f2h
;R04A dd 0fb9134f0h
;R04A dd 030177d9eh
;R04A dd 0ab53be49h
;R04A dd 0e674f11ch
;R04A dd 0052f84f4h
;R04A dd 097dc09deh
;R04A dd 0a81f3502h
;R04A dd 027b85d08h
;R04A dd 0f4a30803h
;R04A dd 0a1b99d45h
;R04A dd 0619d9f0dh
;R04A dd 0b5491bddh
;R04A dd 0c339d15eh
;R04A dd 05659588bh
;R04A dd 0f7dab10ah
;R04A dd 09f00c4c5h
;R04A dd 05be0998ch
;R04A dd 0b94b6355h
;R04A dd 0b64a5ba8h
;R04A dd 034ad997fh
;R04A dd 0d544a368h
;R04A dd 0c28e4393h
;R04A dd 038f75d12h
;R04A dd 0aa01f697h
;R04A dd 0fcd30774h
;R04A dd 01674a90bh
;R04A dd 0e66b10f3h
;R04A dd 09334c954h
;R04A dd 01dd875c5h
;R04A dd 0d6a0fe54h
;R04A dd 091cbb975h
;R04A dd 02d968da8h
;R04A dd 0fac9e27fh
;R04A dd 0c139efd3h
;R04A dd 00677641ah
;R04A dd 0af10ca0ah
;R04A dd 0f5fb095dh
;R04A dd 00a09b32ch
;R04A dd 0c4c1db5eh
;R04A dd 0bba8855ch
;R04A dd 0148fd116h
;R04A dd 0b30b572fh
;R04A dd 0d7a34559h
;R04A dd 0d1d7cdfbh
;R04A dd 069f2d3f3h
;R04A dd 0fd0ab7feh
;R04A dd 03522c257h
;R04A dd 024a0e991h
;R04A dd 050e7467bh
;R04A dd 0102de47dh
;R04A dd 044ad9403h
;R04A dd 05f2207efh
;R04A dd 01246d9bfh
;R04A dd 029a10f2ah
;R04A dd 03d360a0ah
;R04A dd 006c4d04eh
;R04A dd 078f27763h
;R04A dd 021dab361h
;R04A dd 06ae63089h
;R04A dd 0534a1a93h
;R04A dd 063f7dcbah
;R04A dd 031040bd1h
;R04A dd 0194dd6bbh
;R04A dd 01247b91ch
;R04A dd 0422e6836h
;R04A dd 04f1ab5ach
;R04A dd 03a2df93eh
;R04A dd 0929d9a07h
;R04A dd 07f469a66h
;R04A dd 0db322605h
;R04A dd 0296b13f4h
;R04A dd 0dcdebe25h
;R04A dd 00225f23ah
;R04A dd 0e8bdda3ch
;R04A dd 0f052a8cch
;R04A dd 0b0430f46h
;R04A dd 0a721cea0h
;R04A dd 022e6c48eh
;R04A dd 020ed1b2eh
;R04A dd 0cdc46c7ah
;R04A dd 099f45fb6h
;R04A dd 035ff15b5h
;R04A dd 0fe6b2d01h
;R04A dd 0e9ce91dch
;R04A dd 025327792h
;R04A dd 0b5420035h
;R04A dd 0a60558bah
;R04A dd 00c6faa6ah
;R04A dd 0cf35c7f3h
;R04A dd 0d2aa7a7bh
;R04A dd 0f645b524h
;R04A dd 0a1d40cfbh
;R04A dd 051416dabh
;R04A dd 0d5e6b2c8h
;R04A dd 087020d7eh
;R04A dd 02782d254h
;R04A dd 09629f59eh
;R04A dd 0dd325f57h
;R04A dd 04562c7e1h
;R04A dd 0138869dbh
;R04A dd 0e92924fch
;R04A dd 0c65f52bah
;R04A dd 0e019895dh
;R04A dd 0bcac9e15h
;R04A dd 0025fb641h
;R04A dd 0b17c95bch
;R04A dd 07d6b67a4h
;R04A dd 05c5ea735h
;R04A dd 0838ba96fh
;R04A dd 04f0239d3h
;R04A dd 0f295395eh
;R04A dd 0b3c38631h
;R04A dd 07ea7a143h
;R04A dd 0157a4e43h
;R04A dd 046f8173fh
;R04A dd 0fbc18d4ah
;R04A dd 0c401e17ah
;R04A dd 0c4620358h
;R04A dd 0d2ab5437h
;R04A dd 0a01db06fh
;R04A dd 058ce91fch
;R04A dd 0850de1a3h
;R04A dd 09b542dbah
;R04A dd 0ee77f038h
;R04A dd 0ddd3ced6h
;R04A dd 0c225d2ceh
;R04A dd 063a3f765h
;R04A dd 03342a06ch
;R04A dd 06a780c2fh
;R04A dd 0faa925b2h
;R04A dd 0366ebeech
;R04A dd 0bcc9abeah
;R04A dd 0c7b3fa4eh
;R04A dd 0f4f1123dh
;R04A dd 05198702ch
;R04A dd 03e3458b7h
;R04A dd 00b1ce9a1h
;R04A dd 051b1bd7fh
;R04A dd 0711e791eh
;R04A dd 0927d8bedh
;R04A dd 091dbaea9h
;R04A dd 07eefbda9h
;R04A dd 07a19edd9h
;R04A dd 0df7b8dceh
;R04A dd 05bb40613h
;R04A dd 00b0c1e0fh
;R04A dd 085b82c98h
;R04A dd 018da4dc1h
;R04A dd 0c5fd78ach
;R04A dd 057c1e31dh
;R04A dd 04c4001b5h
;R04A dd 0e31d2643h
;R04A dd 0a6afbf58h
;R04A dd 0ad200e68h
;R04A dd 0f0114ba4h
;R04A dd 0d6a620f2h
;R04A dd 0c753a720h
;R04A dd 0ac9022a0h
;R04A dd 028a41f01h
;R04A dd 022a4ba95h
;R04A dd 0c00b7531h
;R04A dd 023d42795h
;R04A dd 0cd836a86h
;R04A dd 090262708h
;R04A dd 03292cad0h
;R04A dd 040022e39h
;R04A dd 0c1581b0ah
;R04A dd 0e5101550h
;R04A dd 06538096bh
;R04A dd 0208c549dh
;R04A dd 03ce2bf88h
;R04A dd 0a71df38eh
;R04A dd 03dec3685h
;R04A dd 0ca3949f1h
;R04A dd 079f3ad1bh
;R04A dd 03ee8b300h
;R04A dd 09d305fc6h
;R04A dd 07a2e5288h
;R04A dd 0be81a2f2h
;R04A dd 07ada0c06h
;R04A dd 0191c7f01h
;R04A dd 058dfcbd1h
;R04A dd 0c78dee72h
;R04A dd 072364226h
;R04A dd 01866de12h
;R04A dd 08d22305ch
;R04A dd 0943a0f0eh
;R04A dd 0c81967ffh
;R04A dd 04d55fb0fh
;R04A dd 0af199be1h
;R04A dd 090bbda61h
;R04A dd 04e7c234fh
;R04A dd 090cfec16h
;R04A dd 09b4bcf26h
;R04A dd 021622023h
;R04A dd 00926f0fah
;R04A dd 01d504377h
;R04A dd 0a58db427h
;R04A dd 08d93ce2bh
;R04A dd 090bfe900h
;R04A dd 029e67397h
;R04A dd 02c1261edh
;R04A dd 04ace9474h
;R04A dd 0d5c60282h
;R04A dd 0e53fb300h
;R04A dd 08a61a0abh
;R04A dd 0a7aa0918h
;R04A dd 04389d7c5h
;R04A dd 0d09d605ch
;R04A dd 06c5bedb5h
;R04A dd 0d6d54c51h
;R04A dd 0433dea21h
;R04A dd 07ad9e677h
;R04A dd 0813bff76h
;R04A dd 05a162c75h
;R04A dd 01ee0661fh
;R04A dd 09b6c2030h
;R04A dd 08e8dc989h
;R04A dd 0cd4bc9fch
;R04A dd 04454675bh
;R04A dd 08d583c9ch
;R04A dd 0e3400094h
;R04A dd 0116ebb83h
;R04A dd 0e847bc9ah
;R04A dd 02a4622ddh
;R04A dd 02a901e6fh
;R04A dd 0d789b1c0h
;R04A dd 0094e2bbbh
;R04A dd 0056e563fh
;R04A dd 09f17e606h
;R04A dd 08bc79b8dh
;R04A dd 0d2c535c1h
;R04A dd 006a45a27h
;R04A dd 09dc56771h
;R04A dd 0a06649e2h
;R04A dd 05ff25ac8h
;R04A dd 06554961eh
;R04A dd 098e583d9h
;R04A dd 038ba93dah
;R04A dd 0dee1de18h
;R04A dd 0037cb9d5h
;R04A dd 06b17f195h
;R04A dd 03431faafh
;R04A dd 013860a0dh
;R04A dd 028bca10dh
;R04A dd 00a54c011h
;R04A dd 09957cdb6h
;R04A dd 03aa1f429h
;R04A dd 09d41b7b3h
;R04A dd 09aea5be2h
;R04A dd 060c7ce6bh
;R04A dd 04cd1c10bh
;R04A dd 024ddddcdh
;R04A dd 0e28412bah
;R04A dd 0a03a5466h
;R04A dd 0a1896879h
;R04A dd 059edcb87h
;R04A dd 01b241765h
;R04A dd 0157bf161h
;R04A dd 0f219f950h
;R04A dd 0e86ff526h
;R04A dd 0262005d9h
;R04A dd 011769531h
;R04A dd 0bca15d95h
;R04A dd 028f5ef17h
;R04A dd 01f27e725h
;R04A dd 0c32631d2h
;R04A dd 007249e61h
;R04A dd 01ba851e3h
;R04A dd 04f49b577h
;R04A dd 0e2a1df5eh
;R04A dd 0826fa7ffh
;R04A dd 0c34e1e2eh
;R04A dd 07fe26024h
;R04A dd 0bc19800fh
;R04A dd 00d368dc9h
;R04A dd 0e03da0c6h
;R04A dd 0adaa4f9ch
;R04A dd 09ad1e43ch
;R04A dd 096f84e44h
;R04A dd 00b6cd695h
;R04A dd 01bb46971h
;R04A dd 0942d6e5bh
;R04A dd 06316170dh
;R04A dd 03164509fh
;R04A dd 0c6659450h
;R04A dd 0b2a0370ah
;R04A dd 0abc208e8h
;R04A dd 06d479811h
;R04A dd 03684bc0eh
;R04A dd 080b7b101h
;R04A dd 0a50b7bb5h
;R04A dd 043d21233h
;R04A dd 0b423559dh
;R04A dd 0f41dcd16h
;R04A dd 0dfd3c276h
;R04A dd 03e586469h
;R04A dd 0d9b7630ah
;R04A dd 0b88f9e44h
;R04A dd 00cda6f4dh
;R04A dd 0e5bf5844h
;R04A dd 08709f788h
;R04A dd 0dae37da6h
;R04A dd 01fb41777h
;R04A dd 01d903f69h
;R04A dd 034383b69h
;R04A dd 0d409ae70h
;R04A dd 0d1c99758h
;R04A dd 0dedfd7a4h
;R04A dd 0a4bdf018h
;R04A dd 0f4058202h
;R04A dd 08565d66fh
;R04A dd 05365aed9h
;R04A dd 0fa69742eh
;R04A dd 02cfbfbcfh
;R04A dd 088a00b60h
;R04A dd 0506c0713h
;R04A dd 02866475bh
;R04A dd 03e1df573h
;R04A dd 0b86f7febh
;R04A dd 031d23a7fh
;R04A dd 0c6320e6ah
;R04A dd 03ebbc2a5h
;R04A dd 083a1d4efh
;R04A dd 015169f5fh
;R04A dd 042a61753h
;R04A dd 0893e553eh
;R04A dd 04ddbc66dh
;R04A dd 07449ec1fh
;R04A dd 076f65d22h
;R04A dd 00622e13bh
;R04A dd 032986f89h
;R04A dd 021181b4bh
;R04A dd 099a80c0ah
;R04A dd 0d6fe00b0h
;R04A dd 0282c0e81h
;R04A dd 09fc1cf88h
;R04A dd 0919b855dh
;R04A dd 0618257d8h
;R04A dd 082c448b8h
;R04A dd 0e22537a1h
;R04A dd 0a90de388h
;R04A dd 0ba73b90ch
;R04A dd 0d765eeb0h
;R04A dd 062b2727eh
;R04A dd 0a08dfe20h
;R04A dd 070b3c8c5h
;R04A dd 03ef04007h
;R04A dd 09f73732bh
;R04A dd 02201edd7h
;R04A dd 0b836219ch
;R04A dd 0f913af7ch
;R04A dd 0f50f64cah
;R04A dd 093ac107ah
;R04A dd 0f509f84ah
;R04A dd 06f6026f6h
;R04A dd 0d9bb8each
;R04A dd 04b268cfah
;R04A dd 0a65a3fa6h
;R04A dd 09837cb75h
;R04A dd 0784fb835h
;R04A dd 02060576dh
;R04A dd 0b1604caeh
;R04A dd 0b9da4116h
;R04A dd 0ab320cf2h
;R04A dd 060a1b501h
;R04A dd 00c73fa79h
;R04A dd 08d5a6f1eh
;R04A dd 057688086h
;R04A dd 0218e4005h
;R04A dd 0ca054e3dh
;R04A dd 0c1a3c3ech
;R04 - end
;R04A - start
dd 000000001h ; Header Version
dd 000000015h ; Patch ID
dd 011241997h ; DATE
dd 000000650h ; CPUID
dd 0ffa999f3h ; Checksum
dd 000000001h ; Loader Version
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 000000000h ; reserved
dd 0a362775ah
dd 089cf893bh
dd 0556fb113h
dd 0ce9f0e72h
dd 0c2e0da2dh
dd 0469308b4h
dd 086e23c44h
dd 0d8c3b38ch
dd 041b4709ch
dd 094cf1402h
dd 0d1a20f91h
dd 042c6a9aeh
dd 0d1ba513ch
dd 0ca96104bh
dd 02e858810h
dd 0e5e5b031h
dd 0eb6507fdh
dd 00b995f61h
dd 0cf5b65a5h
dd 0a2463111h
dd 062b96d8bh
dd 0aa83e8f5h
dd 0e1bb332dh
dd 06ddbd05dh
dd 0c12c6e62h
dd 0c1c41ef1h
dd 0216b4417h
dd 0ceebc189h
dd 0a5a3cc93h
dd 005beb894h
dd 0e8241f73h
dd 0a740364dh
dd 002b31188h
dd 0c393c10bh
dd 0cf9f6649h
dd 003a6dcdah
dd 0886d3ae7h
dd 0c8f82031h
dd 042a85985h
dd 09ac7dc99h
dd 0c8953f19h
dd 0544e4973h
dd 090e7e607h
dd 0c8b9c504h
dd 017e65cf9h
dd 0d879eadfh
dd 0ed54d2e7h
dd 05c14a66bh
dd 0b356b93ch
dd 0ed5433dch
dd 05920ad10h
dd 0b7200e2bh
dd 0e2c7148ch
dd 05737bfd8h
dd 0be037c26h
dd 0c0286e5fh
dd 052029ebbh
dd 09f17483bh
dd 0c49c74b7h
dd 052c3093bh
dd 0dc0fe17bh
dd 0d22f2087h
dd 033032348h
dd 0ea6e3b9eh
dd 0f4d72873h
dd 01b45a187h
dd 0e606f99fh
dd 0f1583036h
dd 05d7450fah
dd 0e6bcd808h
dd 0b64cefc1h
dd 0700d75cfh
dd 0e7109862h
dd 095f29030h
dd 07a72feeeh
dd 0e87ce6abh
dd 0d0ef660ah
dd 07606f482h
dd 0a1dfcb22h
dd 0fbc0ca51h
dd 074a7abb4h
dd 08061aa44h
dd 0fa1cbfdfh
dd 07b61021dh
dd 0c0623123h
dd 0fd9cba62h
dd 030bdf650h
dd 0ed720e56h
dd 0f32ebb94h
dd 0133bc31fh
dd 0e0443eb1h
dd 0f569d3a5h
dd 05d6e080eh
dd 0eaea49e5h
dd 0bc90a9edh
dd 0702fda8fh
dd 0e36cdf9ch
dd 091292068h
dd 077e85b8eh
dd 0e1dac93bh
dd 0d2c200a0h
dd 07713e1f0h
dd 0a99b3d42h
dd 0f8c3fa53h
dd 07e40b61ch
dd 08089268eh
dd 0fe91baabh
dd 079cae8d7h
dd 0ca5e0193h
dd 0f5407609h
dd 03e5c8eb7h
dd 0e017debah
dd 0f79634aah
dd 019b1076ch
dd 0edaf741ah
dd 0f1248ca3h
dd 0589f4e93h
dd 0e40602c0h
dd 0b9d9fcb7h
dd 07980a799h
dd 0e0690480h
dd 097918c18h
dd 074097d81h
dd 0e91f7aaah
dd 0da9c0de7h
dd 07eeafaa4h
dd 0a39d20efh
dd 0f8b6ef54h
dd 0715ea4deh
dd 088a30677h
dd 0f605f2b4h
dd 07761edabh
dd 0caceb499h
dd 0ff7e24d0h
dd 037a84ec9h
dd 0e2680283h
dd 0fea50f3fh
dd 01461276ah
dd 0e5123fb6h
dd 0ff0a87cdh
dd 05267d2e1h
dd 0e19ae6a8h
dd 0b0e3f3fbh
dd 078424f7fh
dd 0ea35e56fh
dd 092304b19h
dd 072b7e35fh
dd 0e811b51ch
dd 0da98fcc2h
dd 07a8822f0h
dd 0a6533572h
dd 0fe9578d4h
dd 07766d101h
dd 0840def0bh
dd 0f78b3450h
dd 070422e6fh
dd 0c9a491fah
dd 0f3dbf4dah
dd 038041ce2h
dd 0eced55f4h
dd 0fcc5808ah
dd 01c647766h
dd 0e25e3857h
dd 0f47eda99h
dd 054d08c21h
dd 0e289b8f3h
dd 0b455da89h
dd 077673cbeh
dd 0e9c7f31ch
dd 09fa09b36h
dd 026313481h
dd 093db9521h
dd 0e4016735h
dd 0c0af10c7h
dd 023ff4c02h
dd 0b2c66606h
dd 0cc6accaah
dd 071c874c4h
dd 0bf2ab781h
dd 0c27fef15h
dd 07f002a17h
dd 0b8608fc2h
dd 0e2a77d70h
dd 05e532b2bh
dd 0930788d0h
dd 0c6922b46h
dd 05c1844ceh
dd 00f4a2645h
dd 0c6cd487fh
dd 0ceded61eh
dd 00c0fa9bah
dd 09f5742b1h
dd 0c82bcfd9h
dd 05480434ah
dd 095bfaa61h
dd 0c6103cc7h
dd 059d55757h
dd 09f1032eah
dd 0cbb9059dh
dd 02b30faaeh
dd 090b704bch
dd 0b61ec1cah
dd 011b8e1e8h
dd 095453991h
dd 084cee1a5h
dd 018436582h
dd 06eec1ce9h
dd 0d9b91834h
dd 0eaa7585bh
dd 03b12d40dh
dd 03f929da1h
dd 01f127347h
dd 0dc7ae9ebh
dd 0ce70f08ah
dd 0181d0044h
dd 0d4ad771ch
dd 0c6f4b4d4h
dd 0158c0026h
dd 0f6239586h
dd 0c67a92deh
dd 03aec5db9h
dd 0f975c7f8h
dd 07118ae4ah
dd 064388564h
dd 04a2bce19h
dd 027a0cf6bh
dd 0f89b3789h
dd 0f7c89dbah
dd 0b22ea3f1h
dd 0465702a6h
dd 0b43f873eh
dd 08528d209h
dd 006995707h
dd 08737d603h
dd 0ccccc062h
dd 079c2f255h
dd 0838ba96fh
dd 04f0239d3h
dd 0f295395eh
dd 0b3c38631h
dd 07ea7a143h
dd 0157a4e43h
dd 046f8173fh
dd 0fbc18d4ah
dd 0c401e17ah
dd 0c4620358h
dd 0d2ab5437h
dd 0a01db06fh
dd 058ce91fch
dd 0850de1a3h
dd 09b542dbah
dd 0ee77f038h
dd 0ddd3ced6h
dd 0c225d2ceh
dd 063a3f765h
dd 03342a06ch
dd 06a780c2fh
dd 0faa925b2h
dd 0366ebeech
dd 0bcc9abeah
dd 0c7b3fa4eh
dd 0f4f1123dh
dd 05198702ch
dd 03e3458b7h
dd 00b1ce9a1h
dd 051b1bd7fh
dd 0711e791eh
dd 0927d8bedh
dd 091dbaea9h
dd 07eefbda9h
dd 07a19edd9h
dd 0df7b8dceh
dd 05bb40613h
dd 00b0c1e0fh
dd 085b82c98h
dd 018da4dc1h
dd 0c5fd78ach
dd 057c1e31dh
dd 04c4001b5h
dd 0e31d2643h
dd 0a6afbf58h
dd 0ad200e68h
dd 0f0114ba4h
dd 0d6a620f2h
dd 0c753a720h
dd 0ac9022a0h
dd 028a41f01h
dd 022a4ba95h
dd 0c00b7531h
dd 023d42795h
dd 0cd836a86h
dd 090262708h
dd 03292cad0h
dd 040022e39h
dd 0c1581b0ah
dd 0e5101550h
dd 06538096bh
dd 0208c549dh
dd 03ce2bf88h
dd 0a71df38eh
dd 03dec3685h
dd 0ca3949f1h
dd 079f3ad1bh
dd 03ee8b300h
dd 09d305fc6h
dd 07a2e5288h
dd 0be81a2f2h
dd 07ada0c06h
dd 0191c7f01h
dd 058dfcbd1h
dd 0c78dee72h
dd 072364226h
dd 01866de12h
dd 08d22305ch
dd 0943a0f0eh
dd 0c81967ffh
dd 04d55fb0fh
dd 0af199be1h
dd 090bbda61h
dd 04e7c234fh
dd 090cfec16h
dd 09b4bcf26h
dd 021622023h
dd 00926f0fah
dd 01d504377h
dd 0a58db427h
dd 08d93ce2bh
dd 090bfe900h
dd 029e67397h
dd 02c1261edh
dd 04ace9474h
dd 0d5c60282h
dd 0e53fb300h
dd 08a61a0abh
dd 0a7aa0918h
dd 04389d7c5h
dd 0d09d605ch
dd 06c5bedb5h
dd 0d6d54c51h
dd 0433dea21h
dd 07ad9e677h
dd 0813bff76h
dd 05a162c75h
dd 01ee0661fh
dd 09b6c2030h
dd 08e8dc989h
dd 0cd4bc9fch
dd 04454675bh
dd 08d583c9ch
dd 0e3400094h
dd 0116ebb83h
dd 0e847bc9ah
dd 02a4622ddh
dd 02a901e6fh
dd 0d789b1c0h
dd 0094e2bbbh
dd 0056e563fh
dd 09f17e606h
dd 08bc79b8dh
dd 0d2c535c1h
dd 006a45a27h
dd 09dc56771h
dd 0a06649e2h
dd 05ff25ac8h
dd 06554961eh
dd 098e583d9h
dd 038ba93dah
dd 0dee1de18h
dd 0037cb9d5h
dd 06b17f195h
dd 03431faafh
dd 013860a0dh
dd 028bca10dh
dd 00a54c011h
dd 09957cdb6h
dd 03aa1f429h
dd 09d41b7b3h
dd 09aea5be2h
dd 060c7ce6bh
dd 04cd1c10bh
dd 024ddddcdh
dd 0e28412bah
dd 0a03a5466h
dd 0a1896879h
dd 059edcb87h
dd 01b241765h
dd 0157bf161h
dd 0f219f950h
dd 0e86ff526h
dd 0262005d9h
dd 011769531h
dd 0bca15d95h
dd 028f5ef17h
dd 01f27e725h
dd 0c32631d2h
dd 007249e61h
dd 01ba851e3h
dd 04f49b577h
dd 0e2a1df5eh
dd 0826fa7ffh
dd 0c34e1e2eh
dd 07fe26024h
dd 0bc19800fh
dd 00d368dc9h
dd 0e03da0c6h
dd 0adaa4f9ch
dd 09ad1e43ch
dd 096f84e44h
dd 00b6cd695h
dd 01bb46971h
dd 0942d6e5bh
dd 06316170dh
dd 03164509fh
dd 0c6659450h
dd 0b2a0370ah
dd 0abc208e8h
dd 06d479811h
dd 03684bc0eh
dd 080b7b101h
dd 0a50b7bb5h
dd 043d21233h
dd 0b423559dh
dd 0f41dcd16h
dd 0dfd3c276h
dd 03e586469h
dd 0d9b7630ah
dd 0b88f9e44h
dd 00cda6f4dh
dd 0e5bf5844h
dd 08709f788h
dd 0dae37da6h
dd 01fb41777h
dd 01d903f69h
dd 034383b69h
dd 0d409ae70h
dd 0d1c99758h
dd 0dedfd7a4h
dd 0a4bdf018h
dd 0f4058202h
dd 08565d66fh
dd 05365aed9h
dd 0fa69742eh
dd 02cfbfbcfh
dd 088a00b60h
dd 0506c0713h
dd 02866475bh
dd 03e1df573h
dd 0b86f7febh
dd 031d23a7fh
dd 0c6320e6ah
dd 03ebbc2a5h
dd 083a1d4efh
dd 015169f5fh
dd 042a61753h
dd 0893e553eh
dd 04ddbc66dh
dd 07449ec1fh
dd 076f65d22h
dd 00622e13bh
dd 032986f89h
dd 021181b4bh
dd 099a80c0ah
dd 0d6fe00b0h
dd 0282c0e81h
dd 09fc1cf88h
dd 0919b855dh
dd 0618257d8h
dd 082c448b8h
dd 0e22537a1h
dd 0a90de388h
dd 0ba73b90ch
dd 0d765eeb0h
dd 062b2727eh
dd 0a08dfe20h
dd 070b3c8c5h
dd 03ef04007h
dd 09f73732bh
dd 02201edd7h
dd 0b836219ch
dd 0f913af7ch
dd 0f50f64cah
dd 093ac107ah
dd 0f509f84ah
dd 06f6026f6h
dd 0d9bb8each
dd 04b268cfah
dd 0a65a3fa6h
dd 09837cb75h
dd 0784fb835h
dd 02060576dh
dd 0b1604caeh
dd 0b9da4116h
dd 0ab320cf2h
dd 060a1b501h
dd 00c73fa79h
dd 08d5a6f1eh
dd 057688086h
dd 0218e4005h
dd 0ca054e3dh
dd 0c1a3c3ech
;R04A - end

ifdef	BOTH_P6_KLAMATH_CPU
	include	P6_Klam.inc
endif;	BOTH_P6_KLAMATH_CPU
	
 else;	KLAMATH_CPU_ONLY 

;------------------------------------------------
;BIOS update data for P6 bug patch
;------------------------------------------------
	include	P6_Klam.inc			;R01

;R01		dd	000000001h ; Header Version
;R01		dd	0000000d1h ; Patch ID
;R01		dd	007181996h ; DATE
;R01		dd	000000619h ; CPUID
;R01		dd 	0a4bf0e1dh ; Checksum
;R01		dd	000000001h ; Loader Version
;R01		dd	000000000h ; reserved
;R01		dd	000000000h ; reserved
;R01		dd	000000000h ; reserved
;R01		dd	000000000h ; reserved
;R01		dd	000000000h ; reserved
;R01		dd	000000000h ; reserved
;R01		dd	00f0c6fd2h
;R01		dd	0e16587e5h
;R01		dd	0133bc99fh
;R01		dd	0fe747929h
;R01		dd	08e4c57f9h
;R01		dd	02b3201e3h
;R01		dd	09e7cbce8h
;R01		dd	0e6d87aabh
;R01		dd	043133c73h
;R01		dd	0afa97149h
;R01		dd	0e37f1c3dh
;R01		dd	003e480d1h
;R01		dd	0a405b973h
;R01		dd	0862ee836h
;R01		dd	01f1637a4h
;R01		dd	0d8cf9460h
;R01		dd	0e6f0dfb0h
;R01		dd	02bbd1d86h
;R01		dd	0b679562fh
;R01		dd	091d1fe8ch
;R01		dd	050790dffh
;R01		dd	0a0bb5096h
;R01		dd	0b3076b23h
;R01		dd	046c1bb43h
;R01		dd	0ff43ad23h
;R01		dd	0879ebe95h
;R01		dd	00bdf4b26h
;R01		dd	0ae340e29h
;R01		dd	0be661cfbh
;R01		dd	02b32174eh
;R01		dd	0f9ff79d8h
;R01		dd	0a72d3135h
;R01		dd	00d891f70h
;R01		dd	0e0859215h
;R01		dd	09374c0bfh
;R01		dd	07a0a1904h
;R01		dd	0c5c64c77h
;R01		dd	08fe4cf2bh
;R01		dd	033b11abch
;R01		dd	0a456e89fh
;R01		dd	09ceb78d8h
;R01		dd	04d0a4b85h
;R01		dd	0f98751ach
;R01		dd	0be2af14ch
;R01		dd	054c232a3h
;R01		dd	09619fa12h
;R01		dd	0d41cc151h
;R01		dd	0749021c1h
;R01		dd	0b9c4acceh
;R01		dd	0c9414256h
;R01		dd	036b69323h
;R01		dd	0befad26fh
;R01		dd	080148d51h
;R01		dd	049b31094h
;R01		dd	0ede7027ch
;R01		dd	08e20489eh
;R01		dd	00f5cf3a8h
;R01		dd	0e4ed52a3h
;R01		dd	0abd93043h
;R01		dd	028fa34d8h
;R01		dd	0d76d6ae7h
;R01		dd	0de769fcfh
;R01		dd	00d17af42h
;R01		dd	0fa689865h
;R01		dd	0ea151380h
;R01		dd	04c08cf42h
;R01		dd	0b4457542h
;R01		dd	087877534h
;R01		dd	007d1d2b5h
;R01		dd	0af48029eh
;R01		dd	0fef31bf6h
;R01		dd	0070c5858h
;R01		dd	09d81f9b8h
;R01		dd	0f47bea6bh
;R01		dd	011363ca2h
;R01		dd	0e5d46a9ch
;R01		dd	0fa0da86dh
;R01		dd	010ba5e98h
;R01		dd	0abb7a33bh
;R01		dd	0c290234bh
;R01		dd	04946a633h
;R01		dd	09b832940h
;R01		dd	0bdc0682ah
;R01		dd	05bf2ec01h
;R01		dd	0d7078f7ah
;R01		dd	0e08a1d7fh
;R01		dd	028469c47h
;R01		dd	0ef393f14h
;R01		dd	0ebd9f522h
;R01		dd	0127e21bah
;R01		dd	0f227036ah
;R01		dd	08ac2110ah
;R01		dd	055fcfd15h
;R01		dd	09bd9cab1h
;R01		dd	0f1f23746h
;R01		dd	07bc2efd4h
;R01		dd	0d69fffd5h
;R01		dd	0afed9badh
;R01		dd	059fb838ah
;R01		dd	0b7e996ffh
;R01		dd	0adedc7f7h
;R01		dd	0435a3ed9h
;R01		dd	0ff6e75e9h
;R01		dd	0d62d956ah
;R01		dd	0005de05dh
;R01		dd	08752c97fh
;R01		dd	0bf34befah
;R01		dd	069c1812fh
;R01		dd	0d40ab8d1h
;R01		dd	0fa51b79dh
;R01		dd	064b76e36h
;R01		dd	0df190140h
;R01		dd	0fec369a3h
;R01		dd	05dfe63c7h
;R01		dd	0ad9eae63h
;R01		dd	09f934984h
;R01		dd	031fbfcfeh
;R01		dd	0eb4dbe1fh
;R01		dd	0bc00fb4fh
;R01		dd	0402b2ed5h
;R01		dd	0b91fe2d7h
;R01		dd	0c2124badh
;R01		dd	03283a22ah
;R01		dd	08d645106h
;R01		dd	0ad43b313h
;R01		dd	03ca7312eh
;R01		dd	0aad55535h
;R01		dd	0b157cad8h
;R01		dd	050dcc6e8h
;R01		dd	0982fefa9h
;R01		dd	08bf87045h
;R01		dd	01393843ch
;R01		dd	0ce97e672h
;R01		dd	0e1fd008fh
;R01		dd	053b178e1h
;R01		dd	0cc661d72h
;R01		dd	0bf77d578h
;R01		dd	07a9d7910h
;R01		dd	0f8ffae69h
;R01		dd	0cba934edh
;R01		dd	07417a31ah
;R01		dd	0936f5853h
;R01		dd	0c2ebc9aah
;R01		dd	01f43c997h
;R01		dd	094cdffbch
;R01		dd	085bae3d4h
;R01		dd	03965bea1h
;R01		dd	0c49447bbh
;R01		dd	0d5e4c14eh
;R01		dd	0043aaa52h
;R01		dd	056e03b07h
;R01		dd	01f051193h
;R01		dd	09ea52be6h
;R01		dd	08f69df3fh
;R01		dd	0faf7adbdh
;R01		dd	0c6a49aa6h
;R01		dd	03986e553h
;R01		dd	0c4ee43f9h
;R01		dd	0ad8cd024h
;R01		dd	0b8ef3827h
;R01		dd	0d3017ae2h
;R01		dd	0636f4870h
;R01		dd	0c64f26bah
;R01		dd	008c7a493h
;R01		dd	03c248aa3h
;R01		dd	03dd4e17bh
;R01		dd	077827cbeh
;R01		dd	00c88243ch
;R01		dd	01edcd627h
;R01		dd	052b19d53h
;R01		dd	047a5644fh
;R01		dd	0c23b2061h
;R01		dd	05da4d2efh
;R01		dd	0a9761d14h
;R01		dd	0e162ab1ch
;R01		dd	0070151f4h
;R01		dd	0a4f92b1bh
;R01		dd	0c290c4ceh
;R01		dd	053e89b7bh
;R01		dd	058b2e500h
;R01		dd	097c0eed9h
;R01		dd	0c1558b8ah
;R01		dd	02de094afh
;R01		dd	0db1ce116h
;R01		dd	086955623h
;R01		dd	079a001a1h
;R01		dd	093dba9d7h
;R01		dd	022006e7fh
;R01		dd	03959223dh
;R01		dd	06fae5c3fh
;R01		dd	06c2c7049h
;R01		dd	0ffdfd832h
;R01		dd	01be6eab5h
;R01		dd	0a47b6f87h
;R01		dd	046843b98h
;R01		dd	0ea8c79f8h
;R01		dd	063fed4ebh
;R01		dd	0fd414788h
;R01		dd	081b2d620h
;R01		dd	0e67c4553h
;R01		dd	089ab5204h
;R01		dd	04d20eb13h
;R01		dd	0f70a9f22h
;R01		dd	0a9de4478h
;R01		dd	00be0a39eh
;R01		dd	0ff9356f4h
;R01		dd	04f22d623h
;R01		dd	03579ed06h
;R01		dd	03f7d682fh
;R01		dd	070c01335h
;R01		dd	0606f560ah
;R01		dd	021b4216ah
;R01		dd	022448d02h
;R01		dd	0117259f2h
;R01		dd	055f0ea0fh
;R01		dd	069e7fbcch
;R01		dd	0838ba96fh
;R01		dd	04f0239d3h
;R01		dd	0f295395eh
;R01		dd	0b3c38631h
;R01		dd	07ea7a143h
;R01		dd	0157a4e43h
;R01		dd	046f8173fh
;R01		dd	0fbc18d4ah
;R01		dd	0c401e17ah
;R01		dd	0c4620358h
;R01		dd	0d2ab5437h
;R01		dd	0a01db06fh
;R01		dd	058ce91fch
;R01		dd	0850de1a3h
;R01		dd	09b542dbah
;R01		dd	0ee77f038h
;R01		dd	0ddd3ced6h
;R01		dd	0c225d2ceh
;R01		dd	063a3f765h
;R01		dd	03342a06ch
;R01		dd	06a780c2fh
;R01		dd	0faa925b2h
;R01		dd	0366ebeech
;R01		dd	0bcc9abeah
;R01		dd	0c7b3fa4eh
;R01		dd	0f4f1123dh
;R01		dd	05198702ch
;R01		dd	03e3458b7h
;R01		dd	00b1ce9a1h
;R01		dd	051b1bd7fh
;R01		dd	0711e791eh
;R01		dd	0927d8bedh
;R01		dd	091dbaea9h
;R01		dd	07eefbda9h
;R01		dd	07a19edd9h
;R01		dd	0df7b8dceh
;R01		dd	05bb40613h
;R01		dd	00b0c1e0fh
;R01		dd	085b82c98h
;R01		dd	018da4dc1h
;R01		dd	0c5fd78ach
;R01		dd	057c1e31dh
;R01		dd	04c4001b5h
;R01		dd	0e31d2643h
;R01		dd	0a6afbf58h
;R01		dd	0ad200e68h
;R01		dd	0f0114ba4h
;R01		dd	0d6a620f2h
;R01		dd	0c753a720h
;R01		dd	0ac9022a0h
;R01		dd	028a41f01h
;R01		dd	022a4ba95h
;R01		dd	0c00b7531h
;R01		dd	023d42795h
;R01		dd	0cd836a86h
;R01		dd	090262708h
;R01		dd	03292cad0h
;R01		dd	040022e39h
;R01		dd	0c1581b0ah
;R01		dd	0e5101550h
;R01		dd	06538096bh
;R01		dd	0208c549dh
;R01		dd	03ce2bf88h
;R01		dd	0a71df38eh
;R01		dd	03dec3685h
;R01		dd	0ca3949f1h
;R01		dd	079f3ad1bh
;R01		dd	03ee8b300h
;R01		dd	09d305fc6h
;R01		dd	07a2e5288h
;R01		dd	0be81a2f2h
;R01		dd	07ada0c06h
;R01		dd	0191c7f01h
;R01		dd	058dfcbd1h
;R01		dd	0c78dee72h
;R01		dd	072364226h
;R01		dd	01866de12h
;R01		dd	08d22305ch
;R01		dd	0943a0f0eh
;R01		dd	0c81967ffh
;R01		dd	04d55fb0fh
;R01		dd	0af199be1h
;R01		dd	090bbda61h
;R01		dd	04e7c234fh
;R01		dd	090cfec16h
;R01		dd	09b4bcf26h
;R01		dd	021622023h
;R01		dd	00926f0fah
;R01		dd	01d504377h
;R01		dd	0a58db427h
;R01		dd	08d93ce2bh
;R01		dd	090bfe900h
;R01		dd	029e67397h
;R01		dd	02c1261edh
;R01		dd	04ace9474h
;R01		dd	0d5c60282h
;R01		dd	0e53fb300h
;R01		dd	08a61a0abh
;R01		dd	0a7aa0918h
;R01		dd	04389d7c5h
;R01		dd	0d09d605ch
;R01		dd	06c5bedb5h
;R01		dd	0d6d54c51h
;R01		dd	0433dea21h
;R01		dd	07ad9e677h
;R01		dd	0813bff76h
;R01		dd	05a162c75h
;R01		dd	01ee0661fh
;R01		dd	09b6c2030h
;R01		dd	08e8dc989h
;R01		dd	0cd4bc9fch
;R01		dd	04454675bh
;R01		dd	08d583c9ch
;R01		dd	0e3400094h
;R01		dd	0116ebb83h
;R01		dd	0e847bc9ah
;R01		dd	02a4622ddh
;R01		dd	02a901e6fh
;R01		dd	0d789b1c0h
;R01		dd	0094e2bbbh
;R01		dd	0056e563fh
;R01		dd	09f17e606h
;R01		dd	08bc79b8dh
;R01		dd	0d2c535c1h
;R01		dd	006a45a27h
;R01		dd	09dc56771h
;R01		dd	0a06649e2h
;R01		dd	05ff25ac8h
;R01		dd	06554961eh
;R01		dd	098e583d9h
;R01		dd	038ba93dah
;R01		dd	0dee1de18h
;R01		dd	0037cb9d5h
;R01		dd	06b17f195h
;R01		dd	03431faafh
;R01		dd	013860a0dh
;R01		dd	028bca10dh
;R01		dd	00a54c011h
;R01		dd	09957cdb6h
;R01		dd	03aa1f429h
;R01		dd	09d41b7b3h
;R01		dd	09aea5be2h
;R01		dd	060c7ce6bh
;R01		dd	04cd1c10bh
;R01		dd	024ddddcdh
;R01		dd	0e28412bah
;R01		dd	0a03a5466h
;R01		dd	0a1896879h
;R01		dd	059edcb87h
;R01		dd	01b241765h
;R01		dd	0157bf161h
;R01		dd	0f219f950h
;R01		dd	0e86ff526h
;R01		dd	0262005d9h
;R01		dd	011769531h
;R01		dd	0bca15d95h
;R01		dd	028f5ef17h
;R01		dd	01f27e725h
;R01		dd	0c32631d2h
;R01		dd	007249e61h
;R01		dd	01ba851e3h
;R01		dd	04f49b577h
;R01		dd	0e2a1df5eh
;R01		dd	0826fa7ffh
;R01		dd	0c34e1e2eh
;R01		dd	07fe26024h
;R01		dd	0bc19800fh
;R01		dd	00d368dc9h
;R01		dd	0e03da0c6h
;R01		dd	0adaa4f9ch
;R01		dd	09ad1e43ch
;R01		dd	096f84e44h
;R01		dd	00b6cd695h
;R01		dd	01bb46971h
;R01		dd	0942d6e5bh
;R01		dd	06316170dh
;R01		dd	03164509fh
;R01		dd	0c6659450h
;R01		dd	0b2a0370ah
;R01		dd	0abc208e8h
;R01		dd	06d479811h
;R01		dd	03684bc0eh
;R01		dd	080b7b101h
;R01		dd	0a50b7bb5h
;R01		dd	043d21233h
;R01		dd	0b423559dh
;R01		dd	0f41dcd16h
;R01		dd	0dfd3c276h
;R01		dd	03e586469h
;R01		dd	0d9b7630ah
;R01		dd	0b88f9e44h
;R01		dd	00cda6f4dh
;R01		dd	0e5bf5844h
;R01		dd	08709f788h
;R01		dd	0dae37da6h
;R01		dd	01fb41777h
;R01		dd	01d903f69h
;R01		dd	034383b69h
;R01		dd	0d409ae70h
;R01		dd	0d1c99758h
;R01		dd	0dedfd7a4h
;R01		dd	0a4bdf018h
;R01		dd	0f4058202h
;R01		dd	08565d66fh
;R01		dd	05365aed9h
;R01		dd	0fa69742eh
;R01		dd	02cfbfbcfh
;R01		dd	088a00b60h
;R01		dd	0506c0713h
;R01		dd	02866475bh
;R01		dd	03e1df573h
;R01		dd	0b86f7febh
;R01		dd	031d23a7fh
;R01		dd	0c6320e6ah
;R01		dd	03ebbc2a5h
;R01		dd	083a1d4efh
;R01		dd	015169f5fh
;R01		dd	042a61753h
;R01		dd	0893e553eh
;R01		dd	04ddbc66dh
;R01		dd	07449ec1fh
;R01		dd	076f65d22h
;R01		dd	00622e13bh
;R01		dd	032986f89h
;R01		dd	021181b4bh
;R01		dd	099a80c0ah
;R01		dd	0d6fe00b0h
;R01		dd	0282c0e81h
;R01		dd	09fc1cf88h
;R01		dd	0919b855dh
;R01		dd	0618257d8h
;R01		dd	082c448b8h
;R01		dd	0e22537a1h
;R01		dd	0a90de388h
;R01		dd	0ba73b90ch
;R01		dd	0d765eeb0h
;R01		dd	062b2727eh
;R01		dd	0a08dfe20h
;R01		dd	070b3c8c5h
;R01		dd	03ef04007h
;R01		dd	09f73732bh
;R01		dd	02201edd7h
;R01		dd	0b836219ch
;R01		dd	0f913af7ch
;R01		dd	0f50f64cah
;R01		dd	093ac107ah
;R01		dd	0f509f84ah
;R01		dd	06f6026f6h
;R01		dd	0d9bb8each
;R01		dd	04b268cfah
;R01		dd	0a65a3fa6h
;R01		dd	09837cb75h
;R01		dd	0784fb835h
;R01		dd	02060576dh
;R01		dd	0b1604caeh
;R01		dd	0b9da4116h
;R01		dd	0ab320cf2h
;R01		dd	060a1b501h
;R01		dd	00c73fa79h
;R01		dd	08d5a6f1eh
;R01		dd	057688086h
;R01		dd	0218e4005h
;R01		dd	0ca054e3dh
;R01		dd	0c1a3c3ech
;R01		dd	0278cb2c0h
;R01		dd	0f41d6be8h
;R01		dd	0839b9b57h
;R01		dd	0de7df900h
;R01		dd	0a6d05386h
;R01		dd	0f79d8944h
;R01		dd	024d4273dh
;R01		dd	0878456feh
;R01		dd	0bc0006e2h
;R01		dd	04cbc49c5h
;R01		dd	016684d87h
;R01		dd	01f2c79a5h
;R01		dd	0847dc8fbh
;R01		dd	0e873c43ah
;R01		dd	0c92223f2h
;R01		dd	0c9c193d4h
;R01		dd	08f43d21dh
;R01		dd	0c723f894h
;R01		dd	0a0ed9e53h
;R01		dd	0d0693391h
;R01
;R01;BIOS update for CPUID 0616 H
;R01 dd 000000001h ; Header Version
;R01 dd 0000000c5h ; Patch ID
;R01 dd 001251995h ; DATE
;R01 
;R01 dd 000000616h ; CPUID
;R01 dd 0c269adc4h ; Checksum
;R01 dd 000000001h ; Loader Version
;R01 dd 000000000h ; reserved
;R01 dd 000000000h ; reserved
;R01 dd 000000000h ; reserved
;R01 dd 000000000h ; reserved
;R01 dd 000000000h ; reserved
;R01 dd 000000000h ; reserved
;R01 dd 0f2a8b5f2h
;R01 dd 0b9212259h
;R01 dd 0ccf5b994h
;R01 dd 04401a59ch
;R01 dd 0c4a0a7c5h
;R01 dd 0c4d91fc3h
;R01 dd 01e13609ch
;R01 dd 084945650h
;R01 dd 0daea7f5ch
;R01 dd 05dbc7b0dh
;R01 dd 0cd435568h
;R01 dd 0c7f51887h
;R01 dd 01833accch
;R01 dd 09d1d7cfah
;R01 dd 0e50189c0h
;R01 dd 05e730b26h
;R01 dd 0b311924dh
;R01 dd 0e75412e4h
;R01 dd 0542c15b8h
;R01 dd 0b83a9255h
;R01 dd 0af1491abh
;R01 dd 0106c1e26h
;R01 dd 0fb49dbe4h
;R01 dd 0e3b5c4c5h
;R01 dd 017018ff6h
;R01 dd 0abad9dd9h
;R01 dd 0ea3b2123h
;R01 dd 0636355deh
;R01 dd 082c46957h
;R01 dd 0ce478de7h
;R01 dd 0400b0286h
;R01 dd 0c18398a1h
;R01 dd 0c511f5a6h
;R01 dd 011e39e52h
;R01 dd 0b9a8ee2bh
;R01 dd 0f77b8095h
;R01 dd 06b4ddde8h
;R01 dd 091edc28dh
;R01 dd 0fd659b88h
;R01 dd 060006706h
;R01 dd 0aedbc1eah
;R01 dd 0dec39a40h
;R01 dd 0038b36c9h
;R01 dd 0ef97a967h
;R01 dd 08b6d7a04h
;R01 dd 06fb554b7h
;R01 dd 0e6bd8028h
;R01 dd 08e865a1fh
;R01 dd 0688a857bh
;R01 dd 0c7517cc9h
;R01 dd 08a418ccch
;R01 dd 008224893h
;R01 dd 0c596e88ah
;R01 dd 0d650552eh
;R01 dd 019f264d8h
;R01 dd 0ceb01c6fh
;R01 dd 098048ab2h
;R01 dd 02df1d5f6h
;R01 dd 09141b123h
;R01 dd 0b37e6c54h
;R01 dd 06b2f50a1h
;R01 dd 09309b569h
;R01 dd 0f7cac4c1h
;R01 dd 043e9f4f4h
;R01 dd 0945bd7b1h
;R01 dd 09733c154h
;R01 dd 05eba3b1dh
;R01 dd 0cdc27fbah
;R01 dd 085b049b8h
;R01 dd 05dc48106h
;R01 dd 095741a8ch
;R01 dd 0b8d462e8h
;R01 dd 01bdae141h
;R01 dd 09f8b7a87h
;R01 dd 0ee049aa8h
;R01 dd 025d8add8h
;R01 dd 0de6b08b0h
;R01 dd 0a0f34c3bh
;R01 dd 066e853afh
;R01 dd 08e8285e4h
;R01 dd 0e5a1be68h
;R01 dd 07b7322fdh
;R01 dd 083b8bff5h
;R01 dd 0e6562404h
;R01 dd 05ba1c73ah
;R01 dd 091b97d6ch
;R01 dd 0c1a4da2dh
;R01 dd 05bc547f8h
;R01 dd 09be4bd87h
;R01 dd 0ce79a807h
;R01 dd 040d2e26bh
;R01 dd 0da181a39h
;R01 dd 0d9f09817h
;R01 dd 0030d9e0bh
;R01 dd 0dae1de4ch
;R01 dd 0c1f68294h
;R01 dd 0307d393bh
;R01 dd 0d873e0a6h
;R01 dd 0dd86cfc3h
;R01 dd 022ec1ca7h
;R01 dd 0f01c002ah
;R01 dd 097597681h
;R01 dd 03ef621b0h
;R01 dd 0bc7bef1ch
;R01 dd 097183528h
;R01 dd 01e1f4a57h
;R01 dd 0a078a911h
;R01 dd 0bfd0aca3h
;R01 dd 0170025e1h
;R01 dd 0a902c40bh
;R01 dd 0ac2e8f3ch
;R01 dd 004726b4bh
;R01 dd 0996e9e3ch
;R01 dd 0b734c576h
;R01 dd 02ef6fc2dh
;R01 dd 09259813eh
;R01 dd 0bd11bac6h
;R01 dd 032d0f42ah
;R01 dd 0bb0f6741h
;R01 dd 0808ef71fh
;R01 dd 011b01dcbh
;R01 dd 098869197h
;R01 dd 087167453h
;R01 dd 0109f329ah
;R01 dd 087d89348h
;R01 dd 08a756938h
;R01 dd 024afbf33h
;R01 dd 0871de5cdh
;R01 dd 0a9381d49h
;R01 dd 0207e5476h
;R01 dd 08199f0dah
;R01 dd 0bf25fde3h
;R01 dd 06024c1cdh
;R01 dd 0b462aedch
;R01 dd 0f6685d31h
;R01 dd 046b0d2f2h
;R01 dd 0b80b99eah
;R01 dd 0f8129719h
;R01 dd 05da73d3dh
;R01 dd 09f790244h
;R01 dd 0c100e0a9h
;R01 dd 07c72544ah
;R01 dd 0b95a04abh
;R01 dd 0c73675cbh
;R01 dd 078a6f90ah
;R01 dd 0a864cd9dh
;R01 dd 0d0eec3e5h
;R01 dd 048f2b812h
;R01 dd 0b2eeccd6h
;R01 dd 0f8a81dd0h
;R01 dd 0f4afa660h
;R01 dd 067b52865h
;R01 dd 0baa7ee0ch
;R01 dd 040e21e0dh
;R01 dd 00587e7e8h
;R01 dd 0f8558340h
;R01 dd 0b00912a4h
;R01 dd 04fa8ba94h
;R01 dd 0fad9acbdh
;R01 dd 001b4a804h
;R01 dd 04d623296h
;R01 dd 04136417eh
;R01 dd 03896fd28h
;R01 dd 0b8746b02h
;R01 dd 070d4c573h
;R01 dd 0cd2495fdh
;R01 dd 0802c0502h
;R01 dd 03999b352h
;R01 dd 0f37c15a6h
;R01 dd 0cdb96b97h
;R01 dd 00060ff8bh
;R01 dd 0ae3e9bfeh
;R01 dd 0f4a2e944h
;R01 dd 058e36c4ch
;R01 dd 0b9bbeb99h
;R01 dd 0320274dah
;R01 dd 04cc4e651h
;R01 dd 0709f92a3h
;R01 dd 0089d20edh
;R01 dd 08031fff0h
;R01 dd 047a4909eh
;R01 dd 0c0cd7682h
;R01 dd 088173ff9h
;R01 dd 024510df8h
;R01 dd 0c546da67h
;R01 dd 0e675fe0eh
;R01 dd 020618617h
;R01 dd 09bd216a1h
;R01 dd 0e4cc5e9dh
;R01 dd 072e3a0e5h
;R01 dd 0949d9892h
;R01 dd 07b928c5ch
;R01 dd 07ebde0e4h
;R01 dd 0080aa401h
;R01 dd 0043b486ch
;R01 dd 0d36dfa00h
;R01 dd 07a29be1ch
;R01 dd 0a6d5f31eh
;R01 dd 06932c2c2h
;R01 dd 07af549f7h
;R01 dd 015e313abh
;R01 dd 06f6b2107h
;R01 dd 0690d771eh
;R01 dd 0d297da48h
;R01 dd 071c13341h
;R01 dd 0ae87a31bh
;R01 dd 0cd7d47fch
;R01 dd 020923428h
;R01 dd 0b58c6162h
;R01 dd 09bb61dafh
;R01 dd 04afb1542h
;R01 dd 0b1a0b563h
;R01 dd 0f9b51ebah
;R01 dd 04cad7a7ch
;R01 dd 0ef1f07b8h
;R01 dd 06f8354cbh
;R01 dd 0d1ede753h
;R01 dd 036b17c47h
;R01 dd 0838ba96fh
;R01 dd 04f0239d3h
;R01 dd 0f295395eh
;R01 dd 0b3c38631h
;R01 dd 07ea7a143h
;R01 dd 0157a4e43h
;R01 dd 046f8173fh
;R01 dd 0fbc18d4ah
;R01 dd 0c401e17ah
;R01 dd 0c4620358h
;R01 dd 0d2ab5437h
;R01 dd 0a01db06fh
;R01 dd 058ce91fch
;R01 dd 0850de1a3h
;R01 dd 09b542dbah
;R01 dd 0ee77f038h
;R01 dd 0ddd3ced6h
;R01 dd 0c225d2ceh
;R01 dd 063a3f765h
;R01 dd 03342a06ch
;R01 dd 06a780c2fh
;R01 dd 0faa925b2h
;R01 dd 0366ebeech
;R01 dd 0bcc9abeah
;R01 dd 0c7b3fa4eh
;R01 dd 0f4f1123dh
;R01 dd 05198702ch
;R01 dd 03e3458b7h
;R01 dd 00b1ce9a1h
;R01 dd 051b1bd7fh
;R01 dd 0711e791eh
;R01 dd 0927d8bedh
;R01 dd 091dbaea9h
;R01 dd 07eefbda9h
;R01 dd 07a19edd9h
;R01 dd 0df7b8dceh
;R01 dd 05bb40613h
;R01 dd 00b0c1e0fh
;R01 dd 085b82c98h
;R01 dd 018da4dc1h
;R01 dd 0c5fd78ach
;R01 dd 057c1e31dh
;R01 dd 04c4001b5h
;R01 dd 0e31d2643h
;R01 dd 0a6afbf58h
;R01 dd 0ad200e68h
;R01 dd 0f0114ba4h
;R01 dd 0d6a620f2h
;R01 dd 0c753a720h
;R01 dd 0ac9022a0h
;R01 dd 028a41f01h
;R01 dd 022a4ba95h
;R01 dd 0c00b7531h
;R01 dd 023d42795h
;R01 dd 0cd836a86h
;R01 dd 090262708h
;R01 dd 03292cad0h
;R01 dd 040022e39h
;R01 dd 0c1581b0ah
;R01 dd 0e5101550h
;R01 dd 06538096bh
;R01 dd 0208c549dh
;R01 dd 03ce2bf88h
;R01 dd 0a71df38eh
;R01 dd 03dec3685h
;R01 dd 0ca3949f1h
;R01 dd 079f3ad1bh
;R01 dd 03ee8b300h
;R01 dd 09d305fc6h
;R01 dd 07a2e5288h
;R01 dd 0be81a2f2h
;R01 dd 07ada0c06h
;R01 dd 0191c7f01h
;R01 dd 058dfcbd1h
;R01 dd 0c78dee72h
;R01 dd 072364226h
;R01 dd 01866de12h
;R01 dd 08d22305ch
;R01 dd 0943a0f0eh
;R01 dd 0c81967ffh
;R01 dd 04d55fb0fh
;R01 dd 0af199be1h
;R01 dd 090bbda61h
;R01 dd 04e7c234fh
;R01 dd 090cfec16h
;R01 dd 09b4bcf26h
;R01 dd 021622023h
;R01 dd 00926f0fah
;R01 dd 01d504377h
;R01 dd 0a58db427h
;R01 dd 08d93ce2bh
;R01 dd 090bfe900h
;R01 dd 029e67397h
;R01 dd 02c1261edh
;R01 dd 04ace9474h
;R01 dd 0d5c60282h
;R01 dd 0e53fb300h
;R01 dd 08a61a0abh
;R01 dd 0a7aa0918h
;R01 dd 04389d7c5h
;R01 dd 0d09d605ch
;R01 dd 06c5bedb5h
;R01 dd 0d6d54c51h
;R01 dd 0433dea21h
;R01 dd 07ad9e677h
;R01 dd 0813bff76h
;R01 dd 05a162c75h
;R01 dd 01ee0661fh
;R01 dd 09b6c2030h
;R01 dd 08e8dc989h
;R01 dd 0cd4bc9fch
;R01 dd 04454675bh
;R01 dd 08d583c9ch
;R01 dd 0e3400094h
;R01 dd 0116ebb83h
;R01 dd 0e847bc9ah
;R01 dd 02a4622ddh
;R01 dd 02a901e6fh
;R01 dd 0d789b1c0h
;R01 dd 0094e2bbbh
;R01 dd 0056e563fh
;R01 dd 09f17e606h
;R01 dd 08bc79b8dh
;R01 dd 0d2c535c1h
;R01 dd 006a45a27h
;R01 dd 09dc56771h
;R01 dd 0a06649e2h
;R01 dd 05ff25ac8h
;R01 dd 06554961eh
;R01 dd 098e583d9h
;R01 dd 038ba93dah
;R01 dd 0dee1de18h
;R01 dd 0037cb9d5h
;R01 dd 06b17f195h
;R01 dd 03431faafh
;R01 dd 013860a0dh
;R01 dd 028bca10dh
;R01 dd 00a54c011h
;R01 dd 09957cdb6h
;R01 dd 03aa1f429h
;R01 dd 09d41b7b3h
;R01 dd 09aea5be2h
;R01 dd 060c7ce6bh
;R01 dd 04cd1c10bh
;R01 dd 024ddddcdh
;R01 dd 0e28412bah
;R01 dd 0a03a5466h
;R01 dd 0a1896879h
;R01 dd 059edcb87h
;R01 dd 01b241765h
;R01 dd 0157bf161h
;R01 dd 0f219f950h
;R01 dd 0e86ff526h
;R01 dd 0262005d9h
;R01 dd 011769531h
;R01 dd 0bca15d95h
;R01 dd 028f5ef17h
;R01 dd 01f27e725h
;R01 dd 0c32631d2h
;R01 dd 007249e61h
;R01 dd 01ba851e3h
;R01 dd 04f49b577h
;R01 dd 0e2a1df5eh
;R01 dd 0826fa7ffh
;R01 dd 0c34e1e2eh
;R01 dd 07fe26024h
;R01 dd 0bc19800fh
;R01 dd 00d368dc9h
;R01 dd 0e03da0c6h
;R01 dd 0adaa4f9ch
;R01 dd 09ad1e43ch
;R01 dd 096f84e44h
;R01 dd 00b6cd695h
;R01 dd 01bb46971h
;R01 dd 0942d6e5bh
;R01 dd 06316170dh
;R01 dd 03164509fh
;R01 dd 0c6659450h
;R01 dd 0b2a0370ah
;R01 dd 0abc208e8h
;R01 dd 06d479811h
;R01 dd 03684bc0eh
;R01 dd 080b7b101h
;R01 dd 0a50b7bb5h
;R01 dd 043d21233h
;R01 dd 0b423559dh
;R01 dd 0f41dcd16h
;R01 dd 0dfd3c276h
;R01 dd 03e586469h
;R01 dd 0d9b7630ah
;R01 dd 0b88f9e44h
;R01 dd 00cda6f4dh
;R01 dd 0e5bf5844h
;R01 dd 08709f788h
;R01 dd 0dae37da6h
;R01 dd 01fb41777h
;R01 dd 01d903f69h
;R01 dd 034383b69h
;R01 dd 0d409ae70h
;R01 dd 0d1c99758h
;R01 dd 0dedfd7a4h
;R01 dd 0a4bdf018h
;R01 dd 0f4058202h
;R01 dd 08565d66fh
;R01 dd 05365aed9h
;R01 dd 0fa69742eh
;R01 dd 02cfbfbcfh
;R01 dd 088a00b60h
;R01 dd 0506c0713h
;R01 dd 02866475bh
;R01 dd 03e1df573h
;R01 dd 0b86f7febh
;R01 dd 031d23a7fh
;R01 dd 0c6320e6ah
;R01 dd 03ebbc2a5h
;R01 dd 083a1d4efh
;R01 dd 015169f5fh
;R01 dd 042a61753h
;R01 dd 0893e553eh
;R01 dd 04ddbc66dh
;R01 dd 07449ec1fh
;R01 dd 076f65d22h
;R01 dd 00622e13bh
;R01 dd 032986f89h
;R01 dd 021181b4bh
;R01 dd 099a80c0ah
;R01 dd 0d6fe00b0h
;R01 dd 0282c0e81h
;R01 dd 09fc1cf88h
;R01 dd 0919b855dh
;R01 dd 0618257d8h
;R01 dd 082c448b8h
;R01 dd 0e22537a1h
;R01 dd 0a90de388h
;R01 dd 0ba73b90ch
;R01 dd 0d765eeb0h
;R01 dd 062b2727eh
;R01 dd 0a08dfe20h
;R01 dd 070b3c8c5h
;R01 dd 03ef04007h
;R01 dd 09f73732bh
;R01 dd 02201edd7h
;R01 dd 0b836219ch
;R01 dd 0f913af7ch
;R01 dd 0f50f64cah
;R01 dd 093ac107ah
;R01 dd 0f509f84ah
;R01 dd 06f6026f6h
;R01 dd 0d9bb8each
;R01 dd 04b268cfah
;R01 dd 0a65a3fa6h
;R01 dd 09837cb75h
;R01 dd 0784fb835h
;R01 dd 02060576dh
;R01 dd 0b1604caeh
;R01 dd 0b9da4116h
;R01 dd 0ab320cf2h
;R01 dd 060a1b501h
;R01 dd 00c73fa79h
;R01 dd 08d5a6f1eh
;R01 dd 057688086h
;R01 dd 0218e4005h
;R01 dd 0ca054e3dh
;R01 dd 0c1a3c3ech
;R01 dd 0278cb2c0h
;R01 dd 0f41d6be8h
;R01 dd 0839b9b57h
;R01 dd 0de7df900h
;R01 dd 0a6d05386h
;R01 dd 0f79d8944h
;R01 dd 024d4273dh
;R01 dd 0878456feh
;R01 dd 0bc0006e2h
;R01 dd 04cbc49c5h
;R01 dd 016684d87h
;R01 dd 01f2c79a5h
;R01 dd 0847dc8fbh
;R01 dd 0e873c43ah
;R01 dd 0c92223f2h
;R01 dd 0c9c193d4h
;R01 dd 08f43d21dh
;R01 dd 0c723f894h
;R01
;R01;BIOS update for CPUID 0612h
;R01		dd	000000001h
;R01		dd	0000000C5h
;R01		dd	001051996h
;R01		dd	000000612h
;R01		dd	07C68ED35h
;R01		dd	000000001h
;R01		dd	000000000h
;R01		dd	000000000h
;R01		dd	000000000h
;R01		dd	000000000h
;R01		dd	000000000h
;R01		dd	000000000h
;R01		dd	0C2804CEEh
;R01		dd	019DD48ADh
;R01		dd	0F9323817h
;R01		dd	00AAAA4E7h
;R01		dd	0B607F157h
;R01		dd	035751513h
;R01		dd	0CE869697h
;R01		dd	0B3ABC0E6h
;R01		dd	099813BDBh
;R01		dd	0E86717E8h
;R01		dd	056064FD4h
;R01		dd	0C14CC7E8h
;R01		dd	0EE8948C4h
;R01		dd	07A90A89Ah
;R01		dd	0506A6F2Ch
;R01		dd	03E8DF5E5h
;R01		dd	0A2DB15B4h
;R01		dd	0F9CDA0F3h
;R01		dd	0BEAD992Bh
;R01		dd	0CA0D023Dh
;R01		dd	0A338274Ch
;R01		dd	0668401B0h
;R01		dd	0FE943AB1h
;R01		dd	0F4EC0E87h
;R01		dd	0BE4C1857h
;R01		dd	04DD69F6Dh
;R01		dd	0FB344F78h
;R01		dd	0977D4A93h
;R01		dd	0B4074DE9h
;R01		dd	0C86BC5D0h
;R01		dd	046E0F2F7h
;R01		dd	0A92AC068h
;R01		dd	090F55479h
;R01		dd	0CD2A8B7Ch
;R01		dd	0EB158731h
;R01		dd	017CEB3C6h
;R01		dd	08E85E5A8h
;R01		dd	013823F4Fh
;R01		dd	06CCBA6C2h
;R01		dd	0C786FEC5h
;R01		dd	042005B2Eh
;R01		dd	07C167CC6h
;R01		dd	0BC0759A3h
;R01		dd	0A75BABFCh
;R01		dd	031AF9906h
;R01		dd	07697870Fh
;R01		dd	0F3201FD8h
;R01		dd	0494240C3h
;R01		dd	0B7D748E0h
;R01		dd	0079F0873h
;R01		dd	03565FEDAh
;R01		dd	0F0C7EE53h
;R01		dd	014F4207Ch
;R01		dd	0E91D2A07h
;R01		dd	0647023F0h
;R01		dd	0A7B780F8h
;R01		dd	06C92624Ch
;R01		dd	0C1592027h
;R01		dd	04070025Dh
;R01		dd	09CBB46E0h
;R01		dd	05731ED7Ch
;R01		dd	061E21EAAh
;R01		dd	02E2ED780h
;R01		dd	0FBB93407h
;R01		dd	0D21E96BEh
;R01		dd	070D90523h
;R01		dd	0FA76E29Ah
;R01		dd	03E6F4423h
;R01		dd	0DCEF9C76h
;R01		dd	0900F34F4h
;R01		dd	0D7412759h
;R01		dd	00071B41Ah
;R01		dd	02837648Ah
;R01		dd	05B96E26Ch
;R01		dd	0DFD22F24h
;R01		dd	01BCB5062h
;R01		dd	010FC9F99h
;R01		dd	0B8349A49h
;R01		dd	0CA26B01Dh
;R01		dd	03D7CD831h
;R01		dd	0BEC8C96Ch
;R01		dd	01FE76310h
;R01		dd	0B58467FAh
;R01		dd	096BBF5E8h
;R01		dd	0110BE882h
;R01		dd	0EB9C22D1h
;R01		dd	000F15E5Dh
;R01		dd	05DE71E4Fh
;R01		dd	0699D9D76h
;R01		dd	0ED392AB5h
;R01		dd	01EAA596Ah
;R01		dd	07394F90Ah
;R01		dd	08B21C650h
;R01		dd	094D2FAF5h
;R01		dd	096AF3672h
;R01		dd	01CA52684h
;R01		dd	09EDD100Eh
;R01		dd	06D91480Fh
;R01		dd	084F1996Ah
;R01		dd	05A697A48h
;R01		dd	085A2D0ECh
;R01		dd	08A51D513h
;R01		dd	00AE3E65Ch
;R01		dd	0F079A44Ch
;R01		dd	026677825h
;R01		dd	041399A92h
;R01		dd	09C534A64h
;R01		dd	0D433DEE1h
;R01		dd	084925770h
;R01		dd	05A4444FEh
;R01		dd	01CEEE8F9h
;R01		dd	0F4B50E51h
;R01		dd	008EA6503h
;R01		dd	0A3B8209Dh
;R01		dd	0E56A8D13h
;R01		dd	034CB1C54h
;R01		dd	0C9359877h
;R01		dd	03FFCEC34h
;R01		dd	00D3F5E25h
;R01		dd	01460671Bh
;R01		dd	04B9E31B8h
;R01		dd	05939D045h
;R01		dd	04546337Ch
;R01		dd	06D500E41h
;R01		dd	0672339F3h
;R01		dd	0AF392192h
;R01		dd	01D43513Bh
;R01		dd	057FEB023h
;R01		dd	06A79A098h
;R01		dd	07E6ED089h
;R01		dd	0BFBF8B4Ah
;R01		dd	0F8829C9Eh
;R01		dd	0F83D98FBh
;R01		dd	08BB32C68h
;R01		dd	0CE77F6BEh
;R01		dd	08ADF8647h
;R01		dd	0606D8715h
;R01		dd	023DC9DD7h
;R01		dd	01B1AD0C5h
;R01		dd	0642E5C68h
;R01		dd	0ADECB822h
;R01		dd	0EEF00B82h
;R01		dd	0F8821782h
;R01		dd	05D44C666h
;R01		dd	09DCACC20h
;R01		dd	0B3A47D27h
;R01		dd	0B950F856h
;R01		dd	080EAE891h
;R01		dd	0DBE8FD6Fh
;R01		dd	01C580456h
;R01		dd	07BA8FF92h
;R01		dd	07F113F5Dh
;R01		dd	064642FC9h
;R01		dd	04EE7533Dh
;R01		dd	08FB095BAh
;R01		dd	022F95308h
;R01		dd	08CF8CC78h
;R01		dd	074F13153h
;R01		dd	0EC9A5746h
;R01		dd	0EFD116A4h
;R01		dd	04349C434h
;R01		dd	0DEE52E4Ah
;R01		dd	047CF4567h
;R01		dd	0C0F68EFAh
;R01		dd	063DBFCE7h
;R01		dd	05F8A8EF7h
;R01		dd	0E591DD02h
;R01		dd	0636EC232h
;R01		dd	0FC11EC9Ah
;R01		dd	04D617E27h
;R01		dd	0ABDCFD6Ch
;R01		dd	0E6602CA8h
;R01		dd	03BAAA7DEh
;R01		dd	0D2145197h
;R01		dd	02A4DD53Fh
;R01		dd	0B6E30679h
;R01		dd	0DC170F85h
;R01		dd	03A2EC963h
;R01		dd	0CEDA6BA3h
;R01		dd	07B3454AAh
;R01		dd	0E9C2AFE7h
;R01		dd	0D15736E0h
;R01		dd	0AB8A5EF4h
;R01		dd	01607FD5Bh
;R01		dd	0AE5AD2AEh
;R01		dd	04573940Ch
;R01		dd	045CE7375h
;R01		dd	0F9A460FFh
;R01		dd	09542861Ch
;R01		dd	012D434D6h
;R01		dd	0CBC29D49h
;R01		dd	034765CBBh
;R01		dd	0C5AA9D24h
;R01		dd	0888B8283h
;R01		dd	07491A902h
;R01		dd	0A29D5036h
;R01		dd	0707EC0A3h
;R01		dd	0747E9DF3h
;R01		dd	004F76353h
;R01		dd	0207DCC09h
;R01		dd	00A39C0D8h
;R01		dd	01C476685h
;R01		dd	025E370F0h
;R01		dd	00C257B0Ah
;R01		dd	054FC418Ch
;R01		dd	0B259628Ah
;R01		dd	096174408h
;R01		dd	0475D5D92h
;R01		dd	0D5306B18h
;R01		dd	0543E21A0h
;R01		dd	0CF72C033h
;R01		dd	06F6E4EC2h
;R01		dd	046A73E69h
;R01		dd	00318EAACh
;R01		dd	0AC3AA681h
;R01		dd	08A00920Bh
;R01		dd	0838BA96Fh
;R01		dd	04F0239D3h
;R01		dd	0F295395Eh
;R01		dd	0B3C38631h
;R01		dd	07EA7A143h
;R01		dd	0157A4E43h
;R01		dd	046F8173Fh
;R01		dd	0FBC18D4Ah
;R01		dd	0C401E17Ah
;R01		dd	0C4620358h
;R01		dd	0D2AB5437h
;R01		dd	0A01DB06Fh
;R01		dd	058CE91FCh
;R01		dd	0850DE1A3h
;R01		dd	09B542DBAh
;R01		dd	0EE77F038h
;R01		dd	0DDD3CED6h
;R01		dd	0C225D2CEh
;R01		dd	063A3F765h
;R01		dd	03342A06Ch
;R01		dd	06A780C2Fh
;R01		dd	0FAA925B2h
;R01		dd	0366EBEECh
;R01		dd	0BCC9ABEAh
;R01		dd	0C7B3FA4Eh
;R01		dd	0F4F1123Dh
;R01		dd	05198702Ch
;R01		dd	03E3458B7h
;R01		dd	00B1CE9A1h
;R01		dd	051B1BD7Fh
;R01		dd	0711E791Eh
;R01		dd	0927D8BEDh
;R01		dd	091DBAEA9h
;R01		dd	07EEFBDA9h
;R01		dd	07A19EDD9h
;R01		dd	0DF7B8DCEh
;R01		dd	05BB40613h
;R01		dd	00B0C1E0Fh
;R01		dd	085B82C98h
;R01		dd	018DA4DC1h
;R01		dd	0C5FD78ACh
;R01		dd	057C1E31Dh
;R01		dd	04C4001B5h
;R01		dd	0E31D2643h
;R01		dd	0A6AFBF58h
;R01		dd	0AD200E68h
;R01		dd	0F0114BA4h
;R01		dd	0D6A620F2h
;R01		dd	0C753A720h
;R01		dd	0AC9022A0h
;R01		dd	028A41F01h
;R01		dd	022A4BA95h
;R01		dd	0C00B7531h
;R01		dd	023D42795h
;R01		dd	0CD836A86h
;R01		dd	090262708h
;R01		dd	03292CAD0h
;R01		dd	040022E39h
;R01		dd	0C1581B0Ah
;R01		dd	0E5101550h
;R01		dd	06538096Bh
;R01		dd	0208C549Dh
;R01		dd	03CE2BF88h
;R01		dd	0A71DF38Eh
;R01		dd	03DEC3685h
;R01		dd	0CA3949F1h
;R01		dd	079F3AD1Bh
;R01		dd	03EE8B300h
;R01		dd	09D305FC6h
;R01		dd	07A2E5288h
;R01		dd	0BE81A2F2h
;R01		dd	07ADA0C06h
;R01		dd	0191C7F01h
;R01		dd	058DFCBD1h
;R01		dd	0C78DEE72h
;R01		dd	072364226h
;R01		dd	01866DE12h
;R01		dd	08D22305Ch
;R01		dd	0943A0F0Eh
;R01		dd	0C81967FFh
;R01		dd	04D55FB0Fh
;R01		dd	0AF199BE1h
;R01		dd	090BBDA61h
;R01		dd	04E7C234Fh
;R01		dd	090CFEC16h
;R01		dd	09B4BCF26h
;R01		dd	021622023h
;R01		dd	00926F0FAh
;R01		dd	01D504377h
;R01		dd	0A58DB427h
;R01		dd	08D93CE2Bh
;R01		dd	090BFE900h
;R01		dd	029E67397h
;R01		dd	02C1261EDh
;R01		dd	04ACE9474h
;R01		dd	0D5C60282h
;R01		dd	0E53FB300h
;R01		dd	08A61A0ABh
;R01		dd	0A7AA0918h
;R01		dd	04389D7C5h
;R01		dd	0D09D605Ch
;R01		dd	06C5BEDB5h
;R01		dd	0D6D54C51h
;R01		dd	0433DEA21h
;R01		dd	07AD9E677h
;R01		dd	0813BFF76h
;R01		dd	05A162C75h
;R01		dd	01EE0661Fh
;R01		dd	09B6C2030h
;R01		dd	08E8DC989h
;R01		dd	0CD4BC9FCh
;R01		dd	04454675Bh
;R01		dd	08D583C9Ch
;R01		dd	0E3400094h
;R01		dd	0116EBB83h
;R01		dd	0E847BC9Ah
;R01		dd	02A4622DDh
;R01		dd	02A901E6Fh
;R01		dd	0D789B1C0h
;R01		dd	0094E2BBBh
;R01		dd	0056E563Fh
;R01		dd	09F17E606h
;R01		dd	08BC79B8Dh
;R01		dd	0D2C535C1h
;R01		dd	006A45A27h
;R01		dd	09DC56771h
;R01		dd	0A06649E2h
;R01		dd	05FF25AC8h
;R01		dd	06554961Eh
;R01		dd	098E583D9h
;R01		dd	038BA93DAh
;R01		dd	0DEE1DE18h
;R01		dd	0037CB9D5h
;R01		dd	06B17F195h
;R01		dd	03431FAAFh
;R01		dd	013860A0Dh
;R01		dd	028BCA10Dh
;R01		dd	00A54C011h
;R01		dd	09957CDB6h
;R01		dd	03AA1F429h
;R01		dd	09D41B7B3h
;R01		dd	09AEA5BE2h
;R01		dd	060C7CE6Bh
;R01		dd	04CD1C10Bh
;R01		dd	024DDDDCDh
;R01		dd	0E28412BAh
;R01		dd	0A03A5466h
;R01		dd	0A1896879h
;R01		dd	059EDCB87h
;R01		dd	01B241765h
;R01		dd	0157BF161h
;R01		dd	0F219F950h
;R01		dd	0E86FF526h
;R01		dd	0262005D9h
;R01		dd	011769531h
;R01		dd	0BCA15D95h
;R01		dd	028F5EF17h
;R01		dd	01F27E725h
;R01		dd	0C32631D2h
;R01		dd	007249E61h
;R01		dd	01BA851E3h
;R01		dd	04F49B577h
;R01		dd	0E2A1DF5Eh
;R01		dd	0826FA7FFh
;R01		dd	0C34E1E2Eh
;R01		dd	07FE26024h
;R01		dd	0BC19800Fh
;R01		dd	00D368DC9h
;R01		dd	0E03DA0C6h
;R01		dd	0ADAA4F9Ch
;R01		dd	09AD1E43Ch
;R01		dd	096F84E44h
;R01		dd	00B6CD695h
;R01		dd	01BB46971h
;R01		dd	0942D6E5Bh
;R01		dd	06316170Dh
;R01		dd	03164509Fh
;R01		dd	0C6659450h
;R01		dd	0B2A0370Ah
;R01		dd	0ABC208E8h
;R01		dd	06D479811h
;R01		dd	03684BC0Eh
;R01		dd	080B7B101h
;R01		dd	0A50B7BB5h
;R01		dd	043D21233h
;R01		dd	0B423559Dh
;R01		dd	0F41DCD16h
;R01		dd	0DFD3C276h
;R01		dd	03E586469h
;R01		dd	0D9B7630Ah
;R01		dd	0B88F9E44h
;R01		dd	00CDA6F4Dh
;R01		dd	0E5BF5844h
;R01		dd	08709F788h
;R01		dd	0DAE37DA6h
;R01		dd	01FB41777h
;R01		dd	01D903F69h
;R01		dd	034383B69h
;R01		dd	0D409AE70h
;R01		dd	0D1C99758h
;R01		dd	0DEDFD7A4h
;R01		dd	0A4BDF018h
;R01		dd	0F4058202h
;R01		dd	08565D66Fh
;R01		dd	05365AED9h
;R01		dd	0FA69742Eh
;R01		dd	02CFBFBCFh
;R01		dd	088A00B60h
;R01		dd	0506C0713h
;R01		dd	02866475Bh
;R01		dd	03E1DF573h
;R01		dd	0B86F7FEBh
;R01		dd	031D23A7Fh
;R01		dd	0C6320E6Ah
;R01		dd	03EBBC2A5h
;R01		dd	083A1D4EFh
;R01		dd	015169F5Fh
;R01		dd	042A61753h
;R01		dd	0893E553Eh
;R01		dd	04DDBC66Dh
;R01		dd	07449EC1Fh
;R01		dd	076F65D22h
;R01		dd	00622E13Bh
;R01		dd	032986F89h
;R01		dd	021181B4Bh
;R01		dd	099A80C0Ah
;R01		dd	0D6FE00B0h
;R01		dd	0282C0E81h
;R01		dd	09FC1CF88h
;R01		dd	0919B855Dh
;R01		dd	0618257D8h
;R01		dd	082C448B8h
;R01		dd	0E22537A1h
;R01		dd	0A90DE388h
;R01		dd	0BA73B90Ch
;R01		dd	0D765EEB0h
;R01		dd	062B2727Eh
;R01		dd	0A08DFE20h
;R01		dd	070B3C8C5h
;R01		dd	03EF04007h
;R01		dd	09F73732Bh
;R01		dd	02201EDD7h
;R01		dd	0B836219Ch
;R01		dd	0F913AF7Ch
;R01		dd	0F50F64CAh
;R01		dd	093AC107Ah
;R01		dd	0F509F84Ah
;R01		dd	06F6026F6h
;R01		dd	0D9BB8EACh
;R01		dd	04B268CFAh
;R01		dd	0A65A3FA6h
;R01		dd	09837CB75h
;R01		dd	0784FB835h
;R01		dd	02060576Dh
;R01		dd	0B1604CAEh
;R01		dd	0B9DA4116h
;R01		dd	0AB320CF2h
;R01		dd	060A1B501h
;R01		dd	00C73FA79h
;R01		dd	08D5A6F1Eh
;R01		dd	057688086h
;R01		dd	0218E4005h
;R01		dd	0CA054E3Dh
;R01		dd	0C1A3C3ECh
;R01		dd	0278CB2C0h
;R01		dd	0F41D6BE8h
;R01		dd	0839B9B57h
;R01		dd	0DE7DF900h
;R01		dd	0A6D05386h
;R01		dd	0F79D8944h
;R01		dd	024D4273Dh
;R01		dd	0878456FEh
;R01		dd	0BC0006E2h
;R01		dd	04CBC49C5h
;R01		dd	016684D87h
;R01		dd	01F2C79A5h
;R01		dd	0847DC8FBh
;R01		dd	0E873C43Ah
;R01		dd	0C92223F2h
;R01		dd	0C9C193D4h
;R01		dd	08F43D21Dh
;R01		dd	0C723F894h
;R01		dd	0A0ED9E53h
;R01		dd	0D0693391h

 endif;KLAMATH_CPU_ONLY
endif;	MORE_P6_MIRCO_CODES
endif;	P6_BIOS_ONLY

		end
