;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

ifdef POWRBIOS
.MODEL  SMALL,STDCALL
.386
else
.MODEL  SMALL,BASIC                 ; no underscore, all caps
.386
 OPTION M510,OLDSTDCALL
  include bios.cfg
endif

;  []==========================================================[]
;
;      This source code is classified as confidential and
;      contains trade secrets owned by Award Software, Inc.
;
;      Copyright 1984, 1996
;      Award Software, Inc.
;      All rights reserved.
;
;  []==========================================================[]
;
;   PAGE  60,132
;   TITLE  DMIPOST  -- DMI Post support
;=============================================================================
; FILE:   DMIPOST.ASM
;
; DESC:   DMI POST support to build and maintain DMI structures
;
;
; BY:     Tim Markey
; DATE:   06/01/96
;=============================================================================
;----------------------------------------------------------------------------
;Rev  Date   Name  Description
;----------------------------------------------------------------------------
;R40A 12/12/97 RIC Add VIA580VPX&590 some external definition
;R41  12/12/97 Stv Added DMI Current Interleave & Memory Error Detecting Method 
;		   & Cache configuration function
;R40  12/11/97 RIC Add VIA597 some external definition
;R39  12/08/97 KVN Supported CPU bus speed to 75MHz and 83 MHz
;R38  12/08/97 KVN Stored various CPU L1 of cache size to DMI pool
;R37  12/02/97 KVN Added AMD-K6 and Cyrix 6x86MX and Pentium-MMX string to
;		   Processor version string of DMI pool
;R36a 11/28/97 STV Don't update CPU_ID if CPU CYRIX.
;R36  10/22/97 KVN Added DMI pool checksum byte to avoid system hang at verify
;		   DMI data if DMI pool data not correct
;R35  09/10/97 TNY Add some extrn definition.
;R34  06/04/97 KVN Fix 'Max memory module size' and 'speeded speeds' of
;		   'memory controller' type be destroyed in Intel-440FX and
;		   plug in P6 CPU.(source code modify from USA 'VINOD)
;R33  05/29/97 KVN Added a new segment for store more BIOS code (save old
;		   DMIPOST.ASM to oldfile directory)
;R32  05/16/97 RCH Support correct string for PPro & PII CPUs
;R31  05/13/97 RCH Fixed wrong L2 cache report for both Pentium Pro & II CPUs
;R30  05/13/97 RCH Support CPU internal clock over 255Mhz for DMI data
;R29  05/13/97 RCH Rewrite CPU information for both P5 & P6 platform to save
;		   BIOS space
;R28  04/29/97 KVN Fix system hang during NT boot routine if NT install LDCM
;		   with DMI function.The reason is LDCM can't to permit DMI
;		   empty string on any type
;R27  03/26/97 KVN Support 2 CPU information
;R26  03/22/97 KVN Store DMI data to F000 shadow to fix Intel LDCM bug
;R25  03/12/97 KVN Add "No_show_Updata_DMI_Msg" definition
;R24  02/04/97 KVN Fixed no restore P6 update micro code because only give DMI
;		   pool size to call "FLASH_WRITE" that will cause INTEL flash
;		   ROM lost P6 micro code after build DMI pool
;R23  12/31/96 KVN Change DMI structure of BIOS date if update BIOS code
;R21D 12/11/96 KVN Don't call DMI function 52h in update dmi_shadow_info.
;		   Because will cause system hang if press hardware reset button
;		   while call Flash_Write subroutine in use INTEL flash ROM
;R22  10/24/96 STV Max speed should not be current speed & fixed l2 cache max 
;		   size	setup error
;R21C 10/21/96 KVN Must be update dmi_shadow_info to correct dmi data between
;		   shadow and flash
;R21B 09/18/96 KVN Fixed DMI build and update fail if not use ESCD_M2
;R21A 09/14/96 KVN Fixed R21 coding mistake that cause DRAM structure and PCI
;		   slot structure can't update because BP be destroy
;R21  09/14/96 KVN Improve DMI pool build and update performance
;R20A 09/05/96 KVN Fixed R20 coding mistake
;R20  09/04/96 KVN Add Pentium Pro family support
;R19  09/03/96 RCH Fixed error BIOS data usage for DMI, this will cause
;		   future usage of memory segment 40.
;R18  08/21/96 KVN  Added CPU brand auto detect for DMI processor component
;R17  08/16/96 KVN  Show 'Verify DMI Pool Data' during compare DMI pool data
;		    and current status of difference, if have some change then
;		    update it to DMI pool and show 'Update Success'
;R16  08/15/96 KVN  Don't show 'success' if update DMI data error
;R15  08/14/96 KVN  Don't update CPU_ID if CPU not intel
;R14  08/02/96 TJM  Moved ct_get_processor_id_lo, ct_get_processor_id_hi and
;	                  ct_get_pci_slot_usage to dmipost.asm from dmi_ct.inc
;R13  07/10/96 TJM  Build support should update flash on every call to SET
;R12  07/03/96 TJM  Fix display messages
;R11  07/03/96 TJM  Added support for detecting if value has changed or not
;                   and only update POOL if a value has changed
;R10  06/25/96 TJM  Add DMI state support to speed up POST updates
;                   The first call to SET_DMI_STRUCTURE will read in the DMI POOL
;                   into the temp buffer, the last call to SET_DMI_STRUCTURE
;                   will flash the buffer into the FLASH CHIP.
;R09  06/25/96 TJM  Add size of cpu_entry to check next entry
;R08  06/25/96 TJM  Do not rely on GET_DMI_INFORMATION for number of structures
;R07  05/25/96 TJM  Convert add_dmi_component to call DMI BIOS SET STRUCTURE
;R06  05/25/96 TJM  Convert to .ASM file supporting MASM 6.11
;R05  04/30/96 TJM  Fixed DMI structures 
;R04  04/23/96 TJM  Added DMI structures for bulk copies
;R03  04/16/96 TJM  Added DMI Signature
;R02  02/02/96 KVN  Added BIOS information for DMI structure
;R01  04/15/96 TJM  Moved from pnppost.asm to dmipost.inc  
;============================================================================-

ifdef DMI_ENABLED
.xlist
ifndef POWRBIOS
  include common.equ
  include common.mac
  include cmos.equ
  include pnp.equ
  include bsetup.inc
endif

include dmi.equ
include dmipost.equ
include dmi_mb.cfg

post_card macro value
  push  ax
  mov   al,value
  out   80h,al
  pop   ax
  endm

ifdef POWRBIOS

CODE SEGMENT PARA PUBLIC 'CODE'

else

option oldstdcall

g_ram		segment	use16 at 40h
		include	g_ram.inc
g_ram		ends

		extrn	Check_K6_Cpu:near	;R37
		extrn	Read_CpuID:near		;R37

ifdef	P6_BIOS_ONLY				;R31
	extrn	Convert_P6L2_Cache:near		;R31
;R37	extrn	Read_CpuID:near			;R32
endif;	P6_BIOS_ONLY				;R31

ifdef	PIIX_ID					;R35
		extrn	DRAM_SPEED_ITEM:near	;R35
endif;	PIIX_ID					;R35
ifdef	VT597					;R40 - starts
		extrn	Tag_Item:near
		extrn	SDRAM_BK_Item:near
ifndef NO_PARITY_ITEM				;R40A
		extrn	Parity_Item:near
endif; NO_PARITY_ITEM				;R40A
		extrn	Bank_01_DRAM_Timing_Item:near
		extrn	Bank_23_DRAM_Timing_Item:near
		extrn	Bank_45_DRAM_Timing_Item:near
endif;	VT597					;R40 - ends
ifdef	VT595					;R40A - starts
		extrn	Tag_Item:near
		extrn	SDRAM_BK_Item:near
ifndef NO_PARITY_ITEM
		extrn	Parity_Item:near
endif; NO_PARITY_ITEM
		extrn	Auto_Cfg_Item:near
endif;	VT595					;R40A - ends

		extrn	GetItem_Value:near
		extrn	post_call_proc:near	;R33
		extrn	dmi_shadow_info:near	;R21D
		extrn	Flash_Read:near		;R21
		extrn	Flash_Write:near	;R21
		extrn	Store_DMI_to_Shadow:near;R26
Temp_DMI_Pool_SEG	EQU	1000h		;R21
Temp_DMI_Pool_OFF	EQU	0		;R21

XGROUP		GROUP	XCODE
XCODE		SEGMENT	USE16 PARA PUBLIC 'XCODE'
		ASSUME	CS:XGROUP,DS:G_RAM,ES:XGROUP
endif

Public  BEGIN_DMI_POST              ; Used to track overall size of
BEGIN_DMI_POST LABEL BYTE           ;  DMI Post 



include dmi_mb.inc                  ; motherboard specific dmi structures
include dmi_ct.inc                  ; chipset specific routines

build_dmi_msg   db  'Building DMI Pool ',0
one_struct_msg  db  '.',0
;R17 update_dmi_msg  db  'Updating DMI Pool ',0
Verify_dmi_msg  db  'Verifying DMI Pool Data ',0	;R17
update_dmi_msg  db  ' Update',0				;R17
;R16 success_msg     db  ' Success',0Dh, 0Ah, 0
success_msg     db  ' Success',0	;R16
new_line_msg    db  0Dh, 0Ah, 0

;=============================================================================
; FUNC: BUILD_DMI_POOL
;
; DESC: Build and maintain DMI pool.  This function will check to see if there
;       are any structures present, if there are no structures present, then
;       it will build default structures.  If there are structures already
;       present, then it will update the information in these structures to
;       reflect the current state of the system.
;
; IN:   NONE
; OUT:  NONE
;=============================================================================
build_dmi_pool proc uses es

  pusha                             ; save all general registers

;R21 start
ifdef	ESCD_M2		;R21B
		mov	ax,DMI_STORAGE_BASE
;R21B start
else	;ESCD_M2
		mov	ax,DMI_STORAGE_BASE_16
endif	;ESCD_M2
;R21B end
		mov	ds,ax
		mov	si,PARAM_BLOCK_BASE+DMI_TBL_OFFSET
		mov	ax,Temp_DMI_Pool_SEG
		mov	es,ax
		mov	di,Temp_DMI_Pool_OFF
;R24		mov	cx,DMI_MAX_POOL_SIZE
		mov	cx,DMI_STORAGE_SIZE		;R24
		F000_call	Flash_Read
;R21 end
;R36 start
		mov	cx,DMI_STORAGE_SIZE-1		;get dmi pool size - 1(checksum byte)
		xor	ah,ah				;clear counter value
@@:
		mov	al,es:[di]			;get data
		inc	di				;next point
		add	ah,al				;count
		loop	@B				;next loop
		cmp	ah,es:[di]			;checksum value equal?
		je	short @F			;Yes,dont rebuild
		mov	di,Temp_DMI_Pool_OFF		;clear temp DMI pool
		mov	ax,0ffffh			;default value
		mov	cx,DMI_STORAGE_SIZE/2		;size / 2 (for word)
		rep	stosw				;clear it
		jmp	short Force_Build_DMI		;go to rebuild routine
@@:
;R36 end
  ; R08 - Do not rely on GET_DMI_INFORMATION for number of structures
  ; mov   ax,TMP_DMI_SEG1
  ; mov   es,ax
  ; call  get_dmi_information_call    ; get the DMI information
  ; 
  ; xor   di,di                       ; offset from zero
  ; assm  di:ptr get_dmi_info
  ; mov   ax,es:[di].num_struc        ; get number of structures
  ; R08 - Do not rely on GET_DMI_INFORMATION for number of structures
  mov   al,NO_SET                   ; or  value - signal to read from flash R11
  call  set_dmi_state               ; set state variable for updates  R11

  call  check_for_structures        ; check if any structures exist

  .if   ax  == DMI_INVALID_HANDLE   ; structure not found
Force_Build_DMI:			;R36
    call  build_dmi_info            ; build the structures
  .endif
  ; R08 - end

  call  update_dmi_info             ; update DMI information

;R21D;R21C start
;R21D	push  0F000h                      ; BiosSelector
;R21D	push  0F000h                      ; DMISelector
;R21D	mov   al,SET_DMI_POOL           ; normal operation
;R21D	push  ax                          ; Control - Set structure immediately
;R21D	call	get_set_dmi_buffers
;R21D	push  fs                          ; work buffer segment 
;R21D	push  si                          ; work buffer offset
;R21D	push  es                          ; data buffer segment
;R21D	push  di                          ; data buffer offset
;R21D	push  DFN_SET_DMI_STRUCT          ; set dmi structure - add structure
;R21D	FAR_CALL  <offset PNP_BIOS_Real>, 0F000h
;R21D	add   sp,16                       ; 
;R21D;R21C end
;R21D start
	cli
	F000_call	F000_Shadow_W		; Enable F000 shadow writeable
	mov	ax,Temp_DMI_Pool_SEG
	mov	ds,ax
	mov	si,Temp_DMI_Pool_OFF
	mov	di,0f000h
	mov	es,di
	mov	di,offset dmi_shadow_info	; point to reserved shadow area R19
	mov	cx,8				; size of signature+max size+num structs
	rep	movsb				; move signature, max size and num structs to shadow
;R26 start
	mov	ax,ds:[si-4]			; get number of structure
	cmp	ax,0ffffh			; check is invalid?
	je	short @F			; Yes,skip store to shadow
	F000_call	Store_DMI_to_Shadow
@@:
;R26 end
	F000_call	F000_Shadow_R		; Enable F000 shadow readonly
	sti
;R21D end

  popa                              ; restore all general registers

  ret

build_dmi_pool endp


;=============================================================================
; FUNC: CHECK_FOR_STRUCTURES
;
; DESC: Attempt to get first DMI structure from DMI Pool
;
; IN:   NONE
; OUT:  AX    - Return value from get dmi structure
;=============================================================================
check_for_structures proc uses es di ds si dx bx
  local dmi_struct_handle:word

  ; R08 - Check to see if one structure already exists
  mov   dmi_struct_handle,0         ; set struct handle to zero, (find first entry)

  push  ss                          ; set ES:DI to point to struct handle
  pop   es                          ; 
  lea   di,dmi_struct_handle            ; 

  mov   dx,TMP_DMI_SEG1             ; set DS:SI to point to dmiStructBuffer
  mov   ds,dx                       ; 
  mov   si,TMP_DMI_OFS1             ; 
  
  mov   dl,al                       ; 
  mov   dh,bh                       ;
  xor   bh,bh                       ;

  call  get_dmi_structure_call      ; get the dmi structure (AX modified)

  ret

check_for_structures endp

;=============================================================================
; FUNC: BUILD_DMI_INFO
;
; DESC: Add DMI structures if not already present.  No optimizations are
;       necessary for this code as it is only performed on first boot.
;       It is safer to update the flash on every change.
;          
; IN:   NONE
; OUT:  NONE
;=============================================================================
;R21 build_dmi_info proc uses ds es fs
build_dmi_info proc uses ds es	;R21
  local last_structure:byte

  pusha

  mov   last_structure,0

ifndef No_show_Updata_DMI_Msg	;R25
  mov   ax, cs
  mov   ds, ax
  mov   si, offset XGROUP:build_dmi_msg
  POST_func_call  Disp_String
endif ;No_show_Updata_DMI_Msg	;R25

  push  cs
  pop   ds                          ; code segment contains table
  lea   bx,dmi_tbl                  ; DS:[BX] points to dmi_tbl
  xor   dx,dx                       ; DX = node number

  call  get_set_dmi_buffers         ; get data buffer in ES:DI, work buffer in FS:SI

  .repeat

    call  show_one_dot              ; put a dot one the screen

    assm  di:ptr dmi_set_struct       ; assume DI points to dmi_set_struct struct
    mov   es:[di].command,DMI_ADD_STRUCT ; set command for adding a structure
    assm  bx:ptr dmi_entry          ; 

    push  bx                        ; save index
    add   bx,sizeof dmi_entry       ; point BX to next entry
    .if [bx].info == 0FFFFh         ; 
      mov   last_structure,1        ; signal that this is the last structure
    .endif
    pop   bx                        ; restore index

    movzx cx,[bx].num_entrys        ; get number of structures to include

    .if   cx != 0                   ; if more than zero entrys

      push  cx                      ; save number of entrys
      push  si                      ; save work buffer offset


      mov   si,[bx].info            ; load pointer (DS already set)
      mov   cx,[bx].tsize           ; load size of table
      mov   es:[di].data_length,cx  ; 

      push  di                      ; save dmi buffer offset
      add   di,ofs dmi_set_struct.struc_type
      rep   movsb                   ; copy structure to add onto end of data buffer
      pop   di                      ; restore dmi buffer offset
      pop   si                      ; restore work buffer offset
      pop   cx                      ; restore number of entrys

      assm  di:ptr dmi_set_struct

      .repeat

        .if  last_structure && cx == 1
          push  bx
          mov   bh,SET_INFO_MASK        ; and                        R11
          mov   bl,LAST_SET             ; or  - signal to flash      R11
          call  update_dmi_state        ; set state variable for updates  R11
          pop   bx
        .endif

        .repeat

          mov   es:[di].struc_handle,dx ; update handle
          call  set_dmi_structure_call  ; add the DMI structure
;R21	  or	ax,ax				;R16
;R21	  jnz	short build_dmi_info_exit	;R16
	  jc	short build_dmi_info_exit	;R21
          inc   dx                      ; increment handle number in DX
;R21        .until ax != DMI_INVALID_HANDLE ; Invalid handle
        .until				;R21

      .untilcxz                     ; loop for number of entrys in CX

    .endif                          ; end if cx != 0

    ; R13 - removed code to change state to MIDDLE_SET

    .if  [bx].build_func != 0       ; get number of structures to include
      call  [bx].build_func         ; build function (needs only to be called once)
    .endif

    add   bx,sizeof dmi_entry       ; point BX to next entry

  .until [bx].info == 0FFFFh        ; until terminator found

;R21 start
ifdef	ESCD_M2	;R21B
		mov	ax,DMI_STORAGE_BASE
;R21B start
else	;ESCD_M2
		mov	ax,DMI_STORAGE_BASE_16
endif	;ESCD_M2
;R21B end
		mov	es,ax
		mov	di,PARAM_BLOCK_BASE+DMI_TBL_OFFSET
		mov	ax,Temp_DMI_Pool_SEG
		mov	ds,ax
		mov	si,Temp_DMI_Pool_OFF
;R24		mov	cx,DMI_MAX_POOL_SIZE
		mov	cx,DMI_STORAGE_SIZE		;R24
		F000_call	Flash_Write
		jc	short build_dmi_info_exit
;R21 end
  call  show_success_msg            ; show success message
build_dmi_info_exit:			;R16
	call	clear_line		;R16

  popa                              ; restore all registers

  ret

build_dmi_info endp


;=============================================================================
; FUNC: BUILD_TYPE00 - (BIOS Information)
;
; DESC: Update the structure with current information from POST
;          
; IN:   DS:BX - Table Entry
; OUT:  NONE
;=============================================================================
build_type00 proc uses ds 

  pusha                             ; save all general registers

  mov   cx,0                        ; instance of information
  mov   bh,BIOS_INFORMATION         ; BIOS information
  mov   bl,0                        ; no other match required
  call  get_struct_hdr              ; get DMI structure in EDX
  jc    build_type00_exit           ; quit if structure not found

;R33  mov   si,seg SIGN_ON_MSG
  mov   si,0f000h			;R33
  mov   ds,si
  mov   si,DATE_STRING_OFFSET       ; add date string
  mov   bl,ofs type00.bios_date     ; date string index

  call  update_dmi_string           ; change word in structure

build_type00_exit:

  popa                              ; restore all general registers

  ret                               ; 

build_type00 endp


;=============================================================================
; FUNC: BUILD_TYPE05 - (Memory Controller Information)
;
; DESC: Update the structure with current information from POST
;          
; IN:   DS:BX - Table Entry
;       DX    - handle of current structure + 1
; OUT:  NONE
;=============================================================================
build_type05 proc uses ds 

  pusha                             ; save all general registers

  mov   ax,dx                       ; save handle in AX

  mov   cx,0                        ; instance of information
  mov   bh,MEM_CTLR_INFORMATION     ; Memory Controller information
  mov   bl,0                        ; no other match required
  call  get_struct_hdr              ; get DMI structure in EDX
  jc    build_type05_exit           ; quit if structure not found

  mov   cx,NUM_MEM_SLOTS            ; number of memory slots

  mov   bl,ofs type05.mem_mod_hndl_list  ; offset

  .repeat
    mov   bh,DMI_CHANGE_WORD          ; Change single WORD
    call  update_dmi_component        ; change word in structure
    inc   ax                          ; AX = next handle
    add   bl,2                        ; set BL to next handle location
  .untilcxz

build_type05_exit:

  popa                              ; restore all general registers

  ret                               ; 

build_type05 endp


;=============================================================================
; FUNC: BUILD_TYPE06 - (Memory Module Information)
;
; DESC: Update the structure with current information from POST
;          
; IN:   DS:BX - Table Entry
;       DX    - handle of current structure + 1
; OUT:  NONE
;=============================================================================
build_type06 proc uses ds es

  pusha                             ; save all general registers

  mov   ax,dx                       ; save handle in AX
  push  cs                          ; set DS to CS
  pop   ds
  xor   cx,cx                       ; clear memory module count in CX


  lea   si,mem_bank_connection_table

  .repeat

    mov   bh,MEM_MOD_INFORMATION    ; Memory Module information
    mov   bl,0                      ; no other match required
    call  get_struct_hdr            ; get DMI structure in EDX
    jc    build_type06_exit         ; quit if structure not found

    push  edx
    mov   al,[si]
    mov   bh,DMI_CHANGE_BYTE        ; Change single BYTE
    mov   bl,ofs type06.bank_connection ; offset
    call  update_dmi_component      ; change word in structure
    inc   si                        ; point SI to next bank connection

    push  si
    movzx bx,cl
    shl   bx,1                      ; word table
    lea   si,mem_string_table       ; get start of mem string table
    mov   si,wptr [si+bx]           ; get pointer to string
    mov   bl,ofs type06.socket_designation ; date string index
    call  update_dmi_string         ; change word in structure
    pop   si
    pop   edx

    inc   cl                        ; get next instance

  .until cl >= NUM_MEM_SLOTS

build_type06_exit:


  popa                              ; restore all general registers

  ret                               ; 

build_type06 endp

;=============================================================================
; FUNC: UPDATE_DMI_INFO
;
; DESC: Update DMI structures with information which changes and needs to
;       be detected by the BIOS during POST.
;          
;       List of items which need to be updated every POST:
;
;       Processor Information:
;          External Clock             (Done)
;          Current Speed              (Done)
;          Status                     (Done)
;       Memory Module Information:
;          Bank Connections 
;          Current Speed
;          Current Memory Type
;          Installed Size 
;          Enabled Size
;          Error Status
;       Cache Information:
;          Cache Configuration        (Done)
;          Installed Size             (Done)
;          Current SRAM Type          (Done)
;       System Slots (PCI):
;          Current Usage
;          Slot ID 
;       On Board Device Information:
;          Device Status
;       System Event Logging
;
; IN:   NONE
; OUT:  NONE
;=============================================================================
update_dmi_info proc uses ds

  pusha                             ; save all registers

;R21 start
ifdef	ESCD_M2	;R21B
		mov	ax,DMI_STORAGE_BASE
;R21B start
else	;ESCD_M2
		mov	ax,DMI_STORAGE_BASE_16
endif	;ESCD_M2
;R21B end
		mov	ds,ax
		mov	si,PARAM_BLOCK_BASE+DMI_TBL_OFFSET
		mov	ax,Temp_DMI_Pool_SEG
		mov	es,ax
		mov	di,Temp_DMI_Pool_OFF
;R24		mov	cx,DMI_MAX_POOL_SIZE
		mov	cx,DMI_STORAGE_SIZE		;R24
		F000_call	Flash_Read
;R21 end
ifndef No_show_Updata_DMI_Msg	;R25
  mov   ax, cs
  mov   ds, ax
;R17  mov   si, offset EGROUP:update_dmi_msg
  mov   si, offset XGROUP:Verify_dmi_msg		;R17
  POST_func_call  Disp_String
endif ;No_show_Updata_DMI_Msg	;R25
  and	byte ptr Post_Temp_Byte[bp],not DMI_UPDATE	;R17

  mov   bh,00h
  mov   bl,FIRST_SET
  call  update_dmi_state          ; Set DMI POST State variable     R11

  push  cs                          ; point DS:BX to dmi_entry table
  pop   ds                          ; 
  lea   bx,dmi_tbl                  ; 

  .repeat

    assm  bx:ptr dmi_entry          ; assume BX points to dmi_entry table

    .if  [bx].update_func != 0      ; get number of structures to include
      call  show_one_dot            ; put a dot one the screen
      call  [bx].update_func        ; update function
    .endif

    add   bx,sizeof dmi_entry       ; point to next entry

  .until [bx].info == 0FFFFh        ; repeat until terminator reached

;R17 start
  test	byte ptr Post_Temp_Byte[bp],DMI_UPDATE
  jz	short update_dmi_info_exit
;R21 start
ifdef	ESCD_M2	;R21B
		mov	ax,DMI_STORAGE_BASE
;R21B start
else	;ESCD_M2
		mov	ax,DMI_STORAGE_BASE_16
endif	;ESCD_M2
;R21B end
		mov	es,ax
		mov	di,PARAM_BLOCK_BASE+DMI_TBL_OFFSET
		mov	ax,Temp_DMI_Pool_SEG
		mov	ds,ax
		mov	si,Temp_DMI_Pool_OFF
;R24		mov	cx,DMI_MAX_POOL_SIZE
		mov	cx,DMI_STORAGE_SIZE		;R24
		F000_call	Flash_Write
		jc	short update_dmi_info_exit
;R21 end
ifndef No_show_Updata_DMI_Msg	;R25
  mov   ax,cs
  mov   ds,ax
  mov   si, offset XGROUP:update_dmi_msg
  POST_func_call  Disp_String
;R17 end
  call  show_success_msg            ; show success message
endif ;No_show_Updata_DMI_Msg	;R25
update_dmi_info_exit:					;R17
  call	clear_line		;R16

  popa                              ; restore all general registers

  ret

update_dmi_info endp

;R23 start
;=============================================================================
; FUNC: UPDATE_TYPE00 - (BIOS Information)
;
; DESC: Update the structure with current information from POST
;          
; IN:   DS:BX - Table Entry
; OUT:  NONE
;=============================================================================
update_type00	proc	near
	jmp	build_type00
update_type00 endp
;R23 end

;=============================================================================
; CPU speed conversion table used for update_type04 function
;=============================================================================
cpu_speed_table label byte
cpu_entry {CPU83, 83}               ;R39 83 Mhz
cpu_entry {CPU75, 75}               ;R39 75 Mhz
cpu_entry {CPU66, 66}               ; 66 Mhz
cpu_entry {CPU60, 60}               ; 60 Mhz
cpu_entry {CPU50, 50}               ; 50 Mhz
cpu_entry {CPU40, 40}               ; 40 Mhz
cpu_entry {CPU33, 33}               ; 33 Mhz
cpu_entry {CPU25, 25}               ; 25 Mhz
cpu_entry {CPU20, 20}               ; 20 Mhz
cpu_entry {CPU16, 16}               ; 16 Mhz
cpu_entry {0, 0}                    ; Table Terminator

;R18 start
null_str	db	0	;R27
Intel_str	db	'Intel',0

;R29 - start
;CPU information for P6 platform
ifdef	P6_BIOS_ONLY
PentiumPro_str:
;R32 ifdef	KLAMATH_CPU_ONLY
;R32		db	'Pentium II',0	
;R32 else;	KLAMATH_CPU_ONLY
		db	'Pentium Pro',0	
;R32 endif;	KLAMATH_CPU_ONLY
PentiumII_str:	db	'Pentium II',0		;R32
else;	P6_BIOS_ONLY
;CPU information for P5 platform
Pentium_str	db	'Pentium',0
PentiumMMX_str	db	'Pentium-MMX',0		;R37
Cyrix_str	db	'Cyrix',0
Cy6x86_str	db	'6x86',0
Cy6x86MX_str	db	'6x86MX',0		;R37
AMD_str		db	'AMD',0
AMD_K5_str	db	'AMD-K5',0
AMD_K6_str	db	'AMD-K6',0		;R37
endif;	P6_BIOS_ONLY
;R29 - end

;R29 ifdef	P6_BIOS_ONLY				;R20A
;R29 PentiumPro_str	db	'Pentium Pro',0		;R20A
;R29 else	;P6_BIOS_ONLY				;R20A
;R29 Pentium_str	db	'Pentium',0
;R29 endif	;P6_BIOS_ONLY				;R20A
;R29 Cyrix_str	db	'Cyrix',0
;R29 Cy6x86_str	db	'6x86',0
;R29 AMD_str		db	'AMD',0
;R29 AMD_K5_str	db	'AMD-K5',0
;R18 end

;=============================================================================
; FUNC: UPDATE_TYPE04 - (Processor Information)
;
; DESC: Update the structure with current information from POST
;          
; IN:   DS:BX - Table Entry
; OUT:  NONE
;=============================================================================
update_type04 proc uses ds

	push	es	;R27
  pusha                             ; save all general registers

  mov   ax,G_RAM                    ; point DS to BIOS data area (40:)
  mov   ds,ax                       ; 
	xor	bx,bx	;R27
	mov	es,bx	;R27
  mov   ah,byte ptr ds:CPU_CLOCK    ; read CPU clock speed into AH
  and   ah,CPU_CLOCK_MASK           ; 
                                     
  push  cs                          ; point DS:SI to cpu_speed_table
  pop   ds                          ; 
  lea   si,cpu_speed_table          ; 
  assm  si:ptr cpu_entry            ; assume SI points to cpu_entry struct

  .repeat
    .if   ah == [si].actual_speed   ; if speed matches entry in table
      mov   al,[si].display_speed   ;  then set AL to display speed
      jmp   ut04_speed_found        ; jmp as we are done
    .endif                          ; 
    add   si,sizeof cpu_entry       ; Add size of cpu_entry to SI (R09)
  .until  [si].actual_speed == 0    ; repeat until terminator found

ut04_speed_found:

  mov   cx,0                        ; instance of information
  .repeat	;R27
  mov   bh,CPU_INFORMATION          ; cpu information
  mov   bl,0                        ; no other match required
  call  get_struct_hdr              ; get DMI structure in EDX
  jc    ut04_exit                   ; quit if structure not found

  push	ax	;R27
  push	cx	;R27
  xor   ah,ah                       ; clear upper byte of external clock field
  mov   bl,ofs type04.external_clock  ; offset
  mov   bh,DMI_CHANGE_WORD          ; Change single WORD
  call  update_dmi_component        ; change word in structure

;R30  xor   ah,ah                       ; clear upper byte of internal clock field
;R30  mov   al,CPU_INT_CLOCK[bp]        ; get internal clock speed from table
      mov   ax,CPU_INT_CLOCK[bp]        ; get internal clock speed from table;R30

;R22  push  ax                          ; save max speed for current clock speed
;R22  mov   bl,ofs type04.max_speed     ; offset
;R22  mov   bh,DMI_CHANGE_WORD          ; Change single WORD
;R22  call  update_dmi_component        ; change word in structure
;R22  pop   ax                          ; restore clock speed for current clock speed

  mov   bl,ofs type04.current_speed ; offset
  mov   bh,DMI_CHANGE_WORD          ; Change single WORD
  call  update_dmi_component        ; change word in structure

;R27 start
	mov	al,41h		;assume CPU enable
	cmp	byte ptr es:[500H],0AAH ;2 CPUs plugged
	je	short @F
	pop	cx
	push	cx
	or	cl,cl
	jz	short @F
	mov	al,42h		;CPU disable by user
@@:
  mov   bl,ofs type04.status		; offset
  mov   bh,DMI_CHANGE_BYTE          ; Change single BYTE
  call  update_dmi_component        ; change word in structure
;R27 end

;R36a	cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_INTEL	;R15
;R18	jne	short ut04_exit				;R15
;R36a	jne	short Dont_Get_CPU_ID	;R18
;R37	cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_CYRIX	;R36a
;R37	je	short Dont_Get_CPU_ID	;R36a
	call  ct_get_processor_id_lo      ; get CPU ID (step/model/family)
;R27 start
	cmp	byte ptr es:[500H],0AAH ;2 CPUs plugged
	je	short @F
	pop	cx
	push	cx
	or	cl,cl
	jz	short @F
	xor	eax,eax
@@:
;R27 end
  mov   bl,ofs type04.lo_processor_id ; offset
  mov   bh,DMI_CHANGE_DWORD         ; Change single WORD
  call  update_dmi_component        ; change word in structure

  push  bx
  mov   bh,SET_INFO_MASK             ; and                             R11
  mov   bl,LAST_SET                 ; or  - flash                     R11
  call  update_dmi_state            ; set state variable for updates  R11
  pop   bx

  call  ct_get_processor_id_hi      ; get CPU id hi (feature flags)
;R27 start
	cmp	byte ptr es:[500H],0AAH ;2 CPUs plugged
	je	short @F
	pop	cx
	push	cx
	or	cl,cl
	jz	short @F
	xor	eax,eax
@@:
;R27 end
  mov   bl,ofs type04.hi_processor_id ; offset
  mov   bh,DMI_CHANGE_DWORD         ; Change single WORD
  call  update_dmi_component        ; change word in structure

;R18 start
;R37Dont_Get_CPU_ID:
;R27 start
	cmp	byte ptr es:[500H],0AAH ;2 CPUs plugged
	je	short @F
	pop	cx
	push	cx
	or	cl,cl
	jz	short @F
	mov	al,Unknown
	lea	di,null_str
	mov	si,di
	jmp	short Update_CPU_Brand
@@:
;R27 end
ifdef	P6_BIOS_ONLY				;R20
	pushad						;R32
	post_func_call	Read_CpuID		;get CPU ID	;R32
	cmp	al,30h			;klamath ?	;R32
	popad						;R32
	mov	al,PentiumII		;yes		;R32
	lea	di,PentiumII_str			;R32
	jae	short P_II_Yes				;R32

	mov	al,PentiumPro			;R20
	lea	di,PentiumPro_str		;R20
P_II_Yes:						;R32
else	;P6_BIOS_ONLY				;R20
	mov	al,Pentium
	lea	di,Pentium_str
endif	;P6_BIOS_ONLY				;R20
	lea	si,Intel_str
	mov	bh,CPU_BRAND[bp]
	cmp	bh,CPU_BRAND_INTEL
ifdef	P6_BIOS_ONLY				;R37
	je	short Update_CPU_Brand
;R37ifndef	P6_BIOS_ONLY				;R29
;R37 start
else	;P6_BIOS_ONLY
	jne	short @F
	pushad
	post_func_call	Read_CpuID		;get CPU ID
	bt	edx,23				;test MMX ?
	popad
	jnc	short Update_CPU_Brand
	lea	di,PentiumMMX_str		;set to MMX string
	jmp	short Update_CPU_Brand
@@:
;R37 end
;R37	mov	al,K5_CPU
;R37	lea	si,AMD_str
;R37	lea	di,AMD_K5_str
	cmp	bh,CPU_BRAND_AMD
;R37	je	short Update_CPU_Brand
;R37 start
	jne	short @F
	Post_func_call	Check_K6_Cpu
	mov	al,K5_CPU
	lea	si,AMD_str
	lea	di,AMD_K5_str
	jnz	short Update_CPU_Brand
	lea	di,AMD_K6_str
	jmp	short Update_CPU_Brand
@@:
;R37 end
;R37	mov	al,M1_CPU
;R37	lea	si,Cyrix_str
;R37	lea	di,Cy6x86_str
	cmp	bh,CPU_BRAND_CYRIX
;R37	je	short Update_CPU_Brand
;R37 start
	jne	short @F
;R38	mov	al,0feh			;DIR 0
;R38	out	22h,al
;R38	in	al,23H			;read CPU device ID
;R38	and	al,0f0h
;R38	cmp	al,50h
	call	Check_M2		;R38
	mov	al,M1_CPU
	lea	si,Cyrix_str
	lea	di,Cy6x86_str
	jnz	short Update_CPU_Brand
	lea	di,Cy6x86MX_str
	jmp	short Update_CPU_Brand
@@:
;R37 end
endif;	P6_BIOS_ONLY				;R29


;R27	jmp	short ut04_exit
	jmp	short Next_CPU	;R27

Update_CPU_Brand:
	mov	bl,ofs type04.processor_family
	mov	bh,DMI_CHANGE_BYTE          ; Change single WORD
	call	update_dmi_component        ; change word in structure
	mov	bl,ofs type04.processor_manufacturer
	call	update_dmi_string           ; change stringin structure
	mov	bl,ofs type04.processor_version
	mov	si,di
	call	update_dmi_string           ; change stringin structure
;R18 end
;R27 start
Next_CPU:
	pop	cx
	pop	ax
	inc	cx
  
	.until cx >= NUM_CPU
;R27 end
ut04_exit:

  popa                              ; restore all general registers
	pop	es	;R27
  assm  si:ptr nothing              ; assume SI points to nothing

  ret                               ; 

update_type04 endp

;R38 start
;Input : None
;Output: ZF = M2
;	 NZ = M1
Check_M2:
	mov	al,0feh			;DIR 0
	out	22h,al
	in	al,23H			;read CPU device ID
	and	al,0f0h
	cmp	al,50h
	ret
;R38 end

;=============================================================================
; FUNC: UPDATE_TYPE05
;
; DESC: Update the following information:
;       1.  Current Interleave
;
; IN:   DS:BX - Table Entry
; OUT:  NONE
;=============================================================================
update_type05 proc uses ds 

  pusha                             ; save all general registers
;R41 - starts
  assm  bx:ptr  dmi_entry         ; assume BX points to dmi_entry
  xor   cx,cx

    mov   bh,MEM_CTLR_INFORMATION     ; Memory Controller information
    mov   bl,0                        ; no other match required
    call  get_struct_hdr              ; get DMI structure in EDX
    jc    ut05_exit		      ; quit if structure not found

    ;==========================================================================
    ; Set Current Interleave
    ;==========================================================================
    call  ct_get_dmi_mem_interleave   ; get the memory current interleave for this chipset
    mov   bl,ofs type05.current_interleave ; offset
    mov   bh,DMI_CHANGE_BYTE          ; Change single BYTE
    call  update_dmi_component        ; change structure

    ;==========================================================================
    ; Set Error Detecting Method
    ;==========================================================================
    call  ct_get_dmi_mem_error_detecting   ; get the memory current interleave for this chipset
    mov   bl,ofs type05.error_detecting ; offset
    mov   bh,DMI_CHANGE_BYTE          ; Change single BYTE
    call  update_dmi_component        ; change structure

ut05_exit:
  assm  bx:ptr nothing              ; assume BX points to nothing
;R41 - ends
  popa                              ; restore all general registers

  ret                               ; 

update_type05 endp
 
;=============================================================================
; FUNC: UPDATE_TYPE06
;
; DESC: Update the following information:
;       1.  Current Memory Type
;       2.  Current Installed Size
;       3.  Current Enabled Size
;       4.  Current Speed
;
; IN:   DS:BX - Table Entry
; OUT:  NONE
;=============================================================================
update_type06 proc uses ds
;R21A  local num_modules:byte

  pusha                             ; save all general registers

  assm  bx:ptr  dmi_entry         ; assume BX points to dmi_entry
  xor   cx,cx

  .repeat

    push  cx

    mov   bh,MEM_MOD_INFORMATION      ; memory module information
    mov   bl,0                        ; no other match required
    call  get_struct_hdr              ; get DMI structure in EDX

    .if   carry?
      pop   cx
      jmp   ut06_exit                   ; quit if structure not found
    .endif

    ;==========================================================================
    ; Set Memory Type
    ;==========================================================================
    call  ct_get_dmi_memory_type      ; get the memory type for this chipset
    mov   bl,ofs type06.current_mem_type ; offset
    mov   bh,DMI_CHANGE_WORD          ; Change single WORD
    call  update_dmi_component        ; change structure

    ;==========================================================================
    ; Set Installed Size
    ;==========================================================================
    call  ct_get_dmi_mem_size         ; get the memory type for this chipset
    mov   bl,ofs type06.installed_size ; offset
    mov   bh,DMI_CHANGE_BYTE          ; Change single BYTE
    call  update_dmi_component        ; change structure

    ;==========================================================================
    ; Set Enabled Size
    ;==========================================================================
    mov   bl,ofs type06.enabled_size  ; offset
    mov   bh,DMI_CHANGE_BYTE          ; Change single BYTE
    call  update_dmi_component        ; change structure

    ;==========================================================================
    ; Set Memory Speed
    ;==========================================================================
    call  ct_get_dmi_mem_speed        ; get the memory speed for this chipset
    mov   bl,ofs type06.current_speed ; offset
    mov   bh,DMI_CHANGE_BYTE          ; Change single BYTE
    call  update_dmi_component        ; change structure
    pop   cx

    inc   cx

  .until cx >= NUM_MEM_SLOTS

ut06_exit:

  popa                              ; restore all general registers
  assm  bx:ptr nothing              ; assume BX points to nothing

  ret                               ; 

update_type06 endp

;=============================================================================
; FUNC: UPDATE_TYPE07_L1 - (Internal Cache Information)
;
; DESC: Update the structure with current information from POST
;          
; IN:   DS:BX - Table Entry
; OUT:  NONE
;=============================================================================
update_type07_l1 proc uses ds

  pusha                             ; save all general registers

  post_func_call  IntCache_Status             ; get internal cache status in AL
  mov   al,80h                      ; assume that cache is on
  .if   zero?
    xor   al,al                     ; Cache is OFF
  .endif
  or    al,TYPE07_CACHE_CFG_INTERNAL ; Internal cache config
;R34  mov   ah,3                         ; Unknown operational mode
  mov   ah,01				;R34

  mov   cx,0                        ; instance of information
  mov   bh,CACHE_INFORMATION        ; cache information
  mov   bl,0                        ; has to be an internal cache
  call  get_struct_hdr              ; get DMI structure in EDX

  .if  !carry?
    mov   bl,ofs type07.cache_config ; offset
    mov   bh,DMI_CHANGE_WORD         ; Change single WORD
    call  update_dmi_component       ; change word in structure
  .endif

;R38 start
ifdef	P6_BIOS_ONLY
	pushad
	post_func_call	Read_CpuID		;get CPU ID
	cmp	al,30h				;Pentium II?
	popad
	mov	ax,32				;Pentium II L1 cache size = 32K
	jae	short Update_Cache_Size		;Yes,jump
	mov	ax,16				;Pentium Pro L1 cache size = 16K
else	;P6_BIOS_ONLY
	mov	bh,CPU_BRAND[bp]
	cmp	bh,CPU_BRAND_INTEL
	jne	short Not_Intel_CPU
	pushad
	post_func_call	Read_CpuID		;get CPU ID
	bt	edx,23				;test MMX ?
	popad
	mov	ax,32				;Pentium-MMX L1 cache size = 32K
	jc	short Update_Cache_Size		;Yes,jump
	mov	ax,16				;Pentium L1 cache size = 16K
	jmp	short Update_Cache_Size
Not_Intel_CPU:
	cmp	bh,CPU_BRAND_AMD
	jne	short Not_AMD_CPU
	Post_func_call	Check_K6_Cpu		;Is K6?
	mov	ax,16				;AMD-K5 L1 cache size = 16K
	jnz	short Update_Cache_Size		;No,jump
	mov	ax,64				;AMD-K6 L1 cache size = 64K
	jmp	short Update_Cache_Size
Not_AMD_CPU:
	call	Check_M2
	mov	ax,16				;Cyrix-M1 L1 cache size = 16K
	jnz	short Update_Cache_Size		;No,jump
	mov	ax,64				;Cyrix-M2 L1 cache size = 64K
endif	;P6_BIOS_ONLY

Update_Cache_Size:
	push	ax
	mov	bl,ofs type07.install_size	; offset
	mov	bh,DMI_CHANGE_WORD		; Change single WORD
	call	update_dmi_component		; change word in structure
	pop	ax
	mov	bl,ofs type07.max_size		; offset
	mov	bh,DMI_CHANGE_WORD		; Change single WORD
	call	update_dmi_component		; change word in structure
;R38 end

  popa                              ; restore all general registers

  ret

update_type07_l1 endp

;=============================================================================
; FUNC: UPDATE_TYPE07_02 - (External Cache Information)
;
; DESC: Update the structure with current information from POST
;          
; IN:   DS:BX - Table Entry
; OUT:  NONE
;=============================================================================
update_type07_l2 proc uses ds

  pusha                             ; save all general registers

  post_func_call  ExtCache_Status             ; get external cache status in zero flag
  mov   al,80h                      ; assume Cache is ON
  jnz   short @F                    ; if zero than cache is ON
  xor   al,al                       ; Cache is OFF
@@:
  or    al,TYPE07_CACHE_CFG_EXTERNAL ; External cache config
;R34  mov   ah,3                         ; Unknown operational mode
  mov   ah,1                         ;R34 Unknown operational mode

  mov   cx,1                        ; instance of information
  mov   bh,CACHE_INFORMATION        ; cache information
  mov   bl,0                        ; no other match required
  call  get_struct_hdr              ; get DMI structure in EDX
  jc    ut07_l2_exit                ; quit if structure not found

  call	ct_get_dmi_cache_config	    ;R41
  mov   bl,ofs type07.cache_config  ; offset
  mov   bh,DMI_CHANGE_WORD          ; Change single WORD
  call  update_dmi_component        ; change word in structure

;R31 - start
ifdef	P6_BIOS_ONLY
	mov	eax,2			;read cache isze
	db	0Fh,0A2h		;OP code: CPUID
	post_func_call	Convert_P6L2_Cache	;convert cache size
else;	P6_BIOS_ONLY
;R31 - end

  F000_call  Get_Cache_Size         ; get cache size AL
endif;	P6_BIOS_ONLY					;R31
  xor   ah,ah                       ; 
  or    al,al                       ; 
  .if   !zero?
    mov   cl,al                     ; 
    mov   al,8                      ; 
    shl   ax,cl                     ; 
  .endif
;R34 start
  push  cx
  push  bx
  mov   cx,1                        ; instance of information
  mov   bh,CACHE_INFORMATION        ; cache information
  mov   bl,0                        ; no other match required
  call  get_struct_hdr              ; get DMI structure in EDX
  pop   bx
  pop   cx
  jc    ut07_l2_exit                ; quit if structure not found
;R34 end

  mov   bl,ofs type07.install_size  ; offset
  mov   bh,DMI_CHANGE_WORD          ; Change single WORD
  call  update_dmi_component        ; change word in structure

;R22 START
  mov	ax,MAX_L2_SIZE
  mov   bl,ofs type07.max_size  ; offset
  mov   bh,DMI_CHANGE_WORD          ; Change single WORD
  call  update_dmi_component        ; change word in structure

;R22 END


ut07_l2_exit:                       ; 

  popa                              ; restore all general registers

  ret

update_type07_l2 endp

;=============================================================================
; FUNC: UPDATE_TYPE09_PCI
;
; DESC: Update the following information:
;       1.  Current Usage
;       2.  Slot ID = slot number field of PCI interupt routing option
;
; IN:   DS:BX - Table Entry
; OUT:  NONE
;=============================================================================
update_type09_pci proc uses ds
;R21A  local route_buffer[IRQ_BUF_SIZE]:byte

  pusha                             ; save all general registers

;R21Aifdef USE_IRQ_TABLE
;R21A  mov   ah,PCI_FUNCTION_ID
;R21A  mov   al,GET_PCI_IRQ_ROUTING    ; get PCI irq routing options
;R21A  xor   bx,bx
;R21A  push  cs
;R21A  pop   es
;R21A  lea   di,route_buffer
;R21A  int   1ah                       ; get routing options
;R21Aelse
  push  cs
  pop   es
  lea   di,slot_id_tbl              ; load slot ID table into ES:DI
;R21Aendif

  xor   cx,cx                       ; clear count in CX

  .repeat

    mov   bh,SYS_SLOTS_INFORMATION  ; pci slot information
    mov   bl,ofs type09.slot_type   ; no other match required
    mov   al,TYPE09_SLOT_TYPE_PCI   ; has to be a PCI slot
    call  get_struct_hdr            ; get DMI structure in EDX
    jc    ut09_pci_exit             ; quit if structure not found

    push  cx
;R21Aifdef USE_IRQ_TABLE
;R21A    assm  di: ptr pci_routing_tbl
;R21A    mov   al,es:[di].device_num     ; get device number
;R21Aelse
    mov   al,byte ptr es:[di]                ; get device number
;R21Aendif
    xor   ah,ah                     ; slot id offset 0AH set to zero
    mov   bl,ofs type09.slot_id     ; offset
    mov   bh,DMI_CHANGE_WORD        ; Change single WORD
    call  update_dmi_component      ; change word in structure

    mov   bl,al                     ; put slot usage  into BL
    call  ct_get_pci_slot_usage     ; return whether slot is used or not
    mov   bl,ofs type09.current_usage ; offset
    mov   bh,DMI_CHANGE_BYTE        ; Change single BYTE
    call  update_dmi_component      ; change word in structure


;R21Aifdef USE_IRQ_TABLE
;R21A    add   di,sizeof pirq_table
;R21Aelse
    inc   di                        ; get next slot id
;R21Aendif
    pop   cx
    inc   cx
  
  .until cx >= NUM_PCI              ; instance of information

ut09_pci_exit:                      ; quit

  popa                              ; restore all general registers

  ret

update_type09_pci endp

;=============================================================================
; Utitity Functions Area
;=============================================================================

;=============================================================================
; FUNC: GET_STRUCT_HDR
;
; DESC: Get the structure header which matches the type passed in BH
;
; IN:   BH      - Type
;       CL      - Instance
;       BL      - offset for compare field
;       AL      - compare value if BL is not zero
; OUT:  EDX     - 4 byte header
;       CY      - structure not found
;=============================================================================
get_struct_hdr proc uses ds si

  call  get_struct
  .if   !carry?
    mov   edx,dptr [si]       ; put structure header in EDX
  .endif

  ret

get_struct_hdr endp

;=============================================================================
; FUNC: GET_STRUCT
;
; DESC: Get the structure header which matches the type passed in BH
;
; IN:   BH      - Type
;       CL      - Instance
;       BL      - offset for compare field
;       AL      - compare value if BL is not zero
; OUT:  DS:SI   - Structure
;       CY      - structure not found
;=============================================================================
get_struct proc uses ax bx cx dx es di 
  local dmi_struct_handle:word
  local ret_struct_hdr:dword

  mov   dmi_struct_handle,0         ; set struct handle to zero, (find first entry)

  push  ss                          ; set ES:DI to point to struct handle
  pop   es                          ; 
  lea   di,dmi_struct_handle        ; 

  mov   dx,TMP_DMI_SEG1             ; set DS:SI to point to dmiStructBuffer
  mov   ds,dx                       ; 
  mov   si,TMP_DMI_OFS1             ; 
  
  assm  si:ptr dmi_struct_hdr       ; assume si points to dmi_struct_hdr

  mov   dl,al                       ; 
  mov   dh,bh
  xor   bh,bh

  .repeat
    call  get_dmi_structure_call    ; get the dmi structure (AX modified)

    .if   [si].dmi_type == dh 

      .if bx == 0 || [si+bx] == dl  
                                    ; if dmi structure type matches type looking for
        .if cx > 0                  ; if instance counter (CX) greate than zero
          dec   cx                  ; decrement instance counter (CX)
        .else                       ; else cx == 0
          clc                       ; signal that structure found
          jmp   exit                ; exit, we found structure
        .endif                      ; endif else

      .endif

    .endif                          ; 
  .until  dmi_struct_handle == 0FFFFh   ; repeat until terminator returned

gs_error:                           ; error 

  stc                               ; signal that structure not found

exit:

  ret

get_struct endp


;=============================================================================
; FUNC: UPDATE_DMI_STRING
;
; DESC: Update DMI string with new string
;
;  IN:  DS:SI - New String
;       BL    - String Number to change
;       EDX   - Structure header
;               
; OUT:  NONE
;=============================================================================
update_dmi_string proc uses es fs

  pusha                             ; save all general registers

  xor   cx,cx                       ; clear count in cx

  push  si                          ; save string pointer SI
  .repeat                           ;
    lodsb                           ; load character into AL
    inc   cx                        ; increment CX for each character
  .until  al  == 0                  ; repeat until terminating zero found
  pop   si                          ; restore string pointer SI

  push  TMP_DMI_SEG1                ; set ES to data buffer segment 
  pop   es                          ; 
  mov   di,TMP_DMI_OFS1             ; set DI to data buffer offset

  assm  di:ptr dmi_set_struct       ; assume DI points to dmi_set_struct

  mov   es:[di].data_length,cx      ; fill in string length
  mov   es:[di].field_ofs,bl        ; field offset to modify
  mov   es:[di].command,DMI_CHANGE_STRING ; command (either change BYTE, WORD, or DWORD)
  mov   dptr es:[di].struc_type,edx ; 4 byte structure header to modify

  push  di                          ; save pointer to change string struct
  add   di,sizeof dmi_set_struct    ; point to location to copy the string
  rep   movsb                       ; copy the string
  pop   di                          ; restore pointer to change string struct
  
  push  TMP_DMI_SEG2                ; set FS to work buffer segment 
  pop   fs                          ; 
  mov   si,TMP_DMI_OFS2             ; set SI to work buffer offset

  call  set_dmi_structure_call      ; set the DMI structure
;R21 start
  jc	short @F
  or	byte ptr Post_Temp_Byte[bp],DMI_UPDATE
@@:
;R21 end

  assm   di:ptr none                ; assume nothing
  popa                              ; restore all general registers

  ret

update_dmi_string endp


;=============================================================================
; FUNC: UPDATE_DMI_COMPONENT
;
; DESC: Update DMI structure with new information
;
;  IN:  BH    - Command Type, either:
;               DMI_CHANGE_BYTE      - Change byte
;               DMI_CHANGE_WORD      - Change word
;               DMI_CHANGE_DWORD     - Change dword
;       EAX   - New Value
;       EDX   - Structure header
;       BL    - Offset of new value
;               
; OUT:  NONE
;=============================================================================
update_dmi_component proc uses es fs

  push	ds	;R27
  push	es	;R27
  pusha                             ; save all general registers

  call  get_set_dmi_buffers         ; get data buffer in ES:DI, work buffer in FS:SI

  assm  di:ptr dmi_set_struct       ; assume DI points to dmi_set_struct
  mov   es:[di].field_ofs,bl        ; field offset to modify
  mov   es:[di].command,bh          ; command (either change BYTE, WORD, or DWORD)
  mov   es:[di].change_mask,00000000h ; ANDing Mask
  mov   es:[di].change_value,eax    ; New Value (ORing Mask)
  mov   dptr es:[di].struc_type,edx ; 4 byte structure header to modify
  
  call  set_dmi_structure_call      ; set the DMI structure
;R17 start
;R21  or	ax,ax
;R21  jnz	short udc_exit
  jc	short udc_exit		;R21
  or	byte ptr Post_Temp_Byte[bp],DMI_UPDATE
;R17 end

udc_exit:

  assm   di:ptr none                ; assume nothing
  popa                              ; restore all general registers
  pop	es	;R27
  pop	ds	;R27

  ret

update_dmi_component endp


;=============================================================================
; FUNC: GET_SET_DMI_BUFFERS
;
; DESC: Setup pointer to work buffer for function: SET_DMI_STRUCTURE_CALL
;       
; IN:   NONE
; OUT:  ES:DI - Data Buffer
;       FS:SI - Work Buffer
; R10   Do not use TMP_DMI_SEG2 for anything other than the work buffer segment
;=============================================================================
get_set_dmi_buffers proc

  push  TMP_DMI_SEG1                ; set ES to data buffer segment 
  pop   es                          ; 
  mov   di,TMP_DMI_OFS1             ; set DI to data buffer offset
  push  TMP_DMI_SEG2                ; set FS to work buffer segment 
  pop   fs                          ; 
  mov   si,TMP_DMI_OFS2             ; set SI to work buffer offset

  ret

get_set_dmi_buffers endp

;=============================================================================
; FUNC: SHOW_ONE_DOT
;
; DESC: Show one dot on the screen
;
; IN:   NONE
; OUT:  NONE
;=============================================================================
show_one_dot proc uses ax si ds

ifndef No_show_Updata_DMI_Msg	;R25
  mov   ax, cs
  mov   ds, ax
  mov   si, offset XGROUP:one_struct_msg
  POST_func_call  Disp_String
endif ;No_show_Updata_DMI_Msg	;R25

  ret

show_one_dot endp


;=============================================================================
; FUNC: SHOW SUCCESS MSG
;
; DESC: Show one dot on the screen
;
; IN:   NONE
; OUT:  NONE
;=============================================================================
show_success_msg proc uses ax si ds

ifndef No_show_Updata_DMI_Msg	;R25
  mov   si,offset XGROUP:success_msg
  mov   ax,cs
  mov   ds,ax
	POST_func_call	Disp_String

;  call  disp_str_in_post            ; display success for building
;  call  F000_Vcrlf
endif ;No_show_Updata_DMI_Msg	;R25

  ret

show_success_msg endp

;=============================================================================
; FUNC: CLEAR_LINE
;
; DESC: Clear Line
;
; IN:   NONE
; OUT:  NONE
;=============================================================================
clear_line proc uses ax si ds

ifndef No_show_Updata_DMI_Msg	;R25
  mov   si,offset XGROUP:new_line_msg
  mov   ax,cs
  mov   ds,ax
	POST_func_call	Disp_String
endif ;No_show_Updata_DMI_Msg	;R25

  ret

clear_line endp


;=============================================================================
; FUNC: UPDATE_DMI_STATE
;
; DESC: Set the current DMI update state
;
; IN:   BH    - And Value
;       BL    - Or Value
; OUT:  NONE
;=============================================================================
update_dmi_state proc uses ax

  call  get_dmi_state
  and   ah,bh                     ; clear
  or    al,bl                     ; set
  call  set_dmi_state

  ret

update_dmi_state endp


;=============================================================================
; FUNC: GET_DMI_STATE
;
; DESC: Get the current DMI update state
;
; IN:   NONE
; OUT:  AL    - Current State
;=============================================================================
get_dmi_state proc uses ds bx

  mov   bx,G_RAM
  mov   ds,bx
;R19  mov   bx,DMI_STATE
;R19   mov   al,[bx]
  mov	al,ds:DMI_STATE	;R19

  ret

get_dmi_state endp

;=============================================================================
; FUNC: SET_DMI_STATE
;
; DESC: Set the current DMI update state
;
; IN:   AL    - New State
; OUT:  NONE
;=============================================================================
set_dmi_state proc uses ds bx

  mov   bx,G_RAM
  mov   ds,bx
;R19  mov   bx,DMI_STATE
;R19  mov   [bx],al
  mov	ds:DMI_STATE,al	;R19

  ret

set_dmi_state endp


cpuid macro
  db  0Fh
  db  0A2h
endm

;=============================================================================
; FUNC: CT_GET_PROCESSOR_ID_LO
;
; DESC: Get the processor ID in EAX
;
; IN:   NONE
; OUT:  EAX  - Processor ID
;=============================================================================
ct_get_processor_id_lo proc uses edx

  mov   eax,1                     ; signal to return information
;R37 start
	;--- if not set CPU ID (e.g. CYRIX CPU) in DMI pool then LDCM can't
	;--- show processor information in Basic Hardware component
	cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_CYRIX
	je	short @F
;R37 end
  cpuid

@@:
  ret

ct_get_processor_id_lo endp

;=============================================================================
; FUNC: CT_GET_PROCESSOR_ID_HI
;
; DESC: Get the processor ID in EAX
;
; IN:   NONE
; OUT:  EAX  - Processor ID
;=============================================================================
ct_get_processor_id_hi proc uses edx

  mov   eax,1                     ; signal to return information
;R37 start
	;--- if not set CPU ID (e.g. CYRIX CPU) in DMI pool then LDCM can't
	;--- show processor information in Basic Hardware component
	cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_CYRIX
	je	short @F
;R37 end
  cpuid
  mov   eax,edx

@@:
  ret

ct_get_processor_id_hi endp


;=============================================================================
; FUNC: CT_GET_PCI_SLOT_USAGE
;
; DESC: Get whether the PCI slot is in use
;
; IN:   BL      - Device / Function Number
; OUT:  AL      - slot usage
;=============================================================================
ct_get_pci_slot_usage proc uses bx cx di

  assm  di: ptr pci_routing_tbl

  mov   ah,PCI_FUNCTION_ID
  mov   bh,0                        ; bus number
  mov   di,DEVICE_ID                ; register number
  mov   al,09h
  int   1ah

  .if   cx  == 0FFFFh               ; if slot is empty
    mov   al,TYPE09_USAGE_AVAILABLE ; slot is available
  .else
    mov   al,TYPE09_USAGE_INUSE     ; slot is in use
  .endif

  ret

ct_get_pci_slot_usage endp

;=============================================================================
; FUNC: SET_DMI_STRUCTURE_CALL
;
; DESC: Add new DMI structure to structure pool by calling DMI function
;       52h, Add DMI structure
;
; IN:   CX    - size of structure to add 
;       ES:DI - Data Buffer
;       FS:SI - Work Buffer
; OUT:  AX    - Return Code
;       00h   - Function Completed Successfully
;       83h   - Invalid handle
;       84h   - Invalid parameter
;       87h   - Insufficient storage space
;=============================================================================

set_dmi_structure_call proc uses bx

;R21  push  0F000h                      ; BiosSelector
;R21  push  0F000h                      ; DMISelector

  xor   ah,ah
  call  get_dmi_state                                                        ; R10
  mov   bl,al                       ; save state variable                    ; R11
  and   al,SET_INFO                 ; seperate out state info                ; R11
  .if   al == FIRST_SET                                                      ; R10
                                                                             ; R10
    mov   bh,SET_INFO_MASK           ; and                             R11
    mov   bl,MIDDLE_SET             ; or  - dont read or flash        R11
    call  update_dmi_state          ; set state variable for updates  R11

    mov   al,0                      ; Read in pool, don't flash              ; R10
                                                                             ; R10
  .elseif al == LAST_SET                                                     ; R10
    mov   al,SET_DMI_POOL+DONT_READ_IN_POOL ; Don't Read in pool, flash      ; R10
                                                                             ; R10
    .if   bl & UPDATE_DMI_POOL                                               ; R11
      or    al,FORCE_UPDATE         ; Force update of POOL, even if no change; R11
    .endif                                                                   ; R10
                                                                             ; R10
  .elseif al == MIDDLE_SET                                                                      ; R10
    mov   al,DONT_READ_IN_POOL      ; Don't Read in pool, don't flash        ; R10
  .else
    mov   al,SET_DMI_POOL           ; normal operation
  .endif                                                                     ; R10

;R21  push  ax                          ; Control - Set structure immediately

;R21  push  fs                          ; work buffer segment 
;R21  push  si                          ; work buffer offset
;R21  push  es                          ; data buffer segment
;R21  push  di                          ; data buffer offset
;R21  push  DFN_SET_DMI_STRUCT          ; set dmi structure - add structure
;R21  FAR_CALL  <offset PNP_BIOS_Real>, 0F000h
;R21  add   sp,16                       ; 
	call	Set_DMI_to_Temp_Pool	;R21

;R21  .if   ax == DMI_SUCCESS               ; if function was successful      R11
	pushf				;R21
    mov   bh,0FFh
    mov   bl,UPDATE_DMI_POOL        ; Update DMI pool at end of POST  R11
    call  update_dmi_state          ; Set DMI POST State variable     R11
	popf				;R21
;R21  .endif

  ret

set_dmi_structure_call endp

;R21 start
;Input	: ES:DI = data buffer address
Set_DMI_to_Temp_Pool:
		push	ds
		pusha

		mov	ax,Temp_DMI_Pool_SEG
		mov	ds,ax
		mov	si,Temp_DMI_Pool_OFF
		mov	dword ptr ds:[si],DMI_SIGNATURE
		add	si,DMI_SIGNATURE_SIZE
		mov	ax,word ptr ds:[si]		;DMI pool total number structures
		mov	bx,word ptr ds:[si+2]		;DMI pool maximum size structures
		add	si,DMI_INFO_SIZE
Check_Next_Struct:
		mov	dh,byte ptr es:[di].command
		mov	cx,word ptr ds:[si]
		add	si,2				;point to struct start
		cmp	cx,0ffffh
		je	short No_else_struct
		mov	dl,byte ptr ds:[si].dmi_handle	;get struct handle
		cmp	dl,byte ptr es:[di].struc_handle
		je	short Set_DMI_Struct
		add	si,cx
		jmp	short Check_Next_Struct
No_else_struct:
		cmp	dh,DMI_ADD_STRUCT
		jne	SDTP_Exit
		mov	cx,word ptr es:[di].data_length
		mov	word ptr ds:[si-2],cx

		cmp	ax,0ffffh			;DMI pool num_structs is invalid?
		jne	short @F			;No,jump
		xor	ax,ax				;clear DMI pool num_structs
@@:
		inc	ax
		mov	word ptr ds:[Temp_DMI_Pool_OFF+DMI_SIGNATURE_SIZE].num_structs,ax

		cmp	bx,0ffffh			;DMI pool max_struct_size is invalid?
		je	short update_max_struct_size	;Yes,jump
		cmp	bx,cx				;new struct size less than max_struct_size
		jae	short @F			;Yes,skip don't update max_struct_size
update_max_struct_size:
		mov	word ptr ds:[Temp_DMI_Pool_OFF+DMI_SIGNATURE_SIZE].max_struct_size,cx
@@:

		add	di,size dmi_set_struct-size dmi_struct_hdr
;R28 LDCM-start
		movzx	bx,byte ptr es:[di].dmi_len
		xor	dx,dx
		push	si
		push	cx
;R28 LDCM-end
@@:
		mov	al,byte ptr es:[di]
;R28 LDCM-start
		cmp	cx,1				;string terminator signature
		je	short Not_Str_Start		;Yes,skip
		or	bx,bx				;string start offset
		jnz	short Not_Str_Start		;No,skip
		inc	bl
		inc	dh				;increase string counter
		or	al,al				;Is string terminator
		jnz	short Not_Str_Start		;No,skip
		cmp	dh,1				;Null string?
		mov	dh,0				;Clear string counter
		jne	short Not_Str_Start		;Not null string then skip
		mov	byte ptr ds:[si],' '		;Force store space char
		inc	si
		inc	dl
Not_Str_Start:
		dec	bx
;R28 LDCM-end
		mov	byte ptr ds:[si],al
		inc	si
		inc	di
		loop	@B
;R28 LDCM-start
		pop	cx
		pop	si
		xor	dh,dh
		add	cx,dx
		mov	word ptr ds:[si-2],cx
		cmp	word ptr ds:[Temp_DMI_Pool_OFF+DMI_SIGNATURE_SIZE].max_struct_size,cx
		jae	short @F
		mov	word ptr ds:[Temp_DMI_Pool_OFF+DMI_SIGNATURE_SIZE].max_struct_size,cx
@@:
;R28 LDCM-end
		clc
		jmp	SDTP_Exit
Set_DMI_Struct:
		movzx	bx,byte ptr es:[di].field_ofs
		mov	eax,dword ptr es:[di].change_mask
		mov	ecx,dword ptr es:[di].change_value
		cmp	dh,DMI_CHANGE_BYTE
		jne	short Not_CHANGE_BYTE
		mov	ah,al
		not	ah
		and	ah,byte ptr ds:[si][bx]
		cmp	ah,cl
		stc
		je	SDTP_Exit
		and	byte ptr ds:[si][bx],al
		or	byte ptr ds:[si][bx],cl
		clc
		jmp	SDTP_Exit
Not_CHANGE_BYTE:
		cmp	dh,DMI_CHANGE_WORD
		jne	short Not_CHANGE_WORD
		mov	di,ax
		not	di
		and	di,word ptr ds:[si][bx]
		cmp	di,cx
		stc
		je	SDTP_Exit
		and	word ptr ds:[si][bx],ax
		or	word ptr ds:[si][bx],cx
		clc
		jmp	SDTP_Exit
Not_CHANGE_WORD:
		cmp	dh,DMI_CHANGE_DWORD
		jne	short Not_CHANGE_DWORD
		mov	edi,eax
		not	edi
		and	edi,dword ptr ds:[si][bx]
		cmp	edi,ecx
		stc
		je	SDTP_Exit
		and	dword ptr ds:[si][bx],eax
		or	dword ptr ds:[si][bx],ecx
		clc
		jmp	SDTP_Exit
Not_CHANGE_DWORD:
		cmp	dh,DMI_ADD_STRUCT
		jne	short Not_ADD_STRUCT

		stc
		jmp	SDTP_Exit
Not_ADD_STRUCT:
		cmp	dh,DMI_DEL_STRUCT
		jne	short Not_DEL_STRUCT

		stc
		jmp	SDTP_Exit
Not_DEL_STRUCT:
		cmp	dh,DMI_CHANGE_STRING
		jne	Not_CHANGE_STRING
;----- Temp DMI pool change string function -----
		push	si				;store struct start offset
		mov	al,byte ptr ds:[si][bx]		;get string number
		movzx	cx,byte ptr ds:[si].dmi_len	;get struct length
		add	si,cx
Search_next_match_string:
		push	si
		xor	ah,ah				;assume string same
		mov	bx,size	dmi_set_struct
@@:
		mov	dl,byte ptr ds:[si]
		cmp	dl,byte ptr es:[di][bx]
		je	short String_Char_Same
		or	ah,1
String_Char_Same:
		cmp	byte ptr ds:[si],0
		je	short @F
		inc	si
		inc	bx
		jmp	short @B
@@:
		pop	cx
		dec	al
		jz	short get_string_start_offset
		inc	si
		jmp	short Search_next_match_string
get_string_start_offset:
		pop	bx			;restore struct start offset to BX
		or	ah,ah
		jnz	short @F
		stc
		jmp	short SDTP_Exit
@@:
		push	cx			;store change string offset
		mov	ax,si
		sub	ax,cx
		inc	ax
		mov	cx,word ptr es:[di].data_length
		sub	cx,ax
		pushf				;R24
		add	word ptr ds:[bx-2],cx	;adjust struct total length
		popf				;R24
		jz	short override_string
		jc	short over_original_string
		mov	ax,cx
		push	es
		push	di
		mov	di,Temp_DMI_Pool_OFF+DMI_MAX_POOL_SIZE-1
		mov	cx,di
		sub	cx,si
		sub	cx,ax
		mov	si,di
		sub	si,ax
		push	ds
		pop	es
		std
		rep	movsb
		pop	di
		pop	es
		jmp	short override_string
over_original_string:



		pop	cx
		push	cx
		add	cx,word ptr es:[di].data_length
		push	es
		push	di
		mov	di,cx
		mov	cx,Temp_DMI_Pool_OFF+DMI_MAX_POOL_SIZE-1
		sub	cx,si
		inc	si
		push	ds
		pop	es
		rep	movsb
		pop	di
		pop	es





override_string:
		pop	si
		mov	bx,size	dmi_set_struct
		mov	cx,word ptr es:[di].data_length
@@:
		mov	al,byte ptr es:[di][bx]
		mov	byte ptr ds:[si],al
		inc	si
		inc	bx
		loop	@B
		cld
		clc
		jmp	short SDTP_Exit
Not_CHANGE_STRING:

SDTP_Exit:
		popa
		pop	ds
		ret
;R21 end

;=============================================================================
; FUNC: GET_DMI_STRUCTURE_CALL
;
; DESC: Get the DMI structure
;
; IN:   ES:DI - Structure
;       DS:SI - dmiStrucBuffer
; OUT:  AX    - Return Code
;       00h   - Function Completed Successfully
;       83h   - Invalid handle
; MODIFIED: Structure       - Contains handle to next available structure
;           dmiStructBuffer - Contains the Structure requested
;=============================================================================
get_dmi_structure_call proc
;R21 start
		push	ds
		pusha
		mov	al,DMI_INVALID_HANDLE
		push	es
		push	di
		mov	dx,word ptr es:[di]
		mov	bx,0ffffh
		mov	di,Temp_DMI_Pool_SEG
		mov	es,di
		mov	di,Temp_DMI_Pool_OFF
		cmp	dword ptr es:[di],DMI_SIGNATURE
		jne	short GDSC_exit
		add	di,DMI_SIGNATURE_SIZE+size dmi_info_struct
		xor	ah,ah
Get_Struct_Loop:
		mov	cx,word ptr es:[di]
		cmp	cx,0ffffh
		je	short Scan_Over
		add	di,2
		or	dx,dx
		jz	short Got_First_Struct
		cmp	word ptr es:[di].dmi_handle,dx
		jne	short Not_got_struct
Got_First_Struct:
		or	ah,ah			;if got it?
		jnz	short Not_got_struct	;Yes,dont duplicate got it
		push	cx
		push	si
		push	di
@@:
		mov	al,byte ptr es:[di]
		mov	byte ptr ds:[si],al
		inc	si
		inc	di
		loop	@B

		pop	di
		pop	si
		pop	cx
		or	ah,1			;got struct component
Not_got_struct:
		cmp	word ptr es:[di].dmi_handle,dx
		jbe	short Next_Struct
		cmp	word ptr es:[di].dmi_handle,bx
		jae	short Next_Struct
		mov	bx,word ptr es:[di].dmi_handle
Next_Struct:
		add	di,cx
		cmp	di,Temp_DMI_Pool_OFF+DMI_MAX_POOL_SIZE
		jb	short Get_Struct_Loop
Scan_Over:
		mov	al,DMI_SUCCESS
GDSC_exit:
		pop	di
		pop	es
		mov	word ptr es:[di],bx
		xor	ah,ah
		mov	ds,ax
		popa
		mov	ax,ds
		pop	ds
;R21 end

;R21  push  0F000h                      ; BiosSelector
;R21  push  0F000h                      ; DMISelector
;R21  push  ds                          ; seg of dmiStrucBuffer
;R21  push  si                          ; ofs of dmiStrucBuffer
;R21  push  es                          ; seg of Structure
;R21  push  di                          ; ofs of Structure
;R21  push  DFN_GET_DMI_STRUCT          ; Get dmi structure (51h)
;R21  FAR_CALL  <offset PNP_BIOS_Real>, 0F000h  ; 
;R21  add   sp,14                       ; 
  ret

get_dmi_structure_call endp
        
; R08 - This function not currently needed                               
;=============================================================================
; FUNC: GET_DMI_INFORMATION_CALL
;
; DESC: Get the DMI information
;
; IN:   ES:0  - Structure Segment
; OUT:  AX    - Return Code
;=============================================================================
; get_dmi_information_call proc
; 
;   push  0F000h                         ; BiosSelector
;   push  es                             ; 
;   push  ofs get_dmi_info.storage_size  ; DMIStorageSize
;   push  es                             ; 
;   push  ofs get_dmi_info.storage_base  ; DMIStorageBase
;   push  es                             ; 
;   push  ofs get_dmi_info.struc_size    ; StructureSize
;   push  es                             ; 
;   push  ofs get_dmi_info.num_struc     ; NumStructures
;   push  es                             ; 
;   push  ofs get_dmi_info.bios_rev      ; DMIBIOSRevision
;   push  DFN_GET_DMI_INFO               ; Get DMI Information (50h)
;   FAR_CALL  <offset PNP_BIOS_Real>, 0F000h ; 
;   add   sp,24                          ; 
; 
;   ret
; 
; get_dmi_information_call endp
; R08 - End

Public  END_DMI_POST              ; Used to track overall size of
END_DMI_POST LABEL BYTE           ;  DMI Post 

XCODE    ENDS
endif   ; DMI_ENABLED

END
