;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R03	11/14/97 BAR	Added IMT 29F002T EEPROM support.
;R02	03/21/97 AVN	Added MXIC 28F002TTC EEPROM support.
;R01	03/07/97 AVN	Added MXIC 28F2000TPC EEPROM support.

		include	btromseg.equ
		include	ROMLEN.INC

ifdef	FLASH_SUPPORT
ifdef	Flash_2M_support
ifdef	Flash_16K_8K_8K_Unit
SST_29EE020_Start:
		include	sst020.nvm
SST_29EE020_End:
AMD_29F002T_Start:
		include	am29f002.nvm
AMD_29F002T_End:
ATMEL_29C020_Start:
		include	atmel020.nvm
ATMEL_29C020_End:
INTEL_28F002BXT_Start:
		include	f002bxt.nvm
INTEL_28F002BXT_End:
MXIC_28F2000PPC_Start:					;R01
		include	mx2mppc.nvm			;R01
MXIC_28F2000PPC_End:					;R01
MXIC_28F002TTC_Start:					;R02
		include	mx2mttc.nvm			;R02
MXIC_28F002TTC_End:					;R02

IMT_29F002T_Start:					;R03
		include	im29f002.nvm			;R03
IMT_29F002T_End:					;R03

SST_29EE020_LEN			EQU	offset SST_29EE020_End - offset SST_29EE020_Start
SST_29EE020_WRITE_OFFSET	EQU	offset SST020_Flash_Write - offset SST020_Flash_Erase
AMD_29F002T_LEN			EQU	offset AMD_29F002T_End - offset AMD_29F002T_Start
AMD_29F002T_WRITE_OFFSET	EQU	offset AM29F002T_Flash_Write - offset AM29F002T_Flash_Erase
ATMEL_29C020_LEN		EQU	offset ATMEL_29C020_End - offset ATMEL_29C020_Start
ATMEL_29C020_WRITE_OFFSET	EQU	offset ATMEL29C020_Flash_Write - offset ATMEL29C020_Flash_Erase
INTEL_28F002BXT_LEN		EQU	offset INTEL_28F002BXT_End - offset INTEL_28F002BXT_Start
INTEL_28F002BXT_WRITE_OFFSET	EQU	offset F002BXT_Flash_Write - offset F002BXT_Flash_Erase
MXIC_28F2000PPC_LEN		EQU	offset MXIC_28F2000PPC_End - offset MXIC_28F2000PPC_Start		;R01
MXIC_28F2000PPC_WRITE_OFFSET	EQU	offset MX_28f2000PPC_Flash_Write - offset MX_28f2000PPC_Flash_Erase	;R01
MXIC_28F002TTC_LEN		EQU	offset MXIC_28F002TTC_End - offset MXIC_28F002TTC_Start			;R02
MXIC_28F002TTC_WRITE_OFFSET	EQU	offset MX_28f002TTC_Flash_Write - offset MX_28F002TTC_Flash_Erase	;R02
IMT_29F002T_LEN			EQU	offset IMT_29F002T_End - offset IMT_29F002T_Start
IMT_29F002T_WRITE_OFFSET	EQU	offset IMT_29F002T_Flash_Write - offset IMT_29F002T_Flash_Erase

FLASH_CODE_SIZE_ERROR	=	0
IF	SST_29EE020_LEN GT _2M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	1
ENDIF
IF	AMD_29F002T_LEN GT _2M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	2
ENDIF
IF	ATMEL_29C020_LEN GT _2M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	3
ENDIF
IF	INTEL_28F002BXT_LEN GT _2M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	4
ENDIF
IF	MXIC_28F2000PPC_LEN GT _2M_EEPROM_LEN		;R01
FLASH_CODE_SIZE_ERROR	=	5			;R01
ENDIF							;R01
IF	MXIC_28F002TTC_LEN GT _2M_EEPROM_LEN		;R02
FLASH_CODE_SIZE_ERROR	=	6			;R02
ENDIF							;R02
IF	IMT_29F002T_LEN GT _2M_EEPROM_LEN		;R03
FLASH_CODE_SIZE_ERROR	=	7			;R03
ENDIF							;R03

IF	FLASH_CODE_SIZE_ERROR	EQ	1
%OUT	ERROR: SST020.NVM code size is more then prepare in ROMLEN.INC
%OUT	       Please increase size in ROMLEN.INC
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	2
%OUT	ERROR: AM29F002.NVM code size is more then prepare in ROMLEN.INC
%OUT	       Please increase size in ROMLEN.INC
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	3
%OUT	ERROR: ATMEL020.NVM code size is more then prepare in ROMLEN.INC
%OUT	       Please increase size in ROMLEN.INC
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	4
%OUT	ERROR: F002BXT.NVM code size is more then prepare in ROMLEN.INC
%OUT	       Please increase size in ROMLEN.INC
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	5					;R01
%OUT	ERROR: MX2MPPC.NVM code size is more then prepare in ROMLEN.INC		;R01
%OUT	       Please increase size in ROMLEN.INC				;R01
ENDIF										;R01

IF	FLASH_CODE_SIZE_ERROR	EQ	6					;R02
%OUT	ERROR: MX2MTTC.NVM code size is more then prepare in ROMLEN.INC		;R02
%OUT	       Please increase size in ROMLEN.INC				;R02
ENDIF										;R02

IF	FLASH_CODE_SIZE_ERROR	EQ	7					;R03
%OUT	ERROR: IMT002T.NVM code size is more then prepare in ROMLEN.INC		;R03
%OUT	       Please increase size in ROMLEN.INC				;R03
ENDIF

elseifdef	Flash_4K_Unit
MXIC_28F2000PPC_Start:
		include	mx2mppc.nvm
MXIC_28F2000PPC_End:

MXIC_28F2000PPC_LEN		EQU	offset MXIC_28F2000PPC_End - offset MXIC_28F2000PPC_Start
MXIC_28F2000PPC_WRITE_OFFSET	EQU	offset MX_28f2000PPC_Flash_Write - offset MX_28f2000PPC_Flash_Erase

FLASH_CODE_SIZE_ERROR	=	0
IF	MXIC_28F2000PPC_LEN GT _2M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	1
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	1
%OUT	ERROR: MX2MPPC.NVM code size is more then prepare in ROMLEN.INC
%OUT	       Please increase size in ROMLEN.INC
ENDIF

endif;	Flash_16K_8K_8K_Unit
else;	Flash_2M_support
ifdef	Flash_4K_Unit
SST_29EE010_Start:
		include	sst010.nvm
SST_29EE010_End:
INTEL_28F001BXT_Start:
		include	f001bxt.nvm
INTEL_28F001BXT_End:
MXIC_28F1000_Start:
		include	mxic.nvm
MXIC_28F1000_End:

SST_29EE010_LEN			EQU	offset SST_29EE010_End - offset SST_29EE010_Start
SST_29EE010_WRITE_OFFSET	EQU	offset SST010_Flash_Write - offset SST010_Flash_Erase
INTEL_28F001BXT_LEN		EQU	offset INTEL_28F001BXT_End - offset INTEL_28F001BXT_Start
INTEL_28F001BXT_WRITE_OFFSET	EQU	offset F001BXT_Flash_Write - offset F001BXT_Flash_Erase
MXIC_28F1000_LEN		EQU	offset MXIC_28F1000_End - offset MXIC_28F1000_Start
MXIC_28F1000_WRITE_OFFSET	EQU	offset MXIC_Flash_Write - offset MXIC_Flash_Erase

FLASH_CODE_SIZE_ERROR	=	0
IF	SST_29EE010_LEN	GT _1M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	1
ENDIF
IF	INTEL_28F001BXT_LEN GT _1M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	2
ENDIF
IF	MXIC_28F1000_LEN GT _1M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	3
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	1
%OUT	ERROR: SST010.NVM code size is more then prepare in ROMLEN.INC
%OUT	       Please increase size in ROMLEN.INC
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	2
%OUT	ERROR: F001BXT.NVM code size is more then prepare in ROMLEN.INC
%OUT	       Please increase size in ROMLEN.INC
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	3
%OUT	ERROR: MXIC.NVM code size is more then prepare in ROMLEN.INC
%OUT	       Please increase size in ROMLEN.INC
ENDIF

elseifdef	Flash_16K_Unit
AMD_29F010_Start:
		include	amd29f.nvm
AMD_29F010_End:
MXIC_28F1000_Start:
		include	mxic.nvm
MXIC_28F1000_End:

AMD_29F010_LEN			EQU	offset AMD_29F010_End - offset AMD_29F010_Start
AMD_29F010_WRITE_OFFSET		EQU	offset AMD29F_Flash_Write - offset AMD29F_Flash_Erase
MXIC_28F1000_LEN		EQU	offset MXIC_28F1000_End - offset MXIC_28F1000_Start
MXIC_28F1000_WRITE_OFFSET	EQU	offset MXIC_Flash_Write - offset MXIC_Flash_Erase

FLASH_CODE_SIZE_ERROR	=	0
IF	AMD_29F010_LEN GT _1M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	1
ENDIF
IF	MXIC_28F1000_LEN GT _1M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	2
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	1
%OUT	ERROR: AMD29F.NVM code size is more then prepare in ROMLEN.INC
%OUT	       Please increase size in ROMLEN.INC
ENDIF
IF	FLASH_CODE_SIZE_ERROR	EQ	2
%OUT	ERROR: MXIC.NVM code size is more then prepare in ROMLEN.INC
%OUT	       Please increase size in ROMLEN.INC
ENDIF

endif;	Flash_4K_Unit
endif;	Flash_2M_support
endif;	FLASH_SUPPORT
