;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R02	12/26/95 ROB	Update for EISA/PNP.
;R01	OCT-15-90 SMS	adding copyright stmt.
		PAGE	56,132
;		TITLE	EISAMAIN.INC  -- 386/486 EISA ROM/BIOS 


;[]--------------------------------------------------------------------------[]
;
; This file contains the stack structure used for passing the register
; parameters for the INT 15H D8 16-bit subfunctions.  For an explanation
; of the actual register parameters for each call, see the EISA specification
; 3.10 section 4.8.
;
; Author: David Korst
; Date: Apr 11, 1990
;
; Name	| Date		| Description
; -----------------------------------------------------------------------------
; DWK	| 04/11/90	| Initial version
;
;[]============================================================================
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; STRUCTURES  -  These are created to obtain offsets to the input and output
;		 parameters which are stored on the stack.  Both of these 
;		 strucs are essentially the same area, pointed at by BP,
;		 on the stack.  The EQUs INREG/OUTREG (sans s) are used
;		 for the actual structure names.
;
;		 The initial regs for INREGS must be pushed
;		 onto the stack in the correct order and output regs from
;		 OUTREGS must be popped off the stack in the reverse order.
;
;
INREGS	STRUC			;This is the input parameter structure
SEG_TYPE	DB	?	;Bit 7 set if 32 bit segment		;AL
		DB	?						;AH
REVNUM_MIN	DB	?						;BL
REVNUM_MAJ	DB	?						;BH
SLOT_NUM	DB	?						;CL
FUNC_NUM	DB	?						;CH
		DW	?						;DX
		DW	?						;DI
NVM_INFO_ADDR	DW	?						;SI
INREGS		ENDS


OUTREGS	STRUC			;This is the output parameter structure
DUP_ID_NUM	DB	?						;AX
ERROR_CODE	DB	?	;AH
REV_MIN		DB	?						;BX
REV_MAJ		DB	?
NVM_CHKSUM	DW	?						;CX
FUNC_INFO_BYTE	DB	?						;DL
NUM_FUNCS	DB	?						;DH
ID_0		DB	?						;DI
ID_1		DB	?
ID_2		DB	?						;SI
ID_3		DB	?
OUTREGS		ENDS

;R02OUTREG		EQU	<[BP]>
;R02INREG		EQU	<[BP]>
OUTREG		EQU	<[EBP]>			;R02
INREG		EQU	<[EBP]>			;R02
;
;
