;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R01	OCT-15-90 SMS	adding copyright stmt.
;----------------------------------------------------------------------------
		PAGE	56,132
;		TITLE	EISA_32.INC  -- 386/486 EISA ROM/BIOS 


;[]--------------------------------------------------------------------------[]
;
; This file contains the stack structures used to pass register parameters
; used in the INT 15H D8 subfunctions.  These structures are for 32-bit mode
; only.
;
; Author: David Korst
; Date: April 11, 1990
;
; Name	| Date		| Description
; -----------------------------------------------------------------------------
; DWK	| 04/11/90	| Initial version
;
;[]============================================================================
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; STRUCTURES  -  These are created to obtain offsets to the input and output
;		 parameters which are stored on the stack.  Both of these 
;		 strucs are essentially the same area, pointed at by BP,
;		 on the stack.  The EQUs INREG/OUTREG (sans s) are used
;		 for the actual strucure names.
;
;		 The initial regs for INREGS must be pushed
;		 onto the stack in the correct order and output regs from
;		 OUTREGS must be popped off the stack in the reverse order.
;
;	These strucs are to be used for the 32-bit code.  They are the same
;	as those used for 16-bit code except they are padded to use 32-bit
;	register pushes.
;
INREGS	STRUC			;This is the input parameter structure
SEG_TYPE	DB	?						;AL
		DB	?						;AH
		DW	?

REVNUM_MIN	DB	?						;BL
REVNUM_MAJ	DB	?						;BH
		DW	?

SLOT_NUM	DB	?						;CL
FUNC_NUM	DB	?						;CH
		DW	?

		DD	?						;EDX
		DD	?						;EDI
NVM_INFO_ADDR	DD	?						;ESI
INREGS		ENDS


OUTREGS	STRUC			;This is the output parameter structure
DUP_ID_NUM	DB	?						;EAX
ERROR_CODE	DB	?	;AH
		DW	?

REV_MIN		DB	?						;EBX
REV_MAJ		DB	?
		DW	?

NVM_CHKSUM	DW	?						;ECX
		DW	?

FUNC_INFO_BYTE	DB	?						;DL
NUM_FUNCS	DB	?						;DH
		DW	?

ID_0		DB	?						;EDI
ID_1		DB	?
		DW	?

ID_2		DB	?						;ESI
ID_3		DB	?
		DW	?
OUTREGS		ENDS

OUTREG		EQU	<[EBP]>
INREG		EQU	<[EBP]>
