;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;		INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE
;		DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED
;		WRITTEN AUTHORIZATION FROM THE OWNER.
;
;	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R04	07/30/97 KEN	Added 60h/64h I/O trapping codes.
;R03	04/09/97 KEN	Fixed bug for supporting multiple hub.
;R02	04/07/97 KEN	Add TimerTask to solve the CMD keyboard problem.
;R01	03/26/97 KEN	Add OHCI supporting.
;R00	01/16/97 KEN	New USBBIOS structure to support HUB and multiple
;			keyboard. The old files is backup as USB0116.zip.

;************************************************************************
;*									*
;*	USB_RAM DEFINITION						*
;*									*
;************************************************************************

ifdef	UHCI	;R01

Usb_Head	db	8 dup(?)	;expansion ROM header

bUsbFlag	db	?
wHostID 	dw	?

dUsbRamAddr	dd	?
dFrameListAddr	dd	?

wHostIoBase	dw	?		;host I/O port base address

wPort1Status	dw	?		;root hub port 1 status
wPort2Status	dw	?		;root hub port 2 status

bLedStatus	db	?		;keyboard LED backup

wCtrlBuffMap	dw	?					;R03
ControlBuffer	db	(SIZE CTLPARA)*MAX_CTLBUFF dup(?)	;R03
;R03ControlBuffer1	db	SIZE CTLPARA dup(?)
;R03ControlBuffer2	db	SIZE CTLPARA dup(?)

HubCtrlBuffer	db	(SIZE HUBCTRL)*MAX_HUB dup(?)
KbdCtrlBuffer	db	(SIZE KBDCTRL)*MAX_KBD dup(?)

wTaskLink	dw	?
SysCtrlTask	db	SIZE TASK dup(?)		;system control task
TimerTask	db	SIZE TASK dup(?)		;R02
HubIntTask	db	(SIZE TASK)*MAX_HUB dup(?)	;hub data in task
KbdIntTask	db	(SIZE TASK)*MAX_KBD dup(?)	;keyboard data in task
MsIntTask	db	(SIZE TASK)*MAX_MS dup(?)	;mouse data in task

DevAddrMap	db	128*2 dup(?)	;device address map
					;byte0.7:address occupied
					;byte0.0-6:parent device address
					;byte1.4-7:reserved
					;byte1.0-2:parent hub port
wHubDevMap	dw	?		;occupied hub device map
wKbdDevMap	dw	?		;occupied keyboard device map
wMsDevMap	dw	?		;occupied mouse device map

RequestBuffer	db	SIZE DEVREQ dup(?)

DevDespBuffer	db	12h dup(?)
CfgDespBuffer	db	MAX_DESP_LEN dup(?)
ClassDespBuffer db	MAX_DESP_LEN dup(?)
MiscDataBuffer	db	256 dup(?)

HubDataBuffer	db	8*MAX_HUB dup(?)
KbdDataBuffer	db	8*MAX_KBD dup(?)
MsDataBuffer	db	8*MAX_MS dup(?)

;R04 - begin
bUsbLedCmd	db	?
UsbWfp		db	?
KbcProc 	dw	?
CmdProc 	dw	?
ActivePort	db	?
IoTrapData	db	?
SearchTbl	dw	?
Read60		db	?
TrapByStatus	db	?
Status8042	db	?
CmdCnt		dw	?

CMDCAP		EQU	4
CMDNUM		EQU	2
CMDSCR		EQU	1
;R04 - end

		align	16
KbdIntQH	db	16*MAX_KBD dup(?)
		align	16
KbdIntTD	db	16*MAX_KBD dup(?)

		align	16
MsIntQH 	db	16*MAX_MS dup(?)
		align	16
MsIntTD 	db	16*MAX_MS dup(?)

		align	16
HubIntQH	db	16*MAX_HUB dup(?)
		align	16
HubIntTD	db	16*MAX_HUB dup(?)

		align	16
SysCtrlQH	db	SIZE QH dup(?)
		align	16
SysCtrlTD	db	SIZE TD dup(?)

		align	16			;R02
TimerQH 	db	SIZE QH dup(?)		;R02
		align	16			;R02
TimerTD 	db	SIZE TD dup(?)		;R02

		align	16
ControlQH	db	SIZE QH dup(?)
		align	16
ControlTD	db	SIZE TD dup(?)

		org	1000h
FrameList	db	1000h dup(?)

;R01 - start
endif	;UHCI

ifdef	OHCI

Usb_Head	db	8 dup(?)	;expansion ROM header

bUsbFlag	db	?
wHostID 	dw	?

dHostMemBase	dd	?
dUsbRamAddr	dd	?

bLedStatus	db	?		;keyboard LED backup

wCtrlBuffMap	dw	?
ControlBuffer	db	(SIZE CTLPARA)*MAX_CTLBUFF dup(?)
;R03ControlBuffer1	db	(SIZE CTLPARA) dup(?)
;R03ControlBuffer2	db	(SIZE CTLPARA) dup(?)

HubCtrlBuffer	db	(SIZE HUBCTRL)*MAX_HUB dup(?)
KbdCtrlBuffer	db	(SIZE KBDCTRL)*MAX_KBD dup(?)

wTaskLink	dw	?
DummyTask	db	SIZE TASK dup(?)
HubIntTask	db	(SIZE TASK)*MAX_HUB dup(?)	;hub data in task
KbdIntTask	db	(SIZE TASK)*MAX_KBD dup(?)	;keyboard data in task
MsIntTask	db	(SIZE TASK)*MAX_MS dup(?)	;mouse data in task

DevAddrMap	db	128*2 dup(?)	;device address map
					;byte0.7:address occupied
					;byte0.0-6:parent device address
					;byte1.4-7:reserved
					;byte1.0-2:parent hub port
wHubDevMap	dw	?		;occupied hub device map
wKbdDevMap	dw	?		;occupied keyboard device map
wMsDevMap	dw	?		;occupied mouse device map

RequestBuffer	db	SIZE DEVREQ dup(?)

DevDespBuffer	db	12h dup(?)
CfgDespBuffer	db	MAX_DESP_LEN dup(?)
ClassDespBuffer db	MAX_DESP_LEN dup(?)
MiscDataBuffer	db	256 dup(?)

HubDataBuffer	db	8*MAX_HUB dup(?)
KbdDataBuffer	db	8*MAX_KBD dup(?)
MsDataBuffer	db	8*MAX_MS dup(?)

		align	16
KbdIntQH	db	16*MAX_KBD dup(?)
		align	16
KbdIntTD	db	16*MAX_KBD dup(?)

		align	16
MsIntQH 	db	16*MAX_MS dup(?)
		align	16
MsIntTD 	db	16*MAX_MS dup(?)

		align	16
HubIntQH	db	16*MAX_HUB dup(?)
		align	16
HubIntTD	db	16*MAX_HUB dup(?)

		align	16
ControlQH	db	SIZE QH dup(?)
		align	16
ControlTD	db	SIZE TD dup(?)

		align	16
DummyQH 	db	SIZE QH dup(?)
		align	16
DummyTD 	db	SIZE TD dup(?)

		org	1000h
FrameList	dd	32 dup(0)
HccaFrameNum	dw	?
HccaPad1	dw	?
HccaDoneHead	dd	?
		db	116 dup(0)	  ;Reserved for use by HC

endif	;OHCI
;R01 - end
