;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R05 04/22/97  TNY	Add "Skip_HDD_Type_1_To_46" definition for reduce code.
;R04 08/17/94  KVN	Added POST auto IDE detect function
;R03 09-MAY-90 TIM	Made HDISK_PARMS a public
;R02 18-DEC-89 KEB	More mar/com adjustments
;R01 08-DEC-89 KEB	Fixed entries to match mar/com specs.
;R00  10/17/89 WDW   V3.06 Made the drive table org include this file instead
;		     of possibly having a different drive table in every set
;		     of source.

HDPARMS 	STRUC
		DW	?			; Maximum cylinder number
		DB	?			; Maximum number of heads
		DW	?			; Not used
		DW	?			; Starting write precomp cylinder
		DB	?			; Not used
		DB	?			; Control byte - bit 3 on for more than 8 heads
		DB	?			; Not used
		DB	?			; Not used
		DB	?			; Not used
		DW	?			; Landing Zone
		DB	?			; Number of sectors/track
		DB	?			; Not used
HDPARMS		ENDS


;               HARD DISK CONFIGURATION TABLE
; TYPE  CYLINDERS   HEADS  WRITE      LANDING SECTORS Example HD Model 
;			   PRE-COMP   ZONE	
;  0 RESERVED
;  1        306       4      128       305     17
;  2        615       4      300       615     17    ST225,ST4026
;  3        615       6      300       615     17
;  4        940       8      512       940     17
;  5        940       6      512       940     17 
;  6        615       4     None       615     17
;  7        462       8      256       511     17
;  8        733       5     None       733     17     ST4038
;  9        900      15     None       901     17
; 10        820       3     None       820     17
; 11        855       5     None       855     17
; 12        855       7     None       855     17
; 13        306       8      128       319     17
; 14        733       7     None       733     17
; 15 RESERVED                                  17                             
; 16        612       4        0       663     17
; 17        977       5      300       977     17
; 18        977       7     None       977     17
; 19       1024       7      512      1023     17
; 20        733       5      300       732     17
; 21        733       7      300       732     17
; 22        733       5      300       733     17
; 23        306       4        0       336     17
; 24	    977	      5	    None       976     17    Seagate 4051
; 25       1024	      9	    None      1023     17    Seagate 4096
; 26       1224	      7	    None      1223     17    Maxtor 2085
; 27       1224	     11	    None      1223     17    Maxtor 2140
; 28       1224	     15	    None      1223     17    Maxtor 2190
; 29       1024       8	    None      1023     17    Maxtor 1085
; 30       1024      11     None      1023     17    Maxtor 1105
; 31        918      11     None      1023     17    Maxtor 1170
; 32        925       9     None       926     17    CDC 9415
; 33       1024      10	    None      1023     17    Generic 10hd
; 34       1024      12	    None      1023     17    Generic 12hd
; 35       1024      13	    None      1023     17    Generic 13hd
; 36       1024      14	    None      1023     17    Generic 14hd
; 37       1024       2	    None      1023     17    Generic 2hd
; 38       1024      16	    None      1023     17    Generic 16hd
; 39        918      15     None      1023     17    Maxtor 1140
; 40	    820	      6	    None       820     17    Seagate 251
;R02 ; 41       1024       5     512       1023     17    Miniscribe 3053/6053 
; 41       1024       5     NONE      1023     17    Miniscribe 3053/6053  ;R02
;R02 ; 42       1024       5     512       1023     26    Miniscribe 3053/6053 RLL 
; 42       1024       5     NONE      1023     26    Miniscribe 3053/6053 RLL ;R02 
;R02 ; 43        809       6     128        852     17    Miniscribe 3650  
; 43        809       6     NONE       852     17    Miniscribe 3650       ;R02
;R02 ; 44        809       6     128        852     26    Miniscribe 3675 RLL      
; 44        809       6     NONE       852     26    Miniscribe 3675 RLL   ;R02   
; 45        776       8     None       775     33    Conner CP3104
; 46	    684      16     None       685     38    Conner CP3204
; 47	    615       6     None       615     17    Seagate ST138

		PUBLIC	HDISK_PARMS                                                
HDISK_PARMS	LABEL	WORD
ifndef	Skip_HDD_Type_1_To_46						;R05
		HDPARMS <132H,	4,0,   80H,0,0,0,0,0,131H,11H,0>  ; 1
		HDPARMS <267H,	4,0,  12CH,0,0,0,0,0,267H,11H,0>  ; 2
		HDPARMS <267H,	6,0,  12CH,0,0,0,0,0,267H,11H,0>  ; 3
		HDPARMS <3ACH,	8,0,  200H,0,0,0,0,0,3ACH,11H,0>  ; 4
		HDPARMS <3ACH,	6,0,  200H,0,0,0,0,0,3ACH,11H,0>  ; 5
		HDPARMS <267H,	4,0,0FFFFH,0,0,0,0,0,267H,11H,0>  ; 6
		HDPARMS <1CEH,	8,0,  100H,0,0,0,0,0,1FFH,11H,0>  ; 7
		HDPARMS <2DDH,	5,0,0FFFFH,0,0,0,0,0,2DDH,11H,0>  ; 8
		HDPARMS <384H,0FH,0,0FFFFH,0,8,0,0,0,385H,11H,0>  ; 9
		HDPARMS <334H,	3,0,0FFFFH,0,0,0,0,0,334H,11H,0>  ; 10
		HDPARMS <357H,	5,0,0FFFFH,0,0,0,0,0,357H,11H,0>  ; 11
		HDPARMS <357H,	7,0,0FFFFH,0,0,0,0,0,357H,11H,0>  ; 12
		HDPARMS <132H,	8,0,   80H,0,0,0,0,0,13FH,11H,0>  ; 13
		HDPARMS <2DDH,	7,0,0FFFFH,0,0,0,0,0,2DDH,11H,0>  ; 14
		HDPARMS <   0,	0,0,	 0,0,0,0,0,0,	0,  0,0>  ; 15-RESERVED
		HDPARMS <264H,	4,0,	 0,0,0,0,0,0,297H,11H,0>  ; 16
		HDPARMS <3D1H,	5,0,  12CH,0,0,0,0,0,3D1H,11H,0>  ; 17
		HDPARMS <3D1H,	7,0,0FFFFH,0,0,0,0,0,3D1H,11H,0>  ; 18
		HDPARMS <400H,	7,0,  200H,0,0,0,0,0,3FFH,11H,0>  ; 19
		HDPARMS <2DDH,	5,0,  12CH,0,0,0,0,0,2DCH,11H,0>  ; 20
		HDPARMS <2DDH,	7,0,  12CH,0,0,0,0,0,2DCH,11H,0>  ; 21
		HDPARMS <2DDH,	5,0,  12CH,0,0,0,0,0,2DDH,11H,0>  ; 22
		HDPARMS <132H,	4,0,	 0,0,0,0,0,0,150H,11H,0>  ; 23
		HDPARMS <3D1H,	5,0,0FFFFH,0,0,0,0,0,3D0H,11H,0>  ; 24
;R02		HDPARMS <400H,	9,0,0FFFFH,0,8,0,0,0,4FFH,11H,0>  ; 25
		HDPARMS <400H,	9,0,0FFFFH,0,8,0,0,0,3FFH,11H,0>  ; 25	   ;R02
		HDPARMS <4C8H,	7,0,0FFFFH,0,0,0,0,0,4C7H,11H,0>  ; 26
		HDPARMS <4C8H,0BH,0,0FFFFH,0,8,0,0,0,4C7H,11H,0>  ; 27
		HDPARMS <4C8H,0FH,0,0FFFFH,0,8,0,0,0,4C7H,11H,0>  ; 28
		HDPARMS <400H,	8,0,0FFFFH,0,0,0,0,0,3FFH,11H,0>  ; 29
		HDPARMS <400H,0BH,0,0FFFFH,0,8,0,0,0,3FFH,11H,0>  ; 30
		HDPARMS <396H,0BH,0,0FFFFH,0,8,0,0,0,3FFH,11H,0>  ; 31
		HDPARMS <39DH,	9,0,0FFFFH,0,8,0,0,0,39EH,11H,0>  ; 32
		HDPARMS <400H,0AH,0,0FFFFH,0,8,0,0,0,3FFH,11H,0>  ; 33
		HDPARMS <400H,0CH,0,0FFFFH,0,8,0,0,0,3FFH,11H,0>  ; 34
		HDPARMS <400H,0DH,0,0FFFFH,0,8,0,0,0,3FFH,11H,0>  ; 35
		HDPARMS <400H,0EH,0,0FFFFH,0,8,0,0,0,3FFH,11H,0>  ; 36
		HDPARMS <400H,	2,0,0FFFFH,0,0,0,0,0,3FFH,11H,0>  ; 37
		HDPARMS <400H,10H,0,0FFFFH,0,8,0,0,0,3FFH,11H,0>  ; 38
		HDPARMS <396H,0FH,0,0FFFFH,0,8,0,0,0,3FFH,11H,0>  ; 39
		HDPARMS <334H,	6,0,0FFFFH,0,0,0,0,0,334H,11H,0>  ; 40

;R01	HDPARMS <400H,	5,0,   512,0,0,0,0,0,1025, 17,0>  ; 41
;R01	HDPARMS <400H,	5,0,   512,0,0,0,0,0,1025, 26,0>  ; 42
;R01	HDPARMS < 809,	6,0,   128,0,0,0,0,0, 852, 17,0>  ; 43
;R01	HDPARMS < 809,	6,0,   128,0,0,0,0,0, 852, 26,0>  ; 44
;R02	HDPARMS <400H,	5,0,0FFFFh,0,0,0,0,0,1025, 17,0>  ; 41	   ;R01
;R02	HDPARMS <400H,	5,0,0FFFFh,0,0,0,0,0,1025, 26,0>  ; 42	   ;R01

		HDPARMS <400H,	5,0,0FFFFh,0,0,0,0,0,1023, 17,0>  ; 41	   ;R02
		HDPARMS <400H,	5,0,0FFFFh,0,0,0,0,0,1023, 26,0>  ; 42	   ;R02
		HDPARMS < 809,	6,0,0FFFFh,0,0,0,0,0, 852, 17,0>  ; 43	   ;R01
		HDPARMS < 809,	6,0,0FFFFh,0,0,0,0,0, 852, 26,0>  ; 44	   ;R01

		HDPARMS < 776,	8,0,0FFFFH,0,0,0,0,0, 775, 33,0>  ; 45
		HDPARMS < 684, 16,0,0FFFFh,0,0,0,0,0, 685, 38,0>  ; 46
;R04		HDPARMS < 615,	6,0,0FFFFh,0,0,0,0,0, 615, 17,0>  ; 47
		HDPARMS < 000,	0,0,00000h,0,0,0,0,0, 000, 00,0>  ; 47	;R04
endif;	Skip_HDD_Type_1_To_46						;R05
