;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

 PAGE   60,132
 TITLE  INT13X - EXTENDED FIXED DISK INTERRUPT SERVICE CODE

;=============================================================================
;FILE:  INT13X.ASM
;
;DESC:  Extended functions for Interrupt service handler 13h
;       And ATAPI interface (optional--CD_ROM flag)
;BY:    HauWei Yu and JohnH
;DATE:  17-November-1994
;=============================================================================
;Rev  Date       Author  Description
;     19 Jan 95  JohnH   Adapted for Elite Bios
;                        Does not save parameters for CD mapped as HDD,
;                        so cannot work with HDD image.
;                        MASM 5.10 insists on unique identifiers for 
;                        structure fields, and doesn't accept the 
;                        (StructName ptr [di]).Field syntax.
;     07 Feb 95  JohnH & HauWei
;                        Works with HDD image; also re-wrote parts of low-
;                        level atapi code.
;     08 Feb 95  JohnH & HauWei
;                        Make Wait_Busy independent of system speed; don't
;                        fail if TestUnitRdy returns carry.
;-----------------------------------------------------------------------------
;R20A	11/19/97 KVN	Fix R20 coding not complete
;R20	11/13/97 KVN	Fix LS120 can't format 1.44MB in DOS even add /f:1.44
;			parameter if use HD-COPY.EXE formated it in Win95 to
;			1.68MB or 1.6MB media first.(p.s. HD-COPY.EXE is a tool
;			for access diskette to special media.this tool is issue
;			by Oliver Fromme)
;R15A	11/11/97 KVN	Fix LS120 can't format 1.44MB in DOS
;R18B	11/11/97 KVN	Fix no 120MB item in WIN95-OSR2 drive A/B of format
;			funtion if support FDPTE in function 48h
;R19	10/24/97 BAR	Fixed boot sequence CD_ROM frist very slow
;			if media is audio CD or can't bootable.
;			This CDROM model list follow:
;			   Panasonic "MATSHITA CR_585"
;R01C	10/22/97 KVN	Force set LBA access method in int13 extention
;R01B	10/22/97 KVN	Support LBA access method in int13 extention if define
;			"ExtInt13_LBA"
;R18A	10/14/97 KVN	Exactly report parameter of EDD table in Int13
;			extension function 48h.otherwise will cause system
;			error while execute FDISK.EXE in Windows 95
;R18	10/07/97 BAR	Added Fixed Disk Parameter Table Extension(FDPTE)
;R14A	08/14/97 KVN	Fix can't format 1.44MB diskette in LS120 drive when
;			dirve A is 1.44MB standard Floppy and drive B is LS120
;R17B	07/24/97 KVN	Fix some CDROM read error (e.g. mitsuimi 4x) when data
;			transfer count is 64K bytes
;R17A	07/08/97 KVN	Fix ZIP100 boot fail by R17
;R17	07/03/97 KVN	Fix TEAC CDROM (model is CD-524E) boot fail
;R16	06/19/97 KVN	Fix can't format ZIP 100MB diskette
;R15	06/13/97 KVN	Fix can't format 120MB diskette in WIN95-OSR2 when insert
;			720KB or 1.44MB diskette in drive before WIN95 boot
;R14	06/13/97 KVN	Fix can't format 120MB diskette in WIN95-OSR2 when dirve
;			A is 1.44MB standard Floppy and drive B is LS120 drive
;R13	06/10/97 KVN	Fix CDROM can't boot if connected it behind LS120 or Zip
;R12	05/09/97 KVN	Fix SCO OS bootable CDROM for install error
;R11	05/07/97 KVN	Add ZIP100 bootable same as LS120
;R07B	05/01/97 KVN	Fixed LS120 device change line error if it's emulate
;			to floppy B
;R10	04/09/97 KVN	Fixed some CDROM read error during boot routine.These
;			CDROM model list follow:
;			1. Pioneer CD-ROM ATAPI Model DR-A12X 0100
;			2. CREATIVE CD1220E
;			3. WEARNES CDD-820
;R01A	02/25/97 KVN	Fixed system hang at EMM386.exe add HIGHSCAN parameter
;			if BIOS include "Int13_Extensions" function
;R09	02/19/97 KVN	Fixed LS120 drive format 120MB media disc error
;R08	02/01/97 KVN	Support IOMEGA ZIP-100 drive active
;R07A	01/27/97 KVN	Fixed R07 coding mistake that will cause CDROM could't
;			bootable
;R07	01/22/97 KVN	Support dual LS120 drive active
;R06	01/16/97 KVN	Fixed identify LS-120 to drive letter became C or later
;			in WIN95 while there has no diskette is existed in LS-120
;R05	12/30/96 KVN	Support LS-120 1.2MB Toshiba(capacity is 1.21MB) read,
;			write and bootability
;R04	12/17/96 KVN	Fixed some LS-120 drive (Model = LKM-F333-102) access
;			error
;R03	11/28/96 KVN	Fixed LS-120 can't access when connect on same channel
;			with HDD (e.g. HDD is master and LS-120 is slave)
;R02	11/26/96 KVN	Fixed 1.44MB floppy with WINDOS v4.1 system can't boot
;			in LS-120 drive
;R01	11/15/96 KVN	Added IDE HDD Int13 Extensions function
;R00	11/01/96 KVN	Added LS-120 support and recode for increase CDROM
;			performance

.386

; MINIMIZE SEGMENT 0 ACCESS IN PROTECTED MODE (EXCEPTION 5)

SEG_0		SEGMENT	USE16 AT 1
		INCLUDE	SEG_0.INC
SEG_0		ENDS

G_RAM		SEGMENT	USE16 AT 40H
		INCLUDE	G_RAM.INC
G_RAM		ENDS


DGROUP		GROUP	FCODE

    extrn gethparm:near
		include	PORT61.EQU
ExtInt13_LBA		equ	1				;R01C
;R18 - start
		Public	FDPTE_Drive0
		Public	FDPTE_Drive1
		Public	FDPTE_Drive2
		Public	FDPTE_Drive3
		extrn	AHDSK_ERROR_RET:near	;R18A
;R18 - end

		extrn	WAIT_FOR_PORT:near
		extrn	HD5_PARMS:byte
		extrn	HD_PARMS:byte
		extrn	ED_PARMS:byte
;R01 start
		include	ahdsk.equ
ifdef	Int13_Extensions
		extrn	FUN10_2:near
		extrn	GOOD_RET:near
		extrn	CONT_CMD:near
		extrn	Detect_LBA_Mode:near
endif	;Int13_Extensions
;R01 end

WAIT_UHD_BUSY_HI	EQU	5
WAIT_UHD_BUSY_LO	EQU	1615h
WAIT_UHD_DRQ_HI		EQU	0
WAIT_UHD_DRQ_LO		EQU	8000h
FDPARMS		STRUC
		FD_SPECIFY_1	DB	0DFH	;00: 1st Specify byte
		FD_SPECIFY_2	DB	002H	;01: 2nd Specify byte
		FD_MOTOR_OFF	DB	025H	;02: motor wait before turn off.
		FD_SEC_SIZE	DB	002H	;03: 128 * 2^N bytes per sector
		FD_EOT		DB	009H	;04: End of track
		FD_NORMAL_GAP	DB	02AH	;05: GAP length
		FD_DTL		DB	0FFH	;06: data length, if 03: = 0
		FD_FORMAT_GAP	DB	050H	;07: gap length for format
		FD_FILL		DB	0F6H	;08: fill byte for format
		FD_HEAD_WAIT	DB	00FH	;09: milliseconds for head settle time
		FD_MOTOR_ON	DB	008H	;10: 1/8 of seconds for motor spin up.
		FD_LAST_CYL	DB	027H	;11: # of last cylinder
		FD_XFER_RATE	DB	080H	;12: Xfer rate, as sent to port.
FDPARMS		ENDS

FCODE		SEGMENT	USE16 PARA PUBLIC 'CODE'	  
		ASSUME	CS:DGROUP

.xlist
  include	bios.cfg
  include	cd_rom.equ
  include	int13x.equ    ; structure defs
  include	common.mac
  include	common.equ
.list

  PAGE

ifdef ATAPI_COMMAND_SUPPORT
UHD_PARMS LABEL	BYTE
FDPARMS	<0DFH,002H,025H,002H,020H,01BH,0FFH,065H,0F6H,00FH,008H,04FH,000H>
;****************************************************************************
;       (standard) Int 13 function translation to ATAPI 
;       This is provided for booting from CD (floppy or hard disk image)
;Entry: AH = subfunction
;       DL = drive (40 if FDD, Cx if HDD image
;       BX-DX = as specified in INT 13 function 
;Exit:  AH = error code
;       CC = no error; CS = error
;****************************************************************************
public std_atapi
std_atapi proc
	push	eax					;R02
	push	bp
	sub	sp,CDROM_RSV_byte
	mov	bp,sp
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	es
	push	ds

	mov	ax,G_RAM
	mov	ds,ax
	assume	ds:G_RAM

	mov	CDROM_port,1f0h
	mov	al,G_RAM:[CDROM_ALLOCATE]
	and	al,3
	mov	INT13X_FLAG,0		;clear flag
ifdef LS120_SUPPORT
	mov	ah,G_RAM:[ATAPI_Byte]
;R07A	mov	al,ah			;R07
	mov	dh,ah			;R07A
	mov	cl,ah
	and	cl,3
	test	ah,4			;have any ATAPI drive exist?
	jz	short @F		;No,skip
	test	ah,40h			;R08 drive 0 is LS-120?
;R11	jnz	short @F		;R08 No,skip
	jnz	short Not_LS120		;R11
	shr	ah,3
	and	ah,1
	cmp	dl,ah
;R07	jne	short @F
;R07 start
;R07B	lea	bx,G_RAM:[Floptical0_EMUL_CYL_SEC]
	je	short Set_LS120_emul
Not_LS120:				;R11
;R08 start
	cmp	dl,1
	jne	short @F
	test	dh,80h
	jnz	short @F
;R08 end
;R07A	mov	cl,al
	mov	cl,dh					;R07A
	shr	cl,4
	and	cl,3
	jz	short @F		;R11
;R07A	shr	al,6
;R07A	and	al,1
;R08	shr	dh,6					;R07A
;R08	and	dh,1					;R07A
;R07B	lea	bx,G_RAM:[Floptical1_EMUL_CYL_SEC]
;R07A	cmp	dl,al
;R08	cmp	dl,dh					;R07A
;R08	jne	short @F
Set_LS120_emul:
;R20A;R07B start
;R20A	lea	bx,G_RAM:[Floptical0_EMUL_CYL_SEC]
;R20A	test	G_RAM:[ATAPI_Byte],30h			;R14
;R20A	jz	short Is_dirveA				;R14
;R20A	or	dl,dl
;R20A	jz	short Is_dirveA
;R20A	lea	bx,G_RAM:[Floptical1_EMUL_CYL_SEC]
;R20AIs_dirveA:
;R20A;R07B end
;R20A;R07A	mov	ax,G_RAM:[bx]
;R20A;R07A	mov	LS120_EMUL_CYL_SEC,ax
;R20A;R07A	mov	ax,G_RAM:[bx+2]
;R20A;R07A	mov	LS120_EMUL_HEAD,al
;R20A;R07A	mov	LS120_Medium_Type,ah
;R20A	mov	dx,G_RAM:[bx]				;R07A
;R20A	mov	LS120_EMUL_CYL_SEC,dx			;R07A
;R20A	mov	dx,G_RAM:[bx+2]				;R07A
;R20A	mov	LS120_EMUL_HEAD,dl			;R07A
;R20A	mov	LS120_Medium_Type,dh			;R07A
;R07 end
	mov	al,cl
	or	INT13X_FLAG,Sector_200b+Floptical_Exist+Write_Assert
	jmp	short Found_ATAPI_drive	;R08
@@:
;R07	mov	ah,10h
;R07	shl	ah,cl
;R07	test	G_RAM:[ATAPI_Byte],ah
;R07	jz	short No_INTRQ
;R07	or	INT13X_FLAG,INTRQ_Assert
;R07No_INTRQ:
endif ;LS120_SUPPORT
;R08 start
ifdef IOMEGA_ZIP_Support
	mov	ah,G_RAM:[ATAPI_Byte]
	test	ah,4
	jz	short None_IOMEGA_ZIP



;R11 start
	mov	dh,ah
	mov	cl,ah
	and	cl,3
	test	ah,40h			;drive 0 is ZIP100?
	jz	short Not_Zip
	shr	ah,3
	and	ah,1
	cmp	dl,ah
	je	short Found_IOMEGA_ZIP
Not_Zip:
	cmp	dl,1
;R13	jne	short @F
	jne	short Found_ATAPI_drive		;R13
	test	dh,80h
;R13	jz	short @F
	jz	short Found_ATAPI_drive		;R13
	mov	cl,dh
	shr	cl,4
	and	cl,3
;R13	jz	short @F
	jz	short Found_ATAPI_drive		;R13
Found_IOMEGA_ZIP:
;R16 start
	mov	LS120_EMUL_CYL_SEC,0a0h
	mov	LS120_EMUL_HEAD,IOMEGA_ZIP_Heads
	mov	LS120_Medium_Type,31h
;R16 end
	mov	al,cl
;R11 end


;R11	cmp	dl,1				;Is Drive B?
;R11	jne	short Check_ZIP_A		;No,go ahead to check
;R11	test	ah,80h				;check ATAPI drive 1 is ZIP?
;R11	jz	short None_IOMEGA_ZIP		;if not then skip
;R11	shr	ah,4				;get second ZIP scheme
;R11	and	ah,3				;have any ATAPI drive 1?
;R11	jnz	short Found_IOMEGA_ZIP		;Yes,set INT13X_FLAG
;R11Check_ZIP_A:
;R11	test	ah,40h				;check ATAPI drive 0 is ZIP?
;R11	jz	short None_IOMEGA_ZIP		;if not then skip
;R11	mov	dh,ah
;R11	shr	dh,3
;R11	and	dh,1
;R11	cmp	dh,dl
;R11	jne	short None_IOMEGA_ZIP
;R11Found_IOMEGA_ZIP:
;R11	mov	al,ah
;R11	and	al,3
	or	INT13X_FLAG,Sector_200b+IOMEGA_ZIP_Exist+Write_Assert
None_IOMEGA_ZIP:
endif	;IOMEGA_ZIP_Support
Found_ATAPI_drive:
;R08 end
	cmp	al,2
	jb	short @F
	sub	CDROM_port,80h
@@:
	mov	CDROM_drive,0a0h
	test	al,1
	jz	short @F
	mov	CDROM_drive,0b0h
@@:
		mov	dx,CDROM_port
		add	dl,6			;dx = 1X6h
		mov	al,CDROM_drive
		out	dx,al
		newiodelay
	mov	CMD_Pkt_buffer.CD_Reserved0,0
	mov	CMD_Pkt_buffer.CD_Reserved1,0
	mov	CMD_Pkt_buffer.CD_Reserved2,0
	mov	CMD_Pkt_buffer.CD_Reserved3,0
	mov	CMD_Pkt_buffer.CD_Reserved4,0

; handle the requests we expect
	cmp	BP_AH,02				; read?
	jnz	@f
	mov	bl,ATAPI_Read
;R08	or	INT13X_FLAG,RW_Flag
	or	INT13X_FLAG,RW_Flag+IOMEGA_ZIP_RW	;R08
	call	std_atapi_access
	jmp	std_atapi_ret
@@:
;R08ifdef LS120_SUPPORT
	cmp	BP_AH,03				; write?
	jne	short @F
	test	INT13X_FLAG,Write_Assert
	jz	short @F
	mov	bl,ATAPI_Write
	and	INT13X_FLAG,not RW_Flag
	or	INT13X_FLAG,IOMEGA_ZIP_RW	;R08
	call	std_atapi_access
	jmp	std_atapi_ret
@@:
;R08endif ;LS120_SUPPORT
	cmp	BP_AH,04				; verify?
	jne	short @f
	mov	bl,ATAPI_Verify
	or	INT13X_FLAG,RW_Flag
	call	std_atapi_access
	jmp	std_atapi_ret
@@:
;R16 ifdef LS120_SUPPORT
	cmp	BP_AH,05				; format?
	jne	short @f
	test	INT13X_FLAG,Write_Assert
	jz	short @F
	call	Send_Test_Unit_Ready
;R16 start
ifdef IOMEGA_ZIP_Support
	cmp	LS120_EMUL_CYL_SEC,0a0h
	je	short False_Format
endif ;IOMEGA_ZIP_Support
ifdef LS120_SUPPORT
;R16 end
	mov	CMD_Pkt_buffer.S_LBA,11h
;R07	cmp	G_RAM:[Floptical_EMUL_CYL_SEC],5009h	;720kb disk
	cmp	LS120_EMUL_CYL_SEC,5009h		;R07
	je	short Go_Format
	mov	CMD_Pkt_buffer.S_LBA,24h
;R07	cmp	G_RAM:[Floptical_EMUL_CYL_SEC],5012h	;1.44Mb disk
	cmp	LS120_EMUL_CYL_SEC,5012h		;R07
	je	short Go_Format

	mov	CMD_Pkt_buffer.S_LBA,23h
;R07	cmp	G_RAM:[Floptical_EMUL_CYL_SEC],500fh	;1.2Mb disk
	cmp	LS120_EMUL_CYL_SEC,500fh		;R07
	je	short Go_Format
;R09	mov	CMD_Pkt_buffer.S_LBA,31h
;R07	cmp	G_RAM:[Floptical_EMUL_CYL_SEC],0c3e0h	;120Mb disk
	cmp	LS120_EMUL_CYL_SEC,0c3e0h		;R07
;R09	je	short Go_Format
	je	short False_Format			;R09
endif ;LS120_SUPPORT					;R16

	jmp	short Format_error
False_Format:						;R09
	xor	ah,ah					;R09
	jmp	std_atapi_ret				;R09
Go_Format:
	mov	CMD_Pkt_buffer.OpCode,ATAPI_Format
	mov	al,bp_dh
	and	al,1
	shl	al,2
	or	al,22h
	mov	CMD_Pkt_buffer.CD_Reserved1,al
	mov	al,bp_ch
	mov	byte ptr CMD_Pkt_buffer.S_Length,al
	and	INT13X_FLAG,not RW_Flag
	call	Ctlr_Drive_Ready
	dec	dl
	mov	al,CDROM_drive
	out	dx,al
	newiodelay
	call	Send_Pkt_Cmd
	jnc	std_atapi_ret
Format_error:
	mov	ah,80h
	jmp	std_atapi_ret
@@:
;R16 endif ;LS120_SUPPORT
	cmp	BP_AH,41h			;check for extension support
	jne	@f
	mov	BP_AH,0				;major version
	mov	BP_AL,0				;minor version
	mov	BP_BX,0aa55h			;must return to confirm
						;extensions are supported
	mov	BP_CX,04h			;EED support ;R18  
	mov	cx,3
	xor	ah,ah				;successfully status return
	jmp	std_atapi_ret1
@@:
	cmp	BP_AH,42h			;extend read?
	jne	@f
	call	Extend_atapi_rd
	jmp	std_atapi_ret
@@:
	cmp	BP_AH,4bh			;extend 4bh func?
	jne	@f
	call	Extend_4B_func
	jmp	std_atapi_ret
@@:
	cmp	BP_AH,0				; reset?
	jnz	@f
	call	atapi_reset
	jmp	std_atapi_ret
@@:
;R08ifdef LS120_SUPPORT
;R18;R08 start
;R18	test	INT13X_FLAG,IOMEGA_ZIP_Exist+Floptical_Exist	;check is floptical drive?
;R18	jz	Not_is_Floptical
;R18;R08 end
	cmp	BP_AH,48h
;R08	jne	short @F
	jne	Not_Func48		;R08
	mov	es,bp_ds
	mov	di,bp_si
;R18	mov	word ptr es:[di],26		;buffer size
;R18	mov	word ptr es:[di+2],11010110b	;information flags
;R18 start


;R18B start
	mov	ax,es:[di]			;get buffer size
	cmp	ax,26				;check buffer size
	jae	short @F			;>= 26 then set parameter to buffer
	mov	ah,1				;set status = bad command
	jmp	std_atapi_ret
@@:
	mov	word ptr es:[di],26		;set buffer size = 26
	cmp	ax,30				;check buffer size
	jb	short @F			;< 26 then set parameter to buffer
	mov	word ptr es:[di],30		;set buffer size = 30
@@:
;R18B end

	mov	word ptr es:[di+2],01011110b	;information flags(assume write and verify assert)
;R18B	mov	word ptr es:[di],30		;buffer size 
	test	INT13X_FLAG,Write_Assert	;Write enable ?
	jnz	short @F			;Yes,skip
	mov	word ptr es:[di+2],01010110b	;information flags(deassert write and verify)
@@:
	mov	cx,ds:CDROM_EMUL_CYL_SEC	;get CDROM emulate Cyl. and sectors
	mov	al,cl				;associate cylinder bits
	xchg	ch,cl				;
	shr	ch,6				;clear ch bit 0-5
;R18 - end
	xor	bx,bx				;BX = 0 for clear high word
;R07	mov	cx,ds:Floptical_EMUL_CYL_SEC
	test	INT13X_FLAG,Floptical_Exist	;R08
	jz	short @F			;R08
;R15	mov	cx,LS120_EMUL_CYL_SEC		;R07
;R15	mov	al,cl
;R15	xchg	ch,cl
;R15	shr	ch,6
	mov	cx,3c3h				;R15
;R08 start
@@:
	test	INT13X_FLAG,IOMEGA_ZIP_Exist
	jz	short @F
	mov	cx,IOMEGA_ZIP_Cylinders
@@:
;R08 end
	mov	word ptr es:[di+4],cx		;physical cylinders
	mov	word ptr es:[di+6],bx		;set high word = 0
;R07	mov	ah,ds:Floptical_EMUL_HEAD
	mov	ah,ds:CDROM_EMUL_HEAD		;R18
	test	INT13X_FLAG,Floptical_Exist	;R08
	jz	short @F			;R08
;R15	mov	ah,LS120_EMUL_HEAD		;R07
	mov	ah,8				;R15
;R08 start
@@:
	test	INT13X_FLAG,IOMEGA_ZIP_Exist
	jz	short @F
	mov	ah,IOMEGA_ZIP_Heads
@@:
;R08 end
	mov	byte ptr es:[di+8],ah		;physical heads
	mov	byte ptr es:[di+9],bl		;set high byte = 0
	mov	word ptr es:[di+10],bx		;set high word = 0
	test	INT13X_FLAG,Floptical_Exist	;R08
	jz	short @F			;R08
;R15	and	al,3fh
	mov	al,20h				;R15
;R08 start
@@:
ifdef IOMEGA_ZIP_Support
	test	INT13X_FLAG,IOMEGA_ZIP_Exist
	jz	short @F
	mov	al,IOMEGA_ZIP_Sectors
@@:
endif ;IOMEGA_ZIP_Support
;R08 end
	mov	byte ptr es:[di+12],al		;physical sectors per track
	mov	byte ptr es:[di+13],bl		;set high byte = 0
	mov	word ptr es:[di+14],bx		;set high word = 0
	mul	ah
	mul	cx
	mov	word ptr es:[di+16],ax
	mov	word ptr es:[di+18],dx
	mov	word ptr es:[di+20],bx		;set high dword = 0
	mov	word ptr es:[di+22],bx
	mov	word ptr es:[di+24],200h	;bytes in a sectors
;R18 start
;------ Get_ATAPI_Allocate ------
	cmp	word ptr es:[di],30		;R18B
	jb	short Dont_set_FDPTE		;R18B
	xor	dx,dx
 	cmp	CDROM_port,1F0h			;Test channel0/channel1
	je	short @F
	or	dl,020h
@@:
   	test	CDROM_drive,10h			;Test master/slave
	jz	short @F
	or	dl,010h
@@:
	mov	ax,offset cs:FDPTE_Drive0
	add	ax,dx				;get FDPTE address	
	mov	word ptr es:[si+26],ax		
	mov	word ptr es:[si+28],0f000h	;save segment
Dont_set_FDPTE:					;R18B
;--------------------------------
;R18 end

	xor	ah,ah
	jmp	std_atapi_ret
;R08@@:
Not_Func48:					;R08
	cmp   BP_AH,15h
	jnz   short @F
	mov	bp_ah,2
	xor	ah,ah
	jmp	std_atapi_ret1
@@:
	cmp   BP_AH,16h
	jnz   short @F
	call	Send_Test_Unit_Ready
;R05	cmp	ah,6
;R05	je	short Media_Change
;R05	xor	ah,ah
;R05Media_Change:
	jmp	std_atapi_ret
@@:
	cmp   BP_AH,17h
	jnz   short @F
	xor	ah,ah
	jmp	std_atapi_ret
@@:
	test	INT13X_FLAG,Floptical_Exist	;R08;check is floptical drive?
	jz	Not_is_Floptical		;R08
	cmp	BP_AH,18h
	jne	short @F
	call	Send_Test_Unit_Ready
	jnc	short Do_Func18
	cmp	ah,6
	mov	ah,80h			;no media present
	jne	short Type_Not_Support
Do_Func18:
	lea	si,UHD_PARMS
	cmp	bp_cx,0c2e0h
	je	short Found_Parms
	lea	si,HD_PARMS
	mov	ah,4
Scan_Parm_Loop:
	mov	cl,cs:[si].FD_EOT		; get last track
	mov	ch,cs:[si].FD_LAST_CYL	; get last cylinder
	cmp	cx,bp_cx
	je	short Found_Parms
	sub	si,SIZE FDPARMS		; else get to next table
	dec	ah
	jnz	short Scan_Parm_Loop
Type_Not_Support:
	mov	ah,0ch			;not support or drive type unknown
	jmp	std_atapi_ret
Found_Parms:
;R20 start
	inc	ch
	lea	bx,G_RAM:[Floptical0_EMUL_CYL_SEC]
	test	G_RAM:[ATAPI_Byte],30h
	jz	short Fun18_Is_dirveA
	lea	bx,G_RAM:[Floptical1_EMUL_CYL_SEC]
Fun18_Is_dirveA:
	mov	G_RAM:[bx],cx
;R20 end
	mov	bp_di,si
	mov	bp_es,cs
	xor	ah,ah
	jmp	std_atapi_ret
@@:
	cmp	BP_AH,20h
	jnz	short @F
	call	Send_Test_Unit_Ready
	jnc	short Media_Present
	cmp	ah,6
	jne	short Media_Not_Present
Media_Present:
;R07	mov	bl,ds:Floptical_Medium_Type
	mov	bl,LS120_Medium_Type		;R07
	xor	ah,ah				;media present
	mov	bp_al,0fh			;assume NEC 3 mode
	cmp	bl,22h				;NEC 3 mode?
	je	std_atapi_ret
	mov	bp_al,0eh			;assume Toshiba 3 mode
	cmp	bl,23h				;Toshiba 3 mode?
	je	std_atapi_ret
	mov	bp_al,4				;assume 1.44M
	cmp	bl,20h				;1.44M unformated?
	je	std_atapi_ret
	cmp	bl,24h				;1.44M ?
	je	std_atapi_ret
	cmp	bl,26h				;R20A 1.68M ?
	je	std_atapi_ret			;R20A
	mov	bp_al,3				;assume 720K
	cmp	bl,10h				;720K unformatted?
	je	std_atapi_ret
	cmp	bl,25h				;720K ?
	je	std_atapi_ret
	mov	ah,32h				;Non-default media
	mov	bp_al,10h			;assume 120M
	cmp	bl,30h				;120M unformatted?
	je	std_atapi_ret
	cmp	bl,31h				;120M ?
	je	std_atapi_ret
Media_Not_Present:
	mov	ah,31h
	jmp	std_atapi_ret
@@:
Not_is_Floptical:
;R08endif ;LS120_SUPPORT
	mov	ah,1
  cmp   BP_AH,8						; get parameters?
  jnz   std_atapi_ret
ifdef LS120_SUPPORT
	test	INT13X_FLAG,Floptical_Exist
	jz	short @F
;R15	or	INT13X_FLAG,RW_Flag		;R04
;R15	call	Send_Test_Unit_Ready
;R05 start
;R15	jnc	short Media_In_Diskette
;R15	cmp	ah,6
;R15	je	short Media_In_Diskette
;R15	mov	bp_dh,1
;R15	mov	ax,5012h
;R15	jmp	short Check_Media
;R15Media_In_Diskette:
;R05 end
;R07	mov	al,ds:Floptical_EMUL_HEAD
;R15	mov	al,LS120_EMUL_HEAD		;R07
;R15	dec	al
;R15	mov	bp_dh,al
;R07	mov	ax,ds:Floptical_EMUL_CYL_SEC
;R15	mov	ax,LS120_EMUL_CYL_SEC		;R07
;R15Check_Media:					;R05
;R05	mov	bl,2
;R06	mov	bl,4				;R05
;R15	mov	di,offset HD5_PARMS
;R15	mov	bp_cx,500fh
;R05	cmp	ax,500fh			;1.2MB floppy?
;R15	mov	bp_cx,4f0fh			;R05
;R15	je	short Set_parm
;R05	mov	bl,4
;R15	mov	di,offset HD_PARMS
;R05	mov	bp_cx,5012h
;R15	mov	bp_cx,4f12h			;R05
;R15	cmp	ah,50h				;1.44MB/720KB floppy?
;R15	je	short Set_parm
;R06	mov	bl,10h
;R15	mov	bp_cx,ax
;R15Set_parm:
;R06	mov	bp_bl,bl
;R15A	mov	bp_cx,0c3e0h			;R15
;R15A	mov	bp_dh,7				;R15
;R15A start
	or	INT13X_FLAG,RW_Flag
	call	Send_Test_Unit_Ready
	jnc	short Media_In_Diskette
	cmp	ah,6
	je	short Media_In_Diskette
	mov	bp_dh,1
	mov	ax,5012h
	jmp	short Check_Media
Media_In_Diskette:
	mov	al,LS120_EMUL_HEAD
	dec	al
	mov	bp_dh,al
	mov	ax,LS120_EMUL_CYL_SEC
Check_Media:
	mov	di,offset HD5_PARMS
	mov	bp_cx,500fh
	mov	bp_cx,4f0fh
	je	short Set_parm
	mov	di,offset HD_PARMS
	mov	bp_cx,4f12h
	cmp	ah,50h				;1.44MB/720KB floppy?
	je	short Set_parm
	mov	bp_cx,ax
Set_parm:
;R15A end
	mov	bp_bl,10h			;R06
	mov	BP_ES,cs
	mov	BP_DI,di

	mov	ah,byte ptr HARDWARE
	shr	ah,6
	inc	ah
	mov	bp_dl,ah
	xor	ah,ah
	jmp	short std_atapi_ret
@@:
endif ;LS120_SUPPORT
;R08 start
ifdef IOMEGA_ZIP_Support
	test	INT13X_FLAG,IOMEGA_ZIP_Exist
	jz	short @F
	mov	bp_dh,1
	mov	bp_cx,4f12h
	mov	bp_bl,10h
	mov	BP_ES,cs
	mov	BP_DI,offset HD_PARMS

	mov	ah,byte ptr HARDWARE
	shr	ah,6
	inc	ah
	mov	bp_dl,ah
	xor	ah,ah
	jmp	short std_atapi_ret
@@:
endif ;IOMEGA_ZIP_Support
;R08 end
  call  get_atapi_parm
  mov   ah,0
  cmp	bp_dl,80h
  jae	short Not_Floppy
  mov	bl,2
  cmp	cl,0fh
  je	short @F
  add	bl,2
  cmp	cl,12h
  je	short @F
  inc	bl
@@:
	mov	BP_ES,cs
	mov	di,offset HD5_PARMS
	cmp	bl,2
	je	short @F
	mov	di,offset HD_PARMS
	cmp	bl,4
	je	short @F
	mov	di,offset ED_PARMS
@@:
	mov	bp_di,di
  mov	bp_bl,bl
Not_Floppy:
  mov   bp_cx,cx
  mov   bp_dx,dx
std_atapi_ret:
	mov	bp_ah,ah
std_atapi_ret1:
	pop	ds
	pop	es
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	mov	bp,ax
	pop	ax
	add	sp,CDROM_RSV_byte
	xchg	ax,bp
	or	ah,ah
	xchg	ax,bp
	pop	bp
	xchg	sp,bp			;R04
	mov	[bp],ax			;R04
	xchg	sp,bp			;R04
	pop	eax					;R02
	clc
	jz	short @F
	stc
@@:
	ret
std_atapi endp

;=============================================================================
;Func:  ATAPI_RESET
;Desc:  Do soft reset, diagnostic mode, and test unit ready to init CD
;Entry: none (use controller address in BDA)
;Exit:  CC/CS
;=============================================================================
atapi_reset proc near
		call	CTLR_BUSY
		jnc	short @F
		dec	dl
		mov	al,CDROM_drive
		out	dx,al
		newiodelay
		call	CTLR_BUSY
		mov	al,ATAPI_Soft_Reset
		out	dx,al
@@:
		ret
atapi_reset endp

;=============================================================================
;Func:  Extend_ATAPI_RD
;Desc:  Translate standard int 13 call parameters and read atapi
;Entry: AH = 42h (extend read function)
;       DL = drive number
;       DS:SI = Disk-address packet
;=============================================================================
Extend_ATAPI_RD proc near
		mov	ax,BP_DS
		mov	es,ax
		mov	bx,BP_SI
		mov	al,es:[bx].DAP_Packet_Size
		cmp	al,10h
		jae	short @F
		mov	ah,1
		ret
@@:
		mov	ax,BP_ES
		push	ax
		mov	ax,BP_BX
		push	ax
		mov	al,BP_AL
		push	ax

		mov	eax,es:[bx].DAP_Buffer_Address
		mov	BP_BX,ax
		shr	eax,16
		mov	BP_ES,ax

		mov	ax,es:[bx].DAP_Block_Count
		shl	ax,2
		mov	BP_AL,al
		mov	DAP_Block_Count_hi,ah

		mov	eax,es:[bx].DAP_Lo_Block_Number
		rol	ax,8
		rol	eax,16
		rol	ax,8
		xor	cl,cl
		mov	Start_Capt_Sec,0

		mov	CMD_Pkt_buffer.OpCode,ATAPI_Read
		or	INT13X_FLAG,RW_Flag
		call	Set_ATAPI_Parm

		pop	bx
		mov	BP_AL,bl
		pop	bx
		mov	BP_BX,bx
		pop	bx
		mov	BP_ES,bx
		ret

Extend_ATAPI_RD endp

;=============================================================================
;Func:  Extend_4B_func
;Desc:  This function returns the system to a configuration that matches a
;	normal floppy or hard disk boot
;Entry: AH = 4Bh (extend read function)
;	AL = 00,return status and terminate emulation
;	AL = 01,return status only,do not terminate emulation
;       DL = drive number to terminate, 7F = terminate all
;       DS:SI = Empty specification packet for return
;
;	else detial see (EI Torito bootable CD-ROM SPEC)
;
;=============================================================================
Extend_4B_func	proc near
;R12		cmp	bp_al,1
;R12		jne	short Ext4B_exit
;R12		mov	byte ptr ds:[si].F4B_Packet_Size,size Func4B_Specify_Pkt
;R12		mov	byte ptr ds:[si].F4B_media_type,40h
;R12		mov	byte ptr ds:[si].F4B_drive_num,CDROM_EMUL_NUM
;R12		mov	byte ptr ds:[si].F4B_controller_index,0	;?????
;R12		mov	eax,ds:CDROM_EMUL_START_SECTOR
;R12		mov	ds:[si].F4B_LBA,eax
;R12		mov	al,ds:[CDROM_ALLOCATE]
;R12		mov	ah,al
;R12		and	al,1
;R12		shr	ah,1
;R12		mov	ds:[si].F4B_drive_specify,ax
;R12		mov	ds:[si].F4B_buffer_seg,2000h	;user buffer segment
;R12		mov	ds:[si].F4B_load_seg,7c0h
;R12		mov	ds:[si].F4B_sector_count,0
;R12		mov	cx,ds:CDROM_EMUL_CYL_SEC
;R12		dec	ch
;R12		mov	ds:[si].F4B_cyl_count,ch
;R12		mov	ds:[si].F4B_sector,cl
;R12		mov	dh,ds:CDROM_EMUL_HEAD
;R12		dec	dh
;R12		mov	ds:[si].F4B_head,dh
;R12 start
		mov	ah,80h
		cmp	bp_al,1
		ja	Ext4B_exit
		mov	si,bp_ds
		mov	es,si
		mov	si,bp_si
		mov	byte ptr es:[si].F4B_Packet_Size,size Func4B_Specify_Pkt

		mov	ah,40h
		mov	cl,CDROM_EMUL_NUM	;set Drive number for no emulation
		mov	al,ds:[CDROM_ALLOCATE]
		and	al,0ch			;isolate emulate bits
		cmp	al,0ch			;Is no emulation?
		je	short @F		;Yes,jump
		mov	cl,80h			;set Drive number for HD
		or	ah,4			;assume HD emulation
		cmp	al,8			;Is HD emulation?
		je	short @F		;Yes,jump
		xor	cl,cl			;set Drive number for FD
		dec	ah			;assume 2.88 emulation
		mov	al,byte ptr ds:[CDROM_EMUL_CYL_SEC]
		cmp	al,24h			;Is 2.88 emulation?
		je	short @F		;Yes,jump
		dec	ah			;assume 1.44 emulation
		cmp	al,12h			;Is 1.44 emulation?
		je	short @F		;Yes,jump
		dec	ah			;assume 1.2 emulation
@@:
		mov	byte ptr es:[si].F4B_media_type,ah
		mov	byte ptr es:[si].F4B_drive_num,cl
		mov	byte ptr ds:[si].F4B_controller_index,0	;?????
		mov	eax,ds:CDROM_EMUL_START_SECTOR
		mov	es:[si].F4B_LBA,eax
		mov	al,ds:[CDROM_ALLOCATE]
		mov	ah,al
		and	al,1
		shr	ah,1
		mov	es:[si].F4B_drive_specify,ax
		mov	es:[si].F4B_buffer_seg,2000h	;user buffer segment
		mov	es:[si].F4B_load_seg,7c0h
		mov	es:[si].F4B_sector_count,0
		mov	cx,ds:CDROM_EMUL_CYL_SEC
		dec	ch
		mov	es:[si].F4B_cyl_count,ch
		mov	es:[si].F4B_sector,cl
		mov	dh,ds:CDROM_EMUL_HEAD
		dec	dh
		mov	es:[si].F4B_head,dh

		cmp	bp_al,0
		jne	short @F
		mov	byte ptr ds:[CDROM_ALLOCATE],0	;terminate emulation
@@:
;R12 end
		xor	ah,ah
Ext4B_exit:
		ret
Extend_4B_func	endp

Send_Test_Unit_Ready:
		clc
		xor	ah,ah
;R08ifdef LS120_SUPPORT
;R08		test	INT13X_FLAG,Floptical_Exist
		test	INT13X_FLAG,Floptical_Exist+IOMEGA_ZIP_Exist	;R08
		jz	short @F
		push	bx
		mov	CMD_Pkt_buffer.OpCode,Test_Unit_Ready
		mov	CMD_Pkt_buffer.CD_Reserved0,0
		mov	CMD_Pkt_buffer.S_LBA,0
		mov	CMD_Pkt_buffer.CD_Reserved1,0
		mov	CMD_Pkt_buffer.S_Length,0
		mov	CMD_Pkt_buffer.CD_Reserved2,0
		mov	CMD_Pkt_buffer.CD_Reserved3,0
		mov	CMD_Pkt_buffer.CD_Reserved4,0
		call	Send_Pkt_Cmd
;R05 start
		pushf
		cmp	ah,6
		jne	short Drive_OK
ifdef LS120_SUPPORT					;R08
		test	INT13X_FLAG,Floptical_Exist	;R08
		jz	short Drive_OK			;R08
		push	ax
		mov	CMD_Pkt_buffer.OpCode,Read_Capacity_Cmd
		call	Send_Pkt_Cmd
		jc	short Drive_OK1
		mov	dx,CDROM_port
		in	eax,dx
		newiodelay
		in	eax,dx
		newiodelay
		call	Get_Media_Para
Drive_OK1:
		pop	ax
endif ;LS120_SUPPORT					;R08
Drive_OK:
;R20A start
	test	INT13X_FLAG,Floptical_Exist
	jz	short Dont_Set_LS120_Para
	lea	bx,G_RAM:[Floptical0_EMUL_CYL_SEC]
	test	G_RAM:[ATAPI_Byte],30h
	jz	short Is_dirveA
	cmp	bp_dl,0
	je	short Is_dirveA
	lea	bx,G_RAM:[Floptical1_EMUL_CYL_SEC]
Is_dirveA:
	mov	dx,G_RAM:[bx]
	mov	LS120_EMUL_CYL_SEC,dx
	mov	dx,G_RAM:[bx+2]
	mov	LS120_EMUL_HEAD,dl
	mov	LS120_Medium_Type,dh
Dont_Set_LS120_Para:
;R20A end
		popf
;R05 end
		pop	bx
@@:
;R08endif ;LS120_SUPPORT
		ret

;=============================================================================
;Func:  STD_ATAPI_ACCESS
;Desc:  Translate standard int 13 call parameters and read atapi
;Entry: AH = 2 (read function)
;       AL = number of sectors
;       CH = cyl low
;       CL = cyl high(2 bits) / sector(low 6 bits)
;       DH = heads
;       DL = drive
;       ES:BX = buffer
;=============================================================================
std_atapi_access	proc	near
		call	Send_Test_Unit_Ready
		jc	exit
		mov	CMD_Pkt_buffer.OpCode,bl
		mov	ax,BP_CX
		xchg	al,ah
		shr	ah,6
		mov	cl,ds:CDROM_EMUL_HEAD
ifdef LS120_SUPPORT
		test	INT13X_FLAG,Floptical_Exist
		jz	short @F
;R07		mov	cl,ds:Floptical_EMUL_HEAD
		mov	cl,LS120_EMUL_HEAD		;R07
@@:
endif ;LS120_SUPPORT
;R08 start
ifdef IOMEGA_ZIP_Support
		test	INT13X_FLAG,IOMEGA_ZIP_Exist
		jz	short @F
		mov	cl,IOMEGA_ZIP_Heads
@@:
endif ;IOMEGA_ZIP_Support
;R08 end
		xor	ch,ch
		mul	cx				;ax = cyl. x HEAD
		add	al,BP_DH
		adc	ah,0
		mov	cl,byte ptr ds:CDROM_EMUL_CYL_SEC
ifdef LS120_SUPPORT
		test	INT13X_FLAG,Floptical_Exist
		jz	short @F
;R07		mov	cl,byte ptr ds:Floptical_EMUL_CYL_SEC
		mov	cx,LS120_EMUL_CYL_SEC	;R07
		xor	ch,ch			;R07
@@:
endif ;LS120_SUPPORT
;R08 start
ifdef IOMEGA_ZIP_Support
		test	INT13X_FLAG,IOMEGA_ZIP_Exist
		jz	short @F
		mov	cl,IOMEGA_ZIP_Sectors
@@:
endif ;IOMEGA_ZIP_Support
;R08 end
		and	cl,3fh
		mul	cx
		mov	cl,BP_CL
		and	cl,3fh
		dec	cx
;R08 start
ifdef IOMEGA_ZIP_Support
		test	INT13X_FLAG,IOMEGA_ZIP_Exist
		jz	short @F
		add	cx,IOMEGA_ZIP_Sectors
@@:
endif ;IOMEGA_ZIP_Support
;R08 end
		add	ax,cx
		adc	dx,0				;dx/ax = LBA number (physical sector)
		test	INT13X_FLAG,Sector_200b
		jnz	short @F
		mov	cl,al
		and	cl,3
		mov	Start_Capt_Sec,cl
		shr	dx,1
		rcr	ax,1
		shr	dx,1
		rcr	ax,1				;dx/ax = CDROM LBA number
		add	ax,word ptr ds:CDROM_EMUL_START_SECTOR
		adc	dx,word ptr ds:CDROM_EMUL_START_SECTOR+2
@@:
		xchg	al,ah
		shl	eax,16
		xchg	dl,dh
		mov	ax,dx
		mov	DAP_Block_Count_hi,0
Set_ATAPI_Parm:
		mov	CMD_Pkt_buffer.S_LBA,eax

		mov	ah,BP_AL
		test	INT13X_FLAG,Sector_200b
		jnz	short @F
		add	ah,cl
		add	ah,3
		shr	ah,2
@@:
		mov	al,DAP_Block_Count_hi
		mov	CMD_Pkt_buffer.S_Length,ax

		call	Send_Pkt_Cmd
		jc	exit

		cmp	CMD_Pkt_buffer.OpCode,ATAPI_Verify
		je	atapi_access_over
		cmp	CMD_Pkt_buffer.OpCode,ATAPI_Format
		je	atapi_access_over

		test	INT13X_FLAG,Sector_200b
		jnz	short Read_Capture_Sector

		mov	cl,Start_Capt_Sec
		xor	ch,ch
		shl	cx,8
		mov	bx,cx
		jcxz	short Read_Capture_Sector
		call	CTLR_BUSY	;R10
		mov	dx,CDROM_port
		cli
		align	4
@@:
		in	ax,dx
		loop	@B
		sti
		call	Wait_Drq_Clear	;R10
		call	Wait_BSY	;R10

Read_Capture_Sector:
;R08 start 
ifdef IOMEGA_ZIP_Support
;--- for write BPB (sector 0) modify
		xor	al,al
		call	Change_BPB_data
		jc	short @F
		mov	byte ptr es:[di+26],64
		mov	byte ptr es:[di+28],32
		mov	byte ptr es:[di+36],80h
@@:
endif ;IOMEGA_ZIP_Support
;R08 end
		test	INT13X_FLAG,Sector_200b
		jnz	short @F
		mov	cx,400h
		sub	cx,bx
@@:
		mov	di,BP_ES
		mov	es,di
		mov	di,BP_BX
		mov	bl,BP_AL
		mov	bh,DAP_Block_Count_hi
		shl	bx,8
		test	INT13X_FLAG,Sector_200b
		jnz	short Access_loop
		cmp	cx,bx
		jbe	short @F
		mov	cx,bx
		jmp	short @F
Access_loop:
		call	CTLR_BUSY
		jc	exit

		mov	ah,3
		mov	al,INT13X_FLAG
		and	al,RW_Flag
		call	Get_CoD_IO
		jc	With_Error
		jnz	With_Error
@@:
		test	INT13X_FLAG,Sector_200b
		jnz	short @F
		sub	bx,cx
		jnc	short @F
		add	bx,cx
		mov	cx,bx
		xor	bx,bx
@@:
		call	CTLR_BUSY
		jc	With_Error
		test	INT13X_FLAG,Sector_200b
		jz	short @F
		mov	cx,100h
@@:
		mov	dx,CDROM_port
		cli
		test	INT13X_FLAG,RW_Flag
		jnz	short Read_Data
		align	4
@@:
		mov	ax,es:[di]
		add	di,2
		out	dx,ax
		loop	@B
		sti
		jmp	short Transfer_Date_Over
Read_Data:
		align	8
@@:
		in	ax,dx
		stosw
		loop	@B
		sti
		call	Wait_Drq_Clear
		call	Wait_BSY	;R10
Transfer_Date_Over:
		test	INT13X_FLAG,Sector_200b
		jz	short @F
		sub	bx,100h
		jz	short Read_Over
		jmp	short Access_loop
@@:
		or	bx,bx
		jz	short Read_Others
		mov	cx,400h
		jmp	Access_loop
Read_Others:
		test	INT13X_FLAG,Sector_200b
		jnz	short Read_Over
		mov	al,Start_Capt_Sec
		add	al,BP_AL
		and	al,3
		mov	cl,4
		sub	cl,al
		mov	ch,DAP_Block_Count_hi
		jcxz	short Read_Over
		call	CTLR_BUSY	;R10
		shl	cx,8
		mov	dx,CDROM_port
		cli
		align	4
@@:
		in	ax,dx
		loop	@B
		sti
Read_Over:
		call	Wait_Drq_Clear
		call	Wait_BSY	;R10

atapi_access_over:
;R08 start 
ifdef IOMEGA_ZIP_Support
;--- for read BPB (sector 0) modify
		mov	al,RW_Flag
		call	Change_BPB_data
		jc	short @F
		mov	byte ptr es:[di+26],12
		mov	byte ptr es:[di+28],0
		mov	byte ptr es:[di+36],0
@@:
endif ;IOMEGA_ZIP_Support
;R08 end
		clc
		xor	ah,ah
exit:
		ret
std_atapi_access	endp

;R08 start
ifdef IOMEGA_ZIP_Support
Change_BPB_data:
	test	INT13X_FLAG,IOMEGA_ZIP_Exist
	jz	short Dont_trans_BPB
	test	INT13X_FLAG,IOMEGA_ZIP_RW
	jz	short Dont_trans_BPB
	cmp	BP_CX,1
	jne	short Dont_trans_BPB
	cmp	BP_DH,0
	jne	short Dont_trans_BPB
	mov	ah,INT13X_FLAG
	and	ah,RW_Flag
	cmp	al,ah
	jne	short Dont_trans_BPB
	mov	di,BP_ES
	mov	es,di
	mov	di,BP_BX
	clc
	ret
Dont_trans_BPB:
	stc
	ret
endif ;IOMEGA_ZIP_Support
;R08 end

;=============================================================================
;Func:  GET_ATAPI_PARM
;Desc:  Get parameters for ATAPI disk
;Entry: DL = drive
;Exit:  DH = max head number
;       DL = number of drives
;       CH = max cyl number (low 8 bits)
;       CL = 7:6 max cyl number high bits, 5:0 max sector number
;=============================================================================
get_atapi_parm proc	near
		mov	dh,ds:CDROM_EMUL_HEAD
		dec	dh
		mov	dl,ds:NUMHDSKS
		mov	cl,byte ptr ds:HARDWARE
		test	cl,1
		jz	short None_floppy
		rol	cl,2			; bit 6 to bit 0.
		and	cl,1			; isolate
		inc	cl			; 0->1, 1->2
		add	dl,cl
None_floppy:
		mov	cx,ds:CDROM_EMUL_CYL_SEC
		dec	ch
		ret
get_atapi_parm endp

Send_Pkt_Cmd:
		call	Drive_Ready
		jc	With_Error
		dec	dl
		mov	al,CDROM_drive
		out	dx,al
		newiodelay
;R04		call	Ctlr_Drive_Ready
		call	Drive_Ready		;R04
		jc	With_Error

;----- Issue Packet Command
		sub	dx,6			;dx = 1X1h
		xor	al,al
		out	dx,al
		newiodelay

		add	dx,3			;dx = 1X4h
		out	dx,al			;send total bytes (low byte) of transfer
		newiodelay

		inc	dx			;dx = 1X5h
;R17		mov	al,Size ATAPI_CmdPkt
		mov	al,8				;R17 800h bytes per sector of CDROM
;R17A start
		test	INT13X_FLAG,Sector_200b
		jz	short @F
		mov	al,2				;200h bytes per sector for LS120/ZIP
@@:
;R17A end
		mul	byte ptr ss:[CMD_Pkt_Buffer+8]	;R17 send total bytes (high byte) of transfer
;R17B start
		or	al,al
		jnz	short @F
		mov	al,0ffh
		dec	dl
		out	dx,al
		inc	dl
@@:
;R17B end
		out	dx,al
		newiodelay

		inc	dx			;dx = 1X6h
		mov	al,CDROM_drive
		out	dx,al
		newiodelay

;R04		call	Drive_Ready
		call	Ctlr_Drive_Ready	;R04
		call	Wait_Drq_Clear

		mov	al,ATAPI_Pkt_Cmd
		out	dx,al
		newiodelay

		call	CTLR_BUSY
		jc	With_Error

		call	Get_DRQ
		jc	With_Error

;----- Write Command Packet Bytes
		mov	dx,CDROM_port
		mov	cx,Size ATAPI_CmdPkt
		shr	cx,1
		lea	si,CMD_Pkt_Buffer
		cli
		align	4
@@:
		mov	ax,ss:[si]
		out	dx,ax
		add	si,2
		loop	@B
		sti
		call	Wait_Drq_Clear

		call	CTLR_BUSY
		jc	With_Error
		cmp	CMD_Pkt_buffer.OpCode,ATAPI_Verify
		je	short Check_Error
		cmp	CMD_Pkt_buffer.OpCode,ATAPI_Format
		je	short Check_Error
		cmp	CMD_Pkt_buffer.OpCode,Read_Capacity_Cmd	;R05
		je	short Check_Error			;R05
		cmp	CMD_Pkt_buffer.OpCode,Test_Unit_Ready
		jne	short Get_Trans_Status
Check_Error:
		call	Ctlr_Drive_Ready
		jc	With_Error
		in	al,dx			;dx = 1X7h
		newiodelay
		test	al,1
		jnz	short Get_Error
		jmp	No_Error
Get_Trans_Status:
		mov	ah,3
		mov	al,INT13X_FLAG
		and	al,RW_Flag
		call	Get_CoD_IO
		jc	short @F
		jz	No_Error
@@:
		mov	dx,CDROM_port
		add	dx,7
		in	al,dx			;dx = 1X7h
		newiodelay
		test	al,1
		jz	Send_Pkt_Cmd
Get_Error:
		sub	dx,6			;dx = 1X1h
		in	al,dx
		newiodelay
		shr	al,4
		cmp	al,2			;Not Ready... Retry
		je	With_Error
		cmp	al,4
		je	With_Error
;R19 - start
		cmp	al,5			;
		jne	short @F
		mov	ah,32h			;return Media type not supported by drive
		jmp	Error_Ret
@@:
;R19 -end
		cmp	al,7			;write protect
		jne	short @F
		mov	ah,3			;return write protect status
		jmp	Error_Ret
@@:
		cmp	al,6			;Unit Attention... Retry
		jne	With_Error
		test	INT13X_FLAG,IOMEGA_ZIP_Exist	;R08
		jnz	Media_change			;R08
		test	INT13X_FLAG,Floptical_Exist
		jz	With_Error
ifdef LS120_SUPPORT
Get_Media_Para:					;R05
		xor	bh,bh
Resend_Id_Cmd:
;----- media have changed so redetect media type for floptical parameter
		call	Ctlr_Drive_Ready
		jc	With_Error
		mov	dx,CDROM_port
		add	dx,7			;dx = 1X7h
		mov	al,ATAPI_Identify_Cmd
		out	dx,al			;Send CDROM identify command
		call	Ctlr_Drive_Ready
		jc	With_Error
		call	Get_DRQ
		jc	With_Error
		mov	dx,CDROM_port
		in	ax,dx			;discard word 0
		in	ax,dx			;get word 1
		mov	di,ax			;get cylinders
		in	ax,dx			;discard word 2
		in	ax,dx			;get word 3
		mov	cl,al			;get heads
		in	ax,dx			;get word 4
		or	al,al			;have any media in drive?
		jnz	short Media_Exist
		mov	cx,0ffh-4		;read remain word
@@:
		in	ax,dx
		loop	@B
		dec	bh
		jnz	Resend_Id_Cmd
		jmp	short With_Error
Media_Exist:
;R07		mov	G_RAM:[Floptical_Medium_Type],al
;R07 start
		lea	si,G_RAM:[Floptical0_EMUL_CYL_SEC]
		test	G_RAM:[ATAPI_Byte],30h			;R14A
		jz	short @F				;R14A
		cmp	BP_DL,0
		je	short @F
		lea	si,G_RAM:[Floptical1_EMUL_CYL_SEC]
@@:
		mov	G_RAM:[si+3],al
;R07 end
		in	ax,dx			;discard word 5
		in	ax,dx			;get word 6
		mov	ch,al			;get heads
		mov	bl,53-7+1		;discard word 7-53
@@:
		in	ax,dx
		dec	bl
		jnz	@B
		in	ax,dx			;get word 54
		cmp	ax,di			;cylinders is equal with word 54?
		je	short @F
		in	ax,dx			;discard word 55
		in	ax,dx			;discard word 56
		jmp	short Discard_remain_word
@@:
		in	ax,dx			;get word 55
		cmp	cl,al			;Heads is equal with word 55?
		je	short @F
		in	ax,dx			;discard word 56
		jmp	short Discard_remain_word
@@:
		in	ax,dx			;get word 56
		cmp	ch,al			;Sectors is equal with word 56?
		jne	short Discard_remain_word
		mov	ax,di			;restore cylinders to AX
;R07		mov	G_RAM:[Floptical_EMUL_HEAD],cl
		mov	G_RAM:[si+2],cl		;R07
		shl	ah,6
		and	ch,3fh
		or	ah,ch
		xchg	al,ah
;R07		mov	G_RAM:[Floptical_EMUL_CYL_SEC],ax
		mov	G_RAM:[si],ax		;R07
Discard_remain_word:
		mov	cx,0ffh-56		;read remain word
@@:
		in	ax,dx
		loop	@B
endif ;LS120_SUPPORT
Media_change:					;R08
		mov	ah,6			;media changed
		jmp	short Error_Ret
With_Error:
		mov	ah,80h
Error_Ret:
		stc
		ret
No_Error:
		clc
		xor	ah,ah
		ret

;-------------------------------------------
;input  : None
;output : CY = error
;	  NC = OK
;-------------------------------------------
Drive_Ready:
;R03		test	INT13X_FLAG,RW_Flag
;R03		jnz	short CTLR_BUSY
		test	INT13X_FLAG,RW_Flag		;R04
		jnz	short CTLR_BUSY			;R04
Ctlr_Drive_Ready:
;R03		test	INT13X_FLAG,Floptical_Exist
;R03		jz	short CTLR_BUSY
;R03		mov	ax,0c040h
;R03		jmp	short Check_Status_Port
		test	INT13X_FLAG,Floptical_Exist	;R04
		jz	short CTLR_BUSY			;R04
		mov	ax,0c040h			;R04
		jmp	short Check_Status_Port		;R04

CTLR_BUSY	PROC	NEAR
		mov	ax,8000h
Check_Status_Port:
		push	bx
		push	cx

		mov	dx,CDROM_port
		add	dx,7			;dx = 1X7h
		mov	bh,WAIT_UHD_BUSY_HI
		mov	cx,WAIT_UHD_BUSY_LO
		call	WAIT_FOR_PORT
		clc
		or	ah,ah
		jz	short @F
		stc
@@:
		pop	cx
		pop	bx
		ret
CTLR_BUSY	ENDP

;-------------------------------------------
;input  : None
;output : CY = error
;	  NC = OK
;-------------------------------------------
Get_DRQ		PROC	NEAR
		push	bx
		push	cx

		mov	dx,CDROM_port
		add	dx,7			;dx = 1X7h
		mov	bh,WAIT_UHD_DRQ_HI
		mov	cx,WAIT_UHD_DRQ_LO
Get_Drq_Loop:
		push	bx
		push	cx
		mov	ax,808h			;wait for top bit to be 0
		xor	bh,bh
		mov	cx,20h
		call	WAIT_FOR_PORT
		pop	cx
		pop	bx
		clc
		or	ah,ah
		jz	short Get_Drq_Exit
		in	al,dx
		test	al,1
		jnz	short Get_Drq_Err
		loop	Get_Drq_Loop
		or	bh,bh
		jz	short Get_Drq_Err
		dec	bh
		jmp	short Get_Drq_Loop
Get_Drq_Err:
		stc
Get_Drq_Exit:
		pop	cx
		pop	bx
		ret
Get_DRQ		ENDP

;-------------------------------------------
;input  : AX = Get pattern
;output : CY = error
;	  NC = OK
;	  NZ = Resend command
;-------------------------------------------
Get_CoD_IO	PROC	NEAR
		push	bx
		push	cx

		mov	dx,CDROM_port
		add	dx,2			;dx = 1X2h
		mov	bh,3
		mov	cx,8000h

		mov	bl,al
G_CoD_IO_Loop:
		in	al,dx			;get status
		and	al,ah			;isolate bits.
		cmp	al,bl			;check for match.
		je	short Got_Pattern	;got the bit
		cmp	al,3
		je	short Resend_Cmd

		ALIGN	4
R_Hi:		in	al,SYS1			;wait for hi to lo
		test	al,10h			;transition on memory
		jnz	short R_Hi		;refresh.

		ALIGN	4
R_Lo:
		in	al,SYS1
		test	al,10h
		jz	short R_Lo

		loop	short G_CoD_IO_Loop
		stc
		or	bh,bh
		jz	short G_CoD_IO_Exit
		dec	bh
		jmp	short G_CoD_IO_Loop

Got_Pattern:
		call	Get_DRQ					;R00
		jc	short G_CoD_IO_Exit			;R00
		xor	ah,ah			;success
		jmp	short @F
Resend_Cmd:
		or	ah,1			;Resend Command
@@:
		clc
G_CoD_IO_Exit:
		pop	cx
		pop	bx
		ret
Get_CoD_IO	ENDP

Wait_Drq_Clear:
		push	bx
		push	cx

		mov	dx,CDROM_port
		add	dx,7			;dx = 1X7h
		xor	bh,bh
		mov	cx,20h
		mov	ax,800h
		call	WAIT_FOR_PORT
		call	CTLR_BUSY

		pop	cx
		pop	bx
		ret

;R10 start
Wait_BSY:
		push	bx
		push	cx

		mov	dx,CDROM_port
		add	dx,7			;dx = 1X7h
		xor	bh,bh
		mov	cx,80h
		mov	ax,8080h
		call	WAIT_FOR_PORT

		pop	cx
		pop	bx
		ret
;R10 end

endif ;ATAPI_COMMAND_SUPPORT

;R01 start
ifdef	Int13_Extensions
		public	EXTEND_FUNC_MAX
		public	EXTEND_FUNC
		public	Get_DAP_Value
Extend_Func:
		DW	OFFSET	FUN41		;FUN41
		DW	OFFSET	FUN42		;FUN42
		DW	OFFSET	FUN43		;FUN43
		DW	OFFSET	FUN44		;FUN44
		DW	OFFSET	FUN45		;FUN45
		DW	OFFSET	FUN46		;FUN46
		DW	OFFSET	FUN47		;FUN47
		DW	OFFSET	FUN48		;FUN48
		DW	OFFSET	FUN49		;FUN49
Extend_Func_MAX	EQU	($-offset Extend_Func)/2

;[]------------------------------------------------------------------------[]
;Function:   	Check for Extension support
;Entry:  	INT 13h
;Input:  	AH = 41h
;		BX = 55AAh
;               DL = Drive Number
;Output: 	CF = 0 - operation successfully completed
;		   AH - major version of extensions
;		   AL - minor version of extensions
;		   BX = 0AA55h
;		   CX = Bits 15 to 2 - reserved (set to 0)
;			Bits 1 = 0 - Removable-media control is not supported
;			       = 1 - Removable-media control is supported
;			Bits 0 = 0 - Extended disk access is not supported
;			       = 1 - Extended disk access is supported
;		CF = 1 - operation failed
;		   AH - Status of operation
;Description:
;
;[]------------------------------------------------------------------------[]
FUN41:
		cmp	word ptr +4[bp],55aah		;BX = 55aah?
		jne	FUN10_2				;no,then return error
		mov	word ptr +2[bp],2100h		;return AX
		mov	word ptr +4[bp],0aa55h		;return BX
;R18		mov	word ptr +6[bp],1		;return CX
		mov	word ptr +6[bp],5		;return CX ;R18
		jmp	GOOD_RET

;[]------------------------------------------------------------------------[]
;Function:   	Extended Read
;Entry:  	INT 13h
;Input:  	AH = 42h
;               DL = Drive Number
;		DS:SI = Disk-address packet
;Output: 	CF = 0 - operation successfully completed
;		     1 - operation failed
;		   AH - Status of operation
;Description:
;
;[]------------------------------------------------------------------------[]
FUN42:
		mov	HD_CMD,20h
		jmp	cont_cmd

;[]------------------------------------------------------------------------[]
;Function:   	Extended Write
;Entry:  	INT 13h
;Input:  	AH = 43h
;		AL = Bits 7 to 1 - reserved (set to 0)
;		     Bit 0 = 0 - Write-verify off
;		     	   = 1 - Write-verify on
;               DL = Drive Number
;		DS:SI = Disk-address packet
;Output: 	CF = 0 - operation successfully completed
;		CF = 1 - operation failed
;		   AH - Status of operation
;Description:
;
;[]------------------------------------------------------------------------[]
FUN43:
		mov	HD_CMD,30h
		jmp	cont_cmd

;[]------------------------------------------------------------------------[]
;Function:   	Extended Verification
;Entry:  	INT 13h
;Input:  	AH = 44h
;               DL = Drive Number
;		DS:SI = Disk-address packet
;Output: 	CF = 0 - operation successfully completed
;		CF = 1 - operation failed
;		   AH - Status of operation
;Description:
;
;[]------------------------------------------------------------------------[]
FUN44:
		mov	HD_CMD,40h
		jmp	cont_cmd

;[]------------------------------------------------------------------------[]
;Function:   	Lock/Unlock drive
;Entry:  	INT 13h
;Input:  	AH = 45h
;               AL = 0 - Lock media in drive
;                  = 1 - Unlock media in drive
;                  = 2 - Return lock/unlock status
;                  = 3 to 0ffh - reserved
;               DL = Drive Number
;Output: 	CF = 0 - operation successfully completed
;		CF = 1 - operation failed
;		   AH - Status of operation
;		      =	1   - unsupported function or parameter
;		      =	20h - general controller failure
;		      =	80h - controller did not respond
;		      =	B0h - media not locked in drive
;		      =	B4h - lock count exceeded
;		   AH - Lock/Unlock status
;		      = 0 - drive is locked
;		      = 1 - drive is unlocked
;Description:
;
;[]------------------------------------------------------------------------[]
FUN45:

;[]------------------------------------------------------------------------[]
;Function:   	Eject media from drive
;Entry:  	INT 13h
;Input:  	AH = 46h
;               DL = Drive Number
;Output: 	CF = 0 - operation successfully completed
;		CF = 1 - operation failed
;		   AH - Status of operation
;		      =	1   - unsupported function or parameter
;		      =	20h - general controller failure
;		      =	80h - controller did not respond
;		      =	B1h - media locked in drive
;		      =	B2h - media not removable
;		      =	B2h - media in use
;		      =	B5h - valid eject request failed
;Description:
;
;[]------------------------------------------------------------------------[]
FUN46:
		jmp	FUN10_2

;[]------------------------------------------------------------------------[]
;Function:   	Extended Seek
;Entry:  	INT 13h
;Input:  	AH = 47h
;               DL = Drive Number
;		DS:SI = Disk-address packet
;Output: 	CF = 0 - operation successfully completed
;		CF = 1 - operation failed
;		   AH - Status of operation
;Description:
;
;[]------------------------------------------------------------------------[]
FUN47:
		mov	HD_CMD,70h
		jmp	cont_cmd

;[]------------------------------------------------------------------------[]
;Function:   	Extended Get Drive Parameters
;Entry:  	INT 13h
;Input:  	AH = 48h
;               DL = Drive Number
;		DS:SI = Disk-address packet
;Output: 	CF = 0 - operation successfully completed
;		CF = 1 - operation failed
;		   AH - Status of operation
;		DS:SI = Resulting buffer
;Description:
;
;[]------------------------------------------------------------------------[]
FUN48:
	mov	si,+14[bp]
	mov	ds,si
	mov	si,+16[bp]
;R18	mov	word ptr ds:[si],26		;buffer size
;R18A	mov	word ptr ds:[si],30		;buffer size ;R18
;R18A start
	mov	ax,ds:[si]			;get buffer size
	cmp	ax,26				;check buffer size
	jae	short @F			;>= 26 then set parameter to buffer
	mov	word ptr +2[BP],100h		;set status = bad command
	jmp	AHDSK_ERROR_RET			;error return
@@:
	mov	word ptr ds:[si],26		;set buffer size = 26
	cmp	ax,30				;check buffer size
	jb	short @F			;< 26 then set parameter to buffer
	mov	word ptr ds:[si],30		;set buffer size = 30
@@:
;R18A end
	mov	word ptr ds:[si+2],00000010b	;information flags

	mov	dx,2
	mov	cl,14
ifndef ExtInt13_LBA				;R01B
	call	Detect_LBA_Mode
	jne	short @F
	mov	dx,90bh
	mov	cl,4
@@:
endif ;ExtInt13_LBA				;R01B
	xor	eax,eax
	mov	al,dl
	mov	dl,DRIVE
	CALL	GETHPARM			;get heads
	mov	ds:[si+8],eax			;store to buffer
	mov	ch,al

	mov	al,cl
	CALL	GETHPARM			;get sectors
	mov	ds:[si+0ch],eax			;store to buffer
	mov	cl,al

	mov	al,dh
	CALL	GETHPARM			;get cylinders
	mov	ds:[si+4],eax			;store to buffer
	xchg	ax,cx
	mul	ah
	mul	cx
	mov	word ptr ds:[si+16],ax
	mov	word ptr ds:[si+18],dx
	mov	word ptr ds:[si+20],0		;set high dword = 0
	mov	word ptr ds:[si+22],0
	mov	word ptr ds:[si+24],200h	;bytes in a sectors
;R18 - start
	cmp	word ptr ds:[si],30		;R18A check buffer size = 30?
	jb	short @F			;R18A if< 30 then skip
	movzx	dx,DRIVE
	shl	dl,4
	add	dx,offset cs:FDPTE_Drive0	;get FDPTE address	
	mov	word ptr ds:[si+26],dx		;save FDPTE offset
	mov	word ptr ds:[si+28],0f000h	;save segment
@@:						;R18A
;R18 - end

	mov	byte ptr +3[BP],0		;no error return
	jmp	GOOD_RET

;[]------------------------------------------------------------------------[]
;Function:   	Extended Disk-Change status
;Entry:  	INT 13h
;Input:  	AH = 49h
;               DL = Drive Number
;Output: 	CF = 0 - operation successfully completed
;		CF = 1 - operation failed
;		   AH = 0 - 'Change' line is inactive
;		      =	1 - 'Change' line is active
;Description:
;
;[]------------------------------------------------------------------------[]
FUN49:
		jmp	FUN10_2

Get_DAP_Value:
;R01A		cmp	byte ptr FUNC_CMD,41h		;function call(AH) below 41h
;R01A		jb	short @F			;Yes,standard call
		push	ds
		push	si
		mov	si,+14[bp]
		mov	ds,si
		mov	si,+16[bp]
		mov	eax,dword ptr ds:[si][bx]
		pop	si
		pop	ds
		clc
;R01A @@:
		ret
endif	;Int13_Extensions
;R01 end
;R18 - start
		align 	16
FDPTE_Drive0	db	16 dup(0)
FDPTE_Drive1	db	16 dup(0)
FDPTE_Drive2	db	16 dup(0)
FDPTE_Drive3	db	16 dup(0)
;R18 - end

FCODE   ENDS
END 

