;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;--------------------------2A5II---------------------------------------------
;R17    12/24/97 AVN    Change Item of caption 
;R16    12/16/97 ATY    Added AT/ATX Power Auto Scan By GPIO5 of item
;R15	11/11/97 ATY    Added AT/ATX power auto scan by GPIO8 of item
;R14	11/07/97 AVN	Change IDE burst mode setup default enable.
;R13	10/20/97 AVN	Fixed too much item to destroy Screen.
;			define 'No_Help_In_IOFEAT'
;R12	10/06/97 AVN	Added AT/ATX power auto scan by input GPCS1, and
;			define 'AT_ATX_SELECT_BY_GPCS1'
;R11	09/12/97 AVN	Fixed use NEC sdram (2T) warm boot will hang, because
;			SHADOW_OK_CMOS(46h) in cmos checksum locate and always
;			clear when write cmos from stack.
;			ALARM_CMOS had change define in BIOS.CFG
;R06C	08/20/97 AVN	save mode cmos
;R10	08/04/97 AVN	Added AT/ATX power auto scan by input GPCS0, and
;			define 'AT_ATX_SELECT_BY_GPCS0'
;R09	07/30/97 AVN	Save F000 code.
;R05A	06/20/97 JKY	Don't Disable USB host controller in POST stage.
;R08	06/16/97 AVN	Added Special Item Address for GEMLIGHT
;R07	06/02/97 JKY	Support no slave IDE mode
;R06B	06/02/97 JKY	Add ifndef for Power Button override function,Ring Up,
;			GPIO5 Power Up.
;R06A	05/28/97 AVN	Fix cmos setup conflict to smc669, so change cmos here
;R06	05/16/97 AVN	Add Alarm Power Up by define 'RSM_BY_ALARM', and add
;			Power Button override function,	Ring Up, GPIO5 Power Up.
;R05	05/08/97 KEN	Add USB host controller enabled/disabled item.
;R04	04/17/97 LRY	For Nexcom: add watch dog items, cmos at 7Bh
;R03	04/07/97 LRY	Added "Ultra_DMA33_support"
;R02	03/28/97 KEN	Add USB_SUPPORT.
;R01	03/05/97 LRY	Change IOCMOS from 7Ah to 48h
;R00	01/07/97 LRY	Initial version

		PAGE	56,132
		.286

		include bios.cfg
		include bsetup.inc
		include setup.ext
		Extrn	Std_Help_Str:near
		Extrn	PAGE_NAME_Y:ABS
		Extrn	Common_Startup_Str:Near
		Extrn	Ena_Str:Near
		Extrn	Dis_Str:Near
		Extrn	NullStr:Near
		Extrn	Self_Dis:near
		Extrn	Re_Enable:near

ifdef	NEW_IO_FEATURE

		Public	IO_Feature_Special_Do
		Public	IO_Feature_Special_Show
		Public	IO_Feature_Key_List
		Public	IO_Feature_StartUp_Str
		Public	IO_Feature_Start
		Public	IO_Feature_End

		Public	IO_Auto_Table
		Public	IO_EndAuto_Table
		Public	IO_Auto_String

endif;	NEW_IO_FEATURE

DGROUP		GROUP	FCODE
FCODE		SEGMENT DWORD PUBLIC 'CODE'
		ASSUME	CS:DGROUP,DS:DGROUP

ifdef	NEW_IO_FEATURE

IO_Feature_Special_Do:
			dw	IO_Feature_Do_NO
IO_Feature_Do_NO	EQU	(($ - offset IO_Feature_Special_Do)-2)/4

IO_Feature_Special_Show:
			dw	IO_Feature_Show_NO
ifdef	USB_SUPPORT						;R05
		dw	USB_ITEM     ,offset Show_USB_Legacy	;R05
endif	;USB_SUPPORT						;R05
ifdef	AIOCMOS
			include AUDIO.SHW
endif	;AIOCMOS
ifndef	ONBOARD_IO_IN_PCISETUP
			include superio.shw
endif	;ONBOARD_IO_IN_PCISETUP

ifdef	ONCHIP_IDE_IN_IOSETUP
ifndef	ONCHIP_IDE_ALWAYS_DISABLE
		dw	Offset Int_IDE_Item,	Offset Show_5513ide
endif	;ONCHIP_IDE_ALWAYS_DISABLE
endif	;ONCHIP_IDE_IN_IOSETUP

;R06 - start
ifdef	RSM_BY_ALARM
                dw      Offset ALARM_ITEM   ,Offset Show_ALARM_ITEM
endif;	RSM_BY_ALARM
;R06 - end

IO_Feature_Show_NO	EQU	(($ - offset IO_Feature_Special_Show)-2)/4

IO_Feature_Key_List	Label	Near
		dw	offset Seq_Up		;function for UP_ARROW
		dw	offset Seq_Down 	;function for DOWN_ARROW
		dw	offset Go_Left_Item	;function for LEFT_ARROW
		dw	offset Go_Right_Item	;function for RIGHT_ARROW

IO_Feature_StartUp_Str	label	near
		STRSHOW <,,,offset Common_StartUp_Str>
;R13 - start
ifdef	No_Help_In_IOFEAT
		CLEAR	<,41,18,78,23>
		POS	<,40,18>
		db	''
		POS	<,79,18>
		db	''
endif;	No_Help_In_IOFEAT
;R13 - end
		POS	<,29,PAGE_NAME_Y>
		public	IO_FEATURE_STR
IO_FEATURE_STR:
		db	'INTEGRATED PERIPHERALS'
		db	0

;----------------------------------------------------------------------------

		ALIGN	4
		db	0
IO_Auto_Table	label	near
IO_EndAuto_Table	label	near


;[]======================================================================[]
;
;			Menuitems
;
;[]======================================================================[]
IO_Feature_START	Label	Near

DEFINE_ITEM	MACRO	MENU_NAME,GAP
IFB	<GAP>
	Yaxis = Yaxis + 1
ELSE	;
 IF	Yaxis GT 3		;if Yaxis great than the top row, process gap
  IFDEF LAST_GAP_POSITION
   IF	Xaxis+Yaxis NE LAST_GAP_POSITION
	Yaxis = Yaxis + 1
   ENDIF;
  ELSE	;
	Yaxis = Yaxis + 1
  ENDIF ;LAST_GAP_POSITION
	LAST_GAP_POSITION = Xaxis + Yaxis
 ENDIF	;
	Yaxis = Yaxis + GAP
ENDIF	;GAP
IF	Yaxis GT 23
	Xaxis = 42
	Yaxis = 4
 IFNB	<GAP>
  IF	GAP EQ 0
	Yaxis = 3
  ENDIF	;
 ENDIF	;
ENDIF	;
IFNB	<MENU_NAME>
	PUBLIC	MENU_NAME
	MENU_NAME:
ENDIF
		ENDM

Xaxis	=	2
Yaxis	=	3

ifdef	ONCHIP_IDE_IN_IOSETUP

ifndef	ONCHIP_IDE_ALWAYS_DISABLE
DEFINE_ITEM	Int_IDE_Item,1
	menuitem <2,\
		  offset Int_IDE_Str,NOCT,03h,56h,0Ch,\
		  offset Int_IDE_Val,0,3,Xaxis,Yaxis,03h,0Ch,offset Std_Help_Str>
 ifdef	NEW_IDE_MODE_3
	FOUR_IDE_PIO_ITEM_IN_PCIFEAT	EQU	1
 endif	;NEW_IDE_MODE_3
endif	;ONCHIP_IDE_ALWAYS_DISABLE

ifdef	FOUR_IDE_PIO_ITEM_IN_PCIFEAT
DEFINE_ITEM	IdeA_Mode_Item
menuitem <0,\
offset IDEA_mode_Str,	       NOCT,11100000b,34h,11100000b,\
offset IDE_mode_Val,0,5,Xaxis,Yaxis,00100000b,	  00000000b,offset Std_Help_Str>

		public	Ide_mode_diff
Ide_mode_diff	EQU	$ - offset IdeA_mode_Item

Slave_Value	=	0			;R07

ifdef	IDE_PRIMARY_ONLY			;R07
Slave_Value	=	ItemDisable		;R07
endif	;IDE_PRIMARY_ONLY			;R07

DEFINE_ITEM	IdeB_Mode_Item
;R07 menuitem <0,\
menuitem <Slave_Value,\				;R07
offset IDEB_mode_Str,	       NOCT,00011100b,34h,00011100b,\
offset IDE_mode_Val,0,5,Xaxis,Yaxis,00000100b,	  00000000b,offset Std_Help_Str>

if	Slave_Value	EQ	ItemDisable	;R07
Yaxis	=	Yaxis	-	1		;R07
endif	;Slave_Value	EQ	ItemDisable	;R07

DEFINE_ITEM	IdeC_Mode_Item
menuitem <0,\
offset IDEC_mode_Str,	       NOCT,11100000b,35h,11100000b,\
offset IDE_mode_Val,0,5,Xaxis,Yaxis,00100000b,	  00000000b,offset Std_Help_Str>

DEFINE_ITEM	IdeD_Mode_Item
;R07 menuitem <0,\
menuitem <Slave_Value,\				;R07
offset IDED_mode_Str,	       NOCT,00011100b,35h,00011100b,\
offset IDE_mode_Val,0,5,Xaxis,Yaxis,00000100b,	  00000000b,offset Std_Help_Str>

if	Slave_Value	EQ	ItemDisable	;R07
Yaxis	=	Yaxis	-	1		;R07
endif	;Slave_Value	EQ	ItemDisable	;R07

endif	;FOUR_IDE_PIO_ITEM_IN_PCIFEAT

;R03 - start
ifdef	Ultra_DMA33_support
DEFINE_ITEM	IdeA_Sdma_Item
menuitem <0,\
offset IDEA_Sdma_Str,NOCT,00000001b,7Ah,00000001b,\
offset Sdma_Str,0,1,Xaxis,Yaxis,00h,01h,offset Std_Help_Str>

DEFINE_ITEM	IdeB_Sdma_Item
;R07 menuitem <0,\
menuitem <Slave_Value,\				;R07
offset IDEB_Sdma_Str,NOCT,00000001b,7Ah,00010000b,\
offset Sdma_Str,0,1,Xaxis,Yaxis,00h,10h,offset Std_Help_Str>

if	Slave_Value	EQ	ItemDisable	;R07
Yaxis	=	Yaxis	-	1		;R07
endif	;Slave_Value	EQ	ItemDisable	;R07

DEFINE_ITEM	IdeC_Sdma_Item
menuitem <0,\
offset IDEC_Sdma_Str,NOCT,00000001b,7Bh,00000001b,\
offset Sdma_Str,0,1,Xaxis,Yaxis,00h,01h,offset Std_Help_Str>

DEFINE_ITEM	IdeD_Sdma_Item
;R07 menuitem <0,\
menuitem <Slave_Value,\				;R07
offset IDED_Sdma_Str,NOCT,00000001b,7Bh,00010000b,\
offset Sdma_Str,0,1,Xaxis,Yaxis,00h,10h,offset Std_Help_Str>

if	Slave_Value	EQ	ItemDisable	;R07
Yaxis	=	Yaxis	-	1		;R07
endif	;Slave_Value	EQ	ItemDisable	;R07

endif	;Ultra_DMA33_support
;R03 - end

ifndef	ONCHIP_IDE_ALWAYS_DISABLE
DEFINE_ITEM	IDE_bst_Item
	menuitem <2,\
		offset IDE_bst_Str,94Ah,80h,5Fh,40h,\
		offset Dis_Str,0,1,Xaxis,Yaxis,00h,40h,offset Std_Help_Str>	;R14
;R14		offset Dis_Str,0,1,Xaxis,Yaxis,00h,00h,offset Std_Help_Str>
endif	;ONCHIP_IDE_ALWAYS_DISABLE

DEFINE_ITEM
	menuitem <2,\
		offset IDEport_post_Str,0083h,04h,5Fh,20h,\
		offset Dis_Str,0,1,Xaxis,Yaxis,0h,20h,offset Std_Help_Str>

ifdef	IDE_ITEM_NOT_IN_BFEATURE
DEFINE_ITEM	IdeBlock_Item
	menuitem <0,\
		offset IdeBlock_Str,NOCT,01000000b,11H,01000000b,\
		offset Dis_Str,0,1,Xaxis,Yaxis,0,40h,Offset Std_Help_Str>
endif	;IDE_ITEM_NOT_IN_BFEATURE

endif	;ONCHIP_IDE_IN_IOSETUP


ifndef	ONBOARD_IO_IN_PCISETUP
DEFINE_ITEM	,0
;R01		IOCMOS = 7Ah
		IOCMOS = 48h		;R01
		IDECMOS= 34h
		include superio.mnu

ifdef	MIRQ	;MIRQ equ 0 ~ 15,  0 is disable
DEFINE_ITEM	MIRQ_Item
	menuitem <2,\
		offset MIRQ_Str,861h,00001111b,37h,00001111b,\
		offset MIRQ_Val,0,15,Xaxis,Yaxis,MIRQ,MIRQ,offset NullStr>
endif	;MIRQ
ifdef	MDRQ	;MDRQ0 equ -1 ~ 7,  -1 is disable
DEFINE_ITEM
	menuitem <2,\
		offset MDRQ_Str,862h,00001111b,38h,00001111b,\
		offset MDRQ_Val,7,15,Xaxis,Yaxis,MDRQ+8,MDRQ+8,offset NullStr>
endif	;MDRQ0

ifdef	PS2_ITEM_NOT_IN_BFEATURE
DEFINE_ITEM	PS2_select_item,1
		menuitem <0,\
			  offset ps2_select_Str,NOCT,01h,PS2_CMOS,PS2_CMOS_BIT,\
			  offset Dis_Str,0,1,Xaxis,Yaxis,01h,PS2_CMOS_BIT,Offset Std_Help_Str>
endif	;PS2_ITEM_NOT_IN_BFEATURE
;R04 - start
 ifdef	NEXCOM_WATCH_DOG_TIMER
DEFINE_ITEM	WDT_PORT_Item,1
	menuitem <0,\
		  offset WDT_PORT_Str,NOCT,00100000b,7Bh,00100000b,\
		  offset WDT_PORT_Val,0,1,Xaxis,Yaxis,00h,00h,offset Std_Help_Str>
DEFINE_ITEM	WDT_en_Item
	menuitem <0,\
		  offset WDT_en_Str,NOCT,00001000b,7Bh,00001000b,\
		  offset Dis_Str,0,1,Xaxis,Yaxis,00h,08h,offset Std_Help_Str>
DEFINE_ITEM	WDT_for_Item
	menuitem <0,\
		  offset WDT_for_Str,NOCT,00010000b,7Bh,00010000b,\
		  offset WDT_for_Val,0,1,Xaxis,Yaxis,00h,00h,offset Std_Help_Str>
DEFINE_ITEM	WDT_TimeOut_Item
	menuitem <0,\
		  offset WDT_TimeOut_Str,NOCT,00000111b,7Bh,00000111b,\
		  offset WDT_TimeOut_Val,0,7,Xaxis,Yaxis,00h,00h,offset Std_Help_Str>
 endif	;NEXCOM_WATCH_DOG_TIMER
;R04 - end
endif	;ONBOARD_IO_IN_PCISETUP

;R09 ;R08 - start
;R09 ifdef	Gemlight_Special_Item_Address
;R09 Xaxis	= 42
;R09 ;Yaxis	= 3
;R09 endif;	Gemlight_Special_Item_Address
;R09 ;R08 - end

;R05 - start
;R05A DEFINE_ITEM	USB_ITEM
;R05A 	menuitem <0,\
;R05A   	  offset UsbPort_Str,0862h,040h,56h,01H,\
;R05A   	  offset Dis_Str,0,1,Xaxis,Yaxis,40h,01h,offset NullStr>
;R05A - start
DEFINE_ITEM	USB_ITEM
	menuitem <0,\
      		  offset UsbPort_Str,NOCT,040h,56h,01H,\
      		  offset Dis_Str,0,1,Xaxis,Yaxis,40h,01h,offset NullStr>
;R05A - end
;R05 - end
;R02 - start
ifdef	USB_SUPPORT
DEFINE_ITEM	Usb_Legacy_Item
	menuitem <0,\
		offset UsbLegacy_Str,NOCT,02h,56h,02h,\
		offset Dis_Str,0,1,Xaxis,Yaxis,0,0,offset Std_Help_Str>
endif	;USB_SUPPORT
;R02 - end

ifdef	AIOCMOS
DEFINE_ITEM	,0
 IF	Xaxis LT 40
Xaxis	= 42
Yaxis	= 3
 ENDIF
Yaxis	= Yaxis + 1
		include AUDIO.MNU
endif	;AIOCMOS

;R06 - start
ifndef	No_Power_B_O_R							;R06B
DEFINE_ITEM	Power_B_O_R_Item
;R06A	menuitem <2,\
;R06A		  offset Power_B_O_R_Str,ACPI_R+5h,02h,IOCMOS,01h,\
;R06A		  offset Dis_Str,0,1,Xaxis,Yaxis,02h,01h,offset NullStr>
ifdef	Power_B_O_R_as_Power_off					;R17
	menuitem <2,\							;R17
		  offset Power_B_O_R_Str,ACPI_R+5h,02h,ALARM_CMOS,02h,\	;R17
		  offset P_B_Val,0,1,Xaxis,Yaxis,02h,02h,offset NullStr>;R17
else;	Power_B_O_R_as_Power_off					;R17
	menuitem <2,\							;R06A
		  offset Power_B_O_R_Str,ACPI_R+5h,02h,ALARM_CMOS,02h,\	;R06A
		  offset Dis_Str,0,1,Xaxis,Yaxis,02h,02h,offset NullStr>;R06A
endif;	Power_B_O_R_as_Power_off					;R17
endif	;No_Power_B_O_R							;R06B

ifndef	No_Ring_UP_Item							;R06B
DEFINE_ITEM	Ring_Up_Item
ifdef	AT_ATX_SELECT_BY_GPCS0						;R10
	menuitem <2,\							;R10
		  offset Ring_Up_Str,NOCT,20h,ALARM_CMOS,04h,\		;R10
		  offset Dis_Str,0,1,Xaxis,Yaxis,20h,04h,offset NullStr>;R10
else;	AT_ATX_SELECT_BY_GPCS0						;R10
ifdef	AT_ATX_SELECT_BY_GPCS1						;R12
	menuitem <2,\							;R12
		  offset Ring_Up_Str,NOCT,20h,ALARM_CMOS,04h,\		;R12
		  offset Dis_Str,0,1,Xaxis,Yaxis,20h,04h,offset NullStr>;R12
else;	AT_ATX_SELECT_BY_GPCS1						;R12
ifdef   AT_ATX_SELECT_BY_GPIO8 						;;;R15
	menuitem <2,\							;;;R15
		  offset Ring_Up_Str,NOCT,20h,ALARM_CMOS,04h,\		;;;R15
		  offset Dis_Str,0,1,Xaxis,Yaxis,20h,04h,offset NullStr>;;;R15
else;	AT_ATX_SELECT_BY_GPIO8 						;;;R15
ifdef	AT_ATX_SELECT_BY_GPIO5						;R16
	menuitem <2,\							;R16
		  offset Ring_Up_Str,NOCT,20h,ALARM_CMOS,04h,\		;R16
		  offset Dis_Str,0,1,Xaxis,Yaxis,20h,04h,offset NullStr>;R16
else;	AT_ATX_SELECT_BY_GPIO5						;R16
;R06A	menuitem <2,\
;R06A		  offset Ring_Up_Str,APC_R+3h,20h,IOCMOS,02h,\
;R06A		  offset Dis_Str,0,1,Xaxis,Yaxis,20h,02h,offset NullStr>
	menuitem <2,\							;R06A
		  offset Ring_Up_Str,APC_R+3h,20h,ALARM_CMOS,04h,\	;R06A
		  offset Dis_Str,0,1,Xaxis,Yaxis,20h,04h,offset NullStr>;R06A
endif;	AT_ATX_SELECT_BY_GPIO5						;R16	
endif;	AT_ATX_SELECT_BY_GPIO8						;;;R15
endif;	AT_ATX_SELECT_BY_GPCS1						;R12
endif;	AT_ATX_SELECT_BY_GPCS0						;R10
endif	;No_Ring_UP_Item						;R06B	;R06B

ifndef	No_GPIO5_Power_UP_Item						;R06B
ifndef	LINEAR_MODE_GPIO5
ifndef	GREEN_ASSERT_GPIO5
DEFINE_ITEM	GPIO5_Power_Up_Item
;R06A	menuitem <2,\
;R06A		  offset GPIO5_Power_Up_Str,APC_R+3h,08h,IOCMOS,40h,\
;R06A		  offset Dis_Str,0,1,Xaxis,Yaxis,08h,40h,offset NullStr>
	menuitem <2,\								;R06A
		  offset GPIO5_Power_Up_Str,APC_R+3h,08h,ALARM_CMOS,08h,\	;R06A
		  offset Dis_Str,0,1,Xaxis,Yaxis,08h,08h,offset NullStr>	;R06A
endif;	LINEAR_MODE_GPIO5
endif;	GREEN_ASSERT_GPIO5
endif	;No_GPIO5_Power_UP_Item						;R06B

;R11 ALARM_CMOS	EQU	40h
ifdef	RSM_BY_ALARM
DEFINE_ITEM     ALARM_ITEM
        menuitem <PMITEM,\
                  offset ALARM_STR,NOCT,00000001b,ALARM_CMOS,00000001b,\
                  offset Dis_Str,0,1,Xaxis,Yaxis ,00000000b,00000000b,offset NullStr>

DEFINE_ITEM	ALARM_MONTH_Item
	menuitem <NOMODBIN+KEYIN,\
		  offset A_MON_Str,NOCT,0,ALARM_CMOS,11110000b,\
		  offset A_MON_Val,0,12,Xaxis,Yaxis,0,0,offset NullStr>

DEFINE_ITEM	ALARM_DATE_Item
;R06C	menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2,\
;R06C		  offset A_D_str,NOCT,0,ALARM_CMOS+1,11111111b,\
;R06C		  offset NullStr1,0,31,Xaxis,Yaxis,0,0,offset NullStr>
;R06C - start
	menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2,\
		  offset A_D_str,NOCT,0,ALARM_CMOS+1,00011111b,\
		  offset NullStr1,0,31,Xaxis,Yaxis,0,0,offset NullStr>
;R06C - end

Yaxis	= Yaxis + 1
	Public	ALARM_WEEK_SHOW						;R10
	ALARM_WEEK_SHOW:
menuitem <NOMODBIN+SHOWONLY,\
	  offset A_W_str,NOCT,0,KERNAL_CONTROL,00000001b,\
	  offset NullStr,0,0,Xaxis,Yaxis,0,0,offset NullStr>

Yaxis	= Yaxis + 1
	Public	ALARM_WEEK_SHOW1					;R10
	ALARM_WEEK_SHOW1:
menuitem <NOMODBIN+SHOWONLY,\
	  offset A_W_str1,NOCT,0,KERNAL_CONTROL,00000001b,\
	  offset NullStr,0,0,Xaxis,Yaxis,0,0,offset NullStr>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DEFINE_ITEM	ALARM_WEEK_1_Item
	menuitem <NOMODBIN,\
		  offset A_W_Str2,NOCT,0,ALARM_CMOS+2,00000010b,\
		  offset A_W_Val,0,1,Xaxis,Yaxis,1,1,offset NullStr>
Yaxis	= Yaxis - 1
DEFINE_ITEM	ALARM_WEEK_2_Item
	menuitem <NOMODBIN,\
		  offset nullstr,NOCT,0,ALARM_CMOS+2,00000100b,\
		  offset A_W_Val,0,1,Xaxis+08,Yaxis,1,1,offset NullStr>
Yaxis	= Yaxis - 1
DEFINE_ITEM	ALARM_WEEK_3_Item
	menuitem <NOMODBIN,\
		  offset nullstr,NOCT,0,ALARM_CMOS+2,00001000b,\
		  offset A_W_Val,0,1,Xaxis+12,Yaxis,1,1,offset NullStr>
Yaxis	= Yaxis - 1
DEFINE_ITEM	ALARM_WEEK_4_Item
	menuitem <NOMODBIN,\
		  offset nullstr,NOCT,0,ALARM_CMOS+2,00010000b,\
		  offset A_W_Val,0,1,Xaxis+16,Yaxis,1,1,offset NullStr>
Yaxis	= Yaxis - 1
DEFINE_ITEM	ALARM_WEEK_5_Item
	menuitem <NOMODBIN,\
		  offset nullstr,NOCT,0,ALARM_CMOS+2,00100000b,\
		  offset A_W_Val,0,1,Xaxis+20,Yaxis,1,1,offset NullStr>
Yaxis	= Yaxis - 1
DEFINE_ITEM	ALARM_WEEK_6_Item
	menuitem <NOMODBIN,\
		  offset nullstr,NOCT,0,ALARM_CMOS+2,01000000b,\
		  offset A_W_Val,0,1,Xaxis+24,Yaxis,1,1,offset NullStr>
Yaxis	= Yaxis - 1
DEFINE_ITEM	ALARM_WEEK_7_Item
	menuitem <NOMODBIN,\
		  offset nullstr,NOCT,0,ALARM_CMOS+2,10000000b,\
		  offset A_W_Val,0,1,Xaxis+28,Yaxis,1,1,offset NullStr>
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DEFINE_ITEM	ALARM_HOUR_Item
;R06C	menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2,\
;R06C		  offset A_H_str,NOCT,0,ALARM_CMOS+3,11111111b,\
;R06C		  offset NullStr1,0,23,Xaxis,Yaxis,07,07,offset NullStr>
;R06C - start
	menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2,\
		  offset A_H_str,NOCT,0,ALARM_CMOS+3,00011111b,\
		  offset NullStr1,0,23,Xaxis,Yaxis,07,07,offset NullStr>
;R06C - end

Yaxis	= Yaxis - 1
DEFINE_ITEM	ALARM_MIN_Item
;R06C	menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2+NODEFAULT,\
;R06C		  offset A_M_str,NOCT,0,ALARM_CMOS+4,11111111b,\
;R06C		  offset NullStr1,0,59,Xaxis+28,Yaxis,0,0,offset NullStr>
;R06C - start
	menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2+NODEFAULT,\
		  offset A_M_str,NOCT,0,ALARM_CMOS+4,00111111b,\
		  offset NullStr1,0,59,Xaxis+28,Yaxis,0,0,offset NullStr>
;R06C - end

Yaxis	= Yaxis - 1
DEFINE_ITEM	ALARM_SEC_Item
;R06C	menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2+NODEFAULT,\
;R06C		  offset A_S_str,NOCT,0,ALARM_CMOS+5,11111111b,\
;R06C		  offset NullStr1,0,59,Xaxis+31,Yaxis,0,0,offset NullStr>
;R06C - start
	menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2+NODEFAULT,\
		  offset A_S_str,NOCT,0,ALARM_CMOS+5,00111111b,\
		  offset NullStr1,0,59,Xaxis+31,Yaxis,0,0,offset NullStr>
;R06C - end
endif;	RSM_BY_ALARM
;R06 - end

IO_Feature_END		Label	Near

IO_Auto_String		db	0

		COLLON_LOC = 24
ifdef	AIOCMOS
		include AUDIO.STR
endif	;AIOCMOS

ifndef	ONBOARD_IO_IN_PCISETUP
		include superio.str

UsbPort_Str		db	'USB Controller          : ',0		;R05
UsbPort_Str_1:
;R02 - start
ifdef	USB_SUPPORT
UsbLegacy_Str		db	'USB Keyboard Support    : ',0
endif	;USB_SUPPORT
;R02 - end

ifdef	MIRQ
 ifdef	MIRQstring
MIRQ_Str		db	MIRQstring,0
 else	;MIRQstring
MIRQ_Str		db	'MIRQ Remapping to       : ',0
 endif	;MIRQstring
MIRQ_Val		db	'None ',0
			db	'Reser',1
			db	'Reser',1
			db	'IRQ3 ',0
			db	'IRQ4 ',0
			db	'IRQ5 ',0
			db	'IRQ6 ',0
			db	'IRQ7 ',0
			db	'Reser',1
			db	'IRQ9 ',0
			db	'IRQ10',0
			db	'IRQ11',0
			db	'IRQ12',0
			db	'Reser',1
			db	'IRQ14',0
			db	'IRQ15',0
endif	;MIRQ
ifdef	MDRQ
 ifdef	MDRQstring
MDRQ_Str		db	MDRQstring,0
 else	;MDRQstring
MDRQ_Str		db	'MDRQ Remapping to       : ',0
 endif	;MDRQstring
MDRQ_Val		db	'None',0
			db	'DMA0',0
			db	'DMA1',0
			db	'DMA2',0
			db	'DMA3',0
			db	'None',1
			db	'DMA5',0
			db	'DMA6',0
			db	'DMA7',0
endif	;MDRQ

 ifdef	PS2_ITEM_NOT_IN_BFEATURE
Ps2_select_Str		db	'PS/2 mouse function     : ',0
 endif	;PS2_ITEM_NOT_IN_BFEATURE
;R04 - start
 ifdef	NEXCOM_WATCH_DOG_TIMER
WDT_PORT_Str		db	'WDT Configuration Port  : ',0
WDT_PORT_Val		db	'F2h',0
			db	'F6h',0
WDT_en_Str		db	'Watch Dog Timer         : ',0
WDT_for_Str		db	'WDT Time Out Active For : ',0
WDT_for_Val		db	'Reset',0
			db	'NMI  ',0
WDT_TimeOut_Str		db	'WDT Active Time         : ',0
WDT_TimeOut_Val		db	'64sec',0
			db	'32sec',0
			db	'16sec',0
			db	'8sec ',0
			db	'4sec ',0
			db	'2sec ',0
			db	'1sec ',0
			db	'     ',1
 endif	;NEXCOM_WATCH_DOG_TIMER
;R04 - end
endif	;ONBOARD_IO_IN_PCISETUP

ifdef	ONCHIP_IDE_IN_IOSETUP
ifndef	ONCHIP_IDE_ALWAYS_DISABLE
Int_IDE_Str		db	'Internal PCI/IDE        : ',0
Int_IDE_Val		db	'Disabled ',0
			db	'Primary  ',0
			db	'Secondary',0
			db	'Both     ',0
IDE_bst_Str		db	'IDE Burst Mode          : ',0

Show_5513ide		Proc	Near
		mov	di,offset _5513_Items_Tbl
		xor	cx,cx
		call	If_CX_Then_Dis
		clc
		ret
Show_5513ide		Endp

_5513_Items_Tbl:
		dw	offset IDE_bst_Item
		dw	offset IdeA_Mode_Item
		dw	offset IdeB_Mode_Item
		dw	offset IdeC_Mode_Item
		dw	offset IdeD_Mode_Item
;R03 - start
ifdef	Ultra_DMA33_support
		dw	offset IdeA_Sdma_Item
		dw	offset IdeB_Sdma_Item
		dw	offset IdeC_Sdma_Item
		dw	offset IdeD_Sdma_Item
endif	;Ultra_DMA33_support
;R03 - end
		dw	-1

endif	;ONCHIP_IDE_ALWAYS_DISABLE

ifdef	FOUR_IDE_PIO_ITEM_IN_PCIFEAT
IDEA_mode_Str		db	'IDE Primary Master PIO  : ',0
IDEB_mode_Str		db	'IDE Primary Slave  PIO  : ',0
IDEC_mode_Str		db	'IDE Secondary Master PIO: ',0
IDED_mode_Str		db	'IDE Secondary Slave  PIO: ',0
IDE_mode_Val		db	'Auto  ',0
			db	'Mode 0',0
			db	'Mode 1',0
			db	'Mode 2',0
			db	'Mode 3',0
			db	'Mode 4',0
endif	;FOUR_IDE_PIO_ITEM_IN_PCIFEAT
;R03 - start
ifdef	Ultra_DMA33_support
;R09 IDEA_Sdma_Str		db	'Primary Master  UltraDMA: ',0
;R09 IDEB_Sdma_Str		db	'Primary Slave   UltraDMA: ',0
;R09 IDEC_Sdma_Str		db	'Secondary MasterUltraDMA: ',0
;R09 IDED_Sdma_Str		db	'Secondary Slave UltraDMA: ',0
IDEA_Sdma_Str		db	'Primary Master  '		;R09
UltraDMA_str		db	'UltraDMA: ',0			;R09
IDEB_Sdma_Str		db	'Primary Slave   '		;R09
			STRSHOW <,,,offset UltraDMA_str>	;R09
			db	0				;R09
IDEC_Sdma_Str		db	'Secondary Master'		;R09
			STRSHOW <,,,offset UltraDMA_str>	;R09
			db	0				;R09
IDED_Sdma_Str		db	'Secondary Slave '		;R09
			STRSHOW <,,,offset UltraDMA_str>	;R09
			db	0				;R09
Sdma_Str		db	'Disabled',0
			db	'Auto    ',0
endif	;Ultra_DMA33_support
;R03 - end
IDEport_post_Str	db	'IDE Data Port Post Write: ',0

 ifdef	IDE_ITEM_NOT_IN_BFEATURE
IdeBlock_Str		db	'IDE HDD Block Mode      : ',0
 endif; IDE_ITEM_NOT_IN_BFEATURE

endif	;ONCHIP_IDE_IN_IOSETUP
endif	;NEW_IO_FEATURE

;R06 - start
Power_B_O_R_Str		db	'Power Button Over Ride  : ',0
ifdef	Power_B_O_R_as_Power_off					;R17
P_B_Val			db	'Instant Off',0				;R17
			db	'Delay 4 Sec',0				;R17
endif;	Power_B_O_R_as_Power_off					;R17
Ring_Up_Str		db	'Ring Power Up Control   : ',0
ifndef	LINEAR_MODE_GPIO5
ifndef	GREEN_ASSERT_GPIO5
GPIO5_Power_Up_Str	db	'GPIO5 Power Up Control  : ',0
endif;	LINEAR_MODE_GPIO5
endif;	GREEN_ASSERT_GPIO5
ifdef	RSM_BY_ALARM
ALARM_STR		db      'Power Up by Alarm       : ',0
A_MON_str		db	'Month Alarm             : ',0
A_MON_Val		db	'NA',0,' 1',0,' 2',0,' 3',0,' 4',0,' 5',0,' 6',0
			db	' 7',0,' 8',0,' 9',0,'10',0,'11',0,'12',0
A_D_str			db      'Day of Month Alarm      : ',0
A_W_str			db	'Week Alarm',0
A_W_str1		db	'*** SUN MON TUE WED THU FRI SAT ***',0
A_W_str2		db	'    ',0
A_W_Val			db	'Off',0
			db	' On',0
A_H_str			db      'Time (hh:mm:ss) Alarm   : ',0
A_M_str			db      ':',0
A_S_str			db      ':',0
Nullstr1		db	0
endif;	RSM_BY_ALARM
;R06 - end

;R05 - start
ifdef	USB_SUPPORT
Show_USB_Legacy	proc	near
		xor	cx, cx
		mov	di, offset USB_Legacy_Tbl
		call	If_CX_Then_Dis
		ret
USB_Legacy_Tbl:
		dw	offset USB_Legacy_Item
		dw	-1
Show_USB_Legacy	endp
endif	;USB_SUPPORT
;R05 - end

;R06 - start
ifdef	RSM_BY_ALARM
Show_ALARM_ITEM:

		xor	cx, cx
		mov	di, offset Alarm_Timer_Loc
		call	If_CX_Then_Dis
		ret

Alarm_Timer_Loc:
		dw	offset ALARM_MONTH_Item
		dw	offset ALARM_DATE_Item
		dw	offset ALARM_WEEK_SHOW
		dw	offset ALARM_WEEK_SHOW1
		dw	offset ALARM_WEEK_1_Item
		dw	offset ALARM_WEEK_2_Item
		dw	offset ALARM_WEEK_3_Item
		dw	offset ALARM_WEEK_4_Item
		dw	offset ALARM_WEEK_5_Item
		dw	offset ALARM_WEEK_6_Item
		dw	offset ALARM_WEEK_7_Item
		dw	offset ALARM_HOUR_Item
		dw	offset ALARM_MIN_Item
		dw	offset ALARM_SEC_Item
		dw	-1
endif;	RSM_BY_ALARM
;R06 - end

FCODE		ENDS
		END
