;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R05	12/19/97 RAX	Add define for move APM code to SMBASE.
;R04	12/18/97 LAW	change "EPA_LOGO_Use_Graphics" with "FULL_SCREEN_LOGO"
;			switch to "Graphics_post"
;R03	05/15/97 RAX	Add hook "SMBHOST_INIT" for more SMBus host support
;R02	10/11/96 RAX	Add Notebook Smart Battery support
;R01	05/28/96 RCH	Move in "APM_INIT" from APM.ASM
;Note : This file is used to contain codes that should be in F-segment but
;	is not run-time codes.

		PAGE	63,132
		TITLE	MISC  -- Miscellous Code
.386P
ENABLE_288_SUPPORT	EQU	1
ENABLE_FDC_FIFO		EQU	1	; (2.88 needs FIFO to avoid slow DMA errors)
FDC_FIFO_THRES		EQU	0dh	; (FIFO threshold set to mid value)

CMOS_FD_288		EQU	5	; (CMOS value for 2.88, can be changed)


SEG_0		SEGMENT	USE16 AT 1
		INCLUDE	SEG_0.INC
SEG_0		ENDS

G_RAM		SEGMENT	USE16 AT 40H
		INCLUDE	G_RAM.INC
G_RAM		ENDS

;R01 - start
PM_RAM		SEGMENT	USE16 AT 0 	; define PM RAM segment

		ORG	0
		INCLUDE	PM_RAM.INC

PM_RAM		ENDS
;R01 - end

.XLIST
		INCLUDE BIOS.CFG

		INCLUDE CMOS.EQU
		INCLUDE 82077.EQU
		INCLUDE	ADISK.EQU
		INCLUDE COMMON.EQU				
		INCLUDE COMMON.MAC

		extrn	GET_CMOS_VALUE:near
		extrn	SEND_COMMAND:near
		extrn	RESULTS:near

		extrn	Ct_Before_Setup:near
		extrn	Int_Kb_Enable:near
		extrn	Cp_Install:near
		extrn	UPDATE_LED:near
		extrn	SETUP:near
		extrn	REDO:near
		extrn	Post_call_proc:near

		extrn	Get_Cmos:near
		extrn	A20_Off:near
		extrn	REAL_IDT_LOC:near

ifdef	SMBIOS_INTERFACE				;R03
		extrn	SMBHOST_INIT:near		;R03
endif	;SMBIOS_INTERFACE				;R03

.LIST

DGROUP		GROUP	FCODE
FCODE		SEGMENT	USE16 PARA PUBLIC 'CODE'      
		ASSUME	CS:DGROUP

;Codes from ADISK.ASM
;;-----------------------------------------------------------------------
IFDEF	ENABLE_288_SUPPORT

		PUBLIC	FD_PERP_MODE
		align	4			
FD_PERP_MODE	PROC	NEAR

		PUSHA				; save regs
		PUSH	DS
		PUSH	ES

		PUSH	CS			; set addressibility
		POP	DS
		ASSUME	DS:DGROUP
		MOV	AX,G_RAM
		MOV	ES,AX
		ASSUME	ES:G_RAM


IFDEF	FORCE_PERP_MODE
		MOV	AL,10000100B		; set perp mode for first drive
		JMP	SHORT FPM_FINISH	; get to common finish mode

ELSE	;not FORCE_PERP_MODE
		MOV	BL,080H			; set for all drives non perp mode

		xor	al,al			; check drive zero for 2.88
		CALL	GET_CMOS_VALUE		; get CMOS drive type
		CMP	AH,CMOS_FD_288		; check 2.88 drive
		JNE	short PERP_1		; skip if NOT 2.88 (or bad cmos)
		OR	BL,004H			; else drive 0 is setup as perp

PERP_1:
		MOV	AL,1			; check drive one for 2.88
		CALL	GET_CMOS_VALUE		; get CMOS drive type
		CMP	AH,CMOS_FD_288		; check 2.88 drive
		JNE	short PERP_2	 	; skip if NOT 2.88 (or bad cmos)
		OR	BL,008H			; else drive 1 is setup as perp

PERP_2:
		XCHG	AX,BX			; parm into al
ENDIF	;FORCE_PERP_MODE

FPM_FINISH:
		PUSH	AX			; parameters on stack
		MOV	SI,SP			; pointer to parameters
		MOV	AH,012H			; perpendicular command
		MOV	BL,2			; 2 bytes in perp command
		CALL	SEND_COMMAND		; output perp command
		ADD	SP,2			; clear parameters off stack.
		OR	AH,AH			; error?
		JNZ	SHORT FPM_BAD		; skip if error

		CLC				; signal no error
		JMP	SHORT FPM_RET		; get to common return

FPM_BAD:
		STC				; signal error

FPM_RET:
		POP	ES
		POP	DS
		POPA
		RET

FD_PERP_MODE	ENDP

ENDIF	;ENABLE_288_SUPPORT



IFDEF	ENABLE_FDC_FIFO

		PUBLIC	FD_FIFO_MODE
		align	4			
FD_FIFO_MODE	PROC	NEAR

		PUSHA				; save regs
		PUSH	DS
		PUSH	ES

		PUSH	CS			; set addressibility
		POP	DS
		ASSUME	DS:DGROUP
		MOV	AX,G_RAM
		MOV	ES,AX
		ASSUME	ES:G_RAM

		MOV	AL,00h			; set PRETRK for configure command
		PUSH	AX			; parameters on stack
		MOV	AL,00h			; set first parm byte for configure command
		MOV	AH,00h+FDC_FIFO_THRES	; set FIFO on and set threshold
		PUSH	AX			; parameters on stack
		MOV	SI,SP			; pointer to parameters
		MOV	AH,013H			; configure command
		MOV	BL,4			; 4 bytes in configure command
		CALL	SEND_COMMAND		; output configure command
		ADD	SP,4			; clear parameters off stack.
		OR	AH,AH			; error?
		JNZ	SHORT FFM_BAD		; skip if error to quit

		MOV	AH,094H			;;;XXXX lock command
		MOV	BL,1			; 1 byte in lock command
		CALL	SEND_COMMAND		; output lock command
		OR	AH,AH			; error?
		JNZ	SHORT FFM_BAD		; skip if error to quit
		CALL	RESULTS			; read results
		OR	AH,AH			; see if error
		JNZ	SHORT FFM_BAD		; skip if error to quit

		CLC				; signal no error
		JMP	SHORT FFM_RET		; get to common return

FFM_BAD:
		STC				; signal error

FFM_RET:
		POP	ES
		POP	DS
		POPA
		RET

FD_FIFO_MODE	ENDP

ENDIF	;ENABLE_FDC_FIFO
;;-----------------------------------------------------------------------

;Codes from AKBRD.ASM
;R04ifndef FULL_SCREEN_LOGO					
ifndef	Graphics_Post					;R04
;;-----------------------------------------------------------------------
;
;	Here we allow the user to enter SETUP while in POST. We must
;	allow keyboard interrupts again, restore BP (which the POST
;	user interface routines and Setup use), call Setup then
;	reboot.
;
		assume	ds:G_RAM
		public	Go_Cmos_Setup
Go_Cmos_Setup:

		call	Int_Kb_Enable

		mov	sp,bp				; restore stack
		popa					; restore all registers
		mov	bp,ds:[Temp_BP]			; get POST BP		
		pop	ds				; restore DS

		jmp	Enter_Setup
;;-----------------------------------------------------------------------

		public	Enter_Setup_Check
Enter_Setup_Check	proc	near
		push	ds
		mov	ax,G_RAM
		mov	ds,ax
		ASSUME	DS:G_RAM
		test	byte ptr POST_FLAG,SETUP_ON
		pop	ds
		jz	short Not_To_Setup

;R12 - Begin
IFDEF	NoteBook_Power_Management
		extrn	Check_0V_Resume:near
		call	Check_0V_Resume
		jnz	short Not_To_Setup
ENDIF	;NoteBook_Power_Management
;R12 - End

Enter_Setup:
		push	ds
		mov	ax,G_RAM
		mov	ds,ax
		ASSUME	DS:G_RAM
		mov	word ptr ds:USER_REBOOT, 0	;reset warm boot flag
		and	INIT_ERR_FLG,NOT IEF_SETUP_OK	; prevent further

		call	Ct_Before_Setup

		pop	ds

PRINTER_0_INIT	EQU	15H
PRN_S_AF_IP_SI	EQU	37AH			;port to talk to strobe,
						; auto feed, initialize
						; printer, and select input
						; pins of parrallel adapter
INITIALIZE_PORT EQU	0100H
		POST_func_call	Cp_Install
		push	ax
		push	dx
		mov	al, PRINTER_0_INIT
		mov	dx, PRN_S_AF_IP_SI
		out	dx, al
		mov	ax, INITIALIZE_PORT
		xor	dx, dx
		int	17H			;init printer port #0
		pop	dx
		pop	ax

		mov	ax,g_ram			;R11
		mov	ds,ax				;R11
		assume	ds:g_ram			;R11
		or	byte ptr KB_FLAG_2,7		;R11
		call	UPDATE_LED			;R11

		mov	al,0AAh
		CALL	SETUP

		JMP	REDO
Not_To_Setup:
		ret
Enter_Setup_Check	endp
endif;	Graphics_Post					;R04
;R04endif ;FULL_SCREEN_LOGO					;R14

;Codes from MULTISER.ASM
;;-----------------------------------------------------------------------
;[]==================================================================[]
;
; EXC9HDLR:
;
;	Come here on type 9 shutdown. This was used when
;	resetting the system on a 286. Applications also use
;	this to come out of protected mode.
;
;ENTRY:	NONE
; EXIT: NONE
;
;Author: Award
;  Date: 11/27/90
;
;[]==================================================================[]

		ALIGN	4
		PUBLIC	EXC9HDLR			; *
EXC9HDLR:
		cli
		lidt	fword ptr cs:[REAL_IDT_LOC]	; dummy load to clear

		mov	ax,G_RAM
		mov	ds,ax
		assume	ds:G_RAM
		mov	ss,ds:[ROM_MODULE_SEG]
		mov	sp,ds:[ROM_MODULE_OFFSET]

		call	A20_Off

		mov	al,0fh NMI_ON		; enable NMI, as shut down
		call	Get_CMOS

		pop	ds			; recover regs
		pop	es
		popa

		mov	ah,al			; save al
		in	al,80h

		or	al,al			; set zero flag
		je	short exc_9

		stc

exc_9:		
		xchg	ah,al			; swap regs and exit
		sti
		retf	2


;;-----------------------------------------------------------------------


;Codes from PCI1A.ASM
;;-----------------------------------------------------------------------
ifdef	PCI_BUS
		extrn	AGet_CfgSpace_Byte:near
		extrn	AGet_CfgSpace_word:near
		extrn	AGet_CfgSpace_Dword:near
		extrn	Aset_CfgSpace_Byte:near
		extrn	Aset_CfgSpace_word:near
		extrn	Aset_CfgSpace_Dword:near

		public	Get_CfgSpace_Byte
		public	Get_CfgSpace_word
		public	Get_CfgSpace_Dword
		public	set_CfgSpace_Byte
		public	set_CfgSpace_word
		public	set_CfgSpace_Dword
Get_CfgSpace_Byte:
		push	bx
		xor	bh,bh			;reset BUS no. for POST
		call	Aget_CfgSpace_Byte
		pop	bx
		ret
Get_CfgSpace_word:
		push	bx
		xor	bh,bh			;reset BUS no. for POST
		call	Aget_CfgSpace_Word
		pop	bx
		ret
Get_CfgSpace_Dword:
		push	bx
		xor	bh,bh			;reset BUS no. for POST
		call	Aget_CfgSpace_DWord
		pop	bx
		ret
	
Set_CfgSpace_Byte:
		push	bx
		xor	bh,bh			;reset BUS no. for POST
		call	ASet_CfgSpace_Byte
		pop	bx
		ret
Set_CfgSpace_word:
		push	bx
		xor	bh,bh			;reset BUS no. for POST
		call	ASet_CfgSpace_Word
		pop	bx
		ret
Set_CfgSpace_Dword:
		push	bx
		xor	bh,bh			;reset BUS no. for POST
		call	ASet_CfgSpace_Dword
		pop	bx
		ret
endif;	PCI_BUS
;;-----------------------------------------------------------------------

;R01 - start
;Codes from PCI1A.ASM
;;-----------------------------------------------------------------------
ifdef	ADVANCE_POWER_MANAGEMENT
;[]=================================================================[]
;Procedure:	APM_INIT
;
;Function :	Initialize the APM low level interface.
;
;Input    :	ES = PM_RAM
;		AL = 0 ---> call from POST when PM is disabled
;		AL = 1 ---> call from POST when PM is enabled
;
;Output   :	None
;
;[Note]	  :	Called from PM_INIT of POST 79
;[]==================================================================[]
		Public	APM_INIT
APM_INIT	Proc	Near
		push	ds				;save data segment
		push	es
		pop	ds
		ASSUME	DS:PM_RAM

		or	[APM_STATUS],IS_32BIT_SUPPORTED\
				     +IS_16BIT_SUPPORTED\
				     +IS_PM_ENABLED\
				     +IS_APM_SUPPORTED
		or	al, al
		jnz	short @F
		and	[APM_STATUS],not IS_PM_ENABLED
	@@:

		or	[EXTEND_APM_STATUS],IS_PM_ENGAGED+PM_ALLOWED_BY_APM

	ifndef	NO_SUPPORT_APM12
		or	al, al
		jz	short @F
		extrn	Ct_PMU_Timer_Status:near
		call	Ct_PMU_Timer_Status
		and	al, PMU_TIMER_ENABLED
		or	[EXTEND_APM_STATUS], al
	@@:
		extrn	Ct_Ring_WakeUp_Status:near
		call	Ct_Ring_WakeUp_Status
		and	al, RING_WAKEUP_ENABLED
		or	[EXTEND_APM_STATUS], al
	endif	;NO_SUPPORT_APM12

;R02 - start
Ifdef SMBIOS_INTERFACE

		mov	[SMB_STATUS],0		;for SMBus use
		mov	[SMB_EXTEND_STATUS],0	;

;R03 		mov	al,0b7h				;Enable Smart Battery Host
;R03 			extrn	SMB_Write_Command:near	
;R03 		call	SMB_Write_Command		;
;R03 		mov	al,01h				;
;R03 			extrn SMB_Write_Data:near	;
;R03 		call	SMB_Write_Data			;

		call	SMBHOST_INIT		;R03

endif; SMBIOS_INTERFACE		
;R02 - end

IFNDEF	APM_IN_SMBASE				;R05
		extrn	Clear_Events:near
		call	Clear_Events
;R05 start
ELSE	;APM_IN_SMBASE
		mov	[APMEventSave],NO_EVENTS
		mov	[APM_EVENT_POST],0
ENDIF	;APM_IN_SMBASE
;R05 end

		pop	ds				;Restore data segment
		ret
APM_INIT	Endp
endif;	ADVANCE_POWER_MANAGEMENT
;;-----------------------------------------------------------------------
;R01 - end

FCODE		ENDS
		END
