;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;
;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;--------------------------2A5II---------------------------------------------
;R11	12/05/97 PAL	Remove Ct_Shadow_R to runtime F000 segment 
;R10	11/10/97 AVN	Added seven pci slot support.
;R09	10/06/97 RCH	Added onboard LAN chip boot ROM support.
;R08	07/30/97 AVN	Save F000 code.
;R07	06/24/97 KEN	Added routine "Ct_Shadow_R" for USB kernal to fix bugs.
;R06	06/23/97 JKY	Share PCI IRQ for Cirrus 6832 Cardbus on slot 2
;			def CARDBUS_ONEIRQ_SLOT2.
;R05 	04/30/97 LRY	Always 'SiS_USB_ENABLE_PATCH'.
;R04	03/28/97 KEN	Add USB_SUPPORT.
;R03	03/15/95 RAY	Compile this file (PCICHIP.ASM) twice by adding
;			switch: COMPILE_FOR_RUN_TIME=0/1 in BIOS.MAK
;			to generate PCICHIP.OBJ & PCIRUN.OBJ such that:
;
;			PCICHIP.OBJ: linked before the fix ORG at F8000
;			PCIRUN.OBJ: linked after the fix ORG at F8000
;
;			This is done to support the dynamic set IRQ for
;			PCI devices as required by the PCI 2.1 specification
;
;R02A	11/13/97	Added 'SPEICAL_IO_ADDRESS' define for OS/2 can`t
;			install from cdrom of master
;R02	03/14/97 LRY	Initial IO base address from 6300h
;R01	02/17/97 LRY	Kill unused codes
;R00	01/09/97 LRY	Initial version

;R03 - starts
ifdef	MASM611
.MODEL  SMALL,BASIC
OPTION	PROC: PRIVATE
endif	;MASM611
;R03 - ends

.386P

		PAGE	56,132
.XLIST
		INCLUDE BIOS.CFG
		include	common.equ

IFE	COMPILE_FOR_RUN_TIME		;R03
ifdef	PCI_BUS
ifdef	NEW_PCI_KERNEL

		INCLUDE COMMON.MAC
		include bsetup.inc

		extrn	Get_Set_Ct:near
		extrn	Get_Ct:near
		extrn	Set_Ct:near
		extrn	Get_CfgSpace_Dword:near
		extrn	Set_CfgSpace_Dword:near
		extrn	Set_CfgSpace_word:near
		extrn	Set_CfgSpace_Byte:near
		extrn	Get_Vendor_ID:near
		extrn	Get_Device_ID:near

		extrn	GetItem_Value:near

		extrn	PCI_IRQ_Method:near
		extrn	PCI_IDE_IRQ:near
		extrn	F000_Shadow_W:Near
		extrn	F000_Shadow_R:Near
		extrn	F000_call_proc:near	;R08
		extrn	F000_Get_Ct:near	;R08
		extrn	F000_Set_Ct:near	;R08
		extrn	F000_Get_Set_Ct:near	;R08

endif	;NEW_PCI_KERNEL
endif	;PCI_BUS

.LIST

EGROUP		GROUP	ECODE			;R08

DGROUP		GROUP	FCODE
FCODE		SEGMENT USE16 PARA PUBLIC 'CODE'
;R03		ASSUME	CS:FCODE
		ASSUME	CS:DGROUP		;R03

ifdef	PCI_BUS
ifdef	NEW_PCI_KERNEL
ifndef	NEW_PNP_SETUP


		extrn	PCI_IRQ1:near
		extrn	PCI_IRQ2:near
		extrn	PCI_IRQ3:near
		extrn	PCI_IRQ4:near
		public	PciIrq_Item
PciIrq_Item:
		dw	offset PCI_IRQ1
		dw	offset PCI_IRQ2
		dw	offset PCI_IRQ3
		dw	offset PCI_IRQ4
		dw	-1			;last IRQ item
endif	;NEW_PNP_SETUP

		public	IrqRout_Table
IrqRout_Table:	;	INT A,INT B,INT C ,INT D
		db	SLOT1_INTA,SLOT1_INTB,SLOT1_INTC,SLOT1_INTD ;slot 1
ifndef		CARDBUS_ONEIRQ_SLOT2				    ;R06
		db	SLOT2_INTA,SLOT2_INTB,SLOT2_INTC,SLOT2_INTD ;slot 2
else		;CARDBUS_ONEIRQ_SLOT2				    ;R06
		db	SLOT2_INTA,SLOT2_INTA,SLOT2_INTC,SLOT2_INTD ;R06
endif		;CARDBUS_ONEIRQ_SLOT2				    ;R06
ifndef TWO_PCI_SLOT_ONLY
		db	SLOT3_INTA,SLOT3_INTB,SLOT3_INTC,SLOT3_INTD ;slot 3
ifndef THREE_PCI_SLOT_ONLY
		db	SLOT4_INTA,SLOT4_INTB,SLOT4_INTC,SLOT4_INTD ;slot 4
endif ;THREE_PCI_SLOT_ONLY
endif ;TWO_PCI_SLOT_ONLY
ifdef	FIVE_PCI_SLOT
		db	SLOT5_INTA,SLOT5_INTB,SLOT5_INTC,SLOT5_INTD ;slot 5
endif	;FIVE_PCI_SLOT
;R10 - start
ifdef	SEVEN_PCI_SLOTS
		db	SLOT5_INTA,SLOT5_INTB,SLOT5_INTC,SLOT5_INTD ;slot 5
		db	SLOT6_INTA,SLOT6_INTB,SLOT6_INTC,SLOT6_INTD ;slot 6
		db	SLOT7_INTA,SLOT7_INTB,SLOT7_INTC,SLOT7_INTD ;slot 7
endif;	SEVEN_PCI_SLOTS
;R10 - end
;R05ifdef	SiS_USB_ENABLE_PATCH
;R05		db	5,5,5,5
;R05endif	;SiS_USB_ENABLE_PATCH
ifdef	ONBOARD_VGA_NEED_IRQ
		db	VGA_INTA,VGA_INTB,VGA_INTC,VGA_INTD
endif;	ONBOARD_VGA_NEED_IRQ
ifdef	ONBOARD_ScsiChip
		db	SCSI_INTA,SCSI_INTB,SCSI_INTC,SCSI_INTD
endif	;ONBOARD_ScsiChip
		db	5,5,5,5					;R05

		public	PCI_SLOT_CFG
PCI_SLOT_CFG:
		db	SLOT1_ID		;slot 1
		db	SLOT2_ID		;slot 2
ifndef	TWO_PCI_SLOT_ONLY
		db	SLOT3_ID		;slot 3
ifndef	THREE_PCI_SLOT_ONLY
		db	SLOT4_ID		;slot 4
endif	;THREE_PCI_SLOT_ONLY
endif	;TWO_PCI_SLOT_ONLY
ifdef	FIVE_PCI_SLOT
		db	SLOT5_ID		;slot 5
endif	;FIVE_PCI_SLOT
;R10 - start
ifdef	SEVEN_PCI_SLOTS
		db	SLOT5_ID		;slot 5
		db	SLOT6_ID		;slot 6
		db	SLOT7_ID		;slot 7
endif;	SEVEN_PCI_SLOTS
;R10 - end
;R05ifdef	SiS_USB_ENABLE_PATCH
;R05		db	1
;R05endif	;SiS_USB_ENABLE_PATCH

ifdef	ONBOARD_VGA_NEED_IRQ
		db	ONBOARD_PCI_VGA
endif	;ONBOARD_VGA_NEED_IRQ
ifdef	ONBOARD_ScsiChip
		db	ONBOARD_ScsiChip_SLOT	;onboard slot
endif	;ONBOARD_ScsiChip
		db	1					;R05

		db	0FFh			;end of table

;R03 ;[]==============================================================[]
;R03 ;Ct_Set_PciIrq:
;R03 ;	Program chipset IRQ routing
;R03 ;Saves: all
;R03 ;Input : AL - interrupt pin to assign ,value is 1-16
;R03 ;
;R03 ;	 AH - IRQ No.
;R03 ;	 CH - IRQ trigger 0-edge, 1-level
;R03 ;	 CL - slot index 0-slot 1 , 1-slot 2, 2-slot 3 ,3-slot 4
;R03 ;Output: None
;R03 ;[]==============================================================[]
;R03 		ALIGN	4
;R03 		public	Ct_Set_PciIrq
;R03 Ct_Set_PciIrq	proc	near
;R03 		pusha
;R03 
;R03 		mov	bl,ah
;R03 		test	ch,01H			;level trigger IRQ ?
;R03 		jz	short Not_Level_Irq
;R03 		call	Set_Level_Irq
;R03 Not_Level_Irq:
;R03 
;R03 		mov	cx,0841H		;INT routing register
;R03 @@:
;R03 		dec	al
;R03 		jz	short Shift_Ok
;R03 		inc	cx
;R03 		jmp	short @B
;R03 Shift_Ok:
;R03 ifdef	SiS_USB_ENABLE_PATCH		;if interrupt pin > 4 means USBIRQ
;R03 		cmp	cl,44h
;R03 		jbe	short Not_USBIRQ
;R03 		mov	cl,62h
;R03 		call	Get_Ct
;R03 		and	al,70h
;R03 		or	ah,al
;R03 Not_USBIRQ:
;R03 endif	;SiS_USB_ENABLE_PATCH
;R03 		mov	al,ah
;R03 		call	Set_Ct
;R03 
;R03 		popa
;R03 		ret
;R03 Ct_Set_PciIrq	endp

;[]==============================================================[]
;Set_Level_Irq:
;	Set level trigger for port 4d0h & 4d1h
;Saves: all
;Input : BL - IRQ level to set
;Output: None
;[]==============================================================[]
		Public	Set_Level_Irq	;R03
Set_Level_Irq:
		call	far ptr E000_Set_Level_Irq	;R08
;R08 		pusha
;R08 
;R08 		;Disable INT before program 8259
;R08 		cli
;R08 		in	al,0a1h
;R08 		mov	ah,al
;R08 		in	al,21h
;R08 		push	ax			;save original interrupt mask
;R08 		mov	al,0ffh 		;mask all interrupt
;R08 		out	21h,al
;R08 		IODELAY
;R08 		out	0a1h,al
;R08 
;R08 ;;config register 4D0h & 4D1h for level trigger interrupt
;R08 		mov	dx,04d0h
;R08 		cmp	bl,8
;R08 		mov	cl,bl
;R08 		jb	short Below_Irq8
;R08 		sub	cl,8
;R08 		inc	dl
;R08 Below_Irq8:
;R08 		mov	ah,1
;R08 		shl	ah,cl
;R08 
;R08 		in	al,dx
;R08 		or	al,ah
;R08 		out	dx,al
;R08 
;R08 		;Restore 8259 status
;R08 		pop	ax			;restore interrupt mask
;R08 		out	21h,al
;R08 		xchg	ah,al
;R08 		out	0a1h,al
;R08 
;R08 		popa
 		ret


;[]==============================================================[]
;Name	   :	Ct_PCI_Info
;
;Function  :	To tell the PCI BIOS Kernel some important
;		chipset informations for PCI's I/O, MEM &
;		ROM initializations.
;
;Input	   :	None
;
;Output    :	al : Starting device to be scanned (note)
;		ah : Ending device to be scanned   (note)
;		edi: Initial IO Base Addr
;		esi: Initial memory base address
;
;[Note]    :	AH must be greater than AL i.e. AH > AL, because
;		the PCI Kernel scan PCI slots in INCREASING manner!
;[]==============================================================[]
		ALIGN	4
		Public	Ct_PCI_Info
Ct_PCI_Info	Proc	Near

		call	far ptr E000_Ct_PCI_Info	;R08
;R08 ;R05ifdef	SiS_USB_ENABLE_PATCH
;R08 		mov	al,1		;starting device to be scanned
;R08 ;R05else	;SiS_USB_ENABLE_PATCH
;R08 ;R05		mov	al,2		;starting device to be scanned
;R08 ;R05endif	;SiS_USB_ENABLE_PATCH
;R08 		mov	ah,20		;ending device to be scanned
;R08 
;R08 ;Rpp		mov	ecx,0E0000000h	;Temporary addr. for ROM
;R08 ;Rpp		mov	esi,0F0000000h	;initial memory addr. space
;R08 
;R08 		mov	ecx,0F8000000h	;Temporary addr. for ROM	;Rpp
;R08 		mov	esi,0E0000000h	;initial memory addr. space	;Rpp
;R08 		mov	edi,0FFFFFFFFh	;maximun memory Base Addr space
;R08 
;R08 ;R02		mov	ebx,000006000H	;Initial IO Base Addr space
;R08 		mov	ebx,000006300H	;Initial IO Base Addr space	;R02
;R08 		mov	edx,00000FFFFh	;maximun IO Base Addr space

		ret

Ct_PCI_Info	Endp

;[]==============================================================[]
;Name	   :	Ct_PCI_VGA_IDSEL
;
;Function  :	To tell the PCI BIOS Kernel the onboard PCI
;		VGA ID number
;
;Input	   :	None
;
;Output    :	cl : onboard PCI VGA ID number
;
;Registers :	Preserve ALL REGISTERS except CX
;
;[Note]    :   if no onboard PCI VGA present, cl muse be greater than 31
;
;[]==============================================================[]
		ALIGN	4
		public	Ct_PCI_VGA_IDSEL
Ct_PCI_VGA_IDSEL	proc	near

ifdef	ALWAYS_DONT_REPORT_ONBOARD_VGA
		mov	cl, -1
else	;ALWAYS_DONT_REPORT_ONBOARD_VGA

	ifdef	ONBOARD_PCI_VGA
		mov	cl,(ONBOARD_PCI_VGA SHL 3)
	else	;ONBOARD_PCI_VGA
		mov	cl,0FFh
	endif	;ONBOARD_PCI_VGA

endif	;ALWAYS_DONT_REPORT_ONBOARD_VGA

		ret

Ct_PCI_VGA_IDSEL	endp

;[]==============================================================[]
;Name	   :	Ct_Shadow_Unit
;
;Function  :	To tell the PCI BIOS Kernel the shadow unit of
;		the chipset
;
;Input	   :	None
;
;Output    :	CX = 4000h : shadow unit is 16K bytes
;		CX = 8000h : shadow unit is 32K bytes
;		All other values are reserved
;
;Registers :	Preserve ALL REGISTERS except CX
;
;[]==============================================================[]
		ALIGN	4
		Public	Ct_Shadow_Unit
Ct_Shadow_Unit	Proc	Near
		mov	cx,4000h
		ret
Ct_Shadow_Unit	Endp

;[]==============================================================[]
;Name	   :	Ct_Special_PCI_Device
;
;Function  :	To initialize special devices
;
;Input	   :	CH - Device number in upper 5 bits
;		     Function number in lower 3 bits
;
;Output    :	CF - Special device was found in this slot
;		NC - No special device was found
;
;Registers :	Please Preserve ALL REGISTERS except FLAGS
;
;[Note]    :	Example:
;
;			call	Get_Vendor_ID
;			cmp	ax,SPECIAL_DEVICE_1
;			jne	short @F
;				.
;				.
;				.
;			stc
;			ret
;		@@:
;			clc
;			ret
;
;[]==============================================================[]
		ALIGN	4
		Public	Ct_Special_PCI_Device
Ct_Special_PCI_Device	Proc	Near
		call	far ptr E000_Ct_Special_PCI_Device	;R08
;R08		call	Get_Vendor_ID
;R08		cmp	ax,1005h		;Advance Logic Vendor ID?
;R08		jne	short @F		;no
;R08		call	Get_Device_ID
;R08		cmp	ax,2301h		;Advance Logic VGA?
;R08		jne	short @F		;no
;R08		stc
;R08		ret
;R08	@@:
;R08		clc
		ret
Ct_Special_PCI_Device	Endp

;[]==============================================================[]
;Name	  :	Ct_Special_Copy_PCI_VGA
;
;Function :	Some chipset/VGA-chip may need special treatment
;		during copy VGA BIOS to shadow
;
;Input	  :	EAX : bit 15-8 = VGA device ID
;		      bit  7-0 = VGA vendor ID
;
;Output   :	CF: the standard code to copy VGA ROM in PCIPOST.ASM
;		    will be skipped
;		NC: Nothing special
;
;[]==============================================================[]
		Public	Ct_Special_Copy_PCI_VGA
Ct_Special_Copy_PCI_VGA Proc	Near
		call	far ptr E000_Ct_Special_Copy_PCI_VGA	;R08
;R08		cmp	eax,23011005h		;Advance Logic VGA?
;R08		jne	short @F		;no
;R08
;R08		mov	cl,04h			;re-enable I/O, MEM decode
;R08		mov	ax,0003h
;R08		call	Set_CfgSpace_Word
;R08	@@:
;R08			clc
			ret
Ct_Special_Copy_PCI_VGA Endp

;[]==============================================================[]
;Name	   :	Ct_C8_To_DF_RW
;
;Function  :	To enable all shadow RAM from C8000h to DFFFFh
;		& make them all R & W enabled
;
;Input	   :	None
;
;Output    :	None
;[]==============================================================[]
		Public	Ct_C8_To_DF_RW
		ALIGN	4
Ct_C8_To_DF_RW	Proc	Near
		call	far ptr E000_Ct_C8_To_DF_RW	;R08
;R08 		mov	cx,71h
;R08 		mov	bx,0AA55h
;R08 @@:
;R08 		call	Get_Set_Ct
;R08 		inc	cx
;R08 		cmp	cl,73h
;R08 		jbe	short @B
		ret
Ct_C8_To_DF_RW	Endp

;[]==============================================================[]
;Name	   :	Ct_C8_To_DF_R
;
;Function  :	To set all shadow RAM from C8000h to DFFFFh to be
;		Read only
;
;Input	   :	None
;
;Output    :	None
;
;[Note]    :	Please "DO NOT" set any segment to be NON-SHADOW
;[]==============================================================[]
		Public	Ct_C8_To_DF_R
		ALIGN	4
Ct_C8_To_DF_R	Proc	Near
		call	far ptr E000_Ct_C8_To_DF_R	;R08
;R08 		mov	cx,71h
;R08 		mov	bx,08855h
;R08 @@:
;R08 		call	Get_Set_Ct
;R08 		inc	cx
;R08 		cmp	cl,73h
;R08 		jbe	short @B
		ret
Ct_C8_To_DF_R	Endp

;[]==============================================================[]
;Input	:	DX = shadow segment to be disabled
;
;		DH = C8h : Disable C8000 -> CBFFF shadow
;		DH = CCh : Disable CC000 -> CFFFF shadow
;		DH = D0h : Disable D0000 -> D3FFF shadow
;		DH = D4h : Disable D4000 -> D7FFF shadow
;		DH = D8h : Disable D8000 -> DBFFF shadow
;		DH = DCh : Disable DC000 -> DFFFF shadow
;[]==============================================================[]
		ALIGN	4
		Public	Ct_Disable_Shadow
Ct_Disable_Shadow	Proc	Near

		call	far ptr E000_Ct_Disable_Shadow	;R08
;R08 		mov	al,dh		;calculate cx
;R08 		sub	al,0C0h
;R08 		shr	al,3
;R08 		mov	cx,70h
;R08 		add	cl,al
;R08 
;R08 		mov	bx,001Fh	;calculate bx
;R08 		test	dh,04h
;R08 		jz	short @F
;R08 		ror	bl,4
;R08 @@:
;R08 		call	Get_Set_Ct
		ret
Ct_Disable_Shadow	Endp

;R04 - start
;R11ifdef	USB_SUPPORT
;[]==============================================================[]
;Input	:	DH = shadow segment to be enabled and read/writed
;
;		DH = C8h : C8000 -> CBFFF shadow
;		DH = CCh : CC000 -> CFFFF shadow
;		DH = D0h : D0000 -> D3FFF shadow
;		DH = D4h : D4000 -> D7FFF shadow
;		DH = D8h : D8000 -> DBFFF shadow
;		DH = DCh : DC000 -> DFFFF shadow
;[]==============================================================[]
		ALIGN	4
		Public	Ct_Shadow_RW
Ct_Shadow_RW	Proc	Near

		call	far ptr E000_Ct_Shadow_RW	;R08
;R08		sub	dh,0C8h
;R08		shr	dh,2
;R08		mov	al,3
;R08		mul	dh
;R08
;R08		mov	bl,al
;R08		xor	bh,bh
;R08		add	bx,offset Shadow_RW_Tbl
;R08
;R08		xor	ch,ch
;R08		mov	cl,cs:[bx+2]
;R08		Call	Get_Ct
;R08		and	al,cs:[bx+0]
;R08		or	al,cs:[bx+1]
;R08		Call	Set_Ct

		ret

Ct_Shadow_RW	Endp

;R08 Shadow_RW_Tbl:
;R08 		db	00011111b,10100000b,71h		;0C800h
;R08 		db	11110001b,00001010b,71h		;0CC00h
;R08 		db	00011111b,10100000b,72h		;0D000h
;R08 		db	11110001b,00001010b,72h		;0D400h
;R08 		db	00011111b,10100000b,73h		;0D800h
;R08 		db	11110001b,00001010b,73h		;0DC00h
;R11endif	;USB_SUPPORT
;R04 - end

;R07 - start
;R11ifdef	USB_SUPPORT
;R11;[]==============================================================[]
;R11;Input	:	DH = shadow segment to be read only
;R11;
;R11;		DH = C8h : C8000 -> CBFFF shadow
;R11;		DH = CCh : CC000 -> CFFFF shadow
;R11;		DH = D0h : D0000 -> D3FFF shadow
;R11;		DH = D4h : D4000 -> D7FFF shadow
;R11;		DH = D8h : D8000 -> DBFFF shadow
;R11;		DH = DCh : DC000 -> DFFFF shadow
;R11;[]==============================================================[]
;R11		ALIGN	4
;R11		Public	Ct_Shadow_R
;R11Ct_Shadow_R	Proc	Near
;R11
;R11		call	far ptr E000_Ct_Shadow_R	;R08
;R11;R08		sub	dh,0C8h
;R11;R08		shr	dh,2
;R11;R08		mov	al,3
;R11;R08		mul	dh
;R11;R08
;R11;R08		mov	bl,al
;R11;R08		xor	bh,bh
;R11;R08		add	bx,offset Shadow_R_Tbl
;R11;R08
;R11;R08		xor	ch,ch
;R11;R08		mov	cl,cs:[bx+2]
;R11;R08		Call	Get_Ct
;R11;R08		and	al,cs:[bx+0]
;R11;R08		or	al,cs:[bx+1]
;R11;R08		Call	Set_Ct
;R11
;R11		ret
;R11Ct_Shadow_R	Endp
;R11
;R11;R08 Shadow_R_Tbl:
;R11;R08 		db	01011111b,10000000b,71h		;0C800h
;R11;R08 		db	11110101b,00001000b,71h		;0CC00h
;R11;R08 		db	01011111b,10000000b,72h		;0D000h
;R11;R08 		db	11110101b,00001000b,72h		;0D400h
;R11;R08 		db	01011111b,10000000b,73h		;0D800h
;R11;R08 		db	11110101b,00001000b,73h		;0DC00h
;R11endif	;USB_SUPPORT
;R11;R07 - end

;[]==============================================================[]
;Name	  :	Ct_NCR_Latency_Timer
;
;Function :	NCR SCSIs need to be programmed with appropriate
;		Latency Timer in different chipsets.
;
;Input	  :	word ptr CURRENT_DEVICE_ID[bp]
;		CH = Device No. in upper 5 bits
;		     Function No. in lower 3 bits
;
;Output   :	None
;
;Note	  :	This routine is called only when NCR vendor ID is
;		found
;
;Examples :
;		Example 1:  810/815/825 with different value
;		----------
;		pusha
;
;		mov	al,40h				;set 40h for 810
;		mov	bx,CURRENT_DEVICE_ID[bp]
;		cmp	bx,DEVICE_NCR810		;NCR/810 ?
;		je	short Set_Lat			;yes
;
;		mov	al,40h				;set 40h for 815
;		cmp	bx,DEVICE_NCR815		;NCR/815?
;		je	short Set_Lat			;yes
;
;		mov	al,00h				;set 00h for 825
;		cmp	bx,DEVICE_NCR825		;NCR/825?
;		jne	short _Exit			;no
;	Set_Lat:
;		mov	cl,0Dh				;latency timer reg.
;		call	Set_CfgSpace_Byte
;
;	_Exit:
;		popa
;
;		ret
;
;		Example 1:  810/815/825 with the same value
;		----------
;
;		mov	cl,0Dh				;latency timer reg.
;		mov	al,00h
;		call	Set_CfgSpace_Byte
;
;[]==============================================================[]
;R01		extrn	Set_CfgSpace_Byte:near
;R01		Public	Ct_NCR_Latency_Timer
;R01Ct_NCR_Latency_Timer	Proc	Near
;R01
;R01		pusha
;R01
;R01		mov	cl,0Dh				;latency timer reg.
;R01		mov	al,40h
;R01		call	Set_CfgSpace_Byte
;R01
;R01		popa
;R01		ret
;R01
;R01Ct_NCR_Latency_Timer	Endp

;R09 - start
ifdef	Combined_Other_PCI_ROM
;[]==============================================================[]
;Procedure :	Ct_If_Combined_ROM_Needed
;
;Input	:	1. CH - Current Device no. & Function No.
;		2. byte ptr CURRENT_DEVICE_ID[bp]
;		3. byte ptr CURRENT_VENDOR_ID[bp]
;		4. byte ptr CURRENT_BUS_NO[bp]
;
;Output	:	1. if NZ Flag - Combined ROM not needed
;		2. if ZR Flag
;		   - Combined ROM needed
;		   - EDI bit 15-8 & Bit 7-0 indicates the location 
;		     the the decompressed ROM
;	
;Note	:	1. Please preserve all registers except EDI
;
;		2. Steps to combine a special PCI ROM:
;
;		   - type "i:cbrom.bat /other ROM_File" under DOS prompt
;
;		   - this batch file will ask you for the address
;		     location where this ROM_File will be expanded to
;
;		   - Enter the addr. location. Normally we use 1800:0
;
;		   - BATCH file will automatically compress the ROM_FILE
;		     and add it to the System BIOS.
;
;		3. In this routine, please compare the current device
;		   ID with the device that the combine ROM is belong to.
;		   If yes, please tell the BIOS kernel the location of
;		   the ROM. In the above case, EDI should return with
;		   80001800h where the one in 1800:0 is the original image
;		   & the one in 8000:0 is duplicated for security
;[]==============================================================[]
		Public	Ct_If_Combined_ROM_Needed
Ct_If_Combined_ROM_Needed	Proc	Near

		extrn	CURRENT_DEVICE_ID:ABS

 ifdef	LAN_BOOT_SUPPORT
		extrn	LanBoot_Item:near
		pushad
       		mov	si,offset LanBoot_Item
		call	Getitem_Value		;check CMOS value
		not	al
		test	al,01h		     	;LAN ROM disabled ?
		popad
		jnz	short @F		;yes,skip ROM initial

		cmp	ch,(LAN_PCI_ID SHL 3)
		jne	short @F

		cmp	dword ptr CURRENT_DEVICE_ID[bp], Combined_Other_PCI_ROM
		jne	short @F					
		mov	edi,(8000h shl 16) + 1800h			
	@@:								
 endif;	LAN_BOOT_SUPPORT

		ret

Ct_If_Combined_ROM_Needed	Endp
endif	;Combined_Other_PCI_ROM
;R09 - end

endif	;NEW_PCI_KERNEL
endif	;PCI_BUS

FCODE		ENDS

;R08 - start
;--------------------------------------------------------------
;--------------------------------------------------------------
;----- The following codes will be located at E000 ! ----------
;----- The following codes will be located at E000 ! ----------
;----- The following codes will be located at E000 ! ----------
;----- The following codes will be located at E000 ! ----------
;--------------------------------------------------------------
;--------------------------------------------------------------
ECODE		SEGMENT USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP,ES:EGROUP

E000_Set_Level_Irq	proc	far
 		pusha
 
 		;Disable INT before program 8259
 		cli
 		in	al,0a1h
 		mov	ah,al
 		in	al,21h
 		push	ax			;save original interrupt mask
 		mov	al,0ffh 		;mask all interrupt
 		out	21h,al
 		IODELAY
 		out	0a1h,al
 
 ;;config register 4D0h & 4D1h for level trigger interrupt
 		mov	dx,04d0h
 		cmp	bl,8
 		mov	cl,bl
 		jb	short Below_Irq8
 		sub	cl,8
 		inc	dl
 Below_Irq8:
 		mov	ah,1
 		shl	ah,cl
 
 		in	al,dx
 		or	al,ah
 		out	dx,al
 
 		;Restore 8259 status
 		pop	ax			;restore interrupt mask
 		out	21h,al
 		xchg	ah,al
 		out	0a1h,al
 
 		popa
		ret
E000_Set_Level_Irq	endp

		Public	Ct_PCI_Info
E000_Ct_PCI_Info	Proc	far

		mov	al,1		;starting device to be scanned
		mov	ah,20		;ending device to be scanned

		mov	ecx,0F8000000h	;Temporary addr. for ROM	;Rpp
		mov	esi,0E0000000h	;initial memory addr. space	;Rpp
		mov	edi,0FFFFFFFFh	;maximun memory Base Addr space

ifndef SPECIAL_IO_ADDRESS						;R02A
                mov     ebx,000006300H  ;Initial IO Base Addr space     ;R02  
else									;R02A
                mov     ebx,000007000H  ;Initial IO Base Addr space     ;R02A 
endif; SPECIAL_IO_ADDRESS						;R02A
		mov	edx,00000FFFFh	;maximun IO Base Addr space	
		ret
E000_Ct_PCI_Info	endp

E000_Ct_Special_PCI_Device	proc	far
		F000_call Get_Vendor_ID
		cmp	ax,1005h		;Advance Logic Vendor ID?
		jne	short @F		;no
		F000_call Get_Device_ID
		cmp	ax,2301h		;Advance Logic VGA?
		jne	short @F		;no
		stc
		ret
	@@:
		clc
		ret
E000_Ct_Special_PCI_Device	endp

E000_Ct_Special_Copy_PCI_VGA	proc	far
		cmp	eax,23011005h		;Advance Logic VGA?
		jne	short @F		;no

		mov	cl,04h			;re-enable I/O, MEM decode
		mov	ax,0003h
		F000_call Set_CfgSpace_Word
	@@:
		clc
		ret
E000_Ct_Special_Copy_PCI_VGA	endp

E000_Ct_C8_To_DF_RW	proc	far
		mov	cx,71h
		mov	bx,0AA55h
@@:
		call	F000_Get_Set_Ct
		inc	cx
		cmp	cl,73h
		jbe	short @B
		ret
E000_Ct_C8_To_DF_RW	endp

E000_Ct_C8_To_DF_R	proc	far
		mov	cx,71h
		mov	bx,08855h
@@:
		call	F000_Get_Set_Ct
		inc	cx
		cmp	cl,73h
		jbe	short @B
		ret
E000_Ct_C8_To_DF_R	endp

E000_Ct_Disable_Shadow	proc	far
		mov	al,dh		;calculate cx
		sub	al,0C0h
		shr	al,3
		mov	cx,70h
		add	cl,al

		mov	bx,001Fh	;calculate bx
		test	dh,04h
		jz	short @F
		ror	bl,4
@@:
		call	F000_Get_Set_Ct
		ret
E000_Ct_Disable_Shadow	endp

;R11ifdef	USB_SUPPORT
E000_Ct_Shadow_RW	proc	far
		sub	dh,0C8h
		shr	dh,2
		mov	al,3
		mul	dh

		mov	bl,al
		xor	bh,bh
		add	bx,offset Shadow_RW_Tbl

		xor	ch,ch
		mov	cl,cs:[bx+2]
		call	F000_Get_Ct
		and	al,cs:[bx+0]
		or	al,cs:[bx+1]
		call	F000_Set_Ct
		ret
E000_Ct_Shadow_RW	endp

Shadow_RW_Tbl:
		db	00011111b,10100000b,71h		;0C800h
		db	11110001b,00001010b,71h		;0CC00h
		db	00011111b,10100000b,72h		;0D000h
		db	11110001b,00001010b,72h		;0D400h
		db	00011111b,10100000b,73h		;0D800h
		db	11110001b,00001010b,73h		;0DC00h

;R11E000_Ct_Shadow_R	proc	far
;R11		sub	dh,0C8h
;R11		shr	dh,2
;R11		mov	al,3
;R11		mul	dh
;R11
;R11		mov	bl,al
;R11		xor	bh,bh
;R11		add	bx,offset Shadow_R_Tbl
;R11
;R11		xor	ch,ch
;R11		mov	cl,cs:[bx+2]
;R11		call	F000_Get_Ct
;R11		and	al,cs:[bx+0]
;R11		or	al,cs:[bx+1]
;R11		call	F000_Set_Ct
;R11		ret
;R11E000_Ct_Shadow_R	endp

;R11Shadow_R_Tbl:
;R11		db	01011111b,10000000b,71h		;0C800h
;R11		db	11110101b,00001000b,71h		;0CC00h
;R11		db	01011111b,10000000b,72h		;0D000h
;R11		db	11110101b,00001000b,72h		;0D400h
;R11		db	01011111b,10000000b,73h		;0D800h
;R11		db	11110101b,00001000b,73h		;0DC00h
;R11endif	;USB_SUPPORT

ECODE		ENDS
;R08 - end

ENDIF	;COMPILE_FOR_RUN_TIME		;R03

;R03 - starts
IF	COMPILE_FOR_RUN_TIME
		include	common.equ
		include	common.mac

		extrn	Get_Set_Ct:Near
		extrn	AGet_CfgSpace_Word:Near
		extrn	ASet_CfgSpace_Word:Near
		extrn	Set_Level_Irq:near
		extrn	Get_Ct:Near
		extrn	Set_Ct:Near

DGROUP		GROUP	FCODE
FCODE		SEGMENT USE16 PARA PUBLIC 'CODE'
		ASSUME	CS:DGROUP

;[]==============================================================[]
;Ct_Set_PciIrq:
;	Program chipset IRQ routing
;Saves: all
;Input : AL - interrupt pin to assign ,value is 1-16
;	      
;	 AH - IRQ No.	
;	 CH - IRQ trigger 0-edge, 1-level
;	      CH=0FFh --> Do not change the Edge/Level setting		;R03
;	 CL - slot index 0-slot 1 , 1-slot 2, 2-slot 3 ,3-slot 4
;	    - 4 - USB
;Output: None
;[]==============================================================[]
		public	Ct_Set_PciIrq
Ct_Set_PciIrq	proc	near
		pusha

		mov	bl,ah
		test	ch,01H			;level trigger IRQ ?
		jz	short Not_Level_Irq
		cmp	ch, 0FFh		;R03
		je	short Not_Level_Irq	;R03
		call	Set_Level_Irq
Not_Level_Irq:

		mov	cx,0841H		;INT routing register
@@:
		dec	al
		jz	short Shift_Ok
		inc	cx
		jmp	short @B
Shift_Ok:
;R05ifdef	SiS_USB_ENABLE_PATCH		;if interrupt pin > 4 means USBIRQ
		cmp	cl,44h
		jbe	short Not_USBIRQ
		mov	cl,62h
		call	Get_Ct
		and	al,70h
		or	ah,al
Not_USBIRQ:
;R05endif	;SiS_USB_ENABLE_PATCH
		mov	al,ah
		call	Set_Ct

		popa
		ret
Ct_Set_PciIrq	endp

;R11 - start
		ALIGN	4
		Public	ct_Shadow_R
ct_Shadow_R	proc	Near
		sub	dh, 0C8h
		shr	dh, 2
		mov	al, 3
		mul	dh

		mov	bl, al
		xor	bh, bh
		add	bx, offset Ct_Shadow_R_Tbl

		xor	ch, ch
		mov	cl, cs:[bx+2]
		Call	Get_Ct
		and	al, cs:[bx+0]
		or	al, cs:[bx+1]
		Call	Set_Ct

		ret

Ct_Shadow_R	Endp

Ct_Shadow_R_Tbl:
		db	01011111b, 10000000b,71h	;0C800h
		db	11110101b, 00001000b,71h	;0CC00h
		db	01011111b, 10000000b,72h	;0D000h
		db	11110101b, 00001000b,72h	;0D400h
		db	01011111b, 10000000b,73h	;0D800h
		db	11110101b, 00001000b,73h	;0DC00h
;R11 - end

FCODE		ENDS

ENDIF	;COMPILE_FOR_RUN_TIME
;R03 - ends


		END
