;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;
;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;--------------------------2A5II---------------------------------------------
;R03	05/24/97 RCH	Added NO_PCI_IDE_2ND_CONTROL to skip item for 2nd
;			IDE channel control for PCI/IDE card
;R02	04/07/97 LRY	Added "Ultra_DMA33_support"
;R01	03/05/97 LRY	Change IOCMOS from 7Ah to 48h
;R00	01/07/97 LRY	Initial version

		PAGE	56,132
		.286

		include bios.cfg
		include bsetup.inc
		include setup.ext
		extrn	Std_Help_Str:near
		extrn	PAGE_NAME_Y:ABS
		Extrn	Common_Startup_Str:Near
		Extrn	Ena_Str:Near
		Extrn	Dis_Str:Near
		Extrn	NullStr:Near
		extrn	Get_Cmos:Near
		extrn	Set_Cmos:Near
		Extrn	NullStr:Near
		Extrn	If_CX_Then_Dis:Near
		Extrn	Re_Enable:Near
		Extrn	Self_Dis:Near

		Public	PCI_Feature_Special_Do
		Public	PCI_Feature_Special_Show
		Public	PCI_Feature_Key_List
		Public	PCI_Feature_StartUp_Str
		Public	PCI_Feature_Start
		Public	PCI_Feature_End
		Public	PCI_STAT

		Public	PCI_Auto_Table
		Public	PCI_EndAuto_Table
		Public	PCI_Auto_String

PNP_CMOS	EQU	58h
PCI_CMOS	EQU	58h

DEFINE_ITEM	MACRO	MENU_NAME,GAP
IFB	<GAP>
	Yaxis = Yaxis + 1
ELSE	;
 IF	Yaxis GT 3		;if Yaxis great than the top row, process gap
  IFDEF LAST_GAP_POSITION
   IF	Xaxis+Yaxis NE LAST_GAP_POSITION
	Yaxis = Yaxis + 1
   ENDIF;
  ELSE	;
	Yaxis = Yaxis + 1
  ENDIF ;LAST_GAP_POSITION
	LAST_GAP_POSITION = Xaxis + Yaxis
 ENDIF	;
	Yaxis = Yaxis + GAP
ENDIF	;GAP
IF	Yaxis GT 23
	Xaxis = 42
	Yaxis = 4
 IFNB	<GAP>
  IF	GAP EQ 0
	Yaxis = 3
  ENDIF	;
 ENDIF	;
ENDIF	;
IFNB	<MENU_NAME>
	PUBLIC	MENU_NAME
	MENU_NAME:
ENDIF
		ENDM

DSP_IOCMOS	MACRO	CMOS_LOC
	if2
		%out	CMOS location = CMOS_LOC
	endif
		ENDM

DGROUP		GROUP	FCODE
FCODE		SEGMENT WORD PUBLIC 'CODE'
		ASSUME	CS:DGROUP,DS:DGROUP


PCI_Feature_Special_Do:
			dw	PCI_Feature_Do_NO
PCI_Feature_Do_NO	EQU	(($ - offset PCI_Feature_Special_Do)-2)/4

PCI_Feature_Special_Show:
		dw	PCI_Feature_Show_NO
ifdef	NEW_PNP_SETUP
		dw	offset PNP_Control_Item, offset Show_PNP_Auto1
endif	;NEW_PNP_SETUP
ifdef	PNP_PCI_AUTO
		dw	offset PnP_Auto_Item, offset Show_PnP_Auto
endif	;PNP_PCI_AUTO
		dw	offset PCI_IDE_IRQ,offset Show_PCI_IDE_IRQ

ifndef	ONCHIP_IDE_IN_IOSETUP
ifndef	ONCHIP_IDE_ALWAYS_DISABLE
		dw	Offset Int_IDE_Item,	Offset Show_5513ide
endif	;ONCHIP_IDE_ALWAYS_DISABLE
endif	;ONCHIP_IDE_IN_IOSETUP

ifdef	ONBOARD_IO_IN_PCISETUP
 ifdef	AIOCMOS
 		include AUDIO.SHW
 endif	;AIOCMOS
		include superio.shw
endif	;ONBOARD_IO_IN_PCISETUP

PCI_Feature_Show_NO	EQU	(($ - offset PCI_Feature_Special_Show)-2)/4

PCI_Feature_Key_List	Label	Near
		dw	offset Seq_Up		;function for UP_ARROW
		dw	offset Seq_Down 	;function for DOWN_ARROW
		dw	offset Go_Left_Item	;function for LEFT_ARROW
		dw	offset Go_Right_Item	;function for RIGHT_ARROW

PCI_Feature_StartUp_Str label	near
		STRSHOW <,,,offset Common_StartUp_Str>
		POS	<,29,PAGE_NAME_Y>
		public	PCI_FEATURE_STR
PCI_FEATURE_STR:
ifdef	NEW_PNP_SETUP
		db	'PNP/PCI CONFIGURATION'
else	;NEW_PNP_SETUP
 ifdef	ONBOARD_IO_IN_PCISETUP
		db	'PCI & ONBOARD I/O SETUP'
 else;	ONBOARD_IO_IN_PCISETUP
		db	'PCI CONFIGURATION SETUP'
 endif; ONBOARD_IO_IN_PCISETUP
endif	;NEW_PNP_SETUP
		db	0

;----------------------------------------------------------------------------

		ALIGN	4
		db	0
PCI_Auto_Table	label	near
PCI_EndAuto_Table	label	near

;[]======================================================================[]
;
;			Menuitems
;
;[]======================================================================[]
PCI_Feature_START	Label	Near

Xaxis	=	2
Yaxis	=	3
;============================================================================

ifdef	NEW_PNP_SETUP

ifdef	PNP_OS_SELECTABLE		
DEFINE_ITEM	OS_Setup_Item
	menuitem <0,\
		offset OS_Setup_Str,NOCT,04h,PNP_CMOS,04h,\
		offset OS_Setup_Val,0,1,Xaxis,Yaxis,0,1,offset NullStr>
endif;	PNP_OS_SELECTABLE		

DEFINE_ITEM	PnP_Control_Item
	menuitem <0,\
		offset PnP_Control_Str,NOCT,01h,PNP_CMOS,01h,\
		offset PnPCtrl_Val,0,1,Xaxis,Yaxis,0h,1,offset NullStr>

DEFINE_ITEM	Reset_Escd_Item
	menuitem <0,\
		offset Reset_Escd_Str,NOCT,02h,PNP_CMOS,02h,\
		offset Dis_Str,0,1,Xaxis,Yaxis,0h,0,offset NullStr>

DEFINE_ITEM	Irq3_Item, 1
	menuitem <0,\
		offset IRQ3_Str,NOCT,01h,PNP_CMOS+1,01h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,1,offset NullStr>

DEFINE_ITEM	Irq4_Item
	menuitem <0,\
		offset IRQ4_Str,NOCT,02h,PNP_CMOS+1,02h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,2,offset NullStr>

DEFINE_ITEM	Irq5_Item
	menuitem <0,\
		offset IRQ5_Str,NOCT,04h,PNP_CMOS+1,04h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,0,offset NullStr>

DEFINE_ITEM	Irq7_Item
	menuitem <0,\
		offset IRQ7_Str,NOCT,08h,PNP_CMOS+1,08h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,8,offset NullStr>

DEFINE_ITEM	Irq9_Item
	menuitem <0,\
		offset IRQ9_Str,NOCT,10h,PNP_CMOS+1,10h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,0,offset NullStr>

DEFINE_ITEM	Irq10_Item
	menuitem <0,\
		offset IRQ10_Str,NOCT,20h,PNP_CMOS+1,20h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,0,offset NullStr>

DEFINE_ITEM	Irq11_Item
	menuitem <0,\
		offset IRQ11_Str,NOCT,40h,PNP_CMOS+1,40h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,0,offset NullStr>

DEFINE_ITEM	Irq12_Item
	menuitem <0,\
		offset IRQ12_Str,NOCT,80h,PNP_CMOS+1,80h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,0,offset NullStr>

DEFINE_ITEM	Irq14_Item
	menuitem <0,\
		offset IRQ14_Str,NOCT,01h,PNP_CMOS+2,01h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,1,offset NullStr>

DEFINE_ITEM	Irq15_Item
	menuitem <0,\
		offset IRQ15_Str,NOCT,02h,PNP_CMOS+2,02h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,2,offset NullStr>

DEFINE_ITEM	Dma0_Item
	menuitem <0,\
		offset DMA0_Str,NOCT,04h,PNP_CMOS+2,04h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,0,offset NullStr>

DEFINE_ITEM	Dma1_Item
	menuitem <0,\
		offset DMA1_Str,NOCT,08h,PNP_CMOS+2,08h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,0,offset NullStr>

DEFINE_ITEM	Dma3_Item
	menuitem <0,\
		offset DMA3_Str,NOCT,10h,PNP_CMOS+2,10h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,0,offset NullStr>

DEFINE_ITEM	Dma5_Item
	menuitem <0,\
		offset DMA5_Str,NOCT,20h,PNP_CMOS+2,20h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,0,offset NullStr>

DEFINE_ITEM	Dma6_Item
	menuitem <0,\
		offset DMA6_Str,NOCT,40h,PNP_CMOS+2,40h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,0,offset NullStr>

DEFINE_ITEM	Dma7_Item
	menuitem <0,\
		offset DMA7_Str,NOCT,80h,PNP_CMOS+2,80h,\
		offset Bus_Var,0,1,Xaxis,Yaxis,0h,0,offset NullStr>

endif	;NEW_PNP_SETUP

ifdef	PNP_PCI_AUTO
DEFINE_ITEM	PnP_Auto_Item
	menuitem <0,\
		offset PnP_Auto_Str,NOCT,10h,PCI_CMOS,10h,\
		offset Dis_Str,0,1,Xaxis,Yaxis,0h,0h,offset NullStr>
endif	;PNP_PCI_AUTO

ifndef	NEW_PNP_SETUP
		public	PCI_IRQ1
		public	PCI_IRQ2
		public	PCI_IRQ3
		public	PCI_IRQ4
ifdef	NCR_IRQ_FIXED
SLOT1_IRQ	EQU	0aH SHL 4
SLOT2_IRQ	EQU	0bH
SLOT3_IRQ	EQU	0cH SHL 4
SLOT4_IRQ	EQU	05H
else;	NCR_IRQ_FIXED
SLOT1_IRQ	EQU	0aH SHL 4
SLOT2_IRQ	EQU	0bH
SLOT3_IRQ	EQU	09H SHL 4
ifdef	MOUSE
SLOT4_IRQ	EQU	05H
else;	MOUSE
SLOT4_IRQ	EQU	0cH
endif;	MOUSE
endif;	NCR_IRQ_FIXED
DEFINE_ITEM	PCI_IRQ1
	menuitem <0,\
		offset PCI_Irq1_Str,NOCT,0f0h,PCI_CMOS+2,0f0h,\
		offset Irq_Val,0,15,Xaxis,Yaxis,SLOT1_IRQ,SLOT1_IRQ,offset NullStr>

DEFINE_ITEM	PCI_IRQ2
	menuitem <0,\
		offset PCI_Irq2_Str,NOCT,0fh,PCI_CMOS+2,0fh,\
		offset Irq_Val,0,15,Xaxis,Yaxis,SLOT2_IRQ,SLOT2_IRQ,offset NullStr>

DEFINE_ITEM	PCI_IRQ3
	menuitem <0,\
		offset PCI_Irq3_Str,NOCT,0f0h,PCI_CMOS+3,0f0h,\
		offset Irq_Val,0,15,Xaxis,Yaxis,SLOT3_IRQ,SLOT3_IRQ,offset NullStr>

DEFINE_ITEM	PCI_IRQ4
	menuitem <0,\
		offset PCI_Irq4_Str,NOCT,0fh,PCI_CMOS+3,0fh,\
		offset Irq_Val,0,15,Xaxis,Yaxis,SLOT4_IRQ,SLOT4_IRQ,offset NullStr>

else	;NEW_PNP_SETUP
 IF	Xaxis LT 40
Xaxis	= 42
Yaxis	= 3
 ENDIF
endif	;NEW_PNP_SETUP


DEFINE_ITEM	PCI_IRQ_Method
	menuitem <0,\
		offset PCI_Trigger_Str,NOCT,01h,PCI_CMOS+4,01h,\
		offset PCI_Trigger_Val,0,1,Xaxis,Yaxis,01h,01h,offset NullStr>

ifndef	NO_PCI_IDE_2ND_CONTROL				;R03
ifdef	PCI_IDE_2nd_Channel_Not_At_BF
DEFINE_ITEM	Second_IDE_channel
	menuitem <0,\
		offset Second_Ide_Str,NOCT,00001000b,3Eh,00001000b,\
		offset Dis_Str,0,1,Xaxis,Yaxis,00001000b    ,00001000b,Offset Std_Help_Str>
endif	;PCI_IDE_2nd_Channel_Not_At_BF
endif;	NO_PCI_IDE_2ND_CONTROL				;R03

DEFINE_ITEM	PCI_IDE_IRQ
ifdef	PCI_IDE_IRQ_ISA
IDE_IRQ 	EQU	02H
else;	PCI_IDE_IRQ_ISA
IDE_IRQ 	EQU	00H
endif;	PCI_IDE_IRQ_ISA
	menuitem <0,\
		offset PCI_Ide_Irq_Str,NOCT,0eh,PCI_CMOS+4,0eh,\
		offset PCI_Ide_Irq_Val,0,1,Xaxis,Yaxis,IDE_IRQ,IDE_IRQ,offset NullStr>

DEFINE_ITEM	First_IDE_INT
	menuitem <0,\
		offset First_Int_Str,NOCT,30h,PCI_CMOS+4,30h,\
		offset First_Int_Val,0,3,Xaxis,Yaxis,0,0,offset NullStr>

DEFINE_ITEM	Second_IDE_INT
	menuitem <0,\
		offset Second_Int_Str,NOCT,0c0h,PCI_CMOS+4,0c0h,\
		offset First_Int_Val,0,3,Xaxis,Yaxis,40h,40h,offset NullStr>


ifndef	ONCHIP_IDE_IN_IOSETUP
ifndef	ONCHIP_IDE_ALWAYS_DISABLE
DEFINE_ITEM	Int_IDE_Item
	menuitem <2,\
		offset Int_IDE_Str,NOCT,03h,56h,0Ch,\
		offset Int_IDE_Val,0,3,Xaxis,Yaxis,03h,0Ch,offset Std_Help_Str>
 ifdef	NEW_IDE_MODE_3
	FOUR_IDE_PIO_ITEM_IN_PCIFEAT	EQU	1
 endif	;NEW_IDE_MODE_3
endif	;ONCHIP_IDE_ALWAYS_DISABLE
endif	;ONCHIP_IDE_IN_IOSETUP

ifdef	FOUR_IDE_PIO_ITEM_IN_PCIFEAT
DEFINE_ITEM	IdeA_Mode_Item
	menuitem <0,\
		offset IDEA_mode_Str,	       NOCT,11100000b,34h,11100000b,\
		offset IDE_mode_Val,0,5,Xaxis,Yaxis,00100000b,	  00000000b,offset Std_Help_Str>

		public	Ide_mode_diff
Ide_mode_diff	EQU	$ - offset IdeA_mode_Item

DEFINE_ITEM	IdeB_Mode_Item
	menuitem <0,\
		offset IDEB_mode_Str,	       NOCT,00011100b,34h,00011100b,\
		offset IDE_mode_Val,0,5,Xaxis,Yaxis,00000100b,	  00000000b,offset Std_Help_Str>

DEFINE_ITEM	IdeC_Mode_Item
	menuitem <0,\
		offset IDEC_mode_Str,	       NOCT,11100000b,35h,11100000b,\
		offset IDE_mode_Val,0,5,Xaxis,Yaxis,00100000b,	  00000000b,offset Std_Help_Str>

DEFINE_ITEM	IdeD_Mode_Item
	menuitem <0,\
		offset IDED_mode_Str,	       NOCT,00011100b,35h,00011100b,\
		offset IDE_mode_Val,0,5,Xaxis,Yaxis,00000100b,	  00000000b,offset Std_Help_Str>
;R02 - start
ifdef	Ultra_DMA33_support
DEFINE_ITEM	IdeA_Sdma_Item
menuitem <0,\
offset IDEA_Sdma_Str,NOCT,00000001b,7Ah,00000001b,\
offset Sdma_Str,0,1,Xaxis,Yaxis,00h,01h,offset Std_Help_Str>

DEFINE_ITEM	IdeB_Sdma_Item
menuitem <0,\
offset IDEB_Sdma_Str,NOCT,00000001b,7Ah,00010000b,\
offset Sdma_Str,0,1,Xaxis,Yaxis,00h,10h,offset Std_Help_Str>

DEFINE_ITEM	IdeC_Sdma_Item
menuitem <0,\
offset IDEC_Sdma_Str,NOCT,00000001b,7Bh,00000001b,\
offset Sdma_Str,0,1,Xaxis,Yaxis,00h,01h,offset Std_Help_Str>

DEFINE_ITEM	IdeD_Sdma_Item
menuitem <0,\
offset IDED_Sdma_Str,NOCT,00000001b,7Bh,00010000b,\
offset Sdma_Str,0,1,Xaxis,Yaxis,00h,10h,offset Std_Help_Str>
endif	;Ultra_DMA33_support
;R02 - end
endif	;FOUR_IDE_PIO_ITEM_IN_PCIFEAT

ifndef	ONCHIP_IDE_IN_IOSETUP
ifndef	ONCHIP_IDE_ALWAYS_DISABLE
DEFINE_ITEM	IDE_bst_Item
	menuitem <2,\
		offset IDE_bst_Str,94Ah,80h,5Fh,40h,\
		offset Dis_Str,0,1,Xaxis,Yaxis,00h,00h,offset Std_Help_Str>
endif	;ONCHIP_IDE_ALWAYS_DISABLE

DEFINE_ITEM
	menuitem <2,\
		offset IDEport_post_Str,0083h,04h,5Fh,20h,\
		offset Dis_Str,0,1,Xaxis,Yaxis,00h,20h,offset Std_Help_Str>

 ifdef	IDE_ITEM_NOT_IN_BFEATURE
DEFINE_ITEM	IdeBlock_Item
	menuitem <0,\
		offset IdeBlock_Str,NOCT,01000000b,11H,01000000b,\
		offset Dis_Str,0,1,Xaxis,Yaxis,0,40h,Offset Std_Help_Str>
 endif	;IDE_ITEM_NOT_IN_BFEATURE
endif	;ONCHIP_IDE_IN_IOSETUP

ifdef	ONBOARD_ScsiChip
DEFINE_ITEM	Onboard_Scsi_Item
	menuitem <0,\
		offset Scsi_Str,NOCT,080h,58h,080h,\
		offset Dis_Str,0,1,Xaxis,Yaxis,80h,80h,offset NullStr>
endif	;ONBOARD_ScsiChip

ifdef	ONBOARD_IO_IN_PCISETUP
SW_CMOS =	57h
;R01 IO_CMOS =	7Ah
ifndef	REMOVE_ITEM_GAP 	;if bit 0=1 then remove right gaps
DEFINE_ITEM	,0
else	;REMOVE_ITEM_GAP
 if	(REMOVE_ITEM_GAP and 1) eq 0
DEFINE_ITEM	,0
 endif
endif	;REMOVE_ITEM_GAP

ifdef	CLEAR_ESCD_OPTION
DEFINE_ITEM	Reset_Escd_Item
	menuitem <0,\
		offset Reset_Escd_Str,NOCT,02h,SW_CMOS,20h,\
		offset Dis_Str,0,1,Xaxis,Yaxis,0h,0,offset NullStr>
endif	;CLEAR_ESCD_OPTION

ifdef	NCR_IRQ_FIXED
DEFINE_ITEM
	menuitem <0,\
		offset NCRIRQ_Str,(ONBOARD_NCR_SLOT SHL 11) + 3CH,0fh,SW_CMOS,00001111b,\
		offset NCRIRQ_Val,9,11,Xaxis,Yaxis,09h,09h,offset Std_Help_Str>
endif;	NCR_IRQ_FIXED

 ifndef NEW_SUPERIDE_KERNEL
  ifdef ONBOARD_PCI_IDE
DEFINE_ITEM	OnboardPciIde_Item
	menuitem <0,\
		offset PciIdeOn_Str,NOCT,40h,SW_CMOS,01000000b,\
		offset Dis_Str,0,1,Xaxis,Yaxis,40h,40h,offset Std_Help_Str>
  endif ;ONBOARD_PCI_IDE
 endif	;NEW_SUPERIDE_KERNEL

;R01		IOCMOS = IO_CMOS
		IOCMOS = 48h		;R01
		IDECMOS= 34h
		include superio.mnu

ifdef	MIRQ	;MIRQ equ 0 ~ 15,  0 is disable
DEFINE_ITEM	MIRQ_Item
	menuitem <2,\
		offset MIRQ_Str,861h,00001111b,37h,00001111b,\
		offset MIRQ_Val,0,15,Xaxis,Yaxis,MIRQ,MIRQ,offset NullStr>
endif	;MIRQ
ifdef	MDRQ	;MDRQ0 equ -1 ~ 7,  -1 is disable
DEFINE_ITEM
	menuitem <2,\
		offset MDRQ_Str,862h,00001111b,38h,00001111b,\
		offset MDRQ_Val,7,15,Xaxis,Yaxis,MDRQ+8,MDRQ+8,offset NullStr>
endif	;MDRQ0

ifdef	PS2_ITEM_NOT_IN_BFEATURE
DEFINE_ITEM	PS2_select_item,1
		menuitem <0,\
			  offset ps2_select_Str,NOCT,01h,PS2_CMOS,PS2_CMOS_BIT,\
			  offset Dis_Str,0,1,Xaxis,Yaxis,01h,PS2_CMOS_BIT,Offset Std_Help_Str>
endif	;PS2_ITEM_NOT_IN_BFEATURE
ifdef	AIOCMOS
DEFINE_ITEM	,0
Yaxis	= Yaxis + 1
		include AUDIO.MNU
endif	;AIOCMOS
endif	;ONBOARD_IO_IN_PCISETUP


PCI_Feature_END 	Label	Near
IF (offset PCI_Feature_END) EQ (offset PCI_Feature_START)
	PCI_STAT		EQU	0 + ITEMDISABLE
ELSE
	PCI_STAT		EQU	0
ENDIF
;----------------------------------------------------------
ifdef	ONBOARD_ScsiChip
Scsi_Str:		db	'Onboard PCI SCSI        : ',0
endif	;ONBOARD_ScsiChip

ifdef	NCR_IRQ_FIXED
NCRIRQ_Str		db	'Onboard NCR SCSI IRQ    : ',0
NCRIRQ_Val		db	'9 ',0
			db	'10',1
			db	'11',0
endif	;NCR_IRQ_FIXED

ifndef	ONCHIP_IDE_IN_IOSETUP
ifdef	IDE_ITEM_NOT_IN_BFEATURE
IdeBlock_Str		db	'IDE HDD Block Mode      : ',0
ifdef	IDE_32BIT_SUPPORT
IDE_transfer_Str	db	'IDE 32-bit Transfer Mode: ',0
IDE_T_Val		db	'Disabled',0
			db	'Enabled ',0
endif	;IDE_32BIT_SUPPORT
endif	;IDE_ITEM_NOT_IN_BFEATURE
endif	;ONCHIP_IDE_IN_IOSETUP

ifndef	NEW_SUPERIDE_KERNEL
ifdef	ONBOARD_PCI_IDE
PciIdeOn_Str		db	'Onboard PCI/IDE Chip    : ',0
endif;	ONBOARD_PCI_IDE
endif	;NEW_SUPERIDE_KERNEL

ifdef	ONBOARD_IO_IN_PCISETUP
		COLLON_LOC = 24
 ifdef	AIOCMOS
		include AUDIO.STR
 endif	;AIOCMOS
		include superio.str

ifdef	MIRQ
 ifdef	MIRQstring
MIRQ_Str		db	MIRQstring,0
 else	;MIRQstring
MIRQ_Str		db	'MIRQ Remapping to       : ',0
 endif	;MIRQstring
MIRQ_Val		db	'None ',0
			db	'Reser',1
			db	'Reser',1
			db	'IRQ3 ',0
			db	'IRQ4 ',0
			db	'IRQ5 ',0
			db	'IRQ6 ',0
			db	'IRQ7 ',0
			db	'Reser',1
			db	'IRQ9 ',0
			db	'IRQ10',0
			db	'IRQ11',0
			db	'IRQ12',0
			db	'Reser',1
			db	'IRQ14',0
			db	'IRQ15',0
endif	;MIRQ
ifdef	MDRQ
 ifdef	MDRQstring
MDRQ_Str		db	MDRQstring,0
 else	;MDRQstring
MDRQ_Str		db	'MDRQ Remapping to       : ',0
 endif	;MDRQstring
MDRQ_Val		db	'None',0
			db	'DMA0',0
			db	'DMA1',0
			db	'DMA2',0
			db	'DMA3',0
			db	'None',1
			db	'DMA5',0
			db	'DMA6',0
			db	'DMA7',0
endif	;MDRQ

 ifdef	PS2_ITEM_NOT_IN_BFEATURE
Ps2_select_Str		db	'PS/2 mouse function     : ',0
 endif	;PS2_ITEM_NOT_IN_BFEATURE
endif	;ONBOARD_IO_IN_PCISETUP


ifdef	FOUR_IDE_PIO_ITEM_IN_PCIFEAT
IDEA_mode_Str		db	'IDE Primary Master PIO  : ',0
IDEB_mode_Str		db	'IDE Primary Slave  PIO  : ',0
IDEC_mode_Str		db	'IDE Secondary Master PIO: ',0
IDED_mode_Str		db	'IDE Secondary Slave  PIO: ',0
IDE_mode_Val		db	'Auto  ',0
			db	'Mode 0',0
			db	'Mode 1',0
			db	'Mode 2',0
			db	'Mode 3',0
			db	'Mode 4',0
endif	;FOUR_IDE_PIO_ITEM_IN_PCIFEAT
;R02 - start
ifdef	Ultra_DMA33_support
IDEA_Sdma_Str		db	'Primary Master  UltraDMA: ',0
IDEB_Sdma_Str		db	'Primary Slave   UltraDMA: ',0
IDEC_Sdma_Str		db	'Secondary MasterUltraDMA: ',0
IDED_Sdma_Str		db	'Secondary Slave UltraDMA: ',0
Sdma_Str		db	'Disabled',0
			db	'Auto    ',0
endif	;Ultra_DMA33_support
;R02 - end

;----------------------------------------------------------------
ifdef	NEW_PNP_SETUP
ifdef	PNP_OS_SELECTABLE		
OS_Setup_Str	db	'PNP OS Installed         : ', 0
OS_Setup_Val	db	'No ', 0
		db	'Yes', 0
endif;	PNP_OS_SELECTABLE		

Reset_Escd_Str	db	'Reset Configuration Data : ', 0
PnP_Control_Str db	'Resources Controlled By  : ', 0
PnPCtrl_Val	db	'Auto  ',0
		db	'Manual',0

IRQ3_Str	db	'IRQ-3 '
Assign_To_Str	db	' assigned to : ', 0

IRQ4_Str	db	'IRQ-4 '
		STRSHOW <,,,offset Assign_To_Str>
		db	0
IRQ5_Str	db	'IRQ-5 '
		STRSHOW <,,,offset Assign_To_Str>
		db	0
IRQ7_Str	db	'IRQ-7 '
		STRSHOW <,,,offset Assign_To_Str>
		db	0
IRQ9_Str	db	'IRQ-9 '
		STRSHOW <,,,offset Assign_To_Str>
		db	0
IRQ10_Str	db	'IRQ-10'
		STRSHOW <,,,offset Assign_To_Str>
		db	0
IRQ11_Str	db	'IRQ-11'
		STRSHOW <,,,offset Assign_To_Str>
		db	0
IRQ12_Str	db	'IRQ-12'
		STRSHOW <,,,offset Assign_To_Str>
		db	0
IRQ14_Str	db	'IRQ-14'
		STRSHOW <,,,offset Assign_To_Str>
		db	0
IRQ15_Str	db	'IRQ-15'
		STRSHOW <,,,offset Assign_To_Str>
		db	0
DMA0_Str	db	'DMA-0 '
		STRSHOW <,,,offset Assign_To_Str>
		db	0
DMA1_Str	db	'DMA-1 '
		STRSHOW <,,,offset Assign_To_Str>
		db	0
DMA3_Str	db	'DMA-3 '
		STRSHOW <,,,offset Assign_To_Str>
		db	0
DMA5_Str	db	'DMA-5 '
		STRSHOW <,,,offset Assign_To_Str>
		db	0
DMA6_Str	db	'DMA-6 '
		STRSHOW <,,,offset Assign_To_Str>
		db	0
DMA7_Str	db	'DMA-7 '
		STRSHOW <,,,offset Assign_To_Str>
		db	0
Bus_Var 	db	'PCI/ISA PnP', 0
		db	'Legacy ISA ', 0

Show_PnP_Auto1	Proc	Near
		mov	di, offset IrqDma_Item_Tbl
		xor	cx, cx
		call	If_CX_Then_Dis
		ret
Show_PnP_Auto1	Endp

IrqDma_Item_Tbl:
		dw	offset Irq3_Item
		dw	offset Irq4_Item
		dw	offset Irq5_Item
		dw	offset Irq7_Item
		dw	offset Irq9_Item
		dw	offset Irq10_Item
		dw	offset Irq11_Item
		dw	offset Irq12_Item
		dw	offset Irq14_Item
		dw	offset Irq15_Item
		dw	offset Dma0_Item
		dw	offset Dma1_Item
		dw	offset Dma3_Item
		dw	offset Dma5_Item
		dw	offset Dma6_Item
		dw	offset Dma7_Item
		dw	-1

		public	IrqItem_Table
IrqItem_Table	label	near
		dw	offset Irq3_Item
		db	3
		dw	offset Irq4_Item
		db	4
		dw	offset Irq5_Item
		db	5
		dw	offset Irq7_Item
		db	7
		dw	offset Irq9_Item
		db	9
		dw	offset Irq10_Item
		db	10
		dw	offset Irq11_Item
		db	11
		dw	offset Irq12_Item
		db	12
		dw	offset Irq14_Item
		db	14
		dw	offset Irq15_Item
		db	15
		dw	-1

		public	DmaItem_Table
DmaItem_Table	label	near
		dw	offset Dma0_Item
		db	0
		dw	offset Dma1_Item
		db	1
		dw	offset Dma3_Item
		db	3
		dw	offset Dma5_Item
		db	5
		dw	offset Dma6_Item
		db	6
		dw	offset Dma7_Item
		db	7
		dw	-1

endif;	NEW_PNP_SETUP

ifdef	PNP_PCI_AUTO
PnP_Auto_Str		db	'PnP BIOS Auto-Config    : ', 0
endif	;PNP_PCI_AUTO

PCI_Trigger_Str:	db	'PCI IRQ Actived By      : ',0
PCI_Trigger_Val:	db	'Edge ',0
			db	'Level',0
PCI_Ide_Irq_Str:	db	'PCI IDE IRQ Map To      : ',0
PCI_Ide_Irq_Val:	db	'PCI-AUTO ',0
			db	'ISA      ',0

ifndef	NEW_PNP_SETUP
 ifdef	CLEAR_ESCD_OPTION
Reset_Escd_Str		db	'Reset Configuration Data: ',0
 endif	;CLEAR_ESCD_OPTION

Irq_Val 		db	'NA',0
			db	'  ',1
			db	'  ',1
			db	'3 ',0
			db	'4 ',0
			db	'5 ',0
			db	'  ',1
			db	'7 ',0
			db	'  ',1
			db	'9 ',0
			db	'10',0
			db	'11',0
			db	'12',0
			db	'  ',1
			db	'14',0
			db	'15',0

PCI_Irq1_Str:		db	'1st Available IRQ       : ',0
PCI_Irq2_Str:		db	'2nd Available IRQ       : ',0
PCI_Irq3_Str:		db	'3rd Available IRQ       : ',0
PCI_Irq4_Str:		db	'4th Available IRQ       : ',0
endif;	NEW_PNP_SETUP

First_Int_Str:		db	' Primary   IDE INT#     : ',0
Second_Int_Str: 	db	' Secondary IDE INT#     : ',0
First_Int_Val:		db	'A',0
			db	'B',0
			db	'C',0
			db	'D',0

ifndef	NO_PCI_IDE_2ND_CONTROL				;R03
ifdef	PCI_IDE_2nd_Channel_Not_At_BF
Second_Ide_Str		db	'PCI IDE 2nd Channel     : ',0
endif	;PCI_IDE_2nd_Channel_Not_At_BF
endif;	NO_PCI_IDE_2ND_CONTROL				;R03


ifndef	ONCHIP_IDE_IN_IOSETUP
ifndef	ONCHIP_IDE_ALWAYS_DISABLE
Int_IDE_Str		db	'Internal PCI/IDE        : ',0
Int_IDE_Val		db	'Disabled ',0
			db	'Primary  ',0
			db	'Secondary',0
			db	'Both     ',0
IDE_bst_Str		db	'IDE Burst Mode          : ',0

Show_5513ide		Proc	Near
		mov	di,offset _5513_Items_Tbl
		xor	cx,cx
		call	If_CX_Then_Dis
		clc
		ret
Show_5513ide		Endp

_5513_Items_Tbl:
		dw	offset IDE_bst_Item
		dw	offset IdeA_Mode_Item
		dw	offset IdeB_Mode_Item
		dw	offset IdeC_Mode_Item
		dw	offset IdeD_Mode_Item
;R02 - start
ifdef	Ultra_DMA33_support
		dw	offset IdeA_Sdma_Item
		dw	offset IdeB_Sdma_Item
		dw	offset IdeC_Sdma_Item
		dw	offset IdeD_Sdma_Item
endif	;Ultra_DMA33_support
;R02 - end
		dw	-1

endif	;ONCHIP_IDE_ALWAYS_DISABLE
IDEport_post_Str	db	'IDE Data Port Post Write: ',0
endif	;ONCHIP_IDE_IN_IOSETUP


Show_PCI_IDE_IRQ	Proc	Near
		mov	di,offset IDE_INT_Item_Tbl
		mov	cx,1
		call	If_CX_Then_Dis
		clc
		ret

IDE_INT_Item_Tbl:
		dw	offset First_IDE_INT
		dw	offset Second_IDE_INT
		dw	-1
Show_PCI_IDE_IRQ	Endp

PCI_Auto_String db	0

ifdef	PNP_PCI_AUTO
Show_PnP_Auto	Proc	near
		mov	di,offset PnP_Item_Table
		mov	cx,1
		call	If_CX_Then_Dis
		clc
		ret
Show_PnP_Auto	endp

PnP_Item_Table	label	word
		dw	offset PCI_IRQ1
		dw	offset PCI_IRQ2
		dw	offset PCI_IRQ3
		dw	offset PCI_IRQ4
		dw	-1
endif	;PNP_PCI_AUTO

FCODE		ENDS
		END
