;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;
;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;--------------------------2A5II---------------------------------------------
;R02	10/02/97 JKY	change software smi transform to purpose smi 
;			def : softsmi_to_purposex2
;R01	03/14/97 LRY	Support 5597 APC power off
;R00	01/07/97 LRY	Initial version
.386p
		PAGE	56,132
		TITLE	CHIPSET  -- 386/486 EISA/ISA ROM/BIOS

		include BIOS.CFG
		include COMMON.MAC
		include COMMON.EQU
		include POST.MAC
		include BSETUP.INC
		include CMOS.EQU
		include 8042.EQU
A8259		=	20H			; first 8259
B8259		=	0A0H			; second (slave) 8259
END_OF_INT	=	20H			; end of interrupt code

ifdef	PM_SUPPORT
		extrn	GetItem_Value:Near
		extrn	Get_Ct:near
		extrn	Set_Ct:near
		extrn	Get_Set_Ct:near
endif	;PM_SUPPORT

;[]--------------------------------------------------------------------------[]
; Power Management registers definition for SIS/551X
;[]--------------------------------------------------------------------------[]

RSM		MACRO
		db     0FH,0AAH 	; Not defined in MASM.
		ENDM

FIXOFST 	MACRO	ADDRESS
		dw	offset ADDRESS - offset SMI_Handler_Start
		ENDM

READ_PCI	MACRO	PORT
		mov	dx,0cf8H		;configuration index
		mov	ax,8000H
		shl	eax,16
		mov	ax,PORT
		out	dx,eax
		add	dl,4
		in	eax,dx
		ENDM

;[]-----------------------------------------------------------------------[]
;     GGGGGGGG		   RRRRRRRR	    AA	     MMM       MMM
;   GGGGGGGGGGG 	   RRRRRRRRR	   AAAA      MMMMM   MMMMM
;  GGGG 		   RRR	  RRR	  AAAAAA     MMMMMM MMMMMM
;  GGG	  GGGGG 	   RRRRRRRRR	 AAA  AAA    MMM MMMMM MMM
;  GGGG     GGGG	   RRRRRRRR	AAAAAAAAAA   MMM MMMMM MMM
;   GGGGGGGGGGGG	   RRR	 RRR   AAAAAAAAAAAA  MMM  MMM  MMM
;    GGGGGGGGGG  ========  RRR	  RRR AAA	 AAA MMM  MMM  MMM
;[]-----------------------------------------------------------------------[]
G_RAM		SEGMENT USE16 AT 0

		ORG	04H*4
		include SEG_0.INC

		ORG	400H
		include G_RAM.INC

G_RAM		ENDS


ifdef	Notebook_Power_Management
SM_RAM		SEGMENT USE16 AT 0
		INCLUDE SM_RAM.INC
SM_RAM		ENDS
endif	;Notebook_Power_Management

SMI_STRUCT	STRUC
		dd	?
_SpSave 	dw	1 dup (?)
_EspSave	dd	1 dup (?)
_EaxSave	dd	1 dup (?)
_EbxSave	dd	1 dup (?)
_Cr2Save	dd	1 dup (?)
_Cr3Save	dd	1 dup (?)
_Gdt		dq	1 dup (0)
		dw	1 dup (?)
		dw	1 dup (?)
		db	1 dup (?)
		db	1 dup (?)
		db	1 dup (?)
		db	1 dup (?)
		dw	1 dup (?)
		dw	1 dup (?)
		db	1 dup (?)
		db	1 dup (?)
		db	1 dup (?)
		db	1 dup (?)
_DsSave 	dt	1 dup (?)
_EsSave 	dt	1 dup (?)
_SsSave 	dt	1 dup (?)
_FsSave 	dt	1 dup (?)
_GsSave 	dt	1 dup (?)
_LdtSave	dt	1 dup (?)
_TskSave	dt	1 dup (?)
_Dstemp 	db	10 dup (?)
_GdtSave	df	1 dup (?)
_GdtNew 	dw	1 dup (?)
		dd	1 dup (?)
_IdtSave	df	1 dup (?)
_RealModeIdt	dw	1 dup (?)
		dd	1 dup (?)
SMI_STRUCT	ENDS

ifdef	PM_SUPPORT

;[]-----------------------------------------------------------------------[]
;  PPPPPPPPP  MMM	MMM	  RRRRRRRR	   AA	    MMM       MMM
;  PPP	  PPP MMMMM   MMMMM	  RRRRRRRRR	  AAAA	    MMMMM   MMMMM
;  PPPPPPPPP  MMMMMM MMMMMM	  RRR	 RRR	 AAAAAA     MMMMMM MMMMMM
;  PPPPPPPP   MMM MMMMM MMM	  RRRRRRRRR	AAA  AAA    MMM MMMMM MMM
;  PPP	      MMM MMMMM MMM	  RRRRRRRR     AAAAAAAAAA   MMM MMMMM MMM
;  PPP	      MMM  MMM	MMM	  RRR	RRR   AAAAAAAAAAAA  MMM  MMM  MMM
;  PPP	      MMM  MMM	MMM ===== RRR	 RRR AAA	AAA MMM  MMM  MMM
;[]-----------------------------------------------------------------------[]
PM_RAM		SEGMENT USE16 AT 0

		ORG	0

PM_RAM_START	LABEL	BYTE

		include PM_RAM.INC
		include CT_PMRAM.INC

PM_RAM_LEN	EQU	$-Offset PM_RAM:PM_RAM_START

PM_RAM		ENDS
endif	;PM_SUPPORT

DGROUP		GROUP	FCODE
FCODE		SEGMENT USE16 DWORD Public 'CODE'
		ASSUME	CS:DGROUP

ifdef	PM_SUPPORT
;[]-------------------------------------------------------------------[]
;
; PPPPPPPP	 AA	  RRRRRRRR   TTTTTTTTTTT	       111
; PPPPPPPPP	AAAA	  RRRRRRRRR  TTTTTTTTTTT    ***       1111
; PPP	 PPP   AAAAAA	  RRR	 RRR	 TTT	    ***      11111
; PPPPPPPPP   AAA  AAA	  RRRRRRRRR	 TTT		       111
; PPPPPPPP   AAAAAAAAAA   RRRRRRRR	 TTT	    ***        111
; PPP	    AAAAAAAAAAAA  RRR	RRR	 TTT	    ***        111
; PPP	   AAA	      AAA RRR	 RRR	 TTT		       111
;
;
;   1. Standard routines that must be filled in to let the BIOS KERNAL
;      to program the PMU registers
;   2. Called during POST & after POST
;
;[]-------------------------------------------------------------------[]

;[]========================================================================[]
;
; Get_PMU:
;
;	Reads a value from the PM registers.
;
; Entry: CL/CX	Register to read (AL if RIS = 0, AX if RIS = 1)
; Exit:  AL/AX	Value read (BL if RVS = 0, BX if RVS = 1)
;
; Destory: AX,DX
;
;[]========================================================================[]
		Public	Get_PMU
Get_PMU 	Proc	Near
		jmp	Get_Ct
Get_PMU 	Endp

;[]========================================================================[]
;
; Set_PMU:
;
;	Changes a value in the PM registers.
;
; Entry: CL/CX	Register to read (AL if RIS = 0, AX if RIS = 1)
;	 AL/AX	Value to write (BL if RVS = 0, BX if RVS = 1)
;
; Exit:  NONE
;
; Destory : AX,DX
;
;[]========================================================================[]
		Public	Set_PMU
Set_PMU 	Proc	Near
		jmp	Set_Ct
Set_PMU 	Endp

;[]==============================================================[]
;Read one PMU register value and set it back
;Input : CL - register index
;	 BH - value to OR with
;	 BL - value to AND with
;Output: none
;[]==============================================================[]
		public	Get_Set_PMU
Get_Set_PMU	proc	near
		jmp	Get_Set_Ct
Get_Set_PMU	endp

;[]========================================================================[]
;Procedure:	Get_PM_RAM_Seg
;
;Function :	To obtain the extended BIOS data area segment address.
;
;Input	  :	None
;
;Output   :	AX: should point to the extended BIOS data area
;
;Note	  :	1. Call from POST 79S (PM initialization)
;		2. Stack available
;[]========================================================================[]
		Public	Get_PM_RAM_Seg
Get_PM_RAM_Seg	Proc	Near

		mov	ax,PM_RAM_SEGMENT
		ret

Get_PM_RAM_Seg	Endp

;[]========================================================================[]
;Procedure:	Open_PM_RAM
;
;Function :	To enable the PM RAM read/write
;
;Input	  :	None
;
;Output   :	None
;
;Preserve :	All
;
;Note	  :	1. Stack available
;		2. called from PM_Init & APM
;[]========================================================================[]
		Public	Open_PM_RAM
Open_PM_RAM	Proc	Near
		pusha
		mov	cx,76h
		mov	bx,20DFh
		call	Get_Set_PMU
		popa
		ret
Open_PM_RAM	Endp

;[]========================================================================[]
;Procedure:	Close_PM_RAM
;
;Function :	To close PM RAM
;		(Normally, PM_RAM is located in shadow RAM)
;
;Input	  :	AL = 1 --> there is option ROM in the PM_RAM area
;		     0 --> there is no option ROM in the PM_RAM area
;
;Output   :	if input AL = 1
;
;		   switch the PM_RAM area back to ROM
;
;		if input AL = 0
;
;		   program this area into read-only mode
;
;Preserve :	All
;
;Note	  :	1. Stack available
;		2. called from PMI_Handler, PM_Init
;[]========================================================================[]
		Public	Close_PM_RAM
Close_PM_RAM	Proc	Near
		pusha
		mov	cx,76h
		mov	bx,00DFh
		call	Get_Set_PMU
		popa
		ret
Close_PM_RAM	Endp

;[]-------------------------------------------------------------------[]
;
; PPPPPPPP	 AA	  RRRRRRRR   TTTTTTTTTTT	       33333
; PPPPPPPPP	AAAA	  RRRRRRRRR  TTTTTTTTTTT    ***       333 333
; PPP	 PPP   AAAAAA	  RRR	 RRR	 TTT	    *** 	  333
; PPPPPPPPP   AAA  AAA	  RRRRRRRRR	 TTT			33333
; PPPPPPPP   AAAAAAAAAA   RRRRRRRR	 TTT	    *** 	  333
; PPP	    AAAAAAAAAAAA  RRR	RRR	 TTT	    ***       333 333
; PPP	   AAA	      AAA RRR	 RRR	 TTT		       33333
;
;	   Hooks to the real mode APM functions
;
;[]-------------------------------------------------------------------[]

;[]========================================================================[]
;Procedure:	Ct_Check_If_LowBat
;
;Function :	Tell BIOS whether the machine is in LOW BATTERY status
;
;Input	  :	DS = PM_RAM
;
;Output   :	if AC on line
;			BH =	01h
;			BL =	FFh
;
;		if AC off line
;			BH =	00h
;
;			BL =	00h ---> Battery Good
;			BL =	01h ---> Battery Low
;
;Note	  :	Stack available
;[]========================================================================[]
		ASSUME	DS:PM_RAM
		Public	Ct_Check_If_LowBat
Ct_Check_If_LowBat	Proc	Near
		mov	bx,1FFh 		;assume AC power
		ret
Ct_Check_If_LowBat	Endp

;[]========================================================================[]
;Procedure:	Ct_APM_Func01
;
;Function :	To do OEM specific functions when APM is connected
;
;Input	  :	DS = PM_RAM
;
;Saves	  :	all
;
;[Note] :	1. This routine will be called "ONLY" when APM fucntion 01
;		   is successful, i.e. APM successfully connected
;
;		2. Function spec. of the APM function 01
;		   (Interface connect)
;
;		   Input  : DS = PM_RAM
;			    AH = 53h
;			    AL = 01h
;			    BX = 0000h - system BIOS
;
;		   Output : if function successful:
;				carry = 0 (NC)
;			    if function unsuccessful:
;				carry = 1 (CY)
;				ah = eoror code
;					02h interface connect
;					    already in effect
;					09h unrecognized device ID
;[]========================================================================[]
		ASSUME	DS:PM_RAM
		Public	Ct_APM_Func01
Ct_APM_Func01	Proc	Near

		ret

Ct_APM_Func01	Endp

;[]========================================================================[]
;Procedure:	Ct_APM_Func04
;
;Function :	To do OEM specific functions when APM is disconnected
;
;Input	  :	DS = PM_RAM
;
;Saves	  :	all
;
;[Note]   :	1. This routine will be called "ONLY" when APM fucntion 04
;		   is successful, i.e. APM successfully disconnected
;
;		2. Function spec. of the APM function 04
;		   (Interface disconnect)
;
;		   Input:
;			ah = 53h
;			al = 04h
;			bx = 0000h - system BIOS
;			DS = PM_RAM
;
;		   Output:
;			if function successful:
;				carry = 0 (NC)
;
;			if function unsuccessful:
;				carry = 1 (CY)
;				ah = error code
;				03h = interface not connected
;				09h = unrecognized device ID
;
;[]========================================================================[]
		ASSUME	DS:PM_RAM
		Public	Ct_APM_Func04
Ct_APM_Func04	Proc	Near

		ret

Ct_APM_Func04	Endp

;[]========================================================================[]
;Procedure:	Ct_APM_Func05
;
;Function :	Set power state into DOZE mode
;
;Input	  :	DS = PM_RAM
;
;Output   :	None
;
;[Note]   :	1. This routine will be called "ONLY" when APM fucntion 05
;		   is successful, i.e. APM is going to put system into
;		   idle state
;
;		2. Function spec. of the APM function 05
;		   (CPU Idle call)
;
;		   Input    :	DS = PM_RAM
;				AH = 53h
;				AL = 05h
;
;		   Output   :	CF - Error
;				     AH = 03h Interface not connected
;				NC - Success
;
;[]========================================================================[]
		ASSUME	DS:PM_RAM
		public	Ct_APM_Func05
Ct_APM_Func05	Proc	Near
		mov	al,[PM_TimeOut_Type]
		inc	al
		call	_Software_SMI
		ret
Ct_APM_Func05	Endp

;[]========================================================================[]
;Procedure:	Ct_APM_Func06
;
;Function :	Set power state into Full On mode
;
;Input	  :	DS = PM_RAM
;
;Output   :	None
;
;[Note]   :	1. This routine will be called "ONLY" when APM fucntion 06
;		   is successful, i.e. APM is going to put system into
;		   full-on state
;
;		2. Function spec. of the APM function 06
;		   (CPU Busy Call)
;
;		   Input    :	AH = 53h
;				AL = 06h
;
;		   Output   :	CF - Error
;				     AH = 03h Interface not connected
;				NC - Success
;
;[]========================================================================[]
		ASSUME	DS:PM_RAM
		public	Ct_APM_Func06
Ct_APM_Func06	Proc	Near
		ret
Ct_APM_Func06	Endp

;[]========================================================================[]
;[]========================================================================[]
		ASSUME	DS:PM_RAM
		PUBLIC	APM_16_SUSPEND
APM_16_SUSPEND	Proc	NEAR
ifndef	softsmi_to_purposex2		;R02
		mov	al,4		; Software Suspend
		call	_Software_SMI
;R02 - start
else	;softsmi_to_purposex2
		mov	dx,611ch	
		in	ax,dx		
		and	ah,0e7h		
		out	dx,ax		
		
		mov	dx,6116h	
		in	ax,dx		
		or	ah,20h		
		out	dx,ax		

		mov	dx,6113h	
		in	ax,dx		
		or	ah,0ffh		
		out	dx,ax		
endif	;softsmi_to_purposex2
;R02 - end
		ret
APM_16_SUSPEND	Endp

;[]========================================================================[]
;[]========================================================================[]
		Public	APM_16_Standby
APM_16_Standby	Proc	Near
		ret
APM_16_Standby	Endp

;[]========================================================================[]
;Input: 	CF = 1 default no power off supported
;Output:	if no power off supported, just return.
;		else
;			CF = 1 power off fail
;			CF = 0 power off successful
;[]========================================================================[]
		Public	APM_16_PowerOff
APM_16_PowerOff Proc	Near
ifdef	PowerOff_By_KB_Pin
 ifdef	HIGH_LEVEL_POWER_OFF				
		mov	al,0BAh+(PowerOff_By_KB_Pin-29)
 else;	HIGH_LEVEL_POWER_OFF				
		mov	al,0B2h+(PowerOff_By_KB_Pin-29)	
 endif;	HIGH_LEVEL_POWER_OFF				
		out	64h,al
		IODELAY
		in	al,60h
		IODELAY
ANOTHER_POWER_OFF	EQU	1			;R01
endif	;PowerOff_By_KB_Pin

;R01 - start
ifndef	ANOTHER_POWER_OFF
		mov	cx,869h
		mov	bx,10FFh
		call	Get_Set_PMU
endif	;ANOTHER_POWER_OFF
;R01 - end
		ret
APM_16_PowerOff Endp

ifndef	NO_SUPPORT_APM12
		Public	CT_APM_FUNC10
CT_APM_FUNC10	Proc	Near
		ret
CT_APM_FUNC10	Endp
endif	;NO_SUPPORT_APM12

;[]========================================================================[]
;[]========================================================================[]
		ASSUME	DS:PM_RAM
		PUBLIC	Software_SMI
Software_SMI	proc	near

		push	PM_RAM_SEGMENT
		pop	ds

ifdef	NoteBook_Power_Management
		cmp	PM_RAM:Software_SMI_Type,0
		je	short _Not_Kernal_SMI
		mov	al,PM_RAM:Software_SMI_Type
_Not_Kernal_SMI:
endif	;NoteBook_Power_Management
_Software_SMI:
	; Set software SMI byte

		mov	PM_RAM:Software_SMI_Byte,al


	; Force SMI

		call	Issue_SW_SMI

		ret
Software_SMI	endp

		public	Issue_SW_SMI
Issue_SW_SMI	proc	near

;Issue software SMI

		mov	cx,9Bh		;enable SW SMI
		mov	bx,01FFh
		call	Get_Set_PMU

		mov	cl,93h		;generate software SMI
		mov	bx,00FDh
		call	Get_Set_PMU
		mov	bh,02h
		call	Get_Set_PMU

		mov	cx,100h 	;wait for software SMI
		loop	short $

		ret
Issue_SW_SMI	endp


endif	;PM_SUPPORT

		Public	PM_Before_HDD
PM_Before_HDD	Proc	Near
PM_Before_HDD	Endp

		Public	PM_After_HDD
PM_After_HDD	Proc	Near
PM_After_HDD	Endp

		Public	PM_Before_FDD
PM_Before_FDD	Proc	Near
PM_Before_FDD	Endp

		Public	PM_After_FDD
PM_After_FDD	Proc	Near
PM_After_FDD	Endp

		Public	PM_Before_PS2_Mouse
PM_Before_PS2_Mouse	Proc	Near
PM_Before_PS2_Mouse	Endp

		Public	PM_After_PS2_Mouse
PM_After_PS2_Mouse	Proc	Near
		ret
PM_After_PS2_Mouse	Endp

FCODE		ENDS
		END
