;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;
		PAGE	60,132
		TITLE	PNPCHIP  -- Plug and Play Chipset Interface
;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;--------------------------2A5II---------------------------------------------
;R06	05/23/97 RCH	Kill unused codes to save ROM space
;R05	05/13/97 AVN	If USB support must always enable PS2 mode for set
;			keyboard command correct.
;R04	05/12/97 JKY	Added CARDBUS support
;R03	04/30/97 JKY	Special support : flash write protect used GPIO0 
;			'h' active. def : FLASH_WP_USE_GPIO0 & GPIO0_H_ACTIVE
;R02	04/01/97 LRY	Added B version internal KBC support
;R01	03/14/97 LRY	Support 'ACPI_BASE_ADDR_PATCH' default
;R00	01/07/97 LRY	Initial version

.386P

.XLIST
;[]========================================================================[]
;
;	Include file definition
;
;[]========================================================================[]

		INCLUDE BIOS.CFG
		INCLUDE COMMON.MAC
		INCLUDE PNP.EQU
ACPI_BASE_ADDR_PATCH	EQU	1		;R01
;GR05 - start
SKIP_108_10F	=	0
SKIP_250_257	=	0

 ifdef	UMC_8663
SKIP_108_10F	=	1
 endif; UMC_8663
 ifdef	UMC_8669
SKIP_108_10F	=	1
 endif; UMC_8669
 ifdef	SMC669_N_UMC_8669
SKIP_108_10F	=	1
 endif;	SMC669_N_UMC_8669

 ifdef	W83787F
SKIP_250_257	=	1
 endif; W83787F
 ifdef	W83877F
SKIP_250_257	=	1
 endif; W83877F
;GR05 - end
;GR05;Rcc - start
;GR05
;GR05SKIP_108_10F	=	0FFH
;GR05SKIP_250_257	=	0FFH
;GR05
;GR05 ifdef	UMC_8663
;GR05SKIP_108_10F	=	(NOT 02H)
;GR05 endif;	UMC_8663
;GR05 ifdef	UMC_8669
;GR05SKIP_108_10F	=	(NOT 02H)
;GR05 endif;	UMC_8669
;GR05
;GR05 ifdef	W83787F
;GR05SKIP_250_257	=	(NOT 04H)
;GR05 endif;	W83787F
;GR05 ifdef	W83877F
;GR05SKIP_250_257	=	(NOT 04H)
;GR05 endif;	W83877F
;GR05
;GR05;Rcc - end
.LIST

;[]========================================================================[]
;
;	External label definition
;
;[]========================================================================[]

ifdef	PNP_BIOS
		EXTRN	SYSTEM4_BYTE:byte
		EXTRN	Dummy_Set_Node:near
		extrn	Record_IO_Map:near	;GR01
		EXTRN	Record_IRQ_Map:near
ifdef	PCI_BUS
ifdef	NEW_PCI_KERNEL
		extrn	LMEM_RESOURCE:ABS
		extrn	LMEM_BEFORE_ROM:ABS	;GR04
		extrn	PCI_IRQ_ASSIGNED:ABS
else	;NEW_PCI_KERNEL
		EXTRN	Get_CfgSpace_Word:near	;PCI1A.ASM
		EXTRN	Get_CfgSpace_Byte:near	;PCI1A.ASM
endif	;NEW_PCI_KERNEL
endif	;PCI_BUS
endif	;PNP_BIOS

;[]========================================================================[]
;
;	Low memory init (1st 64k)
;
;[]========================================================================[]

G_RAM		SEGMENT USE16 AT 0

		ORG	04H*4
		INCLUDE SEG_0.INC

		ORG	400H
		INCLUDE G_RAM.INC

		ORG	2000h
		INCLUDE PNPDATA.INC

		ORG	7C00H
BOOT		LABEL	FAR

G_RAM		ENDS

CONFIG_ADDR	EQU	0CF8h
CT_INDEX	EQU	22H
CT_DATA 	EQU	23H
ifdef	COMPRESS_CODE
		extrn	Get_Cmos:near		;R06
		extrn	Set_Cmos:near		;R06
		extrn	Post_call_proc:near
		extrn	Get_Ct:Near
		extrn	Set_Ct:Near
		extrn	Get_Set_Ct:Near
	ifdef	PM_SUPPORT
		extrn	Open_PM_RAM:near
		extrn	Close_PM_RAM:near
	endif	;PM_SUPPORT

ifdef	Flash_By_KB_Pin
		extrn	OUT_8042_FULL:near
endif	;Flash_By_KB_Pin
DGROUP		GROUP	FCODE
FCODE		SEGMENT USE16 PARA PUBLIC 'CODE'
		ASSUME	CS:DGROUP,DS:NOTHING
else	;COMPRESS_CODE
		extrn	F000_func_end:Near
		extrn	F000_VECT:Near
EGROUP		GROUP	ECODE
ECODE		SEGMENT USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP,DS:NOTHING
endif	;COMPRESS_CODE

IFDEF	PNP_BIOS

;[]========================================================================[]
;
;	Plug and Play BIOS customize definition
;
;[]========================================================================[]

;GR05PNP_DEF1_VALUE	=	0
;GR05
;GR05ifdef	NVRAM_SUPPORT
;GR05PNP_DEF1_VALUE	=	PNP_DEF1_VALUE + NVRAM_FLAG
;GR05endif	;NVRAM_SUPPORT
;GR05
;GR05ifdef	CMOS_RAM_SUPPORT
;GR05PNP_DEF1_VALUE	=	PNP_DEF1_VALUE + CMOS_RAM_FLAG
;GR05endif	;CMOS_RAM_SUPPORT
;GR05
;GR05ifdef	FLASH_SUPPORT
;GR05PNP_DEF1_VALUE	=	PNP_DEF1_VALUE + FLASH_FLAG
;GR05endif	;FLASH_SUPPORT
;GR05
;GR05ifdef	DALLAS_NVM
;GR05PNP_DEF1_VALUE	=	PNP_DEF1_VALUE + DALLAS_FLAG
;GR05endif	;DALLAS_NVM
;GR05
;GR05ifdef	ESCD_SUPPORT
;GR05PNP_DEF1_VALUE	=	PNP_DEF1_VALUE + ESCD_FLAG
;GR05endif	;ESCD_SUPPORT
;GR05
;GR05		public	PNP_DEF_TBL	;used in ATORGS.ASM
;GR05		public	PNP_DEF1
;GR05		ALIGN	16
;GR05PNP_DEF_TBL	label	byte
;GR05		db	"$AWD_PNP"      ;signature (for MODBIN distinguish)
;GR05		db	PNP_INT_VER	;Award PnP internal version
;GR05PNP_DEF1	db	PNP_DEF1_VALUE	;miscellaneous PnP definition
;GR05					;detail bit definition in PNP.EQU
;GR05ifdef	COMPRESS_CODE
;GR05		dw	offset DGROUP:DEF_SYSTEM_MAP
;GR05
;GR05else	;COMPRESS_CODE
;GR05		dw	offset EGROUP:DEF_SYSTEM_MAP
;GR05
;GR05endif	;COMPRESS_CODE

;[]========================================================================[]
;
;	Default System Resource Map
;
;[]========================================================================[]

;GR05 - start
		public	DEF_IRQ_MAP
		public	DEF_DMA_MAP
		public	DEF_IO_MAP
		public	DEF_IO_MAP_L
DEF_IRQ_MAP	dw	1101111011111000b
DEF_DMA_MAP	db	11101111b
DEF_IO_MAP	label	byte
		dwb	3B0h, 30h		;3B0-3DF
	IF	SKIP_108_10F
		dwb	108h, 08h		;108-10F
	ENDIF	;SKIP_108_10F
	IF	SKIP_250_257
		dwb	250h, 08h		;250-257
	ENDIF	;SKIP_250_257
DEF_IO_MAP_L	equ	($ - DEF_IO_MAP)/3
;GR05 - end
;GR05		public	DEF_SYSTEM_MAP
;GR05		public	DEF_SYSTEM_MAP_L
;GR05DEF_SYSTEM_MAP	label	byte
;GR05
;GR05
;GR05DEF_IRQ_MAP	dw	1001111011111000b
;GR05DEF_DMA_MAP	db	11101111b
;GR05DEF_IO_MAP label	byte
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05; Skiped I/O port:
;GR05;	1F0 - 1F8	Primary IDE
;GR05;	370 - 378	Seconday IDE
;GR05;	3B0 - 3BF	Display adapter
;GR05;	3C0 - 3DF	VGA
;GR05;	3F0 - 3F8	Floppy
;GR05
;GR05		db	0FFH AND SKIP_108_10F	;100-13F
;GR05;Rcc ifdef UMC_8663
;GR05;Rcc		db	11111101b	;100 - 13F
;GR05;Rcc else	;UMC_8663
;GR05;Rcc		db	11111111b	;100 - 13F
;GR05;Rcc endif ;UMC_8663
;GR05		db	11111111b	;140 - 17F
;GR05		db	11111111b	;180 - 1BF
;GR05
;GR05		db	11111111b	;1C0 - 1FF
;GR05		db	11111111b	;200 - 23F
;GR05		db	0FFH AND SKIP_250_257	;240-27F	;Rcc
;GR05;Rcc ifdef W83787F
;GR05;Rcc		db	11111011b	;240 - 27F
;GR05;Rcc else	;W83787F
;GR05;Rcc		db	11111111b	;240 - 27F
;GR05;Rcc endif ;W83787F
;GR05		db	11111111b	;280 - 2BF
;GR05		db	11111111b	;2C0 - 2FF
;GR05		db	11111111b	;300 - 33F
;GR05
;GR05		db	11111111b	;340 - 37F
;GR05		db	00111111b	;380 - 3BF
;GR05
;GR05		db	11110000b	;3C0 - 3FF
;GR05
;GR05
;GR05		db	11111111b	;400 - 43F
;GR05		db	11111111b	;440 - 47F
;GR05		db	11111111b	;480 - 4BF
;GR05		db	11111111b	;4C0 - 4FF
;GR05		db	11111111b	;500 - 53F
;GR05		db	11111111b	;540 - 57F
;GR05		db	11111111b	;580 - 5BF
;GR05		db	11111111b	;5C0 - 5FF
;GR05		db	11111111b	;600 - 63F
;GR05		db	11111111b	;640 - 67F
;GR05		db	11111111b	;680 - 6BF
;GR05		db	11111111b	;6C0 - 6FF
;GR05		db	11111111b	;700 - 73F
;GR05		db	11111111b	;740 - 77F
;GR05		db	11111111b	;780 - 7BF
;GR05		db	11111111b	;7C0 - 7FF
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05
;GR05DEF_IO_MAP_L		EQU	$ - DEF_IO_MAP
;GR05DEF_SYSTEM_MAP_L	EQU	$ - DEF_SYSTEM_MAP

;[]========================================================================[]
;
;	READ_DATA port available, these values can be modified by MODBIN
;
;[]========================================================================[]


;[]========================================================================[]
;
;	CHIPSET DEVICE NODES DEFINITION
;
;[]========================================================================[]

		PUBLIC	CHIP_NODE
CHIP_NODE	LABEL	BYTE

;DEV_NODE	wMF_CODE, wPRODUCT_ID, dDEV_TYPE, bDEV_ATTR
;	MEM_DSP 	bMEM_INFO, dMEM_MIN, dMEM_MAX, wMEM_ALIGN, dMEM_LEN
;	MEM32_DSP	bMEM_INFO, dMEM_MIN, dMEM_MAX, dMEM_ALIGN, dMEM_LEN
;	FMEM32_DSP	bMEM_INFO, dMEM_BASE, dMEM_LEN
;	IO_DSP		bIO_INFO, wIO_MIN, wIO_MAX, bIO_ALIGN, bIO_LEN
;	FIO_DSP 	wIO_BASE, bIO_LEN
;	IRQ_DSP 	wIRQ_MASK, [bIRQ_TYPE]
;	DMA_DSP 	bDMA_CH, bDMA_INFO
;	END_DSP
;	END_DSP
;	END_DSP

ifdef	ACPI_BASE_ADDR_PATCH					;R01
; Mother board resource device node				;R01
DEV_NODE	41D0H, 0C02H, 088000H, 00000011B, MB_NODE	;R01
 ifdef	NO_RELEASE_IRQ12					;R01
	IRQ_DSP 	0001000000000000B			;R01
 endif	;NO_RELEASE_IRQ12					;R01
	IO_DSP	     1, 6100h, 6100h, 0, 40h			;R01
	END_DSP							;R01
	END_DSP							;R01
	END_DSP							;R01
DEV_NODE_END							;R01
else	;ACPI_BASE_ADDR_PATCH					;R01
 ifdef	NO_RELEASE_IRQ12
; Mother board resource device node
DEV_NODE	41D0H, 0C02H, 088000H, 00000011B, MB_NODE
	IRQ_DSP 	0001000000000000B
	END_DSP
	END_DSP
	END_DSP
DEV_NODE_END
 endif	;NO_RELEASE_IRQ12
endif	;ACPI_BASE_ADDR_PATCH					;R01

;R04 - start
ifdef	CARDBUS_USE_LAGECY
AT_PCMCIA_NODE	LABEL	NEAR
DEV_NODE	41D0H, 0E03H, 060500H, 010000000B, PCMCIA_NODE
	DB		82h, 09h, 00
	DB		"AT PCMCIA"
	FIO_DSP		3E0h,02h
	END_DSP

	END_DSP
	db	1Ch,41h,0D0h,0Eh,00h
	END_DSP
DEV_NODE_END
endif	;CARDBUS_USE_LAGECY
;R04 - end


		PUBLIC	CHIP_NODE_INDEX
CHIP_NODE_INDEX LABEL	BYTE
		DB	CHIP_NODES_NUM
;R04 - start
ifdef	CARDBUS_USE_LAGECY
 		SET_NODE_INDEX	PCMCIA_NODE, 00001000B
endif	;CARDBUS_USE_LAGECY
;R04 - end
ifdef	ACPI_BASE_ADDR_PATCH					;R01
		SET_NODE_INDEX	MB_NODE, 00001000B		;R01
else	;ACPI_BASE_ADDR_PATCH					;R01
 ifdef	NO_RELEASE_IRQ12
		SET_NODE_INDEX	MB_NODE, 00001000B
 endif	;NO_RELEASE_IRQ12
endif	;ACPI_BASE_ADDR_PATCH					;R01
CHIP_NODES_NUM	EQU	($ - CHIP_NODE_INDEX - 1)/3

		PUBLIC	CHIP_NODE_PROC
CHIP_NODE_PROC	LABEL	BYTE
;R04 - start
ifdef	CARDBUS_USE_LAGECY
 	NODE_PROC	PCMCIA_NODE, Dummy_Set_Node, Dummy_Set_Node, Ct_PCMCIA_Node
endif	;CARDBUS_USE_LAGECY
;R04 - end
ifdef	ACPI_BASE_ADDR_PATCH							;R01
	NODE_PROC	MB_NODE, Dummy_Set_Node, Dummy_Set_Node, Ct_Mb_Node	;R01
else	;ACPI_BASE_ADDR_PATCH							;R01
 ifdef	NO_RELEASE_IRQ12
	NODE_PROC	MB_NODE, Dummy_Set_Node, Dummy_Set_Node, Ct_Mb_Node
 endif	;NO_RELEASE_IRQ12
endif	;ACPI_BASE_ADDR_PATCH					;R01
		DB	0FFh

		CHK_ATTR	%NODE_NUM

;R04 - start
ifdef	CARDBUS_USE_LAGECY
Ct_PCMCIA_Node	Proc	Near
		clc			
		ret
Ct_PCMCIA_Node	Endp
endif	;CARDBUS_USE_LAGECY
;R04 - end

;[]========================================================================[]
;Procedure:	Ct_PNP_Early_Init
;Function :
;Input	  :	None
;Output   :	None
;Registers:
;Note	  :
;[]========================================================================[]
		public	Ct_PNP_Early_Init
Ct_PNP_Early_Init	proc	near
		ret
Ct_PNP_Early_Init	endp

;[]========================================================================[]
;Procedure:	Ct_ReAlloc_Resource
;Function :	Modify system resource map for OEM usage. (e.g. PCI, EISA...)
;Input	  :	DS:SI = pointer of system resource map
;		BP = stack data pointer at POST
;Output   :	None
;Registers:
;Note	  :
;[]========================================================================[]
		public	Ct_ReAlloc_Resource
Ct_ReAlloc_Resource	proc	near

ifdef	PCI_BUS

ifdef	NEW_PCI_KERNEL

		mov	ax, PCI_IRQ_ASSIGNED[bp]	;each bit: 1=assigned
		not	ax
		and	ds:IRQ_MAP, ax				;GR05
;GR05		and	ds:IRQ_MAP[si], ax

		mov	eax, dword ptr LMEM_RESOURCE[bp]	;GR05
		not	eax					;GR05
		shl	eax, 8					;GR05
		and	dword ptr ds:UMB_MAP, eax		;GR05
;GR05		mov	dx, ds:UMB_MAP[si]
;GR05		not	dx
;GR05
;GR05		and	dx, 0F03h			;reserved C0000-C7FFF
;GR05							;	E0000-EFFFF
;GR05		push	di
;GR05		push	eax
;GR05		mov	eax, 0000000Fh
;GR05		mov	di, 0000000000000100b
;GR05	_KKK_:
;GR05		test	dword ptr LMEM_RESOURCE[bp], eax
;GR05		jz	_III_
;GR05		or	dx, di
;GR05	_III_:
;GR05		shl	di, 1
;GR05		shl	eax, 4
;GR05		test	di,0FF00h
;GR05		jz	short _KKK_
;GR05
;GR05		pop	eax
;GR05		pop	di
;GR05
;GR05		not	dx
;GR05		and	ds:UMB_MAP[si], dx

else	;NEW_PCI_KERNEL

		mov	ch, 0
Scan_PCI_IRQ:
		xor	cl,cl			;Vendor ID
		F000_call Get_CfgSpace_Word

		cmp	ax, -1
		je	short Next_PCI_Slot

		mov	cl,3CH
		F000_call Get_CfgSpace_Byte	;AL = IRQ level

		call	Record_IRQ_Map		;DS:SI=point to resource map
						;AL=IRQ level

		test	ch,07h			;already a multi-function space?
		jnz	short @F		;yes, go point to next function

		mov	cl,0Eh			;read header type
		F000_call Get_CfgSpace_Byte	;read header type

		test	al,80H			;multi-function support?
		jnz	short @F		;yes, multi-function card!
Next_PCI_Slot:
		add	ch,7			;point to next device!
@@:
		add	ch,1			;point to next function space
		jnc	short Scan_PCI_IRQ	;scan slot 0-31

endif	;NEW_PCI_KERNEL

endif	;PCI_BUS

;GR01 - start
ifdef	PC87332
ifdef	PC87332_PORT
		mov	ax, PC87332_PORT
endif	;PC87332_PORT
ifdef	PC87332_ADDR_PORT
		mov	ax, PC87332_ADDR_PORT
endif	;PC87332_ADDR_PORT
		mov	dx, 4
ifdef	COMPRESS_CODE
		extrn	Post_call_proc:Near
		POST_func_call	Record_IO_Map
else	;COMPRESS_CODE
		call	Record_IO_Map
endif	;COMPRESS_CODE
endif	;PC87332
;GR01 - end
		mov	cx, 094Ah
		call	Get_Ct
		test	al, 00000100b
		jz	short @f
		mov	ax, 170h
		mov	dx, 8
		POST_func_call	Record_IO_Map
		mov	ax, 376h
		mov	dx, 1
		POST_func_call	Record_IO_Map
		mov	al, 15
		POST_func_call	Record_IRQ_Map
@@:

		ret

Ct_ReAlloc_Resource	endp

;[]========================================================================[]
;Procedure:	Ct_Record_Resource
;Function :	Let OEM record current resource information
;Input	  :	DS:SI = pointer of system resource map
;		BP = stack data pointer at POST
;Output   :	None
;Registers:
;Note	  :
;[]========================================================================[]
		public	Ct_Record_Resource
Ct_Record_Resource	proc	near

ifdef	PCI_BUS
ifdef	NEW_PCI_KERNEL

		push	eax
		push	G_RAM
		pop	ds

;GR05 - start
;GR07		mov	edx, ds:UMB_MAP
		mov	edx, ds:PNPROM_MAP			;GR07
		not	edx
		mov	eax, 0000000Fh
		mov	edi, 00000F00h
	_KK_:
		test	edx, edi
		jz	_II_
		or	dword ptr LMEM_RESOURCE[bp], eax
		or	dword ptr LMEM_BEFORE_ROM[bp], eax	;GR07
;GR06		or	dword ptr LMEM_BEFORE_ROM[bp], eax
	_II_:
		shl	eax, 4
		shl	edi, 4
		or	edi, edi
		jnz	short _KK_
;GR05 - end
;GR05		mov	dx, word ptr ds:UMB_MAP[si]
;GR05		not	dx
;GR05
;GR05		mov	eax, 0000000Fh
;GR05		mov	di, 0000000000000100b
;GR05	_KK_:
;GR05		test	dx, di
;GR05		jz	_II_
;GR05		or	dword ptr LMEM_RESOURCE[bp], eax
;GR05		or	dword ptr LMEM_BEFORE_ROM[bp], eax	;GR04
;GR05	_II_:
;GR05		shl	di, 1
;GR05		shl	eax, 4
;GR05		test	di,0FF00h
;GR05		jz	short _KK_
		pop	eax

endif	;NEW_PCI_KERNEL
endif	;PCI_BUS

		ret
Ct_Record_Resource	endp

;[]========================================================================[]
;Procedure:	Ct_Get_Resource_Map
;Function :	Get system resource information in storage
;Input	  :	DS:SI = pointer of memory buffer for system resource map
;Output   :	CF = 1 no storage support
;		CF = 0 storage support
;			ZF = 1 valid checksum
;			ZF = 0 invalid checksum
;Registers:
;Note	  :
;[]========================================================================[]
		public	Ct_Get_Resource_Map
Ct_Get_Resource_Map	proc	near

ifndef	ESCD_SUPPORT
ifdef	CMOS_RAM_SUPPORT

		push	si
		xor	dl, dl
		mov	dh, CMOS_RESOURCE
		mov	cx, RESOURCE_LENGTH
	@@:
		mov	al, dh
		call	Get_CMOS1
		mov	ds:[si], al
		add	dl, al
		inc	dh
		inc	si
		loop	short @b
		or	dl, dl
		pop	si
		clc
		jz	short @f
		stc
@@:
		clc
		ret

endif	;CMOS_RAM_SUPPORT
else	;ESCD_SUPPORT

		stc
		ret

endif	;ESCD_SUPPORT

Ct_Get_Resource_Map	endp

;[]========================================================================[]
;Procedure:	Ct_Set_Resource_Map
;Function :	Set system resource information to storage
;Input	  :	ES:DI = pointer of memory buffer for system resource map
;Output   :	CF = 1 no storage support
;		CF = 0 storage support
;Registers:
;Note	  :
;[]========================================================================[]
		public	Ct_Set_Resource_Map
Ct_Set_Resource_Map	proc	near

ifndef	ESCD_SUPPORT
ifdef	CMOS_RAM_SUPPORT
		push	di
		xor	dl, dl
		mov	dh, CMOS_RESOURCE
		mov	cx, RESOURCE_LENGTH - 1
@@:
		mov	ah, es:[di]
		add	dl, ah
		mov	al, dh
		call	Set_CMOS1
		inc	dh
		inc	di
		loop	short @b
		neg	dl
		mov	ah, dl
		mov	al, dh
		call	Set_CMOS1
		pop	di
		clc
		ret
endif	;CMOS_RAM_SUPPORT
else	;ESCD_SUPPORT

		stc
		ret

endif	;ESCD_SUPPORT

Ct_Set_Resource_Map	endp

;[]===========================[]
;[]===========================[]
		Public	Get_CMOS1
Get_CMOS1	Proc	Near
ifdef	COMPRESS_CODE				;R06
		jmp	Get_Cmos		;R06
else;	COMPRESS_CODE				;R06
		out	70h, al
		NEWIODELAY
		in	al, 71h
		NEWIODELAY
endif;	COMPRESS_CODE				;R06
		ret
Get_CMOS1	Endp

;[]===========================[]
;[]===========================[]
		Public	Set_CMOS1
Set_CMOS1	Proc	Near
ifdef	COMPRESS_CODE				;R06
		jmp	Set_Cmos		;R06
else;	COMPRESS_CODE				;R06
		out	70h, al
		NEWIODELAY
		mov	al, ah
		out	71h, al
		NEWIODELAY
endif;	COMPRESS_CODE				;R06
		ret
Set_CMOS1	Endp

;****************************************************************
;*								*
;*	CHIPSET DEPENDENT MODULE TO SUPPORT FLASH ROM		*
;*								*
;****************************************************************

;[]========================================================================[]
;Procedure:	Ct_Buffer_Request
;Function :	Return buffer size request for Ct_Save_Shadow and
;		Ct_Restore_Shadow
;Input	  :	none
;Output   :	AX = size request (word unit)
;Registers:
;Note	  :
;[]========================================================================[]
		public	Ct_Buffer_Request
Ct_Buffer_Request	proc	near
		mov	ax, 3		;3 words request
		ret
Ct_Buffer_Request	endp

;[]========================================================================[]
;Procedure:	Ct_Save_Shadow
;Function :	Save shadow or cache status for restore
;Input	  :	SS:EBP = pointer to stack for saving shadow status
;Output   :	none
;Registers:
;Note	  :
;[]========================================================================[]
		public	Ct_Save_Shadow
Ct_Save_Shadow	proc	near
		pushad

		mov	cx,74h			;E0000h configure register
		call	GetCt_Save

		inc	cx			;then cx=75h
		call	GetCt_Save

		inc	cx			;then cx=76h
		call	GetCt_Save

		mov	cl,93h			;disable deturbo
		call	GetCt_Save
		and	al,not 01h
		call	Set_Ct

		mov	cx,840h 		;E & F segment ROM decode
		call	GetCt_Save

		mov	cl,45h			;flash write
		call	GetCt_Save

;R03 - start
ifdef	FLASH_WP_USE_GPIO0
ifdef	GPIO0_H_ACTIVE
		mov	cx,ACPI_R+18	;GPIO0='h' , flash write enable
		mov	bx,01feh
		call	Get_Set_Ct
endif	;GPIO0_H_ACTIVE
endif	;FLASH_WP_USE_GPIO0
;R03 - end
		popad
		ret
Ct_Save_Shadow	endp

GetCt_Save:
		call	Get_Ct
		mov	[ebp],al
		inc	ebp
		ret

;[]========================================================================[]
;Procedure:	Ct_Restore_FShadow
;Function :	Restore Shadow, cache status
;Input	  :	SS:EBP = pointer to stack for restore shadow status
;			these data are saved by Ct_Save_Shadow
;Output   :	none
;Registers:
;Note	  :
;[]========================================================================[]
		public	Ct_Restore_Shadow
Ct_Restore_Shadow	Proc	near
		pushad

;R03 - start
ifdef	FLASH_WP_USE_GPIO0
ifdef	GPIO0_H_ACTIVE
		mov	cx,ACPI_R+18	;GPIO0='l' , flash write disable
		mov	bx,00feh
		call	Get_Set_Ct
endif	;GPIO0_H_ACTIVE
endif	;FLASH_WP_USE_GPIO0
;R03 - end

		mov	cx,74h			;E0000h configure register
		call	Load_Set_Ct

		inc	cx			;then cx=75h
		call	Load_Set_Ct

		inc	cx			;then cx=76h
		call	Load_Set_Ct

		mov	cl,93h
		call	Load_Set_Ct

		mov	cx,840h 		;E & F segment ROM decode
		call	Load_Set_Ct

		mov	cl,45h
		call	Load_Set_Ct
ifdef	Flash_By_KB_Pin
		mov	al,0BAh+(Flash_By_KB_Pin-29)
		out	64h,al
		call	OUT_8042_FULL
		in	al,60h
		iodelay
endif	;Flash_By_KB_Pin
		popad
		ret
Ct_Restore_Shadow	endp

Load_Set_Ct:
		mov	al,[ebp]
		call	Set_Ct
		inc	ebp
		ret

;[]========================================================================[]
;Procedure:	Ct_Enable_Flash
;Function :	Disable F000 shadow, cache for directory ROM access
;		Enable flash ROM write
;Input	  :	none
;Output   :	none
;Registers:
;Note	  :	Just disable F000h shadow RAM, and E000h shadow RAM must be
;		enabled.
;		If F000h segment shadow can't disable independently, must
;		implement Ct_Set_Flash and Ct_Get_Flash
;[]========================================================================[]
		public	Ct_Enable_Flash
Ct_Enable_Flash proc	near
		push	ax
		push	cx

		mov	cx,76h		;Disable Cacheable
		call	Get_Ct		;Read From RAM ,Write To ROM
		and	al,1Fh
		or	al,80h
		call	Set_Ct

		dec	cx		;then cx=75h
		mov	al,88h
		call	Set_Ct

		dec	cx		;then cx=74h
		call	Set_Ct

		mov	cx,840h		;enable ROM decode
		mov	al,0Ah
		call	Set_Ct

		mov	cl,45h		;enable flash write
		call	Get_Ct
		and	al, not 20h
		call	Set_Ct
ifdef	Flash_By_KB_Pin
		mov	al,0B2h+(Flash_By_KB_Pin-29)
		out	64h,al
		call	OUT_8042_FULL
		in	al,60h
		iodelay
endif	;Flash_By_KB_Pin
		pop	cx
		pop	ax
		ret
Ct_Enable_Flash endp

;[]========================================================================[]
;Procedure:	Ct_Set_Flash
;Function :	Write one byte (data/command) to Flash ROM
;Input	  :	ES:DI = address pointer
;		AL = value to write
;Output   :	none
;Registers:
;Note	  :	Don't destroy any registers
;[]========================================================================[]
		public	Ct_Set_Flash
Ct_Set_Flash	proc	near
		mov	es:[di], al
		ret
Ct_Set_Flash	endp

;[]========================================================================[]
;Procedure:	Ct_Get_Flash
;Function :	Read one byte (data/status) from Flash ROM
;Input	  :	ES:DI = address pointer
;Output   :	AL = value
;Registers:
;Note	  :	Don't destroy any registers
;[]========================================================================[]
ifndef	ESCD_M2
		public	Ct_Get_Flash
endif;	ESCD_M2
Ct_Get_Flash	proc	near
ifndef	ESCD_M2	   				;R06
		push	cx
		push	dx

		mov	dx, CONFIG_ADDR
		mov	eax,80000074h
		out	dx, eax
		add	dl, 4
		in	eax, dx

		push	eax			;save value
		and	eax, NOT 0E0FFFFh	;disable shadow value

;******************************************************************************
; The code size of this block must be less than 16 bytes
; and must start at 16 bytes boundary
		align	16
@@:
		out	dx, eax
		NEWIODELAY
		mov	cl, es:[di]
		pop	eax			;restore value
		out	dx, eax
if ($ - @b) GT 16
.ERR
%OUT	ERROR: Set Flash code is more than 16 bytes
endif
;******************************************************************************

		mov	al, cl
		pop	dx
		pop	cx
endif;	ESCD_M2	   				;R06
		ret
Ct_Get_Flash	endp

;[]========================================================================[]
;Procedure:	Ct_GetAll_Flash
;Function :	Read a block data in Flash ROM
;Input	  :	ES:DI = address pointer
;		DS:SI = address of buffer
;Output   :	AL = value
;Registers:
;Note	  :	Don't destroy any registers
;[]========================================================================[]
		public	Ct_GetAll_Flash
Ct_GetAll_Flash proc	near
ifndef	ESCD_M2	   				;R06
		push	dx

		mov	dx, CONFIG_ADDR
		mov	eax, (80000000h+(76h AND 0FFFCh))
		out	dx, eax
		mov	dx, (CONFIG_ADDR+4+(76h AND 03))
		in	al, dx

		push	ax		;restore value
		and	al, NOT 0A0h	;disable shadow read/write

;******************************************************************************
; The code size of this block must be less than 16 bytes
; and must start at 16 bytes boundary
		align	16
@@:
		out	dx, al
		rep	movsb
		pop	ax		;restore value
		out	dx, al
if ($ - @b) GT 16
.ERR
%OUT	ERROR: Set Flash code is more than 16 bytes
endif
;******************************************************************************

		pop	dx
endif;	ESCD_M2	   				;R06
		ret
Ct_GetAll_Flash endp

;[]========================================================================[]
;Procedure:	Ct_Shadow_Write
;Function :	Enable segment E000h, F000h shadow RAM write
;Input	  :	none
;Output   :	none
;Registers:
;Note	  :	If "Enable shadow RAM write" cause "Read from ROM", then
;		must implement Ct_Set_Shadow
;[]========================================================================[]
		public	Ct_Shadow_Write
Ct_Shadow_Write proc	near
ifdef	;PM_SUPPORT
		call	Open_PM_RAM
else	;PM_SUPPORT
		push	ax
		push	cx

		mov	cx,76h		;Read & Write From RAM
		call	Get_Ct
		and	al,5Fh
		or	al,0A0h
		call	Set_Ct

 ifndef	COMPRESS_CODE
		dec	cx		;then cx=75h
		mov	al,0AAh
		call	Set_Ct

		dec	cx		;then cx=74h
		call	Set_Ct
 endif	;COMPRESS_CODE

		pop	cx
		pop	ax
endif	;PM_SUPPORT
		ret
Ct_Shadow_Write endp

;[]========================================================================[]
;Procedure:	Ct_Shadow_Read
;Function :	To prg F000h shadow RAM to be write protected
;Input    :	none
;Output   :	none
;[]========================================================================[]
		public	Ct_Shadow_Read
Ct_Shadow_Read	proc	near

ifdef	PM_SUPPORT
		call	Close_PM_RAM
else	;PM_SUPPORT
		push	ax
		push	cx

		mov	cx,76h		;Write protect
		call	Get_Ct
		and	al,not 20h
		call	Set_Ct

		pop	cx
		pop	ax
endif	;PM_SUPPORT

		ret

Ct_Shadow_Read	endp
;[]========================================================================[]
;Procedure:	Ct_Set_Shadow
;Function :	Write one byte (data) to Shadow RAM
;Input	  :	ES:DI = address pointer
;		AL = value to write
;Output   :	none
;Registers:
;Note	  :	Don't destroy any registers
;[]========================================================================[]
		public	Ct_Set_Shadow
Ct_Set_Shadow	proc	near
		mov	es:[di], al
		ret
Ct_Set_Shadow	endp

;****************************************************************
;*								*
;*	CHIPSET DEVICE NODES PROCESS ROUTINES			*
;*								*
;****************************************************************

;[]========================================================================[]
; Input:	ES:DI = Device node structure pointer
; Output:	CF = 0 Device node structure modified successful
;		CF = 1 Device disabled
;[]========================================================================[]

Ct_Ide1_Node	proc	near

;No internal IDE or internal IDE disable
Ct_Ide1_Node	endp

Ct_Ide2_Node	proc	near

;No internal IDE or internal IDE disable
		stc
		ret
Ct_Ide2_Node	endp

ifdef	ACPI_BASE_ADDR_PATCH			;R01
Ct_Mb_Node	proc	near			;R01
		clc				;R01
		ret				;R01
Ct_Mb_Node	endp				;R01
else	;ACPI_BASE_ADDR_PATCH			;R01
 ifdef	NO_RELEASE_IRQ12
Ct_Mb_Node	proc	near
		push	ds
		mov	ax, G_RAM
		mov	ds, ax
		test	byte ptr ds:Hardware, 00000100b ;PS/2 installed ?
		pop	ds
		jnz	short @f		;no report if PS/2 present
		clc
		ret
@@:
		stc
		ret
Ct_Mb_Node	endp
 endif	;NO_RELEASE_IRQ12
endif	;ACPI_BASE_ADDR_PATCH			;R01


;GR00 - start
;[]========================================================================[]
;Procedure:	Ct_Pci_Escd
;Function :	Return Chipset PCI ESCD
;Input	  :	ES:DI = buffer address pointer
;		CH = device/function number
;Output   :	CF = 0 special PCI ESCD
;		CF = 1 not special PCI ESCD
;Note	  :	1. Don't destroy any register
;		2. Please refer to "2A4X5000.ASM"
;[]========================================================================[]
		public	Ct_Pci_Escd
Ct_Pci_Escd	proc	near
		stc
		ret
Ct_Pci_Escd	endp
;GR00 - end

	LPT_IRQ_ROUTING_MBIRQ	=	0861H	;MIRQ
	DMA_ROUTE_MASK		=	11110000b
	DMA_ROUTE_MASK_SHIFT	=	0

	AUDIO_IRQ_ROUTING_MBIRQ = 861h

	AUDIO_DMA_ROUTE_MASK_SHIFT = 0
	AUDIO_DMA_ROUTE_MASK	   = 11110000b

ifdef	ES1788_DAC_DMA_ROUTING
AUDIO_IRQ_ROUTING	EQU	1
AUDIO_DMA_ROUTING	EQU	1
endif;	ES1788_DAC_DMA_ROUTING

IFDEF	AUDIO_IRQ_ROUTING
;[]=============================================================[]
;Procedure :	Ct_Get_AUDIO_IRQ_Routing
;
;Input	:	None
;
;Output :	AL = 11 : AUDIO IRQ routed to IRQ 11
;		     12 : AUDIO IRQ routed to IRQ 12
;		     -1 : AUDIO IRQ routing disabled
;
;Registers :	Please save all registers except AL
;
;[]=============================================================[]
		Public	Ct_Get_AUDIO_IRQ_Routing
Ct_Get_AUDIO_IRQ_Routing	Proc	Near
		push	cx
		mov	cx,AUDIO_IRQ_ROUTING_MBIRQ
		jmp	ct_get_MIRQ
Ct_Get_AUDIO_IRQ_Routing	Endp

;[]=============================================================[]
;Procedure :	Ct_Set_AUDIO_IRQ_Routing
;
;Input	:	AX = 11 : AUDIO IRQ routed to IRQ 11
;		     12 : AUDIO IRQ routed to IRQ 12
;		     -1 : Disable AUDIO IRQ routing
;
;Output :	None
;
;Registers :	Please save all registers
;
;[]=============================================================[]
		Public	Ct_Set_AUDIO_IRQ_Routing
Ct_Set_AUDIO_IRQ_Routing	Proc	Near
		pushad
		mov	cx,AUDIO_IRQ_ROUTING_MBIRQ
		jmp	ct_set_MIRQ
Ct_Set_AUDIO_IRQ_Routing	Endp

ENDIF;	AUDIO_IRQ_ROUTING

IFDEF	AUDIO_DMA_ROUTING
;[]=============================================================[]
;Procedure :	Ct_Get_AUDIO_DMA_Routing
;
;Input	:	None
;
;Output :	AL = 0 to 7
;
;		    -1 : AUDIO DMA routing disabled
;		     0 : AUDIO DMA routed to DMA 0
;		     1 : AUDIO DMA routed to DMA 1
;				  .
;				  .
;		     7 : AUDIO DMA routed to DMA 7
;
;Registers :	Please save all registers except AL
;
;[]=============================================================[]
		Public	Ct_Get_AUDIO_DMA_Routing
Ct_Get_AUDIO_DMA_Routing	Proc	Near
		push	cx
		push	dx
		mov	dl,AUDIO_DMA_ROUTE_MASK_SHIFT
		jmp	ct_get_MDMA
Ct_Get_AUDIO_DMA_Routing	Endp

;[]=============================================================[]
;Procedure :	Ct_Set_AUDIO_DMA_Routing
;
;Input	:	AL = 0 to 7, -1
;
;		    -1 : Disable DMA routing
;		     0 : AUDIO DMA routed to DMA 0
;		     1 : AUDIO DMA routed to DMA 1
;				  .
;				  .
;		     7 : AUDIO DMA routed to DMA 7
;
;Output :	None
;
;Registers :	Please save all registers
;
;[]=============================================================[]
		Public	Ct_Set_AUDIO_DMA_Routing
Ct_Set_AUDIO_DMA_Routing	Proc	Near
		pushad
		mov	cl,AUDIO_DMA_ROUTE_MASK_SHIFT
		mov	ah,AUDIO_DMA_ROUTE_MASK
		jmp	ct_set_MDMA
Ct_Set_AUDIO_DMA_Routing	Endp

 Compile_MDMA	equ	1
ENDIF;	AUDIO_DMA_ROUTING


;[]=============================================================[]
;Procedure :	Ct_Get_LPT_IRQ_Routing
;
;Input	:	None
;
;Output :	AL = 5 : LPT IRQ routed to IRQ 5
;		     7 : LPT IRQ routed to IRQ 7
;		    -1 : LPT IRQ routing disabled
;
;Registers :	Please save all registers except AL
;
;[]=============================================================[]
		Public	Ct_Get_LPT_IRQ_Routing
Ct_Get_LPT_IRQ_Routing	Proc	Near
ifdef	MIRQ_ROUTING				;R06
		push	cx

		mov	cx,LPT_IRQ_ROUTING_MBIRQ
ct_get_MIRQ:
		push	eax
		call	Get_Ct
		mov	cl,al
		pop	eax

		mov	al,-1
		test	cl,80h			;IRQ routing enabled ?
		jnz	short @F

		mov	al,cl
		and	al,0Fh
	@@:
		pop	cx
else;	MIRQ_ROUTING				;R06
		mov	al,-1	;no routing	;R06
endif;	MIRQ_ROUTING				;R06

		ret

Ct_Get_LPT_IRQ_Routing	Endp

;[]=============================================================[]
;Procedure :	Ct_Set_LPT_IRQ_Routing
;
;Input	:	AL = 5 : LPT IRQ routed to IRQ 5
;		     7 : LPT IRQ routed to IRQ 7
;		    -1 : Disable LPT IRQ routing
;
;Output :	None
;
;Registers :	Please save all registers
;
;[]=============================================================[]
		Public	Ct_Set_LPT_IRQ_Routing
Ct_Set_LPT_IRQ_Routing	Proc	Near

ifdef	MIRQ_ROUTING				;R06
		pushad

		mov	cx,LPT_IRQ_ROUTING_MBIRQ
ct_set_MIRQ:
		cmp	al,-1
		jne	short @F
		mov	al,80h			;disable routing
	@@:
		or	al,40h			;disable sharing
		call	Set_Ct

		popad

endif;	MIRQ_ROUTING				;R06
		ret

Ct_Set_LPT_IRQ_Routing	Endp

;[]=============================================================[]
;Procedure :	Ct_Get_Ecp_DMA_Routing
;
;Input	:	None
;
;Output :	AL = 0 to 7
;
;		    -1 : ECP DMA routing disabled
;		     0 : ECP DMA routed to DMA 0
;		     1 : ECP DMA routed to DMA 1
;				  .
;				  .
;		     7 : ECP DMA routed to DMA 7
;
;Registers :	Please save all registers except AL
;
;[]=============================================================[]
		Public	Ct_Get_Ecp_DMA_Routing
Ct_Get_Ecp_DMA_Routing	Proc	Near

ifdef	ECP_DMA0
		mov	al,ECP_DMA1
		ret
else;	ECP_DMA0
 Compile_MDMA	equ	1
endif;	ECP_DMA0

ifdef	Compile_MDMA
		push	cx
		push	dx
		mov	dl,DMA_ROUTE_MASK_SHIFT
ct_get_MDMA:
		mov	cx,0862H		;port for DMA routing

		push	eax
		call	Get_Ct
		mov	ch,al
		pop	eax

		mov	cl,dl
		shr	ch,cl
		mov	al,ch
		test	al,08H			;DMA routing enabled ?
		jz	short DMA_route_disabled

	;DMA routing enabled

		and	al,07H
		cmp	al,100b
		jne	short @F
DMA_route_disabled:
		mov	al,-1
	@@:

		pop	dx
		pop	cx


		ret
endif	;Compile_MDMA

Ct_Get_Ecp_DMA_Routing	Endp

;[]=============================================================[]
;Procedure :	Ct_Set_Ecp_DMA_Routing
;
;Input	:	AL = 0 to 7, -1
;
;		    -1 : Disable DMA routing
;		     0 : ECP DMA routed to DMA 0
;		     1 : ECP DMA routed to DMA 1
;				  .
;				  .
;		     7 : ECP DMA routed to DMA 7
;
;Output :	None
;
;Registers :	Please save all registers
;
;[]=============================================================[]
		Public	Ct_Set_Ecp_DMA_Routing
Ct_Set_Ecp_DMA_Routing	Proc	Near

ifdef	Compile_MDMA

		pushad
		mov	cl,DMA_ROUTE_MASK_SHIFT
		mov	ah,DMA_ROUTE_MASK
ct_set_MDMA:
		cmp	al,-1
		jne	short @F
		mov	al,100b
		jmp	short set_MDMA_reg
	@@:
		and	al,07h
		or	al,08H			;enable DMA routing
set_MDMA_reg:
		shl	al,cl
		mov	bl,al

		mov	cx,0862H		;port for DMA routing
		call	Get_Ct
		and	al,ah
		or	al,bl
		call	Set_Ct

		popad

endif	;Compile_MDMA
		ret

Ct_Set_Ecp_DMA_Routing	Endp

ifdef 	IRQ12_Ctl_By_Ct
;[]========================================================================[]
;Function : Enable/Disable IRQ 12 for PS2 mouse by run-time
;Input    : AH = 04H - enable IRQ 12
;Output   :    = 00H - disable IRQ 12
;[]========================================================================[]
  		public	Ct_IRQ12_Control
Ct_IRQ12_Control	proc	near
		pusha
;R05 - start
ifdef	USB_SUPPORT
		extrn	USB_ITEM:near
		extrn	GetItem_Value:near
		push	ax
		mov	si,offset USB_ITEM
		call	GetItem_Value
		test	al,al
		pop	ax
		jz	short USB_Item_Disable
		mov	cx,870h
		mov	bx,04ffh
		call	Get_Set_Ct
		popa
		ret
USB_Item_Disable:
endif;	USB_SUPPORT
;R05 - end
;R02		mov	cx,870h
		mov	bl,0FBh
		mov	bh,ah
		mov	cx,08h		;R02 get version number
		call	Get_Ct		;R02
		or	al,al		;R02
		jnz	short B_or_above;R02
		xor	bh,04h
B_or_above:				;R02
		mov	cx,870h		;R02
		call	Get_Set_Ct
		popa
		ret
Ct_IRQ12_Control	endp
endif	;IRQ12_Ctl_By_Ct

ENDIF	;PNP_BIOS

ifdef	COMPRESS_CODE
FCODE		ENDS
else	;COMPRESS_CODE
GET_CT:
		push	edx
		posh	eax
		mov	eax,80000000h
		mov	ax,cx
		and	al,NOT 03h
		mov	dx,CONFIG_ADDR
		out	dx,eax
		add	dl,4
		mov	al,cl
		and	al,03h
		add	dl,al
		pop	eax
		in	al,dx
		pop	edx
		ret

SET_CT:
		push	edx
		push	eax
		mov	eax,80000000h
		mov	ax,cx
		and	al,NOT 03h
		mov	dx,CONFIG_ADDR
		out	dx,eax
		add	dl,4
		mov	al,cl
		and	al,03h
		add	dl,al
		pop	eax
		out	dx,al
		pop	edx
		ret

GET_SET_CT:
		call	Get_Ct
		and	al,bl
		or	al,bh
		call	Set_Ct
		ret


ifdef	Flash_By_KB_Pin
		INCLUDE 8042.EQU
OUT_8042_FULL	PROC	NEAR
		mov	ah,12
otrck:
		xor	cx,cx
inrck:
		in	al,STAT8042
IFNDEF	NO_NEWIODELAY_IN_8042_IO
		NEWIODELAY
ENDIF	;NO_NEWIODELAY_IN_8042_IO
		test	al,OBF_8042
		jnz	short onret
		loop	short inrck
		dec	ah
		jnz	short otrck
onret:
		ret
OUT_8042_FULL	ENDP
endif	;Flash_By_KB_Pin

ECODE		ENDS
endif	;COMPRESS_CODE
		END
