;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R16	07/16/97 RCH	Fixed IOCFG buffer too small for PnP BIOS to treat
;			IO_DSP over 8 entities.
;R15	04/30/96 KEN	Added OS_ENABLE flag of PNP_FLAG, for PNPPOST to skip
;			non-bootable device initializing if OS_Setup_Item
;			is enabled.
;R14	01/31/96 KEN	PNP ROM use separate data to avoid to conflict with
;			PCI kernal.
;R13	12/28/95 KEN	Manage I/O port with 4 bytes unit and UMB with 4KB unit
;			to solve two IBM Token-Ring cards installed problem.
;R12	12/26/95 ROB	Update for EISA/PNP.
;R11	11/29/95 KEN	Fixed the IDE device of Creative ViBRA16S PNP card
;			assigned I/O port as 376h and will conflict with
;			on-chip secondary IDE in windows 95.
;R10	11/10/95 KEN	Add CHOICE_CNT and CHOICE_BUFFER for supporting AT
;			device resource assignment with compatible IRQ.
;R09	10/27/95 KEN	Add CSN_PRIORITY, INIT_FLAG, ERROR_FLAG for supporting
;			initailizing PNP sequence with device type priority.
;R08	09/28/95 RCH	Added structures for EISA/PnP
;R07	08/21/95 KEN	Manage I/O port above 800h, since most of Token Ring
;			cards request I/O port above 800h.
;R05B	07/27/95 KEN	I/O port manage above 400h to 7FFh according to FIC request.
;R05A	07/26/95 KEN	Resume I/O port management with 8 bytes unit, to match
;			Intel CM management method.
;R06	07/25/95 KEN	Support fixed-config for PCI and ISA/PNP devices.
;R05	06/13/95 KEN	Modify SYSTEM_MAP for resource management of I/O port
;			with 4 bytes one unit.
;R04	05/18/95 KEN	Add CurrentEscdPoint for creating ISA/PNP ESCD.
;R03	05/11/95 KEN	Update CFGDATA to support creating ESCD in POST.
;R02	04/21/95 KEN	Add 8 bytes buffer to record PnP ROM
;R01	04/19/95 KEN	Add EscdBrdMap(PnP, Pci) and CurrentEscd
;R00	10/01/94 KEN	Initial Revision

;		+-------------------------------+
;		|				|
;		|  PNP BIOS DATA AREA FOR POST	|
;		|				|
;		+-------------------------------+

PNP_BUFFER	LABEL	BYTE

MAX_CSN		EQU	15

TEMP_PNP_RD	DW	?
TEMP_LAST_CSN	DB	?

PNP_FLAG	DB	?		;R06
BAD_ESCD	EQU	00000001b	;R06
FIX_CONFIG	EQU	00000010b	;R06
OS_ENABLE	EQU	00000100b	;R15 flag for PnP OS select

CSN_CNT		DB	?
LOGIC_DEV_CNT	DB	?
CHOICE_CNT	DB	?		;R10

;R09LOGIC_DEV_NUM	DB	MAX_CSN DUP(?)
CSN_PRIORITY	DB	MAX_CSN DUP(?)	;R09
INIT_FLAG	DW	?		;R09
ERROR_FLAG	DW	?		;R09

SERIAL_ID	DB	MAX_CSN*9 DUP(?)

;R13SYSTEM_MAP	LABEL	BYTE
;R13		DW	?		;00-01 IRQ resource map
;R13		DB	?		;02    DMA resource map
;R13;R05		DB	12 DUP(?)	;03-0E I/O resource map (8 bytes unit)
;R13;R05A		DB	24 DUP(?)	;R05
;R13		DB	12 DUP(?)	;R05A
;R13		DB	16 DUP(?)	;R05B
;R13		DW	?		;0F-10 Expansion ROM map (16 KB unit)
;R13		DD	?		;11-14 Extended memory base
;R13SYSTEM_MAP_L	EQU	$ - SYSTEM_MAP
;R13
;R13;R07TEMP_SYSTEM_MAP	LABEL	BYTE
;R13;R07TEMP_IRQ_MAP	DW	?		;IRQ resource map
;R13;R07TEMP_DMA_MAP	DB	?		;DMA resource map
;R13;R07;R05TEMP_IO_MAP	DB	12 DUP(?)	;I/O resource map (8 bytes unit)
;R13;R07;R05ATEMP_IO_MAP	DB	24 DUP(?)	;R05
;R13;R07TEMP_IO_MAP	DB	12 DUP(?)	;R05A
;R13;R07		DB	16 DUP(?)	;R05B
;R13;R07TEMP_UMB_MAP	DW	?		;Expansion ROM map (16 KB unit)
;R13;R07TEMP_EXTMEM_BASE	DD	?	;Extended memory base
;R13;R07TEMP_SYSTEM_MAP_L	EQU	$ - TEMP_SYSTEM_MAP
;R13UPPER_IO_MAP	DB	((0FFFFh-7FFh)/8/8) DUP(?)	;R07800-FFFF IO Port
;R13UPPER_IO_MAP_L	EQU	$ - UPPER_IO_MAP		;R07
IRQ_MAP		DW	?					;R13
DMA_MAP		DB	?					;R13
IO_RANGE	EQU	1FFFh					;R13
IO_UNIT		EQU	4					;R13
IO_MASK		EQU	0FFFCh					;R13
IO_SHIFT	EQU	2					;R13
IO_MAP_L	EQU	(IO_RANGE-0FFh)/IO_UNIT/8		;R13
IO_MAP		DB	IO_MAP_L DUP(?)				;R13
UMB_MAP		DD	?					;R13
PNPROM_MAP	DD	?					;R14
EXTMEM_BASE	DD	?					;R13
SPECIAL_IO_MAP	DB	?				;R11;376, 3F6

STR_BUF_POINT	DW	?
STR_BUFFER	DB	82 DUP(?)	;string buffer

RES_BUFFER	DB	256 DUP(?)	;Resource data buffer
RES_BUFFER_L	EQU	$ - RES_BUFFER

CHOICE_BUFFER	DB	1024 DUP(?)	;R10

MEMCFGDATA	STRUC
MemCtrl		DB	?
MemBase		DD	?
MemLength	DD	?
MEMCFGDATA	ENDS

IOCFGDATA	STRUC
IoInfo		DB	?		;;R03
IoBase		DW	?
IoLength	DB	?
IOCFGDATA	ENDS

IRQCFGDATA	STRUC			;;R03
IrqInfo		DB	?		;;R03
IrqNum		DB	?		;;R03
IRQCFGDATA	ENDS			;;R03

DMACFGDATA	STRUC			;;R03
DmaInfo		DB	?		;;R03
DmaNum		DB	?		;;R03
DMACFGDATA	ENDS			;;R03

MEM24REG_NUM	EQU	4
MEM32REG_NUM	EQU	4
IOREG_NUM	EQU	8
IRQREG_NUM	EQU	2
DMAREG_NUM	EQU	2

;R03CFGDATA		STRUC
;R03Mem24CfgCount	DB	?
;R03Mem24Cfg	DB	MEM24REG_NUM*(SIZE MEMCFGDATA) DUP(?)
;R03Mem32CfgCount	DB	?
;R03Mem32Cfg	DB	MEM32REG_NUM*(SIZE MEMCFGDATA) DUP(?)
;R03IoCfgCount	DB	?
;R03IoCfg		DB	IOREG_NUM*(SIZE IOCFGDATA) DUP(?)
;R03IrqCfgCount	DB	?
;R03IrqCfg		DB	IRQREG_NUM DUP(?)
;R03DmaCfgCount	DB	?
;R03DmaCfg		DB	DMAREG_NUM DUP(?)
;R03CFGDATA		ENDS
;R03 - start
CFGDATA		STRUC
Mem24CfgCount	DB	?
Mem24Cfg	DB	8*(SIZE MEMCFGDATA) DUP(?)
Mem32CfgCount	DB	?
Mem32Cfg	DB	24*(SIZE MEMCFGDATA) DUP(?)		;R16
;R16 Mem32Cfg	DB	8*(SIZE MEMCFGDATA) DUP(?)
IoCfgCount	DB	?
IoCfg		DB	24*(SIZE IOCFGDATA) DUP(?)		;R16
;R16 IoCfg  	DB	8*(SIZE IOCFGDATA) DUP(?)
IrqCfgCount	DB	?
IrqCfg		DB	8*(SIZE IRQCFGDATA) DUP(?)
DmaCfgCount	DB	?
DmaCfg		DB	8*(SIZE DMACFGDATA) DUP(?)
CFGDATA		ENDS
;R03 - end

;R08 - start
;IF BUS_TYPE EQ EISA_BUS
;R12ESCD_CFGHDR_Adr  DD     ?
;R12ESCD_BRDHDR_Adr  DD     ?
;R12bCfgUtilMajorNum DB     ?
;R12bCfgUtilMinorNum DB     ?
;R12wInsertionPoint  DW     ?
;R12wBrdChksum       DW     ?

;ENDIF ;BUS_TYPE EQ EISA_BUS
;R08 - end

CfgBuffer	DB	(SIZE CFGDATA) DUP(?)

;R10DfBuffer	DB	(SIZE CFGDATA) DUP(?)

PnpRomMap	DB	8 DUP(?)		;R02;PnP ROM map
PnpRomMap_L	equ	$ - PnpRomMap		;R02;PnP ROM map length

EscdBrdMap	DB	8 DUP(?)		;R01
PnPEscdBrdMap	DB	8 DUP(?)		;R06
;R03PnPEscdBrdMap	DB	8 DUP(?)		;R01
;R03PciEscdBrdMap	DB	8 DUP(?)		;R01
OldEscdBrdMap	DB	8 DUP(?)		;R01
NewEscdBrdMap	DB	8 DUP(?)		;R01
EscdBrdMap_L	equ	$ - EscdBrdMap		;R01
CurrentEscdPoint	DW	?		;R04
CurrentEscd	DB	1024 DUP(?)		;R01

;R12ESCD_BUFFER	DB	4096 DUP(?)	;ESCD data buffer
ESCD_BUFFER      DB     (SIZE ESCD_STRUC) DUP(?)	;R12

;;;;		PUBLIC	PNP_BUFFER_L
;;;;PNP_BUFFER_L	EQU	$ - PNP_BUFFER

