;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
; Rev	Date	 Name	Description
;----------------------------------------------------------------------------
; R03	OCT-15-90 SMS	adding copyright stmt.
; R02   08/18/89 Admin  Changed to current header format
; R01	08/01/89 Admin  Added include of BIOS.CFG
; R00	07/31/89 Admin	Initial revision
;

;		+-----------------------+
;		|			|
;		|  386 BIOS DATA AREA	|
;		|			|
;		+-----------------------+

		INCLUDE	BIOS.CFG

; THE GOAL OF THIS IS TO MINIMIZE AND IDENTIFY SEGMENT 0 ACCESS IN
; PROTECTED MODE. THIS FIRST CUT HARD ORIGINS ALL ACCESSES WITH NAMES. USED
; THROUGHOUT THE BIOS

; THE FINAL VERSION WITH, SEGMENT AT 2, SHOULD WARM BOOT IN PROTECTED MODE,
; ALL VIDEO/DISK OPERATIONS SHOULD BE CLEAN IN PROTECTED MODE. HARD ORIGINS
; SHOULD BE REMOVED, LIKE G_RAM.INC SO THE FILE CAN BE BUILT WITH SEGMENT AT
; 0, AND SEGMENT AT 1 DEFINITIONS.

; THE SECOND PROBLEM IS THAT SOME PROCESSORS LOSE CX ON EXCEPTION 5. ALL
; SEGMENT 0 ACCESS SHOULD PUSH AND POP CX TO ACCOUNT FOR THIS HARDWARE
; BUG ON SOME INTEL PROCESSORS.

; THE RESULT WILL BE FASTER EXECUTION OF PROTECTED MODE SOFTWARE DUE TO
; MINIMIZING PROCESSOR EXCEPTIONS.
; *FIRST* IS THE FIRST REFERENCE POINT FROM THE BIOS

; SEGMENT AT 1 STARTS HERE, ONLY USE DUP'S
;		ORG	04H*4
INT04		DD	1 DUP(?)		;
INT05		DD	1 DUP(?)		; PRINT SCREEN
INT06		DD	1 DUP(?)		;
INT07		DD	1 DUP(?)		;
INT08		DD	1 DUP(?)		; TIMER, *FIRST*
INT09		DD	1 DUP(?)		; KEYBOARD
INT0A		DD	1 DUP(?)		;
INT0B		DD	1 DUP(?)		;
INT0C		DD	1 DUP(?)		;
INT0D		DD	1 DUP(?)		; 386 EXCEPT SEGWRAP
INT0E		DD	1 DUP(?)		;
INT0F		DD	1 DUP(?)		;
INT10		DD	1 DUP(?)		; VIDEO
INT11		DD	1 DUP(?)		;
INT12		DD	1 DUP(?)		;
INT13		DD	1 DUP(?)		;
INT14		DD	1 DUP(?)		;
INT15		DD	1 DUP(?)		;
INT16		DD	1 DUP(?)		;
INT17		DD	1 DUP(?)		;
INT18		DD	1 DUP(?)		; NETWORK ADAPTER
INT19		DD	1 DUP(?)		;
INT1A		DD	1 DUP(?)		;
INT1B		DD	1 DUP(?)		;
INT1C		DD	1 DUP(?)		;
PTR_VIDEO_PARM	DD	1 DUP(?)		; POINTER TO VIDEO PARMS
DISK_PARM_PTR	DD	1 DUP(?)		; FLOPPY DISK PARM TABLE
PTR_VIDEO_EXT	DD	1 DUP(?)		; VIDEO EXTENSIONS
INT20		DD	1 DUP(?)		;
INT21		DD	1 DUP(?)		;
INT22		DD	1 DUP(?)		;
INT23		DD	1 DUP(?)		;
INT24		DD	1 DUP(?)		;
INT25		DD	1 DUP(?)		;
INT26		DD	1 DUP(?)		;
INT27		DD	1 DUP(?)		;
INT28		DD	1 DUP(?)		;
INT29		DD	1 DUP(?)		;
INT2A		DD	1 DUP(?)		;
INT2B		DD	1 DUP(?)		;
INT2C		DD	1 DUP(?)		;
INT2D		DD	1 DUP(?)		;
INT2E		DD	1 DUP(?)		;
INT2F		DD	1 DUP(?)		;
INT30		DD	1 DUP(?)		;
INT31		DD	1 DUP(?)		;
INT32		DD	1 DUP(?)		;
INT33		DD	1 DUP(?)		;
INT34		DD	1 DUP(?)		;
INT35		DD	1 DUP(?)		;
INT36		DD	1 DUP(?)		;
INT37		DD	1 DUP(?)		;
INT38		DD	1 DUP(?)		;
INT39		DD	1 DUP(?)		;
INT3A		DD	1 DUP(?)		;
INT3B		DD	1 DUP(?)		;
INT3C		DD	1 DUP(?)		;
INT3D		DD	1 DUP(?)		;
INT3E		DD	1 DUP(?)		;
INT3F		DD	1 DUP(?)		;
INT40		DD	1 DUP(?)		; AHDSK HARD DISK PARM TABLE
DR0VECTOR	DD	1 DUP(?)		; AHDSK DISK 0 C:
INT42		DD	1 DUP(?)		;
INT43		DD	1 DUP(?)		; RE-DIRECT VIDEO FROM EGA/VGA
INT44		DD	1 DUP(?)		;
INT45		DD	1 DUP(?)		;
DR1VECTOR	DD	1 DUP(?)		; AHDSK DISK 1 D:
INT47		DD	1 DUP(?)		;
INT48		DD	1 DUP(?)		;
INT49		DD	1 DUP(?)		;
INT4A		DD	1 DUP(?)		;
INT4B		DD	1 DUP(?)		;
INT4C		DD	1 DUP(?)		;
INT4D		DD	1 DUP(?)		;
INT4E		DD	1 DUP(?)		;
INT4F		DD	1 DUP(?)		;
INT50		DD	1 DUP(?)		;
INT51		DD	1 DUP(?)		;
INT52		DD	1 DUP(?)		;
INT53		DD	1 DUP(?)		;
INT54		DD	1 DUP(?)		;
INT55		DD	1 DUP(?)		;
INT56		DD	1 DUP(?)		;
INT57		DD	1 DUP(?)		;
INT58		DD	1 DUP(?)		;
INT59		DD	1 DUP(?)		;
INT5A		DD	1 DUP(?)		;
INT5B		DD	1 DUP(?)		;
INT5C		DD	1 DUP(?)		;
INT5D		DD	1 DUP(?)		;
INT5E		DD	1 DUP(?)		;
INT5F		DD	1 DUP(?)		;
INT60		DD	1 DUP(?)		; SLAVE INTERRUPTS
INT61		DD	1 DUP(?)		;
INT62		DD	1 DUP(?)		;
INT63		DD	1 DUP(?)		;
INT64		DD	1 DUP(?)		;
INT65		DD	1 DUP(?)		;
INT66		DD	1 DUP(?)		;
INT67		DD	1 DUP(?)		;
INT68		DD	1 DUP(?)		;
INT69		DD	1 DUP(?)		;
INT6A		DD	1 DUP(?)		;
INT6B		DD	1 DUP(?)		;
INT6C		DD	1 DUP(?)		;
INT6D		DD	1 DUP(?)		;
INT6E		DD	1 DUP(?)		;
INT6F		DD	1 DUP(?)		;
INT70		DD	1 DUP(?)		; SECONDARY HARDWARE INTERRUPTS
INT71		DD	1 DUP(?)		;
INT72		DD	1 DUP(?)		;
INT73		DD	1 DUP(?)		;
INT74		DD	1 DUP(?)		;
INT75		DD	1 DUP(?)		;
HD_INT		DD	1 DUP(?)		; SECONDARY HARD DISK INT

INT77		DD	1 DUP(?)		;IRQ15
