;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R09A	12/04/97 DNL	Move some definition to misc.equ for more asm file
;R09	12/03/97 DNL	Added ACPI Thermal Zone support
;R08	11/17/97 TNY	Add "SIS5595_Support" definition.
;R07	11/13/97 TNY	Add "W83781D_Support" definition.
;R06	09/01/97 RIC	Add "VT586_ACPI" define for VIA chipset.
;R05	08/21/97 TNY	Add "GL518SM_Support" definition.
;R04	08/08/97 TNY	Fix coding error, clear error status.
;R03	08/08/97 TNY	Add ALi M1543 SMBus support.
;R02	08/07/97 RCH	Make routine "Chk_SMBus_READY" and "WaitSmbus" as
;			public procedure for both LM78 & LM75 to prevent
;			duplicate codes
;R01	06/18/97 TNY	Always show sensor values in runtime.

ifdef	MASM611
.MODEL  SMALL,BASIC
OPTION	PROC: PRIVATE
endif	;MASM611
.386p
		PAGE	56,132
		TITLE	SENSOR.ASM
.XLIST
		INCLUDE	BIOS.CFG
		INCLUDE	COMMON.MAC
		INCLUDE POST.EQU
		INCLUDE	MISC.EQU		;R09A

;		extrn	F000_call_proc:near
		extrn	F000_GetItem_Value:near
		extrn	F000_VECT:near
		extrn	RET_E_SEG:near

;R09A	SENSOR_KERNEL	=	0
;R09A	NO_CPUFAN_THERMAL	=	0
;R09A
;R09Aifdef	LM75_Support
;R09A	SENSOR_KERNEL	=	1
;R09Aendif	;LM75_Support
;R09A
;R09Aifdef	LM78_Support
;R09A	SENSOR_KERNEL	=	1
;R09A	NO_CPUFAN_THERMAL	=	1		;R09
;R09Aendif	;LM78_Support
;R09A
;R09Aifdef	GL518SM_Support					;R05
;R09A	SENSOR_KERNEL	=	1			;R05
;R09A	NO_CPUFAN_THERMAL	=	1		;R09
;R09Aendif	;GL518SM_Support				;R05
;R09A
;R09Aifdef	W83781D_Support					;R07
;R09A	SENSOR_KERNEL	=	1			;R07
;R09A	NO_CPUFAN_THERMAL	=	1		;R09
;R09Aendif	;W83781D_Support				;R07
;R09A
;R09Aifdef	SIS5595_Support					;R08
;R09A	SENSOR_KERNEL	=	1			;R08
;R09A	NO_CPUFAN_THERMAL	=	1		;R09
;R09Aendif;	SIS5595_Support					;R08

G_RAM		SEGMENT	USE16 AT 0

		ORG	04H*4
		INCLUDE	SEG_0.INC

		ORG	400H
		INCLUDE	G_RAM.INC

G_RAM		ENDS

.LIST

DGROUP		GROUP	FCODE
FCODE           SEGMENT PARA PUBLIC 'CODE'
                ASSUME  CS:DGROUP
FCODE           ENDS

EGROUP		GROUP	ECODE
ECODE		SEGMENT	USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP,DS:G_RAM,ES:EGROUP

IF	SENSOR_KERNEL

		COMPILE_FOR_SENSOR_KERNEL_ASM	=	2

;R09A;R09 - start
;R09Aif	NO_CPUFAN_THERMAL	EQ	1
;R09A		Public	Ct_FillTempPointer
;R09ACt_FillTempPointer	Proc	Near
;R09A		ret
;R09ACt_FillTempPointer	Endp
;R09Aendif	;NO_CPUFAN_THERMAL	EQ	1
;R09A;R09 - end

ifndef	VT586_ACPI					;R06
;R02 - start
 SBUS_NEED	=	0
 ifdef	GL518SM_Support					;R05
  SBUS_NEED	=	1				;R05
 endif	;GL518SM_Support				;R05
 ifdef	LM75_Support
  SBUS_NEED	=	1
 endif;	LM75_Support
 ifdef	LM78_Support
  ifdef	LM78_USE_SMBUS
   SBUS_NEED	=	1
  endif;	LM78_USE_SMBUS
 endif;	LM78_Support
ifdef	W83781D_USE_SMBUS 				;R07
   SBUS_NEED	=	1				;R07
endif	;W83781D_USE_SMBUS				;R07

if SBUS_NEED
;R03 - start
ifdef	M1543						
	public	Chk_SMBus_READY
Chk_SMBus_READY	Proc	Near
		mov	dx,SMBus_Port + 0
		clc
		mov	cx,0100h
Chk_I2C_OK:
		in	al,dx		;get status
		or	al,al
		jz	short Clear_final

		test	al,20h		;Error status
		jnz	short SMBus_Err	       

		test	al,01h		;busy ?
		jz	short Not_Smbusy
		call	WaitSmbus
Not_Smbusy:
		out 	dx,al
		loop	short Chk_I2C_OK
SMBus_Err:
		out	dx,al				;R04
		NEWIODELAY				;R04
		in	al,dx		;get status	;R04
		NEWIODELAY				;R04
		test	al,20h				;R04
		jnz	short SMBus_Err			;R04
		stc
Clear_final:
		ret
Chk_SMBus_READY	Endp
endif;	M1543
;R03 - end

ifdef	PIIX_ID					;R03
	public	Chk_SMBus_READY
Chk_SMBus_READY	Proc	Near
		mov	dx,SMBus_Port + 0
		clc
		mov	cx,0100h
Chk_I2C_OK:
		in	al,dx		;get status
		or	al,al
		jz	short Clear_final

		test	al,04h		       
		jnz	short SMBus_Err	       

		test	al,01h		;busy ?
		jz	short Not_Smbusy
		call	WaitSmbus
Not_Smbusy:
		out 	dx,al
		loop	short Chk_I2C_OK
SMBus_Err:	
		out	dx,al				;R04
		NEWIODELAY				;R04
		in	al,dx		;get status	;R04
		NEWIODELAY				;R04
		test	al,04h				;R04
		jnz	short SMBus_Err			;R04
		stc
Clear_final:
		ret
Chk_SMBus_READY	Endp
endif;	PIIX_ID					;R03

	public	WaitSmbus
WaitSmbus	proc	near			
		push	cx			
		mov	cx,100h
	@@:						
		loop	short @B		
		pop	cx			
		ret				
WaitSmbus	endp
endif; SBUS_NEED
;R02 - end
endif;	VT586_ACPI					;R06

	ifdef	LM75_Support
		include	LM75.SSR
	endif	;LM75_Support

	ifdef	LM78_Support
		include	LM78.SSR
	endif	;LM78_Support

	ifdef	GL518SM_Support					;R05
		include	GL518SM.SSR				;R05
	endif	;GL518SM_Support				;R05

	ifdef	W83781D_Support					;R07
		include	W83781D.SSR				;R07
	endif	;W83781D_Support				;R07

	ifdef	SIS5595_Support					;R08
		include	SIS5595.SSR				;R08
	endif	;SIS5595_Support				;R08

ENDIF	;SENSOR_KERNEL

;[]======================================================================[]
;[]======================================================================[]
		Public	Init_Onboard_Sensor
Init_Onboard_Sensor	Proc	Near

IF	SENSOR_KERNEL

		pushad
		push	ds
		push	es
		pushf
		cli

ifdef	LM75_Support
		call	Prg_LM75_Chip
endif;	LM75_Support

ifdef	LM78_Support
		call	Prg_LM78_Chip
endif;	LM78_Support

ifdef	GL518SM_Support					;R05
		call	Prg_GL518SM_Chip		;R05
endif	;GL518SM_Support				;R05

ifdef	W83781D_Support					;R07
		call	Prg_W83781D_Chip		;R07
endif	;W83781D_Support				;R07

ifdef	SIS5595_Support					;R08
		call	Prg_SIS5595_Chip		;R08
endif	;SIS5595_Support				;R08

		popf
		pop	es
		pop	ds
		popad

ENDIF	;SENSOR_KERNEL

		ret

Init_Onboard_Sensor	Endp

;[]======================================================================[]
;[]======================================================================[]

E_GetItem_Value	Proc	Near
		jmp	F000_GetItem_Value
		ret
E_GetItem_Value	Endp

;R01 - start
		public	Update_Sensor_Screen
Update_Sensor_Screen	Proc	Far

IF	SENSOR_KERNEL
		push	ds
		mov	ax, 40h
		mov	ds, ax
		mov	si, 6ch
		test	byte ptr ds:[si], 0eh
		pop	ds
		jnz	short Update_Sensor_End
ifdef	LM75_Support
		extrn	Update_LM75_Screen:near
		call	Update_LM75_Screen
endif;	LM75_Support
ifdef	LM78_Support
		extrn	Update_LM78_Screen:near
		call	Update_LM78_Screen
endif;	LM78_Support
ifdef	GL518SM_Support					;R05
		extrn	Update_GL518SM_Screen:near	;R05
		call	Update_GL518SM_Screen		;R05
endif	;GL518SM_Support				;R05
ifdef	W83781D_Support					;R07
		extrn	Update_W83781D_Screen:near	;R07
		call	Update_W83781D_Screen		;R07
endif	;W83781D_Support				;R07
ifdef	SIS5595_Support					;R07
		extrn	Update_SIS5595_Screen:near	;R08
		call	Update_SIS5595_Screen		;R08
endif	;SIS5595_Support				;R08
Update_Sensor_End:
ENDIF	;SENSOR_KERNEL

	   	retf
Update_Sensor_Screen	Endp
;R01 - end

ECODE		ENDS
		END
