;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R01	05/15/97 RAX	Add "SMB_32BIT_MARK" for 16-32 bit code merge
;R00	09/04/96 JASON	Final release
;----------------------------------------------------------------------------

ifdef	SMBIOS_INTERFACE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;                  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;  SMB START HERE  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;                  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;---- error message ----

SMB_OK				EQU	00h	;call has been successfully completed
SMB_OK_SMI			EQU	80h	;call has been successfully completed
						;and a previously unreported SMI has taken place.
SMB_CONNECT_FAILED		EQU	01h	;SMB connect failed
SMB_ALREADY_CONNECTED		EQU	02h	;SMB already connected
SMB_DISCONNECTED_FAILED		EQU	03h	;SMB disconnected failed
SMB_NOT_CONNECTED		EQU	04h	;SMB not connected
SMB_INT15_DISABLED		EQU	05h	;SMB int 15h disabled
SMB_ADDRESS_OUTOF_RANGE		EQU	06h	;SMB address request out of range
SMB_UNKNOWN_FAILURE		EQU	07h	;SMB unknown failure
SMB_MESSAGE_LIST_EMPTY		EQU	08h	;SMB message list empty
SMB_MESSAGE_LIST_OVERFLOW	EQU	09h	;SMB message list overflow
SMB_INVALID_SIGNATURE		EQU	0ah	;SMB invalid signature
SMB_NOT_ACKNOWLEDGED		EQU	10h	;SMB device address not acknowledged
SMB_ERROR_DETECTED		EQU	11h	;SMB device error detected
SMB_COMMAND_ACCESS_DINIED	EQU	12h	;SMB device command access denied
SMB_UNKOWN_ERROR		EQU	13h	;SMB unknown error
SMB_TRANSACTION_PENDING		EQU	14h	;SMB transaction pending
SMB_NO_TRANSACTION_PENDING	EQU	15h	;SMB no transaction pending
SMB_PENDING_NOT_MATCH		EQU	16h	;SMB request does not match pending transaction
SMB_DEVICE_ACCESS_DINIED	EQU	17h	;SMB device access denied
SMB_TIME_OUT			EQU	18h	;SMB timeout
SMB_UNSUPPORTED_PROTOCAL	EQU	19h	;SMB host unsupported protocal
SMB_BUSY			EQU	1ah	;SMB busy
SMB_SMI_DETECTED		EQU	1bh	;SMB SMI detected
SMB_NOT_SUPPORTED		EQU	86h	;SMB BIOS interface not supported


;---- Host status ----
SMB_HOST_TIMEOUT		EQU	10000000b	;timed out waiting for host
SMB_BAD_PROTOCOL_CODE		EQU	01000000b	;Received bad protocol code
SMB_RETURN_ERROR		EQU	00100000b	;There is error code waiting 
SMB_CONTINUE_NODATA		EQU	00010000b	;Translation continue, no data yet
SMB_CONTINUE_DATA		EQU	00001000b	;Translation continue, data waiting
SMB_COMPLETE_DATA		EQU	00000100b	;Translation complete, data waiting
SMB_COMPLETE_NODATA		EQU	00000001b	;Translation complete, no data waiting
SMB_NO_STATUS			EQU	00000000b	;No status available

SMB_No_Data_Pending_Complete	EQU	00h
SMB_No_Data_Pending_Continue	EQU	01h
SMB_Data_Pending		EQU	02h

SMB_REALMODE_ESTABLISHED	EQU	01h	;SMB BIOS real mode interface already established
SMB_16BIT_ESTABLISHED		EQU	02h	;SMB BIOS 16bit interface already established
SMB_32BIT_ESTABLISHED		EQU	03h	;SMB BIOS 32bit interface already established



;---- defined in pm_ram.inc begin-----
;SMB_STATUS			DB	?	    	;SMB run-time status
;	SMB_32BIT_CONNECTED	EQU	00000100b   	;=1 if 32 bit connection has been established
;	SMB_16BIT_CONNECTED	EQU	00000010b   	;=1 if 16 bit connection has been established
;	SMB_REALMODE_CONNECTED	EQU	00000001b   	;=1 if real mode connection has been established
;
;SMB_EXTEND_STATUS		DB	?	    	;SMB run-time extend status
;	SMB_IN_PROGRESS 	EQU	10000000b   	;=0 finished or not start yet, =1 In progress
;	SMB_BLOCKREAD_FLAG	EQU	01000000b	;if = 1 then you need save first byte to SMB_BLOCKREAD_COUNTER
;	SMB_WITH_PROTOCOL	EQU	00000100b   	;=1 if last CMD with PROTOCOL
;	SMB_WITH_ADDRESS	EQU	00000010b   	;=1 if last CMD with ADDRESS
;	SMB_WITH_DEVICE_CMD	EQU	00000001b   	;=1 if last CMD with DEVICE COMMAND
;
;SMB_LAST_PROTOCOL		DB	?		;save last protocol
;SMB_LAST_ADDRESS		DB	?		;save last address
;SMB_LAST_DEVICE_CMD		DB	?		;save last device command
;SMB_BLOCKREAD_COUNTER		DB	?		;block read counter
;SMB_OLD_CMD_BYTE		DB	?	    	;for save old kerboard controller command byte
;
;----for SMI use----
;SMB_FLAG			DB	?		;temp flag
;SMB_AX				Dw	?		;temp save AX
;SMB_BX				Dw	?		;temp save BX
;SMB_CX				Dw	?		;temp save CX
;SMB_DX				Dw	?		;temp save DX
;---- defined in pm_ram.inc end-------

;------------------------------------------------------------------------------
;SMB function list
;------------------------------------------------------------------------------
SMB_FUNCTION			EQU	53b0H
SMB_INSTALLATION_CHECK		EQU	01H
SMB_REALMODE_CONNECT		EQU	02H
SMB_16BIT_CONNECT 		EQU	03H
SMB_32BIT_CONNECT 		EQU	04H
SMB_DISCONNECT			EQU	05H
SMB_DEVICE_ADDRESS		EQU	06H
SMB_CRITICAL_MESSAGE		EQU	07H
SMB_REQUEST			EQU	10H
SMB_REQEST_CONTINUATION		EQU	11H
SMB_REQUEST_ABOUT		EQU	12H
SMB_REQUEST_DATA_STATUS		EQU	13H


;------------------------------------------------------------------------------
;SMB Miscellaneous
;------------------------------------------------------------------------------
SMB_BIOS_Version_Number		EQU	0100h	;in BCD format( XX##: xx major, ## minor )
SMB_Vendor_Hardware_Code	EQU	0000h	;
SMB_32BIT_MARK			EQU	5432h	;R01

;----port----
SMB_CMDandSTATUS_Port		EQU	64h	;command (if write), status( if read)
SMB_Data_Port			EQU	60h	;

;----command----
SMHostRead			EQU	0DBh	;for Phoenix KBC
SMHostWrite			EQU	0DCh	;

;SMGetStatus			EQU	80h	;For award KBC
;SMGetErrorCode			EQU	81h	;
;SMHostWriteContinue		EQU	87h	;
;SMAbortTrans			EQU	82h	;
;SMReadCriticalMsg		EQU	83h	;
;SMHostRead			EQU	88h	;
;SMHostWrite			EQU	86h	;

;----protocol----
SMQuickCommand			EQU	00h	;
SMSendByte			EQU	01h	;
SMReceiveByte			EQU	02h	;
SMWriteByte			EQU	03h	;
SMReadByte			EQU	04h	;
SMWriteWord			EQU	05h	;
SMReadWord			EQU	06h	;
SMBlockWrite			EQU	07h	;
SMBlockRead			EQU	08h	;
SMProcessCall			EQU	09h	;

endif	;SMBIOS_INTERFACE

