;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R05	10/27/97 JDN	Added codes for YMF715
;R04	02/03/97 DNL	Added codes for save/restore PnP cards,Sound cards,
;			Modem cards
;R03	12/13/96 DNL	Added space to support suspend_to_DRAM function
;R02	09/03/96 DNL	Change offset value to support new structure
;R01	11/29/95 DNL	Add save COM FIFO control register
;R00	03/16/95 BEN	Initial for Notebook.
;----------------------------------------------------------------------------

;		+-----------------------+
;		|			|
;		|  386 BIOS DATA AREA	|
;		|			|
;		+-----------------------+

			INCLUDE	BIOS.CFG

SMBASE_Segment		EQU	03000H
;[]=====================================================================[]
;	SMM RAM segment definition for Intel & Cyrix CPU 
;[]=====================================================================[]
			ORG	08000H
Cyrix_SMI_Entry		LABEL	BYTE
SMI_Entry		LABEL	BYTE

;R04 - start
			ORG	0B400h
PNP_Device_Save		LABEL	BYTE
			ORG	0B600h
Modem_Device_Save	LABEL	BYTE
;R04 - end
;R02			ORG	08400H
			ORG	0B800h		;R02
BIOS_Entry_Save		LABEL	BYTE		; Need 512 byte
;R02			ORG	08600H
			ORG	0BA00h		;R02
SMM_Temp_Buffer		LABEL	BYTE		; Need 512 byte

			ORG	0BFF0H
STACK_TOP		DW	?

			ORG	0C000H
NoteBook_Suspend_Buffer	Label	Byte

	Save_8259_Area		DB	16 dup(?)
		;----------------------------------
		; Master ICW1:	Save_8259_Area+0
		; Master ICW2:	Save_8259_Area+1
		; Master ICW3:	Save_8259_Area+2
		; Master ICW4:	Save_8259_Area+3
		; Master OCW1:	Save_8259_Area+4
		; Master OCW2:	Save_8259_Area+5
		; Master OCW3:	Save_8259_Area+6
		; Reserve    :	Save_8259_Area+7
		; Slave ICW1 :	Save_8259_Area+8
		; Slave ICW2 :	Save_8259_Area+9
		; Slave ICW3 :	Save_8259_Area+10
		; Slave ICW4 :	Save_8259_Area+11
		; Slave OCW1 :	Save_8259_Area+12
		; Slave OCW2 :	Save_8259_Area+13
		; Slave OCW3 :	Save_8259_Area+14
		; Reserve    :	Save_8259_Area+15
		;----------------------------------
	Timer_8254_Save		DB	9 DUP(?)
	DMA_Page_Save		DB	100 DUP(?)
	Port92_Save		DB	?
	Port61_Save		DB	?
	Save_8042_Command	DB	?
	Save_8042_Output	DB	?
	Save_Mouse_State	DB	?
	Save_Mouse_Resolution	DB	?
	Save_Mouse_Sample_Rate	DB	?
;R01	COMA_Status		DB	7 DUP(?)
;R01	COMB_Status		DB	7 DUP(?)
	COMA_Status		DB	8 DUP(?)	;R01
	COMB_Status		DB	8 DUP(?)	;R01
	Save_FDC_3F2		DB	?
	Save_FDC_3F7		DB	?
	SS_Save			DW	?
	ESP_Save		DD	?
	FPU_Status		DB	94 DUP(?)

;R03 - start
			ORG	0C200H
KBC_State_Save		Label	Byte
			ORG	0C600H
Ct_IO_State_Save	Label	Byte
			ORG	0C700H
Super_IO_State_Save	Label	Byte
;R03 - end
;R02			ORG	0C800H
;R03			ORG	0C400H			;R02
			ORG	0C800H			;R03
VGA_State_Save		Label	Byte

	;---------------------------
	; Standard VGA state save
	;---------------------------
	TSR_Index_Save		DB	?		; Timming Sequencr index
	CRTC_Address_Save	DW	?		; CRTC address
	CRTC_Index_Save		DB	?		; CRTC index
	GDC_Index_Save		DB	?		; graphic index
	ATC_Index_Save		DB	?		; attributes index
	Feature_Control_Save	DB	?		; Feature control
	TSR_Save		DB	04h DUP(?)	; sequencr reg 1 - 4
	VGA_Misc_Save		DB	?		; VGA Misc. Register
	CRTC_Save		DB	19h DUP(?)	; CRTC 0 - 18h
	ATC_Save		DB	14h DUP(?)	; Attribute  0 - 13h
	GDC_Save		DB	09h DUP(?)	; Graphic control register 0 - 8
	DAC_State_Save		DB	?		; DAC register R/W status
	PEL_Address_Save	DB	?		; PEL address
	PEL_Mask_Save		DB	?		; PEL mask
	Color_Select_Save	DB	?		; Color select register
	DAC_Save		DB	256*3 DUP(?)	; DAC register

	;---------------------------
	; Extended VGA state save
	;---------------------------
Extended_VGA_Save	Label	Byte

			ORG	0D000H
Chipset_State_Save	Label	Byte

;R04 - start
			ORG	0E600H
Sound_State_Save	Label	Byte
;R05 - start
ifdef 	YMF715
			ORG	0E630H
WSS_Save		LABEL	Byte
endif	;YMF715
;R05 - end
			
;R04 - end
;
; The following offset is SMM save area for suspend save SMBASE.
; We must save & restore SMBASE within suspend/resume when resume reset CPU.
;
			ORG	0E800H
SMM_State_Save		LABEL	BYTE

			ORG	0FE00H
Intel_SMM_State		LABEL	BYTE		; SMM state for INTEL CPU
Cyrix_CPU_State		LABEL	BYTE		; Cyrix CPU state Save area

			ORG	0FEF8H
SMBASE_LOC		LABEL	BYTE		; SMBASE check for INTEL CPU

; The following offset is SMM save area
			ORG	0FFD0H
Cyrix_SMM_State		LABEL	BYTE		; SMM state for Cyrix CPU
