
        OperationRegion	(
                ITE1, 		// name of Operation Region for SuperIO device
                SystemIO, 	// type of address space
                0x3F0, 		// base address for Configuration Mode
                0x2)		// size of region in bytes

        Field ( ITE1,		// name of Operation Region containing field
                ByteAcc, 	// access in Byte mode
                NoLock, 	// may change, depending on SMI behavior
                Preserve) {	// Update Rule

                         INDX,8,		//field named INDX is 8 bits wide
                  DATA,8, 		//field named DATA is 8 bits wide
                 }


        OperationRegion	(
                ENG1,		// name of Operation Region for SuperIO device
                SystemIO, 	// type of address space
                0x279, 		// base address for Configuration Mode
                0x1)		// size of region in bytes

        Field ( ENG1,		// name of Operation Region containing field
                ByteAcc, 	// access in Byte mode
                NoLock, 	// may change, depending on SMI behavior
                Preserve) {	// Update Rule

                 CONG,8		//field naemd CONG is 8 bits wide
                 }
        IndexField (INDX, DATA, ByteAcc, NoLock, Preserve) {
                Offset(2),
                CFG,8, 		//global config control register
                Offset(7),
                LDN_,8, 	//Logical Device Number, offset 0x07
                Offset(0x22),
                POWC,8,
                Offset(0x30),
                ACTR,8, 	//activate register, offset 0x30
                Offset(0x60),
                IOAH,8, 	//base I/O addr, offset 0x60
                IOAL,8,
                IOBH,8,
                IOBL,8,
                Offset(0x70),
                INTR,8, 	//IRQ, Offset 0x70
                Offset(0x72),
                INT1,8, 	//Second IRQ for some devices, Offset 0x72
                Offset(0x74),
                DMCH,8, 	//DMA channel, offset 0x74
                Offset(0xC0),
                GP40,8, 	//Fast IR control bits, Offset(0xC0)
                Offset(0xF0),
                OPT1,8, 	//Option register 1, Offset(0xF0)
                OPT2,8, 	//Option register 2
                OPT3,8 		//Option register 3
                } 		//end of indexed field

Method(ENFG,0)	{ 		// Enter Config Mode for ITE8680

                Store(0x86, CONG)
                Store(0x61, CONG)
                Store(0x55, CONG)
                Store(0x55, CONG)

                Store(0x6A, INDX)
                Store(0xB5, INDX)
                Store(0xDA, INDX)
                Store(0xED, INDX)
                Store(0xF6, INDX)
                Store(0xFB, INDX)
                Store(0x7D, INDX)
                Store(0xBE, INDX)
                Store(0xDF, INDX)
                Store(0x6F, INDX)
                Store(0x37, INDX)
                Store(0x1B, INDX)
                Store(0x0D, INDX)
                Store(0x86, INDX)
                Store(0xC3, INDX)
                Store(0x61, INDX)
                Store(0xB0, INDX)
                Store(0x58, INDX)
                Store(0x2C, INDX)
                Store(0x16, INDX)
                Store(0x8B, INDX)
                Store(0x45, INDX)
                Store(0xA2, INDX)
                Store(0xD1, INDX)
                Store(0xE8, INDX)
                Store(0x74, INDX)
                Store(0x3A, INDX)
                Store(0x9D, INDX)
                Store(0xCE, INDX)
                Store(0xE7, INDX)
                Store(0x73, INDX)
                Store(0x39, INDX)

                } 		// end ENFG method

Method(EXFG,0)	{		// Exit Config Mode for ITE8680
                Store(0x02, CFG)

                } 		// end EXFG method

                Include	("8661FDC.asl")
                Include	("8661UAR1.asl")
                Include	("8661UAR2.asl")
                Include	("8661LPT.asl")
                Include	("PS2.asl")

