;	[]===========================================================[]
;
;	NOTICE:	THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;		INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE
;		DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED
;		WRITTEN AUTHORIZATION FROM THE OWNER.
;
;	[]===========================================================[]
;

;************************************************************************
;*	This file will be included in PMUPOST.ASM, and compiled		*
;*	with 3 stages. All codes occupied at E000 segment, and		*
;*	some codes will be remove to SMI RAM for run-time execution.	*
;************************************************************************

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R00	03/26/97 KEN	Rename original USBBIOS.ASM as UHCI.ASM, and added
;			OHCI.ASM for supporting OpenHCI. Some host controller
;			independent codes will be moved to new USBBIOS.ASM
;			in future.

IF	COMPILE_FOR_USBBIOS EQ 1

;****************************************************************
;*								*
;*	COMPILING STAGE 1					*
;*								*
;*	MISCELLANEOUS DEFINITION				*
;*								*
;****************************************************************

	INCLUDE HCI.EQU
	INCLUDE USB.EQU

USB_RAM SEGMENT USE16	AT 0
	INCLUDE HCDATA.INC
USB_RAM ENDS

ENDIF	;COMPILE_FOR_USBBIOS EQ 1

IF	COMPILE_FOR_USBBIOS EQ 2

;****************************************************************
;*								*
;*	COMPILING STAGE 2					*
;*								*
;*	POST INITIALIZATION CODES OCCUPIED AT E000 SEGMENT	*
;*								*
;****************************************************************

ENDIF	;COMPILE_FOR_USBBIOS EQ 2

IF	COMPILE_FOR_USBBIOS EQ 3

;****************************************************************
;*								*
;*	COMPILING STAGE 3					*
;*								*
;*	RUN-TIME EXECUTION CODES RESIDENT AT SMI RAM		*
;*								*
;****************************************************************

ENDIF	;COMPILE_FOR_USBBIOS EQ 3

;****************************************************************
;*								*
;*	HOST CONTROLLER INTERFACE				*
;*								*
;****************************************************************

IFDEF	UHCI
	INCLUDE	UHCI.ASM
ENDIF	;UHCI

IFDEF	OHCI
	INCLUDE	OHCI.ASM
ENDIF	;OHCI
