;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;
;----------------------------------------------------------------------------
;Rev  	Date	  Name	Description
;----------------------------------------------------------------------------
;R78	12/17/97  RCH	Added AMD-K6 3D CPU display , the CPU model is 058X.
;R77	11/25/97  DNL	Add show For Intel Tillamook CPU
;R76	11/20/97  DRS	Support M1 150Mhz(75*2) to report CPU75
;R75	11/07/97  RAY	Some chipset will hang up when accessing port 22/23
;			in the measuring speed routine. So we only access
;			these ports if it is Cyrix CPU by checking CPU_BRAND[bp]
;			which is ready in POST 09h
;R74	11/05/97  RCH	Added ELAN/400 chipset support
;R73	11/04/97  RCH	Added Unannounced Pentium/MMX CPU (058X) support
;R72	10/31/97  TNY	Add "No_105MHz" for 2a59iz1c.cfg.
;R71A	10/27/97  RCH	Don't turn ECC off if host clock is 100MHz for
;			Pentium II & Deschutes CPUs
;R71	10/23/97  RCH	Added Pentium II L2 cache ECC controlled by user
;			CMOS setup.
;R70	10/13/97  RCH	Fixed error coding for programming C6's 
;			"write combing".
;R69	10/03/97  RAY	When M1 75x2, we should set CPU75 instead of CPU66
;R68	09/26/97  RAY	Add switch: Special_CPU_Clock_Table which make the BIOS
;			do not reference the NewCPU_Int_Clock_Tbl. Instead, the
;			BIOS that defined this switch should add a new table 
;			named "Ct_Int_Clock_Tbl" in the EGROUP segment of CHIPPOST.ASM 
;R67	09/24/97  RAY	Add switch: No_55MHz to support those customers that do
;			not support 55MHz on their M/B
;R66	09/19/97  RCH	Fixed Pentium Pro & P2 CPUs patch code not executed
;			due to R156 of E0POST.ASM
;R65	09/18/97  RCH	Change CPU name from "IDT-C6" to "IDT WinChip C6",
;			requested by IDT.
;R64A	09/17/97  DRS	R64 coding mistake cause M2 75x2 being shown as PR166
;			which should be shown as PR200
;R64	09/13/97  DRS	1. Added M2 CPU auto core-to-bus clock ratio
;			   by referencing M2 register 0FEh which will reflect
;			   the clock ratio
;
;			2. Use new mothod to show P-Rating for M2
;			   e.g. 66x2.5(166Mhz) show PR200
;				83x2(166Mhz) show PR233
;
;R63	09/10/97  RCH	Added Deschutes CPU (065X) support for P6 class BIOS
;R62	09/08/97  TNY	Add "Lower_233Mhz_FOR_ICS" definition
;R06A	08/26/97  RCH	Added more models(058X & 059X) for K6 series CPUs
;R61	08/22/97  RCH	Change the clock mode for 300Mhz from 60x5 to 66x4.5
;			for Pentium class CPUs.
;R46B	08/19/97  KVN	Fixed the L2 cache of second Penitum Pro CPU always
;			be disabled.
;R60	08/01/97  RCH	Added AMD/K6 model 057X CPU ID(0.25 u) support
;R56B	07/30/97  RCH	Fixed CPU_CLOCK not set properly in G_RAM for chipset
;			reference. This bug cause the IDE timing can not
;			set properly.
;R55C	07/28/97  RCH	Cyrix request to show PR166 for 66x2 M2 CPU again.
;R59	07/24/97  TNY	Fix IDT C6 hang up when install NT 4.0
;R56A	07/22/97  TNY	Fix some M/B detection error(300 MHz to be 299 MHz).
;R58	07/18/97  RCH	The clock detection code already in shadow RAM(E-seg.)
;			It is not necessary to copy into base memory for
;			clock detection.
;R55B	07/17/97  RCH	Show PR150 instead of PR166 for 66x2 M2 CPU
;R40B   07/15/97  MIL	Fixed R40A coding mistake.
;R40A   07/12/97  MIL	Fixed MediaGxi 166MHz CPU detect to 180MHz problem.
;R55A	07/11/97  RCH	Show PR200 for M2 75x2 become standard.
;R57	07/11/97  KVN	POST runtime decompress code compact to subroutine
;R56	07/11/97  RCH	Re-write CPU detection algorithm for P6 class CPUs
;			to get more accurate clock report
;R55	07/04/97  RCH	Added special display for showing PR200 instead of
;			PR166 for M2 for specific customers(requested by Cyrix)
;R53A	07/02/97  AVN	Fixed SiS5596 for GEMLIGHT board still unstable, and
;			added define 'Special_Align_for_M1_Clock_unstable'
;			to save code for other chipset.
;R54	06/27/97  MIL   Added some code for MediaGx CPU running over 133MHz.
;R53	06/27/97  AVN	Fixed SiS5596 for GEMLIGHT board (2a5ifg3a) use CYRIX
;			M1 CPU and clock set 60MHz/66MHz x 2 frequence and
;			post detect cpu clock very unstable.
;R52	06/20/97  RAY	Change the display string of Gx86 to "MediaGX"
;R50B	06/20/97  RCH	Added "Write combining" for IDT-C6 CPU
;R50A	06/19/97  RCH	Don't display "MMX" & "-S" for IDT-C6 CPU
;R51	06/19/97  RCH	Added string "(tm)" display for AMD/K6 CPU
;R50	06/18/97  RCH	Added IDT/C6 CPU support. BIOS treat this CPU as
;			Pentium for CPU type that we don't need to modify
;			all chipset dependent codes
;R45B	06/16/97  RCH	Fixed system hang up if install DRAM over 512Mb and
;			dual Penitum II CPUs are plugged.
;R46A	06/12/97  RCH	Fixed the L2 cache of second Penitum II CPU always
;			be disabled.
;R49	06/05/97  RAY	Some customers do not want the BIOS the turn on the
;			Write Allocation of the K5 CPU
;R48	06/02/97  RCH	Many customers sale the PR133 AMD-K5 but the marking
;			of CPU is PR150, added a switch to display it if
;			customer need it.(SHOW_K5_PR150_INSTEAD_PR133)
;R47	05/29/97  KVN	Added a new segment for store more BIOS code
;R46	05/29/97  RCH	BIOS only disable first PPro/PII L2 cache if user
;			disable L2 cache for MP platform.
;R45A	05/29/97  RCH	Still set full cache address for onboard memory above
;			512Mb if L2 cache is disabled and using P II CPU
;R44A	05/26/97  RCH	The L2 cache size is saved in MPINIT.ASM
;R45	05/21/97  RCH	The L2 cacheable address range of current Pentium II
;			is 512Mb(BBL_CT_CTL3[22:20]=000), BIOS need to set
;			maximum cacheable range in CPU's MTRR to allow memory
;			size usage above 512Mb.
;R44	05/21/97  RCH	Fixed BIOS can not display L2 cache size of secondary
;			Klamath CPU in MP system
;R43	05/20/97  RCH	Added a item to separate "Video RAM" and "Video ROM"
;			cacheability control for P6 system
;R42	05/19/97  TNY	Add "NO_CPU_180MHZ_SUPPORT_FOR_ICS" definition.
;R39B	05/08/97  RCH	Completed PR-rating table for Cyrix/M2 CPU
;R18D	05/02/97  RCH	Change M2 CPU name from "M2" to "6x86MX", requested
;			by IBM(R).
;R39A	04/25/97  RCH	Fixed M2/188MHz can be displayed as PR233
;R41	04/23/97  RAY	Show "Gx86" instead of "Cx5x86" for Gx86 chip
;R40	04/23/97  RAY	There are Cyrix GX86 CPUs that report a 3-time clock
;			but in fact it is 4-time clock
;R39	04/21/97  RCH	Temporary PR-rating display for M2. It's not final.
;R18C	04/21/97  LRY	Removed showing Cyrix M2 the string '-MMX'
;R38	04/18/97  RCH	Disable "bus pipeline" for K5 CPU with model 1,2 & 3
;			and stepping of 4 to get more stable operation
;			Requested by AMD.
;R32C	04/18/97  RCH	Changed CPU display for K6 from K6/PR2-XXX to K6/XXX
;R22B	03/27/97  LRY	Define "CLOCK_TBL_FOR_ICS" for ICS clock generator
;R37	03/25/97  TNY	Fix "CLOCK_TBL_FOR_ICWORK" 133 Mhz table.
;R36	03/17/97  TNY	Add "Lower_150MHz_Tbl" definition.
;R26A	03/05/97  LRY	Disable write cacheability detection not only for
;			intel chipset, otherwise screen maybe have garbage
;R35	03/05/97  LRY	For Cyrix M2 P200, fixed 2x & 2.5x  CPU clock sizing
;R32B	02/27/97  RAY	AMD change the K6 string to 'AMD-K6/PR2-XXX' where
;			XXX is the core freq.
;R34	02/18/97  RAY	Change the string "KLAMATH" to "PENTIUM II" as
;			requested by Intel.
;R32A	02/21/97  RAY	AMD insists the string 'AMD-K6/PRXXX'
;R33	02/17/97  TNY	Enlarge intel 75MHz table.
;R32	02/17/97  RAY	Support AMD's requests for K6 CPU:
;
;		  	  1. Do not display 'MMX' on screen
;			  2. Show P-rating according to the core freq. of
;			     the CPU
;
;R31	02/17/97  AVN	For some motherboard use 68MHz clock for AMD K5 CPU
;			BIOS show 150MHz, Now it will show 166MHz and no 60x2
;			clock support by define 'K586_68MHz_Show_133MHz'
;R29A	02/14/97  RCH	The ALD/486 problem is caused by BOOTROM.ASM and it is
;			fixed with R104D, so restore to original source.
;R22A	02/14/97  TNY	Add ICWORK clock range.
;R25A	02/14/97  KVN	Fixed no show full screen logo bug on 2M BIOS and you
;			combine logo pattern at first area
;R30	02/13/97  RCH	Some customers don't need 240Mhz support for Klamath
;			due to high frequency output for specific clock
;			generator.
;R29	01/31/97  RAY	Fix ALD 486 chipset cannot dectect AMD DX4 CPU
;R28	01/27/97  RCH	Cyrix request to display "PR" instead of "P" rating.
;			same as AMD's CPU
;R27	01/24/97  RCH	Move P6 USWC code for video display buffer from
;			chippost.asm to kernel control.
;R18B	01/24/97  RCH	Support M2 CPU for using INTEL flash and the boot
;			block can not be flashed.
;R18A	01/24/97  RCH	Support M2 CPU become standard feature
;R26	01/22/97  RAY	Add Write Allocation support for K6 CPU
;R25	01/21/97  KVN	Change MOV_SHAD_SEG value become 8000h to avoid conflit
;			with POST runtiime decompress data
;R24	01/15/97  KVN	Remove P6 micro code to ROM driver pool from 0E000h
;			POST location
;R23	01/09/97  RCH	Add support both Pentium Pro and Klamath CPUs in one
;			BIOS. Note: It need 3 swtich in BIOS.CFG
;				BOTH_P6_KLAMATH_CPU	EQU	1
;				KLAMATH_CPU_ONLY	EQU	1
;				P6_BIOS_ONLY		EQU	1
;R22	01/07/97  RCH	ICWORKS clock generator's frequency is too slow, so
;			create special table for clock judgement.
;R21	01/07/97  RCH	Added 2nd CPU L2 cache initials. (Note: the code not
;			test yet)
;R20	12/27/96  RCH	Scan memory boundary from A31 to A16 due to 64Kb unit
;			for POST memory scanning for P6 MTRR setting.
;R19	12/23/96  RCH	Show PR200 for AMD-K5 133Mhz(only for CPUID 053X)
;R17B	12/20/96  RAY	According to AMD's request: always enable the fix
;			range(A0000-FFFFF) of the K5 write allocation.
;			Bit set is disabling fix range's write allocation.
;			this bit cleared will cause some PCI/VGA graphic
;			display failure.
;R18	12/13/96  RCH	Temporary support M2 CPU, This code must be modified
;			after receiving sample.
;R17A	12/12/96  RCH	Fixed error programming of AMD/K5 write allocation
;			for memory hole from 15M-16M
;R13A	12/11/96  RAY	The AMD K5's clock 50x1.75 entry should be
;			placed after 60x1.5 entry to prevent system loading
;			the 50Mhz setting when running on a 90Mhz Pentium.
;R10B	12/07/96  RAY	Show 'MMX' for AMD K6 CPU
;R14A	12/07/96  RAY	Re-define the input/ouput of routine Try_Show_PRating
;			such that:
;
;			1. The screen will not mess up if there are CPUs
;			   in the future that we do not recgonize
;			2. Use word comparison for the CPU_INT_CLOCK[bp]
;			   instead of byte to prepare for future CPUs that
;			   may be having clock running over 255 MHz or
;			   having P-Rating over 255
;
;R17	12/05/96  RAY	Enable Write Allocation for AMD K5 CPUs
;R16	12/05/96  RAY	Save codes by replacing "F000_CALL Get/Set_CMOS"
;			with "call F000_Get/Set_CMOS"
;R10A	12/04/96  RAY	More supports for AMD K6 in the following manners:
;
;			1. Show "AMD-K6" instead of "AMD-K5" for K6 CPU
;			2. Do not show P-rating in the current stage and
;			   will wait for AMD's further information.
;			3. K6 will have the same CPU type (in terms of value
;			   in CMOS 3Dh). All you have to do to differentiate
;			   K5 & K6 is to call a new public routine named
;			   "Check_K6_CPU"
;
;R15	12/04/96  RCH	Added 187Mhz & 250Mhz table for future P5-class CPUs
;R14	12/03/96  RAY	By AMD's request:
;
;			Do not show the actual internal CPU clock for AMD
;			& Cyrix CPU on screen by default.
;
;			Add switch: DISP_MHZ_FOR_AMD_CYRIX to bypass the
;			above default, i.e. always show internal clock
;
;R13	11/30/96  RAY	Added AMD-K5 CPU with ID = 052xh & 053xh
;R12	11/30/96  RAY	1. Move all the CPU related code from E0POST.ASM &
;			   E8POST.ASM to here for easy debugging
;
;			2. Since there are codes should be linked to addr.
;			   between E8000-EFFFF, so add switch COMPILE_FOR_E0=0/1
;			   in BIOS.MAK to compile this ASM file twice to
;			   generate CPUPOST.OBJ & CPUPE8.OBJ such that:
;
;			   CPUPOST.OBJ: linked before the fix ORG at E8000
;			   CPUPE8.OBJ: linked after the fix ORG at E8000
;
;			3. Change the assembler from 5.10A to 6.X
;
;			   ifdef   MASM611
;			   .MODEL  SMALL, BASIC
;			   OPTION  PROC: PRIVATE
;			   endif   ;MASM611
;
;R11	09/16/96  RCH	Added Klamath CPUID(063x) support
;R10	07/29/96  RCH	Added AMD-K6 CPU family ID support (056xh)
;R09	04/23/96  RCH	Don't touch BTB if the CPU stepping is 051x or 052x
;			due to extreme performance degraded for 0512H
;			stepping.
;R08	04/05/96  RCH	Public "Temp_Int06" for new CPU clock detection
;			algorithm.
;R07	03/11/96  RCH	Added CPU ID 163x for INTEL P6T CPU
;R06	03/04/96  RCH	Fixed 100Mhz 6x86 CPU can not detected while update
;			BIOS with INTEL boot block flash ( 28F001BX-T )
;R05	01/24/96  RCH	Added AMD/K5 CPU new family 051X support
;R04	01/18/96  RCH	Disable CPU local APIC for P6 if it is not MP system
;R03	12/15/95  RAY	Add CPU level information, i.e. 486, 586 or 686 ...
;R02	12/07/95  RAY	Add X5 CPU information
;R01	11/30/95  RAY	Since routine Temp_Int06 has moved to E000 segment,
;			we should also fill the high word of the G_RAM:[int06]
;			with E000h ! Otherwise, CPUs do not support CPUID
;			instruction will hang up here !

;R12 - starts
ifdef	MASM611
.MODEL  SMALL, BASIC
OPTION	PROC: PRIVATE
endif	;MASM611

.386p
		PAGE	60,132
		TITLE	CPU - CONTROL SPECIFIC CPU FUNCTIONS
;R12 - ends

.XLIST
		INCLUDE BIOS.CFG

		INCLUDE COMMON.EQU
		INCLUDE POST.EQU
		INCLUDE	CPU.EQU
		include	8259.equ	;R12
		include	p6update.equ	;R12

		INCLUDE	COMMON.MAC
		INCLUDE	POST.MAC

;R12 - starts
G_RAM		SEGMENT USE16 AT 0

		ORG	04H*4
		INCLUDE SEG_0.INC

		ORG	400H
		INCLUDE G_RAM.INC

G_RAM		ENDS
;R12 - ends

;IF	COMPILE_FOR_E0					;R12
IF	COMPILE_FOR_E0					;R12

 ifdef	L2ECC_CMOS					;R71
		extrn	L2Ecc_Item:near			;R71
 endif;	L2ECC_CMOS					;R71

		extrn	POST_decompress:near		;R57
		extrn	F000_GetItem_Value:near		;R45A
		extrn	ExtCache_Item:near		;R45A

		EXTRN	ROM_AND_CMOS:NEAR
		EXTRN	ROM_OR_CMOS:NEAR
		extrn	POST_func_end:Near
		extrn	POST_VECT:Near

		extrn	Check_Cyrix_Cpu:near
		extrn	Init_Cyrix_Reg:near
		extrn	Get_Cmos:near
		extrn	Set_Cmos:near
		extrn	F000_call_proc:near
		extrn	F000_Shadow_W:Near		;R09
		extrn	F000_Shadow_R:Near		;R09

		extrn	LOCK_CYRIX:Near			;R12
		extrn	UNLOCK_CYRIX:Near		;R12
		extrn	LOCK_CYRIX:Near			;R12
		extrn	SET_CYRIX:Near			;R12
		extrn	GET_CYRIX:Near			;R12
		extrn	Check_M1_Cpu:near		;R12
		extrn	F000_Get_Cmos:near		;R12
		extrn	F000_Set_Cmos:near		;R12

;R09 - start
ifdef	ESCD_SUPPORT
ifndef	ESCD_M2
IF BUS_TYPE NE EISA_BUS
		extrn	P5_BtB_Loc:near
endif; BUS_TYPE NE EISA_BUS
endif;	ESCD_M2
endif;	ESCD_SUPPORT
;R09 - end

IF	BIOS_SUPPORT_586				;R17
 		extrn	Check_K586_Cpu:Near 		;R17
		extrn	Read_CpuID:Near			;R17
		extrn	Ct_MemHole_Status:Near		;R17
		extrn	Check_M2Cpu:near		;R64
ENDIF	;BIOS_SUPPORT_586				;R17
		extrn	Cpu_Cache:near	;R24
IF	BIOS_SUPPORT_686				;R45
		extrn	Read_CpuID:Near			;R45
		extrn	P6_L2Cache_Control:near		;R46
endif;	BIOS_SUPPORT_686				;R45

ifdef	Special_CPU_Clock_Table			;R68
		extrn	Ct_Int_Clock_Tbl:Near	;R68
endif	;Special_CPU_Clock_Table		;R68

.LIST
;R12 .386p
;R12 		PAGE	60,132
;R12 		TITLE	CPU - CONTROL SPECIFIC CPU FUNCTIONS

EGROUP		GROUP	ECODE
ECODE		SEGMENT USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP,DS:EGROUP

;=============================================================================
;FUNC:	CYRIX_INIT
;
;DESC:	Handles the initialization of the CYRIX CPU.
;
;IN:	NONE
;OUT:	NONE
;
;SAVES:	NONE + NO STACK
;
;BY:	Richard Chen
;DATE:	18 May 1992
;=============================================================================
FLAGS_MASK	EQU	08D5H

		public	CYRIX_INIT
CYRIX_INIT	proc	near

;R18B;R06 - start
;R18BIF	BIOS_SUPPORT_586
;R18B;Cyrix have a cut of wrong CPU ID ( 21H & 23H ) . We implement it in boot
;R18B;block BOOTROM.ASM , but this 8K code can be updated if INTEL boot block
;R18B;flash was used. So re-check the CPU here.
;R18B
;R18B		F000_call	Check_Cyrix_Cpu
;R18B		jnz	short Not_Wrong_M1
;R18B
;R18B		;check if M1 already
;R18B		mov	al,CMOS_AWARD_2 NMI_OFF	; al = CMOS location
;R18B;R16		F000_CALL	Get_Cmos
;R18B		call	F000_Get_Cmos		;R16
;R18B		and	al,CPU_TYPE_MASK
;R18B		cmp	al,TYPE_M1		;M1 CPU ?
;R18B		je	short Not_Wrong_M1
;R18B
;R18B		mov	al,0feh			;DIR 0
;R18B		out	22h,al
;R18B		in	al,23H			;read CPU device ID
;R18B		cmp	al,21H
;R18B		je	short Yes_Wrong_M1
;R18B		cmp	al,23H
;R18B		jne	short Not_Wrong_M1
;R18BYes_Wrong_M1:
;R18B
;R18B;set CPU type
;R18B		;clear clock mode , SMI bit and WB bit
;R18B		mov	al,OVERRIDE NMI_OFF
;R18B		mov	ah,NOT (CLOCK_MODE+((SMICPU+WBCPU) SHR 8))
;R18B		F000_CALL	ROM_AND_CMOS
;R18B
;R18B		;set CPU type in CMOS
;R18B		mov	bx,CPU_M1_2		;set CPU ID
;R18B		mov	ah,bl
;R18B		mov	al,CMOS_AWARD_2 NMI_OFF	; al = CMOS location
;R18B;R16		F000_CALL	Set_Cmos
;R18B		call	F000_Set_Cmos		;R16
;R18B
;R18B		;set clock mode
;R18B		mov	ah,bh
;R18B		mov	al,CMOS_OVERRIDE NMI_OFF
;R18B		F000_CALL	ROM_OR_CMOS
;R18B
;R18BNot_Wrong_M1:
;R18BENDIF	;BIOS_SUPPORT_586
;R18B;R06 - end

IF	BIOS_SUPPORT_386 OR BIOS_SUPPORT_486
;First , Check Intel or Cyrix CPU

		F000_call	Check_Cyrix_Cpu
		jnz	Not_Cy_Cpu

Yes_Cy:

;If cyrix CPU plugged, setup noncacheable region.
		mov	al,CMOS_AWARD_2 NMI_OFF
;R16		F000_CALL	Get_Cmos
		call	F000_Get_Cmos		;R16

		mov	ah,al
		xor	ah,ah
		and	al,CPU_TYPE_MASK

		cmp	al,TYPE_486DX
		jne	short Check_Cyrix_1

		call	Check_Cyrix_Dclk
		jc	short Not_486slc2

		mov	ax,CPU_CX486SLC2
		xchg	ah,al
		jmp	short Init_Cyrix
Not_486slc2:

		or	ah,TYPE_486SLC + CPUCACHE
		jmp	short Check_TI_CPU
Check_Cyrix_1:

		cmp	al,TYPE_486SX
 		jne	short Not_Cy_Cpu

	   	or	ah,TYPE_486DLC + CPUCACHE

Check_TI_CPU:
IF	BIOS_SUPPORT_TI_CPU
		push	eax
		mov	eax,200h

		DB	0FH,26H,0E0H		;mov	tr4,eax
		mov	eax,1

		DB	0FH,26H,0E8H		;mov	tr5,eax
		mov	eax,2

		DB	0FH,26H,0E8H		;mov	tr5,eax
		DB	0FH,24H,0E0H		;mov	eax,tr4
		and	eax,200h
		cmp	eax,200h
		pop	eax
		je	short Not_TiCpu

Is_TI486SXL:
	   	and	ah,CPU_TYPE_MASK
		cmp	ah,TYPE_486DLC
		mov	ax,CPU_TI486SXLC
		jne	short @F
		mov	ax,CPU_TI486SXL
@@:
		xchg	ah,al

Not_TiCpu:
ENDIF	;BIOS_SUPPORT_TI_CPU

Init_Cyrix:

		mov	al,CMOS_AWARD_2 NMI_OFF
;R16		F000_call	Set_Cmos
		call	F000_Set_Cmos			;R16

		mov	ah,CMOS_OVERRIDE NMI_OFF
		mov	al,ah
;R16		F000_CALL	Get_Cmos
		call	F000_Get_Cmos			;R16
		xchg	ah,al
		or	ah,SMICPU shr 8
;R16		F000_call	Set_Cmos
		call	F000_Set_Cmos			;R16

Not_Cy_Cpu:
ENDIF	;BIOS_SUPPORT_386 OR BIOS_SUPPORT_486

IFE	BIOS_SUPPORT_686				;R14
		F000_call	Init_Cyrix_Reg
ENDIF	;BIOS_SUPPORT_686				;R14

		ret

CYRIX_INIT	endp

;R18B - start
IF	BIOS_SUPPORT_586
M2Cpu_Tbl:
		db	21h,23h		;wrong stepping
		dw	CPU_M1_2	;2/1 for M1
M2CPU_LEN	EQU	($ - offset M2Cpu_Tbl)
		db	51h,59h		;2/1 for M2
		dw	CPU_M1_2
		db	52h,5Ah		;2.5/1 for M2
		dw	CPU_M1_3
		db	53h,5Bh		;3/1 for M2
		dw	CPU_M1_3
		db	54h,5Ch		;3.5/1for M2
		dw	CPU_M1_3
		db	0

Check_M2_M1_Cpu	proc	near

;Cyrix have a cut of wrong CPU ID ( 21H & 23H ) . We implement it in boot
;block BOOTROM.ASM , but this 8K code can not be updated if INTEL boot block
;flash was used. So re-check the CPU here.

		F000_call	Check_Cyrix_Cpu
		jnz	short Not_Wrong_M1

		;check if M1 already
		mov	al,CMOS_AWARD_2 NMI_OFF	; al = CMOS location
		call	F000_Get_Cmos
		and	al,CPU_TYPE_MASK
		cmp	al,TYPE_M1		;M1 CPU ?
		je	short Not_Wrong_M1

		mov	al,0feh			;DIR 0
		out	22h,al
		in	al,23H			;read CPU device ID

		call	Check_M2_Cpu
		jc	short Not_Wrong_M1

;set CPU type

		;clear clock mode , SMI bit and WB bit
		mov	al,OVERRIDE NMI_OFF
		call	F000_Get_Cmos
		mov	ah,al
		and	ah,NOT (CLOCK_MODE+((SMICPU+WBCPU) SHR 8))
		or	ah,bh
		mov	al,OVERRIDE NMI_OFF
		call	F000_Set_Cmos

		;set CPU type in CMOS
		mov	ah,bl
		mov	al,CMOS_AWARD_2 NMI_OFF	; al = CMOS location
		call	F000_Set_Cmos

Not_Wrong_M1:
		ret
Check_M2_M1_Cpu	endp

;Input  : AL - Device ID (DIR0) of M1(M2) CPU
;Output : Zero set - It's M2 CPU , and BX return CPU type to store in CMOS
Check_M2_Cpu	proc	near

		mov	si,offset M2Cpu_Tbl
Check_Next_M2:
		cmp	byte ptr cs:[si],0	;last table ?
		je	short Not_M2

		cmp	byte ptr cs:[si],al
		je	short Get_M2

		cmp	byte ptr cs:[si+1],al
		je	short Get_M2

		add	si,M2CPU_LEN
		jmp	short Check_Next_M2

Not_M2:
		stc
		ret
Get_M2:
		mov	bx,cs:[si+2]		;get CPU type
		clc


		ret
Check_M2_Cpu	endp
endif;	BIOS_SUPPORT_586
;R18B - end

;Input : none
;Output: carry clear - it's double clock
;	 carry set   - it's not double clock
Check_Cyrix_Dclk	proc	near
IF	BIOS_SUPPORT_386 OR BIOS_SUPPORT_486

		push	ax
		mov	al,CMOS_OVERRIDE NMI_OFF
;R16		F000_CALL	Get_Cmos
		call	F000_Get_Cmos			;R16
		and	al,NOT 11000000b		;set single clock
		mov	ah,al

		mov	al,0feh
		out	22h,al
		in	al,23h
		cmp	al,1bh	  			;Is DX2?
		je	short Yes_Dclk
		cmp	al,02h				;Is 486SLC2
		jne	short Not_Dclk
Yes_Dclk:
		or	ax,DOUBLECLOCK+SMICPU
		mov	al,CMOS_OVERRIDE NMI_OFF
;R16		F000_call	Set_Cmos
		call	F000_Set_Cmos			;R16
		pop	ax
		clc
		ret
Not_Dclk:
		mov	al,CMOS_OVERRIDE NMI_OFF
;R16		F000_call	Set_Cmos
		call	F000_Set_Cmos			;R16
		pop	ax
		stc
		ret

ENDIF	;BIOS_SUPPORT_386 OR BIOS_SUPPORT_486
Check_Cyrix_Dclk	endp

;[]========================================================================[]
;	Set the IBM CPU's Cacheable region: Bit 32-39 of register 1001h
;	according to the extended memory found!
;[]========================================================================[]
		Public	IBMCPU_Cacheable_Size
IBMCPU_Cacheable_Size	Proc	Near

IF	BIOS_SUPPORT_IBM_CPU
		mov	al,FIXED_DISK_STEP[bp]
		and	al,CPU_TYPE_MASK
		cmp	al,TYPE_IBM386SLC
		je	short Set_Cacheable_Size
		cmp	al,TYPE_IBM486SLC2
		je	short Set_Cacheable_Size
		cmp	al,TYPE_IBM486DLC3
		jne	short IBMCPU_Cacheable_Exit

Set_Cacheable_Size:

		mov	ecx,1001h
		RDMSR
		mov	ebx,EXT_MEM_SIZE[bp]
		shr	ebx,6			;in terms of 64k
		and	ebx,0FFh
		and	edx,not 0FFh
		or	edx,ebx
		WRMSR

IBMCPU_Cacheable_Exit:
ENDIF	;BIOS_SUPPORT_IBM_CPU

		ret

IBMCPU_Cacheable_Size	Endp

;[]------------------------------------------------------------------------[]
;[]------------------------------------------------------------------------[]
		Public	Chk_Intel_S_CPU
Chk_Intel_S_CPU	Proc	Near

		push	ds
		pushad

IF	BIOS_SUPPORT_486			;R14
;-----------------------------------------------------------------------
;There are 3 versions of AMD DX4 CPU
;	1. CPU ID = DX2	(With AMD SMI)
;	2. CPU ID = Intel's P24C (NO SMI)
;	3. AMD Plus Series
;
;The following algorithm is used to distiquish (2) with Intel's P24C
;	a. if ID <> P24C (i.e. 048X) then skip (b) & (c)
;	b. clear the SMICPU bit
;	c. issue CPUID instruction (which will set SMICPU bit if valid)
;	d. if ID <> P24C (i.e. 048X) then goto (g)
;	e. if SMICPU bit is set then goto
;	f. change CPU type to AMD DX4
;	g. exit
;-----------------------------------------------------------------------
		call	Chk_If_Type_P24C
		jne	short @F
		call	Clear_SMI_Bit
	@@:
ENDIF	;BIOS_SUPPORT_486			;R14

	;replace the original int 06h with a temparary
	;one to prevent trap accurs in some CPUs

		xor	eax,eax			;input value = 1
		mov	ds,ax
;R01		push	word ptr ds:[4*6]	;save int 06h vector
		push	dword ptr ds:[4*6]	;save int 06h vector	;R01
		mov	word ptr ds:[4*6],offset Temp_Int06
		mov	word ptr ds:[4*6+2], 0e000h			;R01


		push	ds

		push	cs
		pop	ds

	;issue special OP code: CPUID(00Fh,0A2h)
	;to check if it is a S-series CPU

		db	0Fh,0A2h		;OP code: CPUID

		mov	si,offset Cpu_Vendor_Tbl
Chk_Nxt_Vendor:
		cmp	word ptr [si],-1 	;last of CPU vendor table
;R09		je	short Finish_Cpu_ID	;yes,over !
		je	Finish_Cpu_ID		;yes,over !	;R09

		cmp	ebx,[si+2]		;check 1st identifier string
		jne	short Next_Vendor

		cmp	ecx,[si+6]		;check 2nd identifier string
		jne	short Next_Vendor

		cmp	edx,[si+10]		;check 3th identifier string
		je	short Good_Vendor

Next_Vendor:
		add	si,SIZE_VENDOR_TBL
		jmp	short Chk_Nxt_Vendor

Good_Vendor:
		call	Set_SMI_Bit

		mov	si,[si]	 		;get vendor's CPU ID table
	;Now , we got correct identifier of CPU, next step is to get CPU ID
		mov	eax,1			;eax = 1 to read CPU ID
		db	0fh,0A2h		;CPU ID instruction
		and	al,0f0h			;mask stepping bits b3-b0

Chk_Nxt_CpuID:
		cmp	word ptr [si],-1 	;last of CPU ID table
		je	short Finish_Cpu_ID

		cmp	ax,[si]			;match CPU ID ?
		je	short Save_Cpu_ID	;yes

		add	si,4			;next CPU ID
		jmp	short Chk_Nxt_CpuID
Save_Cpu_ID:

IF	BIOS_SUPPORT_586			;R14

;R59 - start
		pushad
		xor	eax,eax			;get vendor ID string
		db	0Fh,0A2h		;OP code: CPUID
		cmp	ebx,746e6543h		;C6 vendor ID string match ?
		popad
		je	short Not_P5			
;R59 - end


		cmp	word ptr [si+2],CPU_586		;PENTIUM CPU ?
		jne	short Not_P5

;R09 - start
ifdef	ESCD_SUPPORT
ifndef	ESCD_M2
IF BUS_TYPE NE EISA_BUS
		cmp	al,10H			;skip BTB for 051x
		je	short Skip_BtB
		cmp	al,20H			;skip BTB for 052x
		jne	short No_Skip_BtB

Skip_BtB:
	;skip BTB control for updating ESCD
		F000_CALL F000_Shadow_W
	;change instruction from "jne" to "jmp"
		mov	ax,0f000H		;code in F-segment
		mov	es,ax
		mov	byte ptr es:[P5_BtB_Loc],0EBH
		F000_CALL F000_Shadow_R

No_Skip_BtB:

endif; BUS_TYPE NE EISA_BUS
endif;	ESCD_M2
endif;	ESCD_SUPPORT
;R09 - end

;Disable PENTIUM parity check in TR1 register
                mov     eax,2
                mov     ecx,eax
                xor     edx,edx
                WRMSR

		;disable auto-halt mode by set bit 6 of TR12
		mov	ecx,0eh
		RDMSR
		xor	edx,edx
		mov	eax,40h
		WRMSR
Not_P5:
ENDIF	;BIOS_SUPPORT_586			;R14

;R04 - start
IF	BIOS_SUPPORT_686			;R14
ifndef	MP_SUPPORT				;R14
		cmp	word ptr [si+2],CPU_P6		;P6 CPU ?
		jne	short Not_P6

;R14 ifndef	MP_SUPPORT
;disable local APIC if not support MP
		mov	ecx,27			;MSR index 27
		RDMSR
		and	ah,NOT 08H		;disable CPU APIC
		WRMSR
;R14 endif;	MP_SUPPORT
Not_P6:
endif;	MP_SUPPORT				;R14
ENDIF	;BIOS_SUPPORT_686			;R14
;R04 - end

		mov	dx,[si+2]		;get CPU ID
		call	Set_CPU_Type_Bits
		jmp	short Finish_Cpu_ID

Finish_Cpu_ID:

		pop	ds

IF	BIOS_SUPPORT_486			;R14
;-----------------------------------------------------------------------
;if it is Type P24C without SMICPU bit,
;  then it must be a AMD-DX4 which has the same CPU ID with Intel's P24C
;So, change the CPU type to CPU_AMD486DX4
;-----------------------------------------------------------------------

		call	Chk_If_Type_P24C
		jne	short _A_Y_J
		call	Chk_SMICPU_Bit
		jnz	short _A_Y_J
		mov	dx,(CPU_AMD486DX4) AND (NOT SMICPU)
		call	Set_CPU_Type_Bits
	_A_Y_J:
ENDIF	;BIOS_SUPPORT_486			;R14

;R01		pop	word ptr ds:[4*6]	;restore int 06h vector
		pop	dword ptr ds:[4*6]	;restore int 06h vector	;R01

IF	BIOS_SUPPORT_586			;R18B
		call	Check_M2_M1_Cpu		;R18B
endif;	BIOS_SUPPORT_586			;R18B

		call	Prepare_CPU_Info
		popad
		pop	ds
		ret

;-------------------------------------------------------
; Temporary Int 06 handler for Non-(Intel S-Series) CPU
;-------------------------------------------------------
		public	Temp_Int06		;R08
;R12 Temp_Int06:
Temp_Int06	Label	Near			;R12
		push	bp
		mov	bp,sp
		add	word ptr ss:[bp+2],2
		pop	bp
		iret

Chk_Intel_S_CPU	Endp

Cpu_Vendor_Tbl:
		dw	offset Cpu_INTELs  	;table of INTEL CPUs
		dd	756E6547h	   	;Identifer string 1
		dd	6C65746eh	   	;Identifer string 2
		dd	49656E69h	   	;Identifer string 3
SIZE_VENDOR_TBL	EQU	$ - offset Cpu_Vendor_Tbl

IF	BIOS_SUPPORT_486			;R14
		dw	offset Cpu_UMCs	   	;table of UMC CPUs
		dd	20434d55h	   	;Identifer string 1
		dd	20434d55h	   	;Identifer string 2
		dd	20434d55h	   	;Identifer string 3
ENDIF	;BIOS_SUPPORT_486			;R14

IFE	BIOS_SUPPORT_686			;R14
		dw	offset Cpu_AMDs	   	;table of AMD CPUs
		dd	68747541h	   	;Identifer string 1
		dd	444d4163h	   	;Identifer string 2
		dd	69746e65h	   	;Identifer string 3
ENDIF	;BIOS_SUPPORT_686			;R14

;R50 - start
IF	BIOS_SUPPORT_586
		dw	offset Cpu_IDTs		;table of IDT CPUs
		dd	746e6543h		;Identifer string 1
		dd	736c7561h		;Identifer string 2
		dd	48727561h		;Identifer string 3
endif;	BIOS_SUPPORT_586
;R50 - end
		dw	-1		   	;last of CPU venders table

;CPU table for INTEL s-series CPUs
Cpu_INTELs:

IF	BIOS_SUPPORT_586
		dw	0510h,CPU_586			;PENTIUM 1/1
		dw	0520h,CPU_586			;PENTIUM 3/2
		dw	2520h,CPU_586			;PENTIUM 2/1
		dw	0540h,CPU_586			;PENTIUM 2/1
		dw	2540h,CPU_586			;PENTIUM 2/1
		dw	1520h,CPU_586			;PENTIUM 2/1 ODP
		dw	1540h,CPU_586			;PENTIUM 2/1 ODP
		dw	0570h,CPU_586			;PENTIUM 3/2
		dw	0580h,CPU_586			;PENTIUM/MMX	;R73
ENDIF	;BIOS_SUPPORT_586

IF	BIOS_SUPPORT_686
		dw	0610h,CPU_P6			;P6  Pentium pro
		dw	1610h,CPU_P6			;P6T
		dw	1630H,CPU_P6			;R07
		dw	0630H,CPU_P6			;R11 Pentium II
		dw	0650H,CPU_P6			;R63 Deschutes
ENDIF	;BIOS_SUPPORT_686

IF	BIOS_SUPPORT_486
		dw	0470h,(CPU_P24D) 		;P24D with WT
		dw	0480h,(CPU_P24C) 		;P24C with WT
		dw	1480h,(CPU_P24C) 		;P24C with ODP
		dw	0490h,(CPU_P24C) OR (WBCPU)	;P24C with WB
		dw	1490h,(CPU_P24C) OR (WBCPU)	;P24C with WB/ODP
		dw	1530h,CPU_P24T			;P24T
ENDIF	;BIOS_SUPPORT_486

		dw	-1				;last of table

		ALIGN	16				;R60

;CPU table for AMD s-series CPUs
Cpu_AMDs:
IF	BIOS_SUPPORT_586
		dw	0500H,CPU_AMD5K86
		dw	0510H,CPU_AMD5K86		;R05
		dw	0520H,CPU_AMD5K86		;R13
		dw	0530H,CPU_AMD5K86		;R13
		dw	0560H,CPU_AMD5K86		;R10
		dw	0570H,CPU_AMD5K86		;R60
		dw	0580H,CPU_AMD5K86		;R60A
		dw	0590H,CPU_AMD5K86		;R60A
endif;  BIOS_SUPPORT_586

IF	BIOS_SUPPORT_486
		dw	0430h,(CPU_AMD486PLUS) 		;DX2 plus WT
		dw	0470h,(CPU_AMD486WB_PLUS)      	;DX2 plus WB
		dw	0480h,(CPU_AMD486DX4PLUS)	;DX4 plus WT
		dw	0490h,(CPU_AMD486DX4WB_PLUS)	;DX4 plus WB
		dw	04E0h,(CPU_AMDDX5WT)		;DX5 plus WT
		dw	04F0h,(CPU_AMDDX5WB)		;DX5 plus WB
ENDIF	;BIOS_SUPPORT_486
		dw	-1

;CPU table for UMC s-series CPUs
Cpu_UMCs:
IF	BIOS_SUPPORT_486
		dw	0420h,CPU_U5			;486SX
		dw	0450h,CPU_U486SX2		;486SX2
		dw	0410h,CPU_U486DX		;486DX
		dw	0430h,CPU_U486DX2		;486DX2
ENDIF	;BIOS_SUPPORT_486
		dw	-1

;R50 - start
Cpu_IDTs:	;table of IDT CPUs
		dw	0520h,CPU_586			;C6 w/o MMX
		dw	0540h,CPU_586			;C6 w/  MMX
		dw	-1
;R50 - end

;[]==========================================================[]
;[]==========================================================[]
		Public	Chk_If_Type_P24C
Chk_If_Type_P24C:
IF	BIOS_SUPPORT_486			;R14
		push	ax
		mov	al,CMOS_AWARD_2 NMI_OFF
;R16		F000_CALL	Get_Cmos
		call	F000_Get_Cmos		;R16
		and	al,CPU_TYPE_MASK
		cmp	al,TYPE_P24C
		pop	ax
ENDIF	;BIOS_SUPPORT_486			;R14
		ret

;[]==========================================================[]
;[]==========================================================[]
		Public	Set_SMI_Bit
Set_SMI_Bit:
		mov	ah,CMOS_OVERRIDE NMI_OFF
		mov	al,ah
;R16		F000_CALL	Get_Cmos
		call	F000_Get_Cmos		;R16
		or	al,SMICPU shr 8
		xchg	ah,al
;R16		F000_call	Set_Cmos
		call	F000_Set_Cmos		;R16
		ret

;[]==========================================================[]
;[]==========================================================[]
		Public	Clear_SMI_Bit
Clear_SMI_Bit:
		mov	ah,CMOS_OVERRIDE NMI_OFF
		mov	al,ah
;R16		F000_CALL	Get_Cmos
		call	F000_Get_Cmos		;R16
		and	al,NOT (SMICPU shr 8)
		xchg	ah,al
;R16		F000_call	Set_Cmos
		call	F000_Set_Cmos		;R16
		ret

;[]==========================================================[]
;[]==========================================================[]
		Public	Chk_SMICPU_Bit
Chk_SMICPU_Bit:
		push	ax
		mov	al,CMOS_OVERRIDE NMI_OFF
;R16		F000_CALL	Get_Cmos
		call	F000_Get_Cmos		;R16
		test	al,SMICPU shr 8
		pop	ax
		ret

;[]==========================================================[]
;Input : DL = Value for CMOS_AWARD_2  (03DH)
;        DH = Value for CMOS_OVERRIDE (03FH)
;[]==========================================================[]
Set_CPU_Type_Bits:
		mov	al,CMOS_AWARD_2 NMI_OFF
		mov	ah,dl
;R16		F000_call	Set_CMOS
		call	F000_Set_Cmos		;R16

		mov	ah,CMOS_OVERRIDE NMI_OFF
		mov	al,ah
;R16		F000_CALL	Get_Cmos
		call	F000_Get_Cmos		;R16
		and	al,NOT (CLOCK_MODE+((SMICPU+WBCPU) SHR 8))
		or	al,dh
		xchg	ah,al
;R16		F000_call	Set_Cmos
		call	F000_Set_Cmos		;R16
		ret

;[]------------------------------------------------------------------------[]
;[]------------------------------------------------------------------------[]
		public	Intel_To_AMD
Intel_To_AMD	proc	near

IF	BIOS_SUPPORT_486
		pusha
		mov	al,CMOS_AWARD_2 NMI_OFF
;R16		F000_CALL	Get_Cmos
		call	F000_Get_Cmos		;R16
		and	al,CPU_TYPE_MASK
		mov	dx,CPU_AMD486
		cmp	al,TYPE_486DX
		je	short @F
		mov	dx,CPU_AMD486DX2
@@:
		call	Set_CPU_Type_Bits

		mov	word ptr CPU_BRAND[bp],((SMI_TYPE_OLD_AMD) shl 8)+(CPU_BRAND_AMD)

		popa
ENDIF	;BIOS_SUPPORT_486

		ret

Intel_To_AMD	endp

;[]------------------------------------------------------------------------[]
;Procedur	:	Prepare_CPU_Info
;
;Input		:	None
;
;Output		:	None
;
;Description	:	- This routine is called after the BIOS has issued
;			  the CPUID instruction & all the CPUs are identified.
;
;			- There are 2 variables in the stack area namely
;			  CPU_BRAND[bp] & CPU_SMI_TYPE[bp]
;			  This routine will place appropriate values into
;			  these 2 [BP] variables
;			  The BIOS engineers can easily reference to them
;			  for their own programming
;
;			- please refer to BSETUP.INC for the definitions
;			  of CPU_BRAND[bp] & CPU_SMI_TYPE[bp]
;
;Note		:	BIOS engineers should use instruction "test" to
;			check SMI type & "cmp" for CPU brand
;
;			e.g.
;			    cmp   CPU_BRAND[bp], CPU_BRAND_CYRIX
;			    test  CPU_SMI_TYPE[bp], SMI_TYPE_CYRIX
;
;[]------------------------------------------------------------------------[]
		Public	Prepare_CPU_Info
Prepare_CPU_Info	Proc	Near

		mov	al,CMOS_AWARD_2 NMI_OFF
;R16		F000_CALL	Get_Cmos
		call	F000_Get_Cmos				;R16
		and	al,CPU_TYPE_MASK
		movzx	si,al

		xor	ah, ah					;R03
		shr	ax, 1					;R03
		add	si, ax					;R03

		mov	dx,word ptr cs:CPU_Info_Tbl[si]
		mov	word ptr CPU_BRAND[bp],dx

		mov	al, byte ptr cs:CPU_Info_Tbl[si+2] 	;R03
		mov	byte ptr CPU_LEVEL[bp], al		;R03

		mov	al,OVERRIDE NMI_OFF
;R16		F000_CALL	Get_Cmos
		call	F000_Get_Cmos				;R16
		test	al,((SMICPU) shr 8)		;SMI CPU?
		jnz	short Set_SMI_OK		;Yes

		mov	byte ptr CPU_SMI_TYPE[bp],SMI_NONE
Set_SMI_OK:
		ret

Prepare_CPU_Info	Endp

		ALIGN	4
CPU_Info_Tbl:
;R03 - starts
	db	CPU_BRAND_INTEL	,SMI_NONE	 ,LEVEL_386	;TYPE_386DX
	db	CPU_BRAND_INTEL	,SMI_NONE 	 ,LEVEL_386	;TYPE_386SX
	db	CPU_BRAND_INTEL	,SMI_NONE 	 ,LEVEL_386	;TYPE_386SL
	db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL  ,LEVEL_486	;TYPE_486DX
	db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL  ,LEVEL_486	;TYPE_486SX
	db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL	 ,LEVEL_486	;TYPE_486DX2
	db	CPU_BRAND_CYRIX	,SMI_NONE	 ,LEVEL_386	;TYPE_486SLC
	db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX	 ,LEVEL_386	;TYPE_486DLC
	db	CPU_BRAND_IBM	,SMI_TYPE_IBM	 ,LEVEL_386	;TYPE_IBM386SLC
	db	CPU_BRAND_IBM	,SMI_TYPE_IBM	 ,LEVEL_386	;TYPE_IBM486SLC2
	db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL	 ,LEVEL_486	;TYPE_P24T
	db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX	 ,LEVEL_486	;TYPE_CX486S
	db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX	 ,LEVEL_486	;TYPE_CX486S2
	db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL	 ,LEVEL_586	;TYPE_586
	db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL	 ,LEVEL_486	;TYPE_486DXS
	db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL	 ,LEVEL_486	;TYPE_486SXS
	db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL	 ,LEVEL_486	;TYPE_486DX2S
	db	CPU_BRAND_IBM	,SMI_TYPE_IBM	 ,LEVEL_386	;TYPE_IBM486DLC3
	db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX	 ,LEVEL_486	;TYPE_M7
	db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX	 ,LEVEL_486	;TYPE_M7_2
	db	CPU_BRAND_CYRIX	,SMI_NONE	 ,LEVEL_386	;TYPE_CX486SLC2
	db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL	 ,LEVEL_486	;TYPE_P24C
	db	CPU_BRAND_TI	,SMI_TYPE_CYRIX	 ,LEVEL_486	;TYPE_TI486SXL
	db	CPU_BRAND_TI	,SMI_TYPE_CYRIX	 ,LEVEL_486	;TYPE_TI486SXL2
	db	CPU_BRAND_UMC	,SMI_TYPE_OLD_AMD,LEVEL_486	;TYPE_U5
	db	CPU_BRAND_AMD	,SMI_NONE	 ,LEVEL_486	;TYPE_AMD486
	db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL	 ,LEVEL_586	;TYPE_P54C
	db	CPU_BRAND_TI	,SMI_TYPE_CYRIX	 ,LEVEL_486	;TYPE_TI486SXLC
	db	CPU_BRAND_TI	,SMI_TYPE_CYRIX	 ,LEVEL_486	;TYPE_TI486SXLC2
	db	CPU_BRAND_AMD	,SMI_NONE	 ,LEVEL_486	;TYPE_AMD486DX2
	db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL	 ,LEVEL_486	;TYPE_P24D
	db	CPU_BRAND_AMD	,SMI_NONE	 ,LEVEL_486	;TYPE_AMD486DX4
	db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX	 ,LEVEL_586	;TYPE_M1
	db	CPU_BRAND_AMD	,SMI_TYPE_INTEL	 ,LEVEL_486	;TYPE_AMD486PLUS
	db	CPU_BRAND_AMD	,SMI_TYPE_INTEL	 ,LEVEL_486	;TYPE_AMD486DX4PLUS
	db	CPU_BRAND_UMC	,SMI_TYPE_OLD_AMD,LEVEL_486	;TYPE_U486SX2
	db	CPU_BRAND_UMC	,SMI_TYPE_INTEL	 ,LEVEL_486	;TYPE_U486DX
	db	CPU_BRAND_UMC	,SMI_TYPE_INTEL	 ,LEVEL_486	;TYPE_U486DX2
	db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX	 ,LEVEL_486	;TYPE_M9
	db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX	 ,LEVEL_486	;TYPE_CYRIX_DX4
	db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL	 ,LEVEL_686	;TYPE_P6
	db	CPU_BRAND_AMD	,SMI_TYPE_INTEL	 ,LEVEL_486	;TYPE_X5
	db	CPU_BRAND_AMD	,SMI_TYPE_INTEL	 ,LEVEL_586	;TYPE_AMD5K86
;R03 - ends

;R03		db	CPU_BRAND_INTEL	,SMI_NONE 		;TYPE_386DX
;R03		db	CPU_BRAND_INTEL	,SMI_NONE 		;TYPE_386SX
;R03		db	CPU_BRAND_INTEL	,SMI_NONE 		;TYPE_386SL
;R03		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL 	;TYPE_486DX
;R03		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL 	;TYPE_486SX
;R03		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL		;TYPE_486DX2
;R03		db	CPU_BRAND_CYRIX	,SMI_NONE		;TYPE_486SLC
;R03		db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX		;TYPE_486DLC
;R03		db	CPU_BRAND_IBM	,SMI_TYPE_IBM		;TYPE_IBM386SLC
;R03		db	CPU_BRAND_IBM	,SMI_TYPE_IBM		;TYPE_IBM486SLC2
;R03		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL		;TYPE_P24T
;R03		db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX		;TYPE_CX486S
;R03		db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX		;TYPE_CX486S2
;R03		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL		;TYPE_586
;R03		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL		;TYPE_486DXS
;R03		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL		;TYPE_486SXS
;R03		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL		;TYPE_486DX2S
;R03		db	CPU_BRAND_IBM	,SMI_TYPE_IBM		;TYPE_IBM486DLC3
;R03		db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX		;TYPE_M7
;R03		db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX		;TYPE_M7_2
;R03		db	CPU_BRAND_CYRIX	,SMI_NONE		;TYPE_CX486SLC2
;R03		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL		;TYPE_P24C
;R03		db	CPU_BRAND_TI	,SMI_TYPE_CYRIX		;TYPE_TI486SXL
;R03		db	CPU_BRAND_TI	,SMI_TYPE_CYRIX		;TYPE_TI486SXL2
;R03		db	CPU_BRAND_UMC	,SMI_TYPE_OLD_AMD	;TYPE_U5
;R03		db	CPU_BRAND_AMD	,SMI_NONE		;TYPE_AMD486
;R03		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL		;TYPE_P54C
;R03		db	CPU_BRAND_TI	,SMI_TYPE_CYRIX		;TYPE_TI486SXLC
;R03		db	CPU_BRAND_TI	,SMI_TYPE_CYRIX		;TYPE_TI486SXLC2
;R03		db	CPU_BRAND_AMD	,SMI_NONE		;TYPE_AMD486DX2
;R03		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL		;TYPE_P24D
;R03		db	CPU_BRAND_AMD	,SMI_NONE		;TYPE_AMD486DX4
;R03		db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX		;TYPE_M1
;R03		db	CPU_BRAND_AMD	,SMI_TYPE_INTEL		;TYPE_AMD486PLUS
;R03		db	CPU_BRAND_AMD	,SMI_TYPE_INTEL		;TYPE_AMD486DX4PLUS
;R03		db	CPU_BRAND_UMC	,SMI_TYPE_OLD_AMD	;TYPE_U486SX2
;R03		db	CPU_BRAND_UMC	,SMI_TYPE_INTEL		;TYPE_U486DX
;R03		db	CPU_BRAND_UMC	,SMI_TYPE_INTEL		;TYPE_U486DX2
;R03		db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX		;TYPE_M9
;R03		db	CPU_BRAND_CYRIX	,SMI_TYPE_CYRIX		;TYPE_CYRIX_DX4
;R03		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL		;TYPE_P6
;R03;R02		db	CPU_BRAND_INTEL	,SMI_TYPE_INTEL		;TYPE_P6
;R03		db	CPU_BRAND_AMD	,SMI_TYPE_INTEL		;TYPE_X5	;R02
;R03		db	CPU_BRAND_AMD	,SMI_TYPE_INTEL		;TYPE_AMD5K86

;R56 - start
IF	BIOS_SUPPORT_686
;
;CPU clock detection for Pentium Pro,Pentium II and Deschutes
;
	Public	MOV_SHAD_SEG
MOV_SHAD_SEG	EQU	5000h
		;Clock ratio table for P6 class CPU
P6_ClkRatio	db	10	;x5	,0000
		db	6	;x3	,0001
		db	8	;x4	;0010
		db	4	;x2	;0011
		db	11	;x5.5	;0100
		db	7	;x3.5	;0101
		db	9	;x4.5	;0110
		db	5	;x2.5	;0111
		db	7	;reserve;1000
		db	14	;x7	;1001
		db	16	;x8	;1010
		db	12	;x6	;1011
		db	4	;x2	;1100
		db	15	;x7.5	;1101
		db	3	;x1.5	;1110
		db	13	;x6.5	;1111

		;possible host clock table for P6 class CPU
P6_HostClk:
		db	96,100,CPU66	;100Mhz		;R56B
		dw	1000	;for real CPU frequency calculation
HOSTCLK_SIZE	EQU	($ - offset P6_HostClk)

		db	80,83,CPU66	;83Mhz		;R56B
		dw	832

		db	71,75,CPU66	;75Mhz		;R56B
		dw	750

		db	64,66,CPU66	;66Mhz		;R56B
		dw	665

		db	57,60,CPU60	;60Mhz		;R56B
		dw	600

		db	45,50,CPU50	;50Mhz		;R56B
		dw	500

		db	0	;end of table

		Public	Measure_CPU_Speed
Measure_CPU_Speed	proc	near
;The Pentium Pro, Pentium II and future Intel's CPU have a readable
;clock ratin in MSR register. BIOS use this ration to calculate the host(bus)
;clock and use this clock to calculate real CPU clock.
;Use new algorithm for CPU clock detection if CPU have RDTSC instruction
;(0fh,31h)
		call	New_CpuClk_Detection	;use new method to check
;		jc	short Cpu_NoRdtsc	;CPU clock ?
						;carry set, use old method

		mov	ecx,2AH			;power on config. register
		RDMSR				;read MSR
		shr	eax,22			;get clock ratio in AL bit3-0
		and	ax,0fH			;only low nibble useful
		mov	si,ax
		add	si,offset P6_ClkRatio
		movzx	cx,byte ptr cs:[si] 	;get clock ratio
		mov	ax,bx
		shl	ax,1			;multipler by 2
		idiv	cx			;get host clock in AL

	;now AL contains raw host clock
	;look for formal host clock
		mov	di,offset P6_HostClk
NextHostClk:
		cmp	byte ptr cs:[di+HOSTCLK_SIZE],0	;end of host clock table ?
		je	short HostClkExit	;yes

		cmp	al,cs:[di]		;match ?
		jae	short HostClkExit

		add	di,HOSTCLK_SIZE		;point to next entry
		jmp	short NextHostClk
HostClkExit:

	;Calculate CPU real clock by multipling host clock by clock ratio
		mov	ax,cs:[di+3]		;get factor to calculate clock;R56B
;R56B		mov	ax,cs:[di+2]		;get factor to calculate clock
		movzx	cx,byte ptr cs:[si]	;get clock ration in /2
		mul	cx
		shr	ax,1
		add	ax,5			;for round off
		mov	cx,10
		idiv	cx

		cmp	ax,299			;Is 299 MHz	;R56A
		jne	short @F				;R56A
		mov	ax,300			;Set 300 MHz	;R56A
	@@:							;R56A

;R71		mov	CPU_INT_CLOCK[bp],ax	;actual internal CPU clock
;R71		mov	al,cs:[di+2]	 	;get formal host clock;R56B
;R71;R56B		mov	al,cs:[di+1]	 	;get formal host clock
;R71		push	G_RAM
;R71		pop	es
;R71		mov	byte ptr es:[CPU_CLOCK],al
;R71 - start
		push	G_RAM
		pop	es
		mov	CPU_INT_CLOCK[bp],ax	;actual internal CPU clock
 ifdef	L2ECC_CMOS
  ifdef	KLAMATH_CPU_ONLY
	;Don't turn off L2 ECC if clock is over 333Mhz and allow user
	;to select disable for L2 ECC to get performance benefit
		cmp	ax,330			;clock 333Mhz and above ?
		jae	short Below333
       
	;R71A - start
		;Don't turn ECC off if host clock is 100MHz
		mov	ecx,2AH			;Power on Config. Reg.
		RDMSR
		test	eax,080000H		;bit 19 on (100Mhz) ?
		jnz	short Below333		;ECC always on
	;R71A - end

		mov	si,offset L2Ecc_Item	
		call	F000_GetItem_Value  	;get CMOS value
		or	al,al			;ECC enabled
		jz	short Below333		;yes

		or	byte ptr es:[SYSTEM_FLAG],L2ECC_OFF;mark flag
Below333:
  endif;	KLAMATH_CPU_ONLY
 endif;	L2ECC_CMOS

		mov	cl,cs:[di+2]	 	;get formal host clock
		mov	byte ptr es:[CPU_CLOCK],cl
;R71 - end
		clc
		ret
Measure_CPU_Speed	endp

endif;	BIOS_SUPPORT_686
;R56 - end

;R12 - starts
IF	BIOS_SUPPORT_586 OR BIOS_SUPPORT_686			;R14
;[]==============================================================[]
;
;CpuClk_Int08:
;
;	Temporary interrupt service routine for caculating CPU clock
;
;Saves: NONE
;
;Entry: NONE
;Exit:	NONE
;
;[]==============================================================[]
		ALIGN	4
CpuClk_Int08	PROC	NEAR

		push	edx

		db	0fh,31h			;ReaD Time Stamp Counter
		cmp	dword ptr ds:[4fch],-1	;high 32 bit value
		je	short First_Int

		cmp	byte ptr ds:[4f0h],0aaH	;second INT ?
		je	short Finish_Int

		mov	edi,dword ptr ds:[4fch]	;high 32 bit value
		mov	esi,dword ptr ds:[4f8h]	;low 32 bit value

		sub	edx,edi			;high 32-bit value
		sub	eax,esi			;low 32-bit value
		jnc	short No_Dec_High32
		dec	edx
No_Dec_High32:
		mov	dword ptr ds:[4fch],edx	;high 32 bit value
		mov	dword ptr ds:[4f8h],eax	;low 32 bit value

		mov	byte ptr ds:[4f0h],0aaH;mark for second INT
		jmp	short Finish_Int

First_Int:
		mov	dword ptr ds:[4fch],edx	;high 32 bit value
		mov	dword ptr ds:[4f8h],eax	;low 32 bit value

Finish_Int:
		pop	edx

		NEWIODELAY
		mov	al,END_OF_INT		; eoi command
		out	a8259,al		; tell controller
		NEWIODELAY

		iret
CpuClk_Int08	ENDP

;-----------------------------------------------------------------
;Input	:	None
;Output :	carry set - this CPU don't have instruction RDTSC
;		carry clear - this CPU have instruction RDTSC and
;		BX : CPU clock detected (0-65535Mhz) return
;Destroy:	use 0:4f8H - 0:4ffH as temporary memory
;-----------------------------------------------------------------
;
New_CpuClk_Detection	proc	near
;use RDTSC to check CPU clock if 586 level CPU
		cli
		cmp	byte ptr CPU_LEVEL[bp], LEVEL_686
		je	short Yes_Rdtsc
		cmp	byte ptr CPU_LEVEL[bp], LEVEL_586
		stc				;assume CPU no counter
		jne	No_Rdtsc

Yes_Rdtsc:
		xor	edx,edx
		xor	eax,eax			;input value = 1
		mov	ds,ax
		push	dword ptr ds:[4*6]	;save int 06h vector
		mov	word ptr ds:[4*6],offset Temp_Int06
		mov	word ptr ds:[4*6+2], cs

		db	0fh,31h			;ReaD Time Stamp Counter

		pop	dword ptr ds:[4*6]	;restore int 06h vector

		or	eax,edx			;counter changed ?
		stc				;assume CPU no counter
		jz	short No_Rdtsc		;no , this CPU don't have
						;counter

		mov	ax,G_RAM		; seg_0
		mov	ds,ax
		assume	ds:G_RAM

		mov	byte ptr ds:[4f8h],0	;init flag
		mov	dword ptr ds:[4f8h],0	;init low dword value
		mov	dword ptr ds:[4fch],-1	;init high dword value

;
;	Move INT 08h vector to a temporary routine
;

		mov	dx,word ptr [int08]	; save vector
		mov	bx,word ptr [int08+2]

		mov	word ptr [int08],offset CpuClk_Int08; tmr isr entry
		mov	word ptr [int08+2],cs	; code segment

;
;	Enable just the timer interrupt
;

		mov	al,0ffh 		; mask all interrupts on controller 2
		out	B8259+1,al		; tell controller
		NEWIODELAY
		dec	al			; mask all except timer (IRQ 8)
		out	A8259+1,al		; tell controller

;
;	Set up timer 0
;

		mov	al,36h			; setup timer counter 0
		out	43h,al			; select counter 0
		NEWIODELAY

		xor	ax,ax			; INT every 1/18 seconds
		out	40h,al			; write lsb
		NEWIODELAY
		out	40h,al			; write msb

;
;	Wait for interrupts
;

		xor	ax,ax			; clear interrupt flag
		sti				; enable interrupt
Wait_Irq0:
		cmp	byte ptr ds:[4f0h],0aaH	;second INT occured ?
		jne	short Wait_Irq0
		cli				; disable interrupts

;
;	Turn off all of the interrupts
;
		mov	al,0ffh 		; mask all interrupts
		out	A8259+1,al		; tell controller
		NEWIODELAY

;
;	Restore INT 08h vector
;

		mov	word ptr [int08],dx	; restore old vector
		mov	word ptr [int08+2],bx

;Now , the content of 0:[4f8h] contain counter value
		mov	bx,1
		mov	eax,dword ptr ds:[4f8h]
		mov	ecx,55100		;factor to calculate
Next_Div:
		sub	eax,ecx
		jc	short Finish_Div
		inc	bx
		jmp	short Next_Div
Finish_Div:
		clc
No_Rdtsc:
		ret
New_CpuClk_Detection	endp

ENDIF	;BIOS_SUPPORT_586 OR BIOS_SUPPORT_686			;R56
IFE	BIOS_SUPPORT_686					;R56

;Table for CPU clock over 255Mhz
CPU_Over255MHz:
		db	400-256, 400-256-2,	CPU66		;66x6  ;R60A
		db	366-256, 366-256-2,	CPU66		;66x5.5;R60A
		db	333-256, 333-256-2,	CPU66		;66x5
		db	300-256, 300-256-2,	CPU66		;60x4.5;R61
;R61		db	300-256, 300-256-2,	CPU60		;60x5
		db	266-256, 266-256-2,	CPU66		;66x4
		db	0					;end of table

;Clock table for P5-class CPUs
NewCPU_Int_Clock_Tbl:

ifdef	CLOCK_TBL_FOR_ICWORK					;R22
		db	250,	246,	CPU66		;83*3	;R22
ifndef	NO_CPU_240MHZ_SUPPORT					;R30
		db	240,	236,	CPU60		;60x4	;R22
endif;	NO_CPU_240MHZ_SUPPORT					;R30
		db	233,	228,	CPU66		;66x3.5	;R22
		db	225,	223,	CPU66		;75x3	;R22
		db	210,	205,	CPU60		;60x3.5	;R22
		db	200,	194,	CPU66		;66x3	;R22
;R39A		db	187,	185,	CPU66		;75*2.5	;R22
		db	188,	185,	CPU66		;75*2.5	;R22 ;R39A
		db	180,	176,	CPU60		;60x3	;R22
		db	166,	163,	CPU66		;66x2.5	;R22
		db	150,	147,	CPU60		;60x2.5	;R22
;R22A - start
;R37		db	133,	131,	CPU66		;66x2	;here special
		db	133,	128,	CPU66		;66x2	;here special ;R37
		db	125,	124,	CPU50		;50x2.5
		db	120,	118,	CPU60		;60x2	;here special
		db	117,	115,	CPU66		;66x1.75
		db	110,	109,	CPU50		;55x2
		db	105,	103,	CPU60		;60x1.75
		db	100,   	 98,	CPU66		;66x1.5	;here special
;R22A - end
else;	CLOCK_TBL_FOR_ICWORK					;R22
;R22B - start
ifdef	CLOCK_TBL_FOR_ICS
		db	250,	248,	CPU66		;83*3	 ;R15
ifndef	NO_CPU_240MHZ_SUPPORT					;R30
		db	240,	238,	CPU60		;60x4
endif;	NO_CPU_240MHZ_SUPPORT					;R30

ifdef	Lower_233Mhz_FOR_ICS					;R62
		db	233,	223,	CPU66		;66x3.5	;R62
else;	Lower_233Mhz_FOR_ICS					;R62
		db	233,	230,	CPU66		;66x3.5
endif;	Lower_233Mhz_FOR_ICS					;R62

ifndef	NO_CPU_225MHZ_SUPPORT_FOR_ICS				;R62
		db	225,	223,	CPU66		;75x3
endif;	NO_CPU_225MHZ_SUPPORT_FOR_ICS				;R62

ifndef	NO_CPU_210MHZ_SUPPORT_FOR_ICS				;R62
		db	210,	208,	CPU60		;60x3.5
endif;	NO_CPU_210MHZ_SUPPORT_FOR_ICS				;R62

		db	200,	186,	CPU66		;66x3
		db	193,	181,	CPU50		;55*3.5
;R39A		db	187,	174,	CPU66		;75*2.5
ifndef	NO_CPU_188MHZ_SUPPORT_FOR_ICS				;R42
		db	188,	174,	CPU66		;75*2.5	;R39A
endif;	NO_CPU_188MHZ_SUPPORT_FOR_ICS				;R42
		db	180,	170,	CPU60		;60x3
ifndef	NO_CPU_175MHZ_SUPPORT_FOR_ICS				;R42
		db	175,	164,	CPU50		;50x3.5
endif;	NO_CPU_175MHZ_SUPPORT_FOR_ICS				;R42
		db	166,	154,	CPU66		;66x2.5
		db	150,	138,	CPU60		;60x2.5
		db	133,	123,	CPU66		;66x2
ifndef	NO_CPU_125MHZ_SUPPORT_FOR_ICS				;R62
		db	125,	115,	CPU50		;50x2.5
endif;	NO_CPU_125MHZ_SUPPORT_FOR_ICS				;R62
		db	120,	110,	CPU60		;60x2
		db	117,	106,	CPU66		;66x1.75
		db	110,	101,	CPU50		;55x2
ifndef	NO_CPU_105MHZ_SUPPORT_FOR_ICS				;R62
		db	105,	 96,	CPU60		;60x1.75
endif;	NO_CPU_105MHZ_SUPPORT_FOR_ICS				;R62
ifndef	Higher_100Mhz_FOR_ICS					;R62
		db	100,   	 89,	CPU66		;66x1.5	;R62
else;	Higher_100Mhz_FOR_ICS					;R62
		db	100,   	 93,	CPU66		;66x1.5
endif;	Higher_100Mhz_FOR_ICS					;R62
else;	CLOCK_TBL_FOR_ICS
;R22B - end
		db	250,	248,	CPU66		;83*3	 ;R15
ifndef	NO_CPU_240MHZ_SUPPORT					;R30
		db	240,	238,	CPU60		;60x4
endif;	NO_CPU_240MHZ_SUPPORT					;R30

		db	233,	230,	CPU66		;66x3.5
		db	225,	223,	CPU66		;75x3
		db	210,	208,	CPU60		;60x3.5
		db	200,	195,	CPU66		;66x3
ifndef	No_55MHz							;R67
		db	193,	190,	CPU50		;55*3.5	  	;R32
endif	;No_55MHz							;R67
;R39A		db	187,	185,	CPU66		;75*2.5	  ;R15
		db	188,	185,	CPU66		;75*2.5	  ;R15	;R39A
		db	180,	179,	CPU60		;60x3
		db	175,	174,	CPU50		;50x3.5		;R32
		db	166,	165,	CPU66		;66x2.5
		db	150,	149,	CPU60		;60x2.5
;R22A - start
		db	133,	132,	CPU66		;66x2
		db	125,	124,	CPU50		;50x2.5
		db	120,	119,	CPU60		;60x2
		db	117,	115,	CPU66		;66x1.75
ifndef	No_55MHz							;R67
		db	110,	109,	CPU50		;55x2
endif	;No_55MHz							;R67
ifndef	No_105MHz							;R72
		db	105,	103,	CPU60		;60x1.75	
endif;	No_105MHz							;R72
		db	100,   	 99,	CPU66		;66x1.5
;R22A - end
endif;	CLOCK_TBL_FOR_ICS				;R22B
endif;	CLOCK_TBL_FOR_ICWORK					;R22
;R22A		db	133,	132,	CPU66		;66x2
;R22A		db	125,	124,	CPU50		;50x2.5
;R22A		db	120,	119,	CPU60		;60x2
;R22A		db	117,	115,	CPU66		;66x1.75	;R13
;R22A		db	110,	109,	CPU50		;55x2
;R22A		db	105,	103,	CPU60		;60x1.75	;R13
;R22A		db	100,   	 99,	CPU66		;66x1.5
;R13A		db	 90,	 86,	CPU50		;50x1.75	;R13

		db	 90,   	 88,	CPU60		;60x1.5
		db	 90,	 86,	CPU50		;50x1.75	;R13A
ifndef	No_55MHz							;R67
		db	 83,   	 82,	CPU50		;55x1.5
endif	;No_55MHz							;R67
;R33		db	 75,   	 74,	CPU50		;50x1.5
		db	 75,   	 70,	CPU50		;50x1.5		;R33
		db	 66,   	 65,	CPU66		;66x1
		db	 60,   	 59,	CPU66		;60x1
		db	 50,   	 49,	CPU66		;50x1
		db	 0		;end of table
;R56 ENDIF	;BIOS_SUPPORT_586 OR BIOS_SUPPORT_686			;R14

;Clock detection for 386,486 & 586 CPUs

		ALIGN	16
		Public	MOV_SHAD_OFF
MOV_SHAD_OFF	EQU	00000H
		Public	MOV_SHAD_SEG
;R25 MOV_SHAD_SEG	EQU	4000h
;R25A MOV_SHAD_SEG	EQU	8000h				;R25
;R47 MOV_SHAD_SEG	EQU	6000h				;R25A
MOV_SHAD_SEG	EQU	5000h				;R47

		Public	Measure_CPU_Speed
Measure_CPU_Speed	proc	near

;--------------------------------------
;Copy code into RAM for speed detection
;--------------------------------------

;R58		mov	ax,cs			;GET THE SEGMENT
;R58		mov	ds,ax			;AND SET UP SOURCE
;R58		mov	ax,MOV_SHAD_SEG 	;SET THE SEGMENT FOR DEST
;R58		mov	es,ax
;R58;R12		lea	si,S_Cpu		;GET THE OFFSET FOR SOURCE
;R58		mov	si, offset S_Cpu	;GET THE OFFSET FOR SOURCE	;R12
;R58		mov	di,MOV_SHAD_OFF 	;MOVE OFFSET IN FOR DEST
;R58;R12		lea	cx,LAST_S_Cpu		;GET SETUP FOR THE LENGTH
;R58		mov	cx, offset LAST_S_Cpu	;GET SETUP FOR THE LENGTH	;R12
;R58		sub	cx,si			;GET THE LENGTH OF THE CODE
;R58
;R58		push	cx
;R58		push	es
;R58		push	di
;R58
;R58		rep	movsb			;MOVE THE COPY CODE

		push	0f000h
		pop	ds

IF	BIOS_SUPPORT_586 or BIOS_SUPPORT_686			;R14
;Use new algorithm for CPU clock detection if CPU have RDTSC instruction
;(0fh,31h)
		call	New_CpuClk_Detection	;use new method to check
		jc	short Cpu_NoRdtsc	;CPU clock ?
						;carry set, use old method

		mov	al,bl			;AL = Actual CPU clock found
		mov	dh,bl			;AL = Actual CPU clock found
		mov	CPU_INT_CLOCK[bp],bx	;actual internal CPU clock

		call	Get_M2_Clock_Tbl	;M2 Present ?	;R64
		jc	R_Off_Clk		;Yes	     	;R64

ifdef	Special_CPU_Clock_Table				;R68
		mov	si, offset Ct_Int_Clock_Tbl	;R68
else	;Special_CPU_Clock_Table			;R68
		mov	si,offset NewCPU_Int_Clock_Tbl	;new table for PENTIUM
endif	;Special_CPU_Clock_Table			;R68

		cmp	word ptr CPU_INT_CLOCK[bp],255	;over 255Mhz ?
		jbe	short Not_Over255Mhz

		mov	si,offset CPU_Over255MHz
Not_Over255Mhz:

		jmp	short R_Off_Clk
Cpu_NoRdtsc:
ENDIF	;BIOS_SUPPORT_586 or BIOS_SUPPORT_686			;R14

;R14ifndef	P6_BIOS_ONLY
IFE	BIOS_SUPPORT_686					;R14

;--------------------------------------------------
;Set KB high speed for test & save results(push bx)
;--------------------------------------------------

ifdef	TOGGLE_8042_FOR_CPU_CLK_DETECT
		mov	al,1		;Set low speed for test
		call	F000_Out_8042_Pin
endif;	TOGGLE_8042_FOR_CPU_CLK_DETECT

		in	al,PORT61
		IODELAY
		push	ax 			;save PORT61 value

	;execute the CPU detection code in DRAM
;R58		push	cs
;R58		push	offset SHAD_ret_off
;R58		push	MOV_SHAD_SEG
;R58		push	MOV_SHAD_OFF
;R58		retf
;R58SHAD_ret_off:
		call	far ptr S_CPU			;R58
	;return register values after calling S_CPU are
	; BH - CPU host clock
	; DL - CPU clock mode (x1, x2 ,x3 or x4)
		mov	al,bh
		mul	dl
		mov	si,ax

		pop	ax			;restore PORT61 value
		out	PORT61,al
		IODELAY

ifdef	TOGGLE_8042_FOR_CPU_CLK_DETECT
	;Save KB high speed result

		push	dx
		push	bx

;-------------------------
;Set KB low speed for test
;-------------------------

		xor	al,al			;Set high speed for test
		call	F000_Out_8042_Pin

		in	al,PORT61		;save PORT61 value
		IODELAY
		push	ax

;R58		push	cs
;R58		push	offset SHAD_ret_off1
;R58		push	MOV_SHAD_SEG
;R58		push	MOV_SHAD_OFF
;R58		retf
;R58SHAD_ret_off1:
		call	far ptr S_CPU			;R58

		pop	ax			;restore PORT61 value
		out	PORT61,al
		IODELAY

;--------------------------------------------------------------
;compare results of KB high & KB low speed, take the higher one
;--------------------------------------------------------------

	;restore KB high speed results in ax, di

		mov	al,bh
		mul	dl
		cmp	ax,si
		pop	ax
		pop	di

		jae	short AUTO_CPUS_READY

	;use KB high speed result

		mov	bx,ax
		mov	dx,di

AUTO_CPUS_READY:
endif;	TOGGLE_8042_FOR_CPU_CLK_DETECT

	;write CPU_INTERNAL_CLOCK[bp] with tested value

		mov	al,bh			;system clock(integer) in AL
		mul	dl			;Sing/doub/treb value in DL

		mov	CPU_INT_CLOCK[bp],ax	;actual internal CPU clock

		mov	dl,FIXED_DISK_STEP[bp]	;get CPU type
		and	dl,CPU_TYPE_MASK	;get CPU type

	;special table for P24T , because the clock mode is x2.5
		cmp	dl,TYPE_P24T
		jne	short Not_P24T_2Point5
		test	byte ptr OVERRIDE[bp],DOUBLE_CLOCK
		jz	short Not_P24T_2Point5
		mov	si,offset P24T_Int_Clock_Tbl
		jmp	short R_Off_Clk
Not_P24T_2Point5:

ifdef	No_586_Support				;for 386 & 486 only
		jmp	short Not_Pentium
else	;No_586_Support

	;special table for P5 & M1 & K5
		mov	bh,byte ptr FIXED_DISK_STEP[bp]
		and	bh,CPU_TYPE_MASK
		mov	si,offset CPU_Int_Clock_Tbl	;table for PENTIUM
		cmp	bh,TYPE_586			;Pentium CPU?
		je	short Round_Off_It

		cmp	bh,TYPE_AMD5K86			;K5 CPU?
		je	short Round_Off_It

		mov	si,offset M1_Int_Clock_Tbl	;table for M1
		cmp	bh,TYPE_M1			;M1 CPU?
		je	short Round_Off_It

		jmp	short Not_Pentium

Round_Off_It:

		mov	al,dh
endif	;No_586_Support

ENDIF	;BIOS_SUPPORT_686					;R14
;R14endif;	P6_BIOS_ONLY

R_Off_Clk:

	;far call Round_Off_Clock

		FAR_CALL <offset Round_Off_Clock>,0E000h
		mov	CPU_INT_CLOCK[bp],bl	;actual internal CPU clock
		push	G_RAM
		pop	es

		mov	bl,cs:[si+2]			;SI+2 = system clock

;R14 ifndef	P6_BIOS_ONLY
IF	BIOS_SUPPORT_586					;R14

		cmp	byte ptr CPU_BRAND[bp], CPU_BRAND_CYRIX	;R75
		jne	NotM1_Cpu  				;R75

		call	Check_M2Cpu				;R64
		je	NotM1_Cpu				;R64A
;R64A		jne	NotM1_Cpu				;R64

;There is two combination for 150Mhz , 75*2 and 50*3 , the default is 75*2
;, we need to check the clock mode , if 3x , change host clock to 50Mhz
		mov	al,byte ptr FIXED_DISK_STEP[bp]
		and	al,CPU_TYPE_MASK
		cmp	al,TYPE_M1			;M1 CPU?
		jne	short NotM1_Cpu

		cmp	byte ptr CPU_INT_CLOCK[bp],150		;150Mhze ?
		jne	short NotM1_Cpu

;R35 - start
;Now , BIOS set 150Mhz as 60x2.5 for M2
		mov	al,0FEh			;DIR0 of M2 CPU
		out	22h,al
		in	al,23h
		and	al,0f7h			;mask bit 3
		cmp	al,52H			;x2.5 ?
		je	short NotM1_Cpu		;yes

		cmp	al,51h			;x2 ?
		jne	short Not_M2X2

;R69		mov	bl,CPU66		;set host clock 66x2(75x2)
		mov	bl,CPU75		;set host clock 75x2	;R69
Not_M2X2:
;R35 - end

		test	byte ptr OVERRIDE[bp],THREE_CLOCK	;3x mode ?
		jz	short NotM1_Cpu

	;set 50Mhz host clock if 3x mode
		mov	bl,CPU50				;set host clock

NotM1_Cpu:
;R31 - start
ifdef	K586_68MHz_Show_133MHz
		cmp	al,TYPE_AMD5K86
		jne	short Not_AMD5K86

		cmp	byte ptr CPU_INT_CLOCK[bp],120		;150Mhz ?
		jne	short Not_AMD5K86

	;Set 166MHz For AMD5K86 Use 68MHz
		mov	byte ptr CPU_INT_CLOCK[bp],117		;166Mhz
		mov	bl,CPU66	;66x1.75
Not_AMD5K86:
endif;	K586_68MHz_Show_133MHz
;R31 - end
ENDIF	;BIOS_SUPPORT_586					;R14
;R14 endif;	P6_BIOS_ONLY

		mov	byte ptr es:[CPU_CLOCK],bl

	Not_P54C:
	Not_Pentium:

;Show 100Mhz if 99Mhz
		cmp	byte ptr CPU_INT_CLOCK[bp],132
		je	short Set_133
		cmp	byte ptr CPU_INT_CLOCK[bp],99
		jne	short @F
Set_133:
		inc	byte ptr CPU_INT_CLOCK[bp]
	@@:

ifdef	TOGGLE_8042_FOR_CPU_CLK_DETECT
		mov	al,1
		call	F000_Out_8042_Pin
endif;	TOGGLE_8042_FOR_CPU_CLK_DETECT

;-------------------
;Clear temporary RAM
;-------------------

;R58		pop	di
;R58		pop	es
;R58		pop	cx
;R58		xor	ax,ax
;R58		rep	stosw			;clear ram

		mov	ax,G_RAM
		mov	es,ax
		assume	es:G_RAM

;----------------------------
;Special treatment for TI CPU
;----------------------------

IF	BIOS_SUPPORT_TI_CPU
		cmp	bl,CPU33
		ja	short @F
		mov	al,FIXED_DISK_STEP[bp]
		and	al,CPU_TYPE_MASK
		cmp	al,TYPE_TI486SXL
		mov	dx,CPU_TI486SXL2
		je	short Set_TI_CPU
		cmp	al,TYPE_TI486SXLC
		jne	short @F
		mov	dx,CPU_TI486SXLC2
Set_TI_CPU:
		test	byte ptr FIXED_DISK_STEP[bp],01H;coprocess or exist
		jz	short No_Copro
		or	dl,01H				;restore copro. flag
No_Copro:

		mov	byte ptr FIXED_DISK_STEP[bp],dl
		mov	ah,FIXED_DISK_STEP[bp]
		mov	es:CPU_TYPE_FLAG,ah
		mov	al,CMOS_AWARD_2 NMI_OFF
		call	F000_Set_Cmos

		mov	ah,byte ptr OVERRIDE[bp]
		and	ah,Not Clock_Mode
		or	ah,dh
		mov	byte ptr OVERRIDE[bp],ah
		mov	al,OVERRIDE NMI_OFF
		call	F000_Set_Cmos

		mov	al,0c0h
		out	22h,al
		NEWIODELAY
		in	al,23h
		NEWIODELAY

		or	al,40h
		mov	ah,al

		mov	al,0c0h
		out	22h,al
		NEWIODELAY
		mov	al,ah
		out	23h,al
		NEWIODELAY

		shl	byte ptr CPU_INT_CLOCK[bp],1	;double clock

@@:
ENDIF	;BIOS_SUPPORT_TI_CPU

		mov	byte ptr es:CPU_CLOCK,bl

;R54	- starts
ifdef	VSA_VGA
		mov	ax,word ptr CPU_INT_CLOCK[bp]
		cmp	ax,120			                ;R40B
		jae	short	@F                              ;R40B
		mov	ax,120                                  ;R40B
		jmp	short	_Restore_Clock                  ;R40B
	@@:                                                     ;R40B
		mov	si,offset Gx86_Clock_Tbl
		mov	cx,Gx86_Clock_Tbl_Len
	@@:
		cmp	ax,word ptr cs:[si]
		jb      short	@F
		add	si,2
		loop	@B
	@@:
		sub	si,2
		mov	ax,word ptr cs:[si]
	_Restore_Clock:                                         ;R40B
	   	mov	CPU_INT_CLOCK[bp],ax

endif	;VSA_VGA
;R54	- ends

		clc
		ret
Measure_CPU_Speed	endp

;R64 - starts
M2_Bus_Clock_Tbl_List:
		dw	M2_Bus_Clock_Tbl_X2	;x2
		dw	M2_Bus_Clock_Tbl_X2_	;x2.5
		dw	M2_Bus_Clock_Tbl_X3	;x3
		dw	M2_Bus_Clock_Tbl_X3_	;x3.5

M2_Bus_Clock_Tbl_X2:			
	        db	166,161,CPU83		;83x2 PR233 ?
		db	150,145,CPU75		;75x2
		db	133,127,CPU66		;66x2
		db	120,118,CPU60		;60x2 PR150
		db	110,107,CPU50		;55x2
		db	100, 95,CPU50		;50x2
		db	0

M2_Bus_Clock_Tbl_X2_:	    		
	        db	207,202,CPU83       	;83x2.5
		db	188,183,CPU75       	;75x2.5 PR233
		db	166,161,CPU66  		;66x2.5 PR200
		db	150,145,CPU60  		;60x2.5 PR166
		db	138,135,CPU50		;55x2.5
		db	125,120,CPU50    	;50x2.5
		db	0

M2_Bus_Clock_Tbl_X3:	 		
	        db	250,245,CPU83       	;83x3 PR300 (Forecast)
		db	225,220,CPU75    	;75x3 PR266 (Forecast)
		db	200,195,CPU66    	;66x3
		db	180,179,CPU60  		;60x3
		db	165,160,CPU50		;55x3
		db	150,145,CPU50   	;50x3
		db	0

M2_Bus_Clock_Tbl_X3_:			
		db	231,226,CPU66  		;66x3.5
		db	210,205,CPU60  		;60x3.5
		db	193,188,CPU50		;55x3.5
		db	175,170,CPU50          	;50x3.5
	        db	290-255,290-255-5,CPU83	;83x3.5 over 255MHz
		db	263-255,263-255-2,CPU75 ;75x3.5 over 255MHz
		db	0

Get_M2_Clock_Tbl	proc	near

		push	ax
		push	bx

		cmp	byte ptr CPU_BRAND[bp], CPU_BRAND_CYRIX	;R75
		clc						;R75
		jne	Not_M2_CPU				;R75

		mov	al, 0FEh
		out	22h, al
		in 	al, 23h

		mov 	ah, al
		and	ah, 11110000b			;mask bits[7:4]
		cmp	ah, 50h				; Is M2 CPU present ?
		clc
		jne	short Not_M2_CPU		
	 
		cmp	word ptr CPU_INT_CLOCK[bp], 255	;over 255Mhz ?
		jbe	short Not_Over255MHZ		;no
     
		mov 	ax, word ptr CPU_INT_CLOCK[bp]		
		sub	al, 255
		mov	si, offset M2_Bus_Clock_Tbl_X3_
		jmp 	short Get_M2_Clock_Tbl_OK

Not_Over255Mhz:

		xor	ah,ah
		and	al,00000111b		;AL = 51h or 59h x2
						;     52h or 5Ah x2.5
						;     53h or 5Bh x3
						;     54h or 5Ch x3.5
		dec	ax
		shl	ax,1
		mov 	si,offset M2_Bus_Clock_Tbl_List
		add	si,ax
		mov	si,word ptr cs:[si]		

Get_M2_Clock_Tbl_OK:

		stc
Not_M2_CPU:
		pop	bx
		pop	ax
     		ret

Get_M2_Clock_Tbl	ENDP
;R64 - ends

endif;	BIOS_SUPPORT_686			;R56

;R54	- starts
ifdef	VSA_VGA
Gx86_Clock_Tbl:
		dw	 90		; 90 MHz
		dw	100             ;100 MHz
		dw	120             ;120 MHz
		dw	133             ;133 MHz
		dw	150             ;150 MHz
		dw	166             ;166 MHz
		dw	180             ;180 MHz
		dw	200             ;200 MHz
		dw	233             ;233 MHz
		dw	266             ;266 MHz
Gx86_Clock_Tbl_Len	EQU	($ - offset Gx86_Clock_Tbl)/2
endif	;VSA_VGA
;R54	- ends

DIVID		MACRO
		mov	ax,di
		div	bx
		endm
PORT61		EQU	61H
PORT8254	EQU	42H
DATA8254	EQU	43H
COUNT		EQU	3EH

;-----------------------------------------------------------------
;Input	:	None
;Output :	BH : System Clock in interger
;		BL : System Clock i.e. 10h = 16MHz
;				       20h = 20MHz
;				       30h = 25MHz
;				       40h = 33MHz
;				       50h = 40MHz
;				       60h = 50MHz
;				       60h = 60MHz
;				       60h = 66MHz
;		DH : Actual CPU clock index found
;		DL : Single/Double/Trible
;-----------------------------------------------------------------
		ALIGN	16
S_Cpu		proc	far

;R14 ifndef	P6_BIOS_ONLY
IFE	BIOS_SUPPORT_686			;R14

		cli
		mov	al,0fch 	;disable counter 2
		out	PORT61,al
		SIODELAY
		mov	al,0b4h 	;program counter 2
		out	DATA8254,al
		IODELAY
		xor	al,al
		out	PORT8254,al
		IODELAY
		out	PORT8254,al
		IODELAY

		mov	di,7aaah	;dividend
		mov	bx,5555h	;divisor
		xor	dx,dx
		mov	cx,COUNT	;count
		mov	al,0fdh 	;enable counter
		out	PORT61,al
		SIODELAY
		ALIGN	4
Divid_33:
		DIVID			;divide 1
		DIVID			;divide 2
		DIVID			;divide 3
		DIVID			;divide 4
		DIVID			;divide 5
		DIVID			;divide 6
		DIVID			;divide 7
		DIVID			;divide 8
		DIVID			;divide 9
		DIVID			;divide 10
		DIVID			;divide 11
		DIVID			;divide 12
		DIVID			;divide 13
		DIVID			;divide 14
		DIVID			;divide 15
		DIVID			;divide 16
		DIVID			;divide 17
		DIVID			;divide 18
		DIVID			;divide 19
		DIVID			;divide 20
		DIVID			;divide 21
		DIVID			;divide 22
		DIVID			;divide 23
		DIVID			;divide 24
		DIVID			;divide 25
		DIVID			;divide 26
		DIVID			;divide 27
		DIVID			;divide 28
		DIVID			;divide 29
		DIVID			;divide 30
		DIVID			;divide 31
		DIVID			;divide 32
		DIVID			;divide 33
		dec	cx
		jz	short Finish
		jmp	Divid_33
Finish:
		mov	al,0fch 	;stop counter 2
		out	61h,al
		SIODELAY
		in	al,PORT8254	;read counter 2 low byte
		IODELAY
		mov	ah,al
		in	al,PORT8254	;read counter 2 high byte
		IODELAY
		xchg	ah,al
		mov	si,ax		;store result

		xor	dx,dx
		mov	cx,COUNT	;count
		mov	al,0fdh 	;enable counter
		out	PORT61,al
		SIODELAY
		ALIGN	4
Divid_1:
		DIVID			;divide 1
		dec	cx
		jz	short Finish1
		jmp	short Divid_1
Finish1:
		mov	al,0fch 	;stop counter 2
		out	61h,al
		SIODELAY
		in	al,PORT8254	;read counter 2 low byte
		IODELAY
		mov	ah,al
		in	al,PORT8254	;read counter 2 high byte
		IODELAY
		xchg	ah,al
		mov	cx,ax
		sub	cx,si		;result 2 - result 1

		mov	ax,26f5h	;dividend low word
		mov	dx,005ah	;dividend high word

		mov	bh,byte ptr FIXED_DISK_STEP[bp]
		and	bh,CPU_TYPE_MASK

IF	BIOS_SUPPORT_586			;R14
		cmp	bh,TYPE_AMD5K86	;K86 CPU
		jne	short AmdK86_CPU
		mov	dl,4AH		;for K86
AmdK86_CPU:
		cmp	bh,TYPE_M1
		jne	short Not_M1
		mov	ax,0dbb8h
		mov	dl,56h
		jmp	short Not_Cyrix_Cpu
Not_M1:
ENDIF	;BIOS_SUPPORT_586			;R14

IF	BIOS_SUPPORT_486			;R14
		cmp	bh,TYPE_M9
		jne	short Not_M9
		mov	ax,4632h
		mov	dl,6Dh
		jmp	short Not_Cyrix_Cpu
Not_M9:

		cmp	bh,TYPE_U5
		jne	short Not_U5
		mov	ax,0dbb8h
		mov	dl,52h
		jmp	short Not_Cyrix_Cpu
Not_U5:
ENDIF	;BIOS_SUPPORT_486			;R14

ifdef	IBM_CPU_SUPPORT 				;
		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_IBM
		je	short Yes_Cyrix_Cpu
endif	;IBM_CPU_SUPPORT				;

		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_CYRIX
		je	short Yes_Cyrix_Cpu

IF	BIOS_SUPPORT_TI_CPU
		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_TI
		je	short Yes_Cyrix_Cpu
ENDIF	;BIOS_SUPPORT_TI_CPU

		jmp	short Not_Cyrix_Cpu
Yes_Cyrix_Cpu:
		mov	ax,64a8h
		mov	dl,4eh
Not_Cyrix_Cpu:

		div	cx

		xor	bl,bl
Sub_1:
		inc	bl
		sub	ax,100
		jc	short Fin_0
		jz	short No_Carry
		jmp	short Sub_1
Fin_0:
		add	ax,100

		cmp	al,50
		jae	short No_Carry
		dec	bl
No_Carry:
;------------------------------------------------------------------
;calculate system clock by checking CPU type (Single/Double/Treble)
;------------------------------------------------------------------

IF	BIOS_SUPPORT_486					;R14
		mov	al,byte ptr FIXED_DISK_STEP[bp]
		and	al,CPU_TYPE_MASK
		cmp	al,TYPE_P24C
		jne	short Not_P24C
		cmp	bl,70			;clock below 70Mhz
		jae	short Not_P24C
		;set double clock
		and	byte ptr OVERRIDE[bp],NOT CLOCK_MODE
		or	byte ptr OVERRIDE[bp],DOUBLE_CLOCK
		jmp	short Xchg_CPU_Mode_OK
Not_P24C:

		cmp	bl,50
		jae	short Not_P24T_X1
		cmp	al,TYPE_P24T
		jne	short Not_P24T_X1
		and	byte ptr OVERRIDE[bp],NOT CLOCK_MODE
Not_P24T_X1:

;R29A		cmp	bl,90					;R29
;R29A		jb	short Not_AMDDX4			;R29

		mov	al,byte ptr FIXED_DISK_STEP[bp]
		and	al,CPU_TYPE_MASK
;R29A		cmp	al,TYPE_486DX				;R29
;R29A		je	short Xchg_AMD_CPU			;R29
		cmp	al,TYPE_AMD486DX2
		je	short Xchg_AMD_CPU
		cmp	al,TYPE_486DX2
		jne	short Not_AMDDX4
Xchg_AMD_CPU:
;R29		cmp	bl,90
;R29		jb	short Not_AMDDX4
		cmp	bl,90					;R29A
		jb	short Not_AMDDX4			;R29A
		;set three clock mode
		and	byte ptr OVERRIDE[bp],NOT CLOCK_MODE
		or	byte ptr OVERRIDE[bp],THREE_CLOCK
		mov	al,byte ptr FIXED_DISK_STEP[bp]
		and	al,NOT_CPU_TYPE_MASK
		or	al,TYPE_AMD486DX4
		mov	byte ptr FIXED_DISK_STEP[bp],al
		jmp	short Xchg_CPU_Mode_OK
Not_AMDDX4:
ENDIF	;BIOS_SUPPORT_486					;R14

Xchg_CPU_Mode_OK:

		xor	bh,bh
		mov	ax,bx

		mov	bl,1

IF	BIOS_SUPPORT_586					;R14
		call	Check_586_Cpu		;p5 class CPU ?
		je	short Single_Freq	;yes,
ENDIF	;BIOS_SUPPORT_586					;R14

IF	BIOS_SUPPORT_486 OR BIOS_SUPPORT_386			;R14

		test	byte ptr OVERRIDE[bp],FOUR_CLOCK
		jz	short Three_Freq
		mov	bl,4
		jmp	short Single_Freq
Three_Freq:

		test	byte ptr OVERRIDE[bp],THREE_CLOCK
		jz	short Double_Freq

		mov	bl,3
		jmp	short Single_Freq
Double_Freq:
		test	byte ptr OVERRIDE[bp],DOUBLE_CLOCK
		jz	short Single_Freq

		mov	bl,2

ENDIF	;BIOS_SUPPORT_486 OR BIOS_SUPPORT_386			;R14

Single_Freq:

ifdef	VSA_VGA				;R40
;R40B		cmp	al, 128		;R40
;R40B		jb	short _JJJ	;R40
;R40B		mov	bl, 4		;R40
;R40B		div	bl              ;R40A
;R40B		add	al,2            ;R40A	;tolerance (add 2)
;R40B		jmp	short @F	;R40A
;R40B	_JJJ:				;R40
;R40A	endif	;VSA_VGA		;R40
;R40B		div	bl              ;R40A
;R40B		add	al,3            ;R40A	;tolerance (add 3)
;R40B	@@:                	        ;R40A
		mov	bl,1		;R40B
else	;VSA_VGA			;R40A
		div	bl

		add	al,3	       ;tolerance
endif	;VSA_VGA			;R40A

Skip_Gap:

		mov	dh,al	;DH = Actual CPU clock found
		mov	dl,bl	;DL = Single/Double/Trible

		mov	si,offset Sys_Clock_Tbl
		mov	cx,Sys_Clock_Tbl_Len

	;far call Round_Off_Clock

		FAR_CALL <offset Round_Off_Clock>,0E000h

ENDIF	;BIOS_SUPPORT_686			;R14
;R14endif;	P6_BIOS_ONLY

		ret

Check_586_Cpu	proc	near

IFE	BIOS_SUPPORT_586					;R14
		cmp	sp, 0FFFFh	;always return not 586	;R14
ELSE	;BIOS_SUPPORT_586					;R14
		push	bx
		mov	bh,byte ptr FIXED_DISK_STEP[bp]
		and	bh,CPU_TYPE_MASK
		cmp	bh,TYPE_AMD5K86		;K86 CPU
		je	short Yes_P5_Class

		cmp	bh,TYPE_586		;Pentium CPU?
		je	short Yes_P5_Class

		cmp	bh,TYPE_M1
		je	short Yes_P5_Class

Yes_P5_Class:
		pop	bx
ENDIF	;BIOS_SUPPORT_586					;R14

		ret

Check_586_Cpu	endp

		even
;R12 Last_S_Cpu:
Last_S_Cpu	Label	Near			;R12
S_Cpu		endp

;[]--------------------------------------------------------------[]
;Input	:	AL = Clock to be compared
;		SI = table offset
;		     (format: reference System_Clock_Table)
;		CX = no of entries
;
;Output :	BH = reference value (see System_Clock_Table)
;		BL = round-offed value
;		SI = offset which round-offed value locates
;[]--------------------------------------------------------------[]
Round_Off_Clock Proc	Far
ifdef	VSA_VGA			   		;R54
		mov	bh,al                   ;R54
		mov	bl,0                    ;R54
else	;VSA_VGA                                ;R54
Next_Clk_Tbl:
		mov	bx,cs:[si]
		cmp	al,bh
		jae	short @F
		cmp	byte ptr cs:[si+3],0	;last table ?
		je	short @F
		add	si,3			;next table
		jmp	short Next_Clk_Tbl
@@:
endif	;VSA_VGA                                ;R54
		retf
Round_Off_Clock Endp

;R14 ifndef	P6_BIOS_ONLY
IFE	BIOS_SUPPORT_686		;R14
;--------------------------------------------------------------------
;			round	  value 	value
;			offed	  for		to be put
;			output	  reference	into G_RAM:CPU_CLOCK
;--------------------------------------------------------------------
Sys_Clock_Tbl:
		db	CPU66,		66,	CPU66
		db	CPU60,		60,	CPU60
		db	CPU50,		50,	CPU50
		db	CPU40,		40,	CPU40
		db	CPU33,		33,	CPU33
		db	CPU25,		25,	CPU25
		db	CPU20,		20,	CPU20
		db	CPU16,		16,	CPU16
		db	0		;end of table
Sys_Clock_Tbl_Len	EQU	($ - offset Sys_Clock_Tbl)/3
ENDIF	;BIOS_SUPPORT_686		;R14
;R14 endif;	P6_BIOS_ONLY

;--------------------------------------------------------------------
;			round	  value 	value
;			offed	  for		to be put
;			output	  reference	into G_RAM:CPU_CLOCK
;--------------------------------------------------------------------
CPU_Int_Clock_Tbl:
ifndef	P6_BIOS_ONLY

IF	BIOS_SUPPORT_586
		;Add P55C-150,P54CT-150,P54CT-166 and P54CT-180
ifdef	LOW_CLOCK_VALUE_FOR_P5
		db	200,	193,	CPU66		;66x3
		db	180,	174,	CPU60		;60x3
		db	166,	161,	CPU66		;66x2.5
else;	LOW_CLOCK_VALUE_FOR_P5
ifdef	Higher_200MHz_Tbl
		db	200,	197,	CPU66		;66x3
else	;Higher_200MHz_Tbl
		db	200,	195,	CPU66		;66x3
endif	;Higher_200MHz_Tbl
ifdef LUCKY_START_166_CPU_DETECT
		db	180,	180,	CPU60		;60x3
else ;LUCKY_START_166_CPU_DETECT
		db	180,	179,	CPU60		;60x3
endif ;LUCKY_START_166_CPU_DETECT
		db	166,	163,	CPU66		;66x2.5
endif;	LOW_CLOCK_VALUE_FOR_P5

		db	150,	145,	CPU60		;60x2.5

		;add P54CS CPU support for 120 & 132 MHz
ifdef	Higher_133MHz_Tbl
		db	133,	129,	CPU66		;66x2
else	;Higher_133MHz_Tbl
		db	133,	127,	CPU66		;66x2
endif	;Higher_133MHz_Tbl
		db	125,	121,	CPU50
		db	120,	118,	CPU60		;60x2

ifndef	No_55MHz							;R67
ifndef	NO_110MHZ_CLOCK
ifdef	Higher_110MHz_Tbl
		db	110,	108,	CPU50		;55x2
else	;Higher_110MHz_Tbl

ifdef	LOW_CLOCK_VALUE_FOR_P5
		db	110,	105,	CPU50		;55x2
else;	LOW_CLOCK_VALUE_FOR_P5
		db	110,	107,	CPU50		;55x2
endif;	LOW_CLOCK_VALUE_FOR_P5

endif	;Higher_110MHz_Tbl
endif;	NO_110MHZ_CLOCK
endif	;No_55MHz							;R67

ifdef	Force_100_EQU_50_Double
		db	100,   	95,	CPU50
else	;Force_100_EQU_50_Double
ifdef	Special_P54C_Clock
		db	100,   	100,	CPU66		;66x1.5
else	;Special_P54C_Clock
		db	100,   	95,	CPU66		;66x1.5
endif	;Special_P54C_Clock
endif	;Force_100_EQU_50_Double

		db	 90,   	89,	CPU60		;60x1.5

		db	 83,   	81,	CPU50		;55x1.5
		db	 75,   	70,	CPU50		;50x1.5
		db	 66,   	60,	CPU66		;66x1
		db	0		;end of table
ENDIF	;BIOS_SUPPORT_586
endif;	P6_BIOS_ONLY

;--------------------------------------------------------------------
;			round	  value 	value
;			offed	  for		to be put
;			output	  reference	into G_RAM:CPU_CLOCK
;--------------------------------------------------------------------
M1_Int_Clock_Tbl:

ifndef	P6_BIOS_ONLY

IF	BIOS_SUPPORT_586
ifdef	LOW_CLOCK_VALUE_FOR_P5
		db	200,	193,	CPU66		;66x3
		db	180,	174,	CPU60		;60x3
else;	LOW_CLOCK_VALUE_FOR_P5
		db	200,	195,	CPU66		;66x3
		db	180,	179,	CPU60		;60x3
endif;	LOW_CLOCK_VALUE_FOR_P5

ifdef	Lower_150MHz_Tbl					;R36
;R76		db	150,    143,	CPU66		;75*2	;R36
		db	150,    143,	CPU75		;75*2	;R76
else;	Lower_150MHz_Tbl					;R36
;R76		db	150,    145,	CPU66		;75*2
		db	150,    145,	CPU75		;75*2	;R76
endif;	Lower_150MHz_Tbl					;R36

ifdef	Higher_133MHz_Tbl
	ifdef	Special_Cyrix_Tbl_For_VLSI59X
		db	133,	130,	CPU66		;66x2
	else	;Special_Cyrix_Tbl_For_VLSI59X
		db	133,	129,	CPU66		;66x2
	endif	;Special_Cyrix_Tbl_For_VLSI59X
else	;Higher_133MHz_Tbl
		db	133,	127,	CPU66		;66x2
endif	;Higher_133MHz_Tbl

ifndef	Higher_120MHz_Tbl
		db	120,	118,	CPU60		;60x2
else	;Higher_120MHz_Tbl
		db	120,	120,	CPU60		;60x2
endif	;Higher_120MHz_Tbl

ifndef	No_55MHz							;R67
ifndef	NO_110MHZ_CLOCK
  ifdef	Higher_110MHz_Tbl
	ifdef	Special_Cyrix_Tbl_For_VLSI59X
		db	110,	109,	CPU50		;55x2
	else	;Special_Cyrix_Tbl_For_VLSI59X
		db	110,	108,	CPU50		;55x2
	endif	;Special_Cyrix_Tbl_For_VSI59X
  else	;Higher_110MHz_Tbl

	ifdef	LOW_CLOCK_VALUE_FOR_P5
		db	110,	105,	CPU50		;55x2
	else;	LOW_CLOCK_VALUE_FOR_P5
		db	110,	107,	CPU50		;55x2
	endif;	LOW_CLOCK_VALUE_FOR_P5

  endif	;Higher_110MHz_Tbl
endif;	NO_110MHZ_CLOCK
endif	;No_55MHz							;R67

ifdef	Special_P54C_Clock
		db	100,	100,	CPU50		;50x2
else	;Special_P54C_Clock
		db	100,	95,	CPU50		;50x2
endif	;Special_P54C_Clock
		db	 80,	70,	CPU40		;40x2

		db	 66,	64,	CPU66		;66x1
		db	 60,    58,	CPU60		;60x1
		db	 50,	48,	CPU50		;50x1

		db	0	;end of table
endif;	BIOS_SUPPORT_586
endif;	P6_BIOS_ONLY

P24T_Int_Clock_Tbl:
ifndef	P6_BIOS_ONLY
		db	125,	       110,	CPU50
		db	100,		95,	CPU40
		db	 83,		75,	CPU33
		db	 63,		55,	CPU25
		db	 50,		45,	CPU20
		db	0
endif;	P6_BIOS_ONLY

Cpu_Speed_Msg:	db	'CPU Clock',0

;Function : Program MTRR for CPUs like P6 or P55CT
;Input	  : AL = 0 - program MTRR for conventional memory (0-640K)
;	       = 1 - program MTRR for extended memory (1Mb to top of memory)
;	    esi - extended memory size
;	    BL = 0 - L2 cache status (0-disabled, 1-enabled)	;R45B
;Output   : none
ifdef	Special_Align_for_M1_Clock_unstable			;R53A
;R53A		ALIGN	4					;R53
		ALIGN	16					;R53A
endif;	Special_Align_for_M1_Clock_unstable			;R53A
		Public	Set_Cpu_MtRR
Set_Cpu_MtRR	proc	near

IF	BIOS_SUPPORT_586
;Program cacheable region for M1 CPU
;BIOS have to set cacheable memory size for M1 CPU according to detected
;memory.
;Table for M1 CPU cacheable region control
;	memory size	value of reg.
;	-----------	-------------
;	1Mb		03H
;	2Mb		04H
;	4Mb		05H
;	8Mb		06H
;	...		...
;	4Gb		0FH
		or	al,al			;for extended memory ?
		jz	Not_M1Cpu

		mov	al,byte ptr FIXED_DISK_STEP[bp]	;get CPU type
		and	al,CPU_TYPE_MASK
		cmp	al,TYPE_M1			;6x86 CPU ?
		jne	Not_M1Cpu

		push	esi
		shl	esi,10
		and	esi, 0fff00000h
		shr	esi,10
		mov	ebx,esi
		add	ebx,1024		;add 1Mb base address

		push	ebx			;save ext memory size

		shr	ebx,10			;convert to 1Mb unit

		mov	ah,3			;value for 1Mb
		mov	si,1 			;minmum is 1Mb
Chk_MemSize:
		cmp	bx, si			;if main memory size <= cacheable
						;memory size
		jbe	short Value_Ok0		;yes
		shl	si, 1			;next memory size
		inc	ah  			;next register value
		jmp	short Chk_MemSize	;recheck again
Value_Ok0:
		F000_call Unlock_Cyrix	;open cyrix register locked

	;set cacheable region for M1 CPU in ARR7

		mov	cl, 0dbh	;ARR7
		mov	al, ah		;set cacheable region
		call	F000_Set_Cyrix

		cmp	bx, si		;if main memory = cacheable memory
		pop	ebx		;restore memory size
		je	Value_Ok	;yes , finish
		push	ebx		;Save memory size

		shr	ebx, 2		;EBX b4-b23 -> A12-A31
		shl	ebx, 4

		mov	cl, 0d8h	;ARR6
		mov	al, bl		;set A15-A12 address
		call	F000_Set_Cyrix

		shr	ebx, 8		;EBX bit 15-0 => A31-A16
		mov	cl, 0d6h	;ARR6
		mov	al, bh		;set A31-A24
		call	F000_Set_Cyrix

		mov	cl, 0d7h	;ARR6
		mov	al, bl		;set A23-A16
		call	F000_Set_Cyrix

		mov	cl, 0E2h
		mov	al, 1		;ARR6 as non-cacheable
		call	F000_Set_Cyrix

		pop	ebx		;get onboard memory size
		shr	ebx, 10		;ebx=ebx/1024 convert 1M
		mov	ax, bx		;ax= onboard memory size
		mov	bx, si		;Get Cacheable size
		sub	bx, ax		;bx=must set noncacheable memory size
		mov	ch, 0		;ch=D8h value if bx=0
		jz	short Value_Ok1	;go to set D8h value

		mov	ch, 0Fh		;value for 32MB
		mov	si, 01000000b	;minnum is 32MB
		xor	dx, dx		;initial surplus value
Chk_MemSize1:
		shr	si, 1		;next memory size
		dec	ch  		;next register value
		cmp	bx, si		;if must set noncacheable memory size
					;=> noncacheable memory size
		jae	short Value_Ok1	;then check it is on the times value
		jmp	short Chk_MemSize1;next value to check
Value_Ok1:
		push	ax		;save onboard memory size
		push	dx		;save surplus value
		div	si		;onboard memory size DIV
					;noncacheable memory size
		or	dx, dx		;if on the value
		pop	dx		;restore surplus value
		pop	ax		;restore onboard memory size
		jnz	short Chk_MemSize1	;go to set it

		mov	cl, 0D8h	;ARR6
		call	F000_Get_Cyrix
		and	al, 11110000b
		or	al, ch		;set REGION BLOCK size
		call	F000_Set_Cyrix

		cmp	bx, si		;if must set noncacheable memory size
					;= set noncacheable memory size
		je	Value_Ok	;then set finish

		push	bx		;save next must noncacheable address
					; MB is it unit

		xor	ebx, ebx	;clear ebx

		mov	cl, 0d6h	;ARR6 Noncacheable A31-A24
		call	F000_Get_Cyrix
		mov	bh, al

		mov	cl, 0d7h	;ARR6 Noncacheable A23-A16
		call	F000_Get_Cyrix
		mov	bl, al		;now BX is system memory size

		shl	ebx, 16		;ebx Bit 31 - 16 is A31-A16

		mov	cl, 0d8h	;ARR6 Noncacheable A15-A12
		call	F000_Get_Cyrix
		mov	bh, al		;ebx Bit 31 - 12 is A31-A12

		xor	eax, eax	;clear eax
		mov	ax, si		;get last set cacheable memory size
		shl	eax, 20		;EAX b31-b12 => A31-A12
		add	ebx, eax	;BX is next noncacheable start address
					;Bit 31-12 is A31-A12
					;now BX is next noncacheable address
		mov	al, bh		;set A15-A12
		mov	cl, 0d5h	;ARR5 A15-A12
		call	F000_Set_Cyrix

		shr	ebx, 16		;EBX bit 15-0 is A31-A16

		mov	al, bl
		mov	cl, 0d4h	;ARR5 A23-A16
		call	F000_Set_Cyrix	;set A23-A16

		mov	al, bh
		mov	cl, 0d3h	;ARR5 A31-A24
		call	F000_Set_Cyrix	;set A31-A24

		mov	cl, 0e1h
		mov	al, 1		;Set ARR5 noncacheable region
		call	F000_Set_Cyrix

		pop	bx		;get must noncacheable address
		mov	ax, si		;Get last Cacheable size
		sub	bx, ax		;if noncacheable address =
					;Cacheable size
		mov	ax, bx		;ax is must noncacheable address
		mov	ch, 0		;ch is D5 value
		jz	short Value_Ok2	;go set D5 value

		mov	ch, 0fh		;value for 32MB D5 value
		mov	si, 01000000b	;maxnum is 32MB
Chk_MemSize2:
		shr	si, 1		;next memory size
		dec	ch  		;next register value
		cmp	bx, si		;if must noncacheable address
					;=> Cacheable size
		jae	short Value_Ok2 ;go to check is it on the times value
		jmp	short Chk_MemSize2;check next vlaue
Value_Ok2:
		push	ax		;save must noncacheable address
		push	dx		;save surplus value
		div	si		;onboard memory size DIV
					;noncacheable memory size
		or	dx, dx		;if on the value
		pop	dx		;restore surplus value
		pop	ax		;restore onboard memory size
		jnz	short Chk_MemSize2	;go to set it

		mov	cl, 0D5h	;ARR5
		call	F000_Get_Cyrix
		and	al, 11110000b	;set REGION BLOCK value
		or	al, ch
		call	F000_Set_Cyrix

		cmp	bx, si		;if must set noncacheable memory size
					;= set noncacheable memory size
		je	short Value_Ok	;then set finish

		push	bx		;save must noncacheable address ( MB )
		xor	ebx, ebx	;clear ebx
		mov	cl, 0d3h	;ARR5 Noncacheable A31-A24
		call	F000_Get_Cyrix
		mov	bh, al

		mov	cl, 0d4h	;ARR5 Noncacheable A23-A16
		call	F000_Get_Cyrix
		mov	bl, al		;now BX is system memory size

		shl	ebx, 16		;ebx Bit 31 - 16 is A31-A16

		mov	cl, 0d5h	;ARR5 Noncacheable A15-A12
		call	F000_Get_Cyrix
		mov	bh, al		;ebx Bit 31 - 12 is A31-A12

		xor	eax, eax	;clear EAX
		mov	ax, si		;ax is last set noncacheable size
		shl	eax, 20		;eax bit 31-12 is noncacheable size
					;A31-A12
		add	ebx, eax	;BX is next noncacheable start address
					;Bit 31-12 is A31-A12
					;now BX is next noncacheable address
		mov	al, bh
		mov	cl, 0d2h	;ARR4 A15-A12
		call	F000_Set_Cyrix

		shr	ebx, 16		;EBX bit 15-0 is A31-A16

		mov	al, bl
		mov	cl, 0d1h	;ARR4 A23-A16
		call	F000_Set_Cyrix

		mov	al, bh
		mov	cl, 0d0h	;ARR4 A31-A24
		call	F000_Set_Cyrix

		mov	cl, 0e0h
		mov	al, 1		;Set ARR4 noncacheable region
		call	F000_Set_Cyrix

		pop	bx		;get must noncacheable address ( MB )
		mov	ax, si		;Get last Cacheable size
		sub	bx, ax		;if noncacheable address =
					;Cacheable size
		mov	ax, bx		;ax is must noncacheable address
		mov	ch, 0		;ch is D2 value
		jz	short Value_Ok3	;go set D2 value

		mov	ch, 0fh			;value for 32MB
		mov	si, 01000000b		;maxmum is 32MB
Chk_MemSize3:
		shr	si, 1		;next memory size
		dec	ch  		;next register value
		cmp	bx, si		;if must noncacheable address
					;=> Cacheable size
		jae	short Value_Ok3	;go to check is it on the times value
		jmp	short Chk_MemSize3;check next vlaue
Value_Ok3:
		push	ax		;save must noncacheable address
		push	dx		;save surplus value
		div	si		;onboard memory size DIV
					;noncacheable memory size
		or	dx, dx		;if on the value
		pop	dx		;restore surplus value
		pop	ax		;restore onboard memory size
		jnz	short Chk_MemSize3	;go to set it

		mov	cl, 0D2h	;ARR4
		call	F000_Get_Cyrix
		and	al, 11110000b	;set REGION BLOCK value
		or	al, ch
		call	F000_Set_Cyrix
Value_ok:
		F000_call lock_Cyrix	;lock cyrix CPU register access

 		pop	esi
 Not_M1Cpu:

 endif;	BIOS_SUPPORT_586

ifdef	P6_BIOS_ONLY
;Set 0-640K MTRR for P6 type CPUs

		or	al,al				;for base memory ?
		jnz	short Set_1MbAbove

;Set A0000-BFFFF as uncache region
		xor	eax,eax 	;set uncache of low 32bit
		mov	edx,eax 	;set uncache of high 32bit
		mov	ecx,259H	;region for A0000-BFFFF
		WRMSR

;Set C0000-FFFFF as uncache region ( 268H - 26FH )
		mov	cl,68H		;start from C0000H
SetUc_Nxt32K:
		WRMSR
		inc	cl		;next 32k
		cmp	cl,6FH		;f8000-fffff ?
		jbe	short SetUc_Nxt32K

;Clear all Variable Range MTRRs (200H - 20FH)
		xor	cl,cl		;start from register 200H
Clear_VarMtrr:
		WRMSR
		inc	cl		;next MTRR
		cmp	cl,0FH		;last MTRR ?
		jbe	short Clear_VarMtrr

;Enable write back of 0-640K for P6 CPU
		mov	eax,06060606H	;set memory type to WB in lower 32bit
		mov	edx,eax 	;higher 32bit
		mov	ecx,250H	;address(250H) for 0-512K
		WRMSR
		mov	cl,58H		;address(258H) for 512K-640K
		WRMSR

;Enable caching for memory
		mov	eax,00000C00h
		xor	edx,edx
		mov	cl,0ffH 	;address(2ffH) to enable caching
		WRMSR
		jmp	Flush_Cache_TLB

Set_1MbAbove:

;R45 - start
;Qualify cacheable range for Pentium II CPU accroding to BBL_CR_CTL3[22:20]
;Now, the value of this three bits is "000" , that is maximum - 512MB
;We don't know the meaning of other values except "000"
;So, Set 512Mb as maximum cacheable range. One day, if CPU can support
;cacheable range beyond 512Mb , we have to re-write this code.
ifdef	KLAMATH_CPU_ONLY
 ifdef	BOTH_P6_KLAMATH_CPU
		call	Read_CpuID		;get CPU ID
		cmp	al,30h			;klamath ?
		jb	short Below512M		;It's Pentium Pro
 endif;	BOTH_P6_KLAMATH_CPU

		cmp	esi,(512-1)*1024	;over 512Mb ?
		jbe	short Below512M		;no

;R45A - start
;Don't limit the cacheability to 512Mb if the L2 cache is turned off for P II
;In this condition , the L1 cache still have full address cacheability
;R45B		mov	si,offset ExtCache_Item	;get CMOS status
;R45B		call	F000_GetItem_Value
;R45B		or	al,al			;L2 cache disabed
		or	bl,bl			;L2 cache disabled ?;R45B
		jz	short Below512M		;yes, no limit for > 512MB
;R45A - end

		mov	esi,(512-1)*1024	;maximum 512Mb cacheable
Below512M:
endif;	KLAMATH_CPU_ONLY
;R45 - end

		mov	eax,esi
		or	eax,eax 		;zero size ?
		jz	short No_Need_MTRR

		add	eax,1024		;add 1Mb base address
		shl	eax,10			;convert to flat address

;R20		mov	cx,11			;check A31-A21
		mov	cx,16			;check A31-A16	;R20

		mov	esi,200H		;MTRRphybas0
		xor	ebx,ebx 		;start from MTRR mask 0
		xor	edi,edi

Next_Addr_Bit:

		or	bl,1			;set mask bit
		ror	ebx,1

		rol	eax,1
		jc	short Set_Mtrr_Base

		loop	short Next_Addr_Bit	;next address bit to check

		jmp	short Flush_Cache_TLB

Set_Mtrr_Base:
		push	eax
		push	ecx

		mov	ecx,esi 		;address of MTRR
		mov	eax,edi 		;memory type
		or	al,06H			;enable WB
		xor	edx,edx 		;top 32bit of MTRR
		WRMSR

		inc	ecx			;address mask of MTRR
		mov	edx,0FH			;mask bit for A35-A32
		mov	eax,ebx
		or	ah,08H			;enable valid bit
		WRMSR

	;setup next base address by examine mask address
		xor	eax,eax
		mov	al,1
		mov	ecx,ebx

NextShift_Bit:

		ror	ecx,1
		jc	short Shift_Ok

		shl	eax,1
		jmp	short NextShift_Bit
Shift_Ok:
		add	edi,eax

		pop	ecx
		pop	eax
		inc	esi			;next base address
		inc	esi			;next base address
		jmp	short Next_Addr_Bit

Flush_Cache_TLB:
;Invalidate TLB and flush cache
		WBINVD
		mov	eax,cr3
		mov	cr3,eax 	;Invalidate TLB by loading CR3.

No_Need_MTRR:
endif;	P6_BIOS_ONLY

		ret
Set_Cpu_MtRR	endp

ifdef	MP_SUPPORT
ifdef	P6_BIOS_ONLY
		public	Init_Mtrr
Init_Mtrr	proc	far

		call	P6_BiosUpdate		;update P6 patch codes


ifdef	KLAMATH_CPU_ONLY				;R21
		call	ConfigurePProL2Cache    	;R21
;R44A;R44 - start
;R44A	;save L2 cache size in temporary area
;R44A		mov	eax,2			;read cache isze
;R44A		db	0Fh,0A2h		;OP code: CPUID
;R44A		xor	ax,ax
;R44A		mov	es,ax			;segment 0
;R44A		mov	es:[0502H],dl		;save L2 cache size
;R44A;R44 - end

endif;	KLAMATH_CPU_ONLY				;R21

;R46 - start
;Disable second CPU L2 cache if CMOS disable it.
;R46A		mov	si,offset ExtCache_Item	;get CMOS status
;R46A		call	F000_GetItem_Value
		xor	ax,ax					;R46A
		mov	ds,ax			;segment	;R46A
;R45B		mov	al,ds:[502h]		;get L2 CMOS	;R46A
;R45B		or	al,al			;L2 cache disabed
		mov	bl,ds:[502h]		;get L2 CMOS	 ;R45B
		or	bl,bl			;L2 cache disabed;R45B
		jnz	short CpuL2Enabled

		mov	al,False		;disable L2 cache
		call	P6_L2Cache_Control
		jmp	short Set_CpuL2_Done	;R46B
CpuL2Enabled:
;R46B start
		mov	al,True			;Enable L2 cache
		call	P6_L2Cache_Control
Set_CpuL2_Done:
;R46B end
;R46 - end

		push	bx			;R45B
		xor	al,al			;program address for 0-640k
		call	Set_Cpu_MtRR
		pop	bx			;R45B

		mov	ax,4100H
		mov	ds,ax
		mov	esi,dword ptr ds:[0]	;save extended size

						;bl = L2 cache status
		mov	al,1			;program address above 1Mb
		call	Set_Cpu_MtRR

		ret
Init_Mtrr	endp
endif;	P6_BIOS_ONLY
endif;	MP_SUPPORT

ifdef	P6_BIOS_ONLY
		Public	P6_BiosUpdate
P6_BiosUpdate	proc	near
;Execute BIOS Update data to fix P6 bugs

	;Now , read CPU ID , don't execute BIOS Update data if mismatch
		mov	eax,1			;eax = 1 to read CPU ID
		db	0fh,0A2h		;CPU ID instruction

;R24 start
;----- Check P6 updata micro code is match or not for current CPU ID -----
		mov	bx,2000h
		mov	ds,bx
		mov	bx,P6_Block_Start_Seg
		cmp	ax,word ptr ds:[bx].Processor_Version
		je	short Go_Patch		;yes patch it
ifdef	MP_SUPPORT
		mov	bx,P6_Sec_Block_Start_Seg
		cmp	ax,word ptr ds:[bx].Processor_Version
		je	short Go_Patch		;yes patch it
endif	;MP_SUPPORT
;-------------------------------------------------------------------------

;----- Check P6 default micro code is match or not for current CPU ID -----
;R57		mov	bx,Temp_EXP_Seg
;R57		mov	es,bx
;R57		mov	bx,es:[Temp_EXP_Off+8]
;R57		cmp	bx,0ffffh
;R57		je	short No_Patch_Data
;R57		push	ax		;store current Processor Version
;R57		mov	di,es:[Temp_EXP_Off]
;R57		push	es:[Temp_EXP_Off+10]
;R57		pop	es
;R57		push	cs
;R57		push	offset Exp_Ret_Addr
;R57		push	0dfffh
;R57
;R57		mov	al,TRUE
;R57		F000_Call	Cpu_Cache
;R57		mov	dx,Exp_Data_Seg
;R57		push	2000h
;R57		push	di
;R57		retf
;R57Exp_Ret_Addr:
;R57		mov	al,FALSE
;R57		F000_Call	Cpu_Cache
		pushad					;R66
		mov	di,8				;R57
		call	POST_decompress			;R57
		popad					;R66
		jc	short No_Patch_Data		;R57

		mov	ecx,es:[bx+0bh]			;get total micro code size
		shr	ecx,11				;get total micro code number (each 800h bytes)
		mov	bx,Temp_CBROM_Segment
		mov	ds,bx
		xor	bx,bx
;R57		pop	ax		;restore current Processor Version
Check_Next_P6:
		cmp	ax,word ptr ds:[bx].Processor_Version

		je	short Go_Patch		;yes patch it
		add	bx,800h

		loop	Check_Next_P6
		jmp	short No_Patch_Data
;R24 end

;R24		mov	si,offset P6Upd_CPUIDs	;get offset of CPUID table
;R24Check_Next_P6:
;R24		mov	bx,cs:[si]		;get address of CPUid
;R24		cmp	bx,-1			;last CPU ID ?
;R24		je	short No_Patch_Data
;R24		mov	cx,cs:[si+2]
;R24		mov	ds,cx
;R24		cmp	ax,word ptr ds:[bx].Processor_Version
;R24
;R24		je	short Go_Patch		;yes patch it
;R24		add	si,4
;R24
;R24		jmp	short Check_Next_P6

Go_Patch:
		mov	ecx,79H			;CPU register
		xor	eax,eax
		xor	edx,edx
		mov	ax,ds

		shl	eax,4			;segment of data

		add	bx,48			;point to data area
		mov	ax,bx
		WRMSR
No_Patch_Data:

		ret
P6_BiosUpdate	endp
endif;	P6_BIOS_ONLY

		Public	Enable_M1_FarHit
Enable_M1_FarHit	proc	near

ifndef	P6_BIOS_ONLY

		call	Check_M1_Cpu
		jne	short Not_M1_Cpu

		F000_call	UNlock_Cyrix

ifdef	HIGH_6X86_L2_HIT_RATE
;Enable WT_ALLOC of CCR5 to improve L2 cache hit rate for CCT386.EXE
;For 256Kb cache it improve hit rate from 26% upto 62% for 6x86 CPUs
		mov	cl,0E9H			;CCR5
		call	F000_Get_Cyrix
		or	al,01H			;enable WT_ALLOC
		call	F000_Set_Cyrix
endif;	HIGH_6X86_L2_HIT_RATE

	;set bit 6 of index 30H
		mov	cl,30H
		call	F000_Get_Cyrix
		or	al,40H
		call	F000_Set_Cyrix

	;enable far hit
		mov	ebx,28h
		db	0fh,26h,0cbh		;mov tr1,ebx
		db	0fh,24h,0d0h		;mov eax,tr2
		and	al,NOT 02H		;enable far hits
		db	0fh,26h,0d0h		;mov tr2,eax

	;clear bit 6 of index 30H
		mov	cl,30H
		call	F000_Get_Cyrix
		and	al,NOT 40H
		call	F000_Set_Cyrix

		F000_call lock_Cyrix

Not_M1_Cpu:
endif;	P6_BIOS_ONLY

		ret
Enable_M1_FarHit	endp

		public	F000_Set_Cyrix
F000_Set_Cyrix	Proc	Near
		F000_Call Set_Cyrix
		ret
F000_Set_Cyrix	Endp

F000_Get_Cyrix	Proc	Near
		F000_Call Get_Cyrix
		ret
F000_Get_Cyrix	Endp

ifdef	KLAMATH_CPU_ONLY
		include	P6L2cach.inc
endif;	KLAMATH_CPU_ONLY

;R24		include	P6DATA.INC
;R12 - ends

;R17 - starts
;[]========================================================================[]
;Name	  :	Prg_K5_Write_Allocate
;
;Function :	To enable the AMD K5 CPU's write allocation function
;
;Input	  :	dword ptr EXT_MEM_SIZE[bp] in terms of 1K
;
;Output	  :	None
;[]========================================================================[]
		Public	Prg_K5_Write_Allocate
Prg_K5_Write_Allocate	Proc	Near

ifndef	No_K5_Write_Allocation				;R49
IF	BIOS_SUPPORT_586

		pushad

 		call	Check_K586_Cpu 			;AMD 5k86 CPU ?
;R47 		jne	short No_Write_Alloc		;no !
 		jne	No_Write_Alloc			;R47 no !

		call	Read_CpuID			;read CPU ID in AX
		mov	ah, al
		and	ah, 0F0h			;Model = 0x ?
		jz	short No_Write_Alloc		;yes, skip
		cmp	ah, 030h			;Model = 0x, 1x, 2x ?
		ja	short No_Write_Alloc		;no, skip

		and	al, 0Fh				;AL = stepping
		cmp	al, 4				;stepping >= 4
		jb	short No_Write_Alloc		;no, skip

	;----------------------------------------------------------
	;MSR 85h b15-b0 : Top of memory address
	;	 b16    : Fixed Range Enable, i.e. from A0000-FFFFF
	;	 b17    : Programmable Range Enable
	;	 b18    : Top-Of-Memory Enable
	;----------------------------------------------------------

		F000_call Ct_MemHole_Status	;get hole status in AX
		mov	si, ax			;temporary save to SI

		mov	ecx, 85h
		RDMSR
		mov	ecx, EXT_MEM_SIZE[bp]
		shr	ecx, 6			;convert to 64K byte unit
		add	cx, 10h			;add 1M of base memory
		mov	ax, cx

		and	eax, not 00070000h	;always disable Fixed Range
;R17B		or	eax, 00040000h		;enable Top-Of-Mem range
		or	eax, 00050000h		;enable Top-Of-Mem range;R17B
						;   & Fix Range		;R17B
		or	si, si			;memory hole enabled?
		jz	short @F		;disabled !
		or	eax, 00020000h		;enable Programmable Range
	@@:
		mov	ecx, 85h
		WRMSR

	;program the Programmable Range for 15M-16M as Non-WA

		or	si, si			;memory hole enabled?
		jz	short @F		;disabled !
		mov	ecx, 86h
		RDMSR
;R17A		mov	ax, 0010000Fh
		mov	eax,00FF00F0h		;15M-16M as Non-cacheable;R17A
		mov	ecx, 86h
		WRMSR
	@@:

	;program bit 4 or MSR 83 to enable write allocate
	;bit 31 is for bus pipeline but undocumented.			;R38

		mov	ecx, 83h
		RDMSR
;R38		or	al, 10h			;enable write allocate
		or	eax, 80000010h		;enable write allocate	;R38
						;disable bus pipeline	;R38
		WRMSR

No_Write_Alloc:

		popad

ENDIF	;BIOS_SUPPORT_586
endif	;No_K5_Write_Allocation				;R49

		ret

Prg_K5_Write_Allocate	Endp
;R17 - ends

ECODE		ENDS

ENDIF	;COMPILE_FOR_E0					;R12

;R12 - starts
IFE	COMPILE_FOR_E0

;R26 - starts
		extrn	F000_call_proc:near
		extrn	Ct_MemHole_Status:Near
		extrn	F000_Shadow_W:Near
		extrn	F000_Shadow_R:Near
IF	BIOS_SUPPORT_586
		extrn	Skip_K6_Write_Allocate:Near
ENDIF	;BIOS_SUPPORT_586
;R26 - ends
IF	BIOS_SUPPORT_686			;R27
		extrn	VideoCache_Item:near	;R27
 ifdef	SEPARATE_P6_VIDEO_ITEM			;R43
		extrn	VideoRom_Item:near	;R43
 endif;	SEPARATE_P6_VIDEO_ITEM			;R43
endif;	BIOS_SUPPORT_686			;R27
		extrn	F000_GetItem_Value:near	;R27

		extrn	F000_Display_Char:Near
		extrn	F000_Display_String:Near

;R14 - starts
		extrn	DISPLAY_CS_STRING:Near
		extrn	SYSCFG_CPU_CLOCK1:Near
;R14 - ends

		extrn	fProc_Disp_Word_Int3:far	;R14A
		extrn	fProc_Disp_Byte_Int2:far	;R14A

.LIST
EGROUP		GROUP	ECODE
ECODE		SEGMENT USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP,DS:G_RAM,ES:EGROUP


;Function : return cache size in AL for display
;Input    : DL - CPU register value to indicate cache size
;Output   : AL - cache size for BIOS to display
;           AL -  0 = 0K, 1=16K , 2=32K , 3=64K , 4=128K , 5=256K
;	          6 =512K, 7=1024K ,etc...
		Public	Convert_P6L2_Cache
Convert_P6L2_Cache	proc	near
IF	BIOS_SUPPORT_686			;R14
		mov	al,5			;assume 256K
		cmp	dl,42h			;256k ?
	   	je	short Mark_L2_Size

		mov	al,6			;set 512k
		cmp	dl,43h			;512k ?
	   	je	short Mark_L2_Size

		mov	al,4			;assume 128K
		cmp	dl,41h
	   	je	short Mark_L2_Size	;yes

		xor	al,al			;No L2 cache
Mark_L2_Size:
ENDIF	;BIOS_SUPPORT_686			;R14
		ret
Convert_P6L2_Cache	endp

;=============================================================================
;FUNC:	CPU_DISPLAY
;
;DESC:	Returns the length and description string for the CPU.
;
;IN:	NONE
;OUT:	CS:SI	String pointer
;
;SAVES:	DX
;=============================================================================
		PUBLIC	CPU_DISPLAY
CPU_DISPLAY	PROC	Near

		mov	al,FIXED_DISK_STEP[bp]
		and	al,CPU_TYPE_MASK

;R14 IF	BIOS_SUPPORT_486
IF	BIOS_SUPPORT_TI_CPU			;R14
		mov	si,offset TI_486dx4_str		;assume TI CPU !
		cmp	al,TYPE_CYRIX_DX4		;cyrix DX 4 ?
		jne	short Not_CyDx4
	;read DIR 0 value , it is Ti486DX4 if value is 81H
		push	ax
		mov	al,0FEh
		out	22h,al
		in	al,23h
		cmp	al,81h				;TI 486DX4 CPU ?
		pop	ax
		je	short Cpu_Str_Ok		;yes
Not_CyDx4:
ENDIF	;BIOS_SUPPORT_TI_CPU			;R14
;R14 endif	;BIOS_SUPPORT_486

		cmp	al,NUM_OF_CPU_TYPE
		mov	si,offset Unknown_Str
		ja	short @F
		movzx	si,al
		mov	si,word ptr cs:CPU_TYPE_STRS[si]
	@@:

;R23 - start
ifdef	BOTH_P6_KLAMATH_CPU
		cmp	si,offset Cpu_P6_Str	;is P6 CPU ?
		jne	short Not_P6Cpu
		call	Read_CpuID		;get CPU ID
		cmp	al,30h			;klamath ?
		jae	short Not_P6Cpu
		mov	si,offset Cpu_Ppro_Str	;it's PENTIUM PRO CPU
Not_P6Cpu:
endif;	BOTH_P6_KLAMATH_CPU
;R23 - end

IF	BIOS_SUPPORT_486			;R14
		cmp	al,TYPE_486DX2
		jne	short @F
		test	byte ptr FIXED_DISK_STEP[bp],COPROCESSOR
		jz	short @F
		mov	si,offset cpu_486dx2_str
	@@:
		cmp	al,TYPE_M7_2
		jne	short @F

		mov	al,0FFh
		out	22h,al
		in	al,23h
		test	al,80h			;TI CPU ?
		jz	short @F		;No
		mov	si,offset TI_486dx2_str
	@@:
ENDIF	;BIOS_SUPPORT_486			;R14
Cpu_Str_Ok:

IF	BIOS_SUPPORT_486
;display "P90" for 160Mhz and "P75" for 133Mhz AMD X5 CPUs
	    	cmp	si,offset Cpu_AmdDX5_Str	;AMD X5 ?
		jne	short Not_Amd_X5Cpu

		cmp	byte ptr CPU_INT_CLOCK[bp],160	;160Mhz ?
		jne	short Not_Amd_X5Cpu

		mov	si,offset Cpu_AmdDX5_160_Str	;show P90 for 160Mhz

Not_Amd_X5Cpu:

	    	cmp	si,offset Cpu_AMD486DX4Plus_Str	;Enhanced Am486DX4 ?
		jne	short Not_Amd_150_Cpu

		cmp	byte ptr CPU_INT_CLOCK[bp],150	;150Mhz ?
		jne	short Not_Amd_150_Cpu

		mov	si,offset Cpu_AmdDX5_150_Str	;show P75+ for 150Mhz
Not_Amd_150_Cpu:

endif;	BIOS_SUPPORT_486

;R10A - starts
IF	BIOS_SUPPORT_586
;R50 - start
	;display IDT/C6 string instead of Pentium if it is C6
		cmp	si,offset Cpu_586_Str	;assume Pentium CPU
		jne	short Not_IdtC6
;R77 - start
		call	Check_Tillamook
		jne	short Not_Tillamook
		mov	si,offset Tillamook_Str
		jmp	short GoCpuDisaplay
Not_Tillamook:
;R77 - end
		call	Check_IdtCpu		;is IDT C6 CPU ?
		jne	short Not_IdtC6
		mov	si,offset IdtC6_Str	;display C6 instead of Pentium
		jmp	short GoCpuDisaplay
Not_IdtC6:
;R50 - end

	;if CPU type is AMD K6, then return with K6 string

		call	Check_K6_CPU		;K6 ?
		jne	short Is_Not_K6		;no !

		mov	si, offset Cpu_AmdK6_Str

;R78 - start
		call	Check_K6_3D_Feature	;check if 3D version ?
		jne	short Not_K6_3D
		mov	si, offset Cpu_amdK6_3D_str  ;show K6/3D
Not_K6_3D:
;R78 - end

		jmp	short GoCpuDisaplay	;R50

	Is_Not_K6:

;R18 - start
;R18A ifdef	TEMP_M2_SUPPORT
		call	Check_M1_Cpu 		;check if 6x86 CPU
		jne	short Not_Cy6x86Cpu

		mov	al,0feH			;DIR0 register
		out	22h,al
		in	al,23h			;read DIR0 value

		cmp	al,50h
		jb	short Not_Cy6x86Cpu
		cmp	al,5fH
		ja	short Not_Cy6x86Cpu

		mov	si,offset Cpu_M2_Str
Not_Cy6x86Cpu:
;R18A endif;	TEMP_M2_SUPPORT
;R18 - end
GoCpuDisaplay:					;R50
ENDIF	;BIOS_SUPPORT_586
;R10A - ends

		ret

CPU_DISPLAY	ENDP

;R50 - start
IF	BIOS_SUPPORT_586
;R77 - start
Check_Tillamook	Proc	Near

		cmp	byte ptr CPU_BRAND[bp], CPU_BRAND_INTEL
		jne	short @F

		pushad
		mov	eax,1
		db	0Fh,0A2h
		and	al,0f0h
		cmp	al,80h
		popad
	@@:
		ret

Check_Tillamook	Endp
;R77 - end

;Function: Check if IDT/C6 CPU plugged
;Input   : none
;Output  : zero set - it's IDT-C6 CPU
;	  non-zero - not C6 CPU
		public	Check_IdtCpu
Check_IdtCpu	proc	near
		
		cmp	byte ptr CPU_BRAND[bp], CPU_BRAND_INTEL		;R59
		jne	short @F					;R59

		pushad
		xor	eax,eax			;get vendor ID string
		db	0Fh,0A2h		;OP code: CPUID
		cmp	ebx,746e6543h		;C6 vendor ID string match ?
		popad
	@@:								;R59
		ret
Check_IdtCpu	endp
endif;	BIOS_SUPPORT_586
;R50 - end


CPU_TYPE_STRS:
		dw	offset cpu_386dx_str
		dw	offset cpu_386sx_str
		dw	offset cpu_386sl_str
		dw	offset cpu_486dx_str
		dw	offset cpu_486sx_str
		dw	offset cpu_486sx2_str
		dw	offset cpu_Cx486slc_str
		dw	offset cpu_Cx486dlc_str
		dw	offset cpu_ibm386slc_str
		dw	offset cpu_ibm486slc2_str
		dw	offset Cpu_P24t_str
		dw	offset Cpu_486s_Str
		dw	offset Cpu_486s2_Str
		dw	offset Cpu_586_Str
		dw	offset Cpu_486dxS_Str
		dw	offset Cpu_486sxS_Str
		dw	offset Cpu_486dx2S_Str
		dw	offset cpu_ibm486dlc3_str
		dw	offset Cpu_M7_Str
		dw	offset Cpu_M7_2_Str
		dw	offset Cpu_Cx486slc2_Str
		dw	offset Cpu_P24c_Str
		dw	offset Cpu_TI486SXL_Str
		dw	offset Cpu_TI486SXL2_Str
		dw	offset Cpu_U5_Str
		dw	offset Cpu_AMD486_Str
		dw	offset Cpu_P54c_Str
		dw	offset Cpu_TI486SXLC_Str
		dw	offset Cpu_TI486SXLC2_Str
		dw	offset Cpu_AMD486DX2_Str
		dw	offset Cpu_P24D_Str
		dw	offset Cpu_AMD486DX4_Str
		dw	offset Cpu_M1_Str
		dw	offset Cpu_AMD486Plus_Str
		dw	offset Cpu_AMD486DX4Plus_Str
		dw	offset Cpu_U486sx2_Str
		dw	offset Cpu_U486DX_Str
		dw	offset Cpu_U486DX2_Str
		dw	offset Cpu_M9_Str
		dw	offset Cpu_Cyrix_Dx4_Str
		dw	offset Cpu_P6_Str
		dw	offset Cpu_AmdDX5_Str
		dw	offset Cpu_AmdD5K86_Str
NUM_OF_CPU_TYPE	EQU	($ - offset CPU_TYPE_STRS)

;-------------------------- 386 CPU Strings --------------------------

IF	BIOS_SUPPORT_386

	cpu_386dx_str:		db	"80386DX",0
 ifdef	M6117_CPU
	cpu_386sx_str:		db	"ALi-M6117",0
 else	;M6117_CPU
	cpu_386sx_str:		db	"80386SX",0
 endif	;M6117_CPU
	cpu_386sl_str:		db	"RapidCAD",0
	Cpu_Cx486slc2_Str:	db	"Cx486SLC2",0
	cpu_Cx486slc_str:	db	"Cx486SLC",0
	cpu_Cx486dlc_str:	db	"Cx486DLC",0

ELSE	;BIOS_SUPPORT_386

	cpu_386dx_str:
	cpu_386sx_str:
	cpu_386sl_str:
	Cpu_Cx486slc2_Str:
	cpu_Cx486slc_str:
	cpu_Cx486dlc_str:	db	0

ENDIF	;BIOS_SUPPORT_386

;-------------------------- 486 CPU Strings --------------------------

IF	BIOS_SUPPORT_486

	;----- Intel 486 -----

	cpu_486dx_str:		db	"80486DX",0
	cpu_486sx_str:		db	"80486SX",0
	cpu_487sx_str:		db	"80487SX",0
ifdef 	ELAN400			  				;R74
	cpu_486sx2_str:		db	"ElanSC400",0		;R74
else; 	ELAN400			  				;R74
	cpu_486sx2_str:		db	"80486SX2",0
endif; 	ELAN400			  				;R74
	cpu_486dx2_str:		db	"80486DX2",0
	Cpu_P24t_str:		db	"PENTIUM OverDrive",0

	Cpu_P24c_Str:		db	"DX4",0
	Cpu_P24D_Str:		db	"P24D",0

	;----- TI 486 -----

	TI_486dx2_str:		db	"TI486DX2",0
	TI_486dx4_str:		db	"TI486DX4",0

	;----- Cyrix 486 -----

	ifndef	No_Brand_For_CYRIXCPU

		Cpu_Cyrix_Dx4_Str:	db	"CxDX4",0
		Cpu_486s_Str:		db	"Cx486S",0
		Cpu_486s2_Str:		db	"Cx486S2",0
		Cpu_M7_Str:		db	"Cx486DX",0
		Cpu_M7_2_Str:		db	"Cx486DX2",0

	else	;No_Brand_For_CYRIXCPU

		Cpu_Cyrix_Dx4_Str:	db	"DX4",0
		Cpu_486s_Str:		db	"486S",0
		Cpu_486s2_Str:		db	"486S2",0
		Cpu_M7_Str:		db	"486DX",0
		Cpu_M7_2_Str:		db	"486DX2",0

	endif	;No_Brand_For_CYRIXCPU

	ifdef	VSA_VGA						;R41
;R52		Cpu_M9_Str:		db	"Gx86",0	;R41
		Cpu_M9_Str:		db	"MediaGX",0	;R52
	else	;VSA_VGA					;R41
		Cpu_M9_Str:		db	"Cx5x86",0
	endif	;VSA_VGA					;R41

	;----- UMC 486 -----

	ifndef	No_Brand_For_UMCCPU

		Cpu_U5_Str:		db	"U486SX",0
		Cpu_U486sx2_Str:	db	"U486SX2",0
		Cpu_U486DX_Str:		db	"U486DX",0
		Cpu_U486DX2_Str:	db	"U486DX2",0

	else	;No_Brand_For_UMCCPU

		Cpu_U5_Str:		db	"486SX",0
		Cpu_U486sx2_Str:	db	"486SX2",0
		Cpu_U486DX_Str:		db	"486DX",0
		Cpu_U486DX2_Str:	db	"486DX2",0

	endif	;No_Brand_For_UMCCPU

	;----- AMD 486 -----

	ifndef	No_Brand_For_AMDCPU

		Cpu_AMD486_Str:		db	"Am486DX",0
		Cpu_AMD486DX2_Str:	db	"Am486DX2",0
		Cpu_AMD486DX4_Str:	db	"Am486DX4",0
		Cpu_AMD486Plus_Str:	db	"Enhanced Am486DX2",0
		Cpu_AMD486DX4Plus_Str:	db	"Enhanced Am486DX4",0
		Cpu_AmdDX5_Str:		db	"Am5x86-P75",0
		Cpu_AmdDX5_160_Str:  	db	"Am5x86-P90",0
		Cpu_AmdDX5_150_Str:  	db	"Am5x86-P75+",0

	else	;No_Brand_For_AMDCPU

		Cpu_AMD486_Str:		db	"486DX",0
		Cpu_AMD486DX2_Str:
		Cpu_AMD486Plus_Str:	db	"486DX2",0
		Cpu_AMD486DX4_Str:
		Cpu_AMD486DX4Plus_Str:	db	"486DX4",0
		Cpu_AmdDX5_Str:		db	"Am5x86-P75",0
		Cpu_AmdDX5_160_Str:  	db	"Am5x86-P90",0
		Cpu_AmdDX5_150_Str:  	db	"Am5x86-P75+",0

	endif	;No_Brand_For_AMDCPU

ELSE	;BIOS_SUPPORT_486

	Cpu_AmdDX5_Str:
	cpu_486dx_str:
	cpu_486sx_str:
	cpu_487sx_str:
	cpu_486sx2_str:
	cpu_486dx2_str:
	Cpu_P24t_str:
	Cpu_P24c_Str:
	Cpu_P24D_Str:
	Cpu_AMD486Plus_Str:
	Cpu_AMD486DX4Plus_Str:
	Cpu_U486sx2_Str:
	Cpu_U486DX_Str:
	Cpu_U486DX2_Str:
	Cpu_M9_Str:
	TI_486dx2_str:
	Cpu_Cyrix_Dx4_Str:
	Cpu_486s_Str:
	Cpu_486s2_Str:
	Cpu_M7_Str:
	Cpu_M7_2_Str:
	Cpu_AMD486_Str:
	Cpu_U5_Str:
	Cpu_AMD486DX2_Str:
	Cpu_AMD486DX4_Str:	db	0

ENDIF	;BIOS_SUPPORT_486

;-------------------------- 586 CPU Strings --------------------------

IF	BIOS_SUPPORT_586

	Cpu_586_Str:		db	"PENTIUM",0
	Cpu_P54c_Str:

	Cpu_M1_Str:		db	"6x86",0
	Cpu_AmdD5K86_Str:	db	"AMD-K5",0
	Cpu_AmdK6_Str:		db	"AMD-K6(tm)",0		;R10A;R51
	Cpu_AmdK6_3D_Str:	db	"AMD-K6 3D",0		;R78
	IdtC6_Str:		db	"IDT WinChip C6",0 	;R50;R65
	Tillamook_Str		db	"Tillamook",0		;R77

;R18Aifdef	TEMP_M2_SUPPORT					;R18
	Cpu_M2_Str:		db	"6x86MX",0 		;R18;R18D
;R18Aendif;	TEMP_M2_SUPPORT					;R18

ELSE	;BIOS_SUPPORT_586

	Cpu_AmdD5K86_Str:
	Cpu_586_Str:
	Cpu_P54c_Str:
	Cpu_M1_Str:

ENDIF	;BIOS_SUPPORT_586

;-------------------------- 686 CPU Strings --------------------------

IF	BIOS_SUPPORT_686

ifdef	KLAMATH_CPU_ONLY
;R34	Cpu_P6_Str:		db	"KLAMATH",0
	Cpu_P6_Str:		db	"PENTIUM II",0		;R34

 ifdef	BOTH_P6_KLAMATH_CPU					;R23
 	Cpu_Ppro_Str:		db	"PENTIUM PRO",0		;R23
 endif; BOTH_P6_KLAMATH_CPU					;R23

else;	KLAMATH_CPU_ONLY
	Cpu_P6_Str:		db	"PENTIUM PRO",0
endif;	KLAMATH_CPU_ONLY

ELSE	;BIOS_SUPPORT_686

	Cpu_P6_Str:		db	0

ENDIF	;BIOS_SUPPORT_686

;-------------------------- IBM CPU Strings --------------------------

IF	BIOS_SUPPORT_IBM_CPU

	cpu_ibm386slc_str:	db	"IBM386SLC",0
	cpu_ibm486slc2_str:	db	"IBM486SLC2",0
	cpu_ibm486dlc3_str:	db	"IBM486DLC3",0

ELSE	;BIOS_SUPPORT_IBM_CPU

	cpu_ibm386slc_str:
	cpu_ibm486slc2_str:
	cpu_ibm486dlc3_str:	db	0

ENDIF	;BIOS_SUPPORT_IBM_CPU

;-------------------------- TI CPU Strings --------------------------

IF	BIOS_SUPPORT_TI_CPU

	Cpu_TI486SXL_Str:	db	"TI486SXL",0
	Cpu_TI486SXL2_Str:	db	"TI486SXL2",0
	Cpu_TI486SXLC_Str:	db	"TI486SXLC",0
	Cpu_TI486SXLC2_Str:	db	"TI486SXLC2",0

ELSE	;BIOS_SUPPORT_TI_CPU

	Cpu_TI486SXL_Str:
	Cpu_TI486SXL2_Str:
	Cpu_TI486SXLC_Str:
	Cpu_TI486SXLC2_Str:	db	0

ENDIF	;BIOS_SUPPORT_TI_CPU

;---------------------- Dummy/Unknown CPU Strings -------------------

	unknown_str:		db	"Unknown"
	Cpu_486dxS_Str:
	Cpu_486sxS_Str:
	Cpu_486dx2S_Str:
				db	0

;R14 ifdef	P6_BIOS_ONLY
IF	BIOS_SUPPORT_686			;R14
;Function : Enable/Disable P6 L2 cache
;Input    : AL = TRUE  - enable L2 cache
;	       = FALSE - disable L2 cache
		Public	P6_L2Cache_Control
P6_L2Cache_Control	proc	near
		pushad

ifdef	KLAMATH_CPU_ONLY

;R23 - start
 ifdef	BOTH_P6_KLAMATH_CPU
 		push	ax
		call	Read_CpuID		;read CPU ID
		cmp	al,30H			;Klamath ?
		pop	ax
		jae	short Yes_Klamath

;L2 cache control for PENTIUM PRO CPU
		mov	bl,al
		mov	ecx,119h
		RDMSR
		and	eax,NOT (1 SHL 19)	;assume L2 enable
		cmp	bl,TRUE
		je	short Yes_EnablePpro
		or	eax,(1 SHL 19)		;disable L2 cache
Yes_EnablePpro:
		WRMSR
		jmp	short L2CacheExit
 Yes_Klamath:
 endif;	BOTH_P6_KLAMATH_CPU
;R23 - end

;L2 cache control for KLAMATH CPU
		mov	bl,al
		mov	ecx,11eh
		RDMSR
		or	eax,(1 SHL 8)		;assume L2 enable
		cmp	bl,TRUE
		je	short Yes_Enable
		and	eax,NOT (1 SHL 8)	;disable L2 cache
Yes_Enable:
		WRMSR
else;	KLAMATH_CPU_ONLY
;L2 cache control for PENTIUM PRO CPU
		mov	bl,al
		mov	ecx,119h
		RDMSR
		and	eax,NOT (1 SHL 19)	;assume L2 enable
		cmp	bl,TRUE
		je	short Yes_Enable
		or	eax,(1 SHL 19)		;disable L2 cache
Yes_Enable:
		WRMSR
endif;	KLAMATH_CPU_ONLY
L2CacheExit:					;R23

		popad
		ret
P6_L2Cache_Control	endp
ENDIF	;BIOS_SUPPORT_686			;R14
;R14 endif;	P6_BIOS_ONLY

;R14 		public	Disp_Intel_S_CPU
;R14 Disp_Intel_S_CPU:
;R14
;R14 ifndef	P6_BIOS_ONLY
;R14
;R14 ;Display CPU type "6x86L" if the revision number is 20h-2fh, regular
;R14 ;6x86 is 00h-1fh
;R14 		call	Check_M1_Cpu 		;check if 6x86 CPU
;R14 		jne	short Not_6x86Cpu
;R14
;R14 		mov	al,0ffH			;DIR1 register
;R14 		out	22h,al
;R14 		in	al,23h			;read DIR1 value
;R14
;R14 		cmp	al,20H			;6x86L ?
;R14 		jb	short Not_6x86Cpu
;R14
;R14 		mov	al,"L"
;R14 		call	F000_Display_Char
;R14
;R14 Not_6x86Cpu:
;R14 endif;	P6_BIOS_ONLY
;R14
;R14 		test	byte ptr OVERRIDE[BP],(SMICPU shr 8)
;R14 		jz	short @F
;R14
;R14 ifdef	P6_BIOS_ONLY
;R14
;R14 		call	Read_CpuID		;read CPU ID
;R14 		and	ah,0f0H			;get CPU type
;R14 		cmp	ah,010H			;override drive processor
;R14 		jne	short Not_Odp
;R14
;R14 		push	cs
;R14 		pop	ds
;R14 		mov	si,offset Odp_String	;ODP string
;R14 		call	F000_Display_String
;R14
;R14 Not_Odp:
;R14
;R14 		shr	edx,16
;R14 		test	dl,80H			;With MMX ? (bit23 = 1 ?)
;R14 		jz	short Normal_PentiumPro	;no MMX
;R14
;R14 		push	cs
;R14 		pop	ds
;R14 		mov	si,offset MMX_String	;MMX string
;R14 		call	F000_Display_String
;R14
;R14 		jmp	short @F		;skip "-S" display
;R14 Normal_PentiumPro:
;R14
;R14 ifdef PM_SUPPORT
;R14 		mov	al,"-"
;R14 		call	F000_Display_Char
;R14 		mov	al,"S"
;R14 		call	F000_Display_Char
;R14 endif; PM_SUPPORT
;R14 else;	P6_BIOS_ONLY
;R14
;R14 ifdef	No_Cyrix_Mark_For_M6M7
;R14 ;
;R14 ; This is for special customer
;R14 ; If the CPU is Cyrix then don't show S-serial
;R14 ;
;R14 		F000_Call Cyrix_Detect
;R14 		jnc	short @F
;R14 endif	;No_Cyrix_Mark_For_M6M7
;R14
;R14 ifndef	NO_PRATING_DISPLAY
;R14 ;Display P-rating if CYRIX 6x86 CPU plugged
;R14 		call	Check_M1_Cpu 		;check if 6x86 CPU
;R14 		jne	short Not_6x86
;R14
;R14 		mov	si,offset M1_PRat_Tbl	;table of P-rating
;R14 		call	Show_PRating
;R14
;R14 		jmp	short @F
;R14 Not_6x86:
;R14
;R14 		call	Check_K586_Cpu 	;check if AMD 5k86 CPU
;R14 		jne	short Not_K586
;R14
;R14 		call	Read_CpuID
;R14 		mov	si,offset K586_051x_PRat_Tbl	;table of P-rating
;R14 		and	al,0f0H
;R14 		cmp	al,10H			;CPUID=051X
;R14 ;R13		je	short K5_051x
;R14 		jae	short Go_Show_PRating	;R13
;R14
;R14 		mov	si,offset K586_PRat_Tbl	;table of P-rating
;R14 K5_051x:
;R14 Go_Show_PRating:				;R13
;R14 		call	Show_PRating
;R14
;R14 		jmp	short @F
;R14 Not_K586:
;R14
;R14 endif;	NO_PRATING_DISPLAY
;R14
;R14 ifndef	P6_BIOS_ONLY
;R14
;R14 ;Display string "MMX" if CPU with MMX supported, for PENTIUM CPUs
;R14 ;bit 23 of EDX indicate MMX support or not.
;R14
;R14 		mov	al,byte ptr FIXED_DISK_STEP[bp]
;R14 		and	al,CPU_TYPE_MASK
;R14 		cmp	al,TYPE_586  		;PENTIUM CPU ?
;R14 		jne	short Normal_Pentium	;no , no MMX display
;R14
;R14 		call	Read_CpuID		;read CPU ID
;R14
;R14 		and	ah,0f0H			;get CPU type
;R14 		cmp	ah,010H			;override drive processor
;R14 		jne	short Not_Odp
;R14
;R14 		push	cs
;R14 		pop	ds
;R14 		mov	si,offset Odp_String
;R14 		call	F000_Display_String
;R14
;R14 Not_Odp:
;R14
;R14 		shr	edx,16
;R14 		test	dl,80H			;With MMX ? (bit23 = 1 ?)
;R14 		jz	short Normal_Pentium	;no MMX
;R14
;R14 		push	cs
;R14 		pop	ds
;R14 		mov	si,offset MMX_String
;R14 		call	F000_Display_String
;R14
;R14 		jmp	short @F
;R14 Normal_Pentium:
;R14
;R14 endif;	P6_BIOS_ONLY
;R14
;R14 ifdef PM_SUPPORT
;R14 		mov	al,"-"
;R14 		call	F000_Display_Char
;R14 		mov	al,"S"
;R14 		call	F000_Display_Char
;R14 endif; PM_SUPPORT
;R14
;R14 endif;	P6_BIOS_ONLY
;R14
;R14 	@@:
;R14 		ret

;R14 - starts
;[]=================================================================[]
;Procedure   :	Disp_Extra_CPU_Info
;Input	     :	None
;Ouput	     :	None
;Description :	If CPU Type:
;
;		. PENTIUM PRO & PENTIUM
;
;		   IF   ODP CPU show 'ODP-S' on screen
;		   IF   MMX CPU show 'MMX' on screen
;		   IF   ODP-MMX CPU show 'ODP-MMX' on screen
;		   ELSE show '-S' on screen to indicate SMI
;
;		. Cyrix 6x86L CPU
;
;		  Append a 'L' to '6x86'
;
;		. Other CPUs
;
;		  show '-S' on screen to indicate SMI
;
;[]=================================================================[]
		public	Disp_Extra_CPU_Info
Disp_Extra_CPU_Info	Proc	Near

;---------------------------------------------------------------
; Display CPU type as "6x86L" if the revision number is 20h-2fh,
; regular 6x86 is 00h-1fh
;---------------------------------------------------------------
IF	BIOS_SUPPORT_586
		call	Check_M1_Cpu 		;check if 6x86 CPU
		jne	short Not_6x86Cpu

		mov	al,0ffH			;DIR1 register
		out	22h,al
		in	al,23h			;read DIR1 value

		cmp	al,20H			;6x86L ?
;R18B		jb	short Not_6x86Cpu
		jb	short Not_6x86CpuL	;R18B

		mov	al,"L"
		call	F000_Display_Char

;R18B - start
Not_6x86CpuL:
;R18C;Display string "MMX" for M2 CPU
;R18C		mov	al,0feH			;DIR1 register
;R18C		out	22h,al
;R18C		in	al,23h			;read DIR1 value
;R18C		cmp	al,51h
;R18C		jb	short Not_6x86Cpu
;R18C		cmp	al,5fh
;R18C		ja	short Not_6x86Cpu
;R18C
;R18C		mov	si, offset Dash_MMX_String	;'-MMX' string
;R18C		call	Display_CS_String
;R18B - end

Not_6x86Cpu:
ENDIF	;BIOS_SUPPORT_586

;---------------------------------------------------------------
; Show -MMX & -ODP for all 586 or above CPU
;---------------------------------------------------------------
IF	BIOS_SUPPORT_586 OR BIOS_SUPPORT_686

	IFE	BIOS_SUPPORT_686

	  IF	BIOS_SUPPORT_486 OR BIOS_SUPPORT_386
		cmp	byte ptr CPU_LEVEL[bp], LEVEL_486
		jbe	short No_ODP_MMX
	  ENDIF	;BIOS_SUPPORT_486 OR BIOS_SUPPORT_386

		cmp	byte ptr CPU_BRAND[bp], CPU_BRAND_INTEL
		jne	short No_ODP_MMX

	ENDIF	;BIOS_SUPPORT_686

IF	BIOS_SUPPORT_586 						;R50A
		call	Check_IdtCpu		;is IDT C6 CPU ?   	;R50A
		je	short Disp_S_CPU_Exit	;yes,no MMX display	;R50A
endif;	BIOS_SUPPORT_586 						;R50A

		call	Read_CpuID		;read CPU ID
		and	ah,0f0H			;get CPU type
		cmp	ah,010H			;override drive processor
		jne	short Not_Odp

;R10B		push	cs
;R10B		pop	ds
;R10B		mov	si,offset Odp_String	;ODP string
;R10B		call	F000_Display_String
		mov	si,offset Odp_String	;ODP string	;R10B
		call	Display_CS_String			;R10B

	Not_Odp:

		shr	edx,16
		test	dl,80H			;With MMX ? (bit23 = 1 ?)
		jz	short No_ODP_MMX	;no MMX

;R10B		push	cs
;R10B		pop	ds
;R10B		mov	si,offset MMX_String	;MMX string
;R10B		call	F000_Display_String
		mov	si, offset Dash_MMX_String	;'-MMX' string	;R10B
		call	Display_CS_String				;R10B

		jmp	short Disp_S_CPU_Exit	;skip "-S" display

No_ODP_MMX:
ENDIF	;BIOS_SUPPORT_586 OR BIOS_SUPPORT_686

;-------------------------------------------------------
;Try to skip '-S' for all AMD & Cyrix 586 level CPU
;-------------------------------------------------------
IF	BIOS_SUPPORT_586
;R32 ;R10B - starts
;R32 		call	Check_K6_CPU
;R32 		jne	short It_Is_Not_K6
;R32 		mov	si, offset MMX_String		;'MMX' string
;R32 		call	Display_CS_String
;R32
;R32 	It_Is_Not_K6:
;R32 ;R10B - ends
		call	Check_K586_Cpu 		;check if AMD 5k86 CPU
		je	short Disp_S_CPU_Exit	;skip "-S" display
		call	Check_M1_Cpu 		;check if 6x86 CPU
		je	short Disp_S_CPU_Exit	;skip "-S" display
ENDIF	;BIOS_SUPPORT_586

;-------------------------------------------------------
; This is for special customer
; If the CPU is Cyrix then don't show S-serial
;-------------------------------------------------------
IF	BIOS_SUPPORT_486
	ifdef	No_Cyrix_Mark_For_M6M7
		F000_Call Cyrix_Detect
		jnc	short Disp_S_CPU_Exit
	endif	;No_Cyrix_Mark_For_M6M7
ENDIF	;BIOS_SUPPORT_486

;-------------------------------------------------------
; Display '-S' on screen
;-------------------------------------------------------
IFE	BIOS_SUPPORT_686			;R14
ifdef	PM_SUPPORT
		test	byte ptr OVERRIDE[BP],(SMICPU shr 8)
		jz	short No_S
		mov	al,"-"
		call	F000_Display_Char
		mov	al,"S"
		call	F000_Display_Char
No_S:
endif	;PM_SUPPORT
ENDIF	;BIOS_SUPPORT_686			;R14

Disp_S_CPU_Exit:

		ret

Disp_Extra_CPU_Info	Endp
;R14 - ends

;Function : Read CPU ID
;Input    : none
;Output   : EAX - CPU ID information
;	    EDX - CPU features
		Public	Read_CpuID		;R14
Read_CpuID	proc	near
		mov	eax,1			;read cache isze
		db	0Fh,0A2h		;OP code: CPUID
		ret
Read_CpuID	endp

IF	BIOS_SUPPORT_586 OR BIOS_SUPPORT_686	;R14
Odp_String	db	' ODP',0
;R10B MMX_String	db	'-MMX',0
Dash_MMX_String		db	'-MMX',0	;R10B
MMX_String		db	' MMX',0	;R10B
ENDIF	;BIOS_SUPPORT_586 OR BIOS_SUPPORT_686	;R14

;R39 - start
;[]--------------------------------[]
;Input	:	None
;Ouput	:	ZF - Cyrix M2
;		NZ - not Cyrix M2
;[]--------------------------------[]
		public	Check_M2Cpu
Check_M2Cpu	proc	near
		push	ax
		mov	al,0feH			;DIR1 register
		out	22h,al
		in	al,23h			;read DIR1 value
		cmp	al,51h
		jb	short Not_M2Cpu
		cmp	al,5fh
		ja	short Not_M2Cpu
		xor	al,al			;return zero flag
Not_M2Cpu:
		pop	ax
		ret
Check_M2Cpu	endp
;R39 - end

;R10A - starts
;[]--------------------------------[]
;Input	:	None
;Ouput	:	ZF - Cyrix 6x86
;		NZ - not Cyrix 6x86
;[]--------------------------------[]
;R10A - ends
		public	Check_M1_Cpu
Check_M1_Cpu	proc	near
IFE	BIOS_SUPPORT_586					;R14
		cmp	sp, 0FFFFh	;always return not M1	;R14
ELSE	;BIOS_SUPPORT_586					;R14
		push	bx
		mov	bh,byte ptr FIXED_DISK_STEP[bp]
		and	bh,CPU_TYPE_MASK
		cmp	bh,TYPE_M1
		pop	bx
ENDIF	;BIOS_SUPPORT_586					;R14
		ret
Check_M1_Cpu	endp

;R10A - starts
;[]--------------------------------[]
;Input	:	None
;Ouput	:	ZF - K5 or K6
;		NZ - not K5, not K6
;[]--------------------------------[]
;R10A - ends
		Public	Check_K586_Cpu				;R14
Check_K586_Cpu	proc	near
IF	BIOS_SUPPORT_586					;R14
		push	bx
		mov	bh,byte ptr FIXED_DISK_STEP[bp]
		and	bh,CPU_TYPE_MASK
		cmp	bh,TYPE_AMD5K86
		pop	bx
ELSE	;BIOS_SUPPORT_586					;R14
		cmp	sp, 0FFFFh	;always return NOT K6	;R14
ENDIF	;BIOS_SUPPORT_586					;R14
		ret
Check_K586_Cpu	endp

;R10A - starts
;[]-------------------------[]
;Input	:	None
;Ouput	:	ZF - K6
;		NZ - not K6
;[]-------------------------[]
		Public	Check_K6_CPU
Check_K6_CPU	Proc	Near
IF	BIOS_SUPPORT_586
		cmp	byte ptr CPU_LEVEL[bp], LEVEL_586
		jne	short @F
		cmp	byte ptr CPU_BRAND[bp], CPU_BRAND_AMD
		jne	short @F

		pushad
		call	Read_CpuID		;read CPU ID
		and	al, 0F0h
		cmp	ax, 0590h		;new K6		;R60A
		je	short Yes_NewK6				;R60A
		cmp	ax, 0580h		;new K6		;R60A
		je	short Yes_NewK6				;R60A
		cmp	ax, 0570h		;new K6		;R60
		je	short Yes_NewK6				;R60
		cmp	ax, 0560h		;K6 ?
Yes_NewK6:							;R60
		popad
	@@:
ELSE	;BIOS_SUPPORT_586
		cmp	sp, 0FFFFh		;always return NOT K6
ENDIF	;BIOS_SUPPORT_586
		ret
Check_K6_CPU	Endp
;R10A - ends

;R78 - start
;[]-------------------------------------[]
;Function: Check if AMD-K6 3D CPU plugged
;Input	:	None
;Ouput	:	ZF - K6-3D CPU
;		NZ - not K6-3D
;[]-------------------------------------[]
		Public	Check_K6_3D_feature
Check_K6_3D_feature	Proc	Near
IF	BIOS_SUPPORT_586
		pushad
		call	Read_CpuID		;read CPU ID
		and	al, 0F0h
		cmp	ax, 0580h		;AMD DS080397 K6CH ?
		jne	short @F  		;no

		mov	eax,80000001h		;extended function
		db	0Fh,0A2h		;read CPUID
		and	edx,80000000h		;bit31=1 for 3D feature
		cmp	edx,80000000h
@@:
		popad

ELSE	;BIOS_SUPPORT_586
		cmp	sp, 0FFFFh		;always return NOT K6
ENDIF	;BIOS_SUPPORT_586
		ret
Check_K6_3D_feature	Endp
;R78 - end

;R14 - starts
;[]=================================================================[]
;Input	:	DI = 1 --> show P-Rating with '-'			;R14A
;		DI = 0 --> show P-Rating without '-'			;R14A
;									;R14A
;Output	:	NC - Show P-Rating successfully				;R14A
;		CF - Show P-Rating not successful			;R14A
;[]=================================================================[]
		Public	Try_Show_PRating
Try_Show_PRating	Proc	Near

		stc		;defaut no show P-Rating		;R14A

IF	BIOS_SUPPORT_586
ifndef	NO_PRATING_DISPLAY

	;------------------------------------------
	;Display P-rating if CYRIX 6x86 CPU plugged
	;------------------------------------------

		call	Check_M1_Cpu 		;check if 6x86 CPU
		mov	si,offset M1_PRat_Tbl	;table of P-rating
;R14A - starts
		jne	short Not_M1_P_Rate

		push	word ptr CPU_INT_CLOCK[bp]			;R64

		call	Check_M2Cpu		;R39
		jne	short Its_M1		;R39
;R64 - starts
		mov	al, 0FEh		;DIR0 register
		out	22h, al
		in	al, 23h			;read DIR0 value
		and	al, 00000111b
		mov	ah, al
		push	ds
		push	G_RAM		
		pop	ds
		mov	si, offset CPU_CLOCK
		mov 	al, ds:[si]
		and	al, 11110000b		;Mask 
		pop	ds
		mov	CPU_INT_CLOCK[bp], ax
;R64 - ends
		mov	si,offset M2_PRat_Tbl	;R39 table for M2 PR-rating
Its_M1:						;R39

		call	Show_PRating
		pop	word ptr CPU_INT_CLOCK[bp]			;R64
		jc	short Bad_Try_Show_PRating

		call	Check_M2Cpu		;R39
		je	short Its_M2		;R39

		mov	al, "+"
		call	F000_Display_Char
Its_M2:						;R39
		clc				;indicate show p-rating successfully
		ret

	Not_M1_P_Rate:
;R14A - ends
;R14A		je	short Go_Show_PRating	;it is 6x86 CPU

;R32 - starts
	;------------------------------------------
	;Display P-rating if AMD K6 CPU plugged
	;------------------------------------------
		call	Check_K6_CPU		;K6 ?
		jne	short No_K6_P_Rate	;no !

;R32A		mov	si, offset K6_PRat_Tbl	;table of P-rating
		mov	si, 0FFFFh		;use CPU_INT_CLOCK[bp]	;R32A
		call	Show_PRating		;show P-rating
		jc	Bad_Try_Show_PRating	;no success
		ret
No_K6_P_Rate:
;R32 - ends

	;------------------------------------------
	;Display P-rating if AMD K5 CPU plugged
	;------------------------------------------

;R32		call	Check_K6_CPU		;K6 ?		;R14A
;R32		je	short Not_K586		;no !		;R14A

		call	Check_K586_Cpu 		;check if AMD 5k86 CPU
		jne	short Not_K586		;no, it is not AMD K5

		push	di					;R14A
		call	Read_CpuID
		pop	di					;R14A
		mov	si,offset K586_051x_PRat_Tbl	;table of P-rating
		and	al,0f0H
		cmp	al,10H			;CPUID=051X
		jae	short Go_Show_PRating

		mov	si,offset K586_PRat_Tbl	;table of P-rating

Go_Show_PRating:

		call	Show_PRating
		jc	short Bad_Try_Show_PRating		;R14A
		ret						;R14A
Not_K586:
Bad_Try_Show_PRating:						;R14A

		stc	;indicate show p-rating not successful	;R14A

 endif	;NO_PRATING_DISPLAY
ENDIF	;BIOS_SUPPORT_586

;R14A	@@:
		ret

Try_Show_PRating	Endp
;R14 - ends

IF	BIOS_SUPPORT_586
ifndef	NO_PRATING_DISPLAY
;R14A ;P-rating table of cyrix 6x86 CPU
;R14A M1_PRat_Tbl:		;Mhz
;R14A 		db	80			;80Mhz
;R14A 		db	'90+ ',0		;P-rating
;R14A PRAT_TBL_LEN	EQU	($ - offset M1_PRat_Tbl)
;R14A
;R14A 		db	66			;66Mhz
;R14A 		db	'90+ ',0		;P-rating
;R14A
;R14A 		db	60			;66Mhz
;R14A 		db	'90+ ',0		;P-rating
;R14A
;R14A 		db	100			;100Mhz
;R14A 		db	'120+',0		;P-rating
;R14A
;R14A 		db	110			;110Mhz
;R14A 		db	'133+',0		;P-rating
;R14A
;R14A 		db	120			;120Mhz
;R14A 		db	'150+',0		;P-rating
;R14A
;R14A 		db	133			;133Mhz
;R14A 		db	'166+',0		;P-rating
;R14A
;R14A 		db	150			;150Mhz
;R14A 		db	'200+',0		;P-rating
;R14A
;R14A 		db	0			;end of table
;R14A
;R14A ;P-rating table of cyrix K5 CPU for 050XH
;R14A K586_PRat_Tbl:		;Mhz
;R14A 		db	66			;66Mhz
;R14A 		db	'75  ',0		;P-rating
;R14A
;R14A 		db	75			;75Mhz
;R14A 		db	'75  ',0		;P-rating
;R14A
;R14A 		db	83			;83Mhz
;R14A 		db	'90  ',0		;P-rating
;R14A
;R14A 		db	90			;90Mhz
;R14A 		db	'90  ',0		;P-rating
;R14A
;R14A 		db	100			;100Mhz
;R14A 		db	'100 ',0		;P-rating
;R14A
;R14A 		db	120			;120Mhz
;R14A 		db	'120 ',0		;P-rating
;R14A
;R14A 		db	133			;133Mhz
;R14A 		db	'133 ',0		;P-rating
;R14A
;R14A 		db	0			;end of table
;R14A
;R14A ;P-rating table of cyrix K5 CPU for 051XH
;R14A K586_051X_PRat_Tbl:		;Mhz
;R14A 		db	75			;75Mhz
;R14A 		db	'100 ',0		;P-rating
;R14A
;R14A 		db	83			;83Mhz
;R14A 		db	'100 ',0		;P-rating
;R14A
;R14A 		db	90			;90Mhz
;R14A 		db	'120 ',0		;P-rating
;R14A
;R14A 		db	100			;100Mhz
;R14A 		db	'133 ',0		;P-rating
;R14A
;R14A 		db	120			;120Mhz
;R14A 		db	'150 ',0		;P-rating
;R14A
;R14A 		db	133			;133Mhz
;R14A 		db	'166 ',0		;P-rating
;R14A ;R13 - starts
;R14A 		db	105			;105Mhz
;R14A 		db	'150 ',0		;P-rating
;R14A
;R14A 		db	117			;117Mhz
;R14A 		db	'166 ',0		;P-rating
;R14A ;R13 - ends
;R14A 		db	0			;end of table

;R64 -start
M2_PRat_Tbl:
		;------------------------------------------
		;      Ratio + Clock	, P-Rating
		;------------------------------------------
		; '*' means this PRating value is decided by award
		dw     (01 shl 8)+CPU83	, 233		;83x2 (166 Mhz)
		dw     (01 shl 8)+CPU75	, 200		;75x2 (150 Mhz)			
		dw     (01 shl 8)+CPU66	, 166		;66x2 (133 Mhz)	
		dw     (01 shl 8)+CPU60	, 150		;60x2 (120 Mhz)	
		dw     (01 shl 8)+CPU50	, 133		;50x2 (100 Mhz)	

		dw     (02 shl 8)+CPU83	, 266		;83x2.5	(207 Mhz) *
		dw     (02 shl 8)+CPU75	, 233		;75x2.5	(188 Mhz)
		dw     (02 shl 8)+CPU66	, 200		;66x2.5	(161 Mhz)
		dw     (02 shl 8)+CPU60	, 166		;60x2.5	(150 Mhz)
		dw     (02 shl 8)+CPU50	, 150		;50x2.5	(125 Mhz) *

		dw     (03 shl 8)+CPU83	, 300		;83x3 (250 Mhz)	
		dw     (03 shl 8)+CPU75	, 266		;75x3 (225 Mhz)	
		dw     (03 shl 8)+CPU66	, 233		;66x3 (200 Mhz)	
		dw     (03 shl 8)+CPU60	, 200		;60x3 (180 Mhz)	
		dw     (03 shl 8)+CPU50	, 166		;50x3 (150 Mhz)	*

		dw     (04 shl 8)+CPU83	, 300		;83x3.5	(290 Mhz) *
		dw     (04 shl 8)+CPU75	, 266		;75x3.5	(263 Mhz) *
		dw     (04 shl 8)+CPU66	, 266		;66x3.5	(231 Mhz)
		dw     (04 shl 8)+CPU60	, 266		;60x3.5	(210 Mhz) *
		dw     (04 shl 8)+CPU50	, 233		;50x3.5	(175 Mhz) *
		dw	0
;R64 -end

;R64 ;R39 - start
;R64 M2_PRat_Tbl:
;R64 		;------------------------------
;R64 		;      MHZ	,    P-Rating
;R64 		;------------------------------
;R64 		dw	100	,	133		;50x2	;R39B
;R64 		dw	110	,	133		;55x2	;R39B
;R64 		dw	120	,	150		;60x2	;R39B
;R64 		dw	125	,	150		;50x2.5	;R39B
;R64 ;R55B		dw	133	,	166		;66x2	;R39B
;R64 ;R55C		dw	133	,	150		;66x2	;R55B
;R64 		dw	133	,	166		;66x2	;R55C
;R64 		dw	150	,	166		;60x2.5
;R64 		dw	166	,	200		;66x2.5
;R64 Pr200Tbl:						;R55
;R64 		dw	180	,	200		;60x3	;R39B
;R64 		dw	188	,	233		;75x2.5
;R64 		dw	200	,	233 		;66x3
;R64 		dw	225	,	266		;75x3	;R39B
;R64 		dw	233	,	266		;66x3.5
;R64 		dw	0				;end of table
;R64 ;R39 - end

;R14A - starts
;----------------------------------
; P-rating table of cyrix 6x86 CPU
;----------------------------------
M1_PRat_Tbl:
		;------------------------------
		;      MHZ	,    P-Rating
		;------------------------------
		dw	80	,	90
PRAT_TBL_LEN	EQU	($ - offset M1_PRat_Tbl)
		dw	66	,	90
		dw	60	,	90
		dw	100	,	120
		dw	110	,	133
		dw	120	,	150
		dw	133	,	166
		dw	150	,	200
		dw	0				;end of table

;--------------------------------------
; P-rating table of AMD K5 CPU for 050XH
;--------------------------------------
K586_PRat_Tbl:
		;------------------------------
		;      MHZ	,    P-Rating
		;------------------------------
		dw	66	,	75
		dw	75	,	75
		dw	83	,	90
		dw	90	,	90
		dw	100	,	100
		dw	120	,	120
		dw	133	,	133
		dw	0			;end of table

;--------------------------------------
; P-rating table of AMD K5 CPU for 051XH
;--------------------------------------
K586_051X_PRat_Tbl:
		;------------------------------
		;      MHZ	,    P-Rating
		;------------------------------
		dw	75 	,	100
		dw	83 	,	100
		dw	90 	,	120
 ifdef	SHOW_K5_PR150_INSTEAD_PR133				;R48
		dw	100	,	150			;R48
 else;	SHOW_K5_PR150_INSTEAD_PR133				;R48
		dw	100	,	133
 endif;	SHOW_K5_PR150_INSTEAD_PR133				;R48
		dw	120	,	150
;R19		dw	133	,	166
		dw	133	,	200	;for 053x only	;R19
		dw	105	,	150 	;for 052X only
		dw	117	,	166 	;for 052X only
		dw	0			;end of table
;R14A - ends

;R32 - starts
;R32A ;-----------------------------
;R32A ; P-rating table of AMD K6 CPU
;R32A ;-----------------------------
;R32A K6_PRat_Tbl:
;R32A 		;------------------------------
;R32A 		;      MHZ	,    P-Rating
;R32A 		;------------------------------
;R32A 		dw	100	,	100
;R32A 		dw	110	,	110
;R32A 		dw	120	,	120
;R32A 		dw	125	,	125
;R32A 		dw	133	,	133
;R32A 		dw	150	,	150
;R32A 		dw	166	,	166
;R32A 		dw	175	,	175	;50x3.5
;R32A 		dw	180	,	180
;R32A 		dw	193	,	193	;55x3.5
;R32A 		dw	200	,	200
;R32A 		dw	210	,	210	;60x3.5
;R32A 		dw	233	,	233	;66x3.5
;R32A 		dw	0			;end of table
;R32 - ends

;R14A ;Input : SI - offset of Prating table to display
;R14A ;Output: none
;R14A ;Function: Display P-rating behind of CPU type
;R14A - starts
;[]======================================================================[]
;Input	:	SI - offset of Prating table to compare
;		     if SI=0FFFFh, use CPU_INT_CLOCK[bp] as PR rating	;R32A
;		word ptr CPU_INT_CLOCK[bp] storing the CPU internal clock
;		DI = 1 --> show P-Rating with '-'
;		DI = 0 --> show P-Rating without '-'
;Output	:	NC - Show P-Rating successfully
;		CF - Show P-Rating not successful
;Function:	Display P-rating on screen
;[]======================================================================[]
;R14A - ends
Show_PRating	proc	near

;R32A - starts
		cmp	si, 0FFFFh		;should we reference table ?
		je	short No_Ref_Tbl	;no !
;R32A - ends

	;--------------------------------------------------
	;search the P-Rating by comparing CPU_INT_CLOCK[bp]
	;with a table with pre-defined values and SI will
	;point to a word address storing the P-Rating value
	;--------------------------------------------------

;R14A		mov	al,byte ptr CPU_INT_CLOCK[bp]	;CPU real clock
		mov	ax,CPU_INT_CLOCK[bp]	;CPU real clock		;R14A

Next_Mhz_Tbl:
;R14A		cmp	byte ptr cs:[si],0		;last table ?
		cmp	word ptr cs:[si],0		;last table ?	;R14A
		je	short No_Prat_Found
;R14A		cmp	al,cs:[si]			;Mhz match ?
		cmp	ax,cs:[si]			;Mhz match ?	;R14A
		je	short Prat_Found		;yes

	   	add	si,PRAT_TBL_LEN	  		;no, next mhz
		jmp	short Next_Mhz_Tbl

Prat_Found:

;R64 ;R55 - start
;R64 ;R55A ifdef	SHOW_PR200_FOR_75X2_M2
;R64 ;Show PR200 instead of PR166 for 75x2 mode for specific customers
;R64 		cmp	ax,150		;150Mhz ?
;R64 		jne	short Not150Mhz
;R64 		call	Check_M2Cpu	;Is M2 CPU ?
;R64 		jne	short Not150Mhz
;R64 
;R64 		mov	al,0feH			;DIR1 register
;R64 		out	22h,al
;R64 		in	al,23h			;read DIR1 value
;R64 		and	al,NOT 08H		;mask bit 3
;R64 		cmp	al,51h			;2x mode ?
;R64 		jne	short Not150Mhz		;no
;R64 
;R64 		mov	si,offset Pr200Tbl	;yes, show PR200
;R64 Not150Mhz:
;R64 ;R55A endif;	SHOW_PR200_FOR_75X2_M2
;R64 ;R55 - end

		inc	si				;offset of P-Rating
		inc	si				;R14A

No_Ref_Tbl:						;R32A

;R14A - starts
	;------------------------------------------
	;show '-' according to the input DI
	;------------------------------------------

		cmp	di, 1
		jne	short No_Dash
;R32A - starts
	;----------------------------------
	;show '/' instead of '-' for AMD K6
	;----------------------------------

 		mov	al,"/"				;assume show '/'
		call	Check_K6_CPU			;K6 CPU ?
		je	short @F			;yes, go show it !
;R32A - ends
 		mov	al,"-"				;show '-' on screen
	@@:						;R32A
 		call	F000_Display_Char
	No_Dash:
;R14A - ends

	;------------------------------------------
	;If Cyrix show 'PXX'
	;If AMD show 'PRXX'
	;------------------------------------------

;R32B - starts
		push	si
;R32C		mov	si, offset PR2_String
		call	Check_K6_CPU			;K6 CPU ?
		je	short @F
		mov	si, offset PR_String
;R32C	@@:
		call	Display_CS_String
	@@:						;R32C
		pop	si
;R32B - ends

;R32B		mov	al,"P"
;R32B		call	F000_Display_Char

;R28		call	Check_K586_Cpu 			;check if AMD 5k86 CPU
;R28		jne	short Not_K586_CPU		;no !

;R32B		;"PR" for AMD K5
;R32B		mov	al,"R"
;R32B		call	F000_Display_Char

;R32B	Not_K586_CPU:

;R14A		push	cs
;R14A		pop	ds
;R14A		call	F000_Display_String		;display P-rating

;R14A - starts
	;------------------------------------------
	;display P-rating value stored in CS:[SI]
	;------------------------------------------

;R32A - starts
		mov	ax, CPU_INT_CLOCK[bp]	;assume CPU_INT_CLOCK[bp]
		cmp	si, 0FFFFh		;should we use this value?
		je	short Go_Show_P_Rate	;yes !
;R32A - ends
		mov	ax, cs:[si]

	Go_Show_P_Rate:				;R32A

		cmp	ax, 99
		ja	short @F
		call	far ptr fProc_Disp_Byte_Int2
		jmp	short End_Show_P_Rate
	@@:
		call	far ptr fProc_Disp_Word_Int3

	End_Show_P_Rate:

		clc	;indicate show p-rating successfully
		ret
;R14A - ends

No_Prat_Found:
		stc	;indicate show p-rating not successful	;R14A
		ret

Show_PRating	endp

;R32C PR2_String	db	'PR2-',0	;R32B
PR_String	db	'PR',0			;R32B

endif;	NO_PRATING_DISPLAY

;R26 - starts
;[]========================================================================[]
;Name	  :	Prg_K6_Write_Allocate
;
;Function :	To enable the AMD K6 CPU's write allocation function
;
;Input	  :	dword ptr EXT_MEM_SIZE[bp] in terms of 1K
;
;Output	  :	None
;[]========================================================================[]
		Public	Prg_K6_Write_Allocate
Prg_K6_Write_Allocate	Proc	Near

IF	BIOS_SUPPORT_586

		pushad

		call	Prg_C6_Write_Combine		;R50B

		call	Check_K6_CPU			;K6 ?
		jne	short No_K6_Write_Alloc		;no !

	;-------------------------------------------------------------------
	; This write allocation must be disabled in early stage of warm boot
	; replaced the "jmp short Not_K6" instruction will with 2 NOPs
	;
	;Skip_K6_Write_Allocate	Label	Near
	;
	;	jmp	short Not_K6
	;	mov	ecx, 0c0000082h
	;	RDMSR
	;	and	ax, not 1FFh
	;	WRMSR
	;
	;Not_K6:
	;-------------------------------------------------------------------

		push	ds
		F000_call F000_Shadow_W
		mov	ax, DGROUP
		mov	ds, ax
		mov	si, offset DGROUP:Skip_K6_Write_Allocate
		mov	ds:[si], 9090h
		F000_call F000_Shadow_R
		pop	ds

	;----------------------------------------------------------
	;MSR 85h b15-b0 : Top of memory address
	;	 b16    : Fixed Range Enable, i.e. from A0000-FFFFF
	;	 b17    : Programmable Range Enable
	;	 b18    : Top-Of-Memory Enable
	;----------------------------------------------------------

		F000_call Ct_MemHole_Status	;get hole status in AX
		mov	si, ax			;temporary save to SI

		mov	ecx, 0C0000082h
		RDMSR

		mov	ecx, EXT_MEM_SIZE[bp]
		add	ecx, 1024		;add 1M of base memory
		shr	ecx, 11			;convert to 4M byte unit
		mov	al, cl

		and	al, not 01h		;15-16 disabled
		cmp	al, 08h			;memory >= 16M ?
		jb	short @F		;< 16M !
		or	si, si			;memory hole enabled ?
		jnz	short @F		;enabled !
		or	al, 01h			;15-16 enabled
	@@:

;R26A	ifndef	PIIX_ID
;R26A		or	ah, 01h			;enable write cacheability
;R26A						;detection
;R26A	endif	;;PIIX_ID

		mov	ecx, 0C0000082h
		WRMSR

No_K6_Write_Alloc:

		popad

ENDIF	;BIOS_SUPPORT_586

		ret

Prg_K6_Write_Allocate	Endp
;R26 - ends

;R50B - start
McrbaseNo	equ	110h
Mcrvalue	equ	01F0000FH
BcrNo		equ	145H
TLOCKBit	equ	3

;0-512k
BaseAddr0	equ	0
Mask_512K	equ	0fff80007h

;512-640k
Base_512K	equ	000080000h
Mask_640K	equ	0fffe0007h

;1M - 2M
Base_1		equ	000100000h
Mask_2		equ	0fff00007h

;2M - 4M
Base_2		equ	000200000h
Mask_4		equ	0ffe00007h

;4M-8M
Base_4		equ	000400000h
Mask_8		equ	0ffc00007h

;8M - 16M
Base_8		equ	000800000h
Mask_16		equ	0ff800007h
Mask_12		equ	0ffc00007h

;16M - 32M
Base_16		equ	001000000h
Mask_32		equ	0ff000007h

;32M - 64M
Base_32		equ	002000000h
Mask_64		equ	0fe000007h

;64M - 128M
Base_64		equ	004000000h
Mask_128	equ	0fc000007h

;128M - 256M
Base_128	equ	008000000h
Mask_256	equ	0f8000007h

;256M - 512M
Base_256	equ	010000000h
Mask_512	equ	0f0000007h

;512M - 1024M
Base_512	equ	020000000h
Mask_1024	equ	0e0000007h

;1G- 2G
Base_1024	equ	040000000h
Mask_2048	equ	0c0000007h

;2G- 4G
Base_2048	equ	080000000h
Mask_4096	equ	080000007h

;Programming table for memory range registers
IDt_McrTable	label	dword
		dd	Base_2048
		dd	Mask_4096

		dd	Base_1024
		dd	Mask_2048

		dd	Base_512
		dd	Mask_1024

		dd	Base_256
		dd	Mask_512

		dd	Base_128
		dd	Mask_256

		dd	Base_64
		dd	Mask_128

		dd	Base_32
		dd	Mask_64

		dd	Base_16
		dd	Mask_32

		dd	Base_8
		dd	Mask_16

		dd	Base_4
		dd	Mask_8

		dd	Base_2
		dd	Mask_4

		dd	Base_1
		dd	Mask_2

		dd	Base_512K
		dd	Mask_640K

		dd	-1		;end of table

;[]========================================================================[]
;Name	  :	Prg_C6_Write_Combine
;
;Function :	To enable the IDT C6 CPU's write combing function
;
;Input	  :	dword ptr EXT_MEM_SIZE[bp] in terms of 1K
;
;Output	  :	None
;[]========================================================================[]
		Public	Prg_C6_Write_Combine
Prg_C6_Write_Combine	Proc	Near

		pushad

;R59		cmp	byte ptr CPU_BRAND[bp], CPU_BRAND_INTEL
;R59		jne	NoC6WCombine

		call	Check_IdtCpu		;is IDT C6 CPU ?
		jne	NoC6WCombine

      		mov	eax,0c0000000h		;special IDT function
		db	0fh,0a2h		;CPUID
;R70   		mov	eax,0c0000000h		;special IDT function
      		cmp	eax,0c0000000h		;special IDT function;R70
		jne	NoC6WCombine

		xor	bx,bx			;assume no hole
		F000_call Ct_MemHole_Status	;get hole status in AX
		mov	bl,al			;temporary save to SI

		mov	edi, EXT_MEM_SIZE[bp]	;get extended mem. in 1Kb unit
		shr	edi, 10			;convert to 1Mb unit
		inc	edi

	;always set up 0-512Kb region
		mov	ecx,MCRbaseNo
		mov	edx,BaseAddr0
		mov	eax,Mask_512K
		WRMSR

		mov	si,offset Idt_McrTable
		mov	ecx,4096
RangeComp:
		cmp	edi,ecx
		jae	short Prog_Mcrs
		add	si,8
		shr	ecx,1
		jnz	short RangeComp
		jmp	short NoC6WCombine
Prog_Mcrs:
		mov	ecx,McrbaseNo+1
Prog_One_Mcr:
		mov	edx,cs:dword ptr [si]
		cmp	edx,-1			;last table ?
		je	short Mcr_Done

		mov	eax,cs:dword ptr [si+4]
		cmp	edx,Base_8
		jne	short Around_hole_chk
		or	bl,bl			;hole enabled ?
		jz	short Around_hole_chk
		mov	eax,Mask_12
Around_hole_chk:
		WRMSR
		add	si,8
		inc	ecx
		cmp	ecx,McrbaseNo+8
		jb	short Prog_One_Mcr

Mcr_Done:
	;set up MCR_CTRL
		mov	ecx,120h
		mov	eax,McrValue
		xor	edx,edx
		WRMSR

		mov	ecx,BCRNo
		RDMSR
		or	al,1 SHL TLOCKbit
		WRMSR

NoC6WCombine:

		popad

		ret

Prg_C6_Write_Combine	endp
;R50B - end

ENDIF	;BIOS_SUPPORT_586

;R27 - start
;Function : Program USWC for P6-class CPU according user's CMOS select
;Input    : none
;Output   : none
		public	Prg_P6_USWC
Prg_P6_USWC	proc	near
if	BIOS_SUPPORT_686

;R43 - start
ifdef	SEPARATE_P6_VIDEO_ITEM
		mov	si,offset VideoRom_Item
		call	F000_GetItem_Value
		or	al,al			;video ROM cache enabled ?
		jz	short NoVideoRomCache

;Set C0000-C7fff region cacheability to Write Protect (WP).
 		mov	ecx,268H   	;address(268H) for C0000-C8000
 		mov	edx,05050505H	;set memory type to WP in higher 32bit
		mov	eax,edx
 		WRMSR

NoVideoRomCache:
endif;	SEPARATE_P6_VIDEO_ITEM
;R43 - end
;Set A0000-BFFFF region cacheability according to CMOS setup
		mov	si,offset VideoCache_Item
		call	F000_GetItem_Value
		xor	edx,edx		;assume UC

		or	al,al		;video cache enabled ?
		jz	short UnCache_Video

ifndef	SEPARATE_P6_VIDEO_ITEM					;R43
;Set C0000-C8000 region cacheability to Write Protect (WP).
 		mov	ecx,268H   	;address(268H) for C0000-C8000
 		mov	edx,05050505H	;set memory type to WP in higher 32bit
		mov	eax,edx
 		WRMSR
endif;	SEPARATE_P6_VIDEO_ITEM					;R43

		mov	di,offset VideoCard_Tbl

Check_NextCard:
		mov	dx,cs:[di]		;get vendor ID
		mov	cx,cs:[di+2]		;get device ID
		or	dx,dx			;end of table ?
		jz	short Go_USWC

		xor     si,si                   ;first device
		mov     ax,0b102H               ;find PCI device func. call
		int     1AH

		jnc     short CardTo_Check
		add	di,6			;next card to check
		jmp	short Check_NextCard

CardTo_Check:
		mov	ax,cs:[di+4]		;get qualify routine to run
		call	ax
		jnc	short No_CacheVideoRam

Go_USWC:
 		mov	edx,01010101H	;set memory type to WB in higher 32bit

UnCache_Video:
 		mov	ecx,259H	;address(259H) for A0000-BFFFF
		xor	eax,eax		;set A0000-AFFFF always UC
 					;set B0000-BFFFF according to setup
 		WRMSR

No_CacheVideoRam:

endif;	BIOS_SUPPORT_686
		ret
Prg_P6_USWC	endp


if	BIOS_SUPPORT_686
VideoCard_Tbl:		;vendor  device
		dw	100CH	,3208H 		;ET6000
		dw	offset NoQualify_Rev

		dw	1142H	,6424H		;Aliance 6424
		dw	offset Ali6424_Rev

		dw	0			;end of table

;Input  : none
;Output : carry clear - always disable USWC
;	  carry	set   - USWC is allowed
NoQualify_Rev	proc	near
		clc				;always disable USWC
		ret
NoQualify_Rev	endp

;Input  : none
;Output : carry clear - always disable USWC
;	  carry	set   - USWC is allowed
Ali6424_Rev	proc	near
;Only revision of 6424 is not allowed for USWC
		push	di
		mov	ax,0b108h		;read PCI byte
		mov	di,08H			;revision reg.
		int	1aH
		pop	di
		or	cl,cl			;revision = 00H
		clc
		jz	short No_6424Uswc	;yes , no video buffer cache
	    	stc				;USWC is allowed
No_6424Uswc:
		ret
Ali6424_Rev	endp
endif;	BIOS_SUPPORT_686

;R27 - end

ECODE		ENDS
ENDIF	;COMPILE_FOR_E0
;R12 - ends

;R12 - start
DGROUP		GROUP	FCODE
FCODE		SEGMENT PARA PUBLIC 'CODE'
		ASSUME	CS:DGROUP
FCODE		ENDS
;R12 - ends

		END
