;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R13A	12/24/97 STV	Release Added LAN card Support by cbrom /lan
;			& Fixed LAN card boot ENABLE/DISABLE
;R18	12/24/97 RCH	Fixed error coding that cause system RAM 40:BA become
;	 	        always 0FFH and system always boot from LAN even LAN
;		        is not first boot priority.	
;R17	12/23/97 RAY	Problem:
;
;			  Some onboard VGA will hang up randomly if the
;			  onboard VGA ROM is not plugged and at the same 
;			  time the ROM image is added to the BIOS using
;			  CBROM.EXE.
;
;			  This occurs in Quantas's LX M/B with ATI-RAGE
;
;			Solution:
;
;			   We should disable the ROM completely(write 0 to
;			   register location 30h) when we do not find any
;			   valid ROM images both from high address & from
;			   C000:0000h
;
;R16	12/23/97 RAY	Add [BP] for current class code
;R15	12/23/97 RCH	Fixed S3/868 hang up while working on AGP platform
;			with 16Mb Aperture size selected. It is caused by
;			this VGA requesting 32Mb memory space but actually
;			decode 64Mb space.
;R14	12/23/97 RAY	Fix Adaptec's ROM which support all 78x0 devices
;			cannot be invoked by the new CBROM algorithm
;R13	12/18/97 STV	Added LAN card Support by cbrom /lan
;R12	12/16/97 RAY	To record the assigned PCI IRQs in F000 shadow RAM
;			for the IRQ routing table(both INT 1Ah & MS IRQ
;			Routing table) to reference.
;			This is to to fix the ICU hang up problem
;R11	12/16/97 RAY	Some PCI device report a value of FFFFFFFFh at 30h
;			This version of BIOS will treat it as "ROM required"
;R10	12/16/97 RCH	Fixed system hang up while initial PCI/VGA ROM if 
;			Rendition Verite V2200 is installed and Cyrix M1 or 
;			M2 is used with VIA/VPX chipset.
;R09	12/05/97 PAL	Added Trend_AntiVirus Support by cbrom /vrs
;R08	12/05/97 TNY	Set IRQ9 to be the last of IRQ_Order table.
;			To fix some PCI card behaving abnormally in Win95 if
;			IRQ9 assigned.
;R07	12/01/97 RAY	Some VGA ROM images don't includes the PCI Vendor ID
;			& Device ID. Thus when we seek for VGA image, we have
;			a default image that points to the first image that
;			added with "CBROM /VGA"
;
;R02B	11/17/97 RAY	Fix "CBROM /PCI" does not work with 1M BIOS
;R06	11/15/97 RAY	Symtom:
;
;			  Some PCI devices do not decode address A8. When we 
;			  assign I/O space to these kind of devices at address
;			  using A8, they will fail to decode the correct
;			  address.
;
;			Solution:
;
;			  No matter it is in bus 0 or not, we assign I/O
;			  space with 1K alignment.
;
;R05	11/14/97 RAY	Add Open_IDE_2nd_Channel
;			
;R04	11/14/97 RAY	Move Routine: Reserve_Irq_For_PciBootDev to XGROUP
;			
;R03	11/14/97 RAY	Modify the algorithm for searching combined NCR SCSI
;			ROM
;			
;R02A	11/14/97 RAY	Problem fixed:
;			When apply both /NCR & /AHA to old CBROM.EXE, NCR SCSI
;			ROM is not loaded
;			
;R02	11/13/97 RAY	Add new CBROM.EXE support
;		 STEVEN	Since this function is very code is complicated,
;			I clear all the Rxx for easy debugging. From now on,
;			any changes to this file should add Rxx.

ifdef	MASM611
.MODEL  SMALL, BASIC
OPTION	PROC: PRIVATE
endif	;MASM611

.386P

		PAGE	56, 132
;.XLIST
		INCLUDE BIOS.CFG
		include	COMMON.EQU
		INCLUDE COMMON.MAC
		include	bsetup.inc
		include	fshadow.equ

ifndef	NO_PNP_PCI_AUTO
ifdef	PNP_BIOS
		PNP_PCI_AUTO	EQU	1
endif	;PNP_BIOS
endif;	NO_PNP_PCI_AUTO

ifdef	PCI_BUS

IRQ12_LAST_FOR_PCI	EQU	1
SET_MPIRQ_TBL	=	0

ifdef	MP_SUPPORT
ifdef	NEW_INTEL_IOAPIC
SET_MPIRQ_TBL	=	1
endif;	NEW_INTEL_IOAPIC
endif;	MP_SUPPORT

endif;	PCI_BUS
;R13A start
ifdef	LAN_BOOT_SUPPORT
		extrn	LanBoot_Item:near
endif	;LAN_BOOT_SUPPORT
;R13A end
ifdef	PNP_BIOS
		include	PNP.EQU
endif	;PNP_BIOS

		Public	NCR_810_FOUND

PUSH_ALL	MACRO
		push	ds
		push	es
		pushad
		ENDM

POP_ALL		MACRO
		popad
		pop	es
		pop	ds
		ENDM

;[]================================================================[]
;			EQUATES
;[]================================================================[]

TEMP_AREA		EQU	3000H

CLASS_VGA		EQU	03h
ALT_CLASS_VGA		EQU	0001h
CLASS_IDE		EQU	0101h
CLASS_SCSI		EQU	0100h
CLASS_PP_BRIDGE		EQU	0604H

CLASS_USB		EQU	0C03h

PCI_VGA_CLASS		EQU	03H
NORMAL_VGA_CLASS	EQU	0001H

CIRRUS_VENDOR_ID	EQU	1013H
NCR_VENDOR_ID		EQU	1000h
DEVICE_NCR810		EQU	0001h
DEVICE_NCR860		EQU	0006h
ADAPTEC_VENDOR_ID	EQU	9004h

DEVICE_AHA7850		EQU	5078h
DEVICE_AHA7860		EQU	6078h
DEVICE_AHA7870		EQU	7078h
DEVICE_AHA7880		EQU	8078h
DEVICE_AHA7895		EQU	7895H

BusLogic_VENDOR_ID	EQU	104bh
DEVICE_BA81C15		EQU	8130h

ACARD_VENDOR_ID		EQU	1191h
DEVICE_ACARD6710	EQU	8002h

AMD_VENDOR_ID		EQU	1022h
DEVICE_AMD974_SCSI	EQU	2020h

;[]================================================================[]
;		BP definitions
;[]================================================================[]

STACK_LOC	=	ITEMSTAT_BUF
DEFINE_STACK	MACRO	VAR_NAME, VAR_LEN
		Public	VAR_NAME
	VAR_NAME  = STACK_LOC
	STACK_LOC = STACK_LOC + VAR_LEN
		ENDM

DEFINE_STACK	START_PCI_DEV		, 1
DEFINE_STACK	END_PCI_DEV		, 1

DEFINE_STACK	AVAILABLE_PREFET_START	, 4
DEFINE_STACK	AVAILABLE_MEM_START	, 4
DEFINE_STACK	AVAILABLE_IO_START	, 4

DEFINE_STACK	PREFET_MEM_BUF_PTR	, 2
DEFINE_STACK	HMEM_BUF_PTR		, 2
DEFINE_STACK	IO_BUF_PTR		, 2
DEFINE_STACK	LMEM_BUF_PTR		, 2
DEFINE_STACK	BASE_REQ_BUF_PTR	, 2
DEFINE_STACK	PCI_VGA_DEVICE_BUF_PTR	, 2

DEFINE_STACK	CURRENT_DEVICE_ID	, 2
DEFINE_STACK	CURRENT_VENDOR_ID	, 2
DEFINE_STACK	CURRENT_CLASS_CODE	, 2
DEFINE_STACK	CURRENT_SLOT		, 1
DEFINE_STACK	CURRENT_BUS_NO		, 1
DEFINE_STACK	TOTAL_BUS_NO		, 1

;------------------------------------------------------------
;
;	LMEM_RESOURCE[bp]
;
;each bit describes 4K ROM(Shadow RAM) area
;  starting from C8000h - DF000h
;  i.e. bit 0 = 1 means C8000h-C8FFFh is occupied
;	    1 = 1	C9000h-C9FFFh is occupied
;	.
;	.
;	.
;
;------------------------------------------------------------

DEFINE_STACK	LMEM_RESOURCE		, 4
DEFINE_STACK	AVAIL_LMEM_ADDR		, 4
DEFINE_STACK	TARGET_AVAIL_LMEM	, 4
DEFINE_STACK	LMEM_FOR_ROM_FLG	, 1
DEFINE_STACK	NEED_ASSIGN_LMEM_FLAG	, 1
DEFINE_STACK	LMEM_BEFORE_ROM		, 4
DEFINE_STACK	LMEM_RESERVED		, 4

DEFINE_STACK	PCI_VGA_INFO		, 2		;bus/dev+Fun No.
DEFINE_STACK	PCI_VGA_FOUND		, 1
		VGA_DEVICE_EXIST	EQU	0AAh
DEFINE_STACK	VGA_BIOS_LENGTH		, 1

DEFINE_STACK	NCR_810_FOUND		, 1
		NCR_SCSI_FOUND		EQU	0BBh
		INVOKE_NCR_CBROM	EQU	0AAh
DEFINE_STACK	COMBINED_PCI_ROM_NEED	, 1
DEFINE_STACK	CBROM_BP_START		, 2
DEFINE_STACK	CBROM_BP_END		, 2
DEFINE_STACK	CBROM_BUF_START		, 4
DEFINE_STACK	CBROM_BUF_END		, 4
DEFINE_STACK	PCI_CBROM_TEMP		, 1
DEFINE_STACK	PCI_CBROM_ADDR		, 4

DEFINE_STACK	RESERVE_PCIIRQ		, 1
DEFINE_STACK	PCI_IRQ_ASSIGNED	, 2
DEFINE_STACK	PCI_IRQ_MAP		, 2
DEFINE_STACK	PCIIRQ  		, 32		;need 16*2 bytes
							;PCI available IRQ no. 1,2,4,4
							;low byte = IRQ No. 0-15
							;high byte = INT No. 1-16
DEFINE_STACK	PCI_IDE_EXIST		, 1
DEFINE_STACK	PCI_IDE_FOUND		, 1
		IDE_EXIST		EQU	0AAH	;flag for PCI/IDE found

DEFINE_STACK	ESCD_IRQ		, 2
DEFINE_STACK	ESCD_DMA		, 1

;R13 start
;R13A	ifdef	LAN_BOOT_SUPPORT
;R13A	DEFINE_STACK	LAN_ROM_NEED		, 1
;R13A	DEFINE_STACK	LAN_CARD_ID		, 4
;R13A	endif	;LAN_BOOT_SUPPORT
;R13 end
;[]================================================================[]
;[]================================================================[]

MAX_SUB_BUS		EQU	16
BUS_TREE_STRUC		STRUC
  Host_Slot		db	?
  P2PB_BusNo		db	?
  P2PB_DevFucNo		db	?
  Sub_Buses		db	MAX_SUB_BUS dup (?)
  TotalMemReq		dd	?
  TotalPfMemReq		dd	?
  TotalIOReq		dd	?
  TotalLMemReq		dd	?
  Bus_IO_Start		dd	?
  Bus_Mem_Start		dd	?
  Bus_PfMem_Start	dd	?
BUS_TREE_STRUC		ENDS
SIZE_BUS_TREE_STRUC	EQU	(SIZE BUS_TREE_STRUC)

VGA_INFO_STRUC		STRUC
	VGA_DevNum	db	?
	VGA_BusNum	db	?
	OnboardVGA	db	?
			db	?	;dummy byte
	VGA_ID		dd	?
VGA_INFO_STRUC		ENDS
SIZE_VGA_INFO_STRUC	EQU	(SIZE VGA_INFO_STRUC)

IRQ_REQ_STRUC		STRUC
	IntPin		db	?
	IrqReqDevNum	db	?
	IrqReqBusNum	db	?
	HostSlot	db	?
			dd	?	;dummy dword
IRQ_REQ_STRUC		ENDS
SIZE_IRQ_REQ_STRUC	EQU	(SIZE IRQ_REQ_STRUC)

TEMP_PCI_REQ_BUF	SEGMENT USE16 AT 5000h
P2P_TREE_INFO		Label	Byte
			db	(MAX_SUB_BUS * SIZE_BUS_TREE_STRUC) dup (?)
PCI_VGA_DEVICE_BUF	Label	Byte
			db	16*SIZE_VGA_INFO_STRUC dup (?)
TEMP_BASE_REQ_BUF	Label	Byte
TEMP_PCI_REQ_BUF	ENDS

MEMIO_BUF		STRUC
	MemIO_Req	dd	0
	Cfg_Loc		dw	0
	MemIo_Info	db	0
	Bus_Num		db	0
MEMIO_BUF		ENDS
SIZE_MEMIO_BUF		EQU	SIZE MEMIO_BUF

PCI_REQ_BUF	SEGMENT USE16 AT 4000h
BUF_SIZE	EQU	6*8*32		;max 32 devices
					;each device has max 8 functions
					;each function request max 6 Mem base
IO_BUF		db	(BUF_SIZE * SIZE_MEMIO_BUF) dup (?)
HMEM_BUF	db	(BUF_SIZE * SIZE_MEMIO_BUF) dup (?)
LMEM_BUF	db	(BUF_SIZE * SIZE_MEMIO_BUF) dup (?)
PREFET_MEM_BUF	db	(BUF_SIZE * SIZE_MEMIO_BUF) dup (?)

PCI_REQ_BUF	ENDS

VIRTUAL_HMEM_BASE	EQU	0A0h
VIRTUAL_PFMEM_BASE	EQU	0A8h
VIRTUAL_BUS0_PFMEM_BASE	EQU	0B0h
VIRTUAL_IO_BASE		EQU	0A1h

G_RAM		SEGMENT USE16 AT 0

		ORG	04H*4
		INCLUDE SEG_0.INC

		ORG	400H
		INCLUDE G_RAM.INC
ifdef	PNP_BIOS
		ORG	2000h
		INCLUDE PNPDATA.INC
endif	;PNP_BIOS

G_RAM		ENDS

		extrn	xcall_proc:near
		extrn	X_GetItem_Value:Near

.LIST

IFE	COMPILE_FOR_E0 EQ 1

ifdef	Trend_AntiVirus				;R09
		extrn	F000_Shadow_R:near	;R09
		extrn	F000_Shadow_W:near	;R09
		extrn	Virus_Used_Shadow:near	;R09
endif;	Trend_AntiVirus				;R09

ifdef	PCI_BUS

	ifdef	PNP_BIOS
		extrn	Build_OnboardRomNode:near
	 ifdef	COMBINE_ISA_ROM
		extrn	Build_OtherRomNode:near
	 endif;	COMBINE_ISA_ROM
	 ifndef	NEW_PNP_SETUP
	 ifdef	PNP_PCI_AUTO
		extrn	PnP_Auto_Item:near
	 endif	;PNP_PCI_AUTO
	 endif	;NEW_PNP_SETUP
	endif;	PNP_BIOS

	ifdef	Cardbus_support
		extrn	Cardbus_Init:near
	endif	;Cardbus_support

	IF	SET_MPIRQ_TBL
		extrn	IO_Int_Entry16:near
	ENDIF	;SET_MPIRQ_TBL

		extrn	Pci_Class_Code:near

		extrn	Check_M1_Cpu:near
		extrn	Unlock_Cyrix:near
		extrn	lock_Cyrix:near
		extrn	F000_Set_Cyrix:near

		extrn	F000_call_proc:near
		extrn	Post_call_proc:near
		extrn	POST_func_end:Near
		extrn	POST_VECT:Near

		extrn	Vga_Snoop_Item:near

		extrn	Ct_OnChip_IDE_Chk:near
	ifdef	ONBOARD_NCR_SETUPABLE
		extrn	Scsi_Item:near
	endif	;ONBOARD_NCR_SETUPABLE

		extrn	AGet_CfgSpace_Byte:near
		extrn	AGet_CfgSpace_Word:near
		extrn	AGet_CfgSpace_Dword:near
		extrn	ASet_CfgSpace_Byte:near
		extrn	ASet_CfgSpace_Word:near
		extrn	ASet_CfgSpace_Dword:near
		extrn	Move_Codes:Near
		extrn	GetItem_Value:Near
		extrn	F000_GetItem_Value:near

		extrn	F000_Shadow_W:near
		extrn	F000_Shadow_R:near
		extrn	E000_64k_Shadow_RW:Near
		extrn	E000_64k_Shadow_R:Near
		extrn	C000_Shadow_RW:near		;chipset.asm
		extrn	C000_Shadow_R:near		;chipset.asm
		extrn	C800_Shadow:near		;chipset.asm
		extrn	CC00_Shadow:near		;chipset.asm
		extrn	D000_Shadow:near		;chipset.asm
		extrn	D400_Shadow:near		;chipset.asm
		extrn	D800_Shadow:near		;chipset.asm
		extrn	DC00_Shadow:near		;chipset.asm

		extrn	PCI_SLOT_CFG:near		;chipset.asm
		extrn	Ct_Shadow_Unit:Near		;pcichip.asm
		extrn	Ct_C8_To_DF_RW:Near		;pcichip.asm
		extrn	Ct_C8_To_DF_R:Near		;pcichip.asm
		extrn	Ct_PCI_Info:Near		;pcichip.asm
		extrn	Ct_Special_PCI_Device:Near	;pcichip.asm
		extrn	Ct_Set_PciIrq:near		;pcichip.asm
		extrn	IrqRout_Table:near		;pcichip.asm
	ifndef	NEW_PNP_SETUP
		extrn	PciIrq_Item:near		;pcichip.asm
	endif	;NEW_PNP_SETUP
		extrn	Ct_Disable_Shadow:Near		;pcichip.asm

	ifdef	CT_SHADOW_RW_HOOK_SUPPORT
		extrn	Ct_Shadow_R:near		;pcichip.asm
		extrn	Ct_Shadow_RW:near		;pcichip.asm
	endif	;CT_SHADOW_RW_HOOK_SUPPORT

	ifndef	NO_PCI_IDE_CARD
		extrn	PCI_IDE_IRQ:near		;pcifeat.asm
		extrn	First_IDE_INT:near		;pcifeat.asm
		extrn	Second_IDE_INT:near		;pcifeat.asm
	endif	;NO_PCI_IDE_CARD

	ifndef	NO_PCI_IDE_2ND_CONTROL
		extrn	Second_IDE_channel:near		;bfeature.asm
	endif	;NO_PCI_IDE_2ND_CONTROL

		extrn	Ct_PCI_VGA_IDSEL:near		;pcichip.asm

	ifdef	CT_SPEICAL_PCI_VGA
		extrn	Set_Ct_For_PciVga:near
	endif	;CT_SPEICAL_PCI_VGA

		extrn	Ct_Special_Copy_PCI_VGA:near

	ifdef	SPECIAL_PCI_IDE_PRG
		extrn	CT_PRI_PCI_IDE_PRG:near		;pcichip.asm
		extrn	CT_SEC_PCI_IDE_PRG:near		;pcichip.asm
	endif	;SPECIAL_PCI_IDE_PRG

		extrn	C800_Item:near
		extrn	CC00_Item:near
		extrn	D000_Item:near
		extrn	D400_Item:near
		extrn	D800_Item:near
		extrn	DC00_Item:near

	ifdef	Combined_Other_PCI_ROM
		extrn	Ct_If_Combined_ROM_Needed:near
	endif	;Combined_Other_PCI_ROM

	ifdef	MULTI_HOST_BRIDGE
		extrn	Ct_Set_Mult_PciBus:near
	endif	;MULTI_HOST_BRIDGE

                extrn    GDTR1:fword
                extrn    code1_dt:near
                extrn    data1_dt:near
                extrn    data1_index:abs

		extrn	fProc_Pci_IO_Mem_Init:far

	IF	MSIRQROUT_SUPPORT
		extrn	MsPciIrqTbl:Near
	ENDIF	;MSIRQROUT_SUPPORT
		extrn	PciIrqTbl_Size:Near

		extrn	IRQ_REQ_BUF:Near
		extrn	IRQ_REQ_BUF_PTR:Near

		extrn	fProc_PciRom_Before_Init:Far

		extrn	POST_decompress:near
		extrn	A20_On:Near
		extrn	A20_Off:Near

		extrn	fProc_Reserve_Irq_For_PciBootDev:far	;R04

endif	;PCI_BUS

DGROUP		GROUP	FCODE
FCODE		SEGMENT USE16 PARA PUBLIC 'CODE'
		ASSUME	CS:DGROUP

ifdef	PCI_BUS
;[]==============================================================[]
;
;Note : Don't destroy following codes , because it will be executed
;	while warm booting
;
;Reset_PciMaster:
;	Clear bit 2 (master bit ) of PCI command register
;
;Saves: all
;
;Input : none
;
;Output: None
;
;[]==============================================================[]
		public	Reset_PciMaster
Reset_PciMaster	proc	near

ifndef	PCI_RESET_SUPPORT

		pushad

		xor	bh, bh			;start from bus 0
Scan_Nxt_BusMs:
		xor	cx, cx			;start from devic 0 , func. 0

Scan_Nxt_Master:

ifdef	Cx5510_PCI_REG
		cmp	ch, Cx5510_PCI_REG	;if Cyrix Cx5510 chipset
		je	Next_Dev		;
endif;	Cx5510_PCI_REG

		xor	cl, cl
		call	AGet_CfgSpace_Word	;get vendor ID
		cmp	ax, -1			;legal vendor ?
		je	Next_Dev

		mov	cl, 4
		call	AGet_CfgSpace_Byte	;get command register
		and	al, NOT 04H		;disable master bit
		call	ASet_CfgSpace_Byte	;Set command register

		mov	cl, 0bh
		call	AGet_CfgSpace_Byte	;get class code
		cmp	al, 02			;is PCI LAN ?
		jne	No_PCI_LAN

		mov	cl, 04h
		xor	al, al
		call	ASet_CfgSpace_Byte	;clear command register.
No_PCI_LAN:

Next_Dev:
		call	Get_Nxt_Device		;CH return next device to do
		jnc	Scan_Nxt_Master

		inc	bh			;next bus
		cmp	bh, 4			;total 4 buses
		jb	Scan_Nxt_BusMs

		popad

endif;	PCI_RESET_SUPPORT

		ret

Reset_PciMaster	endp

ifndef	PCI_RESET_SUPPORT
;[]================================================================[]
;Get_Next_Device:
;	This routine is used to get next device no to treat
;Input	:	CH - Slot identification Number
;Output :	NC : CH - Next Slot ID numbuer
;		CF : All slot & function spaces has scanned
;[]================================================================[]
		ALIGN	4
Get_Nxt_Device	proc	near

		test	ch, 07h			;alread a multi-function space?
		jnz	@F			;yes, go point to next function

		mov	cl, 0Eh			;read header type
		call	AGet_CfgSpace_Byte	;read header type
		test	al, 80H			;multi-function support?
		jnz	@F			;yes, multi-function card!
		add	ch, 7			;point to next device!
	@@:
		add	ch, 1			;point to next function space
		jc	@F			;already overflow!

	ifdef	CONFIG_MECHANISM_1
		cmp	ch, (31 SHL 3)		;exceed maximum device?
	else	;CONFIG_MECHANISM_1
		cmp	ch, (15 SHL 3)		;exceed maximum device?
	endif	;CONFIG_MECHANISM_1

		ja	@F			;yes, tell caller error!

		clc				;success return
		ret
	@@:
		stc				;error return
		ret

Get_Nxt_Device	endp
endif;	PCI_RESET_SUPPORT

;[]================================================================[]
;[]================================================================[]
		Public	fProc_Get_CfgSpace_Byte
fProc_Get_CfgSpace_Byte	Proc	Far
		call	Get_CfgSpace_Byte
		retf
fProc_Get_CfgSpace_Byte	Endp
Get_CfgSpace_Byte	Proc	Near
		push	bx
		mov	bh, CURRENT_BUS_NO[bp]
		call	AGet_CfgSpace_Byte
		pop	bx
		ret
Get_CfgSpace_Byte	Endp

;-----------------------
;-----------------------
		Public	fProc_Get_CfgSpace_Word
fProc_Get_CfgSpace_Word	Proc	Far
		call	Get_CfgSpace_Word
		retf
fProc_Get_CfgSpace_Word	Endp
Get_CfgSpace_Word	Proc	Near
		push	bx
		mov	bh, CURRENT_BUS_NO[bp]
		call	AGet_CfgSpace_Word
		pop	bx
		ret
Get_CfgSpace_Word	Endp

;-----------------------
;-----------------------
		Public	fProc_Get_CfgSpace_Dword
fProc_Get_CfgSpace_Dword	Proc	Far
		call	Get_CfgSpace_Dword
		retf
fProc_Get_CfgSpace_Dword	Endp
Get_CfgSpace_Dword	Proc	Near
		push	bx
		mov	bh, CURRENT_BUS_NO[bp]
		call	AGet_CfgSpace_Dword
		pop	bx
		ret
Get_CfgSpace_Dword	Endp

;-----------------------
;-----------------------
		Public	fProc_Set_CfgSpace_Byte
fProc_Set_CfgSpace_Byte	Proc	Far
		call	Set_CfgSpace_Byte
		retf
fProc_Set_CfgSpace_Byte	Endp
Set_CfgSpace_Byte	Proc	Near
		push	bx
		mov	bh, CURRENT_BUS_NO[bp]
		call	ASet_CfgSpace_Byte
		pop	bx
		ret
Set_CfgSpace_Byte	Endp

;-----------------------
;-----------------------
		Public	fProc_Set_CfgSpace_Word
fProc_Set_CfgSpace_Word	Proc	Far
		call	Set_CfgSpace_Word
		retf
fProc_Set_CfgSpace_Word	Endp
Set_CfgSpace_Word	Proc	Near
		push	bx
		mov	bh, CURRENT_BUS_NO[bp]
		call	ASet_CfgSpace_Word
		pop	bx
		ret
Set_CfgSpace_Word	Endp

;-----------------------
;-----------------------
		Public	fProc_Set_CfgSpace_Dword
fProc_Set_CfgSpace_Dword	Proc	Far
		call	Set_CfgSpace_Dword
		retf
fProc_Set_CfgSpace_Dword	Endp
Set_CfgSpace_Dword	Proc	Near
		push	bx
		mov	bh, CURRENT_BUS_NO[bp]
		call	ASet_CfgSpace_Dword
		pop	bx
		ret
Set_CfgSpace_Dword	Endp

;[]================================================================[]
;[]================================================================[]
		ALIGN	4
		Public	Pci_IO_Mem_Init
Pci_IO_Mem_Init Proc	Near

		call	fProc_Pci_IO_Mem_Init
		ret

Pci_IO_Mem_Init Endp

;--------------------------------------------------------------------
;if any shadow segment is not used
;  ---> call hook in PCICHIP.ASM to disable it
;
;if any shadow segment is originally not available for PCI ROM
;  ---> if setup setting is set to ENABLE
;		do nothing
;	else
;		call hook in PCICHIP.ASM to disable it
;--------------------------------------------------------------------
		ALIGN	4
		public	Disable_UnUsed_Shadow
Disable_UnUsed_Shadow	Proc	Near

		POST_FUNC_CALL EDisable_UnUsed_Shadow
		ret

Disable_UnUsed_Shadow	Endp

;---------------------------------------------------------------------------
;
;		copy ROM image from SI:0 --> DI:0
;
;Input	:	SI = source segment
;		DI = Destination segment
;		AL <> 0 : copy size depends on ROM size in SI:2
;		   == 1 : copy size = input CX (no. of 4K)
;
;---------------------------------------------------------------------------
		ALIGN	4
		Public	Copy_ROM
Copy_ROM	Proc	Near

		POST_FUNC_CALL ECopy_Rom
		ret

Copy_ROM	Endp

;[]============================================================[]
;Input	:	CL = Request Memory spaces with size = CL * 4K
;		     e.g. CL = 1 --> request 4K bytes
;
;Output	:	AL = 1 --> NC : AVAIL_LMEM_ADDR[bp] = availbale address
;			   CF : No address available
;[]============================================================[]
		ALIGN	4
		ASSUME	DS:NOTHING
		Public	Get_Available_LMEM
Get_Available_LMEM	Proc	Near

		POST_FUNC_CALL EGet_Available_LMEM
		ret

Get_Available_LMEM	Endp

;[]============================================================[]
;Enter Protected Mode with DS point to 00000000h
;[]============================================================[]
		ALIGN	4
		Public	Enter_Protect_Mode
Enter_Protect_Mode	Proc	Near

                mov     ax, cs
                mov     ds, ax
                assume  ds:dgroup

                lgdt    fword ptr GDTR1

                mov     eax, cr0
                or      al, 1
                mov     cr0, eax

     		jmp	$+2			; flush queue

                mov     ax, DATA1_INDEX
                mov     ds, ax			; ds = 00000000h

		ret

Enter_Protect_Mode	Endp

;[]============================================================[]
;[]============================================================[]
		ALIGN	4
		Public	Leave_Protect_Mode
Leave_Protect_Mode	Proc	Near

                mov     eax, cr0
                and     al, NOT 1
                mov     cr0, eax
     		jmp	$+2			; flush queue

		ret

Leave_Protect_Mode	Endp

;[]============================================================[]
;Input	:	CH - Slot identification Number
;Output :	AX - VENDER ID
;Destroy:	AX
;[]============================================================[]
		Public	fProc_Get_Vendor_ID
fProc_Get_Vendor_ID	Proc	Far
		call	Get_Vendor_ID
		retf
fProc_Get_Vendor_ID	Endp
		ALIGN	4
		ASSUME	DS:NOTHING
		public	Get_Vendor_ID
Get_Vendor_ID	Proc	Near

		push	cx
		xor	cl, cl			;Vendor ID
		call	Get_CfgSpace_Word

		cmp	ax, -1			;valid vendor ID
		stc
		je	Yes_Invalid
		clc
Yes_Invalid:
		pop	cx
		ret

Get_Vendor_ID	Endp

;[]============================================================[]
;Input	:	CH - Slot identification Number
;Output :	AX - DEVICE ID
;Destroy:	AX
;[]============================================================[]
		Public	fProc_Get_Device_ID
fProc_Get_Device_ID	Proc	Far
		call	Get_Device_ID
		retf
fProc_Get_Device_ID	Endp
		ALIGN	4
		ASSUME	DS:NOTHING
		Public	Get_Device_ID
Get_Device_ID	Proc	Near

		push	cx
		mov	cl, 02			;Device ID
		call	Get_CfgSpace_Word
		pop	cx
		ret

Get_Device_ID	Endp

;[]==============================================================[]
;PciRom_After_Init:
;	Force shadow RAM readonly after option ROM initialization
;Saves: all
;Input : none
;Output: None
;[]==============================================================[]
		ALIGN	4
		public	PciRom_After_Init
PciRom_After_Init	proc	near

		POST_FUNC_CALL EPciRom_After_Init
		ret

PciRom_After_Init	endp

;[]==============================================================[]
;PciRom_Before_Init:
;	special treatment before option initialization
;Saves: all
;Input : none
;Output: None
;[]==============================================================[]
		ALIGN	4
		public	PciRom_Before_Init
PciRom_Before_Init	proc	near

		call	fProc_PciRom_Before_Init

;R13 start
;R13A	ifdef	lan_boot_support
;R13A			mov	dword ptr LAN_CARD_ID[bp],0		;clear LAN device&vendor ID
;R13A	
;R13A			mov	di,(8+1)*4
;R13A			post_func_call	post_decompress			;combined lan rom ?
;R13A			jc	short No_LAN_ROM			;yes!
;R13A			push	es
;R13A			push	4000h
;R13A			pop	es
;R13A			mov	bx,es:[18h]
;R13A			mov	ax,es:[bx+4]				;get vendor id
;R13A			shl	eax,16
;R13A			mov	ax,es:[bx+6]				;get device id
;R13A			pop	es
;R13A			mov	LAN_CARD_ID[bp], eax			;save vendor&device id
;R13A	No_LAN_ROM:
;R13A	endif	;lan_boot_support
;R13 end

		ret

PciRom_Before_Init	endp

;R05 - starts
ifdef	SUPPORT_PCISLOT_IDE
		Public	Open_8673
Open_8673	proc	near

		mov	dx, 108h
		mov	al, 04Ah
		out	dx, al
		NEWIODELAY
		mov	al, 06Ch
		out	dx, al
		NEWIODELAY

		mov	al, cl
		out	dx, al
		NEWIODELAY
		inc	dl
		in	al, dx
		NEWIODELAY

		ret

Open_8673	endp

		Public	Set_8673
Set_8673	proc	near

		xchg	al, cl
		mov	dx, 108h
		out	dx, al
		NEWIODELAY
		inc	dl
		xchg	al, cl
		out	dx, al
		NEWIODELAY
		mov	dx, 108h
		mov	al, 034h
		out	dx, al
		NEWIODELAY

		ret

Set_8673	endp
endif;	SUPPORT_PCISLOT_IDE
;R05 - ends

endif	;PCI_BUS

FCODE		ENDS

;--------------------------------------------------------------
;--------------------------------------------------------------
;----- The following codes will be located at E000 ! ----------
;----- The following codes will be located at E000 ! ----------
;----- The following codes will be located at E000 ! ----------
;----- The following codes will be located at E000 ! ----------
;--------------------------------------------------------------
;--------------------------------------------------------------
EGROUP		GROUP	ECODE
ECODE		SEGMENT USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP, DS:G_RAM, ES:EGROUP

ifdef	PCI_BUS

;--------------------------------------------------------
;Input	:	SI = C800 - DF80
;		CL =  number of 4K to mark
;--------------------------------------------------------
		ALIGN	4
		ASSUME	DS:NOTHING
		Public	Mark_Addr_Not_Available
Mark_Addr_Not_Available	Proc	Near

		mov	eax, 1
		shl	eax, cl
		dec	eax

		mov	cx, si
		mov	cl, ch
		sub	cl, 0C8h
		shl	eax, cl
		or	LMEM_RESOURCE[bp], eax

		ret

Mark_Addr_Not_Available	Endp

;---------------------------------------
;Input : SI - segment to check
;Output: zero set  - ROM existed
;	 not zero  - ROM no existed
;---------------------------------------
		Public	Check_ROM_Exist
Check_ROM_Exist	proc	near
		mov	ds, si
		mov	ax, ds:[0]
		iodelay
		cmp	ax, 0AA55h			;ROM signature?
		ret
Check_ROM_Exist	endp

		Public	Rom_In_Terms_of_4K
Rom_In_Terms_of_4K	Label	Near

		mov	cl, ds:[2]			;ROM size in 512K
		test	cl, 07h				;size < 4K
		jz	@F				;no, continue!
		add	cl, 08h				;  to 4K
	@@:
		shr	cl, 3				;in terms of 4K
		ret

;-------------------------------------------
;-------------------------------------------
		ALIGN	4
		Public	Invalidate_Shadow_Seg
Invalidate_Shadow_Seg	Proc	Near

		F000_CALL Ct_Shadow_Unit
		mov	edi, 00Fh
		cmp	cx, 4000h
		mov	cl, 4
		je	@F
		mov	edi, 0FFh
		mov	cl, 8
	@@:

	;------------------------------------
	_A_A:
		test	LMEM_RESOURCE[bp], edi
		jz	_B_B
		or	LMEM_RESOURCE[bp], edi
	_B_B:

		shl	edi, cl
		test	edi, 0FF000000h
		jz	_A_A
	;------------------------------------

		ret

Invalidate_Shadow_Seg	Endp

;---------------------------------------
;---------------------------------------
E000_A20_On	Proc	Near
		push	ds
		F000_CALL A20_On
		pop	ds
		ret
E000_A20_On	Endp

;---------------------------------------
;---------------------------------------
E000_A20_Off	Proc	Near
		push	ds
		F000_CALL A20_Off
		pop	ds
		ret
E000_A20_Off	Endp

;[]================================================================[]
;Function : Far call to write PCI double word value
;Input  : CX - device + function number	, CURRENT_BUS_NO[bp] = bus No.
;Output : none
;[]================================================================[]
		Public	F000_Set_CfgSpace_Dword
F000_Set_CfgSpace_Dword	proc	near
		call	fProc_Set_CfgSpace_Dword
		ret
F000_Set_CfgSpace_Dword	endp

;[]================================================================[]
;Function : Far call to write PCI word value
;Input  : CX - device + function number	, CURRENT_BUS_NO[bp] = bus No.
;Output : none
;[]================================================================[]
		Public	F000_Set_CfgSpace_word
F000_Set_CfgSpace_word	proc	near
		call	fProc_Set_CfgSpace_word
		ret
F000_Set_CfgSpace_word	endp

;[]================================================================[]
;Function : Far call to write PCI byte value
;Input  : CX - device + function number	, CURRENT_BUS_NO[bp] = bus No.
;Output : none
;[]================================================================[]
		Public	F000_Set_CfgSpace_Byte
F000_Set_CfgSpace_Byte	proc	near
		call	fProc_Set_CfgSpace_Byte
		ret
F000_Set_CfgSpace_Byte	endp

;[]================================================================[]
;Function : Far call to read PCI double word value
;Input  : CX - device + function number	, CURRENT_BUS_NO[bp] = bus No.
;Output : none
;[]================================================================[]
		Public	F000_Get_CfgSpace_Dword
F000_Get_CfgSpace_Dword	proc	near
		call	fProc_Get_CfgSpace_Dword
		ret
F000_Get_CfgSpace_Dword	endp

;[]================================================================[]
;Function : Far call to read PCI word value
;Input  : CX - device + function number	, CURRENT_BUS_NO[bp] = bus No.
;Output : none
;[]================================================================[]
		Public	F000_Get_CfgSpace_word
F000_Get_CfgSpace_word	proc	near
		call	fProc_Get_CfgSpace_word
		ret
F000_Get_CfgSpace_word	endp

;[]================================================================[]
;Function : Far call to read PCI Byte value
;Input  : CX - device + function number	, CURRENT_BUS_NO[bp] = bus No.
;Output : none
;[]================================================================[]
		Public	F000_Get_CfgSpace_Byte
F000_Get_CfgSpace_Byte	proc	near
		call	fProc_Get_CfgSpace_Byte
		ret
F000_Get_CfgSpace_Byte	endp

;[]============================================================[]
;Input	:	CH - Slot identification Number
;Output :	AX - VENDER ID
;Destroy:	AX
;[]============================================================[]
		ALIGN	4
		ASSUME	DS:NOTHING
		Public	F000_Get_Vendor_ID
F000_Get_Vendor_ID	Proc	Near

		call	fProc_Get_Vendor_ID
		ret

F000_Get_Vendor_ID	Endp

;[]==============================================================[]
;EPciRom_After_Init:
;	Force shadow RAM readonly after option ROM initialization
;Saves: all
;Input : none
;Output: None
;[]==============================================================[]
		ALIGN	4

EPciRom_After_Init	proc	near

		PUSH_ALL

IF	RELEASE_E000_FOR_PCI
	;Enable E0000-E7FFF shadow RAM read/write because we have
	;to release this area for PCI ROM

		F000_CALL E000_64k_Shadow_RW
ENDIF	;RELEASE_E000_FOR_PCI

		push	dword ptr LMEM_BEFORE_ROM[bp]

		mov	eax, LMEM_BEFORE_ROM[bp]
		mov	edx, LMEM_RESOURCE[bp]
		not	eax
		and	edx, eax
		mov	LMEM_BEFORE_ROM[bp], edx

	;init NON-Compliance ROMs on all Buses

		call	Non_PCI_Compliance_ROM
		jc	@F			;CF = Already shadow

		call	Shadow_C8_To_DF
		call	Dis_Shadow_Not_Avail
	@@:

		ALIGN	4
		pop	dword ptr LMEM_BEFORE_ROM[bp]

	;special for NCR's SCSI devices

	;init Compliance ROMs on all Buses

		call	PCI_Compliance_ROM

		call	Init_NCR810_ROM

	ifdef	COMBINE_ISA_ROM
		call	Init_Other_ROMs
	endif;	COMBINE_ISA_ROM

	ifndef	CT_SHADOW_RW_HOOK_SUPPORT
		F000_CALL Ct_C8_To_DF_R
	else	;CT_SHADOW_RW_HOOK_SUPPORT
		call	Shadow_C8_To_DF_R
	endif	;CT_SHADOW_RW_HOOK_SUPPORT

		call	Invalidate_Shadow_Seg		;invalidate whole shadow seg
							;i.e. shadow unit = 16K(32K)
							;     ==> invalidate whole
							;	  16k(32k) even if it
							;	  is not totally used!

		mov	si, 1
		call	EDisable_UnUsed_Shadow

;Enable/Disable VGA Palette snoop according to setup

		cmp	byte ptr PCI_VGA_FOUND[bp], VGA_DEVICE_EXIST ;PCI VGA existed
		jne	No_PciVga_Found

		mov	si, offset Vga_Snoop_Item
		call	F000_GetItem_Value
		or	al, al
		jz	No_VgaSnoop

		mov	cx, PCI_VGA_INFO[bp]	;ah = bus no. al=dev+fun no
		mov	bh, ch			;bus no.
		xchg	ch, cl
		mov	cl, 04H			;command register
		F000_CALL Aget_CfgSpace_Word
		or	al, 20H			;enable VGA snoop
		F000_CALL ASet_CfgSpace_Word
No_VgaSnoop:
No_PciVga_Found:

IF	RELEASE_E000_FOR_PCI
;--------------------------------------------------------------
;clear the un-used E0000-E7FFF shadow RAM to FFh for EMM386 UMB
;--------------------------------------------------------------

		mov	al, LMEM_RESOURCE[bp+3]	;save for atbase.asm
						;to check if E000 shadow RAM
						; occupied by PCI ROM
		mov	si, offset E000_USED_BY_PCI
		mov	cs:[si], al

		mov	cx, 08000h		;32k to clear
		mov	di, 0E000h		;starting from E000h
	@@:
		or	al, al
		jz	@F
		shr	al, 1
		add	di, 100h		;update starting addr. to clr
		sub	cx, 1000h		;add 4k more to clear
		jmp	@B
	@@:
		or	ch, ch
		jz	No_Need_Clear_E0
		mov	es, di			;Clear shadow with 0FFh
		xor	di, di			;Clear shadow with 0FFh
		cld				;Clear shadow with 0FFh
		mov	al, -1			;Clear shadow with 0FFh
		rep	stosb			;Clear shadow with 0FFh

	No_Need_Clear_E0:

		F000_CALL E000_64k_Shadow_R

ENDIF	;RELEASE_E000_FOR_PCI

		mov	byte ptr LMEM_FOR_ROM_FLG[bp], 1

;R09 - start 
ifdef	Trend_AntiVirus
		pushad
		push	di
		push	es
		push	ds

		mov	di, (07h+1)*4		;Cbrom /vrs number ID
		call	POST_decompress		;Decompress to 4000:0
		jc	Not_trend

		push	4000h
		pop	ds
		mov	cl, ds:[2]     		;get rom size of 4000:2 
		pop	ds
	
		mov	al, cl
		shr	cl, 3			;patch 4k rom size
		and	al, 07h			
		or	al, al
		jz	short @f
		inc	cl
	@@:
		call	EGet_Available_LMEM	;ask for LOW MEM
		jc	Not_trend		;no shadow available

		push	cx
		dec	cx
		mov	eax, 0FFFFFFFEh	
		shl	eax, cl	
		not	eax

		mov	ecx, AVAIL_LMEM_ADDR[bp]
		shr	ecx, 12	
		sub	cl, 0C8h
		shl	eax, cl
		or	LMEM_RESERVED[bp], eax
	
		push	0f000h				
		pop	es			
		F000_call	F000_Shadow_W		;Get a space to save
		mov	si, offset Virus_Used_Shadow	;used shadow

;Enable using shadow block that can be read and write
		pop	cx
		push	cx

		mov	ebx, AVAIL_LMEM_ADDR[bp]
		shr	ebx, 12			;BL is Trend_AntiVirus start
		mov	bh, bl
		and	bh, 0fch		;BH is shadow open start
		mov	dl, bl
		add	dl, cl			;DL is Trend_AntiVirus end
		mov	dh, dl
		mov	ah, dl
		and	ah, 03h
		or	ah, ah
		jz	short @f
		inc	dh			;DH is shadow end
	@@:
		push	bx
	@@:
		pushad
		mov	dh, bh
		F000_Call	Ct_Shadow_RW
		popad
		mov	ah, bh
		add	bh, 04h
		cmp	bh, dh
		jb	short @b
		pop	bx
		mov	al, bh
		mov	es:[si], ax	 	;store ax to Virus_Used_Shadow

		F000_call	F000_Shadow_R		

		pop	cx
		shl	ecx, 11			;Move times by word
		mov	si,4000h		;SI: Source SEG
		mov	edi,AVAIL_LMEM_ADDR[bp]	;EDI: available shadow RAM
		shr	edi,4			;DI: destination SEG
		F000_CALL Move_Codes		
		call 	Init_ROM		;invoke NCR810 ROM
		pop	es
		pop	di
	     	popad
Not_trend:
endif; Trend_AntiVirus
;R09 - end


		POP_ALL

		ret

EPciRom_After_Init	endp

ifdef	COMBINE_ISA_ROM
;-----------------------------------------------------------
;Function : Initial option ISA ROM added by switch /other
;
;Input    : none
;
;Output   : LMEM_RESOURCE[bp] modified by option ROM size
;-----------------------------------------------------------
Init_Other_ROMs	proc	near

		pushad

		mov	edi, 800h			; 1800:0

	Scan_Other_Combine_Isa_ROM:

		push	edi

		call	Find_Valid_ROM_Image 	 	;any of them valid?
		jc	No_OtherRom			;no valid !

	;if it is a PCI ROM, skip it

		mov	di, word ptr ds:[18h]
		cmp	dword ptr ds:[di], 'RICP'
		je	No_OtherRom

		mov	byte ptr LMEM_FOR_ROM_FLG[bp], 1;shadow RAM for ROM

		mov	cl, ds:[2]			;get ROM size
		xor	ch, ch
		shr	cx, 3				;by 4k unit
		adc	cx, 0
		push	cx				;save rom size

		push	dword ptr LMEM_RESOURCE[bp]
		call	EGet_Available_LMEM     	;ask for LOW MEM
		pop	dword ptr LMEM_RESOURCE[bp]
		pop	cx				;restore rom size
		jc	No_OtherRom			;no shadow available

;R09	ifdef	Trend_AntiVirus
;R09
;R09		pop	edi
;R09		push	edi
;R09		cmp	di, 1C00h
;R09		jne	Not_Trend
;R09
;R09		pushad
;R09		push	cx
;R09
;R09		dec	cx
;R09		mov	eax, 0FFFFFFFEh
;R09		shl	eax, cl
;R09		not	eax
;R09
;R09		mov	ecx, AVAIL_LMEM_ADDR[bp]
;R09		shr	ecx, 12
;R09		sub	cl, 0C8h
;R09		shl	eax, cl
;R09		or	LMEM_RESERVED[bp], eax
;R09
;R09		pop	cx
;R09		popad
;R09
;R09	Not_Trend:
;R09	endif	;Trend_AntiVirus

		mov	edi, AVAIL_LMEM_ADDR[bp]	;EDI: available shadow RAM
		shr	edi, 4				;DI: destination SEG

		mov	al, 1				;copy according to CX
		call	ECopy_ROM			;copy ROM to shadow

		call 	Init_ROM			;invoke NCR810 ROM

	;Recalculate available low memory size due to ROM size changed

		mov	eax, AVAIL_LMEM_ADDR[bp]
		mov	TARGET_AVAIL_LMEM[bp], eax
		shr	eax, 4
		call	Recalibrate_LMEM_For_ROM

ifdef	PNP_BIOS
	;build memory used by Motherboard to prevent SCT test failure
		mov	edi, AVAIL_LMEM_ADDR[bp]	;EDI: available shadow RAM
		call	Build_OtherRomNode
endif;	PNP_BIOS

No_OtherRom:

		pop	edi
		add	di, 0080h
		cmp	di, 2000h
		jb	Scan_Other_Combine_Isa_ROM

		popad
		ret

Init_Other_ROMs	endp
endif;	COMBINE_ISA_ROM

;[]==============================================================[]
;Pci_CbRom_decompress:
;
;Description:
;
;
;Input : compress_bp_start = option ROM start index (depand on CBROM.EXE utility)
;	 compress_bp_end = option ROM end index (depand on CBROM.EXE utility)
;        decompress_add_start = device and vender ID store buffer start address
;Output: None
;
;  - 200000h (start)
;  |	VGA Drive Rom Vendor & Device ID and potect_mode address
;  |	Index.
;  - 20002fh (end)
;  - 200030h (start)
;  |	VGA Drive Rom Vendor & Device ID and potect_mode address
;  |	Index.
;  - 2000A0h (end)
;  - 200100h (start)
;  |
;  |
;  |	All VGA & PCI Device ROM decompress pool.
;  |
;  |
;  -
;[]==============================================================[]
		ALIGN	4
		Public	fProc_Pci_CbRom_decompress
fProc_Pci_CbRom_decompress	Proc	Far

		push	ds
		push	es
		mov	esi, 200100h			;temp store decompress code address start
		mov	ax, CBROM_BP_START[bp]
		mov	di, ax
		mov	edx, CBROM_BUF_START[bp]

Decomp_PCI_Loop:

		push	edx
		push	esi				;push temp store decompress code address start to stack
		push	di
		call	POST_decompress			;decompress cbrom pool
		pop	di
		pop	esi				;pop temp store decompress code address start from stack
		pop	edx
		jc	NO_PCI_TABLE

		mov	bx, Temp_EXP_Seg
		mov	es, bx
	ifdef	Flash_2M_support
		mov	ebx, 160000h			;extra option ROM temp address
		cmp	es:[di+Temp_EXP_Off+2], 8000h	;first segment
		je	@F				;Yes, skip
		add	ebx, 10000h			;set to next sgment (170000h)
	@@:
		add	bx, es:[di+Temp_EXP_Off]	;set to physical address
	else	;Flash_2M_support
		xor	ebx, ebx			;R02B
		mov	bx, es:[di+Temp_EXP_Off+2]	;R02B
		shl	ebx, 4				;R02B
		mov	bx, es:[di+Temp_EXP_Off]
	endif	;Flash_2M_support
		push	di
		push	es
		push	edx
		push	esi				;push temp store decompress code address start to stack

;-----------------------           -----------------------------

		cli
		call	E000_A20_On
		call	E000_Enter_Prot_mode		;enter protected mode
		mov	ax, ds
		mov	es, ax
		mov	ecx, es:[ebx+0bh]
		add	ecx, 3
		and	ecx, not 3
		mov	esi, 40000h
		pop	edi				;pop temp store decompress code address start from stack

		pop	edx
		mov	ebx, 40000h
		mov	bx, ds:[esi+18h]		;point to PCIR offset
		mov	eax, ds:[ebx+4]			;get Vendor and Device ID from option ROM
		mov	es:[edx], eax			;store to temp buffer
		mov	es:[edx+4], edi			;store physical address to temp buffer
		add	edx, 8

		shr	ecx, 2
		cld
;R07 - starts
		cmp	byte ptr PCI_CBROM_TEMP[bp], 0
		jne	@F
		cmp	dword ptr ds:[70000h], 0AA55h
		je	@F
		pushad
		mov	edi, 70000h
 		db	67h
 		rep	movsd				;move original option ROM code to
		popad
	@@:
;R07 - ends
 		db	67h
 		rep	movsd				;move original option ROM code to
							;protect mode temp address from 200100h
		push	edi

		call	E000_Back_Real_Mode
		call	E000_A20_Off
;----------------------------------------------------
		pop	esi
		pop	es
		pop	di
NO_PCI_TABLE:
		add	di, 4
		mov	ax, CBROM_BP_END[bp]
		cmp	di, ax
		jb	Decomp_PCI_Loop

		cmp	byte ptr PCI_CBROM_TEMP[bp], -1	;is't PCI flag for pci_cbrom_decompress subroutine
		jne	Pci_CbRom_decompress_End

	;-------------------------------

		mov	ax, 800h

	Compatible_Move:

		push	ax

		mov	ds, ax
		cmp	ds:[0], 0AA55h			;800:0h have pci Decice rom ?
		jne	No_ROM_Here

		push	ds
		push	esi
		mov	bx, ds:[18h]
		mov	eax, ds:[bx+4]

;R03		cmp	ax, NCR_VENDOR_ID
;R03		jne	@F
;R03		and	eax, 0FFFFh
;R03	@@:
		mov	cx, ds:[2]
		shl	cx, 9
		push	eax
		push	cx
		call	E000_Enter_Prot_Mode
		call	E000_Back_Real_Mode		;R03
		pop	cx
		pop	eax
		pop	edi
		pop	si
		movzx	esi, si
		shl	esi, 4

		mov	dword ptr ds:[edx], eax
		mov	dword ptr ds:[edx+4], edi
		add	edx, 8				;R02A
	@@:
		mov	eax, ds:[esi]
		mov     ds:[edi], eax
		add	edi, 4
		add	esi, 4
		loop	@B

		push	edi
;R03		call	E000_Back_Real_Mode
		pop	esi

	No_ROM_Here:

		pop	ax
		cmp	ax, 1000h
		mov	ax, 1000h
		jne	Compatible_Move

	Pci_CbRom_decompress_End:

		pop	es
		pop	ds
		ret

fProc_Pci_CbRom_decompress	endp

;[]-------------------------------------------------------------------[]
;Function : Build PCI/IRQ routing table for Microsoft specification
;Input    : none
;Output   : none
;[]-------------------------------------------------------------------[]
		public	Build_MsPciIrq
Build_MsPciIrq	proc	near

IF	MSIRQROUT_SUPPORT

		F000_CALL F000_Shadow_W

		mov	si, offset MsPciIrqTbl
		mov	ax, SEG MsPciIrqTbl
		mov	ds, ax

IF	USB_ONBOARD
		pushad
		mov	ax, 0B109h		;read word
		mov	bx, USB_ONBOARD		;bus, dev & func no
		xor	di, di			;reg 0 (Vendor ID)
		int	1Ah			;invoke PCI read
		cmp	cx, 0FFFFh		;USB controller exist?
		popad
		jne	@F			;yes!

		sub	word ptr ds:[si+6], 16	;change the table size
		mov	di, offset PciIrqTbl_Size
		sub	word ptr ds:[di], 16
	@@:
ENDIF	;USB_ONBOARD

		mov	cx, [si+6]		;No. of byte for checksum
		cld
		xor	ah, ah			;initial
NextMsPciByte:
		lodsb
		add	ah, al
		loop	NextMsPciByte

		not	ah			;invert byte to zero checksum
		inc	ah
		mov	si, (offset MsPciIrqTbl)+31;checksum location
		mov	[si], ah		;save checksum value

		F000_CALL F000_Shadow_R

ENDIF	;MSIRQROUT_SUPPORT

		ret

Build_MsPciIrq	endp

IF	RELEASE_E000_FOR_PCI
		Public	E000_USED_BY_PCI
E000_USED_BY_PCI	db	0
ENDIF	;RELEASE_E000_FOR_PCI

ifdef	CT_SHADOW_RW_HOOK_SUPPORT
;[]==============================================================[]
;Shadow_C8_To_DF_R:
;	Force all shadow to read only after all PCI ROM done
;Input:		none
;Output:	none
;[]==============================================================[]
		ALIGN	4
Shadow_C8_To_DF_R:
		pushad
		F000_CALL Ct_Shadow_Unit		;shadow unit in CX
		mov	dx, 0C800h			;start segment
		mov	bx, cx				;size in byte
		shr	bx, 4				;convert to segment
		mov	eax, 0000000Fh			;mask value
		mov	cl, 4				;shift value
		cmp	bx, 400h			;size in 16KB?
		je	Shadow_C8_To_DF_R_Loop
		mov	eax, 000000FFh			;mask value
		mov	cl,  8				;shift value

Shadow_C8_To_DF_R_Loop:

		test	LMEM_RESERVED[bp], eax		;reserved by others?
		jnz	Shadow_C8_To_DF_R_Next

		pushad
		F000_CALL Ct_Shadow_R
		popad

Shadow_C8_To_DF_R_Next:

		shl	eax, cl
		add	dx, bx
		test	eax, 0FF000000h			;E000 arrived?
		jz	Shadow_C8_To_DF_R_Loop

		popad
		ret
endif	;USB_SUPPORT

;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
		ALIGN	4
Shadow_C8_To_DF	Proc	Near

		mov	si, 0C800h
		mov	di, TEMP_AREA

		call	GG

ifndef	USB_SUPPORT
		F000_CALL Ct_C8_To_DF_RW
endif	;USB_SUPPORT

		mov	si, TEMP_AREA

		mov	di, 0C800h

ifdef	USB_SUPPORT

		F000_CALL Ct_Shadow_Unit		;shadow unit in CX
		mov	bx, cx				;size in byte
		shr	bx, 4				;convert to segment
		mov	al, 1				;flag for Copy_ROM
		mov	edx, 0000000Fh			;mask value
		mov	cx, 4				;size 4KB*4=16KB
		cmp	bx, 400h			;size in 16KB?
		je	Shadow_C8_To_DF_Loop
		mov	edx, 000000FFh			;mask value
		mov	cx,  8				;size 8KB*4=32KB

	Shadow_C8_To_DF_Loop:

		test	LMEM_RESERVED[bp], edx		;reserved by others?
		jnz	Shadow_C8_To_DF_Next

		pushad
		mov	dx, di				;DX=seg to R/W shadow
		F000_CALL Ct_Shadow_RW
		popad

		pushad
		call	ECopy_ROM
		popad

	Shadow_C8_To_DF_Next:

		add	si, bx				;next source segment
		add	di, bx				;next dest. segment
		shl	edx, cl				;next mask value

		test	edx, 0FF000000h			;E000 arrived?
		jz	Shadow_C8_To_DF_Loop

		ret
endif	;USB_SUPPORT

	GG:
		mov	al, 1
		mov	cx, 24
		call	ECopy_ROM

		ret

Shadow_C8_To_DF	Endp

;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
		ALIGN	4
Request_LMEM_For_ROM	Proc	Near

		mov	byte ptr LMEM_FOR_ROM_FLG[bp], 1; 1 = request addr.
							;     for ROM init
		jmp	@F

Recalibrate_LMEM_For_ROM	Label	Near

		mov	byte ptr LMEM_FOR_ROM_FLG[bp], 2; 2 = request addr.
							;     for run time
	@@:

		push	cx
		mov	ds, ax
		call 	Rom_In_Terms_of_4K

		call	EGet_Available_LMEM		;request low mem
		pop	cx

		ret

Request_LMEM_For_ROM	Endp

;--------------------------------------------------------------------
;After setting the shadow segment C8-DF to be R/W, we have to unshadow
;those segments which is originally not avaible for LMEM. This is very
;critical for PCI devices which request low memory & ROM init at the
;same time
;--------------------------------------------------------------------
Dis_Shadow_Not_Avail	Proc	Near

		pushad

		push	dword ptr LMEM_RESOURCE[bp]
		push	dword ptr LMEM_BEFORE_ROM[bp]
		pop	dword ptr LMEM_RESOURCE[bp]
		xor	dword ptr LMEM_RESOURCE[bp], -1
		xor	si, si
		call	EDisable_UnUsed_Shadow
		pop	dword ptr LMEM_RESOURCE[bp]

		popad
		ret

Dis_Shadow_Not_Avail	Endp

		ALIGN	4
Shadow_Items:
		dw	offset DGROUP:C800_Item
		dw	offset DGROUP:CC00_Item
		dw	offset DGROUP:D000_Item
		dw	offset DGROUP:D400_Item
		dw	offset DGROUP:D800_Item
		dw	offset DGROUP:DC00_Item

;--------------------------------------------------------------------
; Input:	BL = queried VGA BIOS size (512b unit)
; Output:	flags affected
;--------------------------------------------------------------------
Query_VGA_Size	proc	near

		push	ds
		push	ax
		mov	ax, 0C000h
		mov	ds, ax
		cmp	word ptr ds:[0], 0AA55h	;VGA BIOS exist?
		jne	@F			;skip if no VGA BIOS
		cmp	byte ptr ds:[2], bl	;compare BIOS size
		pop	ax
		pop	ds
		ret
	@@:
		cmp	al, bl			;no VGA BIOS, so always less
						; than BL
		pop	ax
		pop	ds
		ret

Query_VGA_Size	endp

;--------------------------------------------------------------------
;if any shadow segment is not used
;  ---> call hook in PCICHIP.ASM to disable it
;
;if any shadow segment is originally not available for PCI ROM
;  ---> if setup setting is set to ENABLE
;		do nothing
;	else
;		call hook in PCICHIP.ASM to disable it
;--------------------------------------------------------------------
		ALIGN	4

EDisable_UnUsed_Shadow	Proc	Near

		mov	bx, 4			;assume shadow unit=16k
		mov	eax, 0000000Fh		;each time 16K
		F000_CALL Ct_Shadow_Unit	;check chipset shadow unit
		cmp	cx, 4000h		;really 16k unit?
		je	@F			;yes, go on
		mov	bx, 8			;set shadow unit=32k
		mov	eax, 000000FFh		;each time 32K
	@@:

		mov	cx, bx
		mov	dx, 0C800h		;starting from C800h
		mov	di, offset Shadow_Items

	Keep_Disable_Shadow:

ifdef	CT_SHADOW_RW_HOOK_SUPPORT
		test	LMEM_RESERVED[bp], eax	;reserved by others?
		jnz	@f
endif	;USB_SUPPORT

		test	LMEM_RESOURCE[bp], eax	;this segment used?
		jz	Dis_It			;no, disable shadow

		test	LMEM_BEFORE_ROM[bp], eax;this segment originally
						;  available for PCI?
		jz	@F			;ZF = available & is
						;      used up by PCI ROM
						;so, let it stay shadowed

		or	si, si			;should check setup setting?
		jz	Dis_It			;no need, go ahead disable

		call	Chk_Setup_Shdw_Setting	;setup set shadow?
		jnz	@F			;yes, do not disable

	Dis_It:

		cmp	dx, 0D000h
		jae	No_Check_VGA_BIOS
		mov	bl, 60h
		call	Query_VGA_Size
		ja	@f
		cmp	dx, 0CC00h
		jae	No_Check_VGA_BIOS
		mov	bl, 40h
		call	Query_VGA_Size
		ja	@f

	No_Check_VGA_BIOS:

		pushad
		F000_CALL Ct_Disable_Shadow
		popad
	@@:
		shr	cx, 1
		add	di, cx
		shl	cx, 1

		add	dh, cl			;point to next shadow unit
		shl	eax, cl

		test	eax, 0FF000000h
		jz	Keep_Disable_Shadow

		ret

EDisable_UnUsed_Shadow	Endp

Chk_Setup_Shdw_Setting	Proc	Near

		pushad
		mov	si, cs:[di]
		call	F000_GetItem_Value
		or	al, al
		popad
		ret

Chk_Setup_Shdw_Setting	Endp

;[]================================================================[]
;[]================================================================[]
Init_ROM	Proc	Near

		PUSH_ALL
		mov	ah, CURRENT_BUS_NO[bp]		;bus number
		mov	al, ch				;device & func number
		mov	word ptr ds:[0], 3
		mov	ds:[2], es

	;------------------------------------------------------------
	;save the original ROM size in BX & push it into stack
	;------------------------------------------------------------

		movzx	bx, byte ptr es:[2]		;ROM size in 512K unit
		shl	bx, 9				;in terms of byte
		push	bx				;save ROM size
		push	es				;save ES

		call	dword ptr ds:[0]

	;------------------------------------------------------------
	;1. restore the original ROM size
	;2. compare with the new ROM size
	;3. if (NEW_SIZE < OLD_SIZE) clear the rest of the shadow RAM
	;------------------------------------------------------------

		pop	es
		pop	bx			;original size in BX
		movzx	di, byte ptr es:[2]	;new size in CX
		shl	di, 9			;in terms of byte
						;DI=starting addr. to clear
		sub	bx, di			;diff. in BX
		jbe	@F			;if no diff then skip
		mov	cx, bx			;no. of bytes in CX
		mov	al, 0ffh		;PATTERN=0FFh
		cld
		rep	stosb
	@@:
		POP_ALL
		ret

Init_ROM	Endp

;-------------------------------------------------------------------------
;Input	:	CH = device & function number
;
;Output	:	CF : no ROM is needed
;		     reg. 30h set to 0
;		NC : ROM needed
;		     EAX = value of register 30h
;-------------------------------------------------------------------------
		ALIGN	4
Check_If_ROM_Needed	Proc	Near

		call	F000_Get_Device_ID  		;device ID in AX
		mov	CURRENT_DEVICE_ID[bp], ax

		call	F000_Get_Vendor_ID		;retrieve vendor ID
		mov	CURRENT_VENDOR_ID[bp], ax
		jc	No_ROM_Needed			;skip

;R16		call	Chk_If_Class_VGA  		;is it a VGA card?
;R16 - starts
		mov	cl, 0AH				;get class code
		call	F000_Get_CfgSpace_Word		;get class code
		mov	CURRENT_CLASS_CODE[bp], ax
		call	Chk_If_Class_VGA_1
;R16 - ends
		je	No_ROM_Needed			;yes, skip!

;R13A start
ifdef	lan_boot_support
		mov	ax,CURRENT_CLASS_CODE[bp]	
		cmp	ah,02h				;is it a LAN card?
		jne	short not_lan_card		;No, skip!

		mov	si,offset LanBoot_Item
		call	F000_GetItem_Value
		or	al,al				;Lan boot disabled ?
		jz	No_ROM_Needed			;don't assign if disabled
not_lan_card:
endif	;lan_boot_support
;R13A end

		mov	cl, 04h				;if command word=0
		call	F000_Get_CfgSpace_Word		; it means this cfg
		or	ax, ax				; space has been
		jz	No_ROM_Needed			; killed in POST 0Bh
		or	al, 07H				;enable MEM, I/O
		call	Check_Master_Needed		;enable master or not?
		jnc	@F
		and	al, not 04h
	@@:
		call	F000_Set_CfgSpace_Word

		mov	cl, 30h				;Expansion. ROM Base Addr. reg.
		call	F000_Get_CfgSpace_Dword

ifdef	Combined_Other_PCI_ROM
		mov	byte ptr COMBINED_PCI_ROM_NEED[bp], 0
		F000_CALL Ct_If_Combined_ROM_Needed	;does this device have
							;a Combined ROM ?
		jne	No_Need_Combined_ROM		;no need !

		mov	eax, 0FFFF0001h
		mov	byte ptr COMBINED_PCI_ROM_NEED[bp], 0AAH

No_Need_Combined_ROM:
endif	;Combined_Other_PCI_ROM

;R13 start
;R13A	ifdef	lan_boot_support
;R13A			mov	byte ptr LAN_ROM_NEED[bp],0
;R13A	
;R13A			mov	edx, LAN_CARD_ID[bp]
;R13A			cmp	dword ptr CURRENT_DEVICE_ID[bp], edx	;LAN card?
;R13A			jne	short No_Need_LAN_ROM			;yes!
;R13A	
;R13A			mov	eax,0FFFF0001h
;R13A			mov	byte ptr LAN_ROM_NEED[bp],0AAH
;R13A	No_Need_LAN_ROM:
;R13A	endif	;lan_boot_support
;R13 end

		call	Force_ROM_For_Some_Devices

;The value read is 0fffffffeh after writing -1 to 960RP expansion ROM
;base register.
		cmp	ax, 0ffffh			;invalid value
;R11		je	No_RomRequired
		je	No_ROM_Needed			;R11
		or	eax, eax			;non-zero value
;R11		jz	No_RomRequired
		jz	No_ROM_Needed			;R11
		or	al, 01H				;ROM needed
No_RomRequired:

		test	al, 01h				;Need PCI ROM?
		jz	No_ROM_Needed			;no, skip!
RomNeeded:
		clc
		ret
No_ROM_Needed:
		stc
		ret

Check_If_ROM_Needed	Endp

Seek_PCI_CbROM_1	Proc	Near
		mov	dword ptr CBROM_BUF_START[bp], 200030h	;PCI device ROM Index start add
		mov	dword ptr CBROM_BUF_END[bp], 200100h	;PCI device ROM Index end add
		call	Seek_PCI_CbROM				;find pci device rom from decompress pool
		cmp	dword ptr PCI_CBROM_ADDR[bp], 0
		ret
Seek_PCI_CbROM_1	Endp

		public	Seek_PCI_CbROM
Seek_PCI_CbROM	Proc	Near				;find pci rom

		pushf
		pushad

		cli
		call	E000_A20_On

		mov	edi, CBROM_BUF_START[bp]
		mov	dword ptr PCI_CBROM_ADDR[bp], 0
		call	E000_Enter_Prot_mode
		call	E000_Back_Real_Mode

	Seek_Next_CbROM:

		mov	ax, ds:[edi]			;AX = ROM's vendor ID
		cmp	ax, CURRENT_VENDOR_ID[bp]	;vendor ID matched ?
		jne	ID_Not_Match			;no !
;R03 - starts
		cmp	byte ptr NCR_810_FOUND[bp], INVOKE_NCR_CBROM
							;Seeking NCR ROM ?
		je	ID_Match			;yes! No need to 
							;check device ID
;R03 - ends
		mov	ax, ds:[edi+2]			;AX = ROM's device ID
;R14		cmp	ax, CURRENT_DEVICE_ID[bp]	;both IDs matched ?
;R14 - starts
		mov	dx, CURRENT_DEVICE_ID[bp]
		cmp	ax, 0078h
		jne	@F
		xor	dh, dh
	@@:
		cmp	dx, ax
;R14 - ends
		je	ID_Match			;yes !

	ID_Not_Match:

		add	edi, 8
		cmp	edi, CBROM_BUF_END[bp]
		jb	Seek_Next_CbROM
		jmp	Seek_PCI_CbROM_End

	ID_Match:

		mov	eax, ds:[edi+4]
		mov	PCI_CBROM_ADDR[bp], eax		;compress start

	Seek_PCI_CbROM_End:

		call	E000_A20_Off
		popad
		popf
		ret

Seek_PCI_CbROM	Endp

Force_ROM_For_Some_Devices	Proc	Near

		cmp	dword ptr CURRENT_DEVICE_ID[bp], \
			(ADAPTEC_VENDOR_ID shl 16) + DEVICE_AHA7850
		jne	Force_ROM_Exit

	Set_ROM_Needed:

		mov	eax, 0FFFF0001h

	Force_ROM_Exit:

		ret

Force_ROM_For_Some_Devices	Endp

;[]================================================================[]
;[]================================================================[]
		ALIGN	4
Non_PCI_Compliance_ROM	Proc	Near

		xor	bx, bx
		mov	byte ptr CURRENT_BUS_NO[bp], 0	;from bus 0

NextBusNonComplianceROM:

		push	bx
		call	Prepare_PCI_Device_No
		pop	bx

		mov	ch, START_PCI_DEV[BP] 		;starting function

	Next_ROM_Func:

		push	cx

		call	Check_If_ROM_Needed  		;ROM needed?
		jc	No_ROM_Func			;no, skip

	;-------------------------------------------------------
	;if A20 to A31 = 1 (i.e. image can be mapped to hi addr)
	;   then skip
	;-------------------------------------------------------

		test	eax, 0FFF00000h			;Map to High addr.?
		jnz	No_ROM_Func			;yes, skip

	;---------------------------------------
	;check if any low addr. available
	;  according to image size in offset 02h
	;---------------------------------------

		push	cx				;save CX
		shr	eax, 12				;ROM size
		not	al				;  in terms of 4K
		inc	al				;  in terms of 4K
		mov	cl, al				;  in terms of 4K
		call	EGet_Available_LMEM 		;request low mem
		pop	cx				;restore CX
		jc	No_ROM_Func			;no low addr. is
							; avaiable
	;---------------------------------------
	;enable this ROM and map it to low addr.
	;---------------------------------------

		mov	eax, AVAIL_LMEM_ADDR[bp]
		mov	cl, 30h
		or	al, 1
		call	F000_Set_CfgSpace_Dword

	;--------------------------------------------------------
	;1. copy ROM image from ROM area to 3000:0 - 4000:0
	;      e.g if ROM map to C800:0 then copy it into 3800:0
	;
	;2. keep record of the image
	;	- destination segment
	;	- device & function number
	;--------------------------------------------------------

		push	1000h
		pop	ds
		add	bx, 8

		mov	esi, eax
		shr	esi, 4
		mov	ds:[bx], si		;destination ROM address
		mov	di, si
		sub	di, (0C000h-1000h)
		mov	ds:[bx+2], di		;source temp address
		mov	ds:[bx+4], ch		;device & function no.

		xor	al, al
		call	ECopy_ROM

	No_ROM_Func:

		pop	cx				;restore slot ID

		call	Disable_PCI_ROM

		call	Get_Next_Device	 		;CH=next device
		jnc	Next_ROM_Func

		call	Get_Next_Bus
		jbe	NextBusNonComplianceROM

;---------------------------------------------------

		clc
		or	bx, bx
		jz	@F

		push	bx
		call	Shadow_C8_To_DF
		call	Dis_Shadow_Not_Avail
		pop	bx

	Init_Next_Low_ROM:

		push	1000h
		pop	ds
		mov	di, ds:[bx]
		mov	si, ds:[bx+2]
		mov	ch, ds:[bx+4]			;device & func number
		xor	al, al
		call	ECopy_ROM

		call	Init_ROM	      		;call this ROM

		sub	bx, 8
		jnz	Init_Next_Low_ROM
		stc
	@@:
		ret

Non_PCI_Compliance_ROM	Endp

;[]================================================================[]
;[]================================================================[]
		ALIGN	4
PCI_Compliance_ROM	Proc	Near

		mov	byte ptr CURRENT_BUS_NO[bp], 0	;from bus 0

NextBusComplianceROM:

		call	Prepare_PCI_Device_No

		mov	ch, START_PCI_DEV[BP] 		;starting function

;------------------------------------------------------------

	Next_Compliance_ROM:

		push	cx				;save slot ID

	;---------------------------------
	;To see if this Cfg space need ROM
	;---------------------------------

		call	Check_If_ROM_Needed
		jc	End_This_ROM_Func		;no, skip!

	;---------------------------------
	;if A20 to A31 = 0 then skip
	;---------------------------------

		test	eax, 0FFF00000h
		jz	End_This_ROM_Func

	;--------------------------------------------
	;search for a valid image & copy it to 3000:0
	;--------------------------------------------

		mov	dword ptr PCI_CBROM_ADDR[bp], 0
		call	Find_PCI_ROM_Image
		jnc	_ROM_Found

		call	Check_If_NCR_SCSI
		jnc	End_This_ROM_Func
		call	Seek_PCI_CbROM_1
		je	End_This_ROM_Func
		call	Find_PCI_ROM_Image
		jc	End_This_ROM_Func			;CF: no image found

	_ROM_Found:

		call	Invoke_PCI_ROM

	End_This_ROM_Func:

		pop	cx				;restore slot ID

		call	Disable_PCI_ROM

		call	Get_Next_Device	   		;CH=next device
		jnc	Next_Compliance_ROM

		call	Get_Next_Bus
		jbe	NextBusComplianceROM

;------------------------------------------------------------

		ret

PCI_Compliance_ROM	Endp

Invoke_PCI_ROM	Proc	Near

	;--------------------------------------------
	;Now the valid image is copied into 3000:0
	;  find low memory resource for this image
	;  according to byte 2 (init size)
	;--------------------------------------------

		mov	ax, 3000h
		push	dword ptr LMEM_RESOURCE[bp]
		call	Request_LMEM_For_ROM
		pop	dword ptr LMEM_RESOURCE[bp]
		jc	Invoke_PCI_ROM_End			;CF: no LMEM available!

		call	Check_If_NCR_SCSI
		jc	_GG_
		mov	byte ptr NCR_810_FOUND[bp], 0
	_GG_:

	;------------------------------------
	;copy image from 3000:0 to shadow RAM
	;------------------------------------

		mov	si, 3000h
		mov	edi, AVAIL_LMEM_ADDR[bp]
		shr	edi, 4
		xor	al, al
		call	ECopy_ROM

		call	Init_ROM	 		;call this ROM

	;--------------------------------
	;update the LMEM_RESOURCE[bp]
	;  according to the run time size
	;--------------------------------

		mov	eax, AVAIL_LMEM_ADDR[bp]
		mov	TARGET_AVAIL_LMEM[bp], eax
		shr	eax, 4
		call	Recalibrate_LMEM_For_ROM

	Invoke_PCI_ROM_End:

		ret

Invoke_PCI_ROM	Endp

		Public	Check_If_NCR_SCSI
Check_If_NCR_SCSI	Proc	Near

		pusha

		cmp	word ptr CURRENT_VENDOR_ID[bp]\
			, NCR_VENDOR_ID			;NCR vendor ID?
		jne	Its_Not_NCR_Device		;no, skip

		cmp	word ptr CURRENT_DEVICE_ID[bp]\
			, DEVICE_NCR860			;NCR/860 ?
		je	@F				;yes !

		cmp	word ptr CURRENT_DEVICE_ID[bp]\
			, DEVICE_NCR810			;NCR 810 ?
		je	@F				;yes !

		call	Check_If_Class_SCSI		;SCSI ?
		je	@F				;yes !

	Its_Not_NCR_Device:

		stc
	@@:
		popa

		ret

Check_If_NCR_SCSI	Endp

;[]================================================================[]
;Details:
;
;    1. In the early stage of POST, the combined NCR810 ROM was copied
;	onto temporary RAM at location 0:8000 & 7000:0
;    2. If NCR810 device is not found, goto 4
;	If the image is not valid(checksum fail or no AA55) goto 4
;    3. Copy one of the two images into shadow RAM
;       Invoke that ROM
;	set flag: NCR_810_FOUND[bp]
;	goto 6
;    4. Clear flag: NCR_810_FOUND[bp] --> no NCR SCSI ROM has been invoked
;    5. End
;
;[]================================================================[]
Init_NCR810_ROM	Proc	Near

		cmp	byte ptr NCR_810_FOUND[bp], NCR_SCSI_FOUND
		jne	No_NCR_ROM			;NCR not exist !

;R03		mov	dword ptr CURRENT_DEVICE_ID[bp], \
;R03			NCR_VENDOR_ID shl 16

		mov	byte ptr NCR_810_FOUND[bp], INVOKE_NCR_CBROM	;R03
		mov	word ptr CURRENT_VENDOR_ID[bp], NCR_VENDOR_ID	;R03
		call	Seek_PCI_CbROM_1
		je	No_NCR_ROM

;R03		mov	byte ptr NCR_810_FOUND[bp], INVOKE_NCR_CBROM
		call	Find_PCI_ROM_Image
		jc	No_NCR_ROM

		call	Invoke_PCI_ROM

	ifdef	PNP_BIOS
		mov	edi, AVAIL_LMEM_ADDR[bp]	;EDI: available shadow RAM
		call	Build_OnboardRomNode
	endif;	PNP_BIOS

	No_NCR_ROM:

		ret

Init_NCR810_ROM	Endp

;[]============================================================[]
;Input	:	CL = Request Memory spaces with size = CL * 4K
;		     e.g. CL = 1 --> request 4K bytes
;
;Output	:	AL = 1 --> NC : AVAIL_LMEM_ADDR[bp] = availbale address
;			   CF : No address available
;[]============================================================[]
		ALIGN	4
		ASSUME	DS:NOTHING
		Public	EGet_Available_LMEM
EGet_Available_LMEM	Proc	Near

		push	ds
		push	es
		pushad

		mov	bl, LMEM_FOR_ROM_FLG[bp]

		or	cl, cl
		jz	No_LMem
		cmp	cl, 24
		ja	No_LMem

		mov	eax, 1
		shl	eax, cl
		dec	eax

		or	bl, bl
		jz	Find_LMem
		mov	cl, 1

	Find_LMem:

		test	dword ptr LMEM_RESOURCE[bp], eax
		jz	LMem_Available

IF	RELEASE_E000_FOR_PCI
;----------------------------------------------------------------------
;if it is a request for initialization of ROM, we shoud also take
;E0000-E7FFF into consideration
;----------------------------------------------------------------------
		or	bl, bl
 		jz	@F
 		shl	eax, cl
 		jnc	Find_LMem
 		jmp	No_LMem
 	@@:
ENDIF	;RELEASE_E000_FOR_PCI

		shl	eax, cl
		test	eax, 0FF000000h
		jz	Find_LMem

	No_LMem:

		stc
		jmp	Shadow_RAM_Manager_Exit

	LMem_Available:

		mov	edx, eax
		push	eax
		mov	dword ptr AVAIL_LMEM_ADDR[bp], 0C8000h
	@@:
		shr	eax, 1
		jc	@F
		add	dword ptr AVAIL_LMEM_ADDR[bp], 1000h
		jmp	@B
	@@:
		pop	eax

;-----------------------------------------------------------------
;if it is a request for run time ROM, we have to return the same
;addr as its was assigned when last time the device request for
;addr. for initialization
;-----------------------------------------------------------------

		cmp	bl, 2				;request for run
							;  time ROM ?
		jne	Not_Recal_Lmem			;no, skip
		push	eax
		mov	eax, AVAIL_LMEM_ADDR[bp]	;target addr reached?
		cmp	eax, TARGET_AVAIL_LMEM[bp]	;target addr reached?
		pop	eax
		je	Not_Recal_Lmem			;yes, leave !
		shl	eax, cl				;esle, point to next
		jmp	Find_LMem			;4K and try again

	Not_Recal_Lmem:

		or	LMEM_RESOURCE[bp], edx		;update resource

		clc

Shadow_RAM_Manager_Exit:

		popad
		pop	es
		pop	ds

		ret

EGet_Available_LMEM	Endp

;-----------------------------------------------------------------
;-----------------------------------------------------------------
Prepare_PCI_Device_No	Proc	Near

		pushad
		push	ds

		call	Check_If_Bus_0
		mov	ax, 1000h
		jne	@F

		F000_CALL Ct_PCI_Info
	@@:
		shl	al, 3			;from first device func 0
		shl	ah, 3
		or	ah, 07h			;to last device func 7
		mov	START_PCI_DEV[BP], al
		mov	END_PCI_DEV[BP], ah

		pop	ds
		popad
		ret

Prepare_PCI_Device_No	Endp

;---------------------------------------------------------------------------
;
;		copy ROM image from SI:0 --> DI:0
;
;Input	:	SI = source segment
;		DI = Destination segment
;		AL <> 0 : copy size depends on ROM size in SI:2
;		   == 1 : copy size = input CX (no. of 4K)
;
;---------------------------------------------------------------------------
		ALIGN	4
		Public	ECopy_ROM
ECopy_ROM	Proc	Near

		push	cx

		push	si
		pop	ds
		push	di
		pop	es

	;----------------------------------------------
	;calculate CX = number of 4K codes to be copied
	;----------------------------------------------

		or	al, al
		jnz	@F

		xor	ch, ch
		call	Rom_In_Terms_of_4K
	@@:

	;------------------------------------------------
	;each time copy 4K codes until all codes finished
	;------------------------------------------------

		push	ds
		push	es

	Copy_ROM_Init_Code:

		push	cx			;copying:
		mov	cx, 400h		;each time 4k
		xor	si, si
		xor	di, di
		cld
		rep	movsd

		mov	ax, ds			;DS:
		add	ah, 01h			; point to next 4K
		mov	ds, ax			; point to next 4K

		mov	ax, es			;ES:
		add	ah, 01h			; point to next 4K
		mov	es, ax			; point to next 4K

		pop	cx
		loop	Copy_ROM_Init_Code

		pop	es
		pop	ds

	;-------------------------------------------

		pop	cx
		ret

ECopy_ROM	Endp

;-------------------------------------------------------------------
;Output	:	1. CURRENT_BUS_NO[bp] = CURRENT_BUS_NO[bp] + 1
;		   AL = CURRENT_BUS_NO[bp]
;		2. If NC & NZ(i.e. JBE), maximum Bus No. reached
;-------------------------------------------------------------------
		Public	Get_Next_Bus
Get_Next_Bus	Proc	Near

		mov	al, byte ptr CURRENT_BUS_NO[bp]
		inc	al
		mov	byte ptr CURRENT_BUS_NO[bp], al
		cmp	al, byte ptr TOTAL_BUS_NO[bp]
		ret

Get_Next_Bus	Endp

;[]================================================================[]
;Get_Next_Device:
;	This routine is used to get next device no to treat
;Input	:	CH - Slot identification Number
;Output :	NC : CH - Next Slot ID numbuer
;		CF : All slot & function spaces has scanned
;[]================================================================[]
		ALIGN	4
		Public	Get_Next_Device
Get_Next_Device	proc	near

		test	ch, 07h			;alread a multi-function space?
		jnz	@F			;yes, go point to next function

		mov	cl, 0Eh			;read header type
		call	F000_Get_CfgSpace_Byte	;read header type
		cmp	al, 0FFh
		je	Func0_No_Dev
		test	al, 80H			;multi-function support?
		jnz	@F			;yes, multi-function card!

	Func0_No_Dev:

		add	ch, 7			;point to next device!
	@@:
		add	ch, 1			;point to next function space
		jc	@F			;already overflow!
		cmp	ch, END_PCI_DEV[BP]	;exceed maximum device?
		ja	@F			;yes, tell caller error!

		clc				;success return
		ret
	@@:
		stc				;error return
		ret

Get_Next_Device	endp

;[]==============================================================[]
;[]==============================================================[]
		Public	If_MultiFunc_Dev
If_MultiFunc_Dev	Proc	Near

		test	ch, 07h			;alread a multi-function space?
		jnz	Is_MultiFunc_Card	;yes, go point to next function

		mov	cl, 0Eh			;read header type
		call	F000_Get_CfgSpace_Byte	;read header type
		test	al, 80H			;multi-function support?
		jz	Not_MultiFunc_Card	;multi-function not supported!

Is_MultiFunc_Card:

		inc	ch
		test	ch, 07h
		jz	End_Of_MultiFunc
		clc
		ret

End_Of_MultiFunc:
Not_MultiFunc_Card:

		stc
		ret

If_MultiFunc_Dev	Endp

;----------------------------------------------------------------------
;Function : Reserve a IRQ for PCI boot device to sure system can boot
;	    from boot device ( like SCSI etc..)
;Input    : none
;Output   : none
;----------------------------------------------------------------------
		public	Reserve_Irq_For_PciBootDev
Reserve_Irq_For_PciBootDev	proc	near

		call	fProc_Reserve_Irq_For_PciBootDev	;R04
		ret						;R04
;R04
;R04	The origingal code was moved to XGROUP
;R04

Reserve_Irq_For_PciBootDev	endp

;R04 ifdef	NEW_PNP_SETUP
;R04 ifdef	IRQ_FOR_BOOTDEV
;R04 BooDev_ClsCode:
;R04 		dd	010000H			;SCSI
;R04 		dd	010400H			;RAID
;R04 		dd	018000H			;other mass storage controller
;R04 		dd	0			;end of table
;R04 endif;	IRQ_FOR_BOOTDEV
;R04 endif;	NEW_PNP_SETUP

;[]================================================================[]
;Check_Master_Needed:
;	This routine is used to check enable master or not.
;	Because some card cannot enable master.
;Output :	NC : enable master
;		CF : disable master
;[]================================================================[]
		ALIGN	4
		Public	Check_Master_Needed
Check_Master_Needed	proc	near

		pushad
		xor	cl, cl			;read vendor & device ID
		call	F000_Get_CfgSpace_Dword

	ifdef	Disable_AMD2000_Master
		cmp	eax, 20001022h		;Is AMD LAN card exist?
		je	No_Need_Master		;yes !
	endif;	Disable_AMD2000_Master
		cmp	eax, 23011005h		;Advance 2301 VGA?
		je	No_Need_Master		;yes !

		popad
		clc				;master bit can be enabled!
		ret

	No_Need_Master:

		popad
		stc				;master bit cannot be enabled!
		ret

Check_Master_Needed	endp

;[]==============================================================[]
;[]==============================================================[]
		Public	Chk_If_Class_VGA
Chk_If_Class_VGA	Proc	Near

		xor	cl, cl			;vendor ID
		call	F000_Get_CfgSpace_Word
		or	ax, ax			;invalid ID
		mov	ax, -1
		jnz	Not_Invalid
		or	ax, ax
		jmp	@F
Not_Invalid:

		push	cx
		mov	cl, 0AH			;Class Code
		call	F000_Get_CfgSpace_Word
		pop	cx

ifdef	Cardbus_support
		cmp	ax, 0607h		;check is cardbus?
		jne	Not_Cardbus
		cmp	cx, Cardbus_SlotID[bp]	;check had init or not
		je	Not_Cardbus		;had init?
		call	Cardbus_Init
Not_Cardbus:
endif	;Cardbus_support

		Public	Chk_If_Class_VGA_1
Chk_If_Class_VGA_1	Label	Near

		cmp	ax, 0300H		;VGA ?
		je	@F			;yes
		cmp	ax, 0301H		;XGA ?

		je	@F			;yes, go initial it!
		cmp	ax, ALT_CLASS_VGA	;alternative VGA type?
	@@:
		ret

Chk_If_Class_VGA	Endp

;[]==============================================================[]
;[]==============================================================[]
		Public	Check_If_Class_SCSI
Check_If_Class_SCSI	Proc	Near

		call	Chk_If_Class_VGA
		cmp	ax, CLASS_SCSI
		ret

Check_If_Class_SCSI	Endp

;======================================================================
;Input	:	EDI = ROM locations
;
;		      e.g. EDI=(7000h shl 16) + 0800h
;			   means ther are 2 images, one at 0:8000h
;			   the other at 7000:0
;
;Output :	CF = ROM Invalid by one of the following reasons:
;
;		     1.	ROM checksum error
;		     2. No 55AAH
;
;		NC = ROM valid
;
;		SI = SEG of ROM location (0800h or 7000h)
;======================================================================
		Public	Find_Valid_ROM_Image
Find_Valid_ROM_Image	Proc	Near

		mov	cx, 2

	Try_Next_SCSI_Image:

		push	cx
		mov	si, di
		call	Cksm_ROM		;check if image valid
		pop	cx

ifndef	NO_CKSUM_FOR_CBROM
	ifndef	ONBOARD_ScsiChip
		jnz	@F			;no image available
	endif;	ONBOARD_ScsiChip
endif;	NO_CKSUM_FOR_CBROM

		cmp	word ptr ds:[0], 0AA55h	;valid ROM image?
		je	SCSI_ROM_Valid	;yes, valid
	@@:
		shr	edi, 16
		loop	Try_Next_SCSI_Image

	SCSI_ROM_Invalid:

		stc
		ret

	SCSI_ROM_Valid:

		clc
		ret

Find_Valid_ROM_Image	Endp

;[]=======================================================[]
;Input	:	SI = segment location of a ROM image
;Output	:	ZF - checksum good
;		NZ - checksum bad
;[]=======================================================[]
		Public	Cksm_ROM
Cksm_ROM	Proc	Near

		push	si
		push	bx
		push	cx

		mov	ds, si
		xor	bl, bl
		xor	si, si

		mov	cl, ds:[2]
		xor	ch, ch
		shl	cx, 9
	@@:
		lodsb
		add	bl, al
		loop	@B
		or	bl, bl			;image valid ?

		pop	cx
		pop	bx
		pop	si
		ret

Cksm_ROM	Endp

;===========================================================
;Input	:	None
;Output	:	CF - no ROM image found
;		NC - ROM image found and is copied to 3000:0
;===========================================================
		ALIGN	4
		Public	Find_PCI_ROM_Image
Find_PCI_ROM_Image	Proc	Near

		cli
		push	ebx
		push	cx

		xor	esi, esi
		xchg	esi, PCI_CBROM_ADDR[bp]
		or	esi, esi
		jnz	EnterProtectMode

ifdef	Combined_Other_PCI_ROM
		cmp	byte ptr COMBINED_PCI_ROM_NEED[bp], 0AAH
		mov	byte ptr COMBINED_PCI_ROM_NEED[bp], 0
		jne	NoCombineROM
		F000_CALL Ct_If_Combined_ROM_Needed	;EDI=image location
		push	cx
		call	Find_Valid_ROM_Image		;any of them valid?
		pop	cx
		jc	NoCombineROM			;none of them valid !
		movzx	esi, si
		shl	esi, 4				;location at 32bit
		jmp	EnterProtectMode		;   address

	NoCombineROM:
endif	;Combined_Other_PCI_ROM

;R13 start
;R13A	ifdef	lan_boot_support
;R13A			cmp	byte ptr LAN_ROM_NEED[bp], 0AAH	;need lan card rom
;R13A			mov	byte ptr LAN_ROM_NEED[bp], 0
;R13A			jne	short Nolanrom			;yes!
;R13A	
;R13A			push	cx
;R13A			mov	di,(8+1)*4
;R13A			call	post_decompress			;decompres lan rom
;R13A			pop	cx
;R13A			jc	short Nolanrom
;R13A			mov	esi,40000h			;rom at 4000:0
;R13A			jmp	EnterProtectMode
;R13A	Nolanrom:
;R13A	endif	;lan_boot_support
;R13 end

		mov	cl, 30h				;ROM addr. reg.
		call	F000_Get_CfgSpace_Dword		;write register
		or	eax, eax
		jz	No_Image_Exist
		mov	esi, eax
		or	al, 1
		call	F000_Set_CfgSpace_Dword		;write register

	EnterProtectMode:

		push	cx

	ifdef	PCI_LAN_PATCH
	;--------------------------------------------------------------
	;disable I/O & memory space for PCI/LAN chip to prevent
	;system hang while warm booting without PCI reset
	;--------------------------------------------------------------
		mov	cl, 0bh				;get class code
		call	F000_Get_CfgSpace_Byte
		cmp	al, 02H				;LAN chip ?
		jne	Not_LanChip
		mov	cl, 4
		call	F000_Get_CfgSpace_Byte		;write register
		and	al, NOT 03H			;disable I/O & Mem.
		call	F000_Set_CfgSpace_Byte		;write register
	Not_LanChip:
	endif;	PCI_LAN_PATCH

		xor	cl, cl				;read vendor & device
		call	F000_Get_CfgSpace_Dword		;ID
		mov	ebx, eax			;save in EBX
		pop	cx

	;When capture card (PLX PCI9060SD) plugged, skip!

		cmp	ebx, 906d10b5h			;Is capture card (PLX PCI9060SD)
		je	No_Image_Exist			;Yes, skip!

		call	E000_A20_On
		call	E000_Enter_Prot_mode		;enter protected mode

	Find_Next_Image:

		mov	edi, esi
		xor	eax, eax			;EDI poiny to PCI
		mov	ax, word ptr ds:[esi+18h]	;  data structure
		add	edi, eax			;

		cmp	word ptr ds:[esi], 0AA55h	;correct signature?
		jne	No_Image_Exist			;no, skip this one

	;check valid PCI data structure signature

		cmp	dword ptr ds:[edi], 'RICP'
		jne	Copy_30000h

		cmp	byte ptr NCR_810_FOUND[bp], INVOKE_NCR_CBROM
		je	Copy_30000h

	;check valid Vendor ID

		cmp	word ptr ds:[edi+04h], bx
		jne	Not_Valid_Image

	;check valid Device ID

		mov	eax, ebx
		shr	eax, 16				;get device ID
		cmp	word ptr ds:[edi+06h], 0078h
		jne	@F
		xor	ah, ah
	@@:
		cmp	word ptr ds:[edi+06h], ax
		jne	Not_Valid_Image

	;check valid code type

		cmp	byte ptr ds:[edi+14h], 0
		jne	Not_Valid_Image

	;valid image found, copy to 30000h

	Copy_30000h:

		push	cx
		xor	ecx, ecx
		mov	cl, ds:[esi+2]			;init size

		shl	ecx, 7				;in terms of dword
		mov	edi, 30000h

	;-------------------------------------------------------------
	;if this is a NCR SCSI ROM image, kill 0:8000 to let the
	;ROM be invoked using the PCI standard way !
	;-------------------------------------------------------------

	@@:
		mov	eax, ds:[esi]
		mov	ds:[edi], eax
		add	edi, 4
		add	esi, 4
		loop	@B

	Copy_30000_End:

		pop	cx

		call	E000_Back_Real_Mode
		call	Disable_PCI_ROM

		clc
		jmp	PCI_Image_Exit1

	Not_Valid_Image:

		test	byte ptr ds:[edi+15h], 80h	;last image?
		jnz	No_Image_Exist			;yes

		xor	eax, eax
		mov	ax, word ptr ds:[edi+10h]
		shl	eax, 9				;in terms of bytes
		add	esi, eax
		jmp	Find_Next_Image

	No_Image_Exist:

		stc					;indicates no ROM image

PCI_Image_Exit:

		pushf
		call	E000_Back_Real_Mode
		call	E000_A20_Off
		popf

PCI_Image_Exit1:

		pop	cx

	;------------------------------------------
	;Restore I/O & memory space for LAN chip
	;------------------------------------------
	ifdef	PCI_LAN_PATCH

		pushf
		push	cx
		mov	cl, 0bh			;get class code
		call	F000_Get_CfgSpace_Byte
		cmp	al, 02H			;LAN chip ?
		jne	Not_LanChip1
		mov	cl, 4
		call	F000_Get_CfgSpace_Byte	;write register
 		or	al, 03H			;disable I/O & Mem.
		and	al, NOT 04h		;clear Master bit
		call	F000_Set_CfgSpace_Byte	;write register

	Not_LanChip1:

		pop	cx
		popf

	endif;	PCI_LAN_PATCH

		pop	ebx

		ret

Find_PCI_ROM_Image	Endp

;[]================================================================[]
;Function : Disable memory space for PCI adaptor ROM
;Input    : none
;Output   : none
;[]================================================================[]
		Public	fProc_Disable_PCI_ROM
fProc_Disable_PCI_ROM	Proc	Far
		call	Disable_PCI_ROM
		retf
fProc_Disable_PCI_ROM	Endp
		ALIGN	4
		Public	Disable_PCI_ROM
Disable_PCI_ROM	Proc	Near

		push	eax
		mov	cl, 30h			;Expansion. ROM Base Addr. reg.
		call	F000_Get_CfgSpace_Dword
		and	al, not 01h
		call	F000_Set_CfgSpace_Dword
		pop	eax
		ret

Disable_PCI_ROM	Endp

;[]============================================================[]
;Input	:	CH  - Device number in upper 5 bits
;		      Function number in lower 3 bits
;Output :	EAX - Class Code
;Destroy:	EAX
;[]============================================================[]
		ALIGN	4
		Public	Get_Class_Code
Get_Class_Code	Proc	Near

		push	cx
		mov	cl, 08			;Class Code + Revision ID
		call	F000_Get_CfgSpace_DWord
		pop	cx
		ret

Get_Class_Code	Endp

;[]============================================================[]
;Input	:	CH - Slot identification Number
;Output :	AX - DEVICE ID
;Destroy:	AX
;[]============================================================[]
		ALIGN	4
		ASSUME	DS:NOTHING
		Public	F000_Get_Device_ID
F000_Get_Device_ID	Proc	Near

		F000_CALL Get_Device_ID
		ret

F000_Get_Device_ID	Endp

endif	;PCI_BUS

;[]============================================================[]
;[]============================================================[]
E_GDTR1:					; global descriptor table register
		dw	8*2			; LIMIT
		dw	offset EGROUP:E_GDT1
		dw	0Eh			; in 0E000h segment

E_GDT1:						; null descriptor
		dw	0			; limit
		dw	0			; base
		db	0			; hibase
		db	0			; access
		db	0			; hilimit
		db	0			; msbase

E_DATA1_DT:					; ds - first 64k segment
E_DATA1_INDEX	=	((OFFSET E_DATA1_DT - OFFSET E_GDT1)/8) SHL 3
		dw	0ffffh			; limit
		dw	0			; base data segment points to
		db	0			; hibase	; 00000000
		db	93h			; access
		db	08fh			; hilimit (4GB)
		db	0			; msbase

;==========================================================================
;Function : Enter CPU protected mode in E-segment with 4GB space accessable
;Input    : none
;Output   : DS - point to data descriptor with starting address 0
;==========================================================================
		public	E000_Enter_Prot_mode
E000_Enter_Prot_mode	proc	near

		push	eax

;---------------- Enter Protect Mode ----------------

                mov     ax, cs
                mov     ds, ax

                lgdt    fword ptr ds:E_GDTR1

                mov     eax, cr0
                or      al, 1
                mov     cr0, eax

		jmp	$+2		;clear prefetch

                mov     ax, E_DATA1_INDEX
                mov     ds, ax			; ds = 00000000h

		pop	eax
		ret

E000_Enter_Prot_mode	endp

;======================================================
;Function : Go back to real mode from protected mode
;Input    : none
;Output   : none
;======================================================
		public	E000_Back_Real_Mode
E000_Back_Real_Mode	proc	near

		push	eax
                mov     eax, cr0
                and     al, NOT 1
                mov     cr0, eax
		jmp	$+2		;clear prefetch
		pop	eax
		ret

E000_Back_Real_Mode	endp

;======================================================
;======================================================
		Public	Check_If_Bus_0
Check_If_Bus_0	Proc	Near
		cmp	byte ptr CURRENT_BUS_NO[bp], 0
		ret
Check_If_Bus_0	Endp

ECODE		ENDS

ENDIF	;COMPILE_FOR_E0 EQ 1

IF	COMPILE_FOR_E0 EQ 1
ifdef	PCI_BUS

		extrn	Check_If_Bus_0:near

ifndef	NO_PCI_IDE_2ND_CONTROL
		extrn	Second_IDE_channel:near		;bfeature.asm
endif;	NO_PCI_IDE_2ND_CONTROL
		extrn	F000_Set_Cyrix:near
		extrn	lock_Cyrix:near
		extrn	Unlock_Cyrix:near

		extrn	Pci_Class_Code:near
ifndef	NO_PCI_IDE_CARD
		extrn	PCI_IDE_IRQ:near		;pcifeat.asm
		extrn	First_IDE_INT:near		;pcifeat.asm
		extrn	Second_IDE_INT:near		;pcifeat.asm
endif	;NO_PCI_IDE_CARD
		extrn	PCI_SLOT_CFG:near		;chipset.asm

		extrn	F000_GetItem_Value:near
		extrn	F000_call_proc:near
		extrn	Ct_Special_PCI_Device:Near	;pcichip.asm
		extrn	Ct_Special_Copy_PCI_VGA:near
		extrn	Ct_Set_PciIrq:near		;pcichip.asm
		extrn	Ct_PCI_VGA_IDSEL:near		;pcichip.asm
		extrn	Ct_OnChip_IDE_Chk:near
		extrn	Check_M1_Cpu:near
		extrn	C000_Shadow_RW:near		;chipset.asm
		extrn	C000_Shadow_R:near		;chipset.asm
		extrn	F_C000_Shadow_RW:near
		extrn	F_C000_Shadow_R:near
		extrn	E000_Move_Codes:Near
		extrn	Ct_C8_To_DF_RW:Near
		extrn	Ct_C8_To_DF_R:Near
		extrn	Ct_Disable_Shadow:Near
		extrn	Ct_Shadow_Unit:Near
		extrn	Disable_UnUsed_Shadow:Near
		extrn	AGet_CfgSpace_Byte:near
		extrn	AGet_CfgSpace_Word:near
		extrn	AGet_CfgSpace_Dword:near
		extrn	ASet_CfgSpace_Byte:near
		extrn	ASet_CfgSpace_Word:near
		extrn	ASet_CfgSpace_Dword:near

		extrn	F000_Get_Device_ID:near
		extrn	F000_Get_Vendor_ID:near
		extrn	CHECK_IF_CLASS_SCSI:near
		extrn	CHECK_MASTER_NEEDED:near
		extrn	CHECK_ROM_EXIST:near
		extrn	CHK_IF_CLASS_VGA:near
		extrn	Chk_If_Class_VGA_1:Near
		extrn	CKSM_ROM:near
		extrn	DISABLE_PCI_ROM:near
		extrn	E000_BACK_REAL_MODE:near
		extrn	E000_ENTER_PROT_MODE:near
		extrn	ECOPY_ROM:near
		extrn	EGet_Available_LMEM:near
		extrn	F000_GET_CFGSPACE_BYTE:near
		extrn	F000_GET_CFGSPACE_DWORD:near
		extrn	F000_GET_CFGSPACE_WORD:near
		extrn	F000_SET_CFGSPACE_BYTE:near
		extrn	F000_SET_CFGSPACE_DWORD:near
		extrn	F000_SET_CFGSPACE_WORD:near
		extrn	F000_GET_VENDOR_ID:near
		extrn	GET_CLASS_CODE:near
		extrn	GET_NEXT_BUS:near
		extrn	GET_NEXT_DEVICE:near
		extrn	IF_MULTIFUNC_DEV:near

		extrn	INVALIDATE_SHADOW_SEG:near
		extrn	MARK_ADDR_NOT_AVAILABLE:near
		extrn	ROM_IN_TERMS_OF_4K:near

ifndef	NEW_PNP_SETUP
		extrn	PciIrq_Item:near
endif;	NEW_PNP_SETUP

ifdef	SUPPORT_PCISLOT_IDE
		extrn	Open_8673:near
		extrn	Set_8673:near
endif;	SUPPORT_PCISLOT_IDE

ifdef	PCI_LATENCY_SELECTABLE
		extrn	Pci_Latency_Item:near
endif;	PCI_LATENCY_SELECTABLE

	ifdef	CONFIG_MECHANISM_1
		extrn	Get_Max_PciBus:near
	endif	;CONFIG_MECHANISM_1
		extrn	F000_Shadow_W:Near
		extrn	F000_Shadow_R:Near

		extrn	E000_64k_Shadow_RW:Near
		extrn	E000_64k_Shadow_R:Near
		extrn	Find_Valid_ROM_Image:Near

	ifdef	USB_IRQ_SELECTABLE
		extrn	UsbIrq_Item:near
	endif	;USB_IRQ_SELECTABLE

		extrn	Seek_PCI_CbROM:Near

endif	;PCI_BUS

DGROUP		GROUP	FCODE
FCODE		SEGMENT USE16 PARA PUBLIC 'CODE'
FCODE		ENDS

EGROUP		GROUP	ECODE
ECODE		SEGMENT USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP, DS:G_RAM, ES:EGROUP

ifdef	PCI_BUS
;[]================================================================[]
;Release_Shadow_From_PCI_VGA:
;	This routine is used to check if VGA BIOS has been condensed
;	after VGA BIOS had been initialed. And reprepare LMEM_RESOURCE[bp]
;[]================================================================[]
		ALIGN	4
		public	Release_Shadow_From_PCI_VGA
Release_Shadow_From_PCI_VGA	proc	near

		call	fProc_Release_Shadow_From_PCI_VGA
		ret

Release_Shadow_From_PCI_VGA	endp

;[]================================================================[]
;Before_PciVGARomInit:
;	This routine is used to set PCI/VGA to special state
;	Before VGA/ROM initial
;Input  : none
;Output : none
;[]================================================================[]
		Public		Before_PciVGARomInit
Before_PciVGARomInit	proc	near

		call	fProc_Before_PciVGARomInit
		ret

Before_PciVGARomInit	endp

;[]============================================================[]
;[]============================================================[]
fProc_Find_VGA_ROM_Image	Proc	Far

		push	cx				;R17

		mov	cl, 30h
 		call	F000_Get_CfgSpace_DWord

	Set_VGA_ROM_Addr:

		mov	esi, eax
		or	al, 01h
 		call	F000_Set_CfgSpace_DWord

		call	E000_Enter_Prot_Mode

		cmp	word ptr ds:[esi], 0AA55h	;ROM existed ?
		je	ROM_Exist			;yes

		call	E000_Back_Real_Mode		;No valid VGA ROM

		cmp	esi, 0C0000h			;have we try C0000h
		mov	eax, 0C0000h			;map ROM to C0000h
		jne	Set_VGA_ROM_Addr		;No, try again!

		xor	eax, eax			;R17
 		call	F000_Set_CfgSpace_DWord		;R17

;R07 - starts
		mov	edi, 7000h			;Find a ROM image in
		call	Find_Valid_ROM_Image		;  7000h
		mov	esi, 70000h			;
		jnc	@F				;NC = Valid ROM image
;R07 - ends
		mov	dword ptr CBROM_BUF_START[bp], 200000h	;compress bp start
		mov	dword ptr CBROM_BUF_END[bp], 200030h	;compress bp end
		call	Seek_PCI_CbROM
		mov	esi, PCI_CBROM_ADDR[bp]			;copy vga rom
		or	esi, esi
		jz	No_Video_Rom
	@@:							;R07
		call	E000_Enter_Prot_mode

	ROM_Exist:

	;----------------------------------------------------------------
	;copy VGA BIOS from high MEM into RAM at address 3000:0
	;----------------------------------------------------------------

		mov	edi, 030000h

		mov	cl, ds:[esi+2]
		xor	ch, ch
		shl	cx, 7
	@@:
		mov	eax, ds:[esi]
	ifndef	PCI_RESET_SUPPORT
		mov	ebx, ds:[esi]
		cmp	eax, ebx
		jnz	@B
	endif	;PCI_RESET_SUPPORT
		mov	ds:[edi], eax
		add	edi, 4
		add	esi, 4
		loop	@B

		call	E000_Back_Real_Mode

		pop	cx				;R17
		clc
		retf

	No_Video_Rom:

		pop	cx				;R17
		stc
		retf

fProc_Find_VGA_ROM_Image	Endp

		Public	Move_VGA_BIOS_To_C000
Move_VGA_BIOS_To_C000	Proc	Near
		ret
Move_VGA_BIOS_To_C000	Endp
endif	;PCI_BUS

ECODE		ENDS

ifdef	PCI_BUS
		extrn	fProc_Get_Vendor_ID:far
		extrn	fProc_Get_Device_ID:far
		extrn	fProc_Get_CfgSpace_Byte:far
		extrn	fProc_Get_CfgSpace_Word:far
		extrn	fProc_Get_CfgSpace_Dword:far
		extrn	fProc_Set_CfgSpace_Byte:far
		extrn	fProc_Set_CfgSpace_Word:far
		extrn	fProc_Set_CfgSpace_Dword:far
		extrn	fProc_Disable_PCI_ROM:far
		extrn	post_call_proc:near
		extrn	IrqRout_Table:Near
		extrn	CPU_Cache:near

		extrn	Set_Cyrix:Near
		extrn	Move_Codes:Near

		extrn	Ct_PCI_Info:Near

	ifndef	ALWAYS_LEVEL_PCI_IRQ
		extrn	PCI_IRQ_Method:near		;pcifeat.asm
	endif;	ALWAYS_LEVEL_PCI_IRQ

	ifdef	PCI_VGA_IRQ_SETUP_ITEM
		extrn	Assign_Pci_IRQ_Item:Near
	endif	;PCI_VGA_IRQ_SETUP_ITEM

	ifdef	ONBOARD_ScsiChip
		extrn	Onboard_Scsi_Item:near
	endif	;ONBOARD_ScsiChip

		extrn	fProc_Pci_CbRom_decompress:far
		extrn	Check_If_NCR_SCSI:Near

	ifdef	SCSI_IRQ_TO_336_SIRQ3
		extrn	Set_336_Sirq3:near
	endif;	SCSI_IRQ_TO_336_SIRQ3

	ifdef	M1523B_USB
		extrn	M1523B_USB_Irq:Near
	endif;	M1523B_USB

	ifdef	ITE8330G_USB
		extrn	ITE8330G_USB_Irq:Near
	endif;	ITE8330G_USB

		extrn	PCI_IRQ_RECORD:word		;R12
 		extrn	Get_PCI_IRQ_Record_Lo:word	;R12
 		extrn	Get_PCI_IRQ_Record_Hi:word	;R12

endif	;PCI_BUS

XGROUP		GROUP	XCODE
XCODE		SEGMENT USE16 PARA PUBLIC 'XCODE'
		ASSUME	CS:XGROUP, ES:XGROUP

ifdef	PCI_BUS
		Public	IRQ_REQ_BUF
		Public	IRQ_REQ_BUF_PTR
IRQ_REQ_BUF	db	256 dup (0)
IRQ_REQ_BUF_PTR	dw	offset IRQ_REQ_BUF

;[]================================================================[]
;Function : Scan all PCI devices and assign I/O , memory space and
;	    IRQ for PCI/IDE if required
;Input  : none
;Output : none
;[]================================================================[]
		ALIGN	4
		Public	fProc_Pci_IO_Mem_Init
fProc_Pci_IO_Mem_Init	Proc	Far

		PUSH_ALL

		mov	al, TRUE
		call	X_CPU_Cache

		call	Init_Variables

 		call	Assign_IRQ_For_PCI_IDE

		call	Open_IDE_2nd_Channel			;R05

		call	Scan_MemIO_Req

		call	Record_Max_Bus_No

		call	Determine_Device_Resource

		call	Scan_PCI_VGA

		mov	byte ptr NEED_ASSIGN_LMEM_FLAG[bp], 0AAh
		call	Determine_Device_Resource

		call	Sort_IRQ_Requests

		call	Disable_Slot_IDE

		mov	al, FALSE
		call	X_CPU_Cache

		POP_ALL
		retf

fProc_Pci_IO_Mem_Init	Endp

;[]============================================================[]
;[]============================================================[]
Sort_IRQ_Requests	Proc	Near
		push	ds
		mov	ax, SEG IRQ_REQ_BUF
		mov	ds, ax
		mov	si, offset IRQ_REQ_BUF
		call	Sort_PCI_Request
		pop	ds
		ret
Sort_IRQ_Requests	Endp

;[]================================================================[]
;Input	     :	None
;Description :	To clear all variables needed for the PCI initializations
;[]================================================================[]
Init_Variables	Proc	Near

	xor	eax, eax
	mov	TOTAL_BUS_NO[bp], al	;initial total bus no. = 0
	mov	CURRENT_BUS_NO[bp], al	;initial bus no. = 0
	mov	CURRENT_SLOT[bp], al	;slot no. of host bridge
	mov	VGA_BIOS_LENGTH[bp], al
	mov	PCI_IDE_EXIST[bp], al
	mov	CURRENT_BUS_NO[bp], al
	mov	PCI_VGA_FOUND[bp], al
	mov	NCR_810_FOUND[bp], al
	mov	LMEM_RESOURCE[bp], eax
	mov	PCI_IRQ_ASSIGNED[bp], ax
	mov	NEED_ASSIGN_LMEM_FLAG[bp], al

	call	Prepare_PCI_Bus_Info				;R05

	call	Prepare_LMEM_Resource

	mov	word ptr BASE_REQ_BUF_PTR[bp], offset TEMP_BASE_REQ_BUF
	mov	word ptr PCI_VGA_DEVICE_BUF_PTR[bp], offset PCI_VGA_DEVICE_BUF

	push	SEG TEMP_PCI_REQ_BUF
	pop	ds
	call	Clear_PCI_Req_Buffer

	call	CMOS_Setup_IRQ_Resource

	ret

Init_Variables	Endp

;[]============================================================[]
;Input	:	AL = 0 : Prepare Memory below 1M resources
;Output	:	AL = 0 --> Output None
;[]============================================================[]
		ALIGN	4
Prepare_LMEM_Resource	Proc	Near

		push	ds
		push	es
		pushad

;-----------------------

		mov	si, 0C800h			;scan from C8000h

;Occupied low memory resource if VGA BIOS is bigger than 32kb

	;=====================
	Scan_ROM:

		POST_FUNC_CALL Check_ROM_Exist		;check if ROM existed?
		je	ISA_ROM_Found			;yes, go record	this

							;  seg. as used!
	;=====================
		xor	di, di

	Chk_RW:

ifndef	No_Chk_LMEM_RW
		cmp	dword ptr ds:[di], -1
		jne	Addr_Can_W
	ifdef PROTECH_RAM_DISK_CARD
		push	word ptr ds:[di]
	endif ;PROTECH_RAM_DISK_CARD

		mov	ah, 0A5h
		mov	byte ptr ds:[di], ah		;write pattern
		cmp	byte ptr ds:[di], ah		;read pattern

	ifdef PROTECH_RAM_DISK_CARD
		pop	word ptr ds:[di]
	endif ;PROTECH_RAM_DISK_CARD

		je	Addr_Can_W
endif	;No_Chk_LMEM_RW

		add	di, 4			;next 4 bytes
		cmp	di, 800h
		jb	Chk_RW
		jmp	No_ROM_Here

	Addr_Can_W:

		mov	cl, 1				;mark 4k not available
		call	X_Mark_Addr_Not_Available
		jmp	No_ROM_Here

	;=====================
	ISA_ROM_Found:

		POST_FUNC_CALL Rom_In_Terms_of_4K
		push	cx
		call	X_Mark_Addr_Not_Available	;record it
		pop	cx

		xor	ch, ch				;point to next addr.
		shl	cx, 8				;  according to ROM
		add	si, cx				;  size
		jmp	@F

	No_ROM_Here:

		add	si, 80h				;next 2k to scan
	@@:
	ifdef	SEANIX_SPECIAL_PCIPOST
		out	80h, al
	endif	;SEANIX_SPECIAL_PCIPOST
		cmp	si, 0E000h			;end of address?
		jb	Scan_ROM			;no, continue!

	ifdef	PNP_BIOS
		push	G_RAM
		pop	ds
		assume	DS:G_RAM

		mov	edx, dword ptr ds:UMB_MAP
		not	edx
		shr	edx, 8
		or	dword ptr LMEM_RESOURCE[bp], edx

	endif	;PNP_BIOS

;-----------------------

		call	X_Invalidate_Shadow_Seg	;invalidate whole shadow seg
						;i.e. shadow unit = 16K(32K)
						;     ==> invalidate whole
						;	  16k(32k) even if it
						;	  is not totally used!

 		push	dword ptr LMEM_RESOURCE[bp]
 		pop	dword ptr LMEM_BEFORE_ROM[bp]

		popad
		pop	es
		pop	ds

		ret

Prepare_LMEM_Resource	Endp

;[]================================================================[]
;  Prepare variables for PCI configurations according to Bus No.
;  such as:
;	1. Memory & IO range
;	2. Device No. range
;	3. Temporary ROM address
;[]================================================================[]
Prepare_PCI_Bus_Info	Proc	Near

		pushad
		push	ds
		push	SEG TEMP_PCI_REQ_BUF
		pop	ds

		call	See_If_Bus_0
		je	Bus0_Info

		mov	al, CURRENT_BUS_NO[bp]
		call	Get_Bus_Info_Offset

 		mov	eax, ds:[si].Bus_PfMem_Start
 		mov	AVAILABLE_PREFET_START[bp], eax
		mov	ebx, ds:[si].Bus_IO_Start
		mov	esi, ds:[si].Bus_Mem_Start
		mov	ax, 1000h
		jmp	Update_PCI_Info

;-----------------------------------------------------
;call chipset dependent routine to get informations
;-----------------------------------------------------
Bus0_Info:
		push	ds
		F000_CALL Ct_PCI_Info
		pop	ds

		mov	ebx, ds:[TotalMemReq]
		add	ebx, ds:[TotalPfMemReq]
		cmp	ebx, 18000000h
		jae	@F
		mov	ebx, 18000000h
	@@:
		mov	esi, 0F8000000h
		sub	esi, ebx
		mov	ebx, 0F000h
		sub	ebx, ds:[TotalIOReq]

;-----------------------------------------------------
;write informations into [BP] area
;-----------------------------------------------------
Update_PCI_Info:

		shl	al, 3			;from first device func 0
		shl	ah, 3
		or	ah, 07h			;to  last device func 7
		mov	START_PCI_DEV[BP], al
		mov	END_PCI_DEV[BP], ah

		mov	AVAILABLE_MEM_START[bp], esi
		mov	AVAILABLE_IO_START[bp], ebx
		pop	ds
		popad
		ret

Prepare_PCI_Bus_Info	Endp

;------------------------------------------------------------------
;
;Input	   :	TOTAL_BUS_NO[bp]
;
;Updated   :	Routine: Get_Max_PciBus in F000 will be hard-coded
;
;Destroyed :	DS, BX, DX, EAX, CX
;
;Note	   :	We put the max bus no. info into shadow RAM
;		by hard coding the routine: Get_Max_PciBus
;		which is simply "mov cl, ??'. The machine code of
;		this instruction is "db 0B1h, ??h"
;
;		By calling this routine during run time (PCI1A.ASM
;		& PCI32.ASM), we will get the maximum bus number in CL
;
;------------------------------------------------------------------
Record_Max_Bus_No	Proc	Near

	ifdef	CONFIG_MECHANISM_1
		push	ds
;R12		F000_CALL F000_Shadow_W
		call	X_F000_Shadow_W			;R12
		mov	ax, SEG Get_Max_PciBus
		mov	ds, ax
		mov	si, offset Get_Max_PciBus
		mov	bl, 0B1h
		mov	bh, TOTAL_BUS_NO[bp]
		mov	ds:[si], bx
;R12		F000_CALL F000_Shadow_R
		call	X_F000_Shadow_R			;R12
		pop	ds
	endif	;CONFIG_MECHANISM_1

		ret

Record_Max_Bus_No	Endp

;--------------------------------------------------------------------
;Input	:	CURRENT_BUS_NO[bp] - Bus to be scanned
;
;Description :	To scan & record all base request of all PCI devices
;		on the PCI bus describe by CURRENT_BUS_NO[bp]. We
;		record all the base requests in a buffer in segment
;		TEMP_PCI_REQ_BUF.
;
;		If any one device on the bus is a P2P bridge, this
;		routine will issue a RECURSIVE call to itself. Thus we
;		need a boundary condition such that this recursive
;		mechanism will come to an end.
;		The boundary condition is:
;
;		  --- THERE IS NO P2P BRIDGE DEVICE ON THE BUS ---
;
;		For the stored base requests in TEMP_PCI_REQ_BUF, they
;		are only stored according to the sequence which they
;		are read. We will further analyse these records in the
;		following manner:
;
;		  1. divide these records according to their bus number
;		     (described in the data structure), move them to another
;		     buffer(PCI_REQ_BUF).
;		  2. Sort the base request in PCI_REQ_BUF in a decreasing
;		     order.
;		  3. Assign resource to them
;		  4. repeat step 1-3 until we reach the maximum bus no.
;
;--------------------------------------------------------------------
Scan_MemIO_Req	Proc	Near

		push	ecx

	;----------------------------------------------------------------
	;Clear all P2P devices on current Bus so that every P2P device
	;(if any) can be access correctly
	;----------------------------------------------------------------

		call	Clear_P2P

		call	Prepare_PCI_Bus_Info
		mov	ch, START_PCI_DEV[BP]

	Next_Pci_Dev_On_This_Bus:

		call	Update_Slot_No

		push	cx			;save device & function no.

	;-----------------------------------------------------
	;If (Device needs no resources)
	;	Skip;
	;If (this device is a P2P Bridge)
	;   {
	;	issue a recursive call to itself
	;	"call Scan_MemIO_Req"
	;   }
	;Else
	;   Record the requests of this device into buffer
	;Endif;
	;-----------------------------------------------------

		call	X_Get_Device_ID  		;device ID in AX
		mov	CURRENT_DEVICE_ID[bp], ax
		shl	eax, 16
		call	X_Get_Vendor_ID 		;retrieve vendor ID
		mov	CURRENT_VENDOR_ID[bp], ax
		jc	Device_No_Request		;skip if no vendor ID !
		or	eax, eax
		jz	Device_No_Request

		mov	cl, 0AH				;get class code
		call	X_Get_CfgSpace_Word		;get class code
		mov	CURRENT_CLASS_CODE[bp], ax	;R16
		cmp	ax, 0601H			;PCI-ISA bridge?
		je	Device_No_Request		;skip it
		cmp	ax, CLASS_PP_BRIDGE		;PP bridge ?
		jne	Go_Analyse_Device		;No! Go to record
							; requests
	;-----------------------------------------------------
	;If this device is a P2P Bridge, issue a recursive
	;call to itself "call Scan_MemIO_Req"
	;-----------------------------------------------------

		inc	byte ptr TOTAL_BUS_NO[bp]	;of course we need to
							;increase total bus
							;number by 1
		mov	cl, 18h
		mov	eax, 407F0000h			;assume subordinate=7Fh
		mov	al, CURRENT_BUS_NO[bp]		;set bus number:
		mov	ah, TOTAL_BUS_NO[bp]		;   pri. bus, 2nd bus
							;   & max. sub bus
		call	X_Set_CfgSpace_DWord

		call	Patch_Platform_P2P_Bridge

		mov	al, CURRENT_BUS_NO[bp]
		call	Record_P2P_Info

		push	ax				;save bus number
		push	word ptr START_PCI_DEV[bp]
		mov	al, TOTAL_BUS_NO[bp]
		mov	CURRENT_BUS_NO[bp], al		;new bus number
		call	Scan_MemIO_Req			;issue recursive call
		pop	word ptr START_PCI_DEV[bp]
		pop	ax				;restore bus number

		mov	CURRENT_BUS_NO[bp], al

		mov	cl, 1Ah				;program reg 1Ah
		mov	al, TOTAL_BUS_NO[bp]		;for the maximum
		call	X_Set_CfgSpace_Byte		;subordinate bus number

		jmp	Device_No_Request		;end of this P2P bridge

	;-----------------------------------------------------
	;If this device is normal PCI device,
	;Record the requests of this device into buffer
	;-----------------------------------------------------

	Go_Analyse_Device:

		mov	bl, 08h			;cache line size = 08h
		call	Prg_Device_Latency	;to program the latency timer

		call	Skip_IDE_Base_Request	;special for IDE devices
		jc	Device_No_Request	;skip some IDE vendor

		pusha				;someone may want to skip
		F000_CALL Ct_Special_PCI_Device	; resources for specific device
		popa				; or slot
		jc	Device_No_Request	;CF = skip this device

		call	Check_If_BusTek_Bt946C	;Special for BusLogic's non PCI
						;compliance device exist
		jc	Device_No_Request	;CF = this device found !

		call	Record_NCR_Device	;record if NCR SCSI exist or not
						;stored at NCR_810_FOUND[bp]

		call	Record_IRQ_Request	;record IRQ requests information
						;in TEMP_PCI_REQ_BUF:IRQ_REQ_BUF

		push	ax			;save class code
		mov	cl, 3cH			;Disable IRQ number, some dev
		mov	al, 0ffH		;has a default value
		call	X_Set_CfgSpace_Byte
		pop	ax			;restore class code

		call	X_Disable_PCI_ROM	;disable the ROM

		call	Record_Base_Requests	;record requests
		jc	Device_No_Request	;CF=This device killed

	;enable IO, MEM, Master and clear status

		mov	cl, 04h			;Command Register
		mov	eax, 0F0000007H
		POST_FUNC_CALL Check_Master_Needed	;enable master or not?
		jnc	@F
		and	al, not 04h
	@@:
		call	X_Set_CfgSpace_DWord

	;-----------------------------------------------------

	Device_No_Request:

		pop	cx			;restore device & function no.

		call	X_Get_Next_Device	;CH point to next device
		jnc	Next_Pci_Dev_On_This_Bus;CF = no more device

	This_Bus_End_Here:

		call	Include_Subordinate_Reqests

		pop	ecx

	;--------------------------------------------------------------
	;if we are now in Bus 0, that means we are going to return
	;to caller:fProc_Pci_IO_Mem_Init. We should append a dummy
	;base request to TEMP_PCI_REQ_BUF:TEMP_BASE_REQ_BUF to indicate
	;the end of all base requests
	;--------------------------------------------------------------

		call	See_If_Bus_0
		jne	@F
		mov	dh, 0FFh
		call	Append_Base_Request
	@@:
		ret

Scan_MemIO_Req	Endp

;======================================================================
;
;Update CURRENT_SLOT[bp]
;
;This information is going to be added to the IRQ request buffer
;informations so that we can retrieve the correct IRQ routing
;when assigning IRQs for devices.
;
;Input	:	CURRENT_BUS_NO[bp] = bus number
;		CH 		   = Dev & Func number
;
;Update	:	CURRENT_SLOT[bp] = 1, 2, 3 .... N
;		CURRENT_SLOT[bp] = 0FFh means this ID select or slot
;				   is not defined in the routing table
;
;======================================================================
Update_Slot_No	Proc	Near

	;-------------------------------------------
	;There are 2 cases that we do not need to
	;update the slot number, i.e.
	;
	;	1. when we are not in Bus 0
	;	2. when we are not in Function 0
	;-------------------------------------------

		call	See_If_Bus_0		;in bus 0 ?
		jne	No_Slot_Update		;no, skip update slot number
		test	ch, 00000111b		;in function 0 ?
		jnz	No_Slot_Update		;no, skip update slot number

	;-------------------------------------------
	;Search in table: PCI_SLOT_CFG for entry
	;matches CH & then update the index into
	;CURRENT_SLOT[bp].
	;
	;CURRENT_SLOT[bp] will be set to 0FFh
	;if no entry is found matched.
	;-------------------------------------------

		push	cx
		push	ax
		push	ds

		push	SEG PCI_SLOT_CFG
		pop	ds
		mov	si, offset PCI_SLOT_CFG
		mov	byte ptr CURRENT_SLOT[bp], 0FFh
		xor	ah, ah

		shr	ch, 3

	Search_Next_SLot:

		mov	al, byte ptr ds:[si]
		cmp	al, 0FFh
		je	Slot_Not_Specified
		cmp	al, ch
		je	Slot_Num_Found
		inc	si
		inc	ah
		jmp	Search_Next_SLot

	Slot_Num_Found:

		mov	byte ptr CURRENT_SLOT[bp], ah

	Slot_Not_Specified:

		pop	ds
		pop	ax
		pop	cx

	No_Slot_Update:

		ret

Update_Slot_No	Endp

;======================================================================
;Input	:	CURRENT_BUS_NO[bp] = bus number
;		CH 		   = Dev & Func number
;		BL 		   = Cache Line Size
;======================================================================
Prg_Device_Latency	Proc	Near

		push	ax
	ifdef	PCI_LATENCY_SELECTABLE
		call	Get_Latency_Value
		mov	al, 08H				;cache line = 08H
	else;	PCI_LATENCY_SELECTABLE
		mov	ah, 40h				;latency = 40H
	endif;	PCI_LATENCY_SELECTABLE
		mov	cl, 0cH
		mov	al, bl
		call	X_Set_CfgSpace_Word
		pop	ax
		ret

Prg_Device_Latency	Endp

ifdef	PCI_LATENCY_SELECTABLE
;----------------------------------------------------
;Function : Read latency timer value set by user
;Input    : none
;Output   : AH - latency timer value
;----------------------------------------------------
Get_Latency_Value	proc	near
		push	si
		mov	si, offset Pci_Latency_Item	;get latency value
		call	X_GetItem_Value
		mov	ah, al
		pop	si
		ret
Get_Latency_Value	endp
endif;	PCI_LATENCY_SELECTABLE

;======================================================================
;======================================================================
Record_NCR_Device	Proc	Near

		pusha

;R03	ifdef	ONBOARD_NCR_SETUPABLE
;R03		call	Check_Onboard_SCSI_Slot		;check if onboard slot
;R03		jc	@F
;R03	endif;	ONBOARD_NCR_SETUPABLE

		POST_FUNC_CALL Check_If_NCR_SCSI
		jc	@F

		mov	byte ptr NCR_810_FOUND[bp], NCR_SCSI_FOUND
	@@:
		popa

		ret

Record_NCR_Device	Endp

;======================================================================
;======================================================================
Check_If_BusTek_Bt946C	Proc	Near

	call	See_If_Bus_0
	jne	@F
	cmp	word ptr CURRENT_VENDOR_ID[bp], 104Bh	;Bustek vendor ID?
	jne	@F
	cmp	byte ptr CURRENT_DEVICE_ID[bp+1], 10h	;PCI compliance card?
	jae	@F					;larger than 10h
							;  --> compliance
	call	Prg_BusTek_BT946C
	stc
	ret
@@:
	clc
	ret

Check_If_BusTek_Bt946C	Endp

;======================================================================
;======================================================================
Prg_BusTek_BT946C	Proc	Near

		pushad
		mov	cl, 10h
		xor	eax, eax			;disable I/O decode
		call	X_Set_CfgSpace_DWord

;Find available I/O port for BT-946C

		push	cx

		mov	si, offset BT_946C_IO_ADDR
Check_Next_Io:
		mov	dx, cs:[si]		;get I/O port
		or	dx, dx			;last I/O
		jz	No_Avail_Io
		mov	cx, 4			;total four ports to check
Inc_Io_Port:
		in	al, dx
		IODELAY
		mov	ah, al
		in	al, dx			;data changed -> I/O not available
		IODELAY
		cmp	ah, al
		jne	Next_IO_Addr
		cmp	al, 0ffh		;should be 0ffH if I/O available
		jne	Next_IO_Addr
		inc	dx
		loop	Inc_Io_Port
		mov	dx, cs:[si]		;get I/O port
		jmp	No_Avail_Io

Next_IO_Addr:
		inc	si
		inc	si
		jmp	Check_Next_Io

No_Avail_Io:
		pop	cx
		mov	cl, 10h			;set I/O for PCI device
		xor	eax, eax
		mov	ax, dx			;set I/O port value
		or	ax, ax			;no I/O port available ?
		jz	No_IO_Assign
		or	al, 1			;enable I/O
No_IO_Assign:
		call	X_Set_CfgSpace_DWord

		mov	cl, 04
		mov	al, 07
		call	X_Set_CfgSpace_Byte

		call	X_Disable_PCI_ROM
Prg_BT946C_End:
		popad
		ret

Prg_BusTek_BT946C	Endp

		ALIGN	4
BT_946C_IO_ADDR:
		DW 	0330h
		DW 	0334h
		DW 	0230h
		DW 	0234h
		DW 	0130h
		DW 	0134h
		dw	0

;------------------------------------------------------------------
;PLATFORM's P2P did a wrong definition of "master abort mode".
;BIOS do a patch for it to prevent reading garbage of configuration
;space behind the P2P
;
;Input	:	dword ptr CURRENT_DEVICE_ID[bp]
;------------------------------------------------------------------
Patch_Platform_P2P_Bridge	Proc	Near

		cmp	CURRENT_DEVICE_ID[bp], (1285H SHL 16)+1000h
							;PLATFROM's P2P bridge ?
		jne	Not_Platform_P2P		;no !

		mov	cl, 3eH
		call	X_Get_CfgSpace_Byte
		or	al, 20H				;report master abort
		call	X_Set_CfgSpace_Byte

	Not_Platform_P2P:

		ret

Patch_Platform_P2P_Bridge	Endp

;-------------------------------------------------------------
;Scan all the P2P bridge on current bus & reset it !
;-------------------------------------------------------------
Clear_P2P	Proc	Near

		pushad
		xor	ch, ch

	Clr_Next_PP:

		call	X_Get_Vendor_ID 	;retrieve vendor ID
		jc	Not_P2P_B		;skip if no vendor ID !
		call	If_PP_Bridge		;check if P2P bridge
		jc	Not_P2P_B		;no !

	;-------------------------------------------------------------
	;write 40H then 00H to P2P controller to reset P2P for fixing
	;AHA3940 rebooting problem
	;-------------------------------------------------------------

		mov	cl, 3Eh
		mov	al, 40h
		call	X_Set_CfgSpace_Byte
		xor	al, al
		call	X_Set_CfgSpace_Byte

	;Clear Bus number

		mov	cl, 18h
		xor	eax, eax
		call	X_Set_CfgSpace_DWord

		mov	cl, 04h
		call	X_Set_CfgSpace_Byte

	Not_P2P_B:

		call	X_Get_Next_Device
		jnc	Clr_Next_PP

	End_Clr_P2P:

		popad

		ret

Clear_P2P	Endp

;---------------------------------------------------------------------
;Input : CH : PCI device no.
;Output: NZ : not PCI-TO-PCI bridge
;	 ZF : it's PP bridge
;---------------------------------------------------------------------
		ALIGN	4
If_PP_Bridge	proc	near
		push	eax
		mov	cl, 0AH				;get class code
		call	X_Get_CfgSpace_Word		;get class code
		cmp	ax, CLASS_PP_BRIDGE		;PP bridge ?
		pop	eax
		ret
If_PP_Bridge	endp

;======================================================================
;======================================================================
Record_Base_Requests	Proc	Near

		push	ds
		pushad

		push	SEG TEMP_PCI_REQ_BUF
		pop	ds

		call	Record_VGA_Devices

		mov	cl, 10h

	Analyse_Next_Base:

		push	cx
		call	Analyse_Base_Request
		jc	This_Base_Done

		cmp	dl, 2
		jne	@F
 		call	See_If_Bus_0
		jne	_Kill_Dev
	@@:
		test	eax, 0C0000000h
		jnz	_Kill_Dev

	;----------------------
	;Put Reqest Into Buffer
	;----------------------

		mov	dh, CURRENT_BUS_NO[bp]
		call	Append_Base_Request

	;------------------------------------------------
	;accumulate total request
	;------------------------------------------------

		push	ax
		mov	al, CURRENT_BUS_NO[bp]
		call	Get_Bus_Info_Offset
		pop	ax

		cmp	dl, 2
		je	This_Base_Done

  		mov	bx, TotalIOReq
		cmp	dl, 1
		je	@F

  		mov	bx, TotalPfMemReq
		cmp	dl, 8
		je	@F

		mov	bx, TotalMemReq
	@@:
		add	ds:[si+bx], eax

	;------------------------------------------------

	This_Base_Done:

		pop	cx

		cmp	dl, 4
		jne	@F
		add	cl, 4
	@@:
		add	cl, 4

		cmp	cl, 28h
		jne	@F
		mov	cl, 30h
	@@:
		cmp	cl, 30h
		jbe	Analyse_Next_Base
		clc

	Record_Base_Requests_End:

		popad
		pop	ds

		ret

	_Kill_Dev:

		pop	cx
		call	Kill_This_CfgSpace
		stc
		jmp	Record_Base_Requests_End

Record_Base_Requests	Endp

;[]=====================================================================[]
;Input	:	AL = bus number
;Output	:	SI - Offset of Bus Info
;[]=====================================================================[]
Get_Bus_Info_Offset	Proc	Near

		push	ax
		push	cx
		mov	cl, SIZE_BUS_TREE_STRUC
		mul	cl
		mov	si, ax
		pop	cx
		pop	ax
		ret

Get_Bus_Info_Offset	Endp

;-----------------------------------------------------------------
;Input	     :  Information of this base request
;		EAX - Size of this base request
;		DL  - the first 4 bit of this base request
;		DH  - bus no of this base request
;		CX  - Device & function no. of this base request
;
;Description :	To append a base request information into the
;		TEMP_PCI_REQ_BUF segment according to the a pointer
;		value stored in BASE_REQ_BUF_PTR[bp]
;-----------------------------------------------------------------
Append_Base_Request	Proc	Near

		push	di
		mov	di, BASE_REQ_BUF_PTR
		push	ds
		push	SEG TEMP_PCI_REQ_BUF
		pop	ds
		call	Store_Base_Request
		pop	ds
		pop	di
		ret

Append_Base_Request	Endp

;-------------------------------------------------------------
;Input	     :  Information of this base request
;		EAX - Size of this base request
;		DL  - the first 4 bit of this base request
;		DH  - bus no of this base request
;		CX  - Device & function no. of this base request
;-------------------------------------------------------------
Store_MEM_Base_Request	Label	Near

		push	di
		mov	di, HMEM_BUF_PTR
		jmp	@F

;----------------------------------------------------------------
;Input	     :  Information of this base request
;		EAX - Size of this base request
;		DL  - the first 4 bit of this base request
;		DH  - bus no of this base request
;		CX  - Device & function no. of this base request
;----------------------------------------------------------------
Store_PfMEM_Base_Request	Label	Near

		push	di
		mov	di, PREFET_MEM_BUF_PTR
		jmp	@F

;----------------------------------------------------------------
;Input	     :  Information of this base request
;		EAX - Size of this base request
;		DL  - the first 4 bit of this base request
;		DH  - bus no of this base request
;		CX  - Device & function no. of this base request
;----------------------------------------------------------------
Store_LMEM_Base_Request	Label	Near

		push	di
		mov	di, LMEM_BUF_PTR
		jmp	@F

;----------------------------------------------------------------
;Input	     :  Information of this base request
;		EAX - Size of this base request
;		DL  - the first 4 bit of this base request
;		DH  - bus no of this base request
;		CX  - Device & function no. of this base request
;----------------------------------------------------------------
Store_IO_Base_Request	Label	Near

		push	di
		mov	di, IO_BUF_PTR
	@@:
		push	ds
		push	SEG PCI_REQ_BUF
		pop	ds
		call	Store_Base_Request
		pop	ds
		pop	di
		ret

;----------------------------------------------------------------
;Input	     :  Information of this base request
;		EAX - Size of this base request
;		DL  - the first 4 bit of this base request
;		DH  - bus no of this base request
;		CX  - Device & function no. of this base request
;		DS -  Segment of the request buffer
;		DI -  [bp+di] as a pointer to point to the current
;		      available address for storing the request
;
;Description :	To store a base request information into the
;		segment DS according to the a pointer value stored in
;		[bp+di]
;----------------------------------------------------------------
Store_Base_Request	Proc	Near

		push	si
		mov	si, [bp+di]

		mov	ds:[si].MemIO_Req, eax
		mov	ds:[si].Cfg_Loc, cx
		mov	ds:[si].MemIo_Info, dl
		mov	ds:[si].Bus_Num, dh

		add	word ptr [bp+di], SIZE MEMIO_BUF
		pop	si
		ret

Store_Base_Request	Endp

;-------------------------------------------------------------
;-------------------------------------------------------------
Include_Subordinate_Reqests	Proc	Near

		push	ds
		pushad

		push	SEG TEMP_PCI_REQ_BUF
		pop	ds

		mov	al, CURRENT_BUS_NO[bp]
		call	Get_Bus_Info_Offset

	;-------------------------------------------------------
	;Includes all subordinate buses requests
	;-------------------------------------------------------

		mov	bx, Sub_Buses
		mov	cx, MAX_SUB_BUS

	Include_Next_Sub_Bus_Req:

		mov	al, ds:[si+bx]
		or	al, al
		jz	No_More_Sub_Bus

		push	cx
		push	si

		mov	di, si
		call	Get_Bus_Info_Offset

		mov	eax, ds:[si].TotalMemReq
		add	ds:[di].TotalMemReq, eax
		mov	eax, ds:[si].TotalPfMemReq
		add	ds:[di].TotalPfMemReq, eax
		mov	eax, ds:[si].TotalIOReq
		add	ds:[di].TotalIOReq, eax

		pop	si
		pop	cx

		inc	bx
		loop	Include_Next_Sub_Bus_Req

	No_More_Sub_Bus:

	;-----------------------------------------------------

		mov	al, CURRENT_BUS_NO[bp]
		call	Get_Bus_Info_Offset

		mov	di, offset P2P_Request_Tbl
		mov	cx, No_Of_P2P_Request

	Next_P2P_Request:

		pusha

	;-------------------------------------------------------
	;Set current bus request to max alignment
	;-------------------------------------------------------

		mov	bx, cs:[di]	;BX=TotalMemReq/TotalIOReq/TotalPfMemReq

		mov	ecx, ds:[si+bx]	;ECX=TotalXXReq
		mov	eax, cs:[di+2]	;[DI+2]=Minimum request for one bus
		shr	eax, 1		;shift right in the first place

	;---------------------------------------------------
	;If MEM or Prefetch memory, do not set a minimum
	;request for it
	;---------------------------------------------------

		cmp	bx, TotalIOReq
		je	@F
		or	ecx, ecx
		jnz	@F
		xor	eax, eax
		jmp	End_Align_Req
	@@:
	;---------------------------------------------------

	Try_Next_Align:

		shl	eax, 1		;shift left
		cmp	ecx, eax	;this request enough ?
		jbe	Go_Align_Req	;yes, enough !
		cmp	eax, cs:[di+6]	;max request reached ?
					;  [DI+6]=Maximum request for one bus
		jne	Try_Next_Align	;not yet !

		mov	eax, cs:[di+10]	;[DI+10]=mask
		and	eax, ecx	;Clear low bits of ECX & result in EAX

	Go_Align_Req:

		mov	ds:[si+bx], eax	;put aligned request back into buffer

	End_Align_Req:

	;-------------------------------------------------------
	;Create Virtual Base Request for the primary bus to treat
	;the whole bridge resource as just a base request
	;-------------------------------------------------------

		or	si, si				;in bus 0 ?
		jz	No_Virtual_Base			;yes, skip virtual requst !

	;-------------------------------------------------------
	;if total P2P request is none, we post a request of
	;value=00000001h to the request buffer. Our resource
	;assign procedure will write 0FFF00000h to the resource
	;register of the PPB which means DISABLED
	;-------------------------------------------------------
		or	eax, eax
		jnz	@F
		mov	al, 1
	@@:
	;-------------------------------------------------------

 		mov	dh, ds:[si].P2PB_BusNo		;DH=bus loc of PPB
 		mov	ch, ds:[si].P2PB_DevFucNo	;CH=Dev&func loc of PPB
		mov	cl, cs:[di+14]			;CL=which reg to be set
		mov	dl, cs:[di+15]			;DL=what kind of request
		or	dh, dh				;PPB at bus 0 ?
		jnz	@F				;no !
		mov	dl, cs:[di+16]			;another kind of request
	@@:
 		call	Append_Base_Request		;put this request into
							;buffer
	No_Virtual_Base:

		popa

		add	di, P2P_Request_Tbl_Data_Len
		loop	Next_P2P_Request

		popad
		pop	ds
		ret

Include_Subordinate_Reqests	Endp

P2P_Request_Tbl	Label	Near

		dw	TotalMemReq
		dd	000100000h
		dd	080000000h
		dd	0FFF00000h
		db	20h
		db	VIRTUAL_HMEM_BASE
		db	VIRTUAL_HMEM_BASE

P2P_Request_Tbl_Data_Len	EQU	($ - (offset P2P_Request_Tbl))

		dw	TotalPfMemReq
		dd	000100000h
		dd	080000000h
		dd	0FFF00000h
		db	24h
		db	VIRTUAL_PFMEM_BASE
		db	VIRTUAL_BUS0_PFMEM_BASE

		dw	TotalIOReq
		dd	000001000h
		dd	000008000h
		dd	00000F000h
		db	1Ch
		db	VIRTUAL_IO_BASE
		db	VIRTUAL_IO_BASE

No_Of_P2P_Request	EQU	($ - (offset P2P_Request_Tbl)) / P2P_Request_Tbl_Data_Len

;[]=====================================================================[]
;[]=====================================================================[]
Determine_Device_Resource	Proc	Near

		push	ds
		pushad

		push	SEG TEMP_PCI_REQ_BUF
		pop	ds

		mov	byte ptr CURRENT_BUS_NO[bp], 0

	Assign_Next_Bus_Resources:

		push	ds
		push	SEG PCI_REQ_BUF
		pop	ds
		call	Clear_PCI_Req_Buffer
		pop	ds

		mov	word ptr IO_BUF_PTR[bp], offset IO_BUF
		mov	word ptr HMEM_BUF_PTR[bp], offset HMEM_BUF
		mov	word ptr LMEM_BUF_PTR[bp], offset LMEM_BUF
		mov	word ptr PREFET_MEM_BUF_PTR[bp], offset PREFET_MEM_BUF

		mov	si, offset TEMP_BASE_REQ_BUF

	Fetch_Stored_Req:

		mov	ah, ds:[si].Bus_Num
		cmp	ah, -1
		je	End_Fetch_Req
		cmp	ah, CURRENT_BUS_NO[bp]
		jne	No_Fetch

		mov	dh, ds:[si].Bus_Num
		mov	dl, ds:[si].MemIo_Info
		mov	cx, ds:[si].Cfg_Loc
		mov	eax, ds:[si].MemIO_Req

		mov	di, offset Store_IO_Base_Request
		test	dl, 01h
		jnz	_Put

		mov	di, offset Store_LMEM_Base_Request
		test	dl, 02h
		jnz	_Put

		mov	di, offset Store_PfMEM_Base_Request
		test	dl, 08h
		jnz	_Put

		mov	di, offset Store_MEM_Base_Request
	_Put:
		call	di

	No_Fetch:

		add	si, SIZE MEMIO_BUF
		jmp	Fetch_Stored_Req

	End_Fetch_Req:

		call	Prepare_PCI_Bus_Info

		push	ds
		push	SEG PCI_REQ_BUF
		pop	ds

		cmp	byte ptr NEED_ASSIGN_LMEM_FLAG[bp], 0AAh
		jne	@F
 		call	Assign_Mem_Below_1M
		jmp	End_Assign_One_Bus
	@@:
		call	Assign_Mem_Above_1M
		call	Assign_Prefectchable_Memory
 		call	Assign_IO_Space

	End_Assign_One_Bus:

		pop	ds

		cmp	byte ptr NEED_ASSIGN_LMEM_FLAG[bp], 0AAh
		je	@F
		POST_FUNC_CALL Get_Next_Bus
		jbe	Assign_Next_Bus_Resources
	@@:

		popad
		pop	ds
		ret

Determine_Device_Resource	Endp

;[]=====================================================================[]
;Input	:	AL & CURRENT_BUS_NO[bp] - Bus location of P2P Bridge
;		CX 			- DEV & FUNC no. of P2P Bridge
;		TOTAL_BUS_NO[bp]	- The Bus no. should this P2P
;					  expand to
;[]=====================================================================[]
Record_P2P_Info	Proc	Near

		push	ds
		pushad

		push	SEG TEMP_PCI_REQ_BUF
		pop	ds

	;Attach a subordinate bus for it's mother bus

		call	Get_Bus_Info_Offset
		add	si, Sub_Buses

		push	cx
		mov	cx, MAX_SUB_BUS
	@@:
		cmp	byte ptr ds:[si], 0
		je	@F
		inc	si
		loop	@B
	@@:
		pop	cx
		mov	al, TOTAL_BUS_NO[bp]
		mov	byte ptr ds:[si], al

	;Record the Bus, Device & Function number of this P2P bridge

		call	Get_Bus_Info_Offset
		mov	al, CURRENT_SLOT[bp]
		mov	ds:[si].Host_Slot, al
		mov	al, CURRENT_BUS_NO[bp]
		mov	ds:[si].P2PB_BusNo, al
		mov	ds:[si].P2PB_DevFucNo, ch

		popad
		pop	ds
		ret

Record_P2P_Info	Endp

;----------------------------------------------------------------
;Special for PCI IDE devices:
;
;  if device <> PCI/IDE
;     continue assign IO/MEM for this device
;  else
;     1. Promise PCI/IDE: Disable PCI ROM
;     2. VIA PCI/IDE    : continue assign IO/MEM for this device
;
;Input	:	AX = Class Code
;		CURRENT_VENDOR_ID[bp]
;		CURRENT_DEVICE_ID[bp]
;----------------------------------------------------------------
Skip_IDE_Base_Request	Proc	Near

		push	ax
		cmp	ax, CLASS_IDE		;its a PCI IDE?
		jne	Not_IDE_Base		;no !

	;enable I/O for PCI/IDE

		mov	cl, 04h			;Command Register
		mov	al, 07h
		call	X_Set_CfgSpace_Byte

	;assign I/O 03001H for master IDE at space 20H, so far BIOS
	;always set fixed I/O address

		call	X_Get_CfgSpace_Byte
		test	al, 04H			;master IDE ?
		jz	Not_Master_Ide

		mov	cl, 20H
		mov	eax, 0F001H
		call	X_Set_CfgSpace_DWord

	Not_Master_Ide:

		mov	ax, CURRENT_VENDOR_ID[bp]
		cmp	ax, 105Ah		;Promise PCI/IDE need to
		jne	@F			;disable PCI ROM before
		call	X_Disable_PCI_ROM
	@@:
		cmp	ax, 1106H		;VIA PCI/IDE ?
		je	Not_IDE_Base		;don't skip for VIA IDE
		pop	ax
		stc				;STC = do not assign anything
		ret				;      for IDE!

	Not_IDE_Base:

		pop	ax
		clc
		ret

Skip_IDE_Base_Request	Endp

;[]----------------------------------------------------------------------[]
;Input	:	CX - device, function no.
;		CL - base reg no.
;Ouput	:	CF - No request
;		NC - request value in EAX
;		     request type in DL : 0/4 --> Memory Space 32bit/64bit
;					  1 -->	I/O Space
;					  2 --> Memory below 1M
;					  8 --> Prefetch Memory Space
;
;		e.g. EAX = 00010000h, DL = 00h
;				------------>>>> 64K Memory Space
;		     EAX = 00000400h, DL = 01h
;		     		------------>>>> 1K I/O Space
;
;[]----------------------------------------------------------------------[]
Analyse_Base_Request	Proc	Near

	;write 0FFFFFFFFh into request register
	;   IO/MEM request will be reflected in the same register

		mov	eax, -1
		call	X_Set_CfgSpace_DWord
		call	X_Get_CfgSpace_Dword
		push	eax
		xor	eax, eax
		call	X_Set_CfgSpace_DWord
		pop	eax

		cmp	cl, 30h
		jne	Skip_Checking_ROM
		test	al, 01h
		jz	No_Base

		test	eax, 0FFF00000h
		jz	No_Base

		call	Check_Invalid_Base
		jc	No_Base

		and	eax, 0FF000000h

	Skip_Checking_ROM:

	;save IO/MEM info in DL

		mov	dl, al

		call	See_If_Bus_0
		je	Scaning_Bus0

		and	dl, 0Fh
		cmp	dl, 08h
		je	Prefetchable_Mem_Req

	Scaning_Bus0:

		and	dl, 07h
		test	dl, 01H			;Need I/O ?
		jnz	Io_Yes

	;----------------------------------------------------
	;	DL > 4 or DL = 3 are invalid requests !!!
	;----------------------------------------------------

		cmp	dl, 04h			;unreasonable value?
		ja	No_Base			;yes, error!
	Io_Yes:
		cmp	dl, 03h			;unreasonable value?
		je	No_Base			;yes, error!

	Prefetchable_Mem_Req:

	;check if unreasonable request
	;if request unreasonable --> skip it

		mov	esi, 0FFFFFFF0H		;MEM req: bit 0123 read only
		mov	edi, 0FFFFF000h		;MEM req: min = 4K bytes

		test	dl, 01h			;I/O request?
		jz	@F			;no

;R06		mov	esi, 0FFFFFFFCh		
;R06		mov	edi, 0FFFFFF00h
;R06		call	See_If_Bus_0
;R06		je	@F			;yes
		mov	si, 0FFFCh		;I/O : bit 01 read only	;R06
		mov	di, 0FC00h
	@@:

		call	Patch_PCI_Base_Request

		test	eax, esi		;unreasonable value?
		jz	No_Base			;yes, error!

	;if request size <= our minimun --> set to minimun

		and	eax, edi

	;if it is a Low Memory request, set A20 to A31 to be high

		cmp	dl, 02h
		jne	@F
		or	eax, 0FFF00000h
	@@:

	;if it is a I/O request, set high word to be FFFFh

		test	dl, 01h
		jz	@F
		and	dl, 03h
		or	eax, 0FFFF0000h
	@@:
		call	Check_Invalid_Base
		jc	No_Base			; CF:not a valid request

		not	eax
		inc	eax

		clc
		ret

	No_Base:

		stc
		ret

Analyse_Base_Request	Endp

;======================================================================
;======================================================================
Patch_PCI_Base_Request	Proc	Near

	;set requesting memory space to 8Mb instead of 4Mb for Matrox
	;due to hardware decoding with 8Mb

		test	dl, 01h					;I/O request?
		jnz	Not_Patch_Matrox

		cmp	word ptr CURRENT_VENDOR_ID[bp], 102Bh	;Matrox?
		jne	Not_Patch_Matrox			;no
		test	eax, 000FFF000h
		jz	Not_Patch_Matrox
		mov	edi, 0FF000000h

	Not_Patch_Matrox:

	;set requesting memory space to 64Mb instead of 32Mb for S3/968
	;due to hardware decoding with 64Mb

		test	dl, 01h					;I/O request?
		jnz	Not_S3Vga968

		cmp	dword ptr CURRENT_DEVICE_ID[bp], 53338880H;S3/868 chip ?;R15
		je	short NotFullyDecodeMemSpace				;R15

		cmp	dword ptr CURRENT_DEVICE_ID[bp], 533388F0H	;S3 968 chip ?
		jne	Not_S3Vga968

	NotFullyDecodeMemSpace:							;R15

		test	eax, 003FFF000H				;request 32M?
		jz	Not_S3Vga968
		mov	edi, 0FC000000h				;set 64Mb

	Not_S3Vga968:

		ret

Patch_PCI_Base_Request	endp

;======================================================================
;======================================================================
Check_Invalid_Base	Proc	Near

		push	ebx
		push	edx

		call	Get_First_Zero		;EBX=1st "0" loc. from left
		jc	Invalid_Base		;CF=All ONEs
		call	Get_First_Non_Zero	;EDX=1st "1" loc. from left
		jc	Invalid_Base		;CF=All ZEROs
		cmp	ebx, edx
		ja	Invalid_Base

	Valid_Base:

		clc
		jmp	Check_Invalid_Base_End

	Invalid_Base:

		stc

	Check_Invalid_Base_End:

		pop	edx
		pop	ebx
		ret

Check_Invalid_Base	Endp

;======================================================================
;======================================================================
Get_First_Zero	Proc	Near
		mov	ebx, 80000000h
	@@:
		test	eax, ebx
		jz	@F
		shr	ebx, 1
		jnz	@B
		stc
		ret
	@@:
		clc
		ret
Get_First_Zero	Endp

;======================================================================
;======================================================================
Get_First_Non_Zero	Proc	Near
		mov	edx, 80000000h
	@@:
		test	eax, edx
		jnz	@F
		shr	edx, 1
		jnz	@B
		stc
		ret
	@@:
		clc
		ret
Get_First_Non_Zero	Endp

;-------------------------------------------------------------
;Input	:	DS : PCI_REQ_BUF
;		CH : device number in upper 5 bits
;		CL : function number in lower 3 bits
;-------------------------------------------------------------
		ALIGN	4
		ASSUME	DS:PCI_REQ_BUF
Kill_This_CfgSpace	Proc	Near

;---------------------
;1. destroy cfg space
;---------------------

		push	cx

	;---------- disable MEM, I/O & Master -------------

		mov	cl, 04h			;PCI command register
		xor	ax, ax
		call	X_Set_CfgSpace_Word

	;----------- kill register 10h to 24h -------------

		mov	cl, 10h
	@@:
		xor	eax, eax
		call	X_Set_CfgSpace_DWord
		add	cl, 4
		cmp	cl, 24h
		jbe	@B

	;-------------- kill ROM decoding -----------------

		call	X_Disable_PCI_ROM

		pop	cx

;----------------------------------------------------------
;2. set all request of this cfgspace(CX) in buffer to -1
;----------------------------------------------------------

		push	si

		mov	si, (offset TEMP_PCI_REQ_BUF)\
			    - SIZE_MEMIO_BUF

;-------------------

	Keep_Killing:

		add	si, SIZE_MEMIO_BUF		;point to next request
		or	[si].MemIO_Req, 0		;all req in this buf done?
		jz	_Killed				;yes, exit this buffer

		cmp	byte ptr [si+Cfg_Loc+1], ch	;is this req to be killed?
		jne	Keep_Killing			;no, skip it

		mov	al, CURRENT_BUS_NO[bp]
		cmp	byte ptr [si].Bus_Num, al	;is this req to be killed?
		jne	Keep_Killing			;no, skip it

		mov	[si].MemIO_Req, -1		;mark request killed
		jmp	Keep_Killing			;continue to next request

	_Killed:

;-------------------

		pop	si
		ret

Kill_This_CfgSpace	Endp

;[]================================================================[]
;[]================================================================[]
		ALIGN	4
		ASSUME	DS:PCI_REQ_BUF
Assign_Prefectchable_Memory	Proc	Near

		push	ds

		mov	si, offset PREFET_MEM_BUF
		call	Sort_PCI_Request

		mov	edi, AVAILABLE_PREFET_START[bp]
		call	Assign_From_Buff

		pop	ds

		ret

Assign_Prefectchable_Memory	Endp

;[]================================================================[]
;[]================================================================[]
		ALIGN	4
		ASSUME	DS:PCI_REQ_BUF
Assign_Mem_Above_1M	Proc	Near

		push	ds

		mov	si, offset HMEM_BUF		;sort all requests
		call	Sort_PCI_Request 		; in decreasing order

		mov	si, offset HMEM_BUF		;SI --> request buffer
		mov	edi, AVAILABLE_MEM_START[bp]	;EDI = Mem addr. start
		call	Assign_From_Buff      		;assign memory
							;  according to buffer
		pop	ds
		ret

Assign_Mem_Above_1M	Endp

;-------------------------------------------------------------
;-------------------------------------------------------------
		ALIGN	4
		ASSUME	DS:PCI_REQ_BUF
Assign_IO_Space	Proc	Near

		push	ds
		mov	si, offset IO_BUF		;SI --> request buffer
		call	Sort_PCI_Request  	 	;sort in decreasing order

		mov	edi, AVAILABLE_IO_START[bp]	;EDI = I/O addr. start

		call	Assign_From_Buff   		;assign IO according
							;     to buffer
		pop	ds
		ret

Assign_IO_Space	Endp

;-------------------------------------------------------------
;-------------------------------------------------------------
		ALIGN	4
		ASSUME	DS:PCI_REQ_BUF
Assign_Mem_Below_1M	Proc	Near

		push	ds

		mov	si, offset LMEM_BUF	;SI --> request buffer
		call 	Sort_PCI_Request  	;sort in decreasing order

		call 	Assign_From_Buff

		call	X_Invalidate_Shadow_Seg	;invalidate whole shadow seg
						;i.e. shadow unit = 16K(32K)
						;     ==> invalidate whole
						;	  16k(32k) even if it
						;	  is not totally used!
		pop	ds
		ret

Assign_Mem_Below_1M	Endp

;-------------------------------------------------------------
;Input	:	DS  = PCI_REQ_BUF
;		SI  = buffer location in PCI_REQ_BUF
;		EDI = available address location
;-------------------------------------------------------------
		ALIGN	4
		ASSUME	DS:PCI_REQ_BUF
Assign_From_Buff	Proc	Near
Assign_Continue:
		mov	cx, [si].Cfg_Loc		;dev & func no.
		mov	eax, [si].MemIO_Req		;value to be assigned
		mov	bl, [si].MemIo_Info		;mem/io info

		or	eax, eax			;end of buffer?
		jz	End_Assign_From_Buf		;yes, exit!

		cmp	eax, -1				;Cfg been killed?
		je	Assign_Next_Req			;yes, skip this one!

;-------- if [si].MemIo_Info = 2,  assign memory below 1M -----------------

		cmp	bl, 02h				;request mem < 1M?
		jne	Assign_HMem_IO			;no, go try I/O or Mem > 1M

		push	cx				;save dev, func no
		shr	eax, 12				;mem. in terms of 4K
		mov	cl, al				;param in CL
		mov	byte ptr LMEM_FOR_ROM_FLG[bp], 0;indicate get LMEM for memory usage
		POST_FUNC_CALL EGet_Available_LMEM 	;request low mem
		pop	cx				;restore dev, func no
		jc	@F				;CF -> mem not available

		mov	eax, AVAIL_LMEM_ADDR[bp]	;EAX = addr.
		call	X_Set_CfgSpace_DWord		;write into cfg space
		jmp	Assign_Next_Req			;assign next request
	@@:
		call	Kill_This_CfgSpace		;kill this cfg Space!
		jmp	Assign_Next_Req			;assign next request

;------------------ assign memory above 1M, I/O request -----------------
Assign_HMem_IO:

	;-------------------------------------------------------
	;a request of value=00000001h means the total P2P request
	;is none, we clear AL so that it won't affect the next
	;available resource
	;-------------------------------------------------------

		cmp	eax, 1
		jne	@F
		xor	al, al
	@@:

		xchg	eax, edi			;eax to be written

		call	Assign_Resource_For_P2P
		jc	Assign_Next_Req

		test	bl, 01h				;IO request?
		jz	_789				;no
		and	eax, 0FFFFh			;fix to 16 bits	for IO
		or	al, 01h				;set bit0=1 for I/O
	_789:

		call	X_Set_CfgSpace_DWord		;write into cfg space
		and	al, not 01h			;restore bit0=0
		add	edi, eax			;add to available space

		cmp	bl, 04h				;mem. 64-bit address?
		jne	Assign_Next_Req			;no!
		add	cl, 04h				;set upper 32bit
		xor	eax, eax			;    address to 0
		call	X_Set_CfgSpace_DWord

	Assign_Next_Req:

		add	si, SIZE_MEMIO_BUF
		jmp	Assign_Continue

	End_Assign_From_Buf:

		ret

Assign_From_Buff	Endp

;======================================================================
;Input	:	BL = what kind of request
;			VIRTUAL_HMEM_BASE
;			VIRTUAL_PFMEM_BASE
;			VIRTUAL_BUS0_PFMEM_BASE
;			VIRTUAL_IO_BASE
;		EAX = Available resource
;		EDI = Amount of resource needed
;		CH & CL = resource register to be set
;
;Output	:	CF - It is a P2P resource & assignment is done
;		NC - not a P2P resource
;======================================================================
Assign_Resource_For_P2P	Proc	Near

		push	ds
		push	si

		mov	si, Bus_Mem_Start
		cmp	bl, VIRTUAL_HMEM_BASE
		je	Assigning_P2P

		mov	si, Bus_PfMem_Start
		cmp	bl, VIRTUAL_BUS0_PFMEM_BASE
		je	Assigning_P2P
		cmp	bl, VIRTUAL_PFMEM_BASE
		je	Assigning_P2P

		mov	si, Bus_IO_Start
		cmp	bl, VIRTUAL_IO_BASE
		clc
		jne	Not_Assigning_P2P

	Assigning_P2P:

	;------------------------------

		pusha

		mov	bx, si

		push	eax
		mov	cl, 19h
		call	X_Get_CfgSpace_Byte
		call	Get_Bus_Info_Offset
		pop	eax

		push	SEG TEMP_PCI_REQ_BUF
		pop	ds
		mov	ds:[si+bx], eax

		popa

	;------------------------------

		cmp	bl, 0A1h
		je	Assigning_P2P_IO

	Assigning_P2P_Mem:

		or	edi, edi			;P2P request = 0
		jnz	@F				;no !
		mov	eax, 0000FFFFh			;disable the resource
		call	X_Set_CfgSpace_DWord		;write into cfg space
		jmp	Finish_Assign_Resource_For_P2P
	@@:
		ror	eax, 16
		call	X_Set_CfgSpace_Word		;write into cfg space
		ror	eax, 16
		inc	cl
		inc	cl
		add	edi, eax			;add to available space
		mov	eax, edi
		dec	eax
		ror	eax, 16
		call	X_Set_CfgSpace_Word		;write into cfg space

		jmp	Finish_Assign_Resource_For_P2P

	Assigning_P2P_IO:

		ror	ax, 8
		call	X_Set_CfgSpace_Byte		;write into cfg space
		inc	cl
		rol	ax, 8
		add	di, ax				;add to available space
		mov	ax, di
		dec	ax
		ror	ax, 8
		call	X_Set_CfgSpace_Byte		;write into cfg space

		mov	bl, 02h				;Cache Line size = 2
		call	Prg_Device_Latency

	;-----------------------------------------------
	;enable SERR#
	;-----------------------------------------------

		mov	cl, 3eH
		call	X_Get_CfgSpace_Byte
		and	al, 00100000b
		or	al, 00000111b			;ISA enable
		call	X_Set_CfgSpace_Byte

	;-----------------------------------------------
	;-----------------------------------------------

	ifdef	CHIPSET_PATCH_AHA3940
	;This register should set to 1 ( Why ? )
		mov	cl, 40H
		mov	al, 3		;disable POST write
		call	X_Set_CfgSpace_Byte
		mov	cl, 44H
		mov	ax, 1111H
		call	X_Set_CfgSpace_Word
	endif;	CHIPSET_PATCH_AHA3940

	;-----------------------------------------------
	;enable I/O , memory & master
	;-----------------------------------------------

		mov	cl, 04H
		mov	ax, 0107H
		call	X_Set_CfgSpace_Word

	Finish_Assign_Resource_For_P2P:

		stc

	Not_Assigning_P2P:

		pop	si
		pop	ds
		ret

Assign_Resource_For_P2P	Endp

;-------------------------------------------------------------
;Input	:	ds : PCI_REQ_BUF
;		si : point to offset of buffer to be sorted
;Output	:	None
;-------------------------------------------------------------
		ALIGN	4
		ASSUME	DS:PCI_REQ_BUF
Sort_PCI_Request	Proc	Near

		push	si
		push	di
Next_Bubble:
		cmp	dword ptr [si], 0
		je	End_Sort_PCI_Request

		mov	di, si
		add	di, 8
	@@:
		mov	eax, [si]
		mov	ebx, [si+4]
		mov	ecx, [di]
		mov	edx, [di+4]

		or	ecx, ecx
		je	End_This_Bubble

		cmp	eax, ecx
		jae	Greater_Or_Equal

		xchg	ecx, eax
		xchg	ebx, edx

		mov	[si], eax
		mov	[si+4], ebx
		mov	[di], ecx
		mov	[di+4], edx

	Greater_Or_Equal:

		add	di, SIZE_MEMIO_BUF
		jmp	@B

	End_This_Bubble:

		add	si, SIZE_MEMIO_BUF
		jmp	Next_Bubble

End_Sort_PCI_Request:

		pop	di
		pop	si

		ret

Sort_PCI_Request	Endp

;-----------------------------------
;Input	:	DS = PCI_REQ_BUF
;-----------------------------------
		ALIGN	4
Clear_PCI_Req_Buffer	Proc	Near

		push	ds
		pop	es
		xor	di, di
		cld
		xor	ax, ax
		mov	cx, 8000h
		rep	stosw

		ret

Clear_PCI_Req_Buffer	Endp

;[]==============================================================[]
;PciRom_Before_Init:
;	special treatment before option initialization
;Saves: all
;Input : none
;Output: None
;[]==============================================================[]
		Public	fProc_PciRom_Before_Init
fProc_PciRom_Before_Init	Proc	Far

		mov	byte ptr PCI_CBROM_TEMP[bp], -1		;set pci flag for pci_cbrom_decompress subroutine
		mov	word ptr CBROM_BP_START[bp], (86h+1)*4	;option ROM start index of PCI device (from 86h)
		mov	word ptr CBROM_BP_END[bp], (0A0h+1)*4	;option ROM end index of PCI device (to 0A0h)
		mov	dword ptr CBROM_BUF_START[bp], 200030h	;PCI device and vender ID start address for decompress use
		call	fProc_Pci_CbRom_decompress

	ifdef	PNP_BIOS
		call	ESCD_IRQ_Resource
	endif	;PNP_BIOS

		call	Assign_IRQ_For_All_PCI

		call	Prg_Onboard_ScsiChip

		retf

fProc_PciRom_Before_Init	Endp

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%                                                          %%%%%%
;%%%%%%                VGA related routines                      %%%%%%
;%%%%%%                                                          %%%%%%
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;======================================================
;======================================================
Record_VGA_Devices	Proc	Near

		call	X_Chk_If_Class_VGA_1
		jne	No_Store_VGA

		mov	si, PCI_VGA_DEVICE_BUF_PTR[bp]
		add	word ptr PCI_VGA_DEVICE_BUF_PTR[bp], SIZE_VGA_INFO_STRUC

		mov	eax, CURRENT_DEVICE_ID[bp]
		mov	ds:[si].VGA_ID, eax

		mov	ds:[si].VGA_DevNum, ch

		mov	al, CURRENT_BUS_NO[bp]
		mov	ds:[si].VGA_BusNum, al

		call	See_If_Bus_0
		jne	@F
		F000_CALL Ct_PCI_VGA_IDSEL		;CL=onboard PCI VGA
		cmp	ch, cl
		jne	@F
		mov	byte ptr ds:[si].OnboardVGA, 0Fh
	@@:

	No_Store_VGA:

		ret

Record_VGA_Devices	Endp

;======================================================================
;======================================================================
		ALIGN	4
Scan_PCI_VGA	Proc	Near

		push	ds
		pushad

		mov	byte ptr PCI_CBROM_TEMP[bp], 0		;set VGA flag for pci_cbrom_decompress subroutine
		mov	word ptr CBROM_BP_START[bp], (80h+1)*4	;option ROM start index of VGA device (from 86h)
		mov	word ptr CBROM_BP_END[bp], (86h+1)*4	;option ROM end index of VGA device (to 0A0h)
		mov	dword ptr CBROM_BUF_START[bp], 200000h	;VGA device and vender ID start address for decompress use
		call	fProc_Pci_CbRom_decompress

	;----------------------------------------------------------------
	; DS point to TEMP_PCI_REQ_BUF
	;----------------------------------------------------------------

		push	SEG TEMP_PCI_REQ_BUF
		pop	ds

	;----------------------------------------------------------------
	;PCI_VGA_DEVICE_BUF_PTR[bp] has a initial value of
	;'offset PCI_VGA_DEVICE_BUF', every PCI display device found will
	;cause this [bp] to increase a value of SIZE_VGA_INFO_STRUC
	;
	;  if [bp] value = initial value ===> no PCI VGA device exist
	;
	;  if VGA device found --> [bp] value <> initial value
	;			   [bp] value point to a empty entry
	;----------------------------------------------------------------

		mov	si, offset PCI_VGA_DEVICE_BUF	;SI -> top of buffer
		mov	di, PCI_VGA_DEVICE_BUF_PTR[bp]	;DI -> end of buffer
		cmp	di, si
		je	No_PCI_Display

	;----------------------------------------------------------------
	;We sort the PCI VGA buffer according to its bus num. & dev, func
	;no. in a decreasing order. Therefore the smallest(last) one
	;described in the buffer will be the one we should invoke.
	;----------------------------------------------------------------

		call	Sort_PCI_Request

	;----------------------------------------------------------------
	;1. We disable from the top of the buffer every VGA device until
	;   the one we should invoked.
	;
	;2. By subtracting the pointer DI by SIZE_VGA_INFO_STRUC, we
	;   disable VGA devices from SI to (DI-SIZE_VGA_INFO_STRUC).
	;
	;3. If C000 already had a valid ROM found, that means the ISA VGA is
	;   used instead. So step 2 should be skipped, i.e. we should disable
	;   all PCI VGAs found
	;----------------------------------------------------------------

		call	If_Any_VGA_BIOS_Exist
		je	@F

		sub	di, SIZE_VGA_INFO_STRUC
	@@:
		mov	al, ds:[si].VGA_BusNum
		mov	CURRENT_BUS_NO[bp], al
		mov	ch, ds:[si].VGA_DevNum

		cmp	si, di
		je	@F

 		mov	cl, 04h			;disable I/O, MEM decode
		xor	ax, ax
 		call	X_Set_CfgSpace_Word

		add	si, SIZE_VGA_INFO_STRUC
		jmp	@B
	@@:

	;----------------------------------------------------------------
	;Now, SI point to the VGA which should be invoked. If this value
	;is the same as the initial value of PCI_VGA_DEVICE_BUF_PTR[bp],
	;that means all PCI VGA are disabled
	;----------------------------------------------------------------

		cmp	si, PCI_VGA_DEVICE_BUF_PTR[bp]
		je	No_PCI_Display

	;----------------------------------------------------------------
	;Enable the path of the VGA device if it is decoded thru
	;P2P bridges
	;
	; i.e. we should enable bit3 of reg3Eh (VGA enable) of each P2P
	;      that the display device go thru
	;----------------------------------------------------------------

		push	word ptr CURRENT_BUS_NO[bp]
		push	cx
	@@:
		or	al, al				;AL = bus no
		je	@F
		call	Get_Bus_Info_Offset
		mov	al, ds:[si].P2PB_BusNo
		mov	CURRENT_BUS_NO[bp], al
  		mov	ch, ds:[si].P2PB_DevFucNo
		mov	cl, 3Eh
 		call	X_Get_CfgSpace_Byte
		or	al, 08h				;P2P VGA enabled
 		call	X_Set_CfgSpace_Byte
		mov	al, CURRENT_BUS_NO[bp]
		jmp	@B
	@@:
		pop	cx
		pop	word ptr CURRENT_BUS_NO[bp]

	;----------------------------------------------------------------
	;Set flag for PCI VGA being found:
	;
	;  1. byte ptr PCI_VGA_FOUND[bp] --> VGA_DEVICE_EXIST(=0AAh)
	;  2. word ptr PCI_VGA_INFO[bp]  --> High byte = bus no.
	;				     Low byte = dev & func no.
	;----------------------------------------------------------------

 		mov	byte ptr PCI_VGA_FOUND[bp]\
			, VGA_DEVICE_EXIST		;set VGA found flag!
 		mov	al, ch				;Low byte = dev & func no.
 		mov	ah, CURRENT_BUS_NO[bp]		;High byte = bus no.
 		mov	PCI_VGA_INFO[bp], ax

	;----------

		mov	eax, ds:[si].VGA_ID

		call	Record_Set_Mode3_VGA

 		call	Patch_S3_765			;patch for VGA

	ifdef 	ALIm152x_Special_Define
		call	Patch_ALIm152x_VGA
	endif	;ALIm152x_Special_Define

	ifndef	PCI_RESET_SUPPORT
		call	Patch_CT65548
 		jnc	No_Need_Video_Rom
	endif	;PCI_RESET_SUPPORT

		call	fProc_Find_VGA_ROM_Image
		jc	short No_Need_Video_ROM		;R17

		mov	si, 03000h
		call	Move_Video_Image_To_C000

	No_Need_Video_ROM:

;R17		call	X_Disable_PCI_ROM
		xor	eax, eax			;R17
		mov	cl, 30h				;R17
 		call	X_Set_CfgSpace_DWord		;R17

	No_PCI_Display:

		popad

;R07 		call	Process_Combined_VGA

		pop	ds

		ret

Scan_PCI_VGA	Endp

;======================================================
;======================================================
If_Any_VGA_BIOS_Exist	Proc	Near

		push	ds
		push	0C000h
		pop	ds
		cmp	word ptr ds:[0], 0AA55h		;ISA VGA exist?

		jne	@F

		push	si
		mov	si, 0C000h
		POST_FUNC_CALL Cksm_ROM
		pop	si
	@@:

		pop	ds
		ret

If_Any_VGA_BIOS_Exist	Endp

;[]============================================================[]
;Function : Patch for special PCI/VGA to avoid compatibility
;Input    : CH - device+function number
;	    EAX = device ID & vendor ID
;output   : none
;[]============================================================[]
Patch_S3_765	proc	near

		push	eax
;R10 - starts
	ifdef	PATCH_VERITE_V2200_FOR_MX_CPU					
		cmp	eax, (1163h SHL 16)+2000h	;Rendition V2200 ?
		je	Disable_6x86_Write_Gathering
	endif;	PATCH_VERITE_V2200_FOR_MX_CPU
;R10 - ends

	;The S3/765 PCI/VGA don't support display buffer write gathering
	;function. So , force disabling this function if 6x86 CPU used.

		cmp	eax, (5333H SHL 16) + 8811H

		mov	cl, 8			;revision number
		call	X_Get_CfgSpace_Byte
		cmp	al, 054H		;S3/765 ?
		jne	Not_S3Vga

	;Disable write gathering function for 6x86 CPU

	Disable_6x86_Write_Gathering:

		POST_FUNC_CALL Check_M1_Cpu 	;check if 6x86 CPU
		jne	Not_S3Vga		;skip if not 6x86

		F000_CALL Unlock_Cyrix		;open cyrix register locked

		mov	cl, 0dch		;RCR0
		mov	al, 01H			;no write gathering
		F000_CALL Set_Cyrix

		F000_CALL lock_Cyrix		;lock cyrix CPU register access

Not_S3Vga:
		pop	eax
		ret

Patch_S3_765	Endp

ifndef	PCI_RESET_SUPPORT
;======================================================
;Input : eax - device ID & vendor ID
;      : CH - device+function number
;output: carry set - Don't use shadow RAM
;	 non carry - use shadow RAM instead of video ROM
;======================================================
		align	4
Patch_CT65548	proc	near

		pushad
		push	ds

		cmp	eax, (102CH shl 16) + 00DCh	;C&T 65548 VGA?
		jne	No_VideROM			;no

		call	X_C000_Shadow_RW
		F000_CALL C000_Shadow_R

		call	If_Any_VGA_BIOS_Exist
		clc
		je	Chk_Video_Exit

	No_VideROM:

		stc

	Chk_Video_Exit:

		pop	ds
		popad
		ret

Patch_CT65548	endp
endif	;PCI_RESET_SUPPORT

;======================================================
;======================================================
ifdef	PATCH_VGA_USE_2E8h_PORT
Patch_VGA_USE_2E8h	proc	near

		mov	byte ptr SIO_COM_SETTING[bp], 0
		cmp	eax, (3d3dH shl 16) + 0004h	;Permedia 3Dlabs
		jne	No_Use_2E8h			;no
		mov	byte ptr SIO_COM_SETTING[bp], 40h

	No_Use_2E8h:

		ret

PATCH_VGA_USE_2E8h	endp
endif;	PATCH_VGA_USE_2E8h_PORT

ifdef 	ALIm152x_Special_Define
;======================================================
;Input : eax - device ID & vendor ID
;      : CH - device+function number
;======================================================
Patch_ALIm152x_VGA	Proc	Near

	ifdef	ONBOARD_PCI_VGA
		push	ax

		call	See_If_Bus_0
		jne	@F

		cmp	ch, (ONBOARD_PCI_VGA) SHL 3
		jne	@F

		mov	cl, 04h
		xor	ax, ax
		call	X_Set_CfgSpace_Word
	@@:
		pop	ax
	endif	;ONBOARD_PCI_VGA

		ret

Patch_ALIm152x_VGA	Endp
endif	;ALIm152x_Special_Define

;======================================================
;
; Some VGA cards need to be set to mode 3 when warm reset
;
;Input : eax - device ID & vendor ID
;      : CH - device+function number
;======================================================
Record_Set_Mode3_VGA	Proc	Near

		push	ds
		push	eax

		push	G_RAM
		pop	ds
		mov	si, offset System_Flag
;R18		mov	byte ptr ds:[si], not VGA_NEED_SET_MODE3
		and	byte ptr ds:[si], not VGA_NEED_SET_MODE3	;R18

		ror	eax, 16			;AX = Vendor ID

		cmp	ax, 5333H		;S3 PCI/VGA ?
		je	Yes_SpcVga

		cmp	ax, 1002H		;ATI PCI/VGA ?
		je	Yes_SpcVga

		cmp	ax, 1039H		;SiS PCI/VGA ?
		je	Yes_SpcVga

		cmp	ax, CIRRUS_VENDOR_ID
		jne	@F

	Yes_SpcVga:

		or	byte ptr ds:[si], VGA_NEED_SET_MODE3
	@@:

		pop	eax
		pop	ds

		ret

Record_Set_Mode3_VGA	Endp

;R07 ;[]==============================================================[]
;R07 ;[]==============================================================[]
;R07 Process_Combined_VGA	Proc	Near
;R07 
;R07 		call	If_Any_VGA_BIOS_Exist		;any VGA ?
;R07 		je	VgaBiosAlready			;yes, so no onboard!
;R07 
;R07 		mov	edi, 7000h
;R07 		POST_FUNC_CALL Find_Valid_ROM_Image
;R07 		jc	VgaBiosAlready
;R07 
;R07 		mov	si, 7000h
;R07 		call	Move_Video_Image_To_C000
;R07 
;R07 	VgaBiosAlready:
;R07 
;R07 		ret
;R07 
;R07 Process_Combined_VGA	Endp

;[]---------------------------------------------------------------[]
; Input	:	si = segment contain the VGA BIOS
;[]---------------------------------------------------------------[]
Move_Video_Image_To_C000	Proc	Near

		push	si
		call	X_C000_Shadow_RW
		mov	di, 0C000h
		mov	cx, 4000h		;32k to move
		call	X_Move_Codes
		pop	si

		mov	ds, si
		mov	al, byte ptr ds:[2]
		mov	byte ptr VGA_BIOS_LENGTH[bp], al

		cmp	byte ptr ds:[2], 40h	;VGA BIOS size =< 32k
		jbe	VgaBios32k		;yes, skip the following !

	;----- Copy the rest of the VGA codes other than 32k -----

		push	si

		call	X_C000_Shadow_RW
		F000_CALL Ct_C8_To_DF_RW	;enable shadow R/W

	;------------------------------------------------------------------
	;Fill unused shadow RAM with 0FFH to prevent SCT "unreport memory"
	;if VGA ROM size is bigger than 32Kb

		push	es
		push	0c800h		;destination segment address
		pop	es

		xor	di, di		;start from offset zero
		mov	ax, 0FFFFH
		mov	cx, 32*1024/2	;32kb to fill
		rep	stosw		;fill shadow RAM pattern 0FFH
		pop	es

	;------------------------------------------------------------------

		mov	cl, ds:[2]		;get code size to copy
		sub	cl, 40h			;code size other than 32k
		xor	ch, ch
		shl	cx, 8 			;in terms of word
		add	si, 800h		;starting from 32k
		mov	di, 0C800h		;copy to C800:0
		call	X_Move_Codes

		pop	si

		call	Record_Resource_For_Big_VGA

	;--- trying to disable the shadow not used for VGA bios -----

		shr	cx, 4

	KeepDisShd:

		pusha
		F000_CALL Ct_Disable_Shadow
		popa
		add	dh, ch
		cmp	dh, 0E0h
		jne	KeepDisShd

	;-----------------------

	VgaBios32k:

		ret

Move_Video_Image_To_C000	Endp

;-----------------------------------------------------
;input	:	si : VGA ROM image location
;output	:	dx : upper boundary addr for VGA
;		cx : shadow unit = 8000h/4000h
;-----------------------------------------------------
Record_Resource_For_Big_VGA	Proc	Near

		mov	ds, si
		mov	bl, ds:[2]		;VGA BIOS size
		cmp	bl, 40h			;VGA BIOS size =< 32k
		jbe	_JBRDE			;no !

		call	X_Ct_Shadow_Unit	;check chipset for shadow unit size
		mov	dx, 0D000h		;disable shadow: starting from D000
		cmp	ch, 80h			;shadow unit 32k ?
		je	@F			;yes !
		cmp	bl, 60h			;VGA BIOS >= 48k ?
		ja	@F			;yes !
		mov	dh, 0CCh		;disable shadow: starting from CC00
	@@:
	;-----------------------

		mov	eax, 0Fh		;assume C800-CBFF used
		cmp	dh, 0CCh		;really the case ?
		je	@F			;yes !
		mov	al, 0FFh		;CC00-CFFF also used !
	@@:
		or	LMEM_RESOURCE[bp], eax	;update resources
	_JBRDE:
		ret

Record_Resource_For_Big_VGA	Endp

;[]================================================================[]
; This routine is used to check if VGA BIOS has been condensed
; after VGA BIOS had been initialed. And reprepare LMEM_RESOURCE[bp]
;[]================================================================[]
fProc_Release_Shadow_From_PCI_VGA	Proc	Far

		pushad
		push	ds
		push	dword ptr LMEM_BEFORE_ROM[bp]

		call	X_Ct_Shadow_Unit	;check chipset for shadow unit size

		mov	dx, 0F20h
		cmp	cx, 4000h
		je	@F
		mov	dx, 0FF40h
	@@:
		mov	cl, VGA_BIOS_LENGTH[bp]

		cmp	cl, 40h
		jbe	RePrepare_Exit

		mov	ax, 0C000H
		push	ax
		pop	ds

		mov	ch, ds:[2]
		cmp	ch, 40h
		jae	@F
		mov	ch, 40h
	@@:
		cmp	cl, ch
		jbe	RePrepare_Exit
		mov	eax, 0FFFFFFFFh
		sub	cl, 40h

		mov	bl, dh
		cmp	cl, dl
		jbe	@F
		shl	bl, 4
		or	bl, dh
	@@:
		not	bl
		and	al, bl

		sub	ch, 40h
		mov	bl, 0
		jbe	@F
		mov	bl, dh
		cmp	ch, dl
		jbe	@F
		shl	bl, 4
		or	bl, dh
	@@:
		call	VGA_release_shadow_fill
		or	al, bl

		and	LMEM_RESOURCE[bp], eax
		and	LMEM_BEFORE_ROM[bp], eax
		xor	si, si

		F000_CALL Disable_Unused_Shadow

RePrepare_Exit:
		pop	dword ptr LMEM_BEFORE_ROM[bp]
		mov	eax, LMEM_BEFORE_ROM[bp]
		or	LMEM_RESOURCE[bp], eax

		pop	ds
		popad
		retf

fProc_Release_Shadow_From_PCI_VGA	Endp

VGA_release_shadow_fill	Proc	near

		pushad
		cld

		mov	al, ch	  	;ch = VGA size(now) - 32kbyte
		add	al, 40h
		shl	ax, 9
		mov	di, ax		;di = will fill start point

		cmp	cl, 20h		;if original VGA bios > 48k
		ja	unit_32k	;

		call	X_Ct_Shadow_Unit	;check chipset for shadow unit size
		cmp	cx, 4000h
		jne	unit_32k

		mov	cx, 0c000h	;cx = C000 - VGA bios end
		sub	cx, di
	   	jmp	@F
	unit_32k:
		mov	cx, di		;cx = 10000 - VGA bios end
		not	cx
		inc	cx
	@@:
		mov	ax, 0C000H
		mov	es, ax
		mov	al, 0ffh		;Fill the shadow (no use) = 0ffh
		rep	stosb
	@@:
		popad
		ret

VGA_release_shadow_fill	Endp

;[]================================================================[]
;
; This routine is used to set PCI/VGA to special state
; Before VGA/ROM initial
;
; Input  : none
; Output : none
;
;[]================================================================[]
fProc_Before_PciVGARomInit	Proc	Far

ifndef	No_Clear_Command_Res_Bit7

		pushad

;-------------------------------------------------------------------------;
;Enable address/data stepping for VGA card to fix VGA ROM initial failure
;for Acer's ATI/Mach32 card

		mov	cx, PCI_VGA_INFO[bp]	;ch = bus no. cl=dev+fun no
		or	cx, cx			;VGA found ?
		jz	No_PciVgaFound

		mov	CURRENT_BUS_NO[bp], ch	;bus number
		mov	ch, cl			;CH = device+func no.

	ifdef	No_Clear_Command_Res_Bit7_When_Trident975

		call	X_Get_Vendor_ID
		cmp	ax, 1023h		; Trident975 Vender ID
		jnz	@F

		call	X_Get_Device_ID
		cmp	ax, 9750h		; Trident975 Device ID
		jz	No_PciVgaFound
	@@:
	endif;	No_Clear_Command_Res_Bit7_When_Trident975

		mov	cl, 04H			;command register
		call	X_Get_CfgSpace_Word
		or	al, 80H			;enable address/data stepping
		call	X_Set_CfgSpace_Word

No_PciVgaFound:
;-------------------------------------------------------------------------;

		popad

endif;	No_Clear_Command_Res_Bit7

		retf

fProc_Before_PciVGARomInit	Endp

;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&                                                         &&&&&&
;&&&&&&               IRQ related routines                      &&&&&&
;&&&&&&                                                         &&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

;======================================================================
;======================================================================
Record_IRQ_Request	Proc	Near

		cmp	byte ptr CURRENT_SLOT[bp], 0FFh
		je	No_Record_IRQ_Request

		push	ds
		pusha
		push	SEG TEMP_PCI_REQ_BUF
		pop	ds

		push	ax			;save class code
		mov	cl, 3DH			;read interrupt pin
		call	X_Get_CfgSpace_Byte
		mov	bl, al			;temp put interrupt pin in BL
		pop	ax			;restore class code

		or	bl, bl			;no IRQ needed ?
		jz	No_IRQ_Req		;0 = no need !
		cmp	bl, 00000100b		;invalid value ?
		ja	No_IRQ_Req		;maximum value is 4 for INT D

		call	Check_No_Irq_Device	;device don't need IRQ?
		jc	No_IRQ_Req		;CF = don't need IRQ !

		mov	al, bl			;put interrupt pin in AL

	;******************************************************

		mov	bl, CURRENT_SLOT[bp]
		mov	bh, CURRENT_BUS_NO[bp]

	;---------------------------------------------------

		push	cx
		push	bx
	@@:
		or	bh, bh			;Bus 0 device?
		jz	@F			;yes, skip

		call	Get_P2P_IrqRoute	;get correct routing
						;for device go thru
						;1 level of P2P bridge
						;input AL = original INT#
						;output AL = INT# on P2P bridge

		push	ax			;get p2p info offset
		mov	al, bh
		call	Get_Bus_Info_Offset
		pop	ax

  		mov	ch, ds:[si].P2PB_DevFucNo
		mov	bh, ds:[si].P2PB_BusNo
		jmp	@B
	@@:
		mov	cl, bl			;current slot index
		call	Get_IrqRouting 		;input : AL - interrupt pin
						;output: AL - interrupt pin routed
		pop	bx
		pop	cx

	;---------------------------------------------------

		push	SEG IRQ_REQ_BUF
		pop	ds
		mov	di, offset IRQ_REQ_BUF_PTR
		mov	si, ds:[di]
		add	word ptr ds:[di], SIZE_IRQ_REQ_STRUC

		mov	ds:[si].IntPin, al
		mov	ds:[si].IrqReqDevNum, ch
		mov	ds:[si].IrqReqBusNum, bh
		mov	ds:[si].HostSlot, bl

	;******************************************************

	No_IRQ_Req:

		popa
		pop	ds

	No_Record_IRQ_Request:

		ret

Record_IRQ_Request	Endp

;[]==============================================================[]
;Check_No_Irq_Device:
;	Check device if it need IRQ or not
;Saves: all
;Input :
;	 CH - PCI device No.
;	 AX - Class code
;Output: carry set - No IRQ required
;	 no  carry - IRQ required
;[]==============================================================[]
Check_No_Irq_Device 	proc	near

		pushad

		cmp	ax, CLASS_IDE			;its a PCI IDE?
		je	Should_Not_Assign_IRQ

	;---------------------------------------------------------
	;Somebody want to have a setup item to decide whether IRQ
	;should be assigned fo USB controller or not
	;---------------------------------------------------------
	ifdef	USB_IRQ_SELECTABLE

		cmp	ax, CLASS_USB			;USB Class code
		jne	NotUsbDev			;no,
		mov	si, offset UsbIrq_Item		;get CMOS value
	 	call	X_GetItem_Value
	 	or	al, al				;enable IRQ for USB ?
		jz	Should_Not_Assign_IRQ		;no IRQ for USB !
		jmp	Should_Assign_IRQ
	NotUsbDev:

	endif	;USB_IRQ_SELECTABLE

	;---------------------------------------------------------
	;Somebody do not want IRQ for VGA devices
	;---------------------------------------------------------
	ifdef	NO_ASSIGN_PCIVGA_IRQ

		call	X_Chk_If_Class_VGA_1		;is it a VGA card?
		je	Should_Not_Assign_IRQ		;yes, skip IRQ

	endif	;NO_ASSIGN_PCIVGA_IRQ

	;---------------------------------------------------------
	;Somebody want to have a setup item to decide whether IRQ
	;should be assigned fo VGA devices or not
	;---------------------------------------------------------
	ifdef	PCI_VGA_IRQ_SETUP_ITEM

		call	X_Chk_If_Class_VGA_1		;is it a VGA card?
		jne	NotVgaDev			;no !

		mov	si, offset Assign_Pci_IRQ_Item	;read the item value
		call	X_GetItem_Value
		or	al, al				;IRQ needed ?
		jnz	Should_Assign_IRQ		;yes !

	   ;---------------------------------------------------------
	   ;set 0FFH to prevent default IRQ No. in 3CH is in 0-15
	   ;like ET3000 , it's default is 15 and bit7-4 is read only
	   ;---------------------------------------------------------

		mov	cl, 3CH				;IRQ No.
		mov	al, 0ffH
		call	X_Set_CfgSpace_Byte		;write PCI byte
		call	X_Get_CfgSpace_Byte		;read PCI byte
		cmp	al, 0FH				;bit7-4 read only
		jne	@F
		xor	al, al				;write 00H
		call	X_Set_CfgSpace_Byte		;write PCI byte
	@@:
		jmp	Should_Not_Assign_IRQ

	NotVgaDev:

	endif	;PCI_VGA_IRQ_SETUP_ITEM

	Should_Assign_IRQ:

		clc
		jmp	@F

	Should_Not_Assign_IRQ:

		stc
	@@:
		popad
		ret

Check_No_Irq_Device 	endp

;[]========================================================================[]
;Procedure  :	CMOS_Setup_IRQ_Resource
;
;Input	    :	None
;
;Output	    :	None
;
;Description:	1. PCIIRQ[BP] format:
;
;		       INT no. (1-16)	    IRQ no.
;		   +------------------+-------------------+
;		 1 |                  |     IRQ 14        |  0
;		   +------------------+-------------------+
;		 3 |                  |     IRQ 15        |  2
;		   +------------------+-------------------+
;		 5 |                  | 1st Available IRQ |  4
;		   +------------------+-------------------+
;		 7 |                  | 2nd Available IRQ |  6
;		   +------------------+-------------------+
;		 9 |                  | 3rd Available IRQ |  8
;		   +------------------+-------------------+
;		11 |                  | 4th Available IRQ | 10
;		   +------------------+-------------------+
;			  .                          .
;			  .                          .
;		   IRQ no.
;		   -------
;		   Indicates the available IRQ channels of 8259
;
;		   The Award PCI BIOS will fill the 1st-nth Available IRQs
;		   according to setup settings. IRQ 14 & 15 will always be
;		   placed in offset 0 & 2.
;
;		   INT no.
;		   -------
;		   lmost all PCI chipsets provides only a few interrupt pins
;		   for the PCI devices. The number of interrupt pins varies
;		   from chip to chip.
;
;		   Example:
;
;		   +------------------------+------------------------+
;		 5 |         1              |         10             |  4
;		   +------------------------+------------------------+
;		 7 |         2              |         11             |  6
;		   +------------------------+------------------------+
;		 9 |         0              |         09             |  8
;		   +------------------------+------------------------+
;
;		   This example tell us that INT pin 1/2 has been assigned
;		   with IRQ 10/11. IRQ 09 is still available
;
;		2. This routine will prepare the available IRQs for
;		   the code follows to assign to PCI devices.
;
;		   PCIIRQ[BP+n] n=0, 2, 4... will be placed with Available IRQs
;					   according to CMOS SETUP
;		   PCIIRQ[BP+m] m=1, 3 will be initialized to 0FFh indicates
;				      that IRQ 14, 15 are available exclusively
;				      for PCI IDE
;				m=5, 7..	will be initialized to to indicate
;					the corresponding IRQ is not yet
;					assigned to any other device
;
;[]========================================================================[]
CMOS_Setup_IRQ_Resource	Proc	Near

	;Copy available PCI IRQs into stack area

		mov	word ptr PCIIRQ[bp+0], 0ff0EH	;IRQ 14 for IDE

	ifdef	Special_IRQ_For_Second_IDE
		mov	word ptr PCIIRQ[bp+2], 0ff00H+\
			Special_IRQ_For_Second_IDE
	else	;Special_IRQ_For_Second_IDE
		mov	word ptr PCIIRQ[bp+2], 0ff0FH	;IRQ 15 for IDE
	endif	;Special_IRQ_For_Second_IDE

		mov	si, 4

ifndef	NEW_PNP_SETUP
		mov	ax, SEG PciIrq_Item
		mov	ds, ax
		mov	di, offset PciIrq_Item

	Next_PciIrq:

		cmp	word ptr ds:[di], -1		;end of PCI IRQ item ?
		je	EndPci_Irq

		push	si
		mov	si, ds:[di]
		call	X_GetItem_Value
		pop	si

		or	al, al				;bad IRQ ?
		jz	Next_Cmos_Irq			;skip it

		xor	ah, ah
		mov	word ptr PCIIRQ[bp+si], ax
		inc	si
		inc	si				;next IRQ
Next_Cmos_Irq:

		add	di, 2				;next available IRQ offset

		jmp	Next_PciIrq
endif	;NEW_PNP_SETUP

	EndPci_Irq:

		mov	word ptr PCIIRQ[bp+si], 00AAH	;last available IRQ

		ret

CMOS_Setup_IRQ_Resource	Endp

ifdef	PNP_BIOS
;[]==============================================================[]
;[]==============================================================[]
		Public	ESCD_IRQ_Resource
ESCD_IRQ_Resource	Proc	Near

		push	ds
		push	es

	;-------------------------------------------------------------------
	;Up to this moment, the ESCD tells us what IRQs are available & they
	;are stored in G_RAM:[SYSTEM_MAP+IRQ_MAP]. In addition, installation
	;of COM, LPT ports are also done. So we issue a call to subroutine
	;"Create_Resource_Map" in PNPPOST.ASM to exclude the IRQs used up by
	;COM/LPT ports!
	;-------------------------------------------------------------------

		mov	ax, G_RAM
		mov	ds, ax
		mov	es, ax
		ASSUME	DS:G_RAM

ifdef	NEW_PNP_SETUP
		call	New_PnP_Setup_IRQ_Resource
else	;NEW_PNP_SETUP
	ifdef	PNP_PCI_AUTO
		call	Old_PnP_Setup_IRQ_Resource
	endif	;PNP_PCI_AUTO
endif	;NEW_PNP_SETUP

		pop	es
		pop	ds

		ret

ESCD_IRQ_Resource	Endp

;R04 - starts
;----------------------------------------------------------------------
;Function : Reserve a IRQ for PCI boot device to sure system can boot
;	    from boot device ( like SCSI etc..)
;Input    : none
;Output   : none
;----------------------------------------------------------------------
		Public	fProc_Reserve_Irq_For_PciBootDev
fProc_Reserve_Irq_For_PciBootDev	Proc	Far

;Don't assign IRQ 5 for PCI or PnP devices if Ensoniq PCI sound card installed
;Note : This sound card need two IRQs , the first one is assigned by normal
;	PCI INT pin, another is direct using ISA's IRQ 5.

		pushad
		push	ds
		mov     dx, 1274h		;vendor ID
		mov	cx, 5000h		;device ID
		xor     si, si			;first device
		mov     ax, 0b102H		;find PCI device func. call
		int     1AH
		jc	Not_EnsoniqPciSound	;device found ?

	;enable SERR# for DOS sound blaster compatible

		mov	ch, bl				;device number
		mov	cl, 05h
		F000_CALL AGet_CfgSpace_Byte
		or	al, 01H				;enable SERR#
		F000_CALL ASet_CfgSpace_Byte

	ifdef	RESERVE_IRQ5_FOR_PCI_AUDIO
	;device found !
		mov	ax, G_RAM
		mov	ds, ax
		ASSUME	DS:G_RAM

		and	byte ptr ds:IRQ_MAP, NOT 20H;don't assign IRQ 5
	endif;	RESERVE_IRQ5_FOR_PCI_AUDIO
						;for PCI or PnP/ISA
Not_EnsoniqPciSound:

		pop	ds
		popad

ifdef	NEW_PNP_SETUP
ifdef	IRQ_FOR_BOOTDEV
		pushad
		push	ds

		mov	byte ptr RESERVE_PCIIRQ[bp], 0	;assume no IRQ reserved

	;scan if SCSI card plugged

		mov	si, offset BooDev_ClsCode

	Check_NextBootDev:

		mov	ecx, cs:[si]
		or	ecx, ecx
		jz	No_BootPci

		push	si
		xor     si, si			;first device
		mov     ax, 0b103H		;find PCI class code
		int     1AH
		pop	si

		add	si, 4			;next class code
		or	ah, ah			;device found ?
		jnz	Check_NextBootDev

	;boot device found , reserve a IRQ

		mov	ax, G_RAM
		mov	ds, ax
		ASSUME	DS:G_RAM

		mov	dx, word ptr ds:IRQ_MAP
	ifdef	AVAILABLE_PCI_IRQ
		and	dx, AVAILABLE_PCI_IRQ
	else	;AVAILABLE_PCI_IRQ
		and	dx, 0001111010100000b
	endif	;AVAILABLE_PCI_IRQ

		mov	si, offset PciIrq_BootDevOrder

	Chk_Nxt_PciIRq:

		mov	cl, cs:[si]		;get IRQ No. to check
		cmp	cl, -1			;end of table
		je	No_Irq_ForPci

		inc	si
		mov	ax, 1
		shl	ax, cl
		test	dx, ax
		jz	Chk_Nxt_PciIRq

		mov	byte ptr RESERVE_PCIIRQ[bp], cl	;save IRQ in buffer

	No_Irq_ForPci:
	No_BootPci:

		pop	ds
		popad

endif;	IRQ_FOR_BOOTDEV
endif;	NEW_PNP_SETUP

		retf

fProc_Reserve_Irq_For_PciBootDev	Endp

ifdef	NEW_PNP_SETUP
ifdef	IRQ_FOR_BOOTDEV
BooDev_ClsCode:
		dd	010000H			;SCSI
		dd	010400H			;RAID
		dd	018000H			;other mass storage controller
		dd	0			;end of table
endif;	IRQ_FOR_BOOTDEV
endif;	NEW_PNP_SETUP
;R04 - ends

;[]==============================================================[]
;[]==============================================================[]
ifdef	NEW_PNP_SETUP
New_PnP_Setup_IRQ_Resource	Proc	Near

		call	Get_Reserved_IRQ

		mov	dx, word ptr ds:IRQ_MAP
		call	Check_Ide_Exist			;check IDE devices

		cmp	byte ptr PCIIRQ[bp+1], 0FFh	;primary IDE
		je	@F

		and	dh, 10111111b
	@@:
		cmp	byte ptr PCIIRQ[bp+3], 0FFh	;secondary IDE
		je	@F

		and	dh, 01111111b
	@@:
	ifdef	AVAILABLE_PCI_IRQ
		and	dx, AVAILABLE_PCI_IRQ
	else	;AVAILABLE_PCI_IRQ
		and	dx, 0001111010100000b
	endif	;AVAILABLE_PCI_IRQ

		call	Assign_IRQ_Special

		mov	si, 4			;start from 3rd IRQ

		mov	di, offset ASSIGN_PCI_IRQ_TBL

Check_Available_IRQ:

		mov	bx, dx
		movzx	cx, byte ptr cs:[di]
		cmp	cx, 00ffh			;Is table's end ?
		je	ASSIGN_PCI_IRQ_EXIT
		push	cx
		mov	ax, 16
		sub	ax, cx
		xchg	al, cl
		shl	bx, cl
		pop	cx
		jnc	@f

		mov	PCIIRQ[bp+si], cx		;assign correct IRQ
		add	si, 2
@@:
		inc	di
		jmp	Check_Available_IRQ

ASSIGN_PCI_IRQ_EXIT:

		mov	word ptr PCIIRQ[bp+si], 00AAh
		ret

New_PnP_Setup_IRQ_Resource	Endp

ASSIGN_PCI_IRQ_TBL	Label	Byte
	ifndef	NO_RELEASE_IRQ15_FOR_PCI
		db	15
	endif;	NO_RELEASE_IRQ15_FOR_PCI
PciIrq_BootDevOrder	Label	Near
		db	11
		db	10
;R08		db	 9
		db	12
		db	14
	ifdef	PCIIRQ34_first_When_free
		db	 3
		db	 4
	endif	;PCIIRQ34_first_When_free
		db	 5
		db	 7
	ifndef	PCIIRQ34_first_When_free
		db	 3
		db	 4
	endif	;PCIIRQ34_first_When_free
		db	 9			;R08
		db    0ffh

endif	;NEW_PNP_SETUP

;[]==============================================================[]
;[]==============================================================[]
ifndef	NEW_PNP_SETUP
ifdef	PNP_PCI_AUTO
Old_PnP_Setup_IRQ_Resource	Proc	Near
		mov	si, offset PnP_Auto_Item
		call	X_GetItem_Value	    		;should we use manaul
		or	al, al				;override or ESCD ?
		jz	No_PnP_Auto		;manually override!

		mov	dx, word ptr ds:IRQ_MAP
		call	Check_Ide_Exist			;check IDE devices
		cmp	byte ptr PCIIRQ[bp+1], 0FFh	;primary IDE
		je	@F

		and	dh, 10111111b
	@@:
		cmp	byte ptr PCIIRQ[bp+3], 0FFh	;secondary IDE
		je	@F

		and	dh, 01111111b
	@@:
	ifdef	AVAILABLE_PCI_IRQ
		and	dx, AVAILABLE_PCI_IRQ
	else	;AVAILABLE_PCI_IRQ
		and	dx, 0001111010100000b
	endif	;AVAILABLE_PCI_IRQ

	ifdef	IRQ12_LAST_FOR_PCI
		push	dx			;save available IRQ
		and	dh, NOT 10H		;mask IRQ 12
	endif;	IRQ12_LAST_FOR_PCI

		mov	si, 4			;start from 3rd IRQ
		mov	cx, 16

Check_Available_IRQ:

		shl	dx, 1
		jnc	@f
		dec	cx
		mov	PCIIRQ[bp+si], cx
		inc	cx
		add	si, 2
	@@:
		loop	Check_Available_IRQ

	ifdef	IRQ12_LAST_FOR_PCI
		pop	dx			;save available IRQ
		test	dh, 10H			;IRQ 12 available
		jz	No_Irq12
		mov	cx, 12
		mov	PCIIRQ[bp+si], cx	;IRQ 12 is available
		add	si, 2			;next IRQ offset
	No_Irq12:
	endif;	IRQ12_LAST_FOR_PCI

		mov	word ptr PCIIRQ[bp+si], 00AAh

	No_PnP_Auto:

		ret
Old_PnP_Setup_IRQ_Resource	Endp
endif	;PNP_PCI_AUTO
endif	;NEW_PNP_SETUP

		ASSUME	DS:NOTHING

;-----------------------------------------------------------------
;Function : Put reserved IRQ to buffer for PCI assignment
;Input    : DS:G_RAM
;Output   : none
;-----------------------------------------------------------------
		ASSUME	DS:G_RAM
Get_Reserved_IRQ	proc	near

ifdef	NEW_PNP_SETUP
ifdef	IRQ_FOR_BOOTDEV
		mov	cl, byte ptr RESERVE_PCIIRQ[bp]	;get IRQ
		or	cl, cl				;IRQ reserved ?
		jz	No_IRQReserved

		mov	ax, 1
		shl	ax, cl
		or	word ptr ds:IRQ_MAP, ax
No_IRQReserved:
endif;	IRQ_FOR_BOOTDEV
endif;	NEW_PNP_SETUP
		ret

Get_Reserved_IRQ	endp

;---------------------------------------------------------------------------
;Function : Assign IRQ for onboard SCSI that don't route IRQ thru PCI-TO-ISA
;	    controller but route to super I/O's IRQIN
;Input    : dx - available IRQ for PCI devices
;Output   : none
;---------------------------------------------------------------------------
Assign_IRQ_Special	proc	near

ifdef	SCSI_IRQ_TO_336_SIRQ3
		push	bx
		push	si

		xor	al, al			;disable routing for 336
		POST_FUNC_CALL Set_336_Sirq3

ifdef	ONBOARD_ScsiChip
;Disable I/O and memory access for onboard device due to setup
		mov	si, offset Onboard_Scsi_Item
		call	X_GetItem_Value
		or	al, al			;disabled ?
		jz	Scsi_Disabled	;don't assign IRQ if disabled
endif;	ONBOARD_ScsiChip

		mov	si, offset IRQ_Order
Next_IRQorder:
		mov	cl, cs:[si]		;get IRQ No. order
		or	cl, cl			;end of table
		jz	Scsi_Disabled	;no IRQ available

		mov	bx, 1
		shl	bx, cl
		test	dx, bx			;IRQ available
		jnz	IRQ_GotIt

		inc	si
		inc	si			;get next IRQ order

		jmp	Next_IRQorder

IRQ_GotIt:
		not	bx
		and	dx, bx			;occupy IRQ

	;Program IRQ in configuration

 		mov	ch, (ONBOARD_ScsiChip_SLOT SHL 3)
		mov	al, cl			;IRQ number
		mov	cl, 3CH
		call	X_Set_CfgSpace_Byte

		mov	al, cs:[si+1]		;value to write for I/O chip
		POST_FUNC_CALL Set_336_Sirq3
Scsi_Disabled:
		pop	si
		pop	bx

endif;	SCSI_IRQ_TO_336_SIRQ3

ifdef	M1523B_USB
		POST_FUNC_call M1523B_USB_Irq
endif;	M1523B_USB

ifdef	ITE8330G_USB
		POST_FUNC_call ITE8330G_USB_Irq
endif;	ITE8330G_USB

		ret

Assign_IRQ_Special	endp

ifdef	SCSI_IRQ_TO_336_SIRQ3
	IRQ_INVERT	=	10H	;invert IRQ for PCI
 ifdef	IRQ_NO_INVERT
	IRQ_INVERT	=	00H	;no inverted IRQ for PCI
 endif;	IRQ_NO_INVERT
;			IRQ No. , Value to write
IRQ_Order	db	11	, (11001011b OR IRQ_INVERT) 	;IRQ 11
		db	10	, (11001010b OR IRQ_INVERT) 	;IRQ 10
;R08		db	 9	, (11001001b OR IRQ_INVERT) 	;IRQ 9
		db	12	, (11001111b OR IRQ_INVERT) 	;IRQ 12 (use IRQ15/SIRQ1 pin)
		db	 5	, (11000101b OR IRQ_INVERT)	;IRQ 5
		db	 7	, (11000111b OR IRQ_INVERT)	;IRQ 7
		db	 3	, (11000011b OR IRQ_INVERT)	;IRQ 3
		db	 4	, (11000100b OR IRQ_INVERT)	;IRQ 4
		db	 9	, (11001001b OR IRQ_INVERT) 	;IRQ 9 ;R08
		db	 0	, 0		;end of table

endif;	SCSI_IRQ_TO_336_SIRQ3

;-----------------------------------------------------------------------
;Function : Check on-chip IDE channels enabled or disabled
;	    Force IRQ 14 & 15 to not available if enabled
;Input    : BX - bit 15 = mask of IRQ 15 , 1-available , 0-not available
;	         ....
;Output   : BX
;-----------------------------------------------------------------------
Check_Piix_Ide	proc	near

ifdef	PIIX_IDE

		push	bx

		mov	si, offset Piix_IdeTbl	;point to IDE table

	Chk_NxtPiix:

		mov	cx, word ptr cs:[si]	;get device ID
		cmp	cx, -1			;last of table
		je	Piix_NotFound

		push	si
		mov     dx, 8086H                ;Intel vendor ID
		xor     si, si                   ;first device
		mov     ax, 0b102H               ;find PCI device func. call
		int     1AH
		pop	si
		jnc     Yes_Piix3

		add	si, 2			;next device
		jmp	Chk_NxtPiix

	Piix_NotFound:

		pop	bx
		jmp	Piix3_Exit

	Yes_Piix3:

		mov	ch, bl			;device & function number
		mov	cl, 40H			;register for IDE
		F000_CALL AGet_CfgSpace_Dword

		pop	bx
		test	ah, 80H			;1st channel IDE enabled?
		jz	Check_2nd
		and	bh, NOT 40H		;IRQ 14 is not available

	Check_2nd:

		shr	eax, 16			;for 2nd IDE
		test	ah, 80H			;1st channel IDE enabled?
		jz	Piix3_Exit

		and	bh, NOT 80H		;IRQ 15 is not available

	Piix3_Exit:

endif	;PIIX_IDE

		ret

Check_Piix_Ide	endp

ifdef	PIIX_IDE
Piix_IdeTbl:
		dw	7010H		;IDE of PIIX3
		dw	7111H		;IDE of PIIX4
		dw	-1		;end of table
endif	;PIIX_IDE

;-----------------------------------------------------------------------
;Input : DX - IRQ mapping
;Output: DX - IRQ mapping
;-----------------------------------------------------------------------
Check_Ide_Exist	proc	near

;check if first channel IDE devices connected

		push	bx
		mov     bx, dx			;save IRQ map

		call	Check_Piix_Ide

		mov	dx, 1f4h			;first channel
		call	Check_Port_Exist
		jne	No_Irq14
		and	bh, 10111111b		;mask IRQ 14
No_Irq14:

;check if second channel IDE devices connected

		mov	dl, 74h			;second channel
		call	Check_Port_Exist
		jne	No_Irq15
		and	bh, 01111111b		;mask IRQ 15
No_Irq15:
		mov	dx, bx			;restore IRQ map

	;Set available IRQs back for PnP card
		mov	word ptr ds:IRQ_MAP, bx

		pop	bx
		ret

Check_Ide_Exist	endp

endif	;PNP_BIOS

;[]==============================================================[]
;Input  : dx - port to check
;Output : zero set - port existed
;[]==============================================================[]
Check_Port_Exist proc	near

		mov	al, 0aah
		mov	ah, al
		out	dx, al
		NEWIODELAY
		not	al
		in	al, dx
		cmp	ah, al
		ret

Check_Port_Exist endp

;[]==============================================================[]
;Get_IrqRouting:
;	Get IRQ routing information
;Saves: all except AL
;Input : AL - interrupt pin to assign 1-INT A , 2-INT B , 3-INT C
;	      4-INT D
;	 CL - slot index 0-slot 1 , 1-slot 2, 2-slot 3 , 3-slot 4
;Output: AL - PCI INT Number
;
;[]==============================================================[]
Get_IrqRouting	proc	near
		push	si
		push	cx
		push	ax

		push	ds
		push	SEG IrqRout_Table		;data segment
		pop	ds

		xor	ch, ch
		shl	cl, 2			;which PCI slot ?
		mov	si, cx
		add	si, offset IrqRout_Table;IRQ routing table
		mov	ecx, ds:[si]		;get routed IRQ
	@@:
		dec	al
		jz	@F
		shr	ecx, 8
		jmp	@B
	@@:
		pop	ds

		pop	ax
		mov	al, cl	     		;new IRQ routed
		pop	cx
		pop	si

		ret

Get_IrqRouting	endp

;[]-------------------------------------------------------------------------[]
;Input  : AL - interrupt pin , 1-INTA , 2-INTB , 3-INTC , 4-INTD
;	  CH - device No.
;Output : AL - interrupt pin , 1-INTA , 2-INTB , 3-INTC , 4-INTD
;Note : Devices on P2P bus the IRQ routing should following table to implement
;	IRQs.
;	Device No.  	INT on Device 	INT on Connector
;	-----------	--------------	----------------
;	0, 4, 8, 12    	INTA 		INTA
;	16, 20, 24, 28 	INTB		INTB
;			INTC		INTC
;			INTD		INTD
;	------------------------------------------------
;	1, 5, 9, 13    	INTA 		INTB
;	17, 21, 25, 29 	INTB		INTC
;			INTC		INTD
;			INTD		INTA
;	------------------------------------------------
;	2, 6, 10, 14   	INTA 		INTC
;	18, 22, 26, 30 	INTB		INTD
;			INTC		INTA
;			INTD		INTB
;	------------------------------------------------
;	3, 7, 11, 15   	INTA 		INTD
;	19, 23, 27, 31 	INTB		INTA
;			INTC		INTB
;			INTD		INTC
;[]-------------------------------------------------------------------------[]
Get_P2P_IrqRoute 	proc	near

	ifdef	VT597_PP	;For VIA VP3 Chip

		pushad
		xor	bh, bh			;bus number
		mov	cx, VT597 + 8		;chip revision ID
		F000_CALL AGet_CfgSpace_Byte	;read VP3 revision
		cmp	al, 02h			;
		popad
		jae	No_Special_Routing

		cmp	bh, 1
		jne	No_Special_Routing
		ret

	No_Special_Routing:

	endif	;VT597_PP	;For VIA VP3 Chip

		push	cx

		shr	ch, 3
		and	ch, 03H
		add	al, ch		;set new INT pin
		cmp	al, 4
		jbe	@F
		sub	al, 4
	@@:
		pop	cx
		ret

Get_P2P_IrqRoute 	endp

;[]==============================================================[]
;[]==============================================================[]
Assign_IRQ_For_PCI_IDE	Proc	Near

;Most of chipset support on-chip IDE , so don't assign IRQ 14 & 15 for
;add-in PCI/IDE card if on-chip IDE is enabled.
		call	X_Ct_OnChip_IDE_Chk    		;on-chip IDE enable
		jnc	OnChipIde_Enabled		;yes, enabled

ifndef	NO_PCI_IDE_CARD
	;First check if PCI/IDE plugged
	;Don't assign IRQ 14 & 15 if PCI/IDE is connected to ISA

		mov	si, offset PCI_IDE_IRQ
		call	X_GetItem_Value
		cmp	al, 1				;ISA IRQ for PCI ?
		je	Last_Slot_IDE

		mov	bx, SEG PCI_SLOT_CFG		;setup item in F-seg
		mov	ds, bx
		mov	bx, offset PCI_SLOT_CFG
		mov	byte ptr CURRENT_SLOT[bp], 0	;init current slot
Try_Slot_IDE:
		mov	ch, ds:[bx]
		cmp	ch, 0ffh			;last PCI slot ?
		je	Last_Slot_IDE
		shl	ch, 3				;device no. at upper 5 bits

	ifdef	BUILD_IN_IDE_IDSEL
		call	See_If_Bus_0
		jne	Not_Built_In_IDE
		cmp	ch, BUILD_IN_IDE_IDSEL		;built in IDE ?
		je	Chk_Next_Slot_1			;yse, skip to next device No.
	Not_Built_In_IDE:
	endif	;BUILD_IN_IDE_IDSEL

Try_Slot_IDE_1:

		call	X_Get_Vendor_ID      		;check if valid PCI device ?
		jc	Chk_Next_Slot			;No PCI device

	ifdef SPECIAL_PCI_IDE_PRG
		F000_CALL CT_PRI_PCI_IDE_PRG
	endif; SPECIAL_PCI_IDE_PRG

		call	Check_PciIde  			;Is PCI/IDE card ?
		jnc	Chk_Next_Slot			;No, do nothing

;Don't assign IRQ 14 & 15 for PCI/IDE if it don't need IRQ , that is the
;content of 3dH is zero
		mov	cl, 3dH				;interrupt pin
		call	X_Get_CfgSpace_Byte
		or	al, al				;need IRQ ?

		jz	Chk_Next_Slot

		mov	cl, CURRENT_SLOT[bp]		;current slot index
		call	Assign_Pci_IDE			;assign IRQ 14 & 15 for PCI
		jmp	Last_Slot_IDE

Chk_Next_Slot:
		call	X_If_MultiFunc_Dev
		jnc	Try_Slot_IDE_1			;It is a Multi-Func card

Chk_Next_Slot_1:
		inc	bx				;next slot address
		inc	byte ptr CURRENT_SLOT[bp]	;next slot
		jmp	Try_Slot_IDE
Last_Slot_IDE:
endif	;NO_PCI_IDE_CARD

OnChipIde_Enabled:

		ret

Assign_IRQ_For_PCI_IDE	Endp

;[]==============================================================[]
;Check_PciIde:
;	Program PCI device with available IRQ
;Saves: all
;Input :
;	 CH - PCI device No.
;	 PCIIRQ - available 4 IRQs for PCI
;Output: carry set - PCI IDE found
;	 not carry - No PCI IDE found
;[]==============================================================[]
Check_PciIde 	proc	near
		pushad

		push	cx
		mov	cl, 0Ah			;Class Code + Revision ID
		call	X_Get_CfgSpace_DWord
		pop	cx

	;Fix dirty IDE chip , for example the WINBOND PCI/IDE
	;the vendor & device ID are OK , but class code is zero

		or	ax, ax			;invalid class code
		jnz	Valid_Class

		call	X_Get_Vendor_ID
		cmp	ax, 1c1cH		;WINBOND PCI/IDE ?
		je	PciIde_Exist

	Valid_Class:

		cmp	ax, CLASS_IDE		;PCI IDE ?
		jne	Not_PciIde

	PciIde_Exist:

		stc
		jmp	PciIde_Exit

	Not_PciIde:

		clc

	PciIde_Exit:

		popad
		ret
Check_PciIde 	endp

;[]==============================================================[]
;Assign_Pci_IDE:
;	Assign IRQ 14 & IRQ 15 for PCI/IDE
;Saves: all
;Input : CH - slot device number
;	 CURRENT_SLOT[bp] - current slot number
;Output: None
;[]==============================================================[]
Assign_Pci_IDE	proc	near
ifndef	NO_PCI_IDE_CARD

		pusha

		mov	si, offset First_IDE_INT
		call	X_GetItem_Value
		inc	al

		mov	cl, CURRENT_SLOT[bp]	;slot index
		call	Get_IrqRouting		;input : AL - interrupt pin
						;output: AL - interrupt pin routed
		mov	byte ptr PCIIRQ[bp+1], al;IRQ 14 used
		mov	ah, 14			;assign IRQ 14 for IDE
	ifdef	ALWAYS_EDGE_FOR_PCI_IDE
		xor	ch, ch			;edge trigger
	else;	ALWAYS_EDGE_FOR_PCI_IDE
		call	Get_Irq_Trigger
	endif;	ALWAYS_EDGE_FOR_PCI_IDE

	ifdef	LEVEL_TO_EDGE_FOR_PCI_IDE
		mov	ch, 80H			;bit 0 - level
						;    7 - convert
	endif;	LEVEL_TO_EDGE_FOR_PCI_IDE

		call	X_Ct_Set_PciIrq

	ifndef	NO_PCI_IDE_2ND_CONTROL
		mov	si, offset Second_IDE_channel
		call	X_GetItem_Value
		or	al, al
		jz	IDE_Assign_Ok
	endif;	NO_PCI_IDE_2ND_CONTROL

		mov	si, offset Second_IDE_INT
		call	X_GetItem_Value
		inc	al

		mov	cl, CURRENT_SLOT[bp]	;slot index
		call	Get_IrqRouting 		;input : AL - interrupt pin
						;output: AL - interrupt pin routed
		mov	byte ptr PCIIRQ[bp+3], al;IRQ 14 used

	ifdef	Special_IRQ_For_Second_IDE
		mov	ah, Special_IRQ_For_Second_IDE ;Special IRQ for IDE
	else	;Special_IRQ_For_Second_IDE
		mov	ah, 15			;assign IRQ 15 for IDE
	endif	;Special_IRQ_For_Second_IDE

	ifdef	ALWAYS_EDGE_FOR_PCI_IDE
		xor	ch, ch			;edge trigger
	else;	ALWAYS_EDGE_FOR_PCI_IDE
		call	Get_Irq_Trigger
	endif;	ALWAYS_EDGE_FOR_PCI_IDE

	ifdef	LEVEL_TO_EDGE_FOR_PCI_IDE
		mov	ch, 80H			;bit 0 - level
						;    7 - convert
	endif;	LEVEL_TO_EDGE_FOR_PCI_IDE
		call	X_Ct_Set_PciIrq

IDE_Assign_Ok:
		mov	byte ptr PCI_IDE_FOUND[bp], IDE_EXIST	;mark found
		popa

endif	;NO_PCI_IDE_CARD

		ret

Assign_Pci_IDE	endp

;R05 - starts
Open_IDE_2nd_Channel	proc	near

ifdef	SUPPORT_PCISLOT_IDE

		pushad
		push	ds

		mov	ax, cs
		mov	ds, ax

		mov	si, offset Second_IDE_channel
		call	X_GetItem_Value
		mov	bl, al			;save flag

		mov	ch, START_PCI_DEV[BP] 	;start slot, func

Scan_2nd_Channel:

		push	cx

		call	Check_PciIde   		;Is PCI/IDE card ?
		jnc	Check_Next_IDE		;No,do nothing

		xor	cl, cl			;Vendor ID
		call	X_Get_CfgSpace_DWord
		mov	edx, eax
		mov	si, offset PCI_IDE_TBL
	@@:
		lodsd
		cmp	ax, 0FFFFh		;end
		je	Check_Next_IDE		;yes

		cmp	eax, edx
		je	@F

		add	si, 2
		jmp	@B
	@@:
		mov	byte ptr PCI_IDE_EXIST[bp], 03
		mov	al, bl
		or	al, 0FEh
		and	PCI_IDE_EXIST[bp], al

		lodsw
		call	ax

	ifdef SPECIAL_PCI_IDE_PRG
		F000_call	CT_SEC_PCI_IDE_PRG
	endif ;SPECIAL_PCI_IDE_PRG

	Check_Next_IDE:

		pop	cx

		call	X_Get_Next_Device		;CH return next device to do
		jnc	Scan_2nd_Channel

		pop	ds
		popad

endif;	SUPPORT_PCISLOT_IDE

		ret

Open_IDE_2nd_Channel	Endp

ifdef	SUPPORT_PCISLOT_IDE
PCI_IDE_TBL:
		dw	01095H			;CMD vendor ID
		dw	00640h			;640 device ID
		dw	offset CMD_IDE_FUNC

		dw	01060H			;UMC vendor ID
		dw	00640h			;8673 device ID
		dw	offset UMC_IDE_FUNC

		dw	0100Bh			;NS vendor ID
		dw	0D001h			;87410 device ID
		dw	offset NS_IDE_FUNC

		dw	01C1CH			;Winbond vendor ID
		dw	00001h			;device ID
		dw	offset WINBOND_IDE_FUNC

		dw	010ADH			;new Winbond vendor ID
		dw	00001h			;device ID
		dw	offset WINBOND_IDE_FUNC

		dw	1098H			;QD8580 vendor ID
		dw	0002H			;QD8580 device ID
		dw	offset QD8580_Ide_Func

		dw	1106H			;VIA      vendor ID
		dw	0561H			;VT83C561 device ID
		dw	offset VT83C561_Ide_Func

		dw	0FFFFH			;end

;Input : BL - 00 = Disable 2nd channel
;	 BL - 01 = Enable 2nd channel
CMD_IDE_FUNC:
		mov	ah,00h			;Disable 2nd Channel
		or	bl,bl
		jz	@F

		mov	ah,08h			;Enable 2nd Channel
	@@:
		mov	cl,51H
		call	X_Get_CfgSpace_Byte
		and	al,not 08h
		or	al,ah
		call	X_Set_CfgSpace_Byte

		ret

		Public	UMC_IDE_FUNC
UMC_IDE_FUNC:
;Input : BL - 00 = Disable 2nd channel
;	 BL - 01 = Enable 2nd channel
		xor	ah, ah			;Disable 2nd Channel
		or	bl, bl
		jz	@F

		mov	ah, 40h			;Enable 2nd Channel
	@@:
		mov	cl, 0B0h
		F000_Call Open_8673
		and	al, 10111111b
		or	al, ah
		F000_Call Set_8673

		ret

;Input : BL - 00 = Disable 2nd channel
;	 BL - 01 = Enable 2nd channel
NS_IDE_FUNC:
		xor	ah, ah			;Disable 2nd Channel
		or	bl, bl
		jz	@F
		mov	ah, 08h			;Enable 2nd Channel
	@@:
		mov	cl, 47H
		call	X_Get_CfgSpace_Byte
		and	al, 11110111b
		or	al, ah
		call	X_Set_CfgSpace_Byte

		ret

;Input : BL - 00 = Disable 2nd channel
;	 BL - 01 = Enable 2nd channel
WINBOND_IDE_FUNC:
		xor	ah, ah			;Disable 2nd Channel
		or	bl,bl
		jz	@F
		mov	ah, 01h			;Enable 2nd Channel
	@@:
		mov	cl, 50H
		call	X_Get_CfgSpace_Byte
		and	al, 11111110b
		or	al, ah
		call	X_Set_CfgSpace_Byte

		ret

;Input : BL - 00 = Disable 2nd channel
;	 BL - 01 = Enable 2nd channel
QD8580_Ide_Func:
		xor	ah, ah			;Disable 2nd Channel
		or	bl, bl
		jz	@F
		mov	ah, 08h			;Enable 2nd Channel
	@@:
		mov	cl, 43H
		call	X_Get_CfgSpace_Byte
		and	al, 11110111b
		or	al, ah
		call	X_Set_CfgSpace_Byte

;Disable prefetch for QD8580 PCI/IDE
		mov	cl, 44H
		call	X_Get_CfgSpace_Byte
		and	al, 0f5H		;clear bit 3 & bit 1 to disable
		call	X_Set_CfgSpace_Byte
		ret

;Input : BL - 00 = Disable 2nd channel
;	 BL - 01 = Enable 2nd channel
VT83C561_Ide_Func:
		mov	cl, 40H
		call	X_Get_CfgSpace_Byte
		and	al, 0FEh
		or	al, bl
		call	X_Set_CfgSpace_Byte
		ret
endif;	SUPPORT_PCISLOT_IDE
;R05 - ends

;[]================================================================[]
;Function : Disable PCI/IDE on slot if onboard IDE is existed and
;	    enabled.
;Input  : none
;Output : none
;[]================================================================[]
Disable_Slot_IDE	proc	near
;Most of chipset support on-chip IDE , so disable I/O in command register for
;add-in PCI/IDE card if on-chip IDE is enabled.
		call	X_Ct_OnChip_IDE_Chk		;on-chip IDE enable
		jc	OnChipIde_Existed		;no, disabled

		mov	ax, SEG PCI_SLOT_CFG		;point DS to segment F000H
		mov	ds, ax
		mov	bx, offset PCI_SLOT_CFG

		mov	byte ptr CURRENT_BUS_NO[bp], 0	;from bus 0
		mov	byte ptr CURRENT_SLOT[bp], 0	;init current slot
CTry_Slot_IDE:
		mov	ch, ds:[bx]

ifdef VT586_USB
		cmp	ch, VT586_USB_ID
		je	Chk_Next_Slot_Ide
endif ;VT586_USB

		cmp	ch, 0ffh			;last PCI slot ?
		je	CLast_Slot_IDE
		shl	ch, 3				;device no. at upper 5 bits

CTry_Slot_IDE_1:

		call	Check_PciIde			;Is PCI/IDE card ?
		jnc	Chk_Next_Slot_Ide		;No, do nothing

		mov	cl, 4				;command register
		xor	al, al				;disable I/O & Mem.
		call	X_Set_CfgSpace_Byte
		jmp	CLast_Slot_IDE

Chk_Next_Slot_Ide:
		call	X_If_MultiFunc_Dev
		jnc	CTry_Slot_IDE_1			;It is a Multi-Func card

		inc	bx				;next slot address
		inc	byte ptr CURRENT_SLOT[bp]	;next slot
		jmp	CTry_Slot_IDE
CLast_Slot_IDE:
OnChipIde_Existed:
		ret
Disable_Slot_IDE	endp

;[]==============================================================[]
;[]==============================================================[]
		Public	Assign_IRQ_For_All_PCI
Assign_IRQ_For_All_PCI	Proc	Near

	;--------------------------------------------
	;Share IRQ for PCI device if lack of IRQs
	;--------------------------------------------

		mov	si, 4				;start from 3rd IRQ
		xor	bx, bx

	Find_Mark_AA:

		cmp	byte ptr PCIIRQ[bp+si], 0AAH	;last IRQ ?
		je	Set_Last_Irq

		mov	bl, byte ptr PCIIRQ[bp+si]	;save last IRQ
		inc	si
		inc	si
		jmp	Find_Mark_AA

	Set_Last_Irq:

		mov	PCIIRQ[bp+si], bx		;save last IRQ
		inc	si
		inc	si
		cmp	si, 18				;max. 8 IRQs to use
		jbe	Set_Last_Irq
		mov	byte ptr PCIIRQ[bp+si], 0AAH	;save last IRQ mark

	;----------------------------------------------------------------

		push	ds

		mov	ax, SEG IRQ_REQ_BUF
		mov	ds, ax
		mov	di, offset IRQ_REQ_BUF_PTR
		mov	di, ds:[di]

	Assign_Next_IRQ_Req:

		sub	di, SIZE_IRQ_REQ_STRUC
		cmp	di, offset IRQ_REQ_BUF
		jb	End_All_IRQs

		mov	al, ds:[di].IrqReqBusNum
		mov	CURRENT_BUS_NO[bp], al
		mov	al, ds:[di].HostSlot
		mov	CURRENT_SLOT[bp], al
		mov	ch, ds:[di].IrqReqDevNum
		mov	al, ds:[di].IntPin
   		call	Assign_PciIrq

		jmp	Assign_Next_IRQ_Req

	End_All_IRQs:

		pop	ds

		ret

Assign_IRQ_For_All_PCI	Endp

;[]==============================================================[]
;[]==============================================================[]
		Public	Prg_Onboard_ScsiChip
Prg_Onboard_ScsiChip	Proc	Near

ifdef	ONBOARD_NCR_SETUPABLE

	;Read setup value to decide to initial
	;built-in ROM for NCR or not.

		mov	si, offset Scsi_Item		;read setup value
		call	X_GetItem_Value
		or	al, al				;onboard SCSI enable?
		jnz	Ncr_Enabled			;yes , check this slot

		cmp 	ch, (ONBOARD_NCR_SLOT SHL 3)
		mov	cl, 04H
		xor	al, al
		call	X_Set_CfgSpace_Byte
		mov	byte ptr NCR_810_FOUND[bp], 0	;R03

	Ncr_Enabled:

endif	;ONBOARD_NCR_SETUPABLE

ifdef	ONBOARD_ScsiChip

		mov	byte ptr CURRENT_BUS_NO[bp], 0

	;Disable I/O and memory access for onboard device due to setup

		mov	si, offset Onboard_Scsi_Item
		call	X_GetItem_Value
		or	al, al			;disabled ?
		jnz	@F		;NZ = Enable

 		mov	ch, (ONBOARD_ScsiChip_SLOT SHL 3)
		mov	cl, 04H
		xor	ax, ax
		call	X_Set_CfgSpace_Byte

		mov	cl, 0Eh			;read header type
		call	X_Get_CfgSpace_Byte	;
		test	al, 80H			;multi-function support?
		jz	NotMultiFunc

	;disable second function device

		inc	ch			;next function
		mov	cl, 04H
		xor	al, al
		call	X_Set_CfgSpace_Byte	;

	NotMultiFunc:
	@@:
endif	;ONBOARD_ScsiChip

		ret

Prg_Onboard_ScsiChip	Endp

;----------------------------------------------
;Output : CH - IRQ trigger
;----------------------------------------------
Get_Irq_Trigger	proc	near

	ifndef	ALWAYS_LEVEL_PCI_IRQ

		push	si
		push	ax
		mov	si, offset PCI_IRQ_Method
		call	X_GetItem_Value
		mov	ch, al
		pop	ax
		pop	si

	else;	ALWAYS_LEVEL_PCI_IRQ

		mov	ch, 1	;level trigger

	endif;	ALWAYS_LEVEL_PCI_IRQ

		ret

Get_Irq_Trigger	endp

;[]==============================================================[]
;Assign_PciIrq:
;	Program PCI device with available IRQ
;Saves: all
;Input : AL - interrupt number to assign 1-INT 1 , 2-INT 2 , 3-INT 3
;	      4-INT 4 ....
;	 CH - PCI device No.
;	 PCIIRQ - available 4 IRQs for PCI
;Output: None
;[]==============================================================[]
Assign_PciIrq	proc	near

		pusha

		xor	si, si
Check_Next_Irq:
		test	byte ptr PCIIRQ[bp+si], 0fh	;valid IRQ No.
		jz	Next_Valid_Irq

		mov	ah, byte ptr PCIIRQ[bp+si+1]
		or	ah, ah				;not assigned ?
		je	Get_It

		cmp	ah, al				;alread assigned ?
		jne	Next_Valid_Irq
	Get_It:
		mov	byte ptr PCIIRQ[bp+si+1], al	;mark this IRQ assigned

		push	ax
		mov	al, byte ptr PCIIRQ[bp+si]	;get IRQ No.

		or	al, al				;IRQ 0 	    ?
		jnz	Not_Irq0			;No.
		mov	al, 0fh				;set IRQ 15
	Not_Irq0:

	ifdef	PNP_BIOS
		push	ax
		mov	cl, al
		mov	ax, 1
		shl	ax, cl
		or	word ptr PCI_IRQ_ASSIGNED[bp], ax
		pop	ax
	endif	;PNP_BIOS

		mov	cl, 3CH
		call	X_Set_CfgSpace_Byte
		pop	ax

		;now AL = INT number
		mov	ah, byte ptr PCIIRQ[bp+si]	;get IRQ No.
		mov	cl, CURRENT_SLOT[bp]		;slot index
		call	Get_Irq_Trigger
		call	Record_PCI_IRQ			;R12
		call	X_Ct_Set_PciIrq
		jmp	No_Valid_Irq		;finish assign

Next_Valid_Irq:
		add	si, 2				;next available IRQ
		cmp	byte ptr PCIIRQ[bp+si], 0AAH
		jne	Check_Next_Irq
No_Valid_Irq:

		popa
		ret

Assign_PciIrq	endp

;R12 - starts
Record_PCI_IRQ	Proc	Near

		pushad
		push	ds
		push	ax
		call	X_F000_Shadow_W
		pop	ax
		push	SEG PCI_IRQ_RECORD
		pop	ds
		mov	si, offset PCI_IRQ_RECORD
		mov	cl, ah
		mov	ax, 1
		shl	ax, cl
		or	word ptr ds:[si], ax

 		mov	ax, word ptr ds:[si]
 		mov	si, offset Get_PCI_IRQ_Record_Lo
 		mov	byte ptr ds:[si+1], al
 		mov	si, offset Get_PCI_IRQ_Record_Hi
 		mov	byte ptr ds:[si+1], ah

		call	X_F000_Shadow_R
		pop	ds
		popad
		ret

Record_PCI_IRQ	Endp
;R12 - ends

X_Get_Device_ID	Proc	Near
		call	fProc_Get_Device_ID
		ret
X_Get_Device_ID	Endp

X_Get_Vendor_ID	Proc	Near
		call	fProc_Get_Vendor_ID
		ret
X_Get_Vendor_ID	Endp

X_Get_CfgSpace_Byte	Proc	Near
		call	fProc_Get_CfgSpace_Byte
		ret
X_Get_CfgSpace_Byte	Endp

X_Get_CfgSpace_Word	Proc	Near
		call	fProc_Get_CfgSpace_Word
		ret
X_Get_CfgSpace_Word	Endp

X_Get_CfgSpace_Dword	Proc	Near
		call	fProc_Get_CfgSpace_Dword
		ret
X_Get_CfgSpace_Dword	Endp

X_Set_CfgSpace_Byte	Proc	Near
		call	fProc_Set_CfgSpace_Byte
		ret
X_Set_CfgSpace_Byte	Endp

X_Set_CfgSpace_Word	Proc	Near
		call	fProc_Set_CfgSpace_Word
		ret
X_Set_CfgSpace_Word	Endp

X_Set_CfgSpace_Dword	Proc	Near
		call	fProc_Set_CfgSpace_Dword
		ret
X_Set_CfgSpace_Dword	Endp

See_If_Bus_0	Proc	Near
		cmp	byte ptr CURRENT_BUS_NO[bp], 0
		ret
See_If_Bus_0	Endp

X_Disable_PCI_ROM	Proc	Near
		call	fProc_Disable_PCI_ROM
		ret
X_Disable_PCI_ROM	Endp

X_Get_Next_Device	Proc	Near
		POST_FUNC_CALL Get_Next_Device
		ret
X_Get_Next_Device	Endp

X_Chk_If_Class_VGA_1	Proc	Near
		POST_FUNC_CALL Chk_If_Class_VGA_1
		ret
X_Chk_If_Class_VGA_1	Endp

X_Mark_Addr_Not_Available	Proc	Near
		POST_FUNC_CALL Mark_Addr_Not_Available
 		ret
X_Mark_Addr_Not_Available	Endp

X_Invalidate_Shadow_Seg	Proc	Near
		POST_FUNC_CALL Invalidate_Shadow_Seg
		ret
X_Invalidate_Shadow_Seg	Endp

X_If_MultiFunc_Dev	Proc	Near
		POST_FUNC_CALL 	If_MultiFunc_Dev
		ret
X_If_MultiFunc_Dev	Endp

		Public	X_Move_Codes
X_Move_Codes	Proc	Near
		F000_CALL Move_Codes
		ret
X_Move_Codes	Endp

		Public	X_CPU_Cache
X_CPU_Cache	Proc	Near
		F000_CALL CPU_Cache
		ret
X_CPU_Cache	Endp

X_Ct_Set_PciIrq	Proc	Near
		F000_CALL Ct_Set_PciIrq
		ret
X_Ct_Set_PciIrq	Endp

X_Ct_Shadow_Unit	Proc	Near
		F000_CALL Ct_Shadow_Unit	;check chipset for shadow unit size
		ret
X_Ct_Shadow_Unit	Endp

X_C000_Shadow_RW	Proc	Near
		F000_CALL C000_Shadow_RW
		ret
X_C000_Shadow_RW	Endp

X_Ct_OnChip_IDE_Chk	Proc	Near
		F000_CALL Ct_OnChip_IDE_Chk    	;on-chip IDE enable
		ret
X_Ct_OnChip_IDE_Chk	Endp

;R12 - starts
		Public	X_F000_Shadow_W
X_F000_Shadow_W	Proc	Near
		F000_Call F000_Shadow_W
		ret
X_F000_Shadow_W	Endp

		Public	X_F000_Shadow_R
X_F000_Shadow_R	Proc	Near
		F000_Call F000_Shadow_R
		ret
X_F000_Shadow_R	Endp
;R12 - ends

endif	;PCI_BUS

XCODE		ENDS
ENDIF	;COMPILE_FOR_E0 EQ 1

		END
