;	[]==========================================================[]
;
;	    This source code is classified as confidential and
;	    contains trade secrets owned by Award Software, Inc.
;
;			Copyright 1984, 1993
;			Award Software, Inc.
;			All rights reserved.
;
;	[]==========================================================[]

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;--------------------------2A5II---------------------------------------------
;R27	12/26/97 PAL	Modify some code in ACPI on to off Legacy PM can be used normally 
;R26	12/24/97 PAL	Added ACPI SCI IRQ remapping for SCI IRQ device enable in WIN98
;R25    12/16/97 ATY    Added Fan on/off control by GPIO7 function
;R24	12/11/97 PAL	Added ACPI Support for Legacy PM and ACPI Switch
;R23	12/10/97 PAL	Added ACPI Function for Enable or Disable
;R22	11/14/97 PAL	Added ACPI Support for suspend
;R21    11/11/97 AVN    Added FUN control by GPIO5 function
;			define 'FAN_CONTROL_BY_GPIO5'
;R20	11/03/97 LAW	added "PM_LED_USE_GPIO" and "LED_Blinking_at_PM" (only ite8661cy)
;R18A	10/07/97 JKY	Fixed code mistake.
;R19	10/06/97 AVN	Chnage Power_B_O_R function to one push POWER ON/ one
;			push POWER off by define 'Power_B_O_R_as_Power_off'
;			and added 'HOT_KEY_AS_SUSPEND' support
;R18	10/02/97 JKY	Fixed 0v_suspend (only Win95 suspend button) resume 
;			after sound error (ESS 1869F) . See pmu.asm R02
;			def : softsmi_to_purposex2
;R17A	09/04/97 AVN	Fixed coding error.
;R17	09/02/97 AVN	Mode code from F000 to E000(SMBASE) for save code,
;			and fixed after suspend	wakeup by USB.
;R16	07/30/97 AVN	Fixed when enable USB control and enable USB legacy
;			support, and save then reboot, then entry setup and
;			disable USB control and save, when after boot and
;			press Ctrl-Alt-Delete will hang.
;R15	07/11/97 AVN	Added FUN control by GPCS0 function
;			define 'FAN_CONTROL_BY_GPCS0'
;			define 'GPCS0_FAN_Lo_Active' for output low turn fun on
;R14	07/04/97 AVN	Fixed can't be awakened from S1 state (code from SiS)
;R13A	06/11/97 AVN	Fixed screen garbage when resum to WIN95, because VGA
;			change to standard mode 3 will load hard font, so now
;			switch VGA to 300x200 16 color before resum.
;R13	06/10/97 AVN	Added notebook suspend to disk function by no new
;			supervga kernel.
;R12	05/16/97 AVN	Added Hot Key (Ctrl+Alt+Backspace) Support
;R11	05/13/97 AVN	Added ACPILED function support by define 'SUSPEND_SHOW_ACPILED'
;R10 	04/29/97 LRY	Support ACPI-buttom suspend
;R09	04/28/97 KEN	Support USB always enabled at POST stage, and
;			initialize USB before memory testing.
;R08	04/03/97 LRY	Special for Abit.
;R07	04/02/97 LRY	Support RING# SMI, define "SUPPORT_RING_SMI"
;R06	03/31/97 LRY	For notebook, run time don't call "Ct_C8_To_DF_RW"
;R05	03/28/97 KEN	Add USB_SUPPORT.
;R04	03/14/97 LRY	Support green assert GPIO pin  (OPTIONAL)
;R03	02/04/97 LRY	Added hook 'Get_Battery_UNIT'
;R02	01/17/97 LRY	Fixed can't resume from 0 volt suspend
;R01	01/14/97 LRY	Added hook 'Save_Ct_device' & 'Restore_Ct_device'
;R00	01/07/97 LRY	Initial version
.386p
		PAGE	56,132
		TITLE	CHIPSET  -- 386/486 EISA/ISA ROM/BIOS

		include BIOS.CFG
		include COMMON.MAC
		include COMMON.EQU
		include POST.MAC
		include BSETUP.INC
		include CMOS.EQU
		include 8042.EQU
A8259		=	20H			; first 8259
B8259		=	0A0H			; second (slave) 8259
END_OF_INT	=	20H			; end of interrupt code

		extrn	Get_Cmos:near
ifdef	PM_SUPPORT
;R20 - start
ifdef	PM_LED_USE_GPIO
		extrn	Set_PM_LED:near
endif;	PM_LED_USE_GPIO
ifdef	LED_Blinking_at_PM
		extrn	Set_PM_LED_Blinking:near
endif;	LED_Blinking_at_PM
;R20 - end
		EXTRN	CONFIG_TABLE:BYTE

		extrn	Set_Cmos:Near
		extrn	GetItem_Value:Near
	ifndef	CRT_Control_Not_In_APM
		extrn	Enable_CRT:near
		extrn	Disable_CRT:near
	endif	;CRT_Control_Not_In_APM
		extrn	PM_Option_Item:near
		extrn	PM_Auto_Table:near
		extrn	Get_Ct:near
		extrn	Set_Ct:near
		extrn	Get_Set_Ct:near
		extrn	NMI_Original:near
		extrn	Check_In_POST:near
		extrn	Not_SMI_Start:near
		extrn	CPU_Cache:Near
ifdef	PM_DISPLAY_ALONE
		extrn	Display_Item:Near
		extrn	Disp_Event2_Item:near
endif	;PM_DISPLAY_ALONE
		extrn	Wait_APM_Item:near
		extrn	HDD_Timer_Item:Near
		extrn	Suspend_Item:Near
		extrn	HDD_Timer_Item:Near
		extrn	SND_SPKR_TONE:near
		extrn	BCD_To_Binary:near
		extrn	E800_Shadow:near
		extrn	Doze_Item:Near
		extrn	Standby_Item:Near
		extrn	Vga_Type_Item:Near
		extrn	Chk_Intel_S_CPU:near
		extrn	Video_Off_Item:near
		extrn	Set_HDD_Standby_Timer:near
		extrn	Doze_Speed_Item:near
		extrn	Standby_Speed_Item:near
;R04 - start
		GREEN_ASSERT_PIN = 0
ifdef	GREEN_ASSERT_GPIO5
		GREEN_ASSERT_PIN = 1
endif	;GREEN_ASSERT_GPIO5
if	GREEN_ASSERT_PIN ne 0
		extrn	GPIO_STPCLK_DEF:near
endif
;R04 - end

ifdef	ACPI_Support					;R23
		extrn	ACPI_option_Item:near		;R23
endif	;ACPI_Support					;R23

ifdef	Notebook_Power_Management
		extrn	Suspend_0V:near
		extrn	Resume_0V:near
ifndef	NEW_SUPERVGA_KERNEL				;R13
		extrn	Rep_Save_VGA:near		;R13
		extrn	Rep_Restore_VGA:near		;R13
		extrn	Get_VGA_Att:near		;R13
		extrn	Set_VGA_Att:near		;R13
		extrn	Set_VGA_Reg:near		;R13
		extrn	Reset_VGA_FF:near		;R13
		extrn	Wait_VRetrace:near		;R13
		extrn	Get_CRTC_Addr:near		;R13
		extrn	VIDEO_FUNC:near			;R13
endif;	NEW_SUPERVGA_KERNEL				;R13
endif	;Notebook_Power_Management
ifdef	LCD_CRT_OPTION
		extrn	Video_Func:near
endif	;LCD_CRT_OPTION

		extrn	Get_PMU:near
		extrn	Set_PMU:near
		extrn	Get_Set_PMU:near
		extrn	Get_PM_RAM_Seg:Near
		extrn	Open_PM_RAM:Near
		extrn	Close_PM_RAM:Near
		extrn	Issue_SW_SMI:near
		extrn	Software_SMI:near

		extrn	REAL_IDT_LOC:near		;R02
endif	;PM_SUPPORT

;R05 - start
		extrn	F000_Func_End:near
		extrn	F000_Vect:near

IFDEF		USB_SUPPORT
		extrn	USB_Item:near			;R16
		extrn	USB_Legacy_Item:near
COMPILE_FOR_USBBIOS	=	1
		include	USBBIOS.ASM
ENDIF		;USB_SUPPORT
;R05 - end

DEF_SEGMENT	MACRO	SegmentAddr
if	SegmentAddr eq 0F000h
FCODE		SEGMENT USE16 PUBLIC 'CODE'
     		ASSUME	CS:DGROUP,DS:NOTHING,ES:NOTHING
elseif	SegmentAddr eq 0E000h
EGROUP		GROUP	ECODE
ECODE		SEGMENT USE16 PUBLIC 'ECODE'
     		ASSUME	CS:EGROUP,DS:NOTHING,ES:NOTHING
endif
		ENDM


END_SEGMENT	MACRO	SegmentAddr
if	SegmentAddr eq 0F000h
FCODE		ENDS
elseif	SegmentAddr eq 0E000h
ECODE		ENDS
endif
		ENDM


Hook		MACRO	HookName,HookSegment,OriginalSegment
			Public	HookName
ifb	<HookSegment>
	HookSegment1 = 0F000h
else
	HookSegment1 = HookSegment
endif
ifb	<OriginalSegment>
	OriginalSegment1 = 0F000h
else
	OriginalSegment1 = OriginalSegment
endif
if	HookSegment1 eq OriginalSegment1
 if	LastHook ne HookSegment1
 		END_SEGMENT	LastHook
 		DEF_SEGMENT	HookSegment1
 endif
 HookName		Proc	near
 FarProc = 0
else
 if	LastHook ne OriginalSegment1
 		END_SEGMENT	LastHook
 		DEF_SEGMENT	OriginalSegment1
 endif
	HookName:
		call	far ptr HookName&_FarCal
		ret
 if	OriginalSegment1 ne HookSegment1
 		END_SEGMENT	OriginalSegment1
 		DEF_SEGMENT	HookSegment1
 endif
 HookName&_FarCal	Proc	far
 FarProc = 1
endif
 LastHook = HookSegment1
		ENDM


EndH		MACRO	HookName,BackToSegment
if	FarProc
 HookName&_FarCal	Endp
else
 HookName		Endp
endif
ifnb	<BackToSegment>
 if	LastHook ne BackToSegment
 		END_SEGMENT	LastHook
 		DEF_SEGMENT	BackToSegment
 LastHook = BackToSegment
 endif
endif
		ENDM


EFcall		MACRO	Routine,RoutineSegment
ifb	<RoutineSegment>
	RoutineSegment1 = 0F000h
else
	RoutineSegment1 = RoutineSegment
endif
	F000_Name = 0
ifidni	<&Routine>,<Get_Ct>
	F000_Name = 1
endif
ifidni	<&Routine>,<Set_Ct>
	F000_Name = 1
endif
ifidni	<&Routine>,<Get_Set_Ct>
	F000_Name = 1
endif
ifidni	<&Routine>,<Get_Pci>
		EFcall	Get_Ct
		EXITM
endif
ifidni	<&Routine>,<Set_Pci>
		EFcall	Set_Ct
		EXITM
endif
ifidni	<&Routine>,<Get_PMU>
		EFcall	Get_Ct
		EXITM
endif
ifidni	<&Routine>,<Set_PMU>
		EFcall	Set_Ct
		EXITM
endif
ifidni	<&Routine>,<Get_Set_PMU>
		EFcall	Get_Set_Ct
		EXITM
endif
ifidni	<&Routine>,<GetItem_Value>
	F000_Name = 1
endif
ifidni	<&Routine>,<GetItem_Or>
		extrn	GetItem_Or:near
	F000_Name = 1
endif

if	RoutineSegment1 eq 0F000h
 if	F000_Name eq 1
  if	LastHook eq 0F000h
 		call	Routine
  elseif	LastHook eq 0E000h
		extrn	F000_&Routine:near
 		call	F000_&Routine
  endif	
 else
  if	LastHook eq 0F000h
 		call	Routine
  elseif	LastHook eq 0E000h
		extrn	F000_call_proc:near
 		F000_call	DGROUP:Routine
  endif	
 endif	;F000_Name eq 1
elseif	RoutineSegment1 eq 0E000h
 if	LastHook eq 0E000h
 		call	Routine
 elseif	LastHook eq 0F000h
 		post_func_call	EGROUP:Routine
 endif	
endif
		ENDM
		LastHook = 0F000h

;[]--------------------------------------------------------------------------[]
; Power Management registers definition for SIS/551X
;[]--------------------------------------------------------------------------[]

RSM		MACRO
		db     0FH,0AAH 	; Not defined in MASM.
		ENDM

FIXOFST 	MACRO	ADDRESS
		dw	offset ADDRESS - offset SMI_Handler_Start
		ENDM

READ_PCI	MACRO	PORT
		mov	dx,0cf8H		;configuration index
		mov	ax,8000H
		shl	eax,16
		mov	ax,PORT
		out	dx,eax
		add	dl,4
		in	eax,dx
		ENDM

;[]-----------------------------------------------------------------------[]
;     GGGGGGGG		   RRRRRRRR	    AA	     MMM       MMM
;   GGGGGGGGGGG 	   RRRRRRRRR	   AAAA      MMMMM   MMMMM
;  GGGG 		   RRR	  RRR	  AAAAAA     MMMMMM MMMMMM
;  GGG	  GGGGG 	   RRRRRRRRR	 AAA  AAA    MMM MMMMM MMM
;  GGGG     GGGG	   RRRRRRRR	AAAAAAAAAA   MMM MMMMM MMM
;   GGGGGGGGGGGG	   RRR	 RRR   AAAAAAAAAAAA  MMM  MMM  MMM
;    GGGGGGGGGG  ========  RRR	  RRR AAA	 AAA MMM  MMM  MMM
;[]-----------------------------------------------------------------------[]
G_RAM		SEGMENT USE16 AT 0

		ORG	04H*4
		include SEG_0.INC

		ORG	400H
		include G_RAM.INC

G_RAM		ENDS


ifdef	Notebook_Power_Management
SM_RAM		SEGMENT USE16 AT 0
		INCLUDE SM_RAM.INC
SM_RAM		ENDS

ZV_Temp_Stack	SEGMENT USE16 AT 0
		org	1000h
VIDEO_BUFFER	LABEL	WORD
		org	2000h
VMode_BUFFER	LABEL	WORD
		org	0FFF0h
ZV_STACK_TOP	LABEL	DWORD
ZV_Temp_Stack	ENDS
endif	;Notebook_Power_Management

SMI_STRUCT	STRUC
		dd	?
_SpSave 	dw	1 dup (?)
_EspSave	dd	1 dup (?)
_EaxSave	dd	1 dup (?)
_EbxSave	dd	1 dup (?)
_Cr2Save	dd	1 dup (?)
_Cr3Save	dd	1 dup (?)
_Gdt		dq	1 dup (0)
		dw	1 dup (?)
		dw	1 dup (?)
		db	1 dup (?)
		db	1 dup (?)
		db	1 dup (?)
		db	1 dup (?)
		dw	1 dup (?)
		dw	1 dup (?)
		db	1 dup (?)
		db	1 dup (?)
		db	1 dup (?)
		db	1 dup (?)
_DsSave 	dt	1 dup (?)
_EsSave 	dt	1 dup (?)
_SsSave 	dt	1 dup (?)
_FsSave 	dt	1 dup (?)
_GsSave 	dt	1 dup (?)
_LdtSave	dt	1 dup (?)
_TskSave	dt	1 dup (?)
_Dstemp 	db	10 dup (?)
_GdtSave	df	1 dup (?)
_GdtNew 	dw	1 dup (?)
		dd	1 dup (?)
_IdtSave	df	1 dup (?)
_RealModeIdt	dw	1 dup (?)
		dd	1 dup (?)
SMI_STRUCT	ENDS

ifdef	PM_SUPPORT

;[]-----------------------------------------------------------------------[]
;  PPPPPPPPP  MMM	MMM	  RRRRRRRR	   AA	    MMM       MMM
;  PPP	  PPP MMMMM   MMMMM	  RRRRRRRRR	  AAAA	    MMMMM   MMMMM
;  PPPPPPPPP  MMMMMM MMMMMM	  RRR	 RRR	 AAAAAA     MMMMMM MMMMMM
;  PPPPPPPP   MMM MMMMM MMM	  RRRRRRRRR	AAA  AAA    MMM MMMMM MMM
;  PPP	      MMM MMMMM MMM	  RRRRRRRR     AAAAAAAAAA   MMM MMMMM MMM
;  PPP	      MMM  MMM	MMM	  RRR	RRR   AAAAAAAAAAAA  MMM  MMM  MMM
;  PPP	      MMM  MMM	MMM ===== RRR	 RRR AAA	AAA MMM  MMM  MMM
;[]-----------------------------------------------------------------------[]
PM_RAM		SEGMENT USE16 AT 0

		ORG	0

PM_RAM_START	LABEL	BYTE

		include PM_RAM.INC
		include CT_PMRAM.INC

PM_RAM_LEN	EQU	$-Offset PM_RAM:PM_RAM_START

PM_RAM		ENDS
endif	;PM_SUPPORT

DGROUP		GROUP	FCODE
FCODE		SEGMENT USE16 DWORD Public 'CODE'
		ASSUME	CS:DGROUP

ifdef	PM_SUPPORT
;[]-------------------------------------------------------------------[]
;
; PPPPPPPP	 AA	  RRRRRRRR   TTTTTTTTTTT	       111
; PPPPPPPPP	AAAA	  RRRRRRRRR  TTTTTTTTTTT    ***       1111
; PPP	 PPP   AAAAAA	  RRR	 RRR	 TTT	    ***      11111
; PPPPPPPPP   AAA  AAA	  RRRRRRRRR	 TTT		       111
; PPPPPPPP   AAAAAAAAAA   RRRRRRRR	 TTT	    ***        111
; PPP	    AAAAAAAAAAAA  RRR	RRR	 TTT	    ***        111
; PPP	   AAA	      AAA RRR	 RRR	 TTT		       111
;
;
;   1. Standard routines that must be filled in to let the BIOS KERNAL
;      to program the PMU registers
;   2. Called during POST & after POST
;
;[]-------------------------------------------------------------------[]

;[]========================================================================[]
;Procedure:	Get_PM_IRQ
;
;Function :	Tell BIOS which IRQ is PMI using
;
;Input	  :	None
;
;Output   :	NC:
;			AL = 1	- PMI using IRQ 15
;			AL = 2	- PMI using NMI
;			AL = 3	- PMI using SMI
;		CF:
;			No IRQ or NMI or SMI is available
;
;Preserve :	All except AX & FLAG
;
;Note	  :	1. Stack available
;		2. called from PM_Init
;[]========================================================================[]
		Public	Get_PM_IRQ
HOOK	Get_PM_IRQ
		mov	al,3		;SMI
		clc
		ret
ENDH	Get_PM_IRQ

;[]========================================================================[]
;Procedure:	Check_PM_Using_NMI
;
;Function :	To handle the NMI which is caused by a PMU
;
;Input	  :	None
;
;Output   :	None
;
;Saves	  :	Please save all registers
;
;[Note]   :	1. Called every time a NMI is occured
;		2. check to see if this SMI is issue by PMU
;
;		     if PMI ;  Serve the PMI then
;
;			       sti
;			       iret
;
;		     if not PMI : jump back to a external label(near)
;				  named "NMI_Original" & do nothing!
;
;		   So if your chip never use NMI, just "jmp NMI_Original"!
;
;[]========================================================================[]
		Public	Check_PM_Using_NMI
Check_PM_Using_NMI:
		jmp	NMI_Original

;[]-------------------------------------------------------------------[]
;
; PPPPPPPP	 AA	  RRRRRRRR   TTTTTTTTTTT	       2222222
; PPPPPPPPP	AAAA	  RRRRRRRRR  TTTTTTTTTTT    ***       22222222
; PPP	 PPP   AAAAAA	  RRR	 RRR	 TTT	    ***      222  222
; PPPPPPPPP   AAA  AAA	  RRRRRRRRR	 TTT			 222
; PPPPPPPP   AAAAAAAAAA   RRRRRRRR	 TTT	    *** 	222
; PPP	    AAAAAAAAAAAA  RRR	RRR	 TTT	    ***        2222222
; PPP	   AAA	      AAA RRR	 RRR	 TTT		      22222222
;
;
;		Called during POST Only
;
;[]-------------------------------------------------------------------[]

;[]========================================================================[]
;Procedure:	Ct_Check_Green_VGA
;
;Function :	To tell BIOS kernel that if the VGA adaptor's V/H SYNC
;		signal should be turned off or not when video off.
;		This should refer to the setup setting.
;
;Input	  :	None
;
;Output   :	ZF : don't turned off V/H SYNC
;		NZ : V/H SYNC can be turned off
;
;Note	  :	1. Some VGA adaptors use V/H SYNC signals for special
;		   purpose, e.g. TSENG LAB use them for DRAM refresh.
;		   Therefore, these signals must never be turn off
;		   at any time.
;		2. called from POST at POST 82
;[]========================================================================[]
			Public	Ct_Check_Green_VGA
HOOK	Ct_Check_Green_VGA
		pusha
		mov	si,offset DGROUP:VGA_Type_Item
		EFcall	GetItem_Or
		popa
		ret
ENDH	Ct_Check_Green_VGA

;[]==============================================================[]
;Input: None
;Function :	To see if it is a SMI
;[]==============================================================[]
			Public	Ct_Check_SMI_Start
HOOK	Ct_Check_SMI_Start
		jmp	Not_SMI_Start
ENDH	Ct_Check_SMI_Start

;[]==============================================================[]
;Procedure:	PM_Option_Check
;
;Function :	Get PM option
;
;Input	  :	None
;
;Output   :	1. ZF  - User Defined!
;			 i.e. use CMOS value to prg PM chip
;
;		   NZ  - Use Pre-defined value to prg PM chip
;			 AL = PM option
;			    i.e. DISBLED
;				 MAX-POWER_SAVING
;				 MIN-POWERING-SAVING....
;			 SI = offset of auto-table
;			    i.e. MIN_PM_SAVING_TABLE
;				 MAX_PM_SAVING_TABLE
;				 PM_DISABLE_TABLE	   in file PFEATURE.ASM
;
;		2. CF  - Global Power Management should be disabled
;
;		   NC  - Global Power Management should be enabled
;
;Registers :	FLAGS, AX, SI - destroyed
;		Others	      - should be preserved
;[]==============================================================[]
HOOK	PM_Option_Check
;R22 - start
ifdef	ACPI_SUPPORT
		mov	cx, 86Ah 		;R26
		mov	al, 09h			;R26
		call	Set_PMU			;R26

		mov	dx, ACPI_BASE_IO_ADDR+28H	;SMI enable command value
		mov	al, 0a1h
		out	dx, al

		mov	dx, ACPI_BASE_IO_ADDR+29H	;SMI disable command value
		mov	al, 0a0h
		out	dx, al

		mov	dx, ACPI_BASE_IO_ADDR+26H	;enable and disable SMI command
		in	al, dx				;R27
		or	al, 18h				;R27
		out	dx, al

		mov	dx, PRC_CNT_BLK
		in	ax, dx
		or	ax, CLK_EN
		out	dx, ax

		mov	dx, ACPI_BASE_IO_ADDR+16H
		xor	ax, ax
		out	dx, ax

;R27		mov	dx, ACPI_BASE_IO_ADDR+1AH
;R27		mov	ax, 0307h
;R27		out	dx, ax


endif;	ACPI_SUPPORT
;R22 - end

		mov	si,offset cs:PM_Option_Item
		EFcall	GetItem_Value
		mov	cl,al
		xor	ch,ch

		mov	si,offset cs:PM_Auto_Table
		shl	cx,1
		dec	cx
		add	si,cx
		mov	si,cs:[si]

PM_Option_Check_Exit:

		cmp	al,1			;PM disabled?
		je	short @F		;yes

	;if PM option is "user defined" then OEM routine should
	;check here for both items disabled

		or	al,al			;set/clear Zero Flag
		clc
		ret

	@@:
		or	al,al			;set/clear Zero Flag
ifdef	ACPI_SUPPORT				;R22
		clc				;R22
else						;R22
		stc				;indicate PM disable
endif;	ACPI_SUPPORT				;R22
		ret

ENDH	PM_Option_Check

;[]==================================================================[]
;Procedure:	Ct_Global_PM_Disable
;
;Function :	To disable all power management features
;
;Input	  :	None

;Output   :	None
;
;Registers:	all registers preserved
;
;[Note]   :	called from PM_INIT before PM_RAM is available
;[]==================================================================[]
HOOK	Ct_Global_PM_Disable
		pushad
		mov	cx, 9Ah 		;SMI Enable register
		xor	al, al			;all disable
		EFcall	Set_PMU
		popad
		ret
ENDH	Ct_Global_PM_Disable

;[]==================================================================[]
;Procedure:	Clear_PM_RAM
;
;Function :	Clear power management data area (PM_RAM segment)
;		This routine is used to clear extended BIOS data area
;		in order to provide a clean environment for power
;		management code
;
;Input	  :	ES : PM_RAM

;Output   :	None
;
;Registers:	all registers preserved except FLAGS
;
;[Note]   :	called from PM_INIT
;[]==================================================================[]
HOOK	Clear_PM_RAM

		ASSUME	ES:PM_RAM

		pusha
		mov	di,offset PM_RAM:PM_RAM_START
		mov	cx,PM_RAM_LEN
		xor	ax,ax
		cld
		rep	stosb

		popa
		ret

ENDH	Clear_PM_RAM
;R20 - start
ifdef	PM_LED_USE_GPIO
F000_Set_PM_LED Proc	Far
		call	Set_PM_LED
		retf
F000_Set_PM_LED Endp
endif;	PM_LED_USE_GPIO
ifdef	LED_Blinking_at_PM
F000_Set_PM_LED_Blinking Proc	Far
		call	Set_PM_LED_Blinking
		retf
F000_Set_PM_LED_Blinking Endp
endif;	LED_Blinking_at_PM
;R20 - end

;[]========================================================================[]
;Procedure:	Ct_PMRAM_Use_SYSRAM
;
;Function :	To tell the BIOS kernel that if you are using the SYSRAM
;		for PM_RAM
;
;Input	  :	None
;
;Output   :	AL = Size of PM_RAM that you want to reserved from SYSRAM.
;		0=None, 1=1K, 2=2k  etc.
;
;Save	  :	All registers except AL & FLAGS
;
;Note	  :	1. called before PM_INIT (POST 79)
;		2. simply return AL=0 if PM_RAM is located at shadow RAM
;		   or SMRAM
;		4. stack available
;[]========================================================================[]
		Public	Ct_PMRAM_Use_SYSRAM
HOOK	Ct_PMRAM_Use_SYSRAM,0E000h

;R05 - start
ifndef	USB_SUPPORT
		call	Ct_SMI_Handler_Init
endif	;USB_SUPPORT
		xor	al, al
		ret
;R05 - end
;R05		pushad
;R05		push	ds
;R05		push	es
;R05
;R05
;R05
;R05
;R05;Copy SMI hanger into SM memory
;R05
;R05ifdef	SMBASE_USE_E000H
;R05		push	0E000H		;use E000H as SMbase
;R05		mov	bx,902Fh
;R05else	;SMBASE_USE_E000H
;R05		push	0A000H		;use A000H as SMbase
;R05		mov	bx,0D02Fh
;R05endif	;SMBASE_USE_E000H
;R05		mov	cx,0A3h
;R05		EFcall	Get_Set_PMU
;R05
;R05		pop	es
;R05;Clear memory to prevent parity error
;R05		xor	di,di
;R05		mov	cx,4000H	;32k to clear
;R05		xor	ax,ax
;R05		cld
;R05		rep	stosw
;R05
;R05		mov	cx, SMI_Handler_Len
;R05		mov	si, offset SMI_Handler_Start
;R05		EFcall	Check_If_M1
;R05		jnz	short Intel_Cpu
;R05
;R05	;M1 CPU, use different SMI service routine
;R05		mov	cx,Cyrix_SMI_Handler_Len
;R05		mov	si,offset Cyrix_SMI_Handler
;R05Intel_Cpu:
;R05		xor	di, di
;R05		push	cs
;R05		pop	ds
;R05		rep	movsb
;R05
;R05		mov	cx,0A3h			;disable SMRAM access
;R05		mov	bx,00EFh
;R05		EFcall	Get_Set_PMU
;R05
;R05		push	03800h			; orginal CPU SMBase
;R05		pop	es
;R05		mov	cx, Change_SMBase_L	;dword length
;R05		mov	si, offset Change_SMBase
;R05		xor	di, di
;R05		rep	movsb
;R05
;R05		EFcall	Check_If_M1
;R05		jz	short M1_Cpu
;R05
;R05		EFcall	Issue_SW_SMI
;R05		EFcall	End_PMI_Handler		;clear SW-SMI status & clear enable
;R05M1_Cpu:
;R05
;R05Smbase_Exit:
;R05		pop	es
;R05		pop	ds
;R05		popad
;R05
;R05		xor	al,al
;R05		ret
ENDH	Ct_PMRAM_Use_SYSRAM

;R05 - start
Ct_SMI_Handler_Init:
		pushad
		push	ds
		push	es

;Copy SMI hanger into SM memory

ifdef	SMBASE_USE_E000H
		push	0E000H		;use E000H as SMbase
		mov	bx,902Fh
else	;SMBASE_USE_E000H
		push	0A000H		;use A000H as SMbase
		mov	bx,0D02Fh
endif	;SMBASE_USE_E000H
		mov	cx,0A3h
		EFcall	Get_Set_PMU

		pop	es
;Clear memory to prevent parity error
		xor	di,di
		mov	cx,4000H	;32k to clear
		xor	ax,ax
		cld
		rep	stosw

		mov	cx, SMI_Handler_Len
		mov	si, offset SMI_Handler_Start
		xor	di, di
		push	cs
		pop	ds
		rep	movsb

; Modified the offset of JMP instruction for different CPU

		mov	ax, (offset Intel_SMI_Start-offset SMI_Handler_Start-3)

		push	ax
		EFcall	Check_If_M1
		pop	ax
		jnz	short Intel_Cpu

		mov	ax, (offset Cyrix_SMI_Start-offset SMI_Handler_Start-3)
Intel_Cpu:
		mov	word ptr es:[1], ax

		mov	cx,0A3h			;disable SMRAM access
		mov	bx,00EFh
		EFcall	Get_Set_PMU

		push	03800h			; orginal CPU SMBase
		pop	es
		mov	cx, Change_SMBase_L	;dword length
		mov	si, offset Change_SMBase
		xor	di, di
		rep	movsb

		EFcall	Check_If_M1
		jz	short M1_Cpu

		EFcall	Issue_SW_SMI
;R17		EFcall	End_PMI_Handler		;clear SW-SMI status & clear enable
		call	End_PMI_Handler		;R17 clear SW-SMI status & clear enable
M1_Cpu:

Smbase_Exit:
		pop	es
		pop	ds
		popad
		ret
;R05 - end

;[]==========================================================================[]
; Change_SMBase:
;	Change SMRAM address to 0A0000h - 0AFFFFh.
;	This is a temporary SMI handler routine.
;[]==========================================================================[]

		ALIGN	4
Change_SMBase	Proc	Near

; Change SMBase
ifdef	SMBASE_USE_E000H
		mov	dword ptr cs:[0FEF8h],0D8000h
else	;SMBASE_USE_E000H
		mov	dword ptr cs:[0FEF8h],098000h
endif	;SMBASE_USE_E000H

; Clear SMI request
		READ_PCI 009CH
		xor	ax,ax			;clear SMI status
		out	dx,eax

		RSM

Change_SMBase	Endp

Change_SMBase_L EQU	$ - offset Change_SMBase

;R05 - start
IFDEF		USB_SUPPORT
COMPILE_FOR_USBBIOS	=	2

		include	USBBIOS.ASM

;[]========================================================================[]
;Procedure:	Ct_Usb_Init
;Function:	USB initialization for Chipset dependent module
;		1. Initialize SMI handler
;		2. Check USB legacy support enabled
;		3. Initialize chipset dependent feature for legacy support
;Input:		none
;Output:	CF = 0 USB legacy support enabled and initialization successful
;		CF = 1 USB legacy support disabled or initialization fail
;[]========================================================================[]

Ct_Usb_Init:
		call	Ct_SMI_Handler_Init

;R09		mov	si, offset USB_Legacy_Item
;R09		EFcall	GetItem_Value
;R09		or	al, al
;R09		jz	short Ct_Usb_Init_Fail

	; Shadow RAM can be accessed by PCI

		mov	cx, 0076h
		mov	bx, 08FFh
		EFcall	Get_Set_PMU

	; Enable USB SMI

		mov	cx, 0095h
		mov	bx, 010E7h
		EFcall	Get_Set_PMU

		clc
		ret
Ct_Usb_Init_Fail:
		stc
		ret

;R09 - start
;[]========================================================================[]
;Procedure:	Ct_Check_Usb_Disabled
;Function:	Check USB host controller enabled and legacy support enabled
;		1. Check host controller enabled
;		2. Check legacy support enabled
;Input:		none
;Output:	CF = 0 Host present and legacy support enabled
;		CF = 1 Host disabled or legacy support disabled
;[]========================================================================[]

Ct_Check_Usb_Disabled:

		mov	si, offset USB_Item		;R16
		EFcall	GetItem_Value			;R16
		or	al,al				;R16
		jz	short Ct_Check_Usb_Fail		;R16

		mov	si, offset USB_Legacy_Item
		EFcall	GetItem_Value
		or	al, al
		jz	short Ct_Check_Usb_Fail

		clc
		ret

Ct_Check_Usb_Fail:
		mov	cx, 0095h
		mov	bx, 00E7h
		EFcall	Get_Set_PMU
		stc
		ret
;R09 - end

;[]========================================================================[]
;Procedure:	Ct_Usb_ID
;Function:	Report PCI ID of USB host controller
;Input:		none
;Output:	AX = Host controller ID
;[]========================================================================[]

Ct_Usb_ID:
		mov	ax, 0A00h		;device 1, function 2
		ret

;[]========================================================================[]
;Procedure:	Ct_USBRAM_Info
;Function:	Report the usage of USB_RAM
;Input:		none
;Output:	AL = 0 can be used with base memory or shadow RAM
;		AL = 1 use base memory only
;[]========================================================================[]

Ct_USBRAM_Info:
		xor	al, al
		ret

ENDIF		;USB_SUPPORT
;R05 - end

;R17 ;*********************************************************************
;R17 ;*********************************************************************
;R17 ;*****								 *****
;R17 ;*****	    The following codes 				 *****
;R17 ;*****	    (between label SMI_Handler_Start & SMI_Handler_End)  *****
;R17 ;*****	    should be placed in SMRAM !!!			 *****
;R17 ;*****								 *****
;R17 ;*********************************************************************
;R17 ;*********************************************************************
;R17 		ALIGN	4
;R17 		Public	SMI_Handler_Start
;R17 SMI_Handler_Start	label	near
;R17 
;R17 		db	0E9h			;R05;JMP
;R17 		dw	?			;R05;Intel_SMI_Start or
;R17 						;R05;Cyrix_SMI_Start
;R17 
;R17 ;R05		DB	0EAH
;R17 ;R05		DW	offset @F - offset SMI_Handler_Start + 8000h
;R17 ;R05ifdef	SMBASE_USE_E000H
;R17 ;R05		DW	0D800h
;R17 ;R05else	;SMBASE_USE_E000H
;R17 ;R05		DW	09800h
;R17 ;R05endif	;SMBASE_USE_E000H
;R17 ;R05	@@:
;R17 ;R05		mov	ax,cs
;R17 ;R05		mov	ss,ax
;R17 ;R05		mov	esp,0bff0h
;R17 ;R05
;R17 ;R05
;R17 ;R05;far call PMI_handler in F0000h
;R17 ;R05;PMI_Handler in F0000h use IRET to return to user,
;R17 ;R05;so pushf before calling
;R17 ;R05
;R17 ;R05		FAR_JMP <OFFSET DGROUP:PMI_Handler>,0F000H
;R17 ;R05
;R17 ;R05		align	4
;R17 ;R05		public	SMI_Handler_End
;R17 ;R05SMI_Handler_End label	near
;R17 ;R05
;R17 ;R05SMI_Handler_Len EQU	$ - offset SMI_Handler_Start	;in DWORD
;R17 
;R17 
;R17 ;*********************************************************************
;R17 ;SMI entry point for M1 CPU
;R17 ;*********************************************************************
;R17 ;R05			ALIGN	4
;R17 Stack_top2	EQU	07000h
;R17 ifdef	SMBASE_USE_E000H
;R17 SMBASE_AT	EQU	0E000h
;R17 else	;SMBASE_USE_E000H
;R17 SMBASE_AT	EQU	0A000h
;R17 endif	;SMBASE_USE_E000H
;R17 ;R05		Public	Cyrix_SMI_Handler
;R17 ;R05Cyrix_SMI_Handler	Label	Near
;R17 ;R05		jmp	Cyrix_SMI_Start
;R17 		ALIGN	4
;R17 ;Data saving table for CYRIX CPU
;R17 
;R17 SpSave		dw	?
;R17 EspSave 	dd	?
;R17 EaxSave 	dd	?
;R17 EbxSave 	dd	?
;R17 Cr2Save 	dd	?
;R17 Cr3Save 	dd	?
;R17 
;R17 Gdt		dq	0
;R17 RD_WR		EQU	12h		;read/write
;R17 EX_RD		EQU	1Ah		;execute/readable
;R17 ADDR		=	0
;R17 LIMT		=	100000h
;R17 G_BIG		=	$ - Gdt
;R17 		dw	(LIMT-1 AND 0ffffh)
;R17 		dw	(ADDR AND 0ffffh)
;R17 		db	((ADDR SHR 16) AND 0ffh)
;R17 		db	RD_WR OR (0 SHL 5) OR (1 SHL 7)
;R17 		db	((LIMT-1 SHR 16) AND 0fh) OR (0 SHL 6) OR (1 SHL 7)
;R17 		db	((ADDR SHR 24) AND 0ffh)
;R17 G_CODE		=	$ - Gdt
;R17 		dw	(LIMT-1 AND 0ffffh)
;R17 		dw	(ADDR AND 0ffffh)
;R17 		db	((ADDR SHR 16) AND 0ffh)
;R17 		db	EX_RD OR (0 SHL 5) OR (1 SHL 7)
;R17 		db	((LIMT-1 SHR 16) AND 0fh) OR (0 SHL 6) OR (1 SHL 7)
;R17 		db	((ADDR SHR 24) AND 0ffh)
;R17 GDTSIZE 	=	($ - Gdt)
;R17 
;R17 DsSave		dt	?
;R17 EsSave		dt	?
;R17 SsSave		dt	?
;R17 FsSave		dt	?
;R17 GsSave		dt	?
;R17 LdtSave 	dt	?
;R17 TskSave 	dt	?
;R17 Dstemp		db	0ffh,0ffh,0,0,0,92h,8fh,0,0,0	;4 Gb segment
;R17 GdtSave 	df	0
;R17 GdtNew		dw	GDTSIZE-1
;R17 		dd	?				;address
;R17 IdtSave 	df	0
;R17 RealModeIdt	dw	3ffh
;R17 		dd	0
;R17 
;R17 Cyrix_SMI_Start:
;R17 		mov	cs:[_EaxSave],eax
;R17 		mov	cs:[_EspSave],esp
;R17 		mov	cs:[_EbxSave],ebx
;R17 		SVLDT	CS,_LdtSave		;save LDT
;R17 		SVTS	CS,_TskSave		;save TSK	;R02
;R17 		SVDC	CS,_DsSave,DS		;save DS
;R17 		SVDC	CS,_EsSave,ES		;save ES
;R17 		SVDC	CS,_SsSave,SS		;save SS
;R17 		SVDC	CS,_FsSave,FS		;save FS
;R17 		SVDC	CS,_GsSave,GS		;save GS
;R17 		RSDC	CS,_Dstemp,DS		;set DS
;R17 		RSDC	CS,_Dstemp,SS		;set SS
;R17 		RSDC	CS,_Dstemp,ES		;set ES
;R17 
;R17 		db	066h
;R17 		SGDT	fword ptr cs:[_GdtSave] ;save GDT
;R17 
;R17 		db	066h
;R17 		SIDT	fword ptr cs:[_IdtSave] ;save IDT
;R17 
;R17 		mov	eax,cr2
;R17 		mov	cs:[_Cr2Save],eax		;save CR2
;R17 
;R17 		mov	eax,cr3
;R17 		mov	cs:[_Cr3Save],eax		;save CR3
;R17 
;R17 		mov	ax,SMBASE_AT
;R17 		mov	ss,ax		;setup stack
;R17 		mov	esp,STACK_TOP2
;R17 
;R17 	;----------------------------
;R17 	;Clear VM flag in Eflags
;R17 
;R17 		mov	eax,0
;R17 		push	eax
;R17 		mov	eax,SMBASE_AT
;R17 		push	eax
;R17 		mov	eax,offset @F
;R17 ;R05		sub	eax,offset Cyrix_SMI_Handler
;R17 		sub	eax,offset SMI_Handler_Start	;R05
;R17 		push	eax
;R17 		iretd
;R17 	@@:
;R17 	;----------------------------
;R17 
;R17 		db	66h
;R17 		LIDT	fword ptr cs:[_RealModeIdt]		;set real mode IDT
;R17 
;R17 		mov	ax,cs
;R17 		mov	ss,ax
;R17 		mov	esp,Stack_top2
;R17 
;R17 ;R05 - start
;R17 ifdef	USB_SUPPORT
;R17 		pushad
;R17 		push	ds
;R17 		push	es
;R17 		call	Usb_Smi
;R17 		pop	es
;R17 		pop	ds
;R17 		popad
;R17 		jnc	short Cyrix_SMI_Exit
;R17 endif	;USB_SUPPORT
;R17 ;R05 - end
;R17 
;R17 		pushf
;R17		FCALL	PMI_Handler
;R17 
;R17 Cyrix_SMI_Exit:					;R05
;R17 		RSLDT	CS,_LdtSave		;retore LDT
;R17 		RSTS	CS,_TskSave		;restore TSK	;R02
;R17 		RSDC	CS,_DsSave,DS		;restore DS
;R17 		RSDC	CS,_EsSave,ES		;restore ES
;R17 		RSDC	CS,_SsSave,SS		;restore SS
;R17 		RSDC	CS,_FsSave,FS		;restore FS
;R17 		RSDC	CS,_GsSave,GS		;restore GS
;R17 
;R17 		db	66h
;R17 		LGDT	fword ptr cs:[_GdtSave] ;restore GDT
;R17 		db	66h
;R17 		LIDT	fword ptr cs:[_IdtSave] ;restore IDT
;R17 
;R17 		mov	eax,cs:[_Cr2Save]	;restore CR2
;R17 		mov	cr2,eax
;R17 		mov	eax,cs:[_Cr3Save]	;restore CR3
;R17 		mov	cr3,eax
;R17 
;R17 		mov	esp,cs:[_EspSave]
;R17 		mov	eax,cs:[_EaxSave]
;R17 		mov	ebx,cs:[_EbxSave]
;R17 
;R17 		RSM
;R17 
;R17 ;R05		ALIGN	4
;R17 ;R05		public	Cyrix_SMI_Handler_End
;R17 ;R05Cyrix_SMI_Handler_End label	near
;R17 ;R05
;R17 ;R05Cyrix_SMI_Handler_Len	EQU	$ - offset Cyrix_SMI_Handler
;R17 
;R17 ;R05 - start
;R17 ;*********************************************************************
;R17 ;SMI entry point for Intel CPU
;R17 ;*********************************************************************
;R17 		ALIGN	4
;R17 Intel_SMI_Start:
;R17 		DB	0EAH
;R17 		DW	offset @F - offset SMI_Handler_Start
;R17 		DW	SMBASE_AT
;R17 	@@:
;R17 		mov	ax,SMBASE_AT
;R17 		mov	ss,ax
;R17 		mov	esp,Stack_Top2
;R17 
;R17 ifdef	USB_SUPPORT
;R17 		pushad
;R17 		push	ds
;R17 		push	es
;R17 		call	Usb_Smi
;R17 		pop	es
;R17 		pop	ds
;R17 		popad
;R17 		jc	short @f
;R17 		rsm
;R17 @@:
;R17 endif	;USB_SUPPORT
;R17 
;R17 ;far call PMI_handler in F0000h
;R17 ;PMI_Handler in F0000h use IRET to return to user,
;R17 ;so pushf before calling
;R17 
;R17		FAR_JMP <OFFSET DGROUP:PMI_Handler>,0F000H
;R17 
;R17 SMI_F0call_Proc:
;R17 		;push	Func_Addr			;[bp+8]
;R17 		;push	Ret_Addr			;[bp+6]
;R17 		push	offset F000_Func_End		;[bp+4]
;R17 		push	cs				;[bp+2]
;R17 		push	ax				;[bp]
;R17 		xchg	bp,sp
;R17 		mov	ax,[bp+2]
;R17 		xchg	ax,[bp+8]
;R17 		mov	[bp+2],ax
;R17 		xchg	bp,sp
;R17 		pop	ax
;R17 		FAR_JMP <offset F000_Vect>,0F000h
;R17 
;R17 IFDEF		USB_SUPPORT
;R17 COMPILE_FOR_USBBIOS	=	3
;R17 		include	USBBIOS.ASM
;R17 
;R17 ;[]========================================================================[]
;R17 ;Procedure:	Ct_USB_SMI_Check
;R17 ;Function:	Check whether USB SMI or not
;R17 ;Input:		none
;R17 ;Output:	CF = 0 USB SMI
;R17 ;		CF = 1 not USB_SMI
;R17 ;[]========================================================================[]
;R17 
;R17 Ct_USB_SMI_Check:
;R17 		mov	cx, 0095h
;R17 		SMI_F0CALL	Get_Ct
;R17 		test	al, 08
;R17 		clc
;R17 		jnz	short @f
;R17 		stc
;R17 @@:
;R17 		ret
;R17 
;R17 ;[]========================================================================[]
;R17 ;Procedure:	Ct_USB_SMI_Disable
;R17 ;Function:	Disable USB SMI
;R17 ;Input:		none
;R17 ;Output:	none
;R17 ;[]========================================================================[]
;R17 
;R17 Ct_USB_SMI_Disable:
;R17 		mov	cx, 0095h
;R17 		SMI_F0CALL	Get_Ct
;R17 		and	al, not 10h
;R17 		SMI_F0CALL	Set_Ct
;R17 		ret
;R17 
;R17 ;[]========================================================================[]
;R17 ;Procedure:	Ct_USB_SMI_Entry
;R17 ;Function:	Chipset process before USB SMI code executed.
;R17 ;Input:		none
;R17 ;Output:	none
;R17 ;[]========================================================================[]
;R17 
;R17 Ct_USB_SMI_Entry:
;R17 		mov	cx, 0095h
;R17 		SMI_F0CALL	Get_Ct
;R17 		and	al, not 08h
;R17 		SMI_F0CALL	Set_Ct
;R17 		ret
;R17 
;R17 ;[]========================================================================[]
;R17 ;Procedure:	Ct_USB_SMI_Exit
;R17 ;Function:	Exit SMI procedure after USB SMI process completed
;R17 ;Input:		none
;R17 ;Output:	none
;R17 ;[]========================================================================[]
;R17 
;R17 Ct_USB_SMI_Exit:
;R17 		ret
;R17 ENDIF		;USB_SUPPORT
;R17 
;R17 		align	4
;R17 		public	SMI_Handler_End
;R17 SMI_Handler_End label	near
;R17 SMI_Handler_Len EQU	$ - offset SMI_Handler_Start
;R17 ;R05 - end

;[]========================================================================[]
;Procedure:	Ct_Early_PM_Init
;
;Function :	Early PM chip initializations
;
;Input	  :	None
;
;Output   :	None
;
;Preserve :	All
;
;Note	  :	1. Call from POST 10
;		2. Stack available
;		3. You can initialize any PM function which is needed
;		   to be done earlier!
;[]========================================================================[]
HOOK	Ct_Early_PM_Init

;R04 - start
if	GREEN_ASSERT_PIN ne 0
 if	LastHook ne 0F000h
		ASSUME	DS:DGROUP
 		push	0F000h
		pop	ds
 endif
		pusha
 ifdef	GREEN_ASSERT_GPIO5
		mov	cx,ACPI_R+18h
		mov	bx,01DFh
		and	bh,byte ptr DGROUP:[GPIO_STPCLK_DEF].RomValue
		shl	bh,5
		EFcall	Get_Set_PMU
 endif	;GREEN_ASSERT_GPIO5
		popa
endif
;R04 - end

;R11 - start
ifdef	SUSPEND_SHOW_ACPILED
	;; Turn off ACPILED
		mov	cx,ACPI_R+19h
		mov	bx,00FBh
		EFcall	Get_Set_PMU
endif;	SUSPEND_SHOW_ACPILED
;R11 - end

		ret
ENDH	Ct_Early_PM_Init

;[]========================================================================[]
;Procedure:	Ct_PM_Init
;
;Function :	Special PM init which the standard code can't do
;
;Input	  :	DS = DGROUP
;		ES = PM_RAM
;
;Output   :	None
;
;Note	  :	1. Call from POST 79S (PM initialization)
;		2. Stack available
;		3. Don't destroy any SEGMENT registers!
;[]========================================================================[]
HOOK	Ct_PM_Init,0E000h
		ASSUME	ES:PM_RAM
		ASSUME	DS:DGROUP

if	LastHook ne 0F000h
 		push	0F000h
		pop	ds
endif
;R04 - start
if	GREEN_ASSERT_PIN ne 0
		mov	ax,DGROUP:[GPIO_STPCLK_DEF].RomValue
		mov	PM_RAM:[SMOUT_Settings],ax
endif	;GREEN_ASSERT_PIN ne 0
;R04 - end

	;video off option

		mov	si,offset DGROUP:Video_Off_Item
		EFcall	GetItem_Or
		mov	PM_RAM:[Video_Off_Mode],al

	;APM option

		mov	si,offset DGROUP:Wait_APM_Item
		EFcall	GetItem_Or
		mov	PM_RAM:[Wait_APM_Flag],al	;wait for APM

	;Timer values

		mov	si,offset DGROUP:Doze_Item
		call	Translate_Timer
		mov	PM_RAM:[Doze_Setting],al

		mov	si,offset DGROUP:Standby_Item
		call	Translate_Timer
		mov	PM_RAM:[Standby_Setting],al

		mov	si,offset DGROUP:Suspend_Item
		call	Translate_Timer
		mov	PM_RAM:[Suspend_Setting],al
		mov	eax,Dword ptr [Doze_Setting]
		mov	Dword ptr [Temp_Doze_Timer],eax
ifdef	NETWORK_SUSPEND_DISABLE
		extrn	NetCard_Item:Near
		mov	si,offset DGROUP:NetCard_Item
		EFcall	GetItem_Or
		jz	short NetCard_Absent
		mov	byte ptr PM_RAM:[Suspend_Setting],0
NetCard_Absent:
endif	;NETWORK_SUSPEND_DISABLE

	;Doze speed & standby speed

		mov	si,offset DGROUP:Doze_Speed_Item
		EFcall	GetItem_Or
		mov	bl,36			;throttling register multiply by 36
		mul	bl
		mov	PM_RAM:[Doze_Speed],al

		mov	si,offset DGROUP:Standby_Speed_Item
		EFcall	GetItem_Or
		mul	bl
		mov	PM_RAM:[Standby_Speed],al

	;HDD off option

	ifndef	No_Suspend_Off_Hdd
		EFcall	HDD_Standby_Offset
		EFcall	GetItem_Or
		mov	PM_RAM:[HDD_Timer_Setting],al
		cmp	al,16
		jne	short @F
		xor	al,al
		EFcall	Set_HDD_Standby_Timer
	@@:
	endif	;No_Suspend_Off_Hdd
;R08 - start
ifdef	ABIT_GPCS
		mov	cx,51h
		EFcall	Get_PMU
		and	al,04h
		shl	al,5
		mov	bl,al
		extrn	ABIT_fan_Item:near
		mov	si,offset DGROUP:ABIT_fan_Item
		EFcall	GetItem_Or
		shl	al,6
		xor	bl,0C0h
		mov	PM_RAM:[GPCS_Save_Value],bl
endif	;ABIT_GPCS
;R08 - end
;R10 - start
;R17 ifndef	SiS_LEGACY_SUSPEND
		mov	cx,ACPI_R+03h		;enable ACPI-buttom suspend
		mov	bx,01FEh
		EFcall	Get_Set_PMU
		mov	cl,26h			;enable wake up SMI
		mov	bx,02FFh
		EFcall	Get_Set_PMU
;R17 endif	;SiS_LEGACY_SUSPEND
;R10 - end

		extrn	Suspend_Sw_Item:Near
		mov	si,offset DGROUP:Suspend_Sw_Item
		EFcall	GetItem_Or
		cmp	al,2
		jb	short Cannot_Break
		mov	cx,9Bh
ifdef	SUPPORT_RING_SMI				;R07
		mov	bx,06F9h			;R07
else	;SUPPORT_RING_SMI				;R07
		mov	bx,02FDh
endif	;SUPPORT_RING_SMI				;R07
		EFcall	Get_Set_PMU
Cannot_Break:
ifndef	NO_SUPPORT_APM12
		and	bh,02h
		mov	PM_RAM:[B_SW_D4], bh
endif	;NO_SUPPORT_APM12

		mov	bx,00C3h
		extrn	VGA_Event_Item:Near
		mov	si,offset DGROUP:VGA_Event_Item
		EFcall	GetItem_Or
		jz	short @F
		mov	bh,38h
	@@:
		extrn	HDD_Event_Item:Near
		mov	si,offset DGROUP:HDD_Event_Item
		EFcall	GetItem_Or
		jz	short @F
		or	bh,04h
	@@:
		mov	cx,91h
		EFcall	Get_Set_PMU

		mov	bx,00CFh
		extrn	COM_Event_Item:Near
		mov	si,offset DGROUP:COM_Event_Item
		EFcall	GetItem_Or
		jz	short @F
		mov	bh,30h
	@@:
		mov	cx,90h
		EFcall	Get_Set_PMU

ifdef	USB_SUPPORT					;R17
ifdef	SiS_LEGACY_SUSPEND				;R17
		mov	si,offset Usb_Legacy_Item	;R17
		EFcall	GetItem_Value			;R17
		mov	PM_RAM:[Usb_Legacy_Flag],al	;R17
endif;	SiS_LEGACY_SUSPEND				;R17
endif;	USB_SUPPORT					;R17

;R19 - start
ifdef	Power_B_O_R_as_Power_off
		extrn	Power_B_O_R_Item:near
		mov	si,offset DGROUP:Power_B_O_R_Item
		EFcall	GetItem_Value
		mov	PM_RAM:[Power_B_O_R_Status],al
endif;	Power_B_O_R_as_Power_off
;R19 - end
;------------------ Set system to FULL-ON mode -----------------

		mov	al,1
		EFcall	Software_SMI

		ret

ENDH	Ct_PM_Init

Translate_Timer:
		EFcall	GetItem_Or
		xor	ah,ah
		mov	si,ax
		add	si,offset Doze_Time_Tbl
		mov	al,cs:[si]
		ret
Doze_Time_Tbl:
		db	0		;disble
		db	2		;20 sec
		db	6		;1 min
		db	32		;5 min
		db	64		;10 min
		db	96		;15 min
		db	128		;20 min
		db	192		;30 min
		db	255		;40 min

;[]========================================================================[]
;Procedure:	Ct_PM_Final_Init
;
;Function :	PM initialization before boot
;
;Input	  :	None
;
;Output   :	None
;
;Registers:	Please preserve all registers
;
;Note	  :	1. Call from POST 82
;		2. Stack available
;[]========================================================================[]
		Public	Ct_PM_Final_Init
HOOK	Ct_PM_Final_Init

		ret
ENDH	Ct_PM_Final_Init

ifndef	NO_SUPPORT_APM12
;[]========================================================================[]
;Input	:	None
;Output	:	AL = 0 			 --> Currently MODEM Ring cannot 
;					     wake up system
;		AL = RING_WAKEUP_ENABLED --> Currently MODEM Ring can
;					     wake up system
;[]========================================================================[]
		Public	CT_RING_WAKEUP_STATUS
HOOK	CT_RING_WAKEUP_STATUS,0E000h
		ASSUME	ES:PM_RAM
		ASSUME	DS:DGROUP

		pushad
		mov	cx, 875h
		EFcall	Get_PMU
		mov	ah, al

		dec	cx		;then cl= 74h
		EFcall	Get_PMU
		not	ax
		mov	word ptr [DEASSERT_STPCLK_IRQS], ax

		extrn	Modem_IRQ_Item:near
		mov	si, offset DGROUP:Modem_IRQ_Item
		EFcall	GetItem_Or
		jnz	short @F
		xor	ax, ax
		mov	word ptr [APM_Modem_IRQ], ax
		popad
		ret
	@@:
		mov	bx, 1
		mov	cl, al
		shl	bx, cl

		mov	word ptr [APM_Modem_IRQ], bx
		test	word ptr [DEASSERT_STPCLK_IRQS], bx
		popad
		mov	al, RING_WAKEUP_ENABLED		;current ON
		jnz	short @F
		xor	al, al				;current OFF
	@@:
		ret

ENDH	CT_RING_WAKEUP_STATUS

;[]========================================================================[]
;Input	:	None
;Output	:	AL = 0 			--> PM Timer is currently disabled
;		AL = PMU_TIMER_ENABLED	--> PM Timer is currently Enabled
;[]========================================================================[]
		Public	CT_PMU_TIMER_STATUS
HOOK	CT_PMU_TIMER_STATUS
		ASSUME	ES:PM_RAM
		ASSUME	DS:DGROUP

		mov	al, PMU_TIMER_ENABLED		;assume enabled 
		cmp	Dword ptr [Doze_Setting],0
		jnz	short @F
		xor	al, al
	@@:
		ret

ENDH	CT_PMU_TIMER_STATUS
endif	;NO_SUPPORT_APM12

;[]========================================================================[]
;Procedure:	Ct_LCD_Init
;
;Function :	Set the LCD power down timer which initial method
;		varies from chip to chip
;
;Input	  :	DS = DGROUP
;		ES = PM_RAM
;
;Output   :	None
;
;Note	  :	1. Call from POST 79S (PM initialization)
;		2. Stack available
;		3. Don't destroy any SEGMENT registers!
;[]========================================================================[]
		Public	Ct_LCD_Init
HOOK	Ct_LCD_Init
		ASSUME	ES:PM_RAM
		ASSUME	DS:DGROUP
		ret
ENDH	Ct_LCD_Init

;[]========================================================================[]
;Procedure:	HDD_Standby_Offset
;
;Function :	Tell BIOS kernal the offset of the setup item
;		"HDD Power Down Timer"
;
;Input	  :	DS = DGROUP
;		ES = PM_RAM
;
;Output   :	NC: HDD Power Down Item exist
;		    SI = Item offset
;		CF: HDD Power Down Item absent
;		    SI Don't care
;
;Note	  :	1. Call from POST 79S (PM initialization)
;		2. Stack available
;		3. Don't destroy any SEGMENT registers!
;		4. If you don't have such a item in SETUP,
;		   just set carry flag & return!
;[]========================================================================[]
		Public	HDD_Standby_Offset
HOOK	HDD_Standby_Offset
		ASSUME	ES:PM_RAM
		ASSUME	DS:DGROUP

		mov	si,offset HDD_Timer_Item
		clc
		ret

ENDH	HDD_Standby_Offset

;[]========================================================================[]
;Procedure:	Get_IRQ15_Offset
;
;Input	  :	DS = G_RAM
;
;Output   :	NC:
;			AX = Segment location of the IRQ15
;			     PMI service routine
;			SI = offset of the IRQ15 PMI service routine
;
;			i.e. AX:SI
;
;		CF:
;			IRQ 15 is not supported!
;
;Registers:	Please preserve all registers except AX & SI
;
;[Note]   :	1. called from PM_INIT
;		   NC: AX:SI will be placed interrupt table located
;		       in segment 0
;		   CF: IRQ15 vector will be masked off
;[]========================================================================[]
			ASSUME	DS:G_RAM
			Public	Get_IRQ15_Offset
HOOK	Get_IRQ15_Offset
;R17		mov	si,offset PMI_Handler
;R17		mov	ax,seg PMI_Handler
;R17		clc
		stc					;R17
		ret
ENDH	Get_IRQ15_Offset

;---------------------------------------------------------------------------

;[]========================================================================[]
;Procedure:	Ct_Resume_Handle
;
;Function :	Ct_Resume_Handle
;
;Input	  :	None
;
;Output   :	None
;[]========================================================================[]
		Public	Ct_Resume_Handle
HOOK	Ct_Resume_Handle
		mov	ax,G_RAM
		mov	ds,ax
		ASSUME	DS:G_RAM
		mov	ss,G_RAM:[ROM_MODULE_SEG]
		mov	sp,G_RAM:[ROM_MODULE_OFFSET]
		iret
ENDH	Ct_Resume_Handle,0F000h

;[]-------------------------------------------------------------------[]
;
; PPPPPPPP	 AA	  RRRRRRRR   TTTTTTTTTTT		44444
; PPPPPPPPP	AAAA	  RRRRRRRRR  TTTTTTTTTTT    ***        444444
; PPP	 PPP   AAAAAA	  RRR	 RRR	 TTT	    ***       444 444
; PPPPPPPPP   AAA  AAA	  RRRRRRRRR	 TTT		     4444444444
; PPPPPPPP   AAAAAAAAAA   RRRRRRRR	 TTT	    ***     44444444444
; PPP	    AAAAAAAAAAAA  RRR	RRR	 TTT	    *** 	  444
; PPP	   AAA	      AAA RRR	 RRR	 TTT			  444
;
;
;
;	   OEM specific subroutines
;
;	   Normally, this part will be placed with the PMI handler
;	   (IRQ15 or SMI or NMI)
;
;[]-------------------------------------------------------------------[]

;R17 ;[]========================================================================[]
;R17 ;Function :	Routine to handle the power management interrupt (PMI).
;R17 ;
;R17 ;Input	  :	None
;R17 ;
;R17 ;Output   :	if PM using IRQ --- no output!
;R17 ;		if PM using NMI --- NC: BIOS has handle this NMI for
;R17 ;					PM chip!
;R17 ;				    CF: NMI is not issue by PM chip
;R17 ;
;R17 ;Destroy:	if PM using IRQ --- destroy None
;R17 ;		if PM using NMI --- destroy FLAG
;R17 ;[]========================================================================[]
;R17 		ASSUME	CS:DGROUP
;R17 		Public	PMI_Handler
;R17 PMI_Handler	Proc	Far
;R17 		cli
;R17 
;R17 		pushad
;R17 		lidt	fword ptr cs:[REAL_IDT_LOC]	;R02
;R17 
;R17 		mov	dx,0CF8h
;R17 		in	eax,dx
;R17 		push	eax
;R17 
;R17 		mov	cx,860h
;R17 		call	Get_PMU
;R17 		mov	ah,al
;R17 
;R17 		mov	cx,76h			;save shadow register
;R17 		call	Get_PMU
;R17 		push	ax
;R17 
;R17 		call	Open_PM_RAM
;R17 		call	Get_PM_RAM_Seg
;R17 		mov	ds,ax
;R17 		ASSUME	DS:PM_RAM
;R17 		call	Get_PMI_Source
;R17 		call	si
;R17 		call	End_PMI_Handler
;R17 
;R17 ;----------------- PMI request is done! About to leave ISR ------------------
;R17 
;R17 		pop	ax			;restore shadow register
;R17 		mov	cx,76h
;R17 		call	Set_PMU
;R17 
;R17 		mov	bl,ah
;R17 
;R17 		pop	eax
;R17 		mov	dx,0CF8h
;R17 		out	dx,eax
;R17 
;R17 ;R14 - start
;R17 		mov	cx,0ffffh		;Prepare IRQ mask data for all
;R17 		mov	eax,80000874h
;R17 		mov	dx,0cf8h
;R17 		out	dx,eax
;R17 		mov	dl,0fch
;R17 		in	al,dx
;R17 		xchg	ax,cx			;Save IRQ mask data
;R17 		out	dx,ax			;Mask all
;R17 		xchg	ax,cx
;R17 		out	dx,ax			;Set back the original value
;R17 ;R14 - end
;R17 
;R17 		call	Check_If_M1
;R17 		xchg	bx,ax
;R17 		out	70h,al
;R17 		jz	short Yes_M1
;R17 
;R17 		RSM	;Execute RSM instruction to get back to application
;R17 Yes_M1:
;R17 
;R17 		popad
;R17 
;R17 		iret
;R17 PMI_Handler	Endp
;R17 
;R17 ifndef	NO_SUPPORT_APM12
;R17 		include	v_alarm.inc
;R17 
;R17 Low_Power_Throttling	Proc	Near
;R17 		mov	cx,9Eh
;R17 		mov	al,48h
;R17 		EFcall	Set_PMU
;R17 		inc	cx	;then cl=9Fh
;R17 		mov	al,01h
;R17 		EFcall	Set_PMU
;R17 		ret
;R17 Low_Power_Throttling	Endp
;R17 endif	;NO_SUPPORT_APM12
;R17 
;R17 ;[]========================================================================[]
;R17 ;Procedure:	Get_PMI_Source
;R17 ;
;R17 ;Function :	To get the corresponding PMI routine according
;R17 ;		to what kind of PMI it is
;R17 ;
;R17 ;Input	  :	DS = PM_RAM
;R17 ;
;R17 ;Output   :	SI = point to appropriate PMI handler
;R17 ;		e.g. if it is a suspend request
;R17 ;		     SI = offset Suspend_Handler
;R17 ;
;R17 ;Note	  :	1. Called from PM_Handler
;R17 ;		2. stack available
;R17 ;		3. The BIOS PM kernal will issue:
;R17 ;		   "call si" after calling this routine!
;R17 ;[]========================================================================[]
;R17 		Public	Get_PMI_Source
;R17 HOOK	Get_PMI_Source
;R17 
;R17 ;R12 - start
;R17 ;Check Hot Key Status
;R17 		mov	cx,086Dh
;R17 		EFcall	Get_PMU
;R17 		test	al,02h
;R17 		mov	si,offset Software_Power_Down_Handler
;R17 		jnz	short PMI_Source_Got
;R17 ;R12 - end
;R17 
;R17 ;Check SMI source status from register 9Ch & 9Dh
;R17 
;R17 		mov	cx,9Dh
;R17 		EFcall	Get_PMU
;R17 		mov	ah,al
;R17 		dec	cx	;then cl=9Ch
;R17 		EFcall	Get_PMU
;R17 		test	ax,0011110001111111b		;wake up ?
;R17 		mov	si,offset Set_Full_On_State
;R17 		jnz	short PMI_Source_Got
;R17 		test	al,80h
;R17 		mov	si,offset PM_TimeOut_Handler
;R17 		jnz	short PMI_Source_Got
;R17 		test	ah,01h
;R17 		mov	si,offset Software_SMI_Handler
;R17 		jnz	short PMI_Source_Got
;R17 		test	ah,02h
;R17 		mov	si,offset Suspend_Switch_Handler
;R17 		jnz	short PMI_Source_Got
;R17 ;R10 - start
;R17 ifndef	SiS_LEGACY_SUSPEND
;R17 		mov	dx,ACPI_BASE_IO_ADDR+25h
;R17 		in	al,dx
;R17 		test	al,02h
;R17 		mov	si,offset Set_Full_On_State
;R17 		jnz	short PMI_Source_Got
;R17 		mov	cx,ACPI_R+01h
;R17 		EFcall	Get_PMU
;R17 		test	al,01h
;R17 		mov	si,offset Suspend_Switch_Handler
;R17 		jnz	short PMI_Source_Got
;R17 endif	;SiS_LEGACY_SUSPEND
;R17 ;R10 - end
;R17 		mov	si,offset Null_Handler
;R17 PMI_Source_Got:
;R17 		ret
;R17 
;R17 ENDH	Get_PMI_Source
;R17 
;R17 
;R17 		ALIGN	4
;R17 ;[]========================================================================[]
;R17 ;[]========================================================================[]
;R17 Null_Handler	Proc	Near
;R17 		ret
;R17 Null_Handler	Endp
;R17 
;R17 ;[]========================================================================[]
;R17 ;[]========================================================================[]
;R17 Software_SMI_Handler	Proc	Near
;R17 
;R17 		Public	APM_R31_Added
;R17 APM_R31_Added:
;R17 		mov	al, [Software_SMI_Type]
;R17 		cmp	al, CRT_OFF_REQ
;R17 		jne	short @F
;R17 		call	Disable_CRT
;R17 		ret
;R17 	@@:
;R17 		cmp	al, CRT_ON_REQ
;R17 		jne	short @F
;R17 		call	Enable_CRT
;R17 		ret
;R17 	@@:
;R17 
;R17 ifndef	NO_SUPPORT_APM12
;R17 		
;R17 	;------------------------------------------------------
;R17 
;R17 		cmp	al, ENABLE_RESUME_TIMER_REQ
;R17 		jne	short @F
;R17 		ret
;R17 	@@:
;R17 
;R17 	;------------------------------------------------------
;R17 
;R17 		cmp	al, DISABLE_RESUME_TIMER_REQ
;R17 		jne	short @F
;R17 		ret
;R17 	@@:
;R17 
;R17 	;------------------------------------------------------
;R17 
;R17 		cmp	al, ENABLE_RESUME_RING
;R17 		jne	short @F
;R17  
;R17 ifdef	SUPPORT_RING_SMI				;R07
;R17 		mov	cx,9Bh				;R07
;R17 		mov	bx,04FBh			;R07
;R17 		call	Get_Set_PMU			;R07
;R17 endif	;SUPPORT_RING_SMI				;R07
;R17 		mov	dx, word ptr [APM_Modem_IRQ]
;R17 		or	word ptr [DEASSERT_STPCLK_IRQS], dx
;R17 		not	dx
;R17 		mov	cx, 874h
;R17 		mov	bl,dl
;R17 		xor	bh,bh
;R17 		call	Get_Set_PMU
;R17 		inc	cx	;then cl=75h
;R17 		mov	bl,dh
;R17 		call	Get_Set_PMU
;R17 		ret
;R17 	@@:
;R17 
;R17 	;------------------------------------------------------
;R17 
;R17 		cmp	al, DISABLE_RESUME_RING
;R17 		jne	short @F
;R17 
;R17 ifdef	SUPPORT_RING_SMI				;R07
;R17 		mov	cx,9Bh				;R07
;R17 		mov	bx,00FBh			;R07
;R17 		call	Get_Set_PMU			;R07
;R17 endif	;SUPPORT_RING_SMI				;R07
;R17 		mov	dx, word ptr [APM_Modem_IRQ]
;R17 		mov	cx, 874h
;R17 		mov	bl,0FFh
;R17 		mov	bh,dl
;R17 		call	Get_Set_PMU
;R17 		inc	cx	;then cl=75h
;R17 		mov	bh,dh
;R17 		call	Get_Set_PMU
;R17 		not	dx
;R17 		and	word ptr [DEASSERT_STPCLK_IRQS], dx
;R17 		ret
;R17 	@@:
;R17 	;------------------------------------------------------
;R17 
;R17 		mov	cx, 9Bh
;R17 		mov	bx,00FDh	;disabel B-SW
;R17 		cmp	al, DISABLE_PM_REQ
;R17 		je	short To_Disable_PM_Timer
;R17 
;R17 		mov	bh, B_SW_D4	;enabel B-SW
;R17 		cmp	al, ENABLE_PM_REQ
;R17 		je	short To_Enable_PM_Timer
;R17 		cmp	al, RESTORE_POWERON_D4_REQ
;R17 		je	short To_Enable_PM_Timer
;R17 
;R17 		mov	bx,00FFh
;R17 
;R17 		cmp	al, ENABLE_TIMER_REQ
;R17 		je	short To_Enable_PM_Timer
;R17 
;R17 		cmp	al, DISABLE_TIMER_REQ
;R17 		jne	short Not_APM_Driver_Req
;R17 
;R17 	To_Disable_PM_Timer:
;R17 
;R17 		mov	Dword ptr [Doze_Setting], 0
;R17 		jmp	short @F
;R17 
;R17 	To_Enable_PM_Timer:
;R17 
;R17 		push	Dword ptr [Temp_Doze_Timer]
;R17 		pop	Dword ptr [Doze_Setting]
;R17 	@@:
;R17 		pusha
;R17 		call	Set_Full_On_State
;R17 		popa
;R17 		call	Get_Set_PMU
;R17 		ret
;R17 
;R17 	Not_APM_Driver_Req:
;R17 
;R17 endif	;NO_SUPPORT_APM12
;R17 
;R17 		mov	al,PM_RAM:Software_SMI_Byte
;R17 
;R17 		mov	bl,al
;R17 		xor	bh,bh
;R17 		shl	bx,1
;R17 		clc
;R17 		add	bx,offset cs:Software_SMI_Table
;R17 		mov	si,cs:[bx]
;R17 
;R17 		mov	PM_RAM:Software_SMI_Byte,0
;R17 
;R17 		call	si
;R17 
;R17 		ret
;R17 Software_SMI_Handler	Endp
;R17 
;R17 		ALIGN	4
;R17 		Public	Software_SMI_Table
;R17 Software_SMI_Table:
;R17 		DW	offset Software_SMI_Null
;R17 		DW	offset Software_SMI_Wakeup
;R17 		DW	offset Software_SMI_Doze
;R17 		DW	offset Software_SMI_Sleep
;R17 		DW	offset Software_SMI_Suspend
;R17 ifdef	NoteBook_Power_Management
;R17 		DW	offset Software_SMI_0V_Resume
;R17 		DW	offset Software_SMI_BIOS_RSM
;R17 endif	;NoteBook_Power_Management
;R17 
;R17 ;[]===============================================================[]
;R17 ;Procedure:	Software_SMI_Null
;R17 ;
;R17 ;Function :	Routine to Handle software SMI Null function
;R17 ;
;R17 ;Input	  :	DS = PM_RAM
;R17 ;
;R17 ;Output   :	None
;R17 ;[]==================================================================[]
;R17 		ASSUME	DS:PM_RAM
;R17 		Public	Software_SMI_Null
;R17 HOOK	Software_SMI_Null
;R17 		ret
;R17 ENDH	Software_SMI_Null
;R17 
;R17 ;[]===============================================================[]
;R17 ;Procedure:	Software_SMI_Wakeup
;R17 ;
;R17 ;Function :	Routine to Handle software SMI wake-up function
;R17 ;
;R17 ;Input	  :	DS = PM_RAM
;R17 ;
;R17 ;Output   :	None
;R17 ;[]==================================================================[]
;R17 		ASSUME	DS:PM_RAM
;R17 		Public	Software_SMI_Wakeup
;R17 HOOK	Software_SMI_Wakeup
;R17 		jmp	Set_Full_On_State
;R17 ENDH	Software_SMI_Wakeup
;R17 
;R17 ;[]===============================================================[]
;R17 ;Procedure:	Software_SMI_Doze
;R17 ;
;R17 ;Function :	Routine to Handle software SMI Doze
;R17 ;
;R17 ;Input	  :	DS = PM_RAM
;R17 ;
;R17 ;Output   :	None
;R17 ;[]==================================================================[]
;R17 		ASSUME	DS:PM_RAM
;R17 		Public	Software_SMI_Doze
;R17 HOOK	Software_SMI_Doze
;R17 		mov	al,0d7h
;R17 		out	80h,al
;R17 		mov	[PM_TimeOut_Type],01h		;Standby request
;R17 		jmp	Go_PM_State
;R17 ENDH	Software_SMI_Doze
;R17 
;R17 ;[]===============================================================[]
;R17 ;Procedure:	Software_SMI_Sleep
;R17 ;
;R17 ;Function :	Routine to Handle software SMI Sleep
;R17 ;
;R17 ;Input	  :	DS = PM_RAM
;R17 ;
;R17 ;Output   :	None
;R17 ;[]==================================================================[]
;R17 		ASSUME	DS:PM_RAM
;R17 		Public	Software_SMI_Doze
;R17 HOOK	Software_SMI_Sleep
;R17 		mov	al,APM_IDLE
;R17 		out	80h,al
;R17 		mov	[PM_TimeOut_Type],02h		;Standby request
;R17 		jmp	Go_PM_State
;R17 ENDH	Software_SMI_Sleep
;R17 
;R17 ;[]===============================================================[]
;R17 ;Procedure:	Software_SMI_Suspend
;R17 ;
;R17 ;Function :	Routine to Handle software SMI Suspend
;R17 ;
;R17 ;Input	  :	DS = PM_RAM
;R17 ;
;R17 ;Output   :	None
;R17 ;[]==================================================================[]
;R17 		ASSUME	DS:PM_RAM
;R17 		Public	Software_SMI_Suspend
;R17 HOOK	Software_SMI_Suspend
;R17 		mov	al,APM_SUS
;R17 		out	80h,al
;R17 		mov	[PM_TimeOut_Type],03h		;Standby request
;R17 		jmp	Go_PM_State
;R17 ENDH	Software_SMI_Suspend
;R17 
;R17 ifdef	NoteBook_Power_Management
;R17 ;[]===============================================================[]
;R17 ;Procedure:	Software_SMI_0V_Resume
;R17 ;
;R17 ;Function :	Routine to Handle software SMI resume from 0V suspend
;R17 ;
;R17 ;Input	  :	DS = PM_RAM
;R17 ;
;R17 ;Output   :	None
;R17 ;[]==================================================================[]
;R17 		ASSUME	DS:PM_RAM
;R17 		Public	Software_SMI_0V_Resume
;R17 HOOK	Software_SMI_0V_Resume
;R17 		jmp	Resume_0V
;R17 ENDH	Software_SMI_0V_Resume
;R17 
;R17 ;[]===============================================================[]
;R17 ;Procedure:	Software_SMI_BIOS_RSM
;R17 ;
;R17 ;Function :	Routine to save system BIOS SMBASE.
;R17 ;
;R17 ;Input	  :	DS = PM_RAM
;R17 ;
;R17 ;Output   :	None
;R17 ;[]==================================================================[]
;R17 		ASSUME	DS:PM_RAM
;R17 		Public	Software_SMI_BIOS_RSM
;R17 HOOK	Software_SMI_BIOS_RSM
;R17 ifdef	NO_ZV_REALTIME_MESSAGE
;R17 		extrn	Save_SMRAM_State:near
;R17 		jmp	Save_SMRAM_State
;R17 else	;NO_ZV_REALTIME_MESSAGE
;R17 		ret
;R17 endif	;NO_ZV_REALTIME_MESSAGE
;R17 ENDH	Software_SMI_BIOS_RSM
;R17 endif	;NoteBook_Power_Management
;R17 
;R17 ;[]==================================================================[]
;R17 ;[]==================================================================[]
;R17 		ASSUME	DS:PM_RAM
;R17 HOOK	Suspend_Switch_Handler
;R17 
;R17 		mov	cx,1000h
;R17 		loop	short $ 		;delay for a while
;R17 
;R17 		mov	[PM_TimeOut_Type],03h
;R17 		call	PM_State_Yes
;R17 		ret
;R17 
;R17 Suspend_Switch_Handler	Endp
;R17 
;R17 ;[]==================================================================[]
;R17 ;[]==================================================================[]
;R17 ;R12 - start
;R17 Software_Power_Down_Handler	Proc	Near
;R17 	;; Turn Off Power
;R17 		mov	cx,0869h
;R17 		mov	bx,10FFh
;R17 		call	Get_Set_PMU
;R17 Software_Power_Down_Handler	endp
;R17 ;R12 - end
;R17 ;[]==================================================================[]
;R17 ;[]==================================================================[]
;R17 		align	4
;R17 PM_TimeOut_Handler	Proc	Near
;R17 ; Check PM mode
;R17 		mov	al, byte ptr PM_RAM:PM_MODE1
;R17 
;R17 		cmp	al,FULL_ON			;Now Full-On mode?
;R17 		mov	si,offset Doze_Setting
;R17 		mov	[PM_TimeOut_Type],01h		;Doze request
;R17 		je	short @F			;yes
;R17 
;R17 		cmp	al,DOZE_MODE			;Now Doze mode?
;R17 		mov	si,offset Standby_Setting
;R17 		mov	[PM_TimeOut_Type],02h		;Standby request
;R17 		je	short @F			;no
;R17 
;R17 		mov	si,offset Suspend_Setting
;R17 		mov	[PM_TimeOut_Type],03h		;Suspend request
;R17 	@@:
;R17 		call	Set_PM_State
;R17 		ret
;R17 
;R17 PM_TimeOut_Handler	Endp
;R17 
;R17 ;[]========================================================================[]
;R17 ;input	:	DS = PM_RAM
;R17 ;[]========================================================================[]
;R17 		ASSUME	DS:PM_RAM
;R17 Set_Full_On_State	Proc	Near
;R17 	ifndef	No_Suspend_Off_Hdd
;R17 		or	[HDD_OFF_FLAG],0
;R17 		jz	short @F
;R17 		mov	[HDD_OFF_FLAG],0
;R17 		jmp	Do_Suspend
;R17 	@@:
;R17 	endif	;No_Suspend_Off_Hdd
;R17 ifdef	POWER_DOWN_OUT_PIN
;R17 		mov	al,POWER_DOWN_OUT_PIN+8
;R17 		call	Out_8042_Pin1
;R17 		extrn	OUT_8042_FULL:near
;R17 		call	OUT_8042_FULL
;R17 		in	al,60h
;R17 		iodelay
;R17 endif	;POWER_DOWN_OUT_PIN
;R17 ;R08 - start
;R17 ifdef	ABIT_GPCS
;R17 		mov	cx,0868h
;R17 		mov	dx,5A7Ch	;io port 5A7Ch
;R17 		mov	al,dh
;R17 		call	Set_PMU
;R17 		dec	cx		;then cx=867h
;R17 		mov	al,dl
;R17 		call	Set_PMU
;R17 		mov	al,PM_RAM:[GPCS_Save_Value]
;R17 		or	al,01100000b	;turn off fan & Suspend LED
;R17 		out	dx,al
;R17 		mov	al,02h		;release io port
;R17 		call	Set_PMU
;R17 endif	;ABIT_GPCS
;R17 ;R08 - end
;R17 
;R17 ;R15 - start
;R17 ;--------------------------
;R17 ;Turn FAN on
;R17 ;--------------------------
;R17 ifdef	FAN_CONTROL_BY_GPCS0
;R17 		mov	cx,0863h
;R17 ifdef	GPCS0_FAN_Lo_Active
;R17 		mov	bx,(00000000b shl 8) or 01101110b
;R17 else;	GPCS0_FAN_Lo_Active
;R17 		mov	bx,(00010000b shl 8) or 01101110b
;R17 endif;	GPCS0_FAN_Lo_Active
;R17 		call	Get_Set_PMU
;R17 endif;	FAN_CONTROL_BY_GPCS0
;R17 ;R15 - end
;R17 
;R17 ;R11 - start
;R17 ifdef	SUSPEND_SHOW_ACPILED
;R17 	;; Turn off ACPILED
;R17 		mov	cx,ACPI_R+19h
;R17 		mov	bx,00FBh
;R17 		call	Get_Set_PMU
;R17 
;R17 		mov	cx,APC_R+04h
;R17 		mov	bx,00FEh
;R17 		call	Get_Set_PMU
;R17 endif;	SUSPEND_SHOW_ACPILED
;R17 ;R11 - end
;R17 
;R17 		call	De_Assert_STPCLK
;R17 		call	Enable_Crt
;R17 
;R17 ;R04 - start
;R17 ifdef	GREEN_ASSERT_GPIO5
;R17 		mov	cx,ACPI_R+18h
;R17 		mov	bx,01DFh
;R17 		and	bh,byte ptr [SMOUT_Settings]
;R17 		shl	bh,5
;R17 		call	Get_Set_PMU
;R17 endif	;GREEN_ASSERT_GPIO5
;R17 ;R04 - end
;R17 
;R17 
;R17 ifndef	SUSPEND_NO_BEEP
;R17 	;restore speaker status
;R17 
;R17 		test	[Speaker_Status],80h
;R17 		jz	short @F
;R17 		in	al,61h
;R17 		and	al,not 03h
;R17 		and	[Speaker_Status],not 80h
;R17 		or	al,[Speaker_Status]
;R17 		out	61h,al
;R17 	@@:
;R17 endif	;SUSPEND_NO_BEEP
;R17 
;R17 		mov	al,PMI_FULLON
;R17 		out	80h,al
;R17 		mov	[PM_MODE1],FULL_ON
;R17 
;R17 		;clear wake up source
;R17 
;R17 		mov	cx,9Ah
;R17 		mov	bx,00E0h
;R17 		call	Get_Set_PMU
;R17 
;R17 		call	Update_PM_Timer
;R17 
;R17 		cmp	[PM_TIMEOUT_TYPE],03h
;R17 		jne	short @F
;R17 		mov	PM_RAM:[APMEventSave],RESUME_NORMAL_NOTIFY
;R17 	@@:
;R17 
;R17 ifdef	ADVANCE_POWER_MANAGEMENT
;R17 		and	byte ptr PM_RAM:[PM_CTRL_FLAG],not CPU_IDLE_FLAG
;R17 		cmp	PM_RAM:[APMEventSave],RESUME_NORMAL_NOTIFY
;R17 		je	short @F
;R17 		mov	PM_RAM:[APMEventSave],NO_EVENTS
;R17 	@@:
;R17 endif;	ADVANCE_POWER_MANAGEMENT
;R17 		mov	byte ptr [PM_TIMEOUT_TYPE],0
;R17 
;R17 		ret
;R17 
;R17 Set_Full_On_State	Endp
;R17 
;R17 Assert_STPCLK	Proc	Near
;R17 		mov	cx,93h
;R17 		call	Get_PMU
;R17 		or	al,28H
;R17 		call	Set_PMU
;R17 		ret
;R17 Assert_STPCLK	endp
;R17 
;R17 De_Assert_STPCLK	Proc	Near
;R17 		mov	cx,93h
;R17 		call	Get_PMU
;R17 		and	al,NOT 38h
;R17 		call	Set_PMU
;R17 		ret
;R17 De_Assert_STPCLK	Endp
;R17 ;----------------------------------------------------------------------
;R17 ifdef	POWER_DOWN_OUT_PIN
;R17 ; save	: none
;R17 ; input : al : 8042 command
;R17 ; output: none
;R17 
;R17 STAT8042	EQU	64h
;R17 Out_8042_Pin1	proc
;R17 
;R17 		cli
;R17 
;R17 		xchg	al,ah
;R17 		in	al,21h
;R17 		push	ax			;save IRQ 1 status
;R17 		or	al,2			;disable IRQ 1
;R17 		out	21h,al
;R17 		IODELAY
;R17 		xchg	al,ah
;R17 
;R17 		extrn	Buffer_8042_Full:near
;R17 		out	STAT8042,al		;set/reset pin
;R17 		NEWIODELAY
;R17 		call	Buffer_8042_Full	;wait for command accepted
;R17 
;R17 		pop	ax
;R17 		out	21h,al
;R17 		IODELAY
;R17 
;R17 		ret
;R17 Out_8042_Pin1	endp
;R17 endif	;POWER_DOWN_OUT_PIN
;R17 
;R17 ;[]========================================================================[]
;R17 ;input	:	DS = PM_RAM
;R17 ;[]========================================================================[]
;R17 		ASSUME	DS:PM_RAM
;R17 Set_PM_State	Proc	Near
;R17 
;R17 		cmp	byte ptr [si],00h
;R17 		jne	short PM_State_Yes
;R17 		cmp	si,offset Suspend_Setting
;R17 		jne	short @F
;R17 		call	Clear_Counter
;R17 		ret
;R17 	@@:
;R17 		inc	[PM_TimeOut_Type]
;R17 		inc	si
;R17 		jmp	short Set_PM_State
;R17 PM_State_Yes:
;R17 		call	Clear_Counter
;R17 
;R17 ifdef	ADVANCE_POWER_MANAGEMENT
;R17 
;R17 		test	byte ptr [Wait_APM_Flag],0FFh		;user care APM?
;R17 		jz	short Dont_Care_APM			;no!
;R17 		test	[APM_STATUS],IS_CONNECT_CALL_MADE	;APM connected?
;R17 		jz	short Dont_Care_APM			;APM not connected!
;R17 		test	[EXTEND_APM_STATUS],IS_PM_ENGAGED
;R17 		jz	short Dont_Care_APM
;R17 		cmp	[PM_TimeOut_Type],03h			;Suspend request?
;R17 		jne	short Idle_Req				;no!
;R17 		mov	[APMEventSave],SUSPENDREQUEST		;make APM request
;R17 		jmp	short Wait_For_APM
;R17 
;R17 Idle_Req:
;R17 		test	[EXTEND_APM_STATUS],APM_16BIT_FUNC_MODE
;R17 		jnz	short Dont_Care_APM
;R17 
;R17 
;R17 		or	[PM_CTRL_FLAG],CPU_IDLE_FLAG
;R17 		mov	[PM_MODE],FULL_ON
;R17 
;R17 Wait_For_APM:
;R17 
;R17 		call	Enable_WakeUp_Source
;R17 
;R17 ifndef	NO_SUPPORT_APM12
;R17 		mov	cx,9Ah		;disable IO port wake up SMI
;R17 		mov	bx,00E0h
;R17 		call	Get_Set_PMU
;R17 
;R17 		mov	cx,875h		;mask IRQ14 / IRQ15
;R17 		mov	bx,0C0FFh
;R17 		call	Get_Set_PMU
;R17 endif	;NO_SUPPORT_APM12
;R17 
;R17 		mov	cx,93h
;R17 		mov	bx,20FFh
;R17 		call	Get_Set_PMU
;R17 
;R17 		mov	al,0D0h 	;wait for APM
;R17 		out	80h,al
;R17 
;R17 		ret
;R17 Dont_Care_APM:
;R17 		mov	al,[PM_TimeOut_Type]
;R17 		or	al,0D0h
;R17 		out	80h,al
;R17 
;R17 endif;	ADVANCE_POWER_MANAGEMENT
;R17 
;R17 Go_PM_State:
;R17 
;R17 ;-------------------------------------------
;R17 ;1. disable CRT according to setup settings
;R17 ;-------------------------------------------
;R17 
;R17 		mov	dl,4
;R17 		sub	dl,[PM_TimeOut_Type]
;R17 
;R17 		cmp	[Video_Off_Mode],dl
;R17 		jb	short @F
;R17 		call	Disable_CRT
;R17 	@@:
;R17 
;R17 ;-----------------------------------------
;R17 ;4. prg SMOUT according to MODBIN settings
;R17 ;-----------------------------------------
;R17 
;R17 ;R04 - start
;R17 if	GREEN_ASSERT_PIN ne 0
;R17 		mov	dx,[SMOUT_Settings]
;R17 		mov	cl,[PM_TimeOut_Type]
;R17 		shl	cl,2
;R17 		shr	dx,cl
;R17 
;R17 	;Prg SMOUT according to MODBIN settings
;R17 
;R17  ifdef	GREEN_ASSERT_GPIO5
;R17 		mov	cx,ACPI_R+18h
;R17 		mov	bx,01DFh
;R17 		and	bh,dl
;R17 		shl	bh,5
;R17 		call	Get_Set_PMU
;R17  endif	;GREEN_ASSERT_GPIO5
;R17 endif	;GREEN_ASSERT_PIN ne 0
;R17 ;R04 - end
;R17 
;R17 ;------------------
;R17 ;5. set indications
;R17 ;------------------
;R17 
;R17 		mov	al,[PM_TimeOut_Type]
;R17 		mov	[PM_MODE],al
;R17 		mov	[PM_MODE1],al
;R17 
;R17 ;------------------------
;R17 ;6. enable trigger source
;R17 ;------------------------
;R17 
;R17 		call	Enable_WakeUp_Source
;R17 
;R17 ;------------------------------------
;R17 ;2. Clock throttling for DOZE/STANDBY
;R17 ;   Stop clock for SUSPEND
;R17 ;------------------------------------
;R17 
;R17 		cmp	[PM_TimeOut_Type],3		;Suspend request?
;R17 
;R17 ifndef	No_Stpclk_When_Suspend
;R17 
;R17 		je	Go_Suspend
;R17 
;R17 else	;No_Stpclk_When_Suspend
;R17 
;R17 		jne	@F
;R17 
;R17 		mov	cx,009Eh
;R17 		mov	al, 48h
;R17 		call	Set_PMU
;R17 
;R17 		inc	cx
;R17 		mov	al, 01h
;R17 		call	Set_PMU
;R17 
;R17 		mov	cl,93h
;R17 		mov	bx,18C7h
;R17 		call	Get_Set_PMU
;R17 
;R17 		jmp	rock_end
;R17 
;R17 endif	;No_Stpclk_When_Suspend
;R17 
;R17 	;program throttling duty cycle for DOZE & STANDBY
;R17 
;R17 		mov	al,[Doze_Speed]
;R17 		cmp	[PM_TimeOut_Type],1		;Suspend request?
;R17 		je	short @F
;R17 		mov	al,[Standby_Speed]
;R17 	@@:
;R17 
;R17 		mov	cx,9Eh
;R17 		call	Set_PMU
;R17 		inc	cx   			;then cl= 9Fh
;R17 		mov	al,36
;R17 		call	Set_PMU
;R17 
;R17 
;R17 	;enable clock throttling
;R17 
;R17 		mov	cl,93h
;R17 		mov	bx,18C7h
;R17 		call	Get_Set_PMU
;R17 
;R17 
;R17 		call	Update_PM_Timer
;R17 		mov	[PM_TimeOut_Type],00h		;clear request
;R17 rock_end:
;R17 		ret
;R17 
;R17 Set_PM_State	Endp
;R17 
;R17 ;[]========================================================================[]
;R17 ;input	:	DS = PM_RAM
;R17 ;[]========================================================================[]
;R17 Go_Suspend	Proc	Near
;R17 
;R17 IFDEF	NoteBook_Power_Management
;R17 		cmp	PM_RAM:Suspend_Option,Zero_V_Suspend
;R17 		jne	short @F
;R17 
;R17 		cmp	dword ptr PM_RAM:[ZV_HDD_Sector],0
;R17 		je	short @F
;R17 
;R17 		call	Suspend_0V
;R17 
;R17 	ifdef	ADVANCE_POWER_MANAGEMENT
;R17 	; Set resume notify flag for APM to update time
;R17 		mov	PM_RAM:[APMEventSave],RESUME_NORMAL_NOTIFY
;R17 	endif;	ADVANCE_POWER_MANAGEMENT
;R17 
;R17 		jmp	Set_Full_On_State
;R17 
;R17 	@@:
;R17 ENDIF	;NoteBook_Power_Management
;R17 
;R17 ;--------------------------
;R17 ;Turn ACPILED on
;R17 ;--------------------------
;R17 ;R11 - start
;R17 ifdef	SUSPEND_SHOW_ACPILED
;R17 	;; Turn on ACPILED
;R17 		mov	cx,ACPI_R+19h
;R17 		mov	bx,04FFh
;R17 		call	Get_Set_PMU
;R17 
;R17 		mov	cx,APC_R+04h
;R17 		mov	bx,01FFh
;R17 		call	Get_Set_PMU
;R17 endif;	SUSPEND_SHOW_ACPILED
;R17 ;R11 - end
;R17 
;R17 ;R15 - start
;R17 ;--------------------------
;R17 ;Turn FAN off
;R17 ;--------------------------
;R17 ifdef	FAN_CONTROL_BY_GPCS0
;R17 		mov	cx,0863h
;R17 ifdef	GPCS0_FAN_Lo_Active
;R17 		mov	bx,(00010000b shl 8) or 01101110b
;R17 else;	GPCS0_FAN_Lo_Active
;R17 		mov	bx,(00000000b shl 8) or 01101110b
;R17 endif;	GPCS0_FAN_Lo_Active
;R17 		call	Get_Set_PMU
;R17 endif;	FAN_CONTROL_BY_GPCS0
;R17 ;R15 - end
;R17 ;--------------------------
;R17 ;Save speaker status
;R17 ;Beep speaker & turn it off
;R17 ;--------------------------
;R17 ifdef	POWER_DOWN_OUT_PIN
;R17 		mov	al,POWER_DOWN_OUT_PIN
;R17 		Call	Out_8042_Pin1
;R17 		call	OUT_8042_FULL
;R17 		in	al,60h
;R17 		iodelay
;R17 endif	;POWER_DOWN_OUT_PIN
;R17 ;R08 - start
;R17 ifdef	ABIT_GPCS
;R17 		mov	cx,0868h
;R17 		mov	dx,5A7Ch	;io port 5A7Ch
;R17 		mov	al,dh
;R17 		call	Set_PMU
;R17 		dec	cx		;then cx=867h
;R17 		mov	al,dl
;R17 		call	Set_PMU
;R17 		mov	al,PM_RAM:[GPCS_Save_Value]
;R17 		and	al,11011111b	;active Suspend LED,  bit7:6 by PM_RAM
;R17 		out	dx,al
;R17 endif	;ABIT_GPCS
;R17 ;R08 - end
;R17 
;R17 		call	De_Assert_STPCLK
;R17 
;R17 ifndef	SUSPEND_NO_BEEP
;R17 		in	al,61h
;R17 		and	al,03h
;R17 		or	al,80h
;R17 		mov	[Speaker_Status],al
;R17 
;R17 		mov	cx, 3
;R17 		call	PM_Warning_Beep
;R17 endif	;SUSPEND_NO_BEEP
;R17 
;R17 ;--------------------------------------------------------
;R17 ;turn off HDDs according setup settings
;R17 ;      i.e. HDD_Timer_Setting = 16
;R17 ;		===> HDD off when suspend
;R17 ;--------------------------------------------------------
;R17 ifndef	No_Suspend_Off_Hdd
;R17 		cmp	[HDD_Timer_Setting],16	;HDD off when suspend?
;R17 		jne	short No_Off_HDD	;no!
;R17 		mov	[HDD_Off_Flag],0AAh
;R17 
;R17 		; << George Huang 1/10/1996
;R17 ifdef ECS_FIX_PMM_TIMER_DELAY
;R17 		mov	al,59h
;R17 		out	22h,al
;R17 		in	al,23h
;R17 		push	ax
;R17 		or	al,80h
;R17 		push	ax
;R17 		mov	al,59h
;R17 		out	22h,al
;R17 		pop	ax
;R17 		out	23h,al
;R17 endif; ECS_FIX_PMM_TIMER_DELAY
;R17 		; >>
;R17 
;R17 		call	HDD_PwDn_Immediately
;R17 
;R17 		; << George Huang 1/10/1996
;R17 ifdef ECS_FIX_PMM_TIMER_DELAY
;R17 		mov	al,59h
;R17 		out	22h,al
;R17 		in	al,23h
;R17 		pop	ax
;R17 		out	23h,al
;R17 endif; ECS_FIX_PMM_TIMER_DELAY
;R17 		;>>
;R17 
;R17 No_Off_HDD:
;R17 endif	;No_Suspend_Off_Hdd
;R17 Do_Suspend:
;R17 
;R17 
;R17 ifdef	SiS_LEGACY_SUSPEND				;R10
;R17 ;Unmask keyboard interrupt to wakeup , because QAPlus mask IRQ 1
;R17 		in	al,21H		;A8259
;R17 		NEWIODELAY
;R17 		push	ax
;R17 
;R17 
;R17 		and	al,NOT 02h	;umask IRQ 1
;R17 ifdef	PATCH_QA_CAN_WAKE_UP
;R17 		xchg	ah,al
;R17 		in	al,20h		;read ISR 1
;R17 		NEWIODELAY
;R17 		test	al,08h		;any pending IRQ 3 ?
;R17 		jnz	short _1	;yes, do not unmask IRQ 3
;R17 		and	ah,not 08h	;unmask IRQ 3
;R17 	_1:
;R17 		test	al,10h		;any pending IRQ 4 ?
;R17 		jnz	short _2	;yes, do not unmask IRQ 4
;R17 		and	ah,not 10h	;unmask IRQ 4
;R17 	_2:
;R17 		xchg	ah,al
;R17 endif	;PATCH_QA_CAN_WAKE_UP
;R17 
;R17 		out	21H,al
;R17 		NEWIODELAY
;R17 		in	al,0A1H 	;8259
;R17 		NEWIODELAY
;R17 		push	ax
;R17 		and	al,NOT 010H	;unmask IRQ 12
;R17 		out	0A1H,al
;R17 		NEWIODELAY
;R17 	; Enable Keyboard Interface
;R17 		mov	al,0AEH
;R17 		out	64H,al
;R17 		NEWIODELAY
;R17 
;R17 		call	End_PMI_Handler
;R17 	;assert STPCLK#
;R17 ifndef	NO_SUPPORT_APM12
;R17 		call	Virtual_Resume_Timer
;R17 		jnc	short WakeUpByResumeTimer
;R17 endif	;NO_SUPPORT_APM12
;R17 
;R17 		call	De_Assert_STPCLK
;R17 		call	Assert_STPCLK
;R17 
;R17 		mov	cx,100h
;R17 		loop	short $
;R17 WakeUpByResumeTimer:
;R17 
;R17 ;restore 8259 mask
;R17 		pop	ax
;R17 		out	0A1h,al
;R17 		NEWIODELAY
;R17 		pop	ax
;R17 		out	21H,al
;R17 		NEWIODELAY
;R17 
;R17 	ifndef	No_Suspend_Off_Hdd
;R17 		or	[HDD_OFF_FLAG],0
;R17 		jz	short @F
;R17 		ret
;R17 	@@:
;R17 	endif	;No_Suspend_Off_Hdd
;R17 
;R17 ifdef	PM_NETWORK_SUPPORT
;R17 		call	Read_Irq_Source
;R17 		test	al,00011010b		;IRQ 1,3,4
;R17 		jnz	short WakeUp
;R17 
;R17 		test	DGROUP:[CONFIG_TABLE+5],04H	;PS2 mouse installed ?
;R17 		jz	short No_Ps2_Mouse
;R17 
;R17 		test	ah,00010000b		;IRQ 12 ?
;R17 		jnz	short WakeUp
;R17 No_Ps2_Mouse:
;R17 
;R17 		mov	[PM_TimeOut_Type],2	;set standby mode
;R17 	;set 9sec for system to re-enter
;R17 		mov	al,01H
;R17 		mov	cx,0A2h
;R17 		call	Set_Pmu
;R17 
;R17 		mov	cl,9Ah			;enable/disable PMI
;R17 		mov	bx,807Fh
;R17 		call	Get_Set_PMU
;R17 
;R17 		in	al,80h			;show previous state
;R17 		dec	al
;R17 		out	80h,al
;R17 
;R17 		ret				;go back standby mode
;R17 WakeUp:
;R17 endif;	PM_NETWORK_SUPPORT
;R17 
;R17 	ifdef	ADVANCE_POWER_MANAGEMENT
;R17 	; Set resume notify flag for APM to update time
;R17 		mov	PM_RAM:[APMEventSave],RESUME_NORMAL_NOTIFY
;R17 	endif;	ADVANCE_POWER_MANAGEMENT
;R17 
;R17 		mov	cx,9Dh
;R17 		call	Get_PMU
;R17 		test	al,02h
;R17 		jz	short Not_B_SW_Wake
;R17 		mov	ecx,800000h
;R17 b_sw_dly:
;R17 		db	67h
;R17 		loop	b_sw_dly
;R17 Not_B_SW_Wake:
;R17 		jmp	Set_Full_On_State
;R17 ;R10 - start
;R17 else	;SiS_LEGACY_SUSPEND
;R17 		mov	cx,ACPI_R+05h
;R17 		mov	bx,20C3h
;R17 		call	Get_Set_PMU
;R17 
;R17 		ret
;R17 endif	;SiS_LEGACY_SUSPEND
;R17 ;R10 - end
;R17 
;R17 Go_Suspend	Endp
;R17 
;R17 ifdef	PM_NETWORK_SUPPORT
;R17 ;Input : none
;R17 ;Output: AX - b0 = 1 IRQ 0 occured
;R17 ;		 = 0 IRQ 0 not occured
;R17 ;	      b1 - IRQ 1 ....
;R17 Read_Irq_Source proc	near
;R17 		mov	al,0ah
;R17 		out	0a0h,al
;R17 		NEWIODELAY
;R17 		in	al,0a0H 	;read IRR of IRQ8-IRQ15
;R17 		NEWIODELAY
;R17 		mov	ah,al
;R17 
;R17 		mov	al,0ah
;R17 		out	20h,al
;R17 		NEWIODELAY
;R17 		in	al,20H		;read IRR of IRQ0-IRQ7
;R17 		NEWIODELAY
;R17 		ret
;R17 Read_Irq_Source endp
;R17 endif;	PM_NETWORK_SUPPORT
;R17 
;R17 
;R17 ifndef	No_Suspend_Off_Hdd
;R17 ;[]==================================[]
;R17 ;Input: 	None
;R17 ;Output:	CH = register 67h
;R17 ;[]==================================[]
;R17 HDD_PwDn_Immediately	Proc	Near
;R17 
;R17 ;Turn off HDD(IO write 1F7h with 0E0h)
;R17 
;R17 		mov	ah,0A0h 		;A0=first HDD
;R17 
;R17 		mov	dx,1F6h
;R17 	Stop_Next_HDD:
;R17 
;R17 		mov	al,ah
;R17 		out	dx,al			;setlect HDD
;R17 		iodelay
;R17 
;R17 		inc	dx
;R17 		mov	al,0E0h
;R17 		out	dx,al			;HDD power down immediately
;R17 		iodelay
;R17 		dec	dx
;R17 
;R17 		add	ah,10h
;R17 		cmp	ah,0b0h 		;B0=second HDD
;R17 		jbe	short Stop_Next_HDD
;R17 		cmp	dx,1f0h
;R17 		jb	short @F
;R17 		mov	dx,176h
;R17 		mov	ah,0A0h 		;A0=secondary channel first HDD
;R17 		jmp	short Stop_Next_HDD
;R17 @@:
;R17 
;R17 		push	ds
;R17 		mov	ax,G_RAM
;R17 		mov	ds,ax
;R17 		assume	DS:G_RAM
;R17 		and	[FDD_VERIFY_CMD_FLAG],not 40h	;tell INT 13
;R17 							;  to wait HDD
;R17 		assume	DS:NOTHING
;R17 		pop	ds
;R17 
;R17 		ret
;R17 HDD_PwDn_Immediately	Endp
;R17 endif	;No_Suspend_Off_Hdd
;R17 
;R17 ;-----------------------------------------------------------
;R17 ;Function :	To clear a specific counter
;R17 ;
;R17 ;Input	  :	CL = chipset register index
;R17 ;
;R17 ;Output   :	None
;R17 ;
;R17 ;Destroy  :	BX, AH, FLAGS
;R17 ;-----------------------------------------------------------
;R17 Clear_Counter	Proc	Near
;R17 		mov	cx,0A2h			;system timer
;R17 		xor	al,al
;R17 		call	Set_PMU
;R17 
;R17 		mov	cl,9Ah
;R17 		call	Get_PMU
;R17 		and	al,01111111b
;R17 		call	Set_PMU
;R17 
;R17 		ret
;R17 Clear_Counter	Endp
;R17 
;R17 ;-----------------------------------------------------------
;R17 ;-----------------------------------------------------------
;R17 		ASSUME	DS:PM_RAM
;R17 Enable_WakeUp_Source	Proc	Near
;R17 
;R17 ifdef	No_Stpclk_When_Suspend
;R17 
;R17 		mov	cx,9Ah
;R17 		mov	bx,1FE0h
;R17 		call	Get_Set_PMU
;R17 		inc	cx		;then cl= 9Bh
;R17 		mov	bx,01FEh
;R17 		call	Get_Set_PMU
;R17 
;R17 		mov	cx,875h
;R17 		call	Get_PMU
;R17 		and	al,0c0h
;R17 		cmp	al,00h		;detect IRQ14&15
;R17 		ja	rock_change1
;R17 		;
;R17 rock1:
;R17 		mov	cx,874h
;R17 		call	Get_PMU
;R17 		and	al,40h	       ;detect IRQ6(Floppy)
;R17 		cmp	al,00h
;R17 		ja	rock_change2
;R17 		;
;R17 rock2:
;R17 		mov	cx,874h
;R17 		call	Get_PMU
;R17 		and	al,18h		;detect IRQ4&3
;R17 		cmp	al,00h
;R17 		ja	rock_change3
;R17 		;
;R17 rock3:
;R17 		mov	cx,874h
;R17 		call	Get_PMU
;R17 		and	al,0a0h 	 ;detect IRQ7&5
;R17 		cmp	al,00h
;R17 		ja	rock_change4
;R17 
;R17 		; rock >>
;R17 
;R17 		jmp	by_pass_rock	;*rock
;R17 rock_change2:
;R17 		jmp	 rock2
;R17 rock_change3:
;R17 		mov	cx,9Ah
;R17 		call	Get_PMU
;R17 		and	al,11110011b
;R17 		call	Set_PMU
;R17 		jmp	 rock3
;R17 rock_change1:
;R17 		mov	cx,9Ah	       ;*rock
;R17 		call	Get_PMU        ;*rock
;R17 		and	al,11111100b   ;rock change for disabling HDD detection
;R17 		call	Set_PMU        ;*rock
;R17 		;
;R17 		jmp    rock1
;R17 
;R17 rock_change4:
;R17 		mov	cx,9Ah
;R17 		call	Get_PMU
;R17 		and	al,11101111b
;R17 		call	Set_PMU
;R17 
;R17 by_pass_rock:				;*rock
;R17 
;R17 		;enable wake trigger source 2
;R17 		mov	cx,9Bh
;R17 		mov	bx,38FFh
;R17 		call	Get_Set_PMU
;R17 
;R17 else	;No_Stpclk_When_Suspend
;R17 
;R17 ifndef	NO_SUPPORT_APM12
;R17 		mov	cx,875h		;restore IRQ events
;R17 		mov	al,byte ptr [DEASSERT_STPCLK_IRQS+1]
;R17 		not	al
;R17 		call	Set_PMU
;R17 endif	;NO_SUPPORT_APM12
;R17 		mov	cx,90h
;R17 		call	Get_PMU
;R17 		mov	ah,al
;R17 		mov	bh,al
;R17 		and	ax,0830h
;R17 		shl	ah,1
;R17 		shr	al,2
;R17 		or	al,ah
;R17 		shr	bh,7
;R17 		or	al,bh
;R17 		shl	bh,1
;R17 		or	bh,al
;R17 		mov	bl,0E0h
;R17 		mov	cl,9Ah
;R17 		call	Get_Set_PMU
;R17 
;R17 endif	;No_Stpclk_When_Suspend
;R17 
;R17 		ret
;R17 
;R17 Enable_WakeUp_Source	Endp
;R17 
;R17 ifndef	SUSPEND_NO_BEEP
;R17 ;[]========================================================================[]
;R17 ;Procedure :	PM_Warning_Beep
;R17 ;
;R17 ;Input	   :	cx = no of beeps
;R17 ;
;R17 ;Output    :	AH bit 1,0    = original speaker status
;R17 ;		AL bit 765432 = original port 61h status
;R17 ;		       1,0    = 00
;R17 ;
;R17 ;Note	   :	speaker will be turned off
;R17 ;
;R17 ;[]========================================================================[]
;R17 DATA8254	EQU	40H
;R17 CTRL8254	EQU	43H
;R17 
;R17 		Public	PM_Warning_Beep
;R17 PM_Warning_Beep Proc	Near
;R17 
;R17 ;------------------ program speaker frequency -------------------------
;R17 
;R17 		mov	al,0B6H
;R17 		out	CTRL8254,al
;R17 		NEWIODELAY
;R17 		mov	al,50h
;R17 		out	DATA8254+2,al
;R17 		NEWIODELAY
;R17 		mov	al,03h
;R17 		out	DATA8254+2,al
;R17 		NEWIODELAY
;R17 
;R17 
;R17 ;------------------------ Beep loop -----------------------------------
;R17 
;R17 Beep_Loop:
;R17 		push	cx
;R17 
;R17 		in	al,61h
;R17 		NEWIODELAY
;R17 		or	al,3
;R17 		out	61h,al
;R17 		NEWIODELAY
;R17 
;R17 		mov	cx,1000h
;R17 		call	Wait_Refr
;R17 
;R17 		and	al,not 03h
;R17 		out	61h,al
;R17 		NEWIODELAY
;R17 
;R17 		call	Wait_Refr
;R17 
;R17 		pop	cx
;R17 
;R17 		loop	Beep_Loop
;R17 
;R17 		ret
;R17 ENDH	PM_Warning_Beep
;R17 
;R17 ;--------------------------------------------
;R17 ;Input	:	CX = number of Refresh Cycle
;R17 ;--------------------------------------------
;R17 		ALIGN	4
;R17 Wait_Refr	Proc	Near
;R17 		pusha
;R17 
;R17 Next_Refresh_Cycle:
;R17 
;R17 	@@:
;R17 		in	al,61h
;R17 		test	al,010h
;R17 		jz	short @B
;R17 	@@:
;R17 		in	al,61h
;R17 		test	al,010h
;R17 		jnz	short @B
;R17 
;R17 		loop	Next_Refresh_Cycle
;R17 		popa
;R17 		ret
;R17 Wait_Refr	Endp
;R17 endif	;SUSPEND_NO_BEEP
;R17 
;R17 ;----------------------------------------------------------------------
;R17 ;Function :	Set Mode timer with appropriate value
;R17 ;Input	  :	DS = PM_RAM
;R17 ;----------------------------------------------------------------------
;R17 		ASSUME	DS:PM_RAM
;R17 Update_PM_Timer Proc	Near
;R17 
;R17 		pusha
;R17 
;R17 		mov	al,[PM_MODE1]
;R17 		xor	ah,ah
;R17 		mov	cx,3
;R17 		sub	cx,ax
;R17 		mov	si,offset PM_RAM:Doze_Setting
;R17 		add	si,ax
;R17 
;R17 		xor	al,al
;R17 		jcxz	short Prg_Sys_Value
;R17 	@@:
;R17 		mov	al,[si]
;R17 		or	al,al
;R17 		jnz	short Prg_Sys_Value
;R17 		inc	si
;R17 		loop	short @B
;R17 		xor	al,al
;R17 Prg_Sys_Value:
;R17 	push	ax
;R17 		mov	cx,0A2h			;system timer low byte
;R17 		call	Set_PMU
;R17 
;R17 		mov	cl,9Ah			;enable/disable PMI
;R17 		call	Get_PMU
;R17 	pop	dx
;R17 		and	al,01111111b
;R17 		or	dl,dl
;R17 		jz	short @F
;R17 		or	al,10000000b
;R17 	@@:
;R17 		call	Set_PMU
;R17 
;R17 		popa
;R17 
;R17 		ret
;R17 Update_PM_Timer Endp
;R17 
;R17 ;[]========================================================================[]
;R17 ;Procedure:	End_PMI_Handler
;R17 ;
;R17 ;Function :	Handle the end of PMI
;R17 ;
;R17 ;Input	  :	DS = PM_RAM
;R17 ;
;R17 ;Output   :	None
;R17 ;
;R17 ;Note	  :	1. called from every PMI & after PMI requests has been served
;R17 ;		2. stack available
;R17 ;[]========================================================================[]
;R17 	ASSUME	DS:PM_RAM
;R17 	Public	End_PMI_Handler
;R17 End_PMI_Handler Proc	Near
;R17 
;R17 		mov	cx,9Bh			;clear software SMI control
;R17 		mov	bx,00FEh
;R17 		call	Get_Set_PMU
;R17 
;R17 		inc	cx		;then cl= 9Ch
;R17 		xor	al,al			;clear status
;R17 		call	Set_PMU
;R17 		inc	cx		;then cl= 9Dh
;R17 		call	Set_PMU
;R17 
;R17 		mov	cl,93h			;clear software SMI trigger
;R17 		mov	bx,00FDh
;R17 		call	Get_Set_PMU
;R17 ;R10 - start
;R17 ifndef	SiS_LEGACY_SUSPEND
;R17 		mov	cx,ACPI_R+01h
;R17 		mov	bx,00FFh
;R17 		call	Get_Set_PMU
;R17 		mov	cl,14h
;R17 		mov	bx,00FFh
;R17 		call	Get_Set_PMU
;R17 		mov	dx,ACPI_BASE_IO_ADDR+25h
;R17 		in	al,dx
;R17 		out	dx,al
;R17 endif	;SiS_LEGACY_SUSPEND
;R17 ;R10 - end
;R17 
;R17 		ret
;R17 End_PMI_Handler Endp

endif	;PM_SUPPORT

;[]===============================================================[]
;
; Cfg_Video_Mode:
;	Routine to initial video after vga initial within POST.
;
; Entry:	none
;
; Exit: 	none
;
; Name	| Date		| Description
; -----------------------------------------------------------------
;[]==================================================================[]
		public	Cfg_Video_Mode
HOOK	Cfg_Video_Mode
		ret
ENDH	Cfg_Video_Mode


;----------------------------------------------------------------------------
;Output   :	AL = 0	DPMS not support
;		(CRT sleep disable or Controll by H/V sync & Blanking)
;		   = 1	CRT sleep use DPMS STANDBY
;		   = 2	CRT sleep use DPMS SUSPEND
;*(Default Value)  = 3	CRT sleep use DPMS OFF
;		   = 4	CRT sleep use DPMS REDUCE ON (not support in v1.0)
;----------------------------------------------------------------------------
		Public	Get_DPMS_Option
HOOK	Get_DPMS_Option,0E000h

ifdef	PM_SUPPORT
		extrn	VGA_Type_Item:near
		extrn	GetItem_Value:near
		mov	si,offset DGROUP:VGA_Type_Item
		EFcall	GetItem_Or
		cmp	al,3
		je	short @F
		xor	al,al
@@:
endif;	PM_SUPPORT
		ret

ENDH	Get_DPMS_Option,0F000h

	ifdef	CRT_Control_Not_In_APM
		include	CRT_Ctrl.inc
	endif	;CRT_Control_Not_In_APM

ifdef	Notebook_Power_Management

;
;
;		Chipset depand for Notebook Power Management
;
;

;[]========================================================================[]
;Procedure:	CT_Restore_VGA
;
;Function :	Restore VGA extended registers and states
;
;Input	  :	DS = Segment for save buffer.
;		ESI = Offset for save buffer.
;
;Output   :	None
;
;Preserve :
;
;[]========================================================================[]
HOOK	CT_Restore_VGA,0E000h,0E000h
;R13 - start
ifndef	NEW_SUPERVGA_KERNEL
		push	ds

		push	es
		pop	ds

		mov	esi,ebx
		add	esi,offset VGA_State_Save

;
; Restore standard VGA register
;
		mov	dx,3C4h
		mov	esi,ebx
		add	esi,offset TSR_Save
		mov	cx,4
		mov	ah,1
		call	Rep_Restore_VGA		; Restore Sequencer Register

		mov	dx,3C2h
		mov	al,es:[ebx+VGA_Misc_Save]
		out	dx,al			; 3C2h, VGA misc out reg

		mov	dx,es:[ebx+CRTC_Address_Save]
		mov	ax,1100h		; Disable CRTC 0-7 lock
		call	Set_VGA_Reg

		mov	esi,ebx
		add	esi,offset CRTC_Save
		mov	cx,19h
		xor	ah,ah
		call	Rep_Restore_VGA		; Restore CRTC registers 0 - 18h

		mov	dx,3CEh
		mov	esi,ebx
		add	esi,offset GDC_Save
		mov	cx,9
		xor	ah,ah
		call	Rep_Restore_VGA		; Restore GDC 0 - 8

		mov	esi,ebx
		add	esi,offset ATC_Save
		xor	ah,ah
		mov	cx,14h
		call	Reset_VGA_FF
		mov	dx,3C0h
	@@:
		mov	al,ah
		out	dx,al
		lods	byte ptr ds:[esi]
		out	dx,al			; Restore ATC 0 - 13h
		inc	ah
		loop	short @B

		mov	dx,es:[ebx+CRTC_Address_Save]
		add	dl,6
		mov	al,es:[ebx+Feature_Control_Save]
		out	dx,al			; Restore Feature control
		push	dx

		mov	dx,3C4h
		mov	al,es:[ebx+TSR_Index_Save]
		out	dx,al			; Restore TSR index

		mov	dx,es:[ebx+CRTC_Address_Save]
		mov	al,es:[ebx+CRTC_Index_Save]
		out	dx,al			; Restore CRTC index

		mov	dx,3CEh
		mov	al,es:[ebx+GDC_Index_Save]
		out	dx,al			; Restore GDC index

		pop	dx
		in	al,dx
		mov	dx,3C0h
		mov	al,es:[ebx+ATC_Index_Save]
		out	dx,al			; Restore ATC index

		mov	ch,14h
		mov	cl,es:[ebx+Color_Select_Save]
		call	Set_VGA_Att		; Restore color select

		mov	al,es:[ebx+PEL_Mask_Save]
		mov	dx,03C6h
		out	dx,al			; Restore PEL Mask

		call	Wait_VRetrace
		mov	esi,ebx
		add	esi,offset DAC_Save
		mov	dx,3C8h
		xor	al,al
		out	dx,al			; port 3C8h, VGA pel address
		inc	dx
		mov	cx,100h
	@@:
		lods	byte ptr ds:[esi]	
		out	dx,al			; Restore DAC
		lods	byte ptr ds:[esi]	
		out	dx,al			; Restore DAC
		lods	byte ptr ds:[esi]
		out	dx,al			; Restore DAC
		loop	short @B

		mov	dx,3C7h
		mov	al,es:[ebx+DAC_State_Save]
		test	al,1
		mov	al,es:[ebx+PEL_Address_Save]
		jnz	short @F
		inc	dx
	@@:
		out	dx,al			; Restore PEL R/W State

		pop	ds
endif;	NEW_SUPERVGA_KERNEL
;R13 - end
		ret
ENDH	CT_Restore_VGA

;[]========================================================================[]
;Procedure:	CT_Save_VGA
;
;Function :	Save VGA extended registers and states
;
;Input	  :	ES = Segment for save buffer.
;
;Output   :	None
;
;Preserve :
;
;[]========================================================================[]
HOOK	CT_Save_VGA,0E000h,0E000h

;R13 - start
ifndef	NEW_SUPERVGA_KERNEL
;
; Save standard VGA registers
;
		push	ebx			
		mov	edi,ebx			
		add	edi,offset VGA_State_Save

		mov	dx,3C4h			; VGA sequencr index
		in	al,dx			
		stos	byte ptr es:[edi]	;[00]: sequencr index

		call	Get_CRTC_Addr		; VGA CRTC index
		mov	ax,dx
		stos	word ptr es:[edi]	;[01,02]: CRTC address

		in	al,dx			
		stos	byte ptr es:[edi]	;[03]: CRTC index

		mov	dx,3CEh			; VGA graphic index
		in	al,dx
		stos	byte ptr es:[edi]	;[04]: graphic index

		mov	dx,3C0h			; VGA attributes index
		in	al,dx
		stos	byte ptr es:[edi]	;[05]: attributes index

		mov	dx,3CAh			; Feature control read register
		in	al,dx
		stos	byte ptr es:[edi]	;[06]: Feature control

		mov	cx,4
		mov	ah,1
		mov	dx,3C4h
		call	Rep_Save_VGA		;[07 - 0A]: sequencr reg 1 - 4

		mov	dx,3CCh			; VGA Misc. Register read
		in	al,dx
		stos	byte ptr es:[edi]	;[0B]: VGA Misc. Register

		mov	cx,19h
		xor	ah,ah
		call	Get_CRTC_Addr
		call	Rep_Save_VGA		;[0C - 24]: CRTC 0 - 18h

		mov	cx,14h
		xor	ah,ah
	@@:
		call	Get_VGA_Att
		stos	byte ptr es:[edi]	;[25 - 38]: attribute  0 - 13h
		inc	ah
		loop	short @B

		mov	cx,9
		xor	ah,ah
		mov	dx,3CEh
		call	Rep_Save_VGA		;[39 - 41]: VGA graphic 0 - 8

		mov	dx,3C7h
		in	al,dx			; VGA DAC state reg
		inc	dx
		and	al,1
		stos	byte ptr es:[edi]	;[42]: VGA DAC reg R/W status
		in	al,dx			; VGA pel address
		jz	short @F
		dec	al
	@@:
		stos	byte ptr es:[edi]	;[43]: VGA pel address

		mov	dl,0C6h
		in	al,dx
		stos	byte ptr es:[edi]	;[44]: VGA pel mask

		mov	ah,14h
		call	Get_VGA_Att
		stos	byte ptr es:[edi]	;[45]: VGA Att 14 color select

		call	Wait_VRetrace
		mov	cx,100h
		xor	al,al
		mov	dx,3C7h
		out	dx,al			; VGA pel address
		inc	dx
		inc	dx
	@@:
		in	al,dx
		stos	byte ptr es:[edi]
		in	al,dx
		stos	byte ptr es:[edi]
		in	al,dx
		stos	byte ptr es:[edi]
		loop	short @B		;[46 - 146] VGA DAC register

		pop	ebx
endif;	NEW_SUPERVGA_KERNEL
;R13 - end

		ret
ENDH	CT_Save_VGA



;[]===============================================================[]
;
; Ct_Save_COMA:
;
; Function :	Save transmit holding buffer and FIFO control of COM1
;
; Input    :	ES = PM Save area
;		DS = G_RAM
;		ESI+6 = offset es:[COMA_STAT+6]
;			--- byte to save COM1's transmit holding
;			    buffer which is write only
;		ESI+7 = offset es:[COMA_STAT+7]
;			--- byte to save COM1's FIFO control which
;			    is write only
;
; Output   :	None
;
; Saves    :	ESI,EBX,ES,DS
;
; Note	   :	Called from Suspend_Handler after saving COMA
;
;[]===============================================================[]
HOOK	Ct_Save_COMA,0E000h,0E000h
		ASSUME	DS:G_RAM
		ret
ENDH	Ct_Save_COMA

;[]===============================================================[]
;
; Ct_Save_COMB:
;
;		Save transmit holding buffer and FIFO control of COM2
;
; Input    :	ES = PM Save area
;		ESI+6 = offset ES:[COMB_STAT+6]
;			--- byte to save COM2's transmit holding
;			    buffer which is write only
;
;		ESI+7 = offset es:[COMA_STAT+7]
;			--- byte to save COM2's FIFO control which
;			    is write only
;
; Output   :	None
;
; Saves    :	ESI,EBX,ES,DS
;
; Note	   :	Called from Suspend_Handler after saving COMA
;
;[]===============================================================[]
HOOK	Ct_Save_COMB,0E000h,0E000h
		ASSUME	DS:G_RAM
		ret
ENDH	Ct_Save_COMB

;[]===============================================================[]
;
; Ct_Save_FDC:
;
; Function :	Save FDD controller ports 3F2h & 3F7h which are
;		normally write only
;
; Input    :	ES    = PM Save area
;		ESI    = offset ES:[SHADOW_FDC_3F2]
;			--- byte to save FDC 3F2h
;		ESI+1  = offset ES:[SHADOW_FDC_3F7]
;			--- byte to save FDC 3F7h
;
; Output   :	None
;
; Note	   :	1. Called from Suspend_Handler
;		2. Fill this routine only if the PMU has shadow
;		   register for this port
;
;[]===============================================================[]
HOOK	Ct_Save_FDC,0E000h,0E000h
		ret
ENDH	Ct_Save_FDC

;[]===============================================================[]
;
; Ct_Restore_FDC:
;
; Function :	Save FDD controller ports 3F2h & 3F7h which are
;		normally write only
;
; Input    :	ES    = PM Save area
;		EBX + Save_FDC_3F2 =
;			--- byte to save FDC 3F2h
;		EBX + Save_FDC_3F7 =
;			--- byte to save FDC 3F7h
;
; Output   :	None
;
; Note	   :	1. Called from Suspend_Handler
;		2. Fill this routine only if the PMU has shadow
;		   register for this port
;
;[]===============================================================[]
HOOK	Ct_Restore_FDC,0E000h,0E000h
		ret
ENDH	Ct_Restore_FDC

;[]===============================================================[]
;
; CT_Save_8259:
;
; Function :	Save 8259 when chipset shadow support
;
; Input    :	ES = PM Save area
;
; Output   :	CF clear = Shadow 8259 support and save it.
;		CF set	 = Shadow 8259 not support.
;
; Note	   :	1. Called from Suspend_Handler
;		2. Fill this routine only if the PMU has shadow
;		   register for this port
;
;		3. The following is save 8259 buffer location brief
;
;		Master ICW1:	Save_8259_Area+0
;		Master ICW2:	Save_8259_Area+1
;		Master ICW3:	Save_8259_Area+2
;		Master ICW4:	Save_8259_Area+3
;		Master OCW1:	Save_8259_Area+4
;		Master OCW2:	Save_8259_Area+5
;		Master OCW3:	Save_8259_Area+6
;		Reserve    :	Save_8259_Area+7
;		Slave ICW1 :	Save_8259_Area+8
;		Slave ICW2 :	Save_8259_Area+9
;		Slave ICW3 :	Save_8259_Area+10
;		Slave ICW4 :	Save_8259_Area+11
;		Slave OCW1 :	Save_8259_Area+12
;		Slave OCW2 :	Save_8259_Area+13
;		Slave OCW3 :	Save_8259_Area+14
;		Reserve    :	Save_8259_Area+15
;
;[]===============================================================[]
HOOK	CT_Save_8259,0E000h,0E000h

		mov	edi,ebx
		add	edi,offset Save_8259_Area
		mov	cx,084Ch
@@:			
		EFcall	Get_PMU
		stos	byte ptr es:[edi]		; Master ICW1~4
		inc	cx
		cmp	cl,4Fh
		jbe	short @B

		inc	edi				; Skip	 OCW1
		mov	cl,54h
@@:
		EFcall	Get_PMU
		stos	byte ptr es:[edi]		; Master OCW2~3
		inc	cx
		cmp	cl,55h
		jbe	short @B

		inc	edi				; Skip Reserve

		mov	cl,50h
@@:
		EFcall	Get_PMU
		stos	byte ptr es:[edi]		; Slave ICW1~4
		inc	cx
		cmp	cl,53h
		jbe	short @B

		inc	edi				; Skip	OCW1
		mov	cl,56h
@@:
		EFcall	Get_PMU
		stos	byte ptr es:[edi]		; Slave OCW2~3
		inc	cx
		cmp	cl,57h
		jbe	short @B

		clc
		ret
ENDH	CT_Save_8259

;[]========================================================================[]
;
;Procedure:	CT_0V_Shutdown
;
;Function :	Routine to put system into off state.
;
;Input	  :	None
;
;Output   :	None
;
;[]========================================================================[]
HOOK	CT_0V_Shutdown,0E000h,0E000h
ifdef	CT0V_SHUTDOWN_JMP_APM16
		extrn	APM_16_PowerOff:near
		EFcall	DGROUP:APM_16_PowerOff
else	;CT0V_SHUTDOWN_JMP_APM16
		ret
endif	;CT0V_SHUTDOWN_JMP_APM16
ENDH	CT_0V_Shutdown

;[]========================================================================[]
;
;Procedure:	CT_System_Wakeup
;
;Function :	Routine for system wake up from Zero-Volt-Suspend.
;
;Input	  :	None
;
;Output   :	None
;
;[]========================================================================[]
HOOK	CT_System_Wakeup,0E000h,0E000h
		ret
ENDH	CT_System_Wakeup

;[]========================================================================[]
;
; Suspend_Chipset_Table
;
;	This table describe chipset registers which save & restore during
;	Zero-Volt-Suspend & Resume.
;	It is refrenced by routine Save_Chipset & Restore_Chipset.
;
;	Formate:
;
;		DW	<Register Index start>, <Regisetr counts>
;		DW		:			:
;		DW		:			:
;		DW		:			:
;		DW	<Register Index start>, <Regisetr counts>
;		DW	FFFFh					; End of table
;
;
;[]========================================================================[]
		PUBLIC	Suspend_Chipset_Table
Suspend_Chipset_Table:
;R02		dw	0000h,256
;R02		dw	0800h,256
		dw	0000h,512	;R02
		dw	0800h,512	;R02
		dw	0900h,512	;R02
		dw	0A00h,512	;R02
		dw	0FFFFh

;[]========================================================================[]
;Procedure:	Get_SMBASE_Seg
;
;Function :	Return SMBASE segment.
;
;Input	  :	None
;
;Output   :	EAX: should point to the SMBASE address (32bit address).
;
;[]========================================================================[]
HOOK	Get_SMBASE_SEG,0E000h,0E000h
ifdef	SMBASE_USE_E000H
		mov	eax,0D8000h
else	;SMBASE_USE_E000H
		mov	eax,098000h
endif	;SMBASE_USE_E000H
		ret
ENDH	Get_SMBASE_SEG

;[]========================================================================[]
;Procedure:	CT_AllShadow_RW
;
;Function :	To Enable/Disable all shadow Read/Write.
;
;Input	  :	AL = 0 For all shadow readable.
;		AL = 1 For all shadow writeable.
;
;Output   :	None
;
;Preserve :
;
;Note	  :	1. Stack available.
;		2. called from Suspend_0V or Resume_0V.
;		3. If the chipset support shadow RAM both Readable & Writeable
;		   then don't care input AL, Just program chipset for shadow
;		   RAM both R/W-able.
;
;[]========================================================================[]
HOOK	CT_AllShadow_RW,0E000h,0E000h
		pusha
;R06		extrn	C000_Shadow_RW:Near
;R06		extrn	Ct_C8_To_DF_RW:Near
;R06		EFcall	DGROUP:C000_Shadow_RW
;R06		EFcall	DGROUP:Ct_C8_To_DF_RW
;R06 - start
		mov	cx,70h
		mov	bx,0AA55h
@@:
		EFcall	Get_Set_PMU
		inc	cx
		cmp	cl,73h
		jbe	short @B
;R06 - end
		popa
		ret
ENDH	CT_AllShadow_RW

;[]========================================================================[]
;Procedure:	CT_SMBASE_Off
;
;Function :	To disable SMBASE map function.
;
;Input	  :	None
;
;Output   :	None
;
;[]========================================================================[]
HOOK	CT_SMBASE_Off,0E000h,0E000h
ifndef	SMBASE_USE_E000H
		pusha
		mov	cx,0A3h
;R02		mov	bx,403Fh
		mov	bx,803Fh	;R02	E000 map to B000
		EFcall	Get_Set_PMU
		popa
endif;	SMBASE_USE_E000H
		ret
ENDH	CT_SMBASE_Off

;[]========================================================================[]
;Procedure:	CT_SMBASE_On
;
;Function :	To Enable SMBASE map function.
;
;Input	  :	None
;
;Output   :	None
;
;[]========================================================================[]
HOOK	CT_SMBASE_On,0E000h,0E000h
ifndef	SMBASE_USE_E000H
		pusha
		mov	cx,0A3h
		mov	bx,0C03Fh
		EFcall	Get_Set_PMU
		popa
endif;	SMBASE_USE_E000H
		ret
ENDH	CT_SMBASE_On

;[]========================================================================[]
;Procedure:	CT_Disable_SMI
;
;Function :	To disable SMI trigger.
;
;Input	  :	None
;
;Output   :	None
;
;[]========================================================================[]
HOOK	CT_Disable_SMI,0E000h,0E000h

		mov	cx,9Ah
		xor	al,al
@@:
		EFcall	Set_PMU
		inc	cx
		cmp	cl,9Dh
		jbe	short @B

		ret
ENDH	CT_Disable_SMI

;[]========================================================================[]
;Procedure:	CT_Skip_ZV_Shadow
;
;Function :	To tell ZV suspend kernal that do not save/restore shadow RAM
;		if it is need.
;
;Input	  :	AX = shadow RAM segment C000H,D000H,E000H,F000H.
;
;Output   :	ZF = Skip this segment save/restore during ZV susupend/resume.
;		NZF = This segment save/restore during ZV susupend/resume.
;
;Save	  :	AX
;
;Note	  :	Sometime chipset use shadow RAM for SMBASE, So it is need to
;		skip shadow RAM save/restore during ZV susupend/resume.
;		Refrence the chipset Sis-550X for this case.
;
;[]========================================================================[]
HOOK	CT_Skip_ZV_Shadow,0E000h,0E000h
ifdef	SMBASE_USE_E000H
		cmp	ax,0E000h
else	;SMBASE_USE_E000H
		or	ax,ax
endif	;SMBASE_USE_E000H
		ret
ENDH	CT_Skip_ZV_Shadow

;[]==================================================================[]
;
; Procedure Name: CT_GET_SUSPEND_MODE
;
;	This routine is return suspend method to kernal
;
; Saves: DS,ES
; Input:
;	none
;
; Output:
;	Al = 0	Static_Suspend	(Asserts STPCLK#)
;	   = 1	Zero_V_Suspend	(Suspend to Disk)
;	   = 2	Five_V_Suspend	(Suspend to DRAM)
;
; [Note]:
;
; Author: Daniel Huang
; Date: September, 09, 1995
;
; Name	| Date		| Description
; -----------------------------------------------------------------
; DNL	| 09/09/95	| Initial version for Intel MOBIL TRITON
;[]==================================================================[]
HOOK	Ct_Get_Suspend_Mode,0E000h,0E000h

		extrn	Suspend_Option_Item:near
		mov	si,offset DGROUP:Suspend_Option_Item
		EFcall	GetItem_Or

		ret

ENDH	Ct_Get_Suspend_Mode

;[]==================================================================[]
; Procedure Name: Ct_Save_VRAM
; Saves: All but Flag
; Input: none
; Output: CF	:	Normal VRAM save method
;	  NC	:	Special VRAM save method ,
;			do it on this procedure
;[]==================================================================[]
		extrn	Get_ZV_HDD_Loc:near
		extrn	HDD_Transfer:near
		extrn	Video_State:near
HOOK	Ct_Save_VRAM,0E000h,0E000h

comment	%	;R13
		push	ds
		push	es
		push	ebx

 ;-----------------------------------------------------------------------
 ;
 ; save the state of the video subsystem
 ;
 ;-----------------------------------------------------------------------

		mov	al,01h
		EFcall	video_state,0E000h

		EFcall	Get_ZV_HDD_Loc,0E000h
		add	ebx,ZV_HDD_VBUFFER_Sector

		mov	ax,ZV_Temp_Stack
		mov	ds,ax
		mov	esi,offset VIDEO_BUFFER

		mov	ah,30h
		mov	al,(4*1024)/512
		EFcall	HDD_Transfer,0E000h

		pop	ebx
		pop	es
		pop	ds

		stc
%		;R13

;R13 - start
ifndef	NEW_SUPERVGA_KERNEL

		push	ds
		push	es
		push	ebx

 ;-----------------------------------------------------------------------
 ;
 ; save the state of the video subsystem
 ;                    
 ;-----------------------------------------------------------------------
 
 		mov	al,01h
		Call	video_state
 
 		call	Get_ZV_HDD_Loc
 		add	ebx,ZV_HDD_VBUFFER_Sector
 
 		mov	ax,ZV_Temp_Stack
 		mov	ds,ax
 		mov	esi,offset VIDEO_BUFFER
 
 		mov	ah,30h
 		mov	al,(4*1024)/512
 		Call	HDD_Transfer

 ;-----------------------------------------------------------------------
 ;
 ; save the video RAM use VESA function call
 ;                    
 ;-----------------------------------------------------------------------

	;;;; Step 1 :  set mode 101h

		mov	ax,4F02h
		mov	bx,8101h		;Set Mode 101h
		F000_Call Video_Func	

	;;;; Step 2 : Disable display output 

                call    Reset_VGA_FF
                mov     dx,03c0h
                xor     al,al
                out     dx,al

	;;;; Step 3 : Get mode 101h information

                mov     ax,ZV_Temp_Stack
                mov     es,ax
                mov     di,offset VIDEO_BUFFER + 100h
                mov     ax,4F01h
		mov	cx,101h
		F000_Call Video_Func	

	;;;; Step 4 : Get VRAM size

                mov     di,offset VIDEO_BUFFER
                mov     ax,4F00h
		F000_Call Video_Func	

                mov     ax,es:[di+12h]

	;;;; Step 5 : Get windows segment

		mov	dx,es:[di+108h]
		xor	bx,bx
		test	byte ptr es:[di+102h],2
		jnz	short @F

		mov	bl,01h
		mov	dx,es:[di+10Ah]
	@@:
		mov	ds,dx
		push	bx

	;;;; Step 6 : Calculate the number of pages

		shl	ax,6
		mov	cx,es:[di+106h]
		xor	dx,dx
		div	cx
		push	ax
		
	;;;; Step 7 : Calculate the number of Granularity units per page

		mov	ax,es:[di+106h]
		mov	cx,es:[di+104h]
		xor	dx,dx
		div	cx

		mov	di,ax
		pop	cx

	;;;; Step 8 : Save VRAM

                call    Get_ZV_HDD_Loc
                add     ebx,ZV_HDD_VRAM_Sector

		xor	dx,dx
		pop	ax
Vesa_Save_RAM:
		push	ax
		push	dx
		push	di
		push	ebx
		push	ds

		mov	bx,ax
		mov	ax,4F05h
		F000_Call Video_Func	

		pop	ds
		pop	ebx
                mov     ah,30h                  ;Write Command
                mov     al,(64*1024)/512
                xor     esi,esi
                Call    HDD_Transfer
                add     ebx,(64*1024)/512

		pop	di
		pop	dx
		add	dx,di
		pop	ax
                loop    Vesa_Save_RAM

		pop	ebx
		pop	es
		pop	ds

		clc				
endif;	NEW_SUPERVGA_KERNEL
;R13 - end
		ret
ENDH	Ct_Save_VRAM

;[]==================================================================[]
; Procedure Name: Ct_Restore_VRAM
; Saves: All but Flag
; Input: none
; Output: CF	:	Normal VRAM restore method
;	  NC	:	Special VRAM restore method ,
;			do it on this procedure
;[]==================================================================[]
HOOK	Ct_Restore_VRAM,0E000h,0E000h

comment	%	;R13
		push	ds
		push	es
		push	ebx

;-----------------------------------------------------------------------
;
; restore the state of the video subsystem
;
;-----------------------------------------------------------------------

		EFcall	Get_ZV_HDD_Loc,0E000h
		add	ebx,ZV_HDD_VBUFFER_Sector

		mov	ax,ZV_Temp_Stack
		mov	es,ax
		mov	edi,offset VIDEO_BUFFER

		mov	ah,20h
		mov	al,(4*1024)/512
		EFcall	HDD_Transfer,0E000h

		mov	al,02h
		EFcall	video_state,0E000h

		pop	ebx
		pop	es
		pop	ds

		stc
%		;R13

;R13 - start
ifndef	NEW_SUPERVGA_KERNEL
		push	ds
		push	es
		push	ebx

 ;-----------------------------------------------------------------------
 ;
 ; restore the video RAM use VESA function call
 ;                    
 ;-----------------------------------------------------------------------

	;;;; Step 1 :  set mode 101h

		mov	ax,4F02h
		mov	bx,0101h		;Set Mode 101h
		F000_Call Video_Func	

	;;;; Step 2 : Disable display output 

                call    Reset_VGA_FF
                mov     dx,03c0h
                xor     al,al
                out     dx,al

	;;;; Step 3 : Get mode 101h information

                mov     ax,ZV_Temp_Stack
                mov     es,ax
                mov     di,offset VIDEO_BUFFER + 100h
                mov     ax,4F01h
		mov	cx,101h
		F000_Call Video_Func	

	;;;; Step 4 : Get VRAM size

                mov     di,offset VIDEO_BUFFER
                mov     ax,4F00h
		F000_Call Video_Func	

                mov     ax,es:[di+12h]

	;;;; Step 5 : Get windows segment

		mov	dx,es:[di+108h]
		xor	bx,bx
		test	byte ptr es:[di+102h],4
		jnz	short @F

		mov	bl,01h
		mov	dx,es:[di+10Ah]
	@@:
		mov	ds,dx
		push	bx

	;;;; Step 6 : Calculate the number of pages

		shl	ax,6
		mov	cx,es:[di+106h]
		xor	dx,dx
		div	cx
		push	ax
		
	;;;; Step 7 : Calculate the number of Granularity units per page

		mov	ax,es:[di+106h]
		mov	cx,es:[di+104h]
		xor	dx,dx
		div	cx

		mov	di,ax
		pop	cx

	;;;; Step 8 : Save VRAM

                call    Get_ZV_HDD_Loc
                add     ebx,ZV_HDD_VRAM_Sector

		xor	dx,dx
		push	ds
		pop	es
		pop	ax
VEsa_Restore_RAM:
		push	ax
		push	dx
		push	di
		push	ebx
		push	es

		mov	bx,ax
		mov	ax,4F05h
		F000_Call Video_Func	

		pop	es
		pop	ebx
                mov     ah,20h                  ;Read Command
                mov     al,(64*1024)/512
                xor     edi,edi
                Call    HDD_Transfer
                add     ebx,(64*1024)/512

		pop	di
		pop	dx
		add	dx,di
		pop	ax
                loop    Vesa_Restore_RAM

;-----------------------------------------------------------------------
;
; restore the state of the video subsystem
;                    
;-----------------------------------------------------------------------

		call	Get_ZV_HDD_Loc
		add	ebx,ZV_HDD_VBUFFER_Sector

		mov	ax,ZV_Temp_Stack
		mov	es,ax
		mov	edi,offset VIDEO_BUFFER

		mov	ah,20h
		mov	al,(4*1024)/512
		Call	HDD_Transfer

;R13A		mov	ax,83h
		mov	ax,8Dh				;R13A
		F000_Call Video_Func	
		push	cx
		mov	cx,400h
		loop	$
		pop	cx

		mov	al,02h
		Call	video_state

		pop	ebx
		pop	es
		pop	ds

		clc				
endif;	NEW_SUPERVGA_KERNEL
;R13 - end
		ret
ENDH	Ct_Restore_VRAM

;[]==================================================================[]
; Procedure Name: Set_Full_On_SMM
; Saves: All
; Input: none
; Output: none
; Function:
;	to wakeup system in this procedure
;[]==================================================================[]
HOOK	Set_Full_On_SMM,0E000h,0E000h
		ret
ENDH	Set_Full_On_SMM

;R01 - start
HOOK	Save_Ct_device,0E000h,0E000h
		ret
ENDH	Save_Ct_device

HOOK	Restore_Ct_device,0E000h,0E000h
		ret
ENDH	Restore_Ct_device
;R01 - end
;R03 - start
HOOK	Get_Battery_UNIT
		ret
ENDH	Get_Battery_UNIT
;R03 - end

endif	;Notebook_Power_Management

ifdef	LCD_CRT_OPTION
HOOK	LCD_BACKLIGHT_ON
 ifdef	CHIP_655XX
		mov	ax,5F54h
		mov	bl,0
		Call	Video_Func
 endif	;CHIP_655XX
		ret
ENDH	LCD_BACKLIGHT_ON

HOOK	LCD_BACKLIGHT_OFF
 ifdef	CHIP_655XX
		mov	ax,5F54h
		mov	bl,1
		Call	Video_Func
 endif	;CHIP_655XX
		ret
ENDH	LCD_BACKLIGHT_OFF
endif	;LCD_CRT_OPTION

ifdef	CHIP_655XX
		Public	Int15_Func5F
Int15_Func5F	Proc	Near
		ret
Int15_Func5F	Endp
endif	;CHIP_655XX

;R17 - start
extrn	OUT_8042_FULL:near
F000_OUT_8042_FULL	proc	far
		call	OUT_8042_FULL
		retf
F000_OUT_8042_FULL	endp

F000_Check_If_M1	proc	far
		call	Check_If_M1
		retf
F000_Check_If_M1	endp

F000_Enable_CRT		proc	far
		call	Enable_CRT
		retf
F000_Enable_CRT		endp

F000_Disable_CRT	proc	far
		call	Disable_CRT
		retf
F000_Disable_CRT	endp

ifdef	NoteBook_Power_Management
F000_Suspend_0V	proc	far
		call	Suspend_0V
		retf
F000_Suspend_0V	endp
endif	;NoteBook_Power_Management
;R17 - end

;output : zero set - is M1 CPU
;	  non zero - not M1
HOOK	Check_If_M1,0F000h
		mov	al,CMOS_AWARD_2 NMI_OFF
		call	Get_Cmos
		and	al,CPU_TYPE_MASK
		cmp	al,TYPE_M1
		ret
ENDH	Check_If_M1

ifdef	INT8_SOUND_VOLUME
HOOK	Prg_Sound_Chip,0F000h
;Read_Status
; 130 Port
; SD0 = 1 Volume Up
; SD1 = 1 Volume Down
; SD2 = 1 Mute
;
		pusha
		push	es
		push	ds
		pushf

		mov	ax,G_RAM
		mov	ds,ax
		assume	ds:G_RAM

		cli
		mov	al,byte ptr G_RAM:[LOW_8254_CNT]
		and	al,03H		;0FH
		cmp	al,03H		;05h
		jne	Exit_control

		mov	dx,130h
		in	al,dx

		cmp	al,0feh 		 ; bit 0 = 0 up volume
		jz	short Do_Up_Volume

		cmp	al,0fdh 		 ; bit 1 = 0 down volume
		jz	short Do_Down_Volume

		cmp	al,0fbh 		 ; bit 2 = 0 mute volume
		jz	Do_Mute_Volume
		jmp	Exit_control
Do_Up_Volume:

; Master Volume Change to louder
; I/O Address [224h] is Mixer Address Port (Write only)
;	      [225h] is Mixer Data Port (Read/Write)

		mov	dx,224h
		mov	al,22h			; left
		out	dx,al

		inc	dx
		in	al,dx
		cmp	al,0ffh
		je	Next_control
		add	al,11h
		out	dx,al
Next_control:
	out	80h,al
		jmp	short Exit_control
Do_Down_Volume:

; Master Volume Change to silent
; I/O Address [224h] is Mixer Address Port (Write only)
;	      [225h] is Mixer Data Port (Read/Write)
;
		mov	dx,224h
		mov	al,22h			; left
		out	dx,al

		inc	dx
		in	al,dx
		cmp	al,00h
		je	Next_control_1
		sub	al,11h
		out	dx,al
Next_control_1:
	out	80h,al
		jmp	short Exit_control
Do_Mute_Volume:

; Master Volume Change to Mute
; I/O Address [224h] is Mixer Address Port (Write only)
;	      [225h] is Mixer Data Port (Read/Write)
;
		mov	dx,224h
		mov	al,22h
		out	dx,al

		inc	dx
		in	al,dx
		cmp	al,00h
		jz	Turn_on

		mov	al,00h		;mute on
		out	dx,al
	out	80h,al
		jmp	Exit_control
Turn_on:
		mov	al,66h	       ;mute off
		out	dx,al
	out	80h,al
Exit_control:
		popf
		pop	ds
		pop	es
		popa
		ret
ENDH	Prg_Sound_Chip
endif	;INT8_SOUND_VOLUME

FCODE		ENDS

;R17 - start
;--------------------------------------------------------------
;--------------------------------------------------------------
;----- The following codes will be located at E000 ! ----------
;----- The following codes will be located at E000 ! ----------
;----- The following codes will be located at E000 ! ----------
;----- The following codes will be located at E000 ! ----------
;--------------------------------------------------------------
;--------------------------------------------------------------
EGROUP		GROUP	ECODE
ECODE		SEGMENT USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP,DS:G_RAM,ES:EGROUP

;R23 - Start
ifdef	ACPI_Support
;[]========================================================================[]
;Procedure:	Ct_ACPI_Option
;
;Function :	Return ACPI on/off status
;
;Input	  :	None
;
;Output   :	CF = 1   ACPI off
;		CF = 0   ACPI on
;[]========================================================================[]
		Public	Ct_ACPI_Option
Ct_ACPI_Option	Proc	Near

		mov	si,offset ACPI_option_Item
                call    F000_GetItem_Value
		or	al,al			;Enable ACPI ?
		clc
		jz	short @F		;Yes
		stc
@@:
		ret

Ct_ACPI_Option	Endp
endif;	ACPI_Support
;R23 - End

;*********************************************************************
;*********************************************************************
;*****								 *****
;*****	    The following codes 				 *****
;*****	    (between label SMI_Handler_Start & SMI_Handler_End)  *****
;*****	    should be placed in SMRAM !!!			 *****
;*****								 *****
;*********************************************************************
;*********************************************************************
		ALIGN	4
		Public	SMI_Handler_Start
SMI_Handler_Start	label	near

		db	0E9h			;R05;JMP
		dw	?			;R05;Intel_SMI_Start or
						;R05;Cyrix_SMI_Start

;*********************************************************************
;SMI entry point for M1 CPU
;*********************************************************************
Stack_top2	EQU	07000h
ifdef	SMBASE_USE_E000H
SMBASE_AT	EQU	0E000h
else	;SMBASE_USE_E000H
SMBASE_AT	EQU	0A000h
endif	;SMBASE_USE_E000H
		ALIGN	4
;Data saving table for CYRIX CPU

SpSave		dw	?
EspSave 	dd	?
EaxSave 	dd	?
EbxSave 	dd	?
Cr2Save 	dd	?
Cr3Save 	dd	?

Gdt		dq	0
RD_WR		EQU	12h		;read/write
EX_RD		EQU	1Ah		;execute/readable
ADDR		=	0
LIMT		=	100000h
G_BIG		=	$ - Gdt
		dw	(LIMT-1 AND 0ffffh)
		dw	(ADDR AND 0ffffh)
		db	((ADDR SHR 16) AND 0ffh)
		db	RD_WR OR (0 SHL 5) OR (1 SHL 7)
		db	((LIMT-1 SHR 16) AND 0fh) OR (0 SHL 6) OR (1 SHL 7)
		db	((ADDR SHR 24) AND 0ffh)
G_CODE		=	$ - Gdt
		dw	(LIMT-1 AND 0ffffh)
		dw	(ADDR AND 0ffffh)
		db	((ADDR SHR 16) AND 0ffh)
		db	EX_RD OR (0 SHL 5) OR (1 SHL 7)
		db	((LIMT-1 SHR 16) AND 0fh) OR (0 SHL 6) OR (1 SHL 7)
		db	((ADDR SHR 24) AND 0ffh)
GDTSIZE 	=	($ - Gdt)

DsSave		dt	?
EsSave		dt	?
SsSave		dt	?
FsSave		dt	?
GsSave		dt	?
LdtSave 	dt	?
TskSave 	dt	?
Dstemp		db	0ffh,0ffh,0,0,0,92h,8fh,0,0,0	;4 Gb segment
GdtSave 	df	0
GdtNew		dw	GDTSIZE-1
		dd	?				;address
IdtSave 	df	0
RealModeIdt	dw	3ffh
		dd	0

Cyrix_SMI_Start:
		mov	cs:[_EaxSave],eax
		mov	cs:[_EspSave],esp
		mov	cs:[_EbxSave],ebx
		SVLDT	CS,_LdtSave		;save LDT
		SVTS	CS,_TskSave		;save TSK
		SVDC	CS,_DsSave,DS		;save DS
		SVDC	CS,_EsSave,ES		;save ES
		SVDC	CS,_SsSave,SS		;save SS
		SVDC	CS,_FsSave,FS		;save FS
		SVDC	CS,_GsSave,GS		;save GS
		RSDC	CS,_Dstemp,DS		;set DS
		RSDC	CS,_Dstemp,SS		;set SS
		RSDC	CS,_Dstemp,ES		;set ES

		db	066h
		SGDT	fword ptr cs:[_GdtSave] ;save GDT

		db	066h
		SIDT	fword ptr cs:[_IdtSave] ;save IDT

		mov	eax,cr2
		mov	cs:[_Cr2Save],eax		;save CR2

		mov	eax,cr3
		mov	cs:[_Cr3Save],eax		;save CR3

		mov	ax,SMBASE_AT
		mov	ss,ax		;setup stack
		mov	esp,STACK_TOP2

	;----------------------------
	;Clear VM flag in Eflags

		mov	eax,0
		push	eax
		mov	eax,SMBASE_AT
		push	eax
		mov	eax,offset @F
		sub	eax,offset SMI_Handler_Start
		push	eax
		iretd
	@@:
	;----------------------------

		db	66h
		LIDT	fword ptr cs:[_RealModeIdt]		;set real mode IDT

		mov	ax,cs
		mov	ss,ax
		mov	esp,Stack_top2

ifdef	USB_SUPPORT
		pushad
		push	ds
		push	es
		call	Usb_Smi
		pop	es
		pop	ds
		popad
		jnc	short Cyrix_SMI_Exit
endif	;USB_SUPPORT

;R17A		pushf
		call	PMI_Handler

Cyrix_SMI_Exit:
		RSLDT	CS,_LdtSave		;retore LDT
		RSTS	CS,_TskSave		;restore TSK
		RSDC	CS,_DsSave,DS		;restore DS
		RSDC	CS,_EsSave,ES		;restore ES
		RSDC	CS,_SsSave,SS		;restore SS
		RSDC	CS,_FsSave,FS		;restore FS
		RSDC	CS,_GsSave,GS		;restore GS

		db	66h
		LGDT	fword ptr cs:[_GdtSave] ;restore GDT
		db	66h
		LIDT	fword ptr cs:[_IdtSave] ;restore IDT

		mov	eax,cs:[_Cr2Save]	;restore CR2
		mov	cr2,eax
		mov	eax,cs:[_Cr3Save]	;restore CR3
		mov	cr3,eax

		mov	esp,cs:[_EspSave]
		mov	eax,cs:[_EaxSave]
		mov	ebx,cs:[_EbxSave]

		RSM

;*********************************************************************
;SMI entry point for Intel CPU
;*********************************************************************
		ALIGN	4
Intel_SMI_Start:
		DB	0EAH
		DW	offset @F - offset SMI_Handler_Start
		DW	SMBASE_AT
	@@:
		mov	ax,SMBASE_AT
		mov	ss,ax
		mov	esp,Stack_Top2

ifdef	USB_SUPPORT
		pushad
		push	ds
		push	es
		call	Usb_Smi
		pop	es
		pop	ds
		popad
		jc	short @f
		rsm
@@:
endif	;USB_SUPPORT

;far call PMI_handler in F0000h
;PMI_Handler in F0000h use IRET to return to user,
;so pushf before calling

		call	PMI_Handler

SMI_F0call_Proc:
		;push	Func_Addr			;[bp+8]
		;push	Ret_Addr			;[bp+6]
		push	offset F000_Func_End		;[bp+4]
		push	cs				;[bp+2]
		push	ax				;[bp]
		xchg	bp,sp
		mov	ax,[bp+2]
		xchg	ax,[bp+8]
		mov	[bp+2],ax
		xchg	bp,sp
		pop	ax
		FAR_JMP <offset F000_Vect>,0F000h

IFDEF		USB_SUPPORT
COMPILE_FOR_USBBIOS	=	3
		include	USBBIOS.ASM

;[]========================================================================[]
;Procedure:	Ct_USB_SMI_Check
;Function:	Check whether USB SMI or not
;Input:		none
;Output:	CF = 0 USB SMI
;		CF = 1 not USB_SMI
;[]========================================================================[]

Ct_USB_SMI_Check:
		mov	cx, 0095h
		SMI_F0CALL	Get_Ct
		test	al, 08
		clc
		jnz	short @f
		stc
@@:
		ret

;[]========================================================================[]
;Procedure:	Ct_USB_SMI_Disable
;Function:	Disable USB SMI
;Input:		none
;Output:	none
;[]========================================================================[]

Ct_USB_SMI_Disable:
		mov	cx, 0095h
		SMI_F0CALL	Get_Ct
		and	al, not 10h
		SMI_F0CALL	Set_Ct
		ret

;[]========================================================================[]
;Procedure:	Ct_USB_SMI_Entry
;Function:	Chipset process before USB SMI code executed.
;Input:		none
;Output:	none
;[]========================================================================[]

Ct_USB_SMI_Entry:
		mov	cx, 0095h
		SMI_F0CALL	Get_Ct
		and	al, not 08h
		SMI_F0CALL	Set_Ct
		ret

;[]========================================================================[]
;Procedure:	Ct_USB_SMI_Exit
;Function:	Exit SMI procedure after USB SMI process completed
;Input:		none
;Output:	none
;[]========================================================================[]

Ct_USB_SMI_Exit:
		ret
ENDIF		;USB_SUPPORT

;[]========================================================================[]
;Function :	Routine to handle the power management interrupt (PMI).
;
;Input	  :	None
;
;Output   :	if PM using IRQ --- no output!
;		if PM using NMI --- NC: BIOS has handle this NMI for
;					PM chip!
;				    CF: NMI is not issue by PM chip
;
;Destroy:	if PM using IRQ --- destroy None
;		if PM using NMI --- destroy FLAG
;[]========================================================================[]
		Public	PMI_Handler
PMI_Handler	Proc	Near
		cli

		pushad

		mov	ax,SEG REAL_IDT_LOC
		mov	es,ax
		mov	si,OFFSET REAL_IDT_LOC
		lidt	fword ptr es:[si]

		mov	dx,0CF8h
		in	eax,dx
		push	eax

		mov	cx,860h
		call	A000_Get_PMU
		mov	ah,al

		mov	cx,76h			;save shadow register
		call	A000_Get_PMU
		push	ax

		call	A000_Open_PM_RAM
		call	A000_Get_PM_RAM_Seg
		mov	ds,ax
		ASSUME	DS:PM_RAM
		call	Get_PMI_Source
		call	si
		call	End_PMI_Handler

;----------------- PMI request is done! About to leave ISR ------------------

		pop	ax			;restore shadow register
		mov	cx,76h
		call	A000_Set_PMU

		mov	bl,ah

		pop	eax
		mov	dx,0CF8h
		out	dx,eax

		mov	cx,0ffffh		;Prepare IRQ mask data for all
		mov	eax,80000874h
		mov	dx,0cf8h
		out	dx,eax
		mov	dl,0fch
		in	al,dx
		xchg	ax,cx			;Save IRQ mask data
		out	dx,ax			;Mask all
		xchg	ax,cx
		out	dx,ax			;Set back the original value

		FAR_Call F000_Check_If_M1, 0F000h
		
		xchg	bx,ax
		out	70h,al
		jz	short Yes_M1

		RSM	;Execute RSM instruction to get back to application
Yes_M1:

		popad

;R17A		iret
		ret				;R17A
PMI_Handler	Endp

ifndef	NO_SUPPORT_APM12
		include	v_alarm.inc

Low_Power_Throttling	Proc	Near
		mov	cx,9Eh
		mov	al,48h
		call	A000_Set_PMU
		inc	cx	;then cl=9Fh
		mov	al,01h
		call	A000_Set_PMU
		ret
Low_Power_Throttling	Endp
endif	;NO_SUPPORT_APM12

;[]========================================================================[]
;Procedure:	Get_PMI_Source
;
;Function :	To get the corresponding PMI routine according
;		to what kind of PMI it is
;
;Input	  :	DS = PM_RAM
;
;Output   :	SI = point to appropriate PMI handler
;		e.g. if it is a suspend request
;		     SI = offset Suspend_Handler
;
;Note	  :	1. Called from PM_Handler
;		2. stack available
;		3. The BIOS PM kernal will issue:
;		   "call si" after calling this routine!
;[]========================================================================[]
Get_PMI_Source	proc	near
;R22 - start
ifdef 	ACPI_Support
		mov	dx,ACPI_BASE_IO_ADDR+25h
		in	al,dx
		mov	si,(offset Software_SMI_Handler - offset SMI_Handler_Start)
		test	al,18h
		jnz	short PMI_Source_Got
endif; 	ACPI_Support
;R22 - end

;Check Hot Key Status
		mov	cx,086Dh
		call	A000_Get_PMU
		test	al,02h
ifdef	HOT_KEY_AS_SUSPEND									;R19
		mov	si,(offset Suspend_Switch_Handler - offset SMI_Handler_Start)		;R19
else;	HOT_KEY_AS_SUSPEND									;R19
		mov	si,(offset Software_Power_Down_Handler - offset SMI_Handler_Start)
endif;	HOT_KEY_AS_SUSPEND									;R19
		jnz	short PMI_Source_Got

;Check SMI source status from register 9Ch & 9Dh

		mov	cx,9Dh
		call	A000_Get_PMU
		mov	ah,al
		dec	cx	;then cl=9Ch
		call	A000_Get_PMU
		test	ax,0011110001111111b		;wake up ?
		mov	si,(offset Set_Full_On_State - offset SMI_Handler_Start)
		jnz	short PMI_Source_Got
		test	al,80h
		mov	si,(offset PM_TimeOut_Handler - offset SMI_Handler_Start)
		jnz	short PMI_Source_Got
		test	ah,01h
		mov	si,(offset Software_SMI_Handler - offset SMI_Handler_Start)
		jnz	short PMI_Source_Got
		test	ah,02h
		mov	si,(offset Suspend_Switch_Handler - offset SMI_Handler_Start)
		jnz	short PMI_Source_Got

		mov	dx,ACPI_BASE_IO_ADDR+25h
		in	al,dx
		test	al,02h
		mov	si,(offset Set_Full_On_State - offset SMI_Handler_Start)
		jnz	short PMI_Source_Got
		mov	cx,ACPI_R+01h
		call	A000_Get_PMU
		test	al,01h
ifdef	Power_B_O_R_as_Power_off								;R19
		pushf										;R19
		test	Power_B_O_R_Status,1							;R19
		jz	short Power_B_O_R_as_Poweroff						;R19
		mov	si,(offset Suspend_Switch_Handler - offset SMI_Handler_Start)		;R19
		jmp	short @f								;R19
Power_B_O_R_as_Poweroff:									;R19
		mov	si,(offset Software_Power_Down_Handler - offset SMI_Handler_Start)	;R19
@@:												;R19
		popf										;R19
else;	Power_B_O_R_as_Power_off								;R19
		mov	si,(offset Suspend_Switch_Handler - offset SMI_Handler_Start)
endif;	Power_B_O_R_as_Power_off								;R19
		jnz	short PMI_Source_Got

;R18 - start
ifdef	softsmi_to_purposex2
		mov	dx,6114h		
		in	ax,dx			
		test	ah,20h			
		mov	si,(offset Purpose_SMI_Handler - offset SMI_Handler_Start)
		mov	PM_RAM:Software_SMI_Byte,4
		jnz	short PMI_Source_Got	
endif	;softsmi_to_purposex2
;R18 - end
		mov	si,(offset Null_Handler - offset SMI_Handler_Start)
PMI_Source_Got:
		ret

Get_PMI_Source	endp

Software_Power_Down_Handler	Proc	Near
	;; Turn Off Power
		mov	cx,0869h
		mov	bx,10FFh
		call	A000_Get_Set_PMU
		xor	cx,cx
		loop	$
Software_Power_Down_Handler	endp

;[]========================================================================[]
;input	:	DS = PM_RAM
;[]========================================================================[]
		ASSUME	DS:PM_RAM
Set_Full_On_State	Proc	Near
	ifndef	No_Suspend_Off_Hdd
		or	[HDD_OFF_FLAG],0
		jz	short @F
		mov	[HDD_OFF_FLAG],0
		jmp	Do_Suspend
	@@:
	endif	;No_Suspend_Off_Hdd
ifdef	POWER_DOWN_OUT_PIN
		mov	al,POWER_DOWN_OUT_PIN+8
		call	Out_8042_Pin1
		FAR_Call F000_OUT_8042_FULL, 0F000h
		in	al,60h
		iodelay
endif	;POWER_DOWN_OUT_PIN

ifdef	ABIT_GPCS
		mov	cx,0868h
		mov	dx,5A7Ch	;io port 5A7Ch
		mov	al,dh
		call	A000_Set_PMU
		dec	cx		;then cx=867h
		mov	al,dl
		call	A000_Set_PMU
		mov	al,PM_RAM:[GPCS_Save_Value]
		or	al,01100000b	;turn off fan & Suspend LED
		out	dx,al
		mov	al,02h		;release io port
		call	A000_Set_PMU
endif	;ABIT_GPCS

;--------------------------
;Turn FAN on
;--------------------------
ifdef	FAN_CONTROL_BY_GPCS0
		mov	cx,0863h
ifdef	GPCS0_FAN_Lo_Active
		mov	bx,(00000000b shl 8) or 01101110b
else;	GPCS0_FAN_Lo_Active
		mov	bx,(00010000b shl 8) or 01101110b
endif;	GPCS0_FAN_Lo_Active
		call	A000_Get_Set_PMU
endif;	FAN_CONTROL_BY_GPCS0

;R25 start
;--------------------------				
;Turn FAN on By GPIO7
;--------------------------
ifdef	FAN_CONTROL_BY_GPIO7
		mov	cx,ACPI_R+18h
		mov 	bx,80FFh
		call	A000_Get_Set_PMU
endif;	FAN_CONTROL_BY_GPIO7				
;R25 end

;--------------------------
;Turn FAN on By GPIO5
;--------------------------
ifdef	FAN_CONTROL_BY_GPIO5				;;;R21
		mov	cx,ACPI_R+18h
		mov	bx,20ffh
		call	A000_Get_Set_PMU
endif; 	FAN_CONTROL_BY_GPIO5				;;;R21

ifdef	SUSPEND_SHOW_ACPILED
	;; Turn off ACPILED
		mov	cx,ACPI_R+19h
		mov	bx,00FBh
		call	A000_Get_Set_PMU

		mov	cx,APC_R+04h
		mov	bx,00FEh
		call	A000_Get_Set_PMU
endif;	SUSPEND_SHOW_ACPILED

		call	De_Assert_STPCLK
		FAR_Call F000_Enable_Crt, 0F000h

ifdef	GREEN_ASSERT_GPIO5
		mov	cx,ACPI_R+18h
		mov	bx,01DFh
		and	bh,byte ptr [SMOUT_Settings]
		shl	bh,5
		call	A000_Get_Set_PMU
endif	;GREEN_ASSERT_GPIO5

ifndef	SUSPEND_NO_BEEP
	;restore speaker status

		test	[Speaker_Status],80h
		jz	short @F
		in	al,61h
		and	al,not 03h
		and	[Speaker_Status],not 80h
		or	al,[Speaker_Status]
		out	61h,al
	@@:
endif	;SUSPEND_NO_BEEP

		mov	al,PMI_FULLON
		out	80h,al
		mov	[PM_MODE1],FULL_ON

		;clear wake up source

		mov	cx,9Ah
		mov	bx,00E0h
		call	A000_Get_Set_PMU

		call	Update_PM_Timer

		cmp	[PM_TIMEOUT_TYPE],03h
		jne	short @F
		mov	PM_RAM:[APMEventSave],RESUME_NORMAL_NOTIFY
	@@:

ifdef	ADVANCE_POWER_MANAGEMENT
		and	byte ptr PM_RAM:[PM_CTRL_FLAG],not CPU_IDLE_FLAG
		cmp	PM_RAM:[APMEventSave],RESUME_NORMAL_NOTIFY
		je	short @F
		mov	PM_RAM:[APMEventSave],NO_EVENTS
	@@:
endif;	ADVANCE_POWER_MANAGEMENT
		mov	byte ptr [PM_TIMEOUT_TYPE],0
;R20 - start
ifdef	PM_LED_USE_GPIO
		pushad
		mov	al, 0
		Call 	far ptr F000_SET_PM_LED
		popad
endif;	PM_LED_USE_GPIO
ifdef	LED_Blinking_at_PM
		pushad
		mov	al, 0
		Call 	far ptr F000_SET_PM_LED_Blinking
		popad
endif;	LED_Blinking_at_PM
;R20 - end

		ret

Set_Full_On_State	Endp

;[]==================================================================[]
;[]==================================================================[]
		align	4
PM_TimeOut_Handler	Proc	Near
; Check PM mode
		mov	al, byte ptr PM_RAM:PM_MODE1

		cmp	al,FULL_ON			;Now Full-On mode?
		mov	si,offset Doze_Setting
		mov	[PM_TimeOut_Type],01h		;Doze request
		je	short @F			;yes

		cmp	al,DOZE_MODE			;Now Doze mode?
		mov	si,offset Standby_Setting
		mov	[PM_TimeOut_Type],02h		;Standby request
		je	short @F			;no

		mov	si,offset Suspend_Setting
		mov	[PM_TimeOut_Type],03h		;Suspend request
;R18 - start
ifdef	softsmi_to_purposex2
		call	Clear_Counter	
		call	out_pm_state	
		call	Go_PM_State	
		ret
endif	;softsmi_to_purposex2
;R18 - end
	@@:
		call	Set_PM_State
		ret

PM_TimeOut_Handler	Endp

;[]========================================================================[]
;[]========================================================================[]
;R18 - start
ifdef	softsmi_to_purposex2
Purpose_SMI_Handler:
		mov	dx,6114h	
		in	ax,dx		
		or	ah,20h		
		out	dx,ax		

		mov	dx,6116h	
		in	ax,dx		
		and	ah,not 20h  	
		out	dx,ax		
endif	;softsmi_to_purposex2
;R18 - end
Software_SMI_Handler	Proc	Near
ifdef	ACPI_Support				;R22
		call	ACPIOnOff		;R22
		jc	short @f		;R22
		ret				;R22
@@:						;R22
endif;	ACPI_Support				;R22

		Public	APM_R31_Added
APM_R31_Added:
		mov	al, [Software_SMI_Type]
		cmp	al, CRT_OFF_REQ
		jne	short @F
		FAR_Call F000_Disable_Crt, 0F000h
		ret
	@@:
		cmp	al, CRT_ON_REQ
		jne	short @F
		FAR_Call F000_Enable_Crt, 0F000h
		ret
	@@:

ifndef	NO_SUPPORT_APM12
		
	;------------------------------------------------------

		cmp	al, ENABLE_RESUME_TIMER_REQ
		jne	short @F
		ret
	@@:

	;------------------------------------------------------

		cmp	al, DISABLE_RESUME_TIMER_REQ
		jne	short @F
		ret
	@@:

	;------------------------------------------------------

		cmp	al, ENABLE_RESUME_RING
		jne	short @F
 
ifdef	SUPPORT_RING_SMI
		mov	cx,9Bh
		mov	bx,04FBh
		call	A000_Get_Set_PMU
endif	;SUPPORT_RING_SMI

		mov	dx, word ptr [APM_Modem_IRQ]
		or	word ptr [DEASSERT_STPCLK_IRQS], dx
		not	dx
		mov	cx, 874h
		mov	bl,dl
		xor	bh,bh
		call	A000_Get_Set_PMU
		inc	cx	;then cl=75h
		mov	bl,dh
		call	A000_Get_Set_PMU
		ret
	@@:

	;------------------------------------------------------

		cmp	al, DISABLE_RESUME_RING
		jne	short @F

ifdef	SUPPORT_RING_SMI
		mov	cx,9Bh
		mov	bx,00FBh
		call	A000_Get_Set_PMU
endif	;SUPPORT_RING_SMI

		mov	dx, word ptr [APM_Modem_IRQ]
		mov	cx, 874h
		mov	bl,0FFh
		mov	bh,dl
		call	A000_Get_Set_PMU
		inc	cx	;then cl=75h
		mov	bh,dh
		call	A000_Get_Set_PMU
		not	dx
		and	word ptr [DEASSERT_STPCLK_IRQS], dx
		ret
	@@:
	;------------------------------------------------------

		mov	cx, 9Bh
		mov	bx,00FDh	;disabel B-SW
		cmp	al, DISABLE_PM_REQ
		je	short To_Disable_PM_Timer

		mov	bh, B_SW_D4	;enabel B-SW
		cmp	al, ENABLE_PM_REQ
		je	short To_Enable_PM_Timer
		cmp	al, RESTORE_POWERON_D4_REQ
		je	short To_Enable_PM_Timer

		mov	bx,00FFh

		cmp	al, ENABLE_TIMER_REQ
		je	short To_Enable_PM_Timer

		cmp	al, DISABLE_TIMER_REQ
		jne	short Not_APM_Driver_Req

	To_Disable_PM_Timer:

		mov	Dword ptr [Doze_Setting], 0
		jmp	short @F

	To_Enable_PM_Timer:

		push	Dword ptr [Temp_Doze_Timer]
		pop	Dword ptr [Doze_Setting]
	@@:
		pusha
		call	Set_Full_On_State
		popa
		call	A000_Get_Set_PMU
		ret

	Not_APM_Driver_Req:

endif	;NO_SUPPORT_APM12

		mov	al,PM_RAM:Software_SMI_Byte

		mov	bl,al
		xor	bh,bh
		shl	bx,1
		clc
		add	bx,(offset Software_SMI_Table - offset SMI_Handler_Start)
		mov	si,cs:[bx]
		mov	PM_RAM:Software_SMI_Byte,0
		call	si

		ret
Software_SMI_Handler	Endp

		ALIGN	4
		Public	Software_SMI_Table
Software_SMI_Table:
		DW	(offset Software_SMI_Null - offset SMI_Handler_Start)
		DW	(offset Software_SMI_Wakeup - offset SMI_Handler_Start)
		DW	(offset Software_SMI_Doze - offset SMI_Handler_Start)
		DW	(offset Software_SMI_Sleep - offset SMI_Handler_Start)
		DW	(offset Software_SMI_Suspend - offset SMI_Handler_Start)
ifdef	NoteBook_Power_Management
		DW	(offset Software_SMI_0V_Resume - offset SMI_Handler_Start)
		DW	(offset Software_SMI_BIOS_RSM - offset SMI_Handler_Start)
endif	;NoteBook_Power_Management

;R22
ifdef 	ACPI_Support
;Need to include chip set dependent EQU for SMI_CMD port.
;
	include	ACPI.INC
	include	ACPI_CT.INC
;[]========================================================================[]
;ACPIOnOff
;Check if this SW SMI is ACPI on/off request or not.  If yes, set the
;SCI_EN bit in PM1a_CNT_BLK accordingly, clear the flag, and return.  If not
;set the flag and return.
;Entry: None
;
;Exit:  NC=This SW SMI is OS requests disable/enable ACPI
;	CF=Other SW SMI
;Destroy : Flag
;
;[]========================================================================[]
		Public	ACPIOnOff
ACPIOnOff	Proc	Near
		push	ax
		push	dx
;R22 - start

		mov	dx,ACPI_BASE_IO_ADDR+25h
		in	al,dx
		test	al,08h
		jz	short @f

;R22 - end
;R22		mov	edx, SMI_CMD		;
;R22		in	al, dx			;Read SMI_CMD (APMC) port
;R22		cmp	al, ACPI_Enable		;Is OS request to turn on ACPI
;R22		jne	short @f 		;Nah!
;OS requests ACPI on

		Call	Save_Legacy_PM		;R24
;R27		Call	Disable_PM_Timer	;R24
		Call	To_Disable_PM_Timer	;R27


		mov	dx, PM1a_CNT_BLK      	;
		in	ax, dx			;Read control register
		or	ax, SCI_EN+200h		;Set SCI_EN bit 
		out	dx, ax

		mov	dx, ACPI_BASE_IO_ADDR+26H
		in	al, dx			;R27
		or	al, 18h			;R27
		and	al, 0FDh		;R27
		out	dx, al

		clc				;Clear the flag
		jmp	short ACPIOnOffExit	;Exit
@@:
		test	al,10h			;R22
		jz	short @f		;R22
;R22		cmp	al, ACPI_Disable     	;Is OS request to turn off ACPI
;R22		jne	short @f     		;Nah!
;OS requests ACPI off

		Call	Restore_Legacy_PM	;R24
;R27		Call	Set_Full_On_State	;R24
    		Call	To_Enable_PM_Timer


		mov	dx, PM1a_CNT_BLK 	
		in	al, dx			;Read control register
		and	al, NOT SCI_EN 		;Clear SCI_EN bit
		out	dx, al
		clc	    			;Clear the flag
		jmp	short ACPIOnOffExit	;Exit
@@:
		stc
ACPIOnOffExit:
		pop	dx
		pop	ax
		ret
ACPIOnOff	Endp

;R24 - start
Save_Legacy_PM	Proc	Near

		push	es

		mov	ax,Seg DGROUP
		mov	es,ax
		mov	di,offset Legacy_PM_Offset

		mov	dx, ACPI_BASE_IO_ADDR+02H	;R27
		in	ax, dx				;R27
		stosw					;R27

		mov	dx, ACPI_BASE_IO_ADDR+16H	;R27
		in	ax, dx				;R27
		stosw					;R27
							;R27
		mov	dx, ACPI_BASE_IO_ADDR+26H	;R27
		in	al, dx				;R27
		stosb					;R27

                mov     cx,80h
		mov	bx,38h		;00h - 37h
	@@:
		call	A000_Get_PMU
		stosb
		inc	cl
		dec	bx
		jnz	short @B
		pop	es
		ret
Save_Legacy_PM	Endp

Restore_Legacy_PM	Proc	Near

		push	ds

		mov	ax,Seg DGROUP
		mov	ds,ax
		mov	si,offset Legacy_PM_Offset

		mov	dx, ACPI_BASE_IO_ADDR+02H	;R27
		lodsw					;R27	
		out	dx, ax				;R27

		mov	dx, ACPI_BASE_IO_ADDR+16H	;R27
		lodsw					;R27	
		out	dx, ax				;R27
							;R27
		mov	dx, ACPI_BASE_IO_ADDR+26H	;R27
		lodsb					;R27
		out	dx, al				;R27

                mov     cx,80h	
		mov	bx,38h			;00h - 37h
	@@:
		lodsb
		call	A000_Set_PMU
		inc	cl
		dec	bx
		jnz	short @B

		pop	ds
	
		ret
Restore_Legacy_PM	Endp

;R27Disable_PM_Timer	Proc	Near
;R27
;R27		pushad
;R27		mov	cx, 9ah
;R27		xor	al, al
;R27		call	A000_Set_PMU
;R27		popad
;R27		ret
;R27
;R27Disable_PM_Timer	Endp
;R24 - end

endif;	ACPI_Support
;R22

;[]===============================================================[]
;Procedure:	Software_SMI_Null
;
;Function :	Routine to Handle software SMI Null function
;
;Input	  :	DS = PM_RAM
;
;Output   :	None
;[]==================================================================[]
		ASSUME	DS:PM_RAM
Software_SMI_Null	proc	near
		ret
Software_SMI_Null	endp

;[]===============================================================[]
;Procedure:	Software_SMI_Wakeup
;
;Function :	Routine to Handle software SMI wake-up function
;
;Input	  :	DS = PM_RAM
;
;Output   :	None
;[]==================================================================[]
		ASSUME	DS:PM_RAM
Software_SMI_Wakeup	proc	near
		jmp	Set_Full_On_State
Software_SMI_Wakeup	endp

;[]===============================================================[]
;Procedure:	Software_SMI_Doze
;
;Function :	Routine to Handle software SMI Doze
;
;Input	  :	DS = PM_RAM
;
;Output   :	None
;[]==================================================================[]
		ASSUME	DS:PM_RAM
Software_SMI_Doze	proc	near
		mov	al,0d7h
		out	80h,al
		mov	[PM_TimeOut_Type],01h		;Standby request
		jmp	Go_PM_State
Software_SMI_Doze	endp

;[]===============================================================[]
;Procedure:	Software_SMI_Sleep
;
;Function :	Routine to Handle software SMI Sleep
;
;Input	  :	DS = PM_RAM
;
;Output   :	None
;[]==================================================================[]
		ASSUME	DS:PM_RAM
Software_SMI_Sleep	proc	near
		mov	al,APM_IDLE
		out	80h,al
		mov	[PM_TimeOut_Type],02h		;Standby request
		jmp	Go_PM_State
Software_SMI_Sleep	endp

;[]===============================================================[]
;Procedure:	Software_SMI_Suspend
;
;Function :	Routine to Handle software SMI Suspend
;
;Input	  :	DS = PM_RAM
;
;Output   :	None
;[]==================================================================[]
		ASSUME	DS:PM_RAM
Software_SMI_Suspend	proc	near
		mov	al,APM_SUS
		out	80h,al
;R18 - start
ifdef	softsmi_to_purposex2
		cmp	[Temp_reg],00h		
		jne	short @F     
ttt:		
		mov	[Temp_reg],11h		
		mov	[APMEventSave],SUSPENDREQUEST 	;make APM request
		ret
	@@:
		cmp	[Temp_reg],11h		
		jne	short ttt	
		mov	[Temp_reg],00		
endif	;softsmi_to_purposex2
;R18 - end
		mov	[PM_TimeOut_Type],03h		;Standby request
		jmp	Go_PM_State
Software_SMI_Suspend	endp

ifdef	NoteBook_Power_Management
;[]===============================================================[]
;Procedure:	Software_SMI_0V_Resume
;
;Function :	Routine to Handle software SMI resume from 0V suspend
;
;Input	  :	DS = PM_RAM
;
;Output   :	None
;[]==================================================================[]
		ASSUME	DS:PM_RAM
Software_SMI_0V_Resume	proc	near
		FAR_Call Resume_0V, 0F000h
Software_SMI_0V_Resume	endp

;[]===============================================================[]
;Procedure:	Software_SMI_BIOS_RSM
;
;Function :	Routine to save system BIOS SMBASE.
;
;Input	  :	DS = PM_RAM
;
;Output   :	None
;[]==================================================================[]
		ASSUME	DS:PM_RAM
Software_SMI_BIOS_RSM	proc	near
ifdef	NO_ZV_REALTIME_MESSAGE
		extrn	Save_SMRAM_State:near
		jmp	Save_SMRAM_State
else	;NO_ZV_REALTIME_MESSAGE
		ret
endif	;NO_ZV_REALTIME_MESSAGE
Software_SMI_BIOS_RSM	endp
endif	;NoteBook_Power_Management

;[]==================================================================[]
;[]==================================================================[]
		ASSUME	DS:PM_RAM
Suspend_Switch_Handler	proc	near

		mov	cx,1000h
		loop	short $ 		;delay for a while

		mov	[PM_TimeOut_Type],03h
ifndef	softsmi_to_purposex2	    		;R18A
		call	PM_State_Yes		;R18A
;R18		call	PM_State_Yes
;R18 - start
;R18A ifdef	softsmi_to_purposex2
else	;softsmi_to_purposex2	    		;R18A
		call	Clear_Counter	
		call	out_pm_state	
		call	Go_PM_State	
endif	;softsmi_to_purposex2
;R18 - end	
		ret

Suspend_Switch_Handler	Endp

;R18 - start
ifdef	softsmi_to_purposex2
out_pm_state	proc	near
		mov	al,0d3h
		test	byte ptr [Wait_APM_Flag],0FFh		;user care APM?
		jz	short @f			;no!
		test	[APM_STATUS],IS_CONNECT_CALL_MADE	;APM connected?
		jz	short @f			;APM not connected!
		test	[EXTEND_APM_STATUS],IS_PM_ENGAGED
		jz	short @f
		mov	al,0d9h
	@@:
		out	80h,al
		mov	[Temp_reg],00		
		ret
out_pm_state	endp	
endif	;softsmi_to_purposex2
;R18 - end

;[]========================================================================[]
;[]========================================================================[]
Null_Handler	Proc	Near
		ret
Null_Handler	Endp

;[]========================================================================[]
;input	:	DS = PM_RAM
;[]========================================================================[]
Go_Suspend	Proc	Near

IFDEF	NoteBook_Power_Management
		cmp	PM_RAM:Suspend_Option,Zero_V_Suspend
		jne	short @F

		cmp	dword ptr PM_RAM:[ZV_HDD_Sector],0
		je	short @F

		FAR_Call F000_Suspend_0V, 0F000h

	ifdef	ADVANCE_POWER_MANAGEMENT
	; Set resume notify flag for APM to update time
		mov	PM_RAM:[APMEventSave],RESUME_NORMAL_NOTIFY
	endif;	ADVANCE_POWER_MANAGEMENT

		jmp	Set_Full_On_State

	@@:
ENDIF	;NoteBook_Power_Management

;--------------------------
;Turn ACPILED on
;--------------------------
;R11 - start
ifdef	SUSPEND_SHOW_ACPILED
	;; Turn on ACPILED
		mov	cx,ACPI_R+19h
		mov	bx,04FFh
		call	A000_Get_Set_PMU

		mov	cx,APC_R+04h
		mov	bx,01FFh
		call	A000_Get_Set_PMU
endif;	SUSPEND_SHOW_ACPILED
;R11 - end
;R20 - start
ifdef	PM_LED_USE_GPIO
		pushad
		mov	al, 1
		Call 	far ptr F000_SET_PM_LED
		popad
endif;	PM_LED_USE_GPIO
ifdef	LED_Blinking_at_PM
		pushad
		mov	al, 1
		Call 	far ptr F000_SET_PM_LED_Blinking
		popad
endif;	LED_Blinking_at_PM
;R20 - end

;R15 - start
;--------------------------
;Turn FAN off
;--------------------------
ifdef	FAN_CONTROL_BY_GPCS0
		mov	cx,0863h
ifdef	GPCS0_FAN_Lo_Active
		mov	bx,(00010000b shl 8) or 01101110b
else;	GPCS0_FAN_Lo_Active
		mov	bx,(00000000b shl 8) or 01101110b
endif;	GPCS0_FAN_Lo_Active
		call	A000_Get_Set_PMU
endif;	FAN_CONTROL_BY_GPCS0
;R15 - end

;R25 start
;--------------------------				
;Turn FAN off By GPIO7
;--------------------------
ifdef	FAN_CONTROL_BY_GPIO7
		mov	cx,ACPI_R+18h
		mov	bx,007Fh
		call	A000_Get_Set_PMU
endif;	FAN_CONTROL_BY_GPIO7				
;R25 end

;--------------------------
;Turn FAN off By GPIO5
;--------------------------
ifdef	FAN_CONTROL_BY_GPIO5				;;;R21
		mov	cx,ACPI_R+18h
		mov	bx,00dfh
		call	A000_Get_Set_PMU
endif; 	FAN_CONTROL_BY_GPIO5				;;;R21

;--------------------------
;Save speaker status
;Beep speaker & turn it off
;--------------------------
ifdef	POWER_DOWN_OUT_PIN
		mov	al,POWER_DOWN_OUT_PIN
		Call	Out_8042_Pin1
		call	OUT_8042_FULL
		in	al,60h
		iodelay
endif	;POWER_DOWN_OUT_PIN
;R08 - start
ifdef	ABIT_GPCS
		mov	cx,0868h
		mov	dx,5A7Ch	;io port 5A7Ch
		mov	al,dh
		call	A000_Set_PMU
		dec	cx		;then cx=867h
		mov	al,dl
		call	A000_Set_PMU
		mov	al,PM_RAM:[GPCS_Save_Value]
		and	al,11011111b	;active Suspend LED,  bit7:6 by PM_RAM
		out	dx,al
endif	;ABIT_GPCS
;R08 - end

		call	De_Assert_STPCLK

ifndef	SUSPEND_NO_BEEP
		in	al,61h
		and	al,03h
		or	al,80h
		mov	[Speaker_Status],al

		mov	cx, 3
		call	PM_Warning_Beep
endif	;SUSPEND_NO_BEEP

;--------------------------------------------------------
;turn off HDDs according setup settings
;      i.e. HDD_Timer_Setting = 16
;		===> HDD off when suspend
;--------------------------------------------------------
ifndef	No_Suspend_Off_Hdd
		cmp	[HDD_Timer_Setting],16	;HDD off when suspend?
		jne	short No_Off_HDD	;no!
		mov	[HDD_Off_Flag],0AAh

		; << George Huang 1/10/1996
ifdef ECS_FIX_PMM_TIMER_DELAY
		mov	al,59h
		out	22h,al
		in	al,23h
		push	ax
		or	al,80h
		push	ax
		mov	al,59h
		out	22h,al
		pop	ax
		out	23h,al
endif; ECS_FIX_PMM_TIMER_DELAY
		; >>

		call	HDD_PwDn_Immediately

		; << George Huang 1/10/1996
ifdef ECS_FIX_PMM_TIMER_DELAY
		mov	al,59h
		out	22h,al
		in	al,23h
		pop	ax
		out	23h,al
endif; ECS_FIX_PMM_TIMER_DELAY
		;>>

No_Off_HDD:
endif	;No_Suspend_Off_Hdd
Do_Suspend:


ifdef	SiS_LEGACY_SUSPEND				;R10
;Unmask keyboard interrupt to wakeup , because QAPlus mask IRQ 1
		in	al,21H		;A8259
		NEWIODELAY
		push	ax


		and	al,NOT 02h	;umask IRQ 1
ifdef	PATCH_QA_CAN_WAKE_UP
		xchg	ah,al
		in	al,20h		;read ISR 1
		NEWIODELAY
		test	al,08h		;any pending IRQ 3 ?
		jnz	short _1	;yes, do not unmask IRQ 3
		and	ah,not 08h	;unmask IRQ 3
	_1:
		test	al,10h		;any pending IRQ 4 ?
		jnz	short _2	;yes, do not unmask IRQ 4
		and	ah,not 10h	;unmask IRQ 4
	_2:
		xchg	ah,al
endif	;PATCH_QA_CAN_WAKE_UP

		out	21H,al
		NEWIODELAY
		in	al,0A1H 	;8259
		NEWIODELAY
		push	ax
		and	al,NOT 010H	;unmask IRQ 12
		out	0A1H,al
		NEWIODELAY
	; Enable Keyboard Interface
		mov	al,0AEH
		out	64H,al
		NEWIODELAY

		call	End_PMI_Handler
	;assert STPCLK#
ifndef	NO_SUPPORT_APM12
		call	Virtual_Resume_Timer
		jnc	short WakeUpByResumeTimer
endif	;NO_SUPPORT_APM12

ifdef	USB_SUPPORT
		test	[Usb_Legacy_Flag],1
		jz	short Non_USB_Suspend_Throttling
		
USB_Suspend_Throttling:
		mov	cx,9Eh
		mov	al,0ffh
		call	A000_Set_PMU
		inc	cx   			;then cl= 9Fh
		mov	al,01
		call	A000_Set_PMU

	;enable clock throttling

		mov	cl,93h
		mov	bx,18C7h
		call	A000_Get_Set_PMU

		pushad
		push	ds
		push	es
		call	Usb_Smi
		pop	es
		pop	ds
		popad
		
		mov	cx,9Dh
		call	A000_Get_PMU
		mov	ah,al
		dec	cx	;then cl=9Ch
		call	A000_Get_PMU
		test	ax,0011110001111111b		;wake up ?
		jz	short USB_Suspend_Throttling
		jmp	short WakeUpByResumeTimer

Non_USB_Suspend_Throttling:
endif	;USB_SUPPORT

		call	De_Assert_STPCLK
		call	Assert_STPCLK

		mov	cx,100h
		loop	short $
WakeUpByResumeTimer:

;restore 8259 mask
		pop	ax
		out	0A1h,al
		NEWIODELAY
		pop	ax
		out	21H,al
		NEWIODELAY

	ifndef	No_Suspend_Off_Hdd
		or	[HDD_OFF_FLAG],0
		jz	short @F
		ret
	@@:
	endif	;No_Suspend_Off_Hdd

ifdef	PM_NETWORK_SUPPORT
		call	Read_Irq_Source
		test	al,00011010b		;IRQ 1,3,4
		jnz	short WakeUp

		test	DGROUP:[CONFIG_TABLE+5],04H	;PS2 mouse installed ?
		jz	short No_Ps2_Mouse

		test	ah,00010000b		;IRQ 12 ?
		jnz	short WakeUp
No_Ps2_Mouse:

		mov	[PM_TimeOut_Type],2	;set standby mode
	;set 9sec for system to re-enter
		mov	al,01H
		mov	cx,0A2h
		call	A000_Set_PMU

		mov	cl,9Ah			;enable/disable PMI
		mov	bx,807Fh
		call	A000_Get_Set_PMU

		in	al,80h			;show previous state
		dec	al
		out	80h,al

		ret				;go back standby mode
WakeUp:
endif;	PM_NETWORK_SUPPORT

	ifdef	ADVANCE_POWER_MANAGEMENT
	; Set resume notify flag for APM to update time
		mov	PM_RAM:[APMEventSave],RESUME_NORMAL_NOTIFY
	endif;	ADVANCE_POWER_MANAGEMENT

		mov	cx,9Dh
		call	A000_Get_PMU
		test	al,02h
		jz	short Not_B_SW_Wake
		mov	ecx,800000h
b_sw_dly:
		db	67h
		loop	b_sw_dly
Not_B_SW_Wake:
		jmp	Set_Full_On_State
;R10 - start
else	;SiS_LEGACY_SUSPEND
		mov	cx,ACPI_R+05h
		mov	bx,20C3h
		call	A000_Get_Set_PMU

		ret
endif	;SiS_LEGACY_SUSPEND
;R10 - end

Go_Suspend	Endp

ifdef	PM_NETWORK_SUPPORT
;Input : none
;Output: AX - b0 = 1 IRQ 0 occured
;		 = 0 IRQ 0 not occured
;	      b1 - IRQ 1 ....
Read_Irq_Source proc	near
		mov	al,0ah
		out	0a0h,al
		NEWIODELAY
		in	al,0a0H 	;read IRR of IRQ8-IRQ15
		NEWIODELAY
		mov	ah,al

		mov	al,0ah
		out	20h,al
		NEWIODELAY
		in	al,20H		;read IRR of IRQ0-IRQ7
		NEWIODELAY
		ret
Read_Irq_Source endp
endif;	PM_NETWORK_SUPPORT


ifndef	No_Suspend_Off_Hdd
;[]==================================[]
;Input: 	None
;Output:	CH = register 67h
;[]==================================[]
HDD_PwDn_Immediately	Proc	Near

;Turn off HDD(IO write 1F7h with 0E0h)

		mov	ah,0A0h 		;A0=first HDD

		mov	dx,1F6h
	Stop_Next_HDD:

		mov	al,ah
		out	dx,al			;setlect HDD
		iodelay

		inc	dx
		mov	al,0E0h
		out	dx,al			;HDD power down immediately
		iodelay
		dec	dx

		add	ah,10h
		cmp	ah,0b0h 		;B0=second HDD
		jbe	short Stop_Next_HDD
		cmp	dx,1f0h
		jb	short @F
		mov	dx,176h
		mov	ah,0A0h 		;A0=secondary channel first HDD
		jmp	short Stop_Next_HDD
@@:

		push	ds
		mov	ax,G_RAM
		mov	ds,ax
		assume	DS:G_RAM
		and	[FDD_VERIFY_CMD_FLAG],not 40h	;tell INT 13
							;  to wait HDD
		assume	DS:NOTHING
		pop	ds

		ret
HDD_PwDn_Immediately	Endp
endif	;No_Suspend_Off_Hdd

ifndef	SUSPEND_NO_BEEP
;[]========================================================================[]
;Procedure :	PM_Warning_Beep
;
;Input	   :	cx = no of beeps
;
;Output    :	AH bit 1,0    = original speaker status
;		AL bit 765432 = original port 61h status
;		       1,0    = 00
;
;Note	   :	speaker will be turned off
;
;[]========================================================================[]
DATA8254	EQU	40H
CTRL8254	EQU	43H

		Public	PM_Warning_Beep
PM_Warning_Beep Proc	Near

;------------------ program speaker frequency -------------------------

		mov	al,0B6H
		out	CTRL8254,al
		NEWIODELAY
		mov	al,50h
		out	DATA8254+2,al
		NEWIODELAY
		mov	al,03h
		out	DATA8254+2,al
		NEWIODELAY


;------------------------ Beep loop -----------------------------------

Beep_Loop:
		push	cx

		in	al,61h
		NEWIODELAY
		or	al,3
		out	61h,al
		NEWIODELAY

		mov	cx,1000h
		call	Wait_Refr

		and	al,not 03h
		out	61h,al
		NEWIODELAY

		call	Wait_Refr

		pop	cx

		loop	Beep_Loop

		ret
PM_Warning_Beep	endp

;--------------------------------------------
;Input	:	CX = number of Refresh Cycle
;--------------------------------------------
		ALIGN	4
Wait_Refr	Proc	Near
		pusha

Next_Refresh_Cycle:

	@@:
		in	al,61h
		test	al,010h
		jz	short @B
	@@:
		in	al,61h
		test	al,010h
		jnz	short @B

		loop	Next_Refresh_Cycle
		popa
		ret
Wait_Refr	Endp
endif	;SUSPEND_NO_BEEP







;[]========================================================================[]
;input	:	DS = PM_RAM
;[]========================================================================[]
		ASSUME	DS:PM_RAM
Set_PM_State	Proc	Near

		cmp	byte ptr [si],00h
		jne	short PM_State_Yes
		cmp	si,offset Suspend_Setting
		jne	short @F
		call	Clear_Counter
		ret
	@@:
		inc	[PM_TimeOut_Type]
		inc	si
		jmp	short Set_PM_State
PM_State_Yes:
		call	Clear_Counter

ifdef	ADVANCE_POWER_MANAGEMENT

		test	byte ptr [Wait_APM_Flag],0FFh		;user care APM?
		jz	short Dont_Care_APM			;no!
		test	[APM_STATUS],IS_CONNECT_CALL_MADE	;APM connected?
		jz	short Dont_Care_APM			;APM not connected!
		test	[EXTEND_APM_STATUS],IS_PM_ENGAGED
		jz	short Dont_Care_APM
		cmp	[PM_TimeOut_Type],03h			;Suspend request?
		jne	short Idle_Req				;no!
		mov	[APMEventSave],SUSPENDREQUEST		;make APM request
		jmp	short Wait_For_APM

Idle_Req:
		test	[EXTEND_APM_STATUS],APM_16BIT_FUNC_MODE
		jnz	short Dont_Care_APM


		or	[PM_CTRL_FLAG],CPU_IDLE_FLAG
		mov	[PM_MODE],FULL_ON

Wait_For_APM:

		call	Enable_WakeUp_Source

ifndef	NO_SUPPORT_APM12
		mov	cx,9Ah		;disable IO port wake up SMI
		mov	bx,00E0h
		call	A000_Get_Set_PMU

		mov	cx,875h		;mask IRQ14 / IRQ15
		mov	bx,0C0FFh
		call	A000_Get_Set_PMU
endif	;NO_SUPPORT_APM12

		mov	cx,93h
		mov	bx,20FFh
		call	A000_Get_Set_PMU

		mov	al,0D0h 	;wait for APM
		out	80h,al

		ret
Dont_Care_APM:
		mov	al,[PM_TimeOut_Type]
		or	al,0D0h
		out	80h,al

endif;	ADVANCE_POWER_MANAGEMENT

Go_PM_State:

;-------------------------------------------
;1. disable CRT according to setup settings
;-------------------------------------------

		mov	dl,4
		sub	dl,[PM_TimeOut_Type]

		cmp	[Video_Off_Mode],dl
		jb	short @F
		FAR_Call F000_Disable_Crt, 0F000h
	@@:

;-----------------------------------------
;4. prg SMOUT according to MODBIN settings
;-----------------------------------------

if	GREEN_ASSERT_PIN ne 0
		mov	dx,[SMOUT_Settings]
		mov	cl,[PM_TimeOut_Type]
		shl	cl,2
		shr	dx,cl

	;Prg SMOUT according to MODBIN settings

 ifdef	GREEN_ASSERT_GPIO5
		mov	cx,ACPI_R+18h
		mov	bx,01DFh
		and	bh,dl
		shl	bh,5
		call	A000_Get_Set_PMU
 endif	;GREEN_ASSERT_GPIO5
endif	;GREEN_ASSERT_PIN ne 0

;------------------
;5. set indications
;------------------

		mov	al,[PM_TimeOut_Type]
		mov	[PM_MODE],al
		mov	[PM_MODE1],al

;------------------------
;6. enable trigger source
;------------------------

		call	Enable_WakeUp_Source

;------------------------------------
;2. Clock throttling for DOZE/STANDBY
;   Stop clock for SUSPEND
;------------------------------------

		cmp	[PM_TimeOut_Type],3		;Suspend request?

ifndef	No_Stpclk_When_Suspend

		je	Go_Suspend

else	;No_Stpclk_When_Suspend

		jne	@F

		mov	cx,009Eh
		mov	al, 48h
		call	A000_Set_PMU

		inc	cx
		mov	al, 01h
		call	A000_Set_PMU

		mov	cl,93h
		mov	bx,18C7h
		call	A000_Get_Set_PMU

		jmp	rock_end

endif	;No_Stpclk_When_Suspend

	;program throttling duty cycle for DOZE & STANDBY

		mov	al,[Doze_Speed]
		cmp	[PM_TimeOut_Type],1		;Suspend request?
		je	short @F
		mov	al,[Standby_Speed]
	@@:

		mov	cx,9Eh
		call	A000_Set_PMU
		inc	cx   			;then cl= 9Fh
		mov	al,36
		call	A000_Set_PMU


	;enable clock throttling

		mov	cl,93h
		mov	bx,18C7h
		call	A000_Get_Set_PMU


		call	Update_PM_Timer
		mov	[PM_TimeOut_Type],00h		;clear request
rock_end:
		ret

Set_PM_State	Endp

;----------------------------------------------------------------------
;----------------------------------------------------------------------
ifdef	POWER_DOWN_OUT_PIN
; save	: none
; input : al : 8042 command
; output: none

STAT8042	EQU	64h
Out_8042_Pin1	proc

		cli

		xchg	al,ah
		in	al,21h
		push	ax			;save IRQ 1 status
		or	al,2			;disable IRQ 1
		out	21h,al
		IODELAY
		xchg	al,ah

		extrn	Buffer_8042_Full:near
		out	STAT8042,al		;set/reset pin
		NEWIODELAY
		call	Buffer_8042_Full	;wait for command accepted

		pop	ax
		out	21h,al
		IODELAY

		ret
Out_8042_Pin1	endp
endif	;POWER_DOWN_OUT_PIN

Assert_STPCLK	Proc	Near
		mov	cx,93h
		call	A000_Get_PMU
		or	al,28H
		call	A000_Set_PMU
		ret
Assert_STPCLK	endp

De_Assert_STPCLK	Proc	Near
		mov	cx,93h
		call	A000_Get_PMU
		and	al,NOT 38h
		call	A000_Set_PMU
		ret
De_Assert_STPCLK	Endp

;----------------------------------------------------------------------
;Function :	Set Mode timer with appropriate value
;Input	  :	DS = PM_RAM
;----------------------------------------------------------------------
		ASSUME	DS:PM_RAM
Update_PM_Timer Proc	Near

		pusha

		mov	al,[PM_MODE1]
		xor	ah,ah
		mov	cx,3
		sub	cx,ax
		mov	si,offset PM_RAM:Doze_Setting
		add	si,ax

		xor	al,al
		jcxz	short Prg_Sys_Value
	@@:
		mov	al,[si]
		or	al,al
		jnz	short Prg_Sys_Value
		inc	si
		loop	short @B
		xor	al,al
Prg_Sys_Value:
		push	ax
		mov	cx,0A2h			;system timer low byte
		call	A000_Set_PMU

		mov	cl,9Ah			;enable/disable PMI
		call	A000_Get_PMU
		pop	dx
		and	al,01111111b
		or	dl,dl
		jz	short @F
		or	al,10000000b
	@@:
		call	A000_Set_PMU

		popa

		ret
Update_PM_Timer Endp

;-----------------------------------------------------------
;Function :	To clear a specific counter
;
;Input	  :	CL = chipset register index
;
;Output   :	None
;
;Destroy  :	BX, AH, FLAGS
;-----------------------------------------------------------
Clear_Counter	Proc	Near
		mov	cx,0A2h			;system timer
		xor	al,al
		call	A000_Set_PMU

		mov	cl,9Ah
		call	A000_Get_PMU
		and	al,01111111b
		call	A000_Set_PMU

		ret
Clear_Counter	Endp

;-----------------------------------------------------------
;-----------------------------------------------------------
		ASSUME	DS:PM_RAM
Enable_WakeUp_Source	Proc	Near

ifdef	No_Stpclk_When_Suspend

		mov	cx,9Ah
		mov	bx,1FE0h
		call	A000_Get_Set_PMU
		inc	cx		;then cl= 9Bh
		mov	bx,01FEh
		call	A000_Get_Set_PMU

		mov	cx,875h
		call	A000_Get_PMU
		and	al,0c0h
		cmp	al,00h		;detect IRQ14&15
		ja	rock_change1

rock1:
		mov	cx,874h
		call	A000_Get_PMU
		and	al,40h	       ;detect IRQ6(Floppy)
		cmp	al,00h
		ja	rock_change2

rock2:
		mov	cx,874h
		call	A000_Get_PMU
		and	al,18h		;detect IRQ4&3
		cmp	al,00h
		ja	rock_change3

rock3:
		mov	cx,874h
		call	A000_Get_PMU
		and	al,0a0h 	 ;detect IRQ7&5
		cmp	al,00h
		ja	rock_change4

		jmp	by_pass_rock	;*rock
rock_change2:
		jmp	 rock2
rock_change3:
		mov	cx,9Ah
		call	A000_Get_PMU
		and	al,11110011b
		call	A000_Set_PMU
		jmp	 rock3
rock_change1:
		mov	cx,9Ah	       ;*rock
		call	A000_Get_PMU        ;*rock
		and	al,11111100b   ;rock change for disabling HDD detection
		call	A000_Set_PMU        ;*rock
		jmp    rock1

rock_change4:
		mov	cx,9Ah
		call	A000_Get_PMU
		and	al,11101111b
		call	A000_Set_PMU

by_pass_rock:				;*rock

		;enable wake trigger source 2
		mov	cx,9Bh
		mov	bx,38FFh
		call	A000_Get_Set_PMU

else	;No_Stpclk_When_Suspend

ifndef	NO_SUPPORT_APM12
		mov	cx,875h		;restore IRQ events
		mov	al,byte ptr [DEASSERT_STPCLK_IRQS+1]
		not	al
		call	A000_Set_PMU
endif	;NO_SUPPORT_APM12
		mov	cx,90h
		call	A000_Get_PMU
		mov	ah,al
		mov	bh,al
		and	ax,0830h
		shl	ah,1
		shr	al,2
		or	al,ah
		shr	bh,7
		or	al,bh
		shl	bh,1
		or	bh,al
		mov	bl,0E0h
		mov	cl,9Ah
		call	A000_Get_Set_PMU

endif	;No_Stpclk_When_Suspend

		ret
Enable_WakeUp_Source	Endp

;[]========================================================================[]
;Procedure:	End_PMI_Handler
;
;Function :	Handle the end of PMI
;
;Input	  :	DS = PM_RAM
;
;Output   :	None
;
;Note	  :	1. called from every PMI & after PMI requests has been served
;		2. stack available
;[]========================================================================[]
	ASSUME	DS:PM_RAM
	Public	End_PMI_Handler
End_PMI_Handler Proc	Near

		mov	cx,9Bh			;clear software SMI control
		mov	bx,00FEh
		call	A000_Get_Set_PMU

		inc	cx		;then cl= 9Ch
		xor	al,al			;clear status
		call	A000_Set_PMU
		inc	cx		;then cl= 9Dh
		call	A000_Set_PMU

		mov	cl,93h			;clear software SMI trigger
		mov	bx,00FDh
		call	A000_Get_Set_PMU

		mov	cx,ACPI_R+01h
		mov	bx,00FFh
		call	A000_Get_Set_PMU
		mov	cl,14h
		mov	bx,00FFh
		call	A000_Get_Set_PMU
		mov	dx,ACPI_BASE_IO_ADDR+25h
		in	al,dx
		out	dx,al

		ret
End_PMI_Handler Endp

;;	ifdef	CRT_Control_Not_In_APM
;;		include	CRT_Ctrl.inc
;;	endif	;CRT_Control_Not_In_APM

;[]========================================================================[]
;Procedure:	A000_Get_PM_RAM_Seg
;
;Function :	To obtain the extended BIOS data area segment address.
;
;Input	  :	None
;
;Output   :	AX: should point to the extended BIOS data area
;
;Note	  :	1. Call from POST 79S (PM initialization)
;		2. Stack available
;[]========================================================================[]
A000_Get_PM_RAM_Seg	Proc	Near
		mov	ax,PM_RAM_SEGMENT
		ret
A000_Get_PM_RAM_Seg	Endp

;[]========================================================================[]
;Procedure:	A000_Open_PM_RAM
;
;Function :	To enable the PM RAM read/write
;
;Input	  :	None
;
;Output   :	None
;
;Preserve :	All
;
;Note	  :	1. Stack available
;		2. called from PM_Init & APM
;[]========================================================================[]
A000_Open_PM_RAM	Proc	Near
		pusha
		mov	cx,76h
		mov	bx,20DFh
		call	A000_Get_Set_PMU
		popa
		ret
A000_Open_PM_RAM	Endp

;[]========================================================================[]
;Procedure:	A000_Close_PM_RAM
;
;Function :	To close PM RAM
;		(Normally, PM_RAM is located in shadow RAM)
;
;Input	  :	AL = 1 --> there is option ROM in the PM_RAM area
;		     0 --> there is no option ROM in the PM_RAM area
;
;Output   :	if input AL = 1
;
;		   switch the PM_RAM area back to ROM
;
;		if input AL = 0
;
;		   program this area into read-only mode
;
;Preserve :	All
;
;Note	  :	1. Stack available
;		2. called from PMI_Handler, PM_Init
;[]========================================================================[]
A000_Close_PM_RAM	Proc	Near
		pusha
		mov	cx,76h
		mov	bx,00DFh
		call	A000_Get_Set_PMU
		popa
		ret
A000_Close_PM_RAM	Endp


;[]===================================================================[]
;
; A000_GET_PMU:
;
;	Reads a value directly from the chipset registers.
;
; Entry: CL/CX	Register to read (AL if RIS = 0, AX if RIS = 1)
; Exit:  AL/AX	Value read (BL if RVS = 0, BX if RVS = 1)
;
; Destory (PCI): EAX high word, AL, EDX high word
;
;[]===================================================================[]

		align	4
A000_GET_PMU	PROC	NEAR
CONFIG_ADDR	EQU	0CF8h
		shl	edx,16		;save dx
		shl	eax,16

		cmp	ch,ACPI_R/100h
		je	short ACPI_Reg_Rd

		mov	ax,8000h
		rol	eax,16

		cmp	ch,APC_R/100h
		je	short APC_Reg_Rd

		xchg	cx,ax		;then ch=ah, ah=ch, al=cl
		mov	cl,al		;then cl=cl
		and	al,NOT 03h	;32 bit access for PCI
		mov	dx,CONFIG_ADDR	;index is 0cf8h
		out	dx,eax
		add	dl,4		;start from 0cfch
		xchg	cx,ax		;then ch=ch, ah=ah, al=cl
		mov	cl,al		;then cl=cl
		and	al,03h
		add	dl,al		;byte index to read
		in	al,dx
rst_dx_ret:
		shr	edx,16		;restore dx
		ret
ACPI_Reg_Rd:
		mov	dx,ACPI_BASE_IO_ADDR
		add	dl,cl
		adc	dh,0
		and	dl,NOT 01h
		in	ax,dx
		mov	dx,ax
		shr	eax,16		;restore ah
		mov	al,dl
		test	cl,01h
		jz	short rst_dx_ret
		mov	al,dh
		jmp	short rst_dx_ret
APC_Reg_Rd:
ifndef	Use_External_RTC
		mov	ax,0844h
		mov	dx,CONFIG_ADDR	;index is 0cf8h
		out	dx,eax
		add	dl,4
		in	al,dx
		or	al,10h
		iodelay
		out	dx,al
		mov	al,cl
		out	70h,al
		newiodelay
		in	al,71h
		shl	eax,16
		in	al,dx
		and	al,not 10h
		iodelay
		out	dx,al
		shr	eax,16
endif;	Use_External_RTC
		jmp	short rst_dx_ret
A000_GET_PMU	ENDP

;[]===================================================================[]
;
; A000_SET_PMU:
;
;	Changes a value in the chipset registers.
;
; Entry: CL/CX	Register to read (AL if RIS = 0, AX if RIS = 1)
;	 AL/AX	Value to write (BL if RVS = 0, BX if RVS = 1)
;
; Exit:  NONE
;
; Destory (PCI): EAX high word, ECX high word, EDX high word
;
;[]===================================================================[]

		align	4
A000_SET_PMU	PROC	NEAR

		cmp	ch,0FFh
		jb	short @F
		ret
	@@:

		shl	edx,16		;save dx
		xchg	ax,cx
		shl	ecx,16		;save value
		xchg	ax,cx		;restore cx

		cmp	ch,ACPI_R/100h
		je	short ACPI_Reg_Wr
		cmp	ch,APC_R/100h
		je	short APC_Reg_Wr

		mov	eax,80000000h	;device 16 is for 881
		mov	ax,cx
		and	al,NOT 03h	;32 bit access for PCI
		mov	dx,CONFIG_ADDR	;index is 0cf8h
		out	dx,eax
		add	dl,4		;start from 0cfch
		mov	al,cl
		and	al,03h
		add	dl,al		;byte index to read
		mov	eax,ecx
		shr	eax,16
		out	dx,al
rst_dx_ret1:
		shr	edx,16		;restore dx
		ret
ACPI_Reg_Wr:
		mov	dx,ACPI_BASE_IO_ADDR
		add	dl,cl
		adc	dh,0
		and	dl,NOT 01h
		in	ax,dx
		test	cl,01h
 		ror	ecx,16		;ror instruction will not change Z flag
		jz	short even_ACPI_reg
		mov	ah,cl
		jmp	short out_ACPI_reg
even_ACPI_reg:
		mov	al,cl
out_ACPI_reg:
		out	dx,ax
		mov	ax,cx
		shr	ecx,16
		jmp	short rst_dx_ret1
APC_Reg_Wr:
ifndef	Use_External_RTC
		mov	eax,80000844h
		mov	dx,CONFIG_ADDR	;index is 0cf8h
		out	dx,eax
		add	dl,4
		in	al,dx
		or	al,10h
		iodelay
		out	dx,al
		mov	al,cl
		out	70h,al
		mov	eax,ecx
		shr	eax,16
		out	71h,al
		shl	eax,16
		in	al,dx
		and	al,not 10h
		iodelay
		out	dx,al
endif;	Use_External_RTC
		jmp	short rst_dx_ret1
A000_SET_PMU		ENDP

;[]==============================================================[]
;Read one chipset register value and set it back
;Input : CL - register index
;	 BL - value to AND
;	 BH - value to OR
;Output: none
;[]==============================================================[]
		align	4
A000_GET_SET_PMU	proc	near
		call	A000_GET_PMU
		and	al,bl
		or	al,bh
		call	A000_SET_PMU
		ret
A000_GET_SET_PMU	endp

		align	4
		public	SMI_Handler_End
SMI_Handler_End label	near
SMI_Handler_Len EQU	$ - offset SMI_Handler_Start

ECODE		ENDS
;R17 - end
		END
